/*
 * 	(c) Copyright 1986 Gould Inc.
 * 	    All Rights Reserved.
 */


#ifndef	INCLUDE_STAB_H
#define	INCLUDE_STAB_H
#if	defined(RCSID) && !defined(lint)
static char *include_stab_hrcsid = "@(#) (Gould) $Header: stab.h,v 1.2 87/02/19 23:36:54 jlisanke UTX $";
#endif	/* RCSID */
/* 	@(#) UTX/32 1.3  stab.h ver 1.3 */

/*
 * Copyright (c) 1980 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 *
 *	@(#)stab.h	5.1 (Berkeley) 5/30/85
 */

/* IF YOU ADD DEFINITIONS, ADD THEM TO nm.c as well */
/*
 * This file gives definitions supplementing <nlist.h>
 * for permanent symbol table entries.
 * These must have one of the N_STAB bits on,
 * and are subject to relocation according to the masks in <reloc.h>.
 */

#ifdef gould
/*
 * for symbolic debugger, dbx(1):
 */

#define	N_GSYM	0x20		/* global symbol: name,,0,size,0 */
#define	N_FNAME	0x22		/* procedure name (f77 kludge): name,,0 */
#define	N_FUN	0x2a		/* procedure: name,,0,linenumber,address */
#define	N_STSYM	0x26		/* static symbol: name,,0,size,address */
#define	N_NBSTS	0x2c		/* nobase static symbol: name,,0,size,address */
#define	N_LCSYM	0x28		/* .lcomm symbol: name,,0,size,address */
#define	N_NBLCS	0x2e		/* nobase .lcomm symbol: name,,0,size,address */
#define	N_RSYM	0x40		/* register sym: name,,0,size,register */
#define	N_SLINE	0x4a		/* src line: 0,,0,linenumber,address */
#define	N_SSYM	0x60		/* structure elt: name,,0,size,struct_offset */
#define	N_SO	0x6a		/* source file name: name,,0,0,address */
#define	N_LSYM	0x80		/* local sym: name,,0,size,offset */
#define	N_SOL	0x8a		/* #included file name: name,,0,0,address */
#define	N_PSYM	0xa0		/* parameter: name,,0,size,offset */
#define	N_ENTRY	0xaa		/* alternate entry: name,linenumber,address */
#define	N_LBRAC	0xca		/* left bracket: 0,,0,nesting level,address */
#define	N_RBRAC	0xea		/* right bracket: 0,,0,nesting level,address */
#define	N_BCOMM	0xe2		/* begin common: name,, */
#define	N_ECOMM	0xe4		/* end common: name,, */
#define	N_ECOML	0xe8		/* end common (local name): ,,address */
#define	N_LENG	0xfe		/* second stab entry with length information */

#else /* gould */

/*
 * for symbolic debugger, sdb(1):
 */
#define	N_GSYM	0x20		/* global symbol: name,,0,type,0 */
#define	N_FNAME	0x22		/* procedure name (f77 kludge): name,,0 */
#define	N_FUN	0x24		/* procedure: name,,0,linenumber,address */
#define	N_STSYM	0x26		/* static symbol: name,,0,type,address */
#define	N_LCSYM	0x28		/* .lcomm symbol: name,,0,type,address */
#define	N_RSYM	0x40		/* register sym: name,,0,type,register */
#define	N_SLINE	0x44		/* src line: 0,,0,linenumber,address */
#define	N_SSYM	0x60		/* structure elt: name,,0,type,struct_offset */
#define	N_SO	0x64		/* source file name: name,,0,0,address */
#define	N_LSYM	0x80		/* local sym: name,,0,type,offset */
#define	N_SOL	0x84		/* #included file name: name,,0,0,address */
#define	N_PSYM	0xa0		/* parameter: name,,0,type,offset */
#define	N_ENTRY	0xa4		/* alternate entry: name,linenumber,address */
#define	N_LBRAC	0xc0		/* left bracket: 0,,0,nesting level,address */
#define	N_RBRAC	0xe0		/* right bracket: 0,,0,nesting level,address */
#define	N_BCOMM	0xe2		/* begin common: name,, */
#define	N_ECOMM	0xe4		/* end common: name,, */
#define	N_ECOML	0xe8		/* end common (local name): ,,address */
#define	N_LENG	0xfe		/* second stab entry with length information */

#endif /* gould */

/*
 * for the berkeley pascal compiler, pc(1):
 */
#define	N_PC	0x30		/* global pascal symbol: name,,0,subtype,line */

/*
 * 	(c) Copyright 1986 Gould Inc.
 * 	    All Rights Reserved.
 */
#endif	/* INCLUDE_STAB_H */
