/*~!nbcc.c*/
/* Name:  nbcc.c Part No.: _______-____r
 *
 * Copyright 1990 - J B Systems, Morrison, CO
 *
 * The recipient of this product specifically agrees not to distribute,
 * disclose, or disseminate in any way, to any one, nor use for its own
 * benefit, or the benefit of others, any information contained  herein
 * without the expressed written consent of J B Systems.
 *
 *                     RESTRICTED RIGHTS LEGEND
 *
 * Use, duplication, or disclosure by the Government is  subject  to
 * restriction  as  set forth in paragraph (b) (3) (B) of the Rights
 * in Technical Data and Computer Software  Clause  in  DAR  7-104.9
 * (a).
 */

#ident	"@(#)nbcbin:nbcc.c	1.0"

/*
 *	This file contains non-based support modifications
 *	for operation under MPX.  Derived from Encores' base
 *	mode CC command processor.
 */

/*
 * cc - front end for C compiler
 */

#if defined (mpx) && !defined (i386)
#include <param.h>
#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <dir.h>
#include <limits.h>
#else	/* mpx */
/* #include <sys/param.h> */
#include <stdio.h>
#include <ctype.h>
#include <signal.h>
#include <sys/ndir.h>
#define PATH_MAX 128
#endif

#if defined (mpx) && !defined (i386)
char *cpp = "/system/bin/nbcpp";
char *ccom = "/system/bin/nbccom";
char *as = "/system/bin/nbcas";
#else
char *cpp = "/u/bin/nbcpp";
char *ccom = "/u/bin/nbccom";
char *as = "/u/bin/nbcas";
#endif

char *savestr(), *strspl(), *setsuf(), *strip(), *lastfield();
int idexit();

/* define arg list pointers */
char **av, **clist, **llist, **plist, **tlist;

/*
 *   arrange to pass options directly to the preprocessor via -P
 *   arrange to pass options directly to the compiler via -X
 *   arrange to pass options directly to the assembler via -A
 */

char 	*input;		/* input file pointer */
char	*output;	/* output file pointer */
int	exfail = 0;	/* execv failed flag */
int	errflag = 0;	/* error detected flag */
int	oflag = 0;	/* output object to linker */
int	cflag = 0;	/* output object to prog.o */
int	debug = 0;	/* work in verbose mode */
int	exflag = 1;	/* pass output to linker */
int	eflag = 0;	/* -E flag, run cpp only, output to prog.i */
int	gflag = 0;	/* -G flag, debug symbols from assembler */
int	hflag = 0;	/* -H flag, tell BBCCOM no csect directives */
int	pflag = 0;	/* assign prefile to assembler */
int	sflag = 0;	/* generate ccom output into file prog.z */
int	tflag = 0;	/* assign tempfile to assembler */
int	mflag = 0;	/* assign macro library to assembler */
int	wflag = 0;	/* suppress ccom warnings */
int	lflag = 0;	/* generate assembler listing */
char	*prefile = 0;	/* prefile to use */
char	*listfile = 0;	/* listing file for assembler */
char	list[PATH_MAX + 3];
char	obj[PATH_MAX + 3];
int	nl = 0;		/* number of items in llist */
int	np = 0;		/* number of items in plist */
int	nc = 0;		/* number of items in clist */
int	nt = 0;		/* number of items in tlist */
int	na = 0;		/* number of items in av */
int	inx = 0;	/* save of loop index, if a break occurs */

#define cunlink(s) if (s) unlink(s)

main(argc, argv)
char **argv;
{
  char *t;
  int i, j, c;

  av = (char **)calloc(argc+15, sizeof (char **));
  clist = (char **)calloc(argc, sizeof (char **));
  llist = (char **)calloc(argc, sizeof (char **));
  plist = (char **)calloc(argc, sizeof (char **));
  tlist = (char **)calloc(argc, sizeof (char **));

#ifdef i386
  sflag++;
#endif
  /* if no args, display options */
  if (argc <= 1 ) {
    fprintf(stderr, "NBCC Options:\n");
    fprintf(stderr, "Q[option]	send option to NBCPP\n");
    fprintf(stderr, "X[option]	send option to NBCCOM\n");
    fprintf(stderr, "A[option]	send option to NBCAS\n\n");

    fprintf(stderr, "-V		echo commands from NBCC during processing\n");

    fprintf(stderr, "-Dsym	define sym to NBCPP during processing\n");
    fprintf(stderr, "-Usym	undefine sym to NBCPP during processing\n");
    fprintf(stderr, "-Idir	search dir for include files in NBCPP\n");
    fprintf(stderr, "-E		send output from NBCPP to prog.i\n");

    fprintf(stderr, "-H		MPX handler, emit dsect only from NBCCOM\n");
    fprintf(stderr, "-S		keep output from NBCCOM in prog.z, do not run NBCAS\n");
    fprintf(stderr, "-W		suppress NBCCOM warning messages\n");

    fprintf(stderr, "-C		output object to prog.o from NBCAS\n");
    fprintf(stderr, "-G		output debug symbols from NBCAS\n");
    fprintf(stderr, "-L[file]	assign file as listing file for NBCAS, default prog.l\n");
    fprintf(stderr, "-M[lib]	assign lib as macro library for NBCAS\n");
    fprintf(stderr, "-P[file]	assign file as prefile for NBCAS\n");
    fprintf(stderr, "-T[file]	assign file as tempfile for NBCAS\n");

    fprintf(stderr, "-O		reserved, not currently used\n");
    exit(0);
  }
  for (i = 1; i < argc; i++) {
    if (*argv[i] == '-') switch (argv[i][1]) {

    case 'S':	/* generate assembler output from ccom */
      sflag++;
      cflag = 0;
      continue;

    case 'Q':	/* cpp specific flags */
      if (argv[i][2] == '\0')
      {
        continue;
      }
      argv[i][1] = '-';
      plist[np++] = &argv[i][1];
      continue;

    case 'X':	/* ccom specific flags */
      if (argv[i][2] == '\0')
      {
        continue;
      }
      tlist[nt++] = argv[i];
      continue;

    case 'A':	/* as specific flags */
      if (argv[i][2] == '\0')
      {
        continue;
      }
      argv[i][1] = '-';
      llist[nl++] = &argv[i][1];
      continue;

#ifdef i386
    case 'o':
#endif
    case 'O':
#ifdef FUTURE
      if (++i < argc) {
        outfile = argv[i];
        switch (getsuf(outfile)) {

        case 'c':
        case 'o':
          error("-o would overwrite %s",
              outfile);
          exit(8);
        }
      }
#endif
      continue;

    case 'G':	/* out debug symbols from assembler */
      gflag++;
      continue;

    case 'H':	/* surpress csect directives */
      hflag++;
      continue;

    case 'W':	/* surpress ccom warning messages */
      wflag++;
      continue;

    case 'E':	/* output cpp output to file.i */
      eflag++;
      continue;

    case 'L':	/* output listing file */
      lflag++;
      if (argv[i][2] == '\0') {
        continue;
      }
      llist[nl++] = argv[i];
      listfile = &argv[i][2];
      continue;

    case 'P':	/* use prefile */
      if (argv[i][2] == '\0') {
        error("Prefile not given for -P option", 0);
        continue;
      } else {
        pflag++;
        prefile = &argv[i][2];
      }
      continue;

#ifdef i386
    case 'c':
#endif
    case 'C':	/* generate object in prog.o */
#ifndef i386
      cflag++;
      sflag = 0;
#endif
      continue;

    case 'M':	/* assign macro library */
      if (argv[i][2] == '\0') {
        error("Macro library not given for -M option", 0);
        continue;
      }
      mflag++;
      llist[nl++] = argv[i];
      continue;

    case 'T':	/* assign temp asm file */
      if (argv[i][2] == '\0') {
        error("temp filename not given for -T option", 0);
        continue;
      }
      tflag++;
      llist[nl++] = argv[i];
      continue;

    case 'D':	/* define for cpp */
    case 'I':	/* dir search path for cpp */
    case 'U':	/* undefine for cpp */
      if (argv[i][2] == '\0') {
        error("Entry not provided for -%c option", argv[i][1]);
        continue;
      } else {
        plist[np++] = argv[i];
        continue;
      }

    case 'V':   /* Use -v for debugging */
      debug = 1;
      continue;

    }	/* end of option switch */

    /* now process file names */
    t = argv[i];
    c = getsuf(t);
    if (!c)
      error("File does not have valid suffix: %s", t);
    if (c=='c' || c=='s' || c=='i') {
      clist[nc++] = t;
      t = setsuf(t, 'o');
    }
#ifdef FUTURE
    /* not sure why this is here */
    if (nodup(llist, t)) {
      llist[nl++] = t;
      if (getsuf(t)=='o')
        nxo++;
    }
#endif
  }

  /* Now start the real work */
  /* if not files given, exit */
  if (nc==0)
    goto nocom;

#ifndef mpx
  if (signal(SIGINT, SIG_IGN) != SIG_IGN)
    signal(SIGINT, idexit);
  if (signal(SIGTERM, SIG_IGN) != SIG_IGN)
    signal(SIGTERM, idexit);
  if (signal(SIGHUP, SIG_IGN) != SIG_IGN)
    signal(SIGHUP, idexit);
#endif

/* now process all files in clist */
  for (i=0; i<nc; i++) {

    inx = i;
    if (nc > 1) {
      printf(" Processing %s:\n", clist[i]);
      fflush(stdout);
    }
    if (getsuf(clist[i]) == 's') {
      input = clist[i];
      goto assemble;
    }

    if (getsuf(clist[i]) == 'i') {
      input = clist[i];
      goto compile;
    }

    /* do the cpp work for .c files */
    av[0] = "nbcpp"; 
    av[1] = clist[i]; 
    output = setsuf(clist[i], 'i');
    av[2] = output;
    na = 3;
    /* if listing required, leave comments */
#ifdef MAYBE
    if (lflag)
      av[na++] = "-C";
#endif
    for (j = 0; j < np; j++)
      av[na++] = plist[j];
    av[na++] = 0;
    if (callsys(cpp, av)) {
      exfail++;
      errflag++;
      if (!eflag)
        cunlink(output); 
      continue;
    }

    /* if -E flag, skip to next file */
    if (eflag) {
      continue;
    }

    /* prog.i becomes input to ccom */
    /* output is to prog.z or prog.s depending on sflag */
    input = output;
compile:	/* enter here if .i file specified */
    if (sflag)
        output = setsuf(clist[i], 's');
    else
        output = setsuf(clist[i], 'z');
    av[0] = "nbccom"; 
    av[1] = input; 
    av[2] = output; 
    na = 3;
    if (lflag)
      av[na++] = "-Xl";
    /* set input file name for ccom */
    av[na++] = "-XF";
    av[na++] = strip(lastfield(clist[i]));
#ifdef FUTURE
    if (gflag)
      av[na++] = "-Xg";
#endif
    if (hflag)
      av[na++] = "-XH";
    if (wflag)
      av[na++] = "-w";
    for (j = 0; j < nt; j++)
      av[na++] = tlist[j];
    av[na] = 0;
    if (callsys(ccom, av)) {
      exflag++;
      errflag++;
      if (!sflag)
        cunlink(output); 
      if (getsuf(clist[i]) != 'i')
        cunlink(input); 
      continue;
    }

    /* unlink prog.i file */
    if (getsuf(clist[i]) != 'i')
      cunlink(input); 
    input = output;
    /* if -S specified, skip to next program */
    if (sflag)
      continue;
assemble:
    av[0] = "nbcas"; 
    na = 1;
    if (gflag)
      av[na++] = "-G";
    if (lflag) {
      av[na++] = "-X";	/* do xref with listing */
      if (!listfile) {
        strcpy(list, "-L");
        strcat(list, setsuf(clist[i], 'l'));
        av[na++] = list;
      }
    }
    if (cflag) {
      strcpy(obj, "-O");
      strcat(obj, setsuf(clist[i], 'o'));
      av[na++] = obj;
    }
    /* assign user options */
    for (j = 0; j < nl; j++)
      av[na++] = llist[j];
    /* assign prefile, if present */
    if (pflag)
      av[na++] = prefile;
    /* and finally, the input file */
    av[na++] = input;
    av[na] = 0;
/*
 *   assembler usually returns 1 on most errors.
 */
    if (callsys(as, av) != 0) {
      exflag++;
      errflag++;
      if (getsuf(clist[i]) != 's')
        cunlink(input); 
      continue;
    }
    if (getsuf(clist[i]) != 's') 
      /* unlink prog.z file */
      cunlink(input); 

    /* this file done, do next */
  }
nocom:
  dexit();
}

idexit()
{

  if (eflag)
    cunlink(setsuf(clist[inx], 'i'));
  if (cflag)
    cunlink(setsuf(clist[inx], 'o'));
  if (lflag)
    cunlink(setsuf(clist[inx], 'l'));
  if (sflag)
    cunlink(setsuf(clist[inx], 's'));
  else
    cunlink(setsuf(clist[inx], 'z'));
  errflag = 100;
  dexit();
}

dexit()
{
  exit(errflag);
}

error(s, x)
char *s, *x;
{
  FILE *diag = exflag ? stderr : stdout;

  fprintf(diag, "nbcc: ");
  fprintf(diag, s, x);
  putc('\n', diag);
  exfail++;
  errflag++;
}

/* get suffix of the filename, c or s */
getsuf(s)
register char *s;
{
  register int c;
  register int t;

  c = 0;
  while (t = *s++)
    switch (t) {
      case '@':
      case '^':
      case '(':
      case ')':
      case '/':
        c = 0;
	continue;
      default:
        c++;
    }
  s -= 3;
  if (c <= MAXNAMLEN && c > 2 && *s++ == '.')
    return (tolower(*s));
  return (0);
}

char *
setsuf(as, ch)
char *as;
char ch;
{
  register char *s, *s1;
  register char c;

  s = s1 = savestr(as);
  while (*s)
    if ((c = *s++) == '/' || c == ')')
      s1 = s;
  s[-1] = tolower(ch);
  return (s1);
}

callsys(f, v)
char *f, **v;
{
  int t, status;

  if(debug)
    prexec(f, v, 0, 0);

#ifdef i386
  t = fork();
  if (t == -1) {
    printf("No more processes\n");
    return (100);
  }
  if (t == 0) {
    execv(f, v);
    printf("Can't find %s\n", f);
    fflush(stdout);
    _exit(100);
  }
  while (t != wait(&status))
    ;
  if ((t=(status&0377)) != 0 && t!=14) {
    if (t!=2) {
      printf("Fatal error in %s\n", f);
      errflag = 8;
    }
    return(1);
  }
  return ((status>>8) & 0377);
#else
  if ((t = vexecv(f, v)) == -1) {
    printf("Can't find %s\n", f);
    fflush(stdout);
    idexit(1);
  }
  if (t == 0) {
    return (0);	/* all was a ok */
  }
  printf("Fatal error in %s\n", f);
  errflag = 8;
  return (1);	/* to shutup warnings */

#endif
}

nodup(l, os)
char **l, *os;
{
  register char *t, *s;
  register int c;

  s = os;
  if (getsuf(s) != 'o')
    return (1);
  while (t = *l++) {
    while (c = tolower(*s++))
      if (c != tolower(*t++))
        break;
    if (*t==0 && c==0)
      return (0);
    s = os;
  }
  return (1);
}

#define NSAVETAB 1024
char *savetab;
int saveleft;

char *
savestr(cp)
register char *cp;
{
  register int len;

  len = strlen(cp) + 1;
  if (len > saveleft) {
    saveleft = NSAVETAB;
    if (len > saveleft)
      saveleft = len;
    savetab = (char *)malloc(saveleft);
    if (savetab == 0) {
      fprintf(stderr, "ran out of memory (savestr)\n");
      idexit(1);
    }
  }
  strncpy(savetab, cp, len);
  cp = savetab;
  savetab += len;
  saveleft -= len;
  return (cp);
}

char *
strspl(left, right)
char *left, *right;
{
  char buf[BUFSIZ];

  strcpy(buf, left);
  strcat(buf, right);
  return (savestr(buf));
}

prexec(f, v, si, so)
char f[], *v[], *si, *so;
{
  int i;

  printf("%s ", f);
  for(i=1; v[i]; i++) {
    printf("%s ", v[i]);
  }
  if(si) printf(" <%s ", si);
  if(so) printf(" >%s ", so);
  printf("\n");
  fflush(stdout);
}

char *
strip(s)
char *s;
{
	register char	*ns;
	register char 	*t, *dot;

	ns = savestr(s);
	for (t = ns; *t ; ++t)
		if (*t == '.')
			dot = t;
	*dot = '\0';
	return ns;
}

char *
lastfield(s)
register char *s;
{
	register char *t;
	for (t = s; *s ; ++s)
		if (*s == '/' || *s == ')')
			t = s+1;
	return(t);
}
