/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      Declaration, Initialization, and Variable Ref.   */
/*                          Section - Basic type 2.1                         */
/*  Product and Revision :  Unix 1.3                                         */
/*  Author :                Suifun Law                                       */
/*  Date :                  3/15/84                                          */
/*  Source File :           source/decl.2112.c                               */
/*  Revisions :             09/30/83    Sqa     Original UTX 2.0 Release     */
/*                                                                           */
/*                          03/13/84    T. Aleksa   UTX-32 1.0 Release       */
/*                          -- Changed from class 3 to 1.                    */
/*                          -- Changed test description and added types      */
/*                             long int, unsigned short, unsigned long,      */
/*                             unsigned char, int and long float.  Unsigned  */
/*                             char is valid only for UTX-32 1.0 Release.    */
/*                                                                           */
/*  Description :           Verify that int, short int, long int, unsigned   */
/*                          int, unsigned short, unsigned long, unsigned     */
/*                          char, float and double can be declared and that  */
/*                          the correct number of bytes are allocated for    */
/*                          them.                                            */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/decl.21.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
 
#include <stdio.h>
main()
{  FILE *fp;
 int a,b,c,d,e,f,g,h,i,j,k,l,m,n;
    short int x;
    short    xx;
    long     yy;
    unsigned int z;
    unsigned     zz;
    char ch;
    float    fl;
    double   dd;
    int      in;
    long int li;
    unsigned short us;
    unsigned long  ul;
    unsigned char  uc;
    long float     lf;
    fp=fopen("decl_res bloc=y","a");
    if ( (a = sizeof(x)) != 2 ||
         (b = sizeof(xx)) != 2 ||
         (c = sizeof(yy)) != 4 ||
         (d = sizeof(z))  != 4 ||
         (e = sizeof(zz)) != 4 ||
         (f = sizeof(ch)) != 1 ||
         (g = sizeof(fl)) != 4 ||
         (h = sizeof(dd)) != 8 ||
         (i = sizeof(in)) != 4 ||
         (j = sizeof(li)) != 4 ||
         (k = sizeof(us)) != 2 ||
         (l = sizeof(ul)) != 4 ||
         (m = sizeof(uc)) != 1 ||
         (n = sizeof(lf)) != 8   )
         {
         fprintf(fp,"  ** declaration, basic types 2.1.1.2 class 1 fail exit return code : %d%d%d%d%d%d%d%d%d%d%d%d%d%d\n",a,b,c,d,e,f,g,h,i,j,k,l,m,n);
         printf("  ** declaration, basic types 2.1.1.2 class 1 fail exit return code : %d%d%d%d%d%d%d%d%d%d%d%d%d%d\n",a,b,c,d,e,f,g,h,i,j,k,l,m,n);
         } 
    else
         {
         fprintf(fp,"  .. declaration, basic types 2.1.1.2 class 1 pass\n");
         printf("  .. declaration, basic types 2.1.1.2 class 1 pass\n");
         fclose(fp);
         }
}
 
