/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      Declarations, Initialization and Variable        */
/*                          Reference  - Arrays                              */
/*                          Section - 2.6.1                                  */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Tina Aleksa                                      */
/*  Source File :           source/decl.2612.c                               */
/*                                                                           */
/*  Revisions :             06/04/84  Sqa   Original UTX-32 1.0 Release      */
/*  Date :                  6/19/84                                          */
/*  Description :           For single and double dimension arrays, verify   */
/*                          that static and external arrays of basic types   */
/*                          can be initialized on the declaration and the    */
/*                          elements can be referenced.                      */
/*                          The compiler fails if this program cannot        */
/*                          compile.                                         */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/decl.26.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
#include <stdio.h>
#define TRUE 1
 
int fail= 0;
 
/*  define and initialize external single and double dimension arrays */
 
int a1[10]   =  { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
int a2[3][3] =  { { 0, 1, 2 }, { 0, 1, 2 }, { 0, 1, 2 } };
 
short b1[10]  =  { 0, 5, 10, 15, 20, 25, 30, 35, 40, 45 };
short b2[4][4] = { { 0, 1, 2, 3 },{ 0, 1, 2, 3 },{ 0, 1, 2, 3 },{ 0, 1, 2, 3 }};
 
short int c1[5] = { 0, 3, 6, 9, 12 };
short int c2[2][2] = { { 1 }, { 2 } };
 
long d1[6] = { 0, 2, 4, 6, 8, 10 };
long d2[2][2] = { { 0, 1 }, { 0, 2 } };
 
long int e1[10] = { 0, 6, 12, 18, 24, 30, 36, 42, 48, 54 };
long int e2[2][5] = { { 0, 1, 2, 3, 4 }, { 0, 1, 2, 3, 4 } };
 
char f1[27] = "abcdefghijklmnopqrstuvwxyz";
char f2[2][27] = { "abcdefghijklmnopqrstuvwxyz", "zyxwvutsrqponmlkjihgfedcba" };
 
unsigned char g1[27] = "abcdefghijklmnopqrstuvwxyz";
unsigned char g2[2][27] = { "abcdefghijklmnopqrstuvwxyz",
                            "zyxwvutsrqponmlkjihgfedcba" };
 
unsigned h1[10] = { 0, 10, 20, 30, 40, 50, 60, 70, 80, 90 };
unsigned h2[2][10] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                       { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 } };
 
unsigned int i1[10] = { 0, 7, 14, 21, 28, 35, 42, 49, 56, 63 };
unsigned int i2[2][10] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                           { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 } };
 
unsigned short j1[10] = { 0, 4, 8, 12, 16, 20, 24, 28, 32, 36 };
unsigned short j2[2][10] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                             { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 } };
 
unsigned long k1[10] = { 0, 9, 18, 27, 36, 45, 54, 63, 72, 81 };
unsigned long k2[2][10] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                            { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 } };
 
float l1[10] = { 0, 1.5, 3.0, 4.5, 6.0, 7.5, 9.0, 10.5, 12.0, 13.5 };
float l2[2][10] = { { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0 },
                    { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0 } };
 
double m1[10] = { 0, .5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 };
double m2[2][10] = { { 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 },
                     { 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 } };
 
long float n1[10] = { 0, .5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 };
long float n2[2][10] = { { 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 },
                         { 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 } };
 
/*  define and initialize external static single and double dimension arrays */
 
static int a3[10]   = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
static int a4[3][3] = { 0, 1, 2, 0, 1, 2, 0, 1, 2 };
 
static short b3[10]  =  { 0, 5, 10, 15, 20, 25, 30, 35, 40, 45 };
static short b4[4][4] = { { 0, 1, 2, 3 },{ 0, 1, 2, 3 },{ 0, 1, 2, 3 },
                          { 0, 1, 2, 3 } };
 
static short int c3[5] = { 0, 3, 6, 9, 12 };
static short int c4[2][2] = { { 1 }, { 2 } };
 
static long d3[6] = { 0, 2, 4, 6, 8, 10 };
static long d4[2][2] = { { 0, 1 }, { 0, 2 } };
 
static long int e3[10] = { 0, 6, 12, 18, 24, 30, 36, 42, 48, 54 };
static long int e4[2][5] = { { 0, 1, 2, 3, 4 }, { 0, 1, 2, 3, 4 } };
 
static char f3[27] = { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k',
                       'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
                       'w', 'x', 'y', 'z','\0' };
static char f4[2][27] = { "abcdefghijklmnopqrstuvwxyz",
                          "zyxwvutsrqponmlkjihgfedcba"  };
 
static unsigned char g3[27] = { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
                                'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r',
                                's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '\0' };
static unsigned char g4[2][27] = { "abcdefghijklmnopqrstuvwxyz",
                                   "zyxwvutsrqponmlkjihgfedcba"  };
 
static unsigned h3[10] = { 0, 10, 20, 30, 40, 50, 60, 70, 80, 90 };
static unsigned h4[2][10] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
                              0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
 
static unsigned int i3[10] = { 0, 7, 14, 21, 28, 35, 42, 49, 56, 63 };
static unsigned int i4[2][10] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
                                  0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
 
static unsigned short j3[10] = { 0, 4, 8, 12, 16, 20, 24, 28, 32, 36 };
static unsigned short j4[2][10] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
                                    0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
 
static unsigned long k3[10] = { 0, 9, 18, 27, 36, 45, 54, 63, 72, 81 };
static unsigned long k4[2][10] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,
                                   0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
 
static float l3[10] = { 0, 1.5, 3.0, 4.5, 6.0, 7.5, 9.0, 10.5, 12.0, 13.5 };
static float l4[2][10] = { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0,
                           0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0 };
 
static double m3[10] = { 0, .5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 };
static double m4[2][10] = { 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5,
                            0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 };
 
static long float n3[10] = { 0, .5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 };
static long float n4[2][10] = {0.0, 0.5, 1.0, 1.5,2.0, 2.5,3.0, 3.5, 4.0, 4.5,
                               0.0, 0.5, 1.0, 1.5,2.0, 2.5,3.0, 3.5, 4.0, 4.5 };
FILE *fp;
 
main()
{
 
/*  define and initialize internal static single and double dimension arrays */
 
static int a5[10] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
static int a6[3][3] = { 0, 1, 2, 0, 1, 2, 0, 1, 2 };
 
static short b5[10]  =  { 0, 5, 10, 15, 20, 25, 30, 35, 40, 45 };
static short b6[4][4] = { { 0, 1, 2, 3 },{ 0, 1, 2, 3 },{ 0, 1, 2, 3 },
                          { 0, 1, 2, 3 } };
 
static short int c5[5] = { 0, 3, 6, 9, 12 };
static short int c6[2][2] = { { 1 }, { 2 } };
 
static long d5[6] = { 0, 2, 4, 6, 8, 10 };
static long d6[2][2] = { { 0, 1 }, { 0, 2 } };
 
static long int e5[10] = { 0, 6, 12, 18, 24, 30, 36, 42, 48, 54 };
static long int e6[2][5] = {  0, 1, 2, 3, 4, 0, 1, 2, 3, 4 };
 
static char f5[27] = "abcdefghijklmnopqrstuvwxyz";
static char f6[2][27] = { { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j',
                            'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't',
                            'u', 'v', 'w', 'x', 'y', 'z', '\0' },
                          { 'z', 'y', 'x', 'w', 'v', 'u', 't', 's', 'r', 'q',
                            'p', 'o', 'n', 'm', 'l', 'k', 'j', 'i', 'h', 'g',
                            'f', 'e', 'd', 'c', 'b', 'a', '\0' } };
 
static unsigned char g5[27] = "abcdefghijklmnopqrstuvwxyz";
static unsigned char g6[2][27] = { { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h',
                                     'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p',
                                     'q', 'r', 's', 't', 'u', 'v', 'w', 'x',
                                     'y', 'z', '\0' },
                                   { 'z', 'y', 'x', 'w', 'v', 'u', 't', 's',
                                     'r', 'q', 'p', 'o', 'n', 'm', 'l', 'k',
                                     'j', 'i', 'h', 'g', 'f', 'e', 'd', 'c',
                                     'b', 'a', '\0' } };
 
static unsigned h5[10] = { 0, 10, 20, 30, 40, 50, 60, 70, 80, 90 };
static unsigned h6[2][10] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                              { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 } };
 
static unsigned int i5[10] = { 0, 7, 14, 21, 28, 35, 42, 49, 56, 63 };
static unsigned int i6[2][10] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                  { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 } };
 
static unsigned short j5[10] = { 0, 4, 8, 12, 16, 20, 24, 28, 32, 36 };
static unsigned short j6[2][10] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                    { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 } };
 
static unsigned long k5[10] = { 0, 9, 18, 27, 36, 45, 54, 63, 72, 81 };
static unsigned long k6[2][10] = { { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 },
                                   { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 } };
 
static float l5[10] = { 0, 1.5, 3.0, 4.5, 6.0, 7.5, 9.0, 10.5, 12.0, 13.5 };
static float l6[2][10] = { 0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0,
                           0.0, 1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0 };
 
static double m5[10] = { 0, .5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 };
static double m6[2][10] = { 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5,
                            0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 };
 
static long float n5[10] = { 0, .5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0, 4.5 };
static long float n6[2][10] = { 0.0, 0.5,1.0, 1.5, 2.0,2.5, 3.0, 3.5,4.0, 4.5,
                                0.0, 0.5,1.0, 1.5, 2.0,2.5, 3.0, 3.5,4.0, 4.5 };
/*  Verify that all arrays are initialized correctly      */
 
suba ( a1, a2, a3, a4, a5, a6 );   /* arrays of type int */
subb ( b1, b2, b3, b4, b5, b6 );   /* arrays of type short */
subc ( c1, c2, c3, c4, c5, c6 );   /* arrays of type short  int */
subd ( d1, d2, d3, d4, d5, d6 );   /* arrays of type long */
sube ( e1, e2, e3, e4, e5, e6 );   /* arrays of type long  int */
subf ( f1, f2, f3, f4, f5, f6 );   /* arrays of type char */
subg ( g1, g2, g3, g4, g5, g6 );   /* arrays of type unsigned char */
subh ( h1, h2, h3, h4, h5, h6 );   /* arrays of type unsigned */
subi ( i1, i2, i3, i4, i5, i6 );   /* arrays of type unsigned int */
subj ( j1, j2, j3, j4, j5, j6 );   /* arrays of type unsigned short */
subk ( k1, k2, k3, k4, k5, k6 );   /* arrays of type unsigned long */
subl ( l1, l2, l3, l4, l5, l6 );   /* arrays of type float */
subm ( m1, m2, m3, m4, m5, m6 );   /* arrays of type double */
subn ( n1, n2, n3, n4, n5, n6 );   /* arrays of type long float */
 
fp=fopen("decl_res bloc=y","a");
 
if ( !fail ){
   fprintf(fp,"  .. declaration, arrays 2.6.1.2 class 1 pass\n" );
   printf("  .. declaration, arrays 2.6.1.2 class 1 pass\n" );
   }
}
 
/*  Test 2.6.1.2-1  -  This test verifies that both single and double
    dimension arrays declared of type int are initialized correctly.
    The error routine is handled by subroutine fail_a.
*/
suba ( a1, a2, a3, a4, a5, a6 )
int a1[10], a3[10], a5[10];
int a2[3][3], a4[3][3], a6[3][3];
{
  int a[10], b[3][3];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10 ; i++ )
  {
   a[i] = i;
   if ( a1[i] != a[i] ) fail1 = 1;
   if ( a3[i] != a[i] ) fail3 = 3;
   if ( a5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 3; i++ )
  {
   for ( j = 0; j < 3; j++ )
   {
    b[i][j] = j;
    if ( a2[i][j] != b[i][j] ) fail2 = 2;
    if ( a4[i][j] != b[i][j] ) fail4 = 4;
    if ( a6[i][j] != b[i][j] ) fail6 = 6;
   }
  }
 
  /*  If any of the fail flags are set, perform subroutine fail_a.
      Note that a dummy variable is passed to subroutine fail_a to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_a( a1, b, fail1 );
  if ( fail2 != 0 ) fail_a( a, a2, fail2 );
  if ( fail3 != 0 ) fail_a( a3, b, fail3 );
  if ( fail4 != 0 ) fail_a( a, a4, fail4 );
  if ( fail5 != 0 ) fail_a( a5, b, fail5 );
  if ( fail6 != 0 ) fail_a( a, a6, fail6 );
}
 
/*  Test 2.6.1.2-1  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-1.1 refers to array a1.
*/
fail_a ( a, b, test )
int a[10], b[3][3];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-1.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-1.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           for ( i = 0; i < 10; i++ )
           {
               fprintf(fp," %d ", a[i] );
               printf(" %d ", a[i] );
               }
        else
           {  for ( i = 0; i < 3; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 3; j++ )
                  {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
/*  Test 2.6.1.2-2  -  This test verifies that both single and double
    dimension arrays declared of type short are initialized correctly.
    The error routine is handled by subroutine fail_b.
*/
subb ( b1, b2, b3, b4, b5, b6 )
short b1[10], b3[10], b5[10];
short b2[4][4], b4[4][4], b6[4][4];
{
  short a[10], b[4][4];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10 ; i++ )
  {
   a[i] = i * 5;
   if ( b1[i] != a[i] ) fail1 = 1;
   if ( b3[i] != a[i] ) fail3 = 3;
   if ( b5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 4; i++ )
  {
   for ( j = 0; j < 4; j++ )
   {
    b[i][j] = j;
    if ( b2[i][j] != b[i][j] ) fail2 = 2;
    if ( b4[i][j] != b[i][j] ) fail4 = 4;
    if ( b6[i][j] != b[i][j] ) fail6 = 6;
   }
  }
 
  /*  If any of the fail flags are set, perform subroutine fail_b.
      Note that a dummy variable is passed to subroutine fail_b to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_b( b1, b, fail1 );
  if ( fail2 != 0 ) fail_b( a, b2, fail2 );
  if ( fail3 != 0 ) fail_b( b3, b, fail3 );
  if ( fail4 != 0 ) fail_b( a, b4, fail4 );
  if ( fail5 != 0 ) fail_b( b5, b, fail5 );
  if ( fail6 != 0 ) fail_b( a, b6, fail6 );
}
 
/*  Test 2.6.1.2-2  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-2.1 refers to array b1.
*/
fail_b ( a, b, test )
short a[10], b[4][4];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-2.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-2.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
           {
                  fprintf(fp," %d ", a[i] );
                  printf(" %d ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 4; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 4; j++ )
                  {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-3  -  This test verifies that both single and double
    dimension arrays declared of type short int are initialized correctly.
    The error routine is handled by subroutine fail_c.
*/
subc ( c1, c2, c3, c4, c5, c6 )
short int c1[5], c3[5], c5[5];
short int c2[2][2], c4[2][2], c6[2][2];
{
  short int a[5], b[2][2];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 5 ; i++ )
  {
   a[i] = i * 3;
   if ( c1[i] != a[i] ) fail1 = 1;
   if ( c3[i] != a[i] ) fail3 = 3;
   if ( c5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
  b[0][0] = 1;
  b[0][1] = 0;
  b[1][0] = 2;
  b[1][1] = 0;
  for ( i = 0; i < 2; i++ )
  {
   for ( j = 0; j < 2; j++ )
   {
    if ( c2[i][j] != b[i][j] ) fail2 = 2;
    if ( c4[i][j] != b[i][j] ) fail4 = 4;
    if ( c6[i][j] != b[i][j] ) fail6 = 6;
   }
  }
 
  /*  If any of the fail flags are set, perform subroutine fail_c.
      Note that a dummy variable is passed to subroutine fail_c to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_c( c1, b, fail1 );
  if ( fail2 != 0 ) fail_c( a, c2, fail2 );
  if ( fail3 != 0 ) fail_c( c3, b, fail3 );
  if ( fail4 != 0 ) fail_c( a, c4, fail4 );
  if ( fail5 != 0 ) fail_c( c5, b, fail5 );
  if ( fail6 != 0 ) fail_c( a, c6, fail6 );
}
 
/*  Test 2.6.1.2-3  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-3.1 refers to array c1.
*/
fail_c ( a, b, test )
short int a[5], b[2][2];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-3.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-3.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 5; i++ )
               {
                  fprintf(fp," %d ", a[i] );
                  printf(" %d ", a[i] );
                  }
 
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 2; j++ )
                  {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-4  -  This test verifies that both single and double
    dimension arrays declared of type long are initialized correctly.
    The error routine is handled by subroutine fail_d.
*/
subd ( d1, d2, d3, d4, d5, d6 )
long d1[6], d3[6], d5[6];
long d2[2][2], d4[2][2], d6[2][2];
{
  long a[6], b[2][2];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 6 ; i++ )
  {
   a[i] = i * 2;
   if ( d1[i] != a[i] ) fail1 = 1;
   if ( d3[i] != a[i] ) fail3 = 3;
   if ( d5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
  b[0][0] = 0;                  /* initialize elements */
  b[0][1] = 1;
  b[1][0] = 0;
  b[1][1] = 2;
  for ( i = 0; i < 2; i++ )
  {
   for ( j = 0; j < 2; j++ )
   {
    if ( d2[i][j] != b[i][j] ) fail2 = 2;
    if ( d4[i][j] != b[i][j] ) fail4 = 4;
    if ( d6[i][j] != b[i][j] ) fail6 = 6;
   }
  }
 
  /*  If any of the fail flags are set, perform subroutine fail_d.
      Note that a dummy variable is passed to subroutine fail_d to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_d( d1, b, fail1 );
  if ( fail2 != 0 ) fail_d( a, d2, fail2 );
  if ( fail3 != 0 ) fail_d( d3, b, fail3 );
  if ( fail4 != 0 ) fail_d( a, d4, fail4 );
  if ( fail5 != 0 ) fail_d( d5, b, fail5 );
  if ( fail6 != 0 ) fail_d( a, d6, fail6 );
}
 
/*  Test 2.6.1.2-4  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-4.1 refers to array d1.
*/
fail_d ( a, b, test )
long a[6], b[2][2];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-4.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-4.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 6; i++ )
                 {
                  fprintf(fp," %d ", a[i] );
                  printf(" %d ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 2; j++ )
                   {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-5  -  This test verifies that both single and double
    dimension arrays declared of type long int are initialized correctly.
    The error routine is handled by subroutine fail_e.
*/
sube ( e1, e2, e3, e4, e5, e6 )
long int e1[10], e3[10], e5[10];
long int e2[2][5], e4[2][5], e6[2][5];
{
  long int a[10], b[2][5];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10 ; i++ )
  {
   a[i] = i * 6;
   if ( e1[i] != a[i] ) fail1 = 1;
   if ( e3[i] != a[i] ) fail3 = 3;
   if ( e5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 2; i++ )
  {
   for ( j = 0; j < 5; j++ )
   {
    b[i][j] = j;
    if ( e2[i][j] != b[i][j] ) fail2 = 2;
    if ( e4[i][j] != b[i][j] ) fail4 = 4;
    if ( e6[i][j] != b[i][j] ) fail6 = 6;
   }
  }
 
  /*  If any of the fail flags are set, perform subroutine fail_e.
      Note that a dummy variable is passed to subroutine fail_e to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_e( e1, b, fail1 );
  if ( fail2 != 0 ) fail_e( a, e2, fail2 );
  if ( fail3 != 0 ) fail_e( e3, b, fail3 );
  if ( fail4 != 0 ) fail_e( a, e4, fail4 );
  if ( fail5 != 0 ) fail_e( e5, b, fail5 );
  if ( fail6 != 0 ) fail_e( a, e6, fail6 );
}
 
/*  Test 2.6.1.2-5  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-5.1 refers to array e1.
*/
fail_e ( a, b, test )
long int a[10], b[2][5];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-5.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-5.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
                {
                  fprintf(fp," %d ", a[i] );
                  printf(" %d ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 5; j++ )
                  {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-6  -  This test verifies that both single and double
    dimension arrays declared of type char are initialized correctly.
    The error routine is handled by subroutine fail_f.
*/
subf ( f1, f2, f3, f4, f5, f6 )
char f1[27], f3[27], f5[27];
char f2[2][27], f4[2][27], f6[2][27];
{
  char a[27], b[2][27], c;
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0, c = 'a'; i < 27 ; i++, c++ )
  {
 
   if ( i == 26 )  /*  the null character is in the last element of the array */
       a[i] = '\0';
   else
       a[i] = c;
 
   if ( f1[i] != a[i] ) fail1 = 1;
   if ( f3[i] != a[i] ) fail3 = 3;
   if ( f5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0, j = 0, c = 'a'; j < 26; j++, c++ )
   {
    if ( j == 26 ) /*  the null character is in the last element of the array */
       b[i][j] = '\0';
    else
       b[i][j] = c;
 
    if ( f2[i][j] != b[i][j] ) fail2 = 2;
    if ( f4[i][j] != b[i][j] ) fail4 = 4;
    if ( f6[i][j] != b[i][j] ) fail6 = 6;
   }
 
   for ( i = 1, j = 0, c = 'z'; j < 26; j++, c-- )
   {
    if ( j == 26 ) /*  the null character is in the last element of the array */
       b[i][j] = '\0';
    else
       b[i][j] = c;
 
    if ( f2[i][j] != b[i][j] ) fail2 = 2;
    if ( f4[i][j] != b[i][j] ) fail4 = 4;
    if ( f6[i][j] != b[i][j] ) fail6 = 6;
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_f.
      Note that a dummy variable is passed to subroutine fail_f to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_f( f1, b, fail1 );
  if ( fail2 != 0 ) fail_f( a, f2, fail2 );
  if ( fail3 != 0 ) fail_f( f3, b, fail3 );
  if ( fail4 != 0 ) fail_f( a, f4, fail4 );
  if ( fail5 != 0 ) fail_f( f5, b, fail5 );
  if ( fail6 != 0 ) fail_f( a, f6, fail6 );
}
 
/*  Test 2.6.1.2-6  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-6.1 refers to array f1.
*/
fail_f ( a, b, test )
char a[27], b[2][27];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-6.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-6.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 27; i++ )
              {
                  fprintf(fp," %c ", a[i] );
                  printf(" %c ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 27; j++ )
                  {
                      fprintf(fp," %c ", b[i][j] );
                      printf(" %c ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-7  -  This test verifies that both single and double
    dimension arrays declared of type unsigned char are initialized correctly.
    The error routine is handled by subroutine fail_g.
*/
subg ( g1, g2, g3, g4, g5, g6 )
unsigned char g1[27], g3[27], g5[27];
unsigned char g2[2][27], g4[2][27], g6[2][27];
{
  unsigned char a[27], b[2][27], c;
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0, c = 'a'; i < 27 ; i++, c++ )
  {
 
   if ( i == 26 )  /*  the null character is in the last element of the array */
       a[i] = '\0';
   else
       a[i] = c;
 
   if ( g1[i] != a[i] ) fail1 = 1;
   if ( g3[i] != a[i] ) fail3 = 3;
   if ( g5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0, j = 0, c = 'a'; j < 26; j++, c++ )
   {
    if ( j == 26 ) /*  the null character is in the last element of the array */
       b[i][j] = '\0';
    else
       b[i][j] = c;
 
    if ( g2[i][j] != b[i][j] ) fail2 = 2;
    if ( g4[i][j] != b[i][j] ) fail4 = 4;
    if ( g6[i][j] != b[i][j] ) fail6 = 6;
   }
 
   for ( i = 1, j = 0, c = 'z'; j < 26; j++, c-- )
   {
    if ( j == 26 ) /*  the null character is in the last element of the array */
       b[i][j] = '\0';
    else
       b[i][j] = c;
 
    if ( g2[i][j] != b[i][j] ) fail2 = 2;
    if ( g4[i][j] != b[i][j] ) fail4 = 4;
    if ( g6[i][j] != b[i][j] ) fail6 = 6;
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_g.
      Note that a dummy variable is passed to subroutine fail_g to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_g( g1, b, fail1 );
  if ( fail2 != 0 ) fail_g( a, g2, fail2 );
  if ( fail3 != 0 ) fail_g( g3, b, fail3 );
  if ( fail4 != 0 ) fail_g( a, g4, fail4 );
  if ( fail5 != 0 ) fail_g( g5, b, fail5 );
  if ( fail6 != 0 ) fail_g( a, g6, fail6 );
}
 
/*  Test 2.6.1.2-7  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-7.1 refers to array g1.
*/
fail_g ( a, b, test )
unsigned char a[27], b[2][27];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-7.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-7.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 27; i++ )
           {
                  fprintf(fp," %c ", a[i] );
                  printf(" %c ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 27; j++ )
                  {
                      fprintf(fp," %c ", b[i][j] );
                      printf(" %c ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-8  -  This test verifies that both single and double
    dimension arrays declared of type unsigned are initialized correctly.
    The error routine is handled by subroutine fail_h.
*/
subh ( h1, h2, h3, h4, h5, h6 )
unsigned h1[10], h3[10], h5[10];
unsigned h2[2][10], h4[2][10], h6[2][10];
{
  unsigned a[10], b[2][10];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10 ; i++ )
  {
   a[i] = i * 10;
   if ( h1[i] != a[i] ) fail1 = 1;
   if ( h3[i] != a[i] ) fail3 = 3;
   if ( h5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0; i < 2; i++ )
   {
    for ( j = 0; j < 10; j++ )
    {
      b[i][j] = j;
      if ( h2[i][j] != b[i][j] ) fail2 = 2;
      if ( h4[i][j] != b[i][j] ) fail4 = 4;
      if ( h6[i][j] != b[i][j] ) fail6 = 6;
    }
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_h.
      Note that a dummy variable is passed to subroutine fail_h to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_h( h1, b, fail1 );
  if ( fail2 != 0 ) fail_h( a, h2, fail2 );
  if ( fail3 != 0 ) fail_h( h3, b, fail3 );
  if ( fail4 != 0 ) fail_h( a, h4, fail4 );
  if ( fail5 != 0 ) fail_h( h5, b, fail5 );
  if ( fail6 != 0 ) fail_h( a, h6, fail6 );
}
 
/*  Test 2.6.1.2-8  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-8.1 refers to array h1.
*/
fail_h ( a, b, test )
unsigned a[10], b[2][10];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-8.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-8.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
                  {
                  fprintf(fp," %d ", a[i] );
                  printf(" %d ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 10; j++ )
                   {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-9  -  This test verifies that both single and double
    dimension arrays declared of type unsigned int are initialized correctly.
    The error routine is handled by subroutine fail_i.
*/
subi ( i1, i2, i3, i4, i5, i6 )
unsigned int i1[10], i3[10], i5[10];
unsigned int i2[2][10], i4[2][10], i6[2][10];
{
  unsigned int a[10], b[2][10];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10 ; i++ )
  {
   a[i] = i * 7;
   if ( i1[i] != a[i] ) fail1 = 1;
   if ( i3[i] != a[i] ) fail3 = 3;
   if ( i5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0; i < 2; i++ )
   {
    for ( j = 0; j < 10; j++ )
    {
      b[i][j] = j;
      if ( i2[i][j] != b[i][j] ) fail2 = 2;
      if ( i4[i][j] != b[i][j] ) fail4 = 4;
      if ( i6[i][j] != b[i][j] ) fail6 = 6;
    }
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_i.
      Note that a dummy variable is passed to subroutine fail_i to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_i( i1, b, fail1 );
  if ( fail2 != 0 ) fail_i( a, i2, fail2 );
  if ( fail3 != 0 ) fail_i( i3, b, fail3 );
  if ( fail4 != 0 ) fail_i( a, i4, fail4 );
  if ( fail5 != 0 ) fail_i( i5, b, fail5 );
  if ( fail6 != 0 ) fail_i( a, i6, fail6 );
}
 
/*  Test 2.6.1.2-9  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-9.1 refers to array i1.
*/
fail_i ( a, b, test )
unsigned  int a[10], b[2][10];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-9.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-9.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
                  {
                  fprintf(fp," %d ", a[i] );
                  printf(" %d ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 10; j++ )
                  {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-10  -  This test verifies that both single and double
    dimension arrays declared of type unsigned short are initialized correctly.
    The error routine is handled by subroutine fail_j.
*/
subj ( j1, j2, j3, j4, j5, j6 )
unsigned short j1[10], j3[10], j5[10];
unsigned short j2[2][10], j4[2][10], j6[2][10];
{
  unsigned short a[10], b[2][10];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10 ; i++ )
  {
   a[i] = i * 4;
   if ( j1[i] != a[i] ) fail1 = 1;
   if ( j3[i] != a[i] ) fail3 = 3;
   if ( j5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0; i < 2; i++ )
   {
    for ( j = 0; j < 10; j++ )
    {
      b[i][j] = j;
      if ( j2[i][j] != b[i][j] ) fail2 = 2;
      if ( j4[i][j] != b[i][j] ) fail4 = 4;
      if ( j6[i][j] != b[i][j] ) fail6 = 6;
    }
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_j.
      Note that a dummy variable is passed to subroutine fail_j to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_j( j1, b, fail1 );
  if ( fail2 != 0 ) fail_j( a, j2, fail2 );
  if ( fail3 != 0 ) fail_j( j3, b, fail3 );
  if ( fail4 != 0 ) fail_j( a, j4, fail4 );
  if ( fail5 != 0 ) fail_j( j5, b, fail5 );
  if ( fail6 != 0 ) fail_j( a, j6, fail6 );
}
 
/*  Test 2.6.1.2-10  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-10.1 refers to array j1.
*/
fail_j ( a, b, test )
unsigned short a[10], b[2][10];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-10.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-10.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
                {
                  fprintf(fp," %d ", a[i] );
                  printf(" %d ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 10; j++ )
                     {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-11  -  This test verifies that both single and double
    dimension arrays declared of type unsigned long are initialized correctly.
    The error routine is handled by subroutine fail_k.
*/
subk ( k1, k2, k3, k4, k5, k6 )
unsigned long k1[10], k3[10], k5[10];
unsigned long k2[2][10], k4[2][10], k6[2][10];
{
  unsigned long a[10], b[2][10];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10 ; i++ )
  {
   a[i] = i * 9;
   if ( k1[i] != a[i] ) fail1 = 1;
   if ( k3[i] != a[i] ) fail3 = 3;
   if ( k5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0; i < 2; i++ )
   {
    for ( j = 0; j < 10; j++ )
    {
      b[i][j] = j;
      if ( k2[i][j] != b[i][j] ) fail2 = 2;
      if ( k4[i][j] != b[i][j] ) fail4 = 4;
      if ( k6[i][j] != b[i][j] ) fail6 = 6;
    }
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_k.
      Note that a dummy variable is passed to subroutine fail_k to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_k( k1, b, fail1 );
  if ( fail2 != 0 ) fail_k( a, k2, fail2 );
  if ( fail3 != 0 ) fail_k( k3, b, fail3 );
  if ( fail4 != 0 ) fail_k( a, k4, fail4 );
  if ( fail5 != 0 ) fail_k( k5, b, fail5 );
  if ( fail6 != 0 ) fail_k( a, k6, fail6 );
}
 
/*  Test 2.6.1.2-11  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-11.1 refers to array k1.
*/
fail_k ( a, b, test )
unsigned long a[10], b[2][10];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-11.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-11.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
                {
                  fprintf(fp," %d ", a[i] );
                  printf(" %d ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 10; j++ )
                    {
                      fprintf(fp," %d ", b[i][j] );
                      printf(" %d ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-12  -  This test verifies that both single and double
    dimension arrays declared of type float are initialized correctly.
    The error routine is handled by subroutine fail_l.
*/
subl ( l1, l2, l3, l4, l5, l6 )
float l1[10], l3[10], l5[10];
float l2[2][10], l4[2][10], l6[2][10];
{
  float a[10], b[2][10];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10 ; i++ )
  {
   a[i] = i * 1.5;
   if ( l1[i] != a[i] ) fail1 = 1;
   if ( l3[i] != a[i] ) fail3 = 3;
   if ( l5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0; i < 2; i++ )
   {
    for ( j = 0; j < 10; j++ )
    {
      b[i][j] = j;
      if ( l2[i][j] != b[i][j] ) fail2 = 2;
      if ( l4[i][j] != b[i][j] ) fail4 = 4;
      if ( l6[i][j] != b[i][j] ) fail6 = 6;
    }
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_l.
      Note that a dummy variable is passed to subroutine fail_l to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_l( l1, b, fail1 );
  if ( fail2 != 0 ) fail_l( a, l2, fail2 );
  if ( fail3 != 0 ) fail_l( l3, b, fail3 );
  if ( fail4 != 0 ) fail_l( a, l4, fail4 );
  if ( fail5 != 0 ) fail_l( l5, b, fail5 );
  if ( fail6 != 0 ) fail_l( a, l6, fail6 );
}
 
/*  Test 2.6.1.2-12  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-12.1 refers to array l1.
*/
fail_l ( a, b, test )
float a[10], b[2][10];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-12.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-12.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
                {
                  fprintf(fp," %f ", a[i] );
                  printf(" %f ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 10; j++ )
                    {
                      fprintf(fp," %f ", b[i][j] );
                      printf(" %f ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-13  -  This test verifies that both single and double
    dimension arrays declared of type double are initialized correctly.
    The error routine is handled by subroutine fail_m.
*/
subm ( m1, m2, m3, m4, m5, m6 )
double m1[10], m3[10], m5[10];
double m2[2][10], m4[2][10], m6[2][10];
{
  double a[10], b[2][10];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10; i++ )
  {
   a[i] = i * 0.5;
   if ( m1[i] != a[i] ) fail1 = 1;
   if ( m3[i] != a[i] ) fail3 = 3;
   if ( m5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0; i < 2; i++ )
   {
    for ( j = 0; j < 10; j++ )
    {
      b[i][j] = j * .5;
      if ( m2[i][j] != b[i][j] ) fail2 = 2;
      if ( m4[i][j] != b[i][j] ) fail4 = 4;
      if ( m6[i][j] != b[i][j] ) fail6 = 6;
    }
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_m.
      Note that a dummy variable is passed to subroutine fail_m to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_m( m1, b, fail1 );
  if ( fail2 != 0 ) fail_m( a, m2, fail2 );
  if ( fail3 != 0 ) fail_m( m3, b, fail3 );
  if ( fail4 != 0 ) fail_m( a, m4, fail4 );
  if ( fail5 != 0 ) fail_m( m5, b, fail5 );
  if ( fail6 != 0 ) fail_m( a, m6, fail6 );
}
 
/*  Test 2.6.1.2-13  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-13.1 refers to array m1.
*/
fail_m ( a, b, test )
double a[10], b[2][10];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-13.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-13.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
                {
                  fprintf(fp," %f ", a[i] );
                  printf(" %f ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 10; j++ )
                     {
                      fprintf(fp," %f ", b[i][j] );
                      printf(" %f ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
 
}
 
/*  Test 2.6.1.2-14  -  This test verifies that both single and double
    dimension arrays declared of type long float are initialized correctly.
    The error routine is handled by subroutine fail_n.
*/
subn ( n1, n2, n3, n4, n5, n6 )
long float n1[10], n3[10], n5[10];
long float n2[2][10], n4[2][10], n6[2][10];
{
  long float a[10], b[2][10];
  int fail1, fail2, fail3, fail4, fail5, fail6;
  int i, j;
 
  fail1 = fail2 = fail3 = fail4 = fail5 = fail6 = 0;
 
  /*  Compare single dimension arrays with array a declared and initialized
      within the subroutine.
  */
  for ( i = 0; i < 10; i++ )
  {
   a[i] = i * 0.5;
   if ( n1[i] != a[i] ) fail1 = 1;
   if ( n3[i] != a[i] ) fail3 = 3;
   if ( n5[i] != a[i] ) fail5 = 5;
  }
 
  /*  Compare double dimension arrays with array b declared and initialized
      within the subroutine.
  */
   for ( i = 0; i < 2; i++ )
   {
    for ( j = 0; j < 10; j++ )
    {
      b[i][j] = j * .5;
      if ( n2[i][j] != b[i][j] ) fail2 = 2;
      if ( n4[i][j] != b[i][j] ) fail4 = 4;
      if ( n6[i][j] != b[i][j] ) fail6 = 6;
    }
   }
 
  /*  If any of the fail flags are set, perform subroutine fail_n.
      Note that a dummy variable is passed to subroutine fail_n to allow
      for both single and double dimension error reporting in that subroutine.
  */
  if ( fail1 != 0 ) fail_n( n1, b, fail1 );
  if ( fail2 != 0 ) fail_n( a, n2, fail2 );
  if ( fail3 != 0 ) fail_n( n3, b, fail3 );
  if ( fail4 != 0 ) fail_n( a, n4, fail4 );
  if ( fail5 != 0 ) fail_n( n5, b, fail5 );
  if ( fail6 != 0 ) fail_n( a, n6, fail6 );
}
 
/*  Test 2.6.1.2-14  Error routine :  This subroutine outputs the values
    of the array in error indicated by its test number. Example :
    2.6.1.2-14.1 refers to array n1.
*/
fail_n ( a, b, test )
long float a[10], b[2][10];
int test;
{
        int i,j;
        fail = TRUE;
        fprintf(fp,"  ** declaration, array 2.6.1.2-14.%d class 1 fail exit return code : \n", test );
        printf("  ** declaration, array 2.6.1.2-14.%d class 1 fail exit return code : \n", test );
 
        if ( test == 1 || test == 3 || test == 5 ) /* single dimension array */
           {  for ( i = 0; i < 10; i++ )
                {
                  fprintf(fp," %f ", a[i] );
                  printf(" %f ", a[i] );
                  }
           }
        else
           {  for ( i = 0; i < 2; i++ )            /* double dimension array */
              {
                  for ( j = 0; j < 10; j++ )
                    {
                      fprintf(fp," %f ", b[i][j] );
                      printf(" %f ", b[i][j] );
                      }
                  fprintf(fp,"\n");
                  printf("\n");
              }
           }
 
         fprintf(fp,"\n\n");
         printf("\n\n");
         fclose(fp);
 
}
