/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      Declarations, Initialization and Variable        */
/*                          Reference  - Arrays                              */
/*                          Section - 2.6.1                                  */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Tina Aleksa                                      */
/*  Source File :           source/decl.2614.c                               */
/*                                                                           */
/*  Revisions :             07/10/84  Sqa   Original UTX-32 1.0 Release      */
/*  Date :                  2/26/85                                          */
/*  Description :           For single and double dimension arrays, verify   */
/*                          that arrays of basic types can be initialized    */
/*                          and referenced.                                  */
/*                          The compiler fails if this program cannot        */
/*                          compile.                                         */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/decl.26.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
#include <stdio.h>
#define TRUE 1
 
int fail;
 
main()
{
 
FILE *fp;
fp=fopen("decl_res bloc=y","a");
fail= 0;
/*  Test 1  */
{
 int a1[10];
 int a2[3][3];
 int *a3[5], a4[5], a5[5];
 
        a1[0] = 1;
        a1[9] = 2;
        a1[1] = a1[0] + a1[9];
 
        a2[0][0] = 3;
        a2[2][2] = 4;
        a2[1][1] = a2[0][0] + a2[2][2];
 
        a3[0] = a4;
        a3[1] = a5;
        a3[0][0] = 5;
        a3[1][1] = 6;
        a3[0][1] = a3[0][0] + a3[1][1];
 
        if ( a1[1] != 3 || a2[1][1] != 7 || a3[0][1] != 11 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-1 class 1 fail exit return code : %d %d %d\n",a1[1], a2[1][1], a3[0][1] );
             printf("  ** declaration, array 2.6.1.4-1 class 1 fail exit return code : %d %d %d\n",a1[1], a2[1][1], a3[0][1] );
           }
}
 
/*  Test 2  */
{
 short b1[10];
 short b2[3][3];
 short *b3[5], a4[5], a5[5];
 
        b1[1] = 1;
        b1[8] = 2;
        b1[2] = b1[1] * b1[8];
 
        b2[0][1] = 3;
        b2[2][0] = 4;
        b2[1][2] = b2[0][1] * b2[2][0];
 
        b3[0] = a4;
        b3[1] = a5;
        b3[0][2] = 5;
        b3[1][3] = 6;
        b3[1][0] = b3[0][2] * b3[1][3];
 
        if ( b1[2] != 2 || b2[1][2] != 12 || b3[1][0] != 30 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-2 class 1 fail exit return code : %d %d %d\n",b1[2], b2[1][2], b3[1][0] );
             printf("  ** declaration, array 2.6.1.4-2 class 1 fail exit return code : %d %d %d\n",b1[2], b2[1][2], b3[1][0] );
           }
}
 
/*  Test 3  */
{
 short int c1[10];
 short int c2[3][3];
 short int *c3[5], c4[5], c5[5];
 
        c1[2] = 1;
        c1[7] = 2;
        c1[3] = c1[2] / c1[7];
 
        c2[0][1] = 3;
        c2[0][2] = 4;
        c2[0][0] = c2[0][2] / c2[0][1];
 
        c3[1] = c4;
        c3[2] = c5;
        c3[1][1] = 5;
        c3[2][1] = 6;
        c3[2][2] = c3[1][1] / c3[2][1];
 
        if ( c1[3] != 0 || c2[0][0] != 1 || c3[2][2] != 0 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-3 class 1 fail exit return code : %d %d %d\n",c1[3], c2[0][0], c3[2][2] );
             printf("  ** declaration, array 2.6.1.4-3 class 1 fail exit return code : %d %d %d\n",c1[3], c2[0][0], c3[2][2] );
           }
}
 
/*  Test 4  */
{
 long d1[10];
 long d2[3][3];
 long *d3[5], d4[5], d5[5];
 
        d1[3] = 1;
        d1[6] = 2;
        d1[4] = d1[6] - d1[3];
 
        d2[0][2] = 3;
        d2[1][2] = 4;
        d2[0][1] = d2[0][2] - d2[1][2];
 
        d3[1] = d4;
        d3[2] = d5;
        d3[1][2] = 5;
        d3[2][2] = 6;
        d3[2][1] = d3[2][2] - d3[1][2];
 
        if ( d1[4] != 1 || d2[0][1] != -1 || d3[2][1] != 1 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-4 class 1 fail exit return code : %d %d %d\n",d1[4], d2[0][1], d3[2][1] );
             printf("  ** declaration, array 2.6.1.4-4 class 1 fail exit return code : %d %d %d\n",d1[4], d2[0][1], d3[2][1] );
           }
}
 
/*  Test 5  */
{
 long int e1[10];
 long int e2[3][3];
 long int *e3[5], e4[5], e5[5];
 
        e1[4] = 1;
        e1[5] = 2;
        e1[6] = e1[4] + e1[5];
 
        e2[1][0] = 3;
        e2[2][0] = 4;
        e2[1][1] = e2[1][0] + e2[2][0];
 
        e3[3] = e4;
        e3[4] = e5;
        e3[3][2] = 5;
        e3[4][2] = 6;
        e3[4][0] = e3[3][2] + e3[4][2];
 
        if ( e1[6] != 3 || e2[1][1] != 7 || e3[4][0] != 11 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-5 class 1 fail exit return code : %d %d %d\n",e1[6], e2[1][1], e3[4][0] );
             printf("  ** declaration, array 2.6.1.4-5 class 1 fail exit return code : %d %d %d\n",e1[6], e2[1][1], e3[4][0] );
           }
}
 
/*  Test 6  */
{
 char f1[27];
 char f2[2][27];
 char *f3[5], f4[5], f5[5];
 
        f1[0] = 'a';
        f1[26] = 'z';
 
        f2[0][0] = 'b';
        f2[1][26] = 'c';
 
        f3[4] = f4;
        f3[3] = f5;
        f3[4][0] = 'd';
        f3[3][4] = 'y';
 
        if ( f1[0] != 'a' || f1[26] != 'z' || f2[0][0] != 'b' ||
             f2[1][26] != 'c' || f3[4][0] != 'd' || f3[3][4] != 'y' )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-6 class 1 fail exit return code : %c %c %c %c %c %c\n",f1[0], f1[26], f2[0][0], f2[1][26], f3[4][0], f3[3][4] );
             printf("  ** declaration, array 2.6.1.4-6 class 1 fail exit return code : %c %c %c %c %c %c\n",f1[0], f1[26], f2[0][0], f2[1][26], f3[4][0], f3[3][4] );
           }
}
 
/*  Test 7  */
{
 unsigned char g1[27];
 unsigned char g2[2][27];
 unsigned char *g3[5], g4[5], g5[5];
 
        g1[1] = 'a';
        g1[25] = 'z';
        g2[1][0] = 'b';
        g2[0][26] = 'c';
 
        g3[2] = g4;
        g3[1] = g5;
        g3[2][4] = 'd';
        g3[1][0] = 'y';
 
        if ( g1[1] != 'a' || g1[25] != 'z' || g2[1][0] != 'b' ||
             g2[0][26] != 'c' || g3[2][4] != 'd' || g3[1][0] != 'y' )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-7 class 1 fail exit return code : %c %c %c %c %c %c\n",g1[1], g1[25], g2[1][0], g2[0][26], g3[2][4], g3[1][0] );
             printf("  ** declaration, array 2.6.1.4-7 class 1 fail exit return code : %c %c %c %c %c %c\n",g1[1], g1[25], g2[1][0], g2[0][26], g3[2][4], g3[1][0] );
           }
}
 
/*  Test 8  */
{
 unsigned h1[10];
 unsigned h2[3][3];
 unsigned *h3[5], h4[5], h5[5];
 
        h1[5] = 1;
        h1[4] = 2;
        h1[3] = h1[5] * h1[4];
 
        h2[2][2] = 3;
        h2[1][1] = 4;
        h2[2][0] = h2[2][2] * h2[1][1];
 
        h3[0] = h4;
        h3[1] = h5;
        h3[0][2] = 5;
        h3[1][0] = 6;
        h3[0][1] = h3[0][2] * h3[1][0];
 
        if ( h1[3] != 2 || h2[2][0] != 12 || h3[0][1] != 30 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-8 class 1 fail exit return code : %d %d %d\n",h1[3], h2[2][0], h3[0][1] );
           }
}
 
/*  Test 9  */
{
 unsigned int i1[10];
 unsigned int i2[3][3];
 unsigned int *i3[5], i4[5], i5[5];
 
        i1[6] = 1;
        i1[3] = 2;
        i1[4] = i1[6] + i1[3];
 
        i2[0][0] = 3;
        i2[0][2] = 4;
        i2[0][1] = i2[0][0] + i2[0][2];
 
        i3[1] = i4;
        i3[2] = i5;
        i3[1][0] = 5;
        i3[2][1] = 6;
        i3[1][1] = i3[1][0] + i3[2][1];
 
        if ( i1[4] != 3 || i2[0][1] != 7 || i3[1][1] != 11 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-9 class 1 fail exit return code : %d %d %d\n",i1[4], i2[0][1], i3[1][1] );
             printf("  ** declaration, array 2.6.1.4-9 class 1 fail exit return code : %d %d %d\n",i1[4], i2[0][1], i3[1][1] );
           }
}
 
/*  Test 10  */
{
 unsigned short j1[10];
 unsigned short j2[3][3];
 unsigned short *j3[5], j4[5], j5[5];
 
        j1[7] = 1;
        j1[2] = 2;
        j1[6] = j1[7] * j1[2];
 
        j2[1][1] = 3;
        j2[2][0] = 4;
        j2[1][0] = j2[1][1] * j2[2][0];
 
        j3[3] = j4;
        j3[4] = j5;
        j3[3][1] = 5;
        j3[4][2] = 6;
        j3[3][0] = j3[3][1] * j3[4][2];
 
        if ( j1[6] != 2 || j2[1][0] != 12 || j3[3][0] != 30 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-10 class 1 fail exit return code : %d %d %d\n",j1[6], j2[1][0], j3[3][0] );
             printf("  ** declaration, array 2.6.1.4-10 class 1 fail exit return code : %d %d %d\n",j1[6], j2[1][0], j3[3][0] );
           }
}
 
/*  Test 11  */
{
 unsigned long k1[10];
 unsigned long k2[3][3];
 unsigned long *k3[5], k4[5], k5[5];
 
        k1[8] = 1;
        k1[1] = 2;
        k1[7] = k1[8] + k1[1];
 
        k2[1][2] = 3;
        k2[2][1] = 4;
        k2[1][0] = k2[1][2] + k2[2][1];
 
        k3[0] = k4;
        k3[1] = k5;
        k3[0][1] = 5;
        k3[1][2] = 6;
        k3[0][2] = k3[0][1] + k3[1][2];
 
        if ( k1[7] != 3 || k2[1][0] != 7 || k3[0][2] != 11 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-11 class 1 fail exit return code : %d %d %d\n",k1[7], k2[1][0], k3[0][2] );
             printf("  ** declaration, array 2.6.1.4-11 class 1 fail exit return code : %d %d %d\n",k1[7], k2[1][0], k3[0][2] );
           }
}
 
/*  Test 12  */
{
 float l1[10];
 float l2[3][3], sgl_pos, sgl_neg;
 float *l3[5], l4[5], l5[5];
 
        l1[9] = 1.0;
        l1[0] = 2.0;
        sgl_pos = 2.384185710015625e-07;
        sgl_neg = -2.9802322376953125e-08;
        l2[1][3] = sgl_pos;
        l2[2][2] = sgl_neg;
 
        l3[2] = l4;
        l3[3] = l5;
        l3[2][2] = 5.0;
        l3[3][3] = 6.0;
 
        if ( l1[9] != 1.0 || l1[0] != 2.0 || l2[1][3] != sgl_pos ||
             l2[2][2] != sgl_neg || l3[2][2] != 5.0 || l3[3][3] != 6.0 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-12 class 1 fail exit return code : %f %f %f %f %f %f\n",l1[9], l1[0], l2[1][3], l2[2][2], l3[2][2], l3[3][3] );
             printf("  ** declaration, array 2.6.1.4-12 class 1 fail exit return code : %f %f %f %f %f %f\n",l1[9], l1[0], l2[1][3], l2[2][2], l3[2][2], l3[3][3] );
           }
}
 
/*  Test 13  */
{
 long float m1[10];
 long float m2[3][3], dbl_pos;
 long float *m3[5], m4[5], m5[5];
 
        m1[0] = 1.0;
        m1[1] = 2.0;
        dbl_pos = 1.1102230246252e-16;
        m2[2][2] = dbl_pos;
        m2[1][1] = 4.0;
 
        m3[0] = m4;
        m3[4] = m5;
        m3[0][0] = 5.0;
        m3[4][0] = 6.0;
 
        if ( m1[0] != 1.0 || m1[1] != 2.0 || m2[2][2] != dbl_pos ||
             m2[1][1] != 4.0 || m3[0][0] != 5.0 || m3[4][0] != 6.0 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-13 class 1 fail exit return code : %e %e %e %e %e %e\n",m1[0], m1[1], m2[2][2], m2[1][1], m3[0][0], m3[4][0] );
             printf("  ** declaration, array 2.6.1.4-13 class 1 fail exit return code : %e %e %e %e %e %e\n",m1[0], m1[1], m2[2][2], m2[1][1], m3[0][0], m3[4][0] );
           }
}
 
/*  Test 14  */
{
 double n1[10];
 double n2[3][3], dbl_pos;
 double *n3[5], n4[5], n5[5];
 
        n1[2] = 1.0;
        n1[3] = 2.0;
        dbl_pos = 1.1102230246252e-16;
        n2[0][2] = dbl_pos;
        n2[1][0] = 4.0;
 
        n3[1] = n4;
        n3[2] = n5;
        n3[1][1] = 5.0;
        n3[2][4] = 6.0;
 
        if ( n1[2] != 1.0 || n1[3] != 2.0 || n2[0][2] != dbl_pos ||
             n2[1][0] != 4.0 || n3[1][1] != 5.0 || n3[2][4] != 6.0 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-14 class 1 fail exit return code : %e %e %e %e %e %e\n",n1[2], n1[3], n2[0][2], n2[1][0], n3[1][1], n3[2][4] );
             printf("  ** declaration, array 2.6.1.4-14 class 1 fail exit return code : %e %e %e %e %e %e\n",n1[2], n1[3], n2[0][2], n2[1][0], n3[1][1], n3[2][4] );
           }
}
 
/*  Test 15  */
{
 register p1[10];
 register p2[3][3];
 register *p3[5], p4[5], p5[5];
 
        p1[4] = 1;
        p1[5] = 2;
        p1[0] = p1[4] * p1[5];
 
        p2[0][0] = 3;
        p2[1][1] = 4;
        p2[2][2] = p2[0][0] * p2[1][1];
 
        p3[3] = p4;
        p3[4] = p5;
        p3[3][3] = 5;
        p3[4][4] = 6;
        p3[3][1] = p3[3][3] * p3[4][4];
 
        if ( p1[0] != 2 || p2[2][2] != 12 || p3[3][1] != 30 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-15 class 1 fail exit return code : %d %d %d\n",p1[0], p2[2][2], p3[3][1] );
             printf("  ** declaration, array 2.6.1.4-15 class 1 fail exit return code : %d %d %d\n",p1[0], p2[2][2], p3[3][1] );
           }
}
 
/*  Test 16  */
{
 register int q1[10];
 register int q2[3][3];
 register int *q3[5], q4[5], q5[5];
 
        q1[6] = 1;
        q1[7] = 2;
        q1[5] = q1[6] + q1[7];
 
        q2[2][2] = 3;
        q2[2][0] = 4;
        q2[2][1] = q2[2][2] + q2[2][0];
 
        q3[0] = q4;
        q3[1] = q5;
        q3[0][1] = 5;
        q3[1][1] = 6;
        q3[0][4] = q3[0][1] + q3[1][1];
 
        if ( q1[5] != 3 || q2[2][1] != 7 || q3[0][4] != 11 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-16 class 1 fail exit return code : %d %d %d\n",q1[5], q2[2][1], q3[0][4] );
             printf("  ** declaration, array 2.6.1.4-16 class 1 fail exit return code : %d %d %d\n",q1[5], q2[2][1], q3[0][4] );
           }
}
 
/*  Test 17  */
{
 register short int r1[10];
 register short int r2[3][3];
 register short int *r3[5], r4[5], r5[5];
 
        r1[8] = 1;
        r1[9] = 2;
        r1[7] = r1[8] + r1[9];
 
        r2[0][1] = 3;
        r2[1][1] = 4;
        r2[0][2] = r2[0][1] + r2[1][1];
 
        r3[2] = r4;
        r3[3] = r5;
        r3[2][4] = 5;
        r3[3][0] = 6;
        r3[3][1] = r3[2][4] + r3[3][0];
 
        if ( r1[7] != 3 || r2[0][2] != 7 || r3[3][1] != 11 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-17 class 1 fail exit return code : %d %d %d\n",r1[7], r2[0][2], r3[3][1] );
             printf("  ** declaration, array 2.6.1.4-17 class 1 fail exit return code : %d %d %d\n",r1[7], r2[0][2], r3[3][1] );
           }
}
 
/*  Test 18  */
{
 register long int s1[10];
 register long int s2[3][3];
 register long int *s3[5], s4[5], s5[5];
 
        s1[0] = 1;
        s1[1] = 2;
        s1[2] = s1[0] * s1[1];
 
        s2[2][0] = 3;
        s2[0][2] = 4;
        s2[2][1] = s2[2][0] * s2[0][2];
 
        s3[4] = s4;
        s3[0] = s5;
        s3[4][1] = 5;
        s3[0][3] = 6;
        s3[4][0] = s3[4][1] * s3[0][3];
 
        if ( s1[2] != 2 || s2[2][1] != 12 || s3[4][0] != 30 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-18 class 1 fail exit return code : %d %d %d\n",s1[2], s2[2][1], s3[4][0] );
             printf("  ** declaration, array 2.6.1.4-18 class 1 fail exit return code : %d %d %d\n",s1[2], s2[2][1], s3[4][0] );
           }
}
 
/*  Test 19  */
{
 register long t1[10];
 register long t2[3][3];
 register long *t3[5], t4[5], t5[5];
 
        t1[2] = 1;
        t1[3] = 2;
        t1[1] = t1[2] + t1[3];
 
        t2[2][1] = 3;
        t2[0][1] = 4;
        t2[0][0] = t2[2][1] + t2[0][1];
 
        t3[1] = t4;
        t3[2] = t5;
        t3[3][2] = 5;
        t3[1][4] = 6;
        t3[3][0] = t3[3][2] + t3[1][4];
 
        if ( t1[1] != 3 || t2[0][0] != 7 || t3[3][0] != 11 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-19 class 1 fail exit return code : %d %d %d\n",t1[1], t2[0][0], t3[3][0] );
             printf("  ** declaration, array 2.6.1.4-19 class 1 fail exit return code : %d %d %d\n",t1[1], t2[0][0], t3[3][0] );
           }
}
 
/*  Test 20  */
{
 register short u1[10];
 register short u2[3][3];
 register short *u3[5], u4[5], u5[5];
 
        u1[4] = 1;
        u1[5] = 2;
        u1[6] = u1[4] + u1[5];
 
        u2[1][1] = 3;
        u2[0][0] = 4;
        u2[0][2] = u2[1][1] + u2[0][0];
 
        u3[3] = u4;
        u3[4] = u5;
        u3[3][0] = 5;
        u3[4][3] = 6;
        u3[3][1] = u3[3][0] + u3[4][3];
 
        if ( u1[6] != 3 || u2[0][2] != 7 || u3[3][1] != 11 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-20 class 1 fail exit return code : %d %d %d\n",u1[6], u2[0][2], u3[3][1] );
             printf("  ** declaration, array 2.6.1.4-20 class 1 fail exit return code : %d %d %d\n",u1[6], u2[0][2], u3[3][1] );
           }
}
 
/*  Test 21  */
{
 register char f1[27];
 register char f2[2][27];
 register char *f3[5], f4[5], f5[5];
 
        f1[0] = 'a';
        f1[26] = 'z';
 
        f2[0][0] = 'b';
        f2[1][26] = 'c';
 
        f3[4] = f4;
        f3[3] = f5;
        f3[4][0] = 'd';
        f3[3][4] = 'y';
 
        if ( f1[0] != 'a' || f1[26] != 'z' || f2[0][0] != 'b' ||
             f2[1][26] != 'c' || f3[4][0] != 'd' || f3[3][4] != 'y' )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, array 2.6.1.4-21 class 1 fail exit return code : %c %c %c %c %c %c\n",f1[0], f1[26], f2[0][0], f2[1][26], f3[4][0], f3[3][4] );
             printf("  ** declaration, array 2.6.1.4-21 class 1 fail exit return code : %c %c %c %c %c %c\n",f1[0], f1[26], f2[0][0], f2[1][26], f3[4][0], f3[3][4] );
           }
}
        if ( !fail ) {
           fprintf(fp,"  .. declaration, arrays 2.6.1.4 class 1 pass\n");
           printf("  .. declaration, arrays 2.6.1.4 class 1 pass\n");
           }
           fclose(fp);
}
