/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      Declarations, Initializations and Variable       */
/*                          Reference  -  Compound Statements                */
/*                          Section  - 2.9                                   */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Tina Aleksa                                      */
/*  Source File :           source/decl.293.c                                */
/*  Revisions :             03/14/85    Sqa     Original UTX-32 1.2 Release  */
/*                                                                           */
/*  Date :                  3/18/85                                          */
/*  Descriptions :          For all basic types, arrays, structures, unions  */
/*                          and fields in block declarations :               */
/*                          Verify that extern declarations do not reserve   */
/*                          storage, so initialization of external variables */
/*                          is not permitted within a block.                 */
/*                          The compiler fails if this program compiles.     */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/decl.29.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
#include <stdio.h>
#define  TRUE  1;
 
int     fail=0;
int a, a1[5];
short b, b1[3];
short int c, c1[4];
long d, d1[7];
long int e, e1[100];
float f, f1[200];
long float g, g1[80];
double h, h1[50];
char i, i1[40];
unsigned j, j1[30];
unsigned int k, k1[20];
unsigned short l, l1[10];
unsigned short int m, m1[5];
unsigned long n, n1[8];
unsigned long int o, o1[2];
unsigned char p, p1[3];
 
main()
{
         FILE *fp;
         extern int a = 10;
         extern short b = 20;
         extern short int c = 30;
         extern long d = 40;
         extern long int e = 50;
         extern float f = 60.5;
         extern long float g = 120.7;
         extern double h = 80.85;
         extern char i = 'a';
         extern unsigned j = 5;
         extern unsigned int k = 6;
         extern unsigned short l = 7;
         extern unsigned short int m = 8;
         extern unsigned long n = 9;
         extern unsigned long int o = 10;
         extern unsigned char p = 'b';
         fp=fopen("decl_res bloc=y","a");
         fprintf(fp,"declaration,class 2.9.3. fail/should abort.\n");
         printf("declaration,class 2.9.3. fail/should abort.\n");
         fclose(fp);
}
