/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      External Definitions and Declarations            */
/*                          External Data - Section 3.1                      */
/*                          Local Basic Types - Section 3.1.1                */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Tina Aleksa                                      */
/*  Source File :           source/extn.3113.c                               */
/*  Revisions :             03/20/85    Sqa     Original UTX-32 1.2 Release  */
/*                                                                           */
/*  Date :                  3/21/85                                          */
/*  Descriptions :          For all basic types, defined and declared        */
/*                          (implicitly by context or explicitly using the   */
/*                          extern storage class specifier ) in the same     */
/*                          file:                                            */
/*                          Verify that locations that are not explicitly    */
/*                          initialized are initialized to zero.             */
/*                          The compiler fails if this program cannot be     */
/*                          compiled.                                        */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/extn.31.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
#include <stdio.h>
#define  TRUE  1;
int     fail;
 
int             in;
short           sh;
short int       si;
long            lg;
long int        li;
char            ch;
 
unsigned                un;
unsigned int            ui;
unsigned short          us;
unsigned short int      usi;
unsigned long           ul;
unsigned long int       uli;
unsigned char           uc;
 
float           fl;
long float      lf;
double          db;
 
main()
{
FILE *fp;
fp=fopen("extn_res bloc=y","a");
  if ( in != 0 || sh != 0 || si != 0 ||
       lg != 0 || li != 0 || ch != 0 )
     { fail = TRUE;
       fprintf(fp,"  ** external, local basic types 3.1.1.3-1 class 1 fail - exit return code : %d%d%d%d%d%d\n",  in, sh, si, lg, li, ch );
       printf("  ** external, local basic types 3.1.1.3-1 class 1 fail - exit return code : %d%d%d%d%d%d\n",  in, sh, si, lg, li, ch );
     }
 
  if ( un != 0  || ui != 0 || us != 0  ||
       usi != 0 || ul != 0 || uli != 0 ||
       uc != 0 )
     { fail = TRUE;
       fprintf(fp,"  ** external, local basic types 3.1.1.3-2 class 1 fail  exit return code : %d%d%d%d%d%d%d\n", un, ui, us, usi, ul,
             uli, uc );
        printf("  ** external, local basic types 3.1.1.3-2 class 1 fail  exit return code : %d%d%d%d%d%d%d\n", un, ui, us, usi, ul,
             uli, uc );
     }
 
  if ( fl != 0 || lf != 0 || db != 0 )
     { fail = TRUE;
       fprintf(fp,"  ** external, local basic types 3.1.1.3-3 class 1 fail -  exit return code : %f%f%f\n", fl, lf, db );
       printf("  ** external, local basic types 3.1.1.3-3 class 1 fail -  exit return code : %f%f%f\n", fl, lf, db );
     }
 
  if ( !fail )
    {fprintf(fp,"  .. external, local basic types 3.1.1.3 class 1 pass\n");
     printf("  .. external, local basic types 3.1.1.3 class 1 pass\n");}
  fclose(fp);
}
