/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      External Definitions and Declarations            */
/*                          - External Data                                  */
/*                          Section 3.1.2                                    */
/*  Product and Revision :  Unix 1.4                                         */
/*  Author :                Suifun Law                                       */
/*  Date :                  3/21/85                                          */
/*  Source File :           source/extn.3121.c                               */
/*  Revisions :             09/29/83    Sqa     Original UTX 2.0 Release     */
/*                          03/21/85    T. Aleksa   UTX-32(1.2)  Release     */
/*                          -- added conditional tests for union and field   */
/*                                                                           */
/*  Description :           Verify that external complex type in the same    */
/*                          file is allocated correctly and the storage space*/
/*                          persists to the end of the file.                 */
/*                          The compiler fails if this program cannot compile*/
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/extn.31.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
 
#include <stdio.h>
/* Extern declaration within the same file */
 
struct symbl {
                int  ident[9];
             } fsym = {0,1,2,3,4,5,6,7,8};
union  utab  {  char  id_name;
                int   id_number;
             } val;
 
struct field {  unsigned  bit1 : 1 ;
                unsigned  bit2 : 2 ;
                int       bit3 : 29;
             } bval = {0,1,50};
main()
{       extern struct symbl fsym;
        extern union  utab  val;
        extern struct field bval;
 
FILE *fp;
fp=fopen("extn_res bloc=y","a");
        val.id_number = 25;
 
        if ( fsym.ident[0] != 0 )
          {fprintf(fp,"  ** external, local complex types 3.1.2.1-1 class 1 fail exit return code : %d\n",fsym.ident[0]);
            printf("  ** external, local complex types 3.1.2.1-1 class 1 fail exit return code : %d\n",fsym.ident[0]);} 
        else
        if ( fsym.ident[1] != 1 )
         {fprintf(fp,"  ** external, local complex types 3.1.2.1-2 class 1 fail  exit return code : %d\n",fsym.ident[1]);
          printf("  ** external, local complex types 3.1.2.1-2 class 1 fail  exit return code : %d\n",fsym.ident[1]);}
        else
        if ( fsym.ident[2] != 2 )
           {fprintf(fp,"  ** external, local complex types 3.1.2.1-3 class 1 fail-  exit return code : %d\n",fsym.ident[2]);
            printf("  ** external, local complex types 3.1.2.1-3 class 1 fail-  exit return code : %d\n",fsym.ident[2]);} 
        else
        if ( fsym.ident[8] != 8 )
           {fprintf(fp,"  ** external, local complex types 3.1.2.1-4 class 1 fail-  exit return code : %d\n",fsym.ident[8]);
            printf("  ** external, local complex types 3.1.2.1-4 class 1 fail-  exit return code : %d\n",fsym.ident[8]);} 
        else
        if ( val.id_number != 25 )
           {fprintf(fp,"  ** external, local complex types 3.1.2.1-5 class 1 fail-  exit return code : %d\n",val.id_number);
            printf("  ** external, local complex types 3.1.2.1-5 class 1 fail-  exit return code : %d\n",val.id_number);} 
        else
        if ( bval.bit1 != 0 )
           {fprintf(fp,"  ** external, local complex types 3.1.2.1-6 class 1 fail-  exit return code : %d\n",bval.bit1);
            printf("  ** external, local complex types 3.1.2.1-6 class 1 fail-  exit return code : %d\n",bval.bit1);} 
        else
        if ( bval.bit3 != 50 )
          {fprintf(fp,"  ** external, local complex types 3.1.2.1-7 class 1 fail  exit return code : %d\n",bval.bit3);
            printf("  ** external, local complex types 3.1.2.1-7 class 1 fail  exit return code : %d\n",bval.bit3);} 
        else
          {fprintf(fp,"  .. external, local complex types 3.1.2.1 class 1 pass\n");
           printf("  .. external, local complex types 3.1.2.1 class 1 pass\n");} 
        fclose(fp);
}
 
