/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      External Definitions and Declarations            */
/*                          External Data - Section 3.1                      */
/*                          Local Complex Types - Section 3.1.2              */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Tina Aleksa                                      */
/*  Source File :           source/extn.3123.c                               */
/*  Revisions :             03/21/85    Sqa     Original UTX-32 1.2 Release  */
/*                                                                           */
/*  Date :                  3/27/85                                          */
/*  Descriptions :          For structures, arrays, fields, and unions       */
/*                          defined and declared ( implicitly by context     */
/*                          or explicitly using the external storage class   */
/*                          specifier) in the same file:                     */
/*                          Verify that locations that are not explicitly    */
/*                          initialized are initialized to zero.             */
/*                          The compiler fails if this program cannot be     */
/*                          compiled.                                        */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/extn.31.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
#include <stdio.h>
#define TRUE 1;
int fail;
 
char          ch[20];
unsigned char uc[40];
unsigned      un[60];
short         sh[80];
int           in[100];
float         fl[120];
short int     si[140];
long          lg[160];
long float    lf[180];
double        db[200];
unsigned short us[220];
unsigned long  ul[240];
 
struct emp_rec {
                 int   emp_no;
                 float salary;
               } emp_data;
 
union emp_code {
                int code_a;
                short code_b;
                char code_c;
               } code_emp;
 
struct field   {
                unsigned part1 :  4;
                unsigned part2 : 12;
                unsigned part3 : 16;
               } emp_fields;
main()
{
        /* declare external variables explicitly using the extern
           storage class specifier.  Array sizes are optional when used
           with the extern declaration.
        */
 
         char          name[];
         unsigned char addr[];
         unsigned      tel[];
         short         id_code[];
         int           hr_day[];
         float         hr_rate_wk[];
         short         hr_wkend[];
         long          sick_wk[];
         long float    hr_rate_wkend[];
         double        earn_wk[];
         unsigned short ins_wk[];
         unsigned long vac_hr[];
         
FILE *fp;
fp=fopen("extn_res bloc=y","a");
        /* verify that locations are initialized to zero    */
 
        if ( emp_data.emp_no != 0 || emp_data.salary != 0 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, local complex types 3.1.2.3-1 class 1 fail   -  exit return code : %d%f\n", emp_data.emp_no,
                      emp_data.salary );
              printf("  ** declaration, local complex types 3.1.2.3-1 class 1 fail   -  exit return code : %d%f\n", emp_data.emp_no,
                      emp_data.salary );
           }
 
        if ( code_emp.code_a != 0 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, local complex types 3.1.2.3-2 class 1 fail  -  exit return code : %d\n", code_emp.code_a );
             printf("  ** declaration, local complex types 3.1.2.3-2 class 1 fail  -  exit return code : %d\n", code_emp.code_a );
           }
 
        if ( emp_fields.part1 != 0 || emp_fields.part2 != 0 ||
             emp_fields.part3 != 0 )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, local complex types 3.1.2.3-3 class 1 fail  -  exit return code : %d%d%d\n", emp_fields.part1,
                   emp_fields.part2, emp_fields.part3 );
              printf("  ** declaration, local complex types 3.1.2.3-3 class 1 fail  -  exit return code : %d%d%d\n", emp_fields.part1,
                   emp_fields.part2, emp_fields.part3 );
           }
 
        if ( ch[0] !=  0 || ch[19] != 0  || uc[1] != 0  || uc[39] != 0  ||
             un[2] !=  0 || un[59] != 0  || sh[3] != 0  || sh[79] != 0  ||
             in[4] !=  0 || in[99] != 0  || fl[5] != 0  || fl[119] != 0 ||
             si[6] !=  0 || si[139] != 0 || lg[7] != 0  || lg[159] != 0 ||
             lf[8] !=  0 || lf[179] != 0 || db[9] != 0  || db[199] != 0 ||
             us[10] != 0 || us[119] != 0 || us[11] != 0 || ul[239] != 0  )
           { fail = TRUE;
             fprintf(fp,"  ** declaration, local complex types 3.1.2.3-4 class 1 fail - exit return code : %d%d%u%u%u%u%d%d%d%d%f%f%d%d%d%d%f%f%f%f%u%u%u%u\n",
             ch[0],ch[19],uc[1],uc[39],un[2],un[59],sh[3],sh[79],in[4],in[99],
             fl[5],fl[119],si[6],si[139],lg[7],lg[159],lf[8],lf[179],db[9],
             db[199],us[10],us[119],us[11],ul[239] );
              printf("  ** declaration, local complex types 3.1.2.3-4 class 1 fail - exit return code : %d%d%u%u%u%u%d%d%d%d%f%f%d%d%d%d%f%f%f%f%u%u%u%u\n",
             ch[0],ch[19],uc[1],uc[39],un[2],un[59],sh[3],sh[79],in[4],in[99],
             fl[5],fl[119],si[6],si[139],lg[7],lg[159],lf[8],lf[179],db[9],
             db[199],us[10],us[119],us[11],ul[239] );
           }
 
 
  if ( !fail )
    {fprintf(fp,"  .. external, local complex types 3.1.2.3 class 1 pass\n");
     printf("  .. external, local complex types 3.1.2.3 class 1 pass\n");}
  fclose(fp);
}
