/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      External Definitions and Declarations            */
/*                          External Data - Section 3.1                      */
/*                          Remote Basic Types  - Section 3.1.3              */
/*  Product and Revision :  Unix 1.2    			             */
/*  Author :                Tina Aleksa                                      */
/*  Source File :           source/extn.3132b.c                              */
/*  Revisions :		    04/16/85	Sqa	Original UTX-32 1.2 Release  */
/*                                                                           */
/*  Date :		    4/17/85  					     */
/*  Descriptions :          For basic types defined and declared in          */
/*                          different files:                                 */
/*                          Verify that a globally declared identifier can   */
/*                          be correctly referenced through the end of the   */
/*                          souce file.  The compiler fails if this program  */
/*                          cannot be compiled.                              */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/extn.31.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.  Associated files include                */
/*                          source/extn.3132a.c which is compiled with this  */
/*                          program.                                         */
/*                                                                           */
/*****************************************************************************/
 
 
/*  This function multiplies the global variables defined and declared  
    in file source/extn.3132a.c  and this file,  by 2.  Char and unsigned
    char variables are incremented by 2.  Global or external variables
    local to this source file are declared using the extern identifier
    in funtion dbl() because this function is located above the declaration
    and definition of those variables.
*/
 
dbl()
{
	extern int in;
	extern short int si;
	extern long int li;
	extern short sh;
	extern long lg;
	extern char ch;
	extern unsigned un;
	extern unsigned int ui;
	extern unsigned short us;
	extern unsigned short int usi;
	extern unsigned long ul;
	extern unsigned long int uli;
	extern unsigned char uc;
	extern float fl;
	extern long float lf;
	extern double db;
 
 	  in *= 2;
	  si *= 2;
	  li *= 2;
 	  sh *= 2;
	  lg *= 2;
	  un *= 2;
	  ui *= 2;
	  us *= 2;
	  usi *= 2;
	  ul *= 2;
	  uli *= 2;
	  fl *= 2;
	  lf *= 2;
	  db *= 2;
	  ch += 2;
	  uc += 2;
 
}
 
int in = 5;
short int si = (-10);
long int li = 15;
short sh = (-20);
long lg = 25;
unsigned un = 30;
unsigned int ui = 35;
unsigned short us = 40;
unsigned short int usi = 45;
unsigned long ul = 50;
unsigned long int uli = 55;
unsigned char uc = 'a';
char ch = 'b';
 
/*  This function decrements the external variables defined and declared
    in file source/extn.3132a.c and this file,  by 1.
*/
 
dec()
{
	extern float fl;
	extern long float lf;
	extern double db;
 
 	  --in;
	  --si;
	  --li;
 	  --sh;
	  --lg;
	  --ch;
	  --un;
	  --ui;
	  --us;
	  --usi;
	  --ul;
	  --uli;
	  --uc;
	  --fl;
	  --lf;
	  --db;
}
 
