/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      External Definitions And Declarations - function */
/*                          Section 3.3.5                                    */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Suifun Law                                       */
/*  Source File :           source/extn.335.c                                */
/*  Revisions :             09/30/83    Sqa     Original UTX 2.0 Release     */
/*  Date :                  10/25/83                                         */
/*  Description :           Function call by taking its address. The follow- */
/*                          program verify that if the name of a function    */
/*                          appears in an expression not in the function-name*/
/*                          position of a call, a pointer to the function is */
/*                          generated.                                       */
/*                          The compiler fails if this program cannot be     */
/*                          compiled.                                        */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/extn.33.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
 
/* Function  This program tests the ability of passing one
             function to another.
             The name of a function appears in an expression
             not in the function name position of a call, a
             pointer to the function is generated.
*/
#include <stdio.h>
 
FILE *fp;
main()
{
        int LABEL();
        int FUNC();
        fp=fopen("extn_res bloc=y","a");
 
 
        FUNC(LABEL);
        fclose(fp);
 
}
 
FUNC(LABEL)
int (*LABEL)();
{
    (*LABEL)();
}
 
LABEL()
{
    fprintf(fp,"  .. external, functions 3.3.5   class 1 pass\n");
    printf("  .. external, functions 3.3.5   class 1 pass\n");
 
}
 
