/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      Miscellaneous Concepts                           */
/*                          1.1.2.2 identifiers                              */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Suifun Law                                       */
/*  Date :                  10/25/83                                         */
/*  Source File :           source/misc_1122.c                               */
/*  Revisions :             09/30/83    Sqa     Original UTX 2.0 Release     */
/*                                                                           */
/*  Description :           upper/lower case differentiation                 */
/*                          The uper case identifiers should be distinguished*/
/*                          from keywords with the same spelling.            */
/*                          Any mixed case identifiers can be distinguished  */
/*                          from keywords with the same spelling.            */
/*                          This program verifies this conformance.          */
/*                          The compiler fails if this program cannot be     */
/*                          compiled.                                        */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/misc.11.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
/* Identifiers   Verify that identifiers that have same spelling
                 as keywords but  written in mixing upper case
                 and lower case are recognized correctly.
                 The compiler deviates if the program cannot be
                 compiled.
*/
 
#include <stdio.h>
main()
{
    int  Int,INT;
    int  ChAr, fLOAT, Double, Struct, UNION, LONG, SHORT,UNSIGNED;
    auto EXTERN, REGISTER, TYPEDEF, STATIC;
    char GoTo, ReTurn, SizeOf, BREAK, CONTINUE, ELSE, FOR, DO, WHILE,
         SWITCH, CASE, DEFAULT, ENTRY;
         FILE *fp;
         fp=fopen("misc_res bloc=y","a");
 
Int = 1;
INT = 0;
if ( Int == INT ) goto If;
    goto IF;
 
If: fprintf(fp,"  ** miscellaneous, identifiers 1.1.2.2 class 1 fail\n");
    printf("  ** miscellaneous, identifiers 1.1.2.2 class 1 fail\n");
    goto END;
IF: fprintf(fp,"  .. miscellaneous, identifiers 1.1.2.2 class 1 pass\n");
    printf("  .. miscellaneous, identifiers 1.1.2.2 class 1 pass\n");
 
END:
fclose(fp);
 
}
 
