/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      The C Preprocessor - File Inclusion              */
/*                          Section  6.2                                     */
/*  Author :                Tina Aleksa                                      */
/*  Product and Revision :  Unix 1.2                                         */
/*  Date :                  7/6/84                                           */
/*  Source File :           source/prep.6263.c                               */
/*  Revisions :             07/05/84    Sqa  Original UTX-32 (1.0) Release   */
/*                                                                           */
/*  Description :           Verify that bad #include syntax causes an        */
/*                          appropriate compiler error when the syntax has   */
/*                          a missing > delimiters.                          */
/*                          The compiler fails if the program compiles.      */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/prep.62.j                              */
/*                                                                           */
/*  Associated Files :      Data file prep.6263.d which is an include file.  */
/*                          Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
/*      This test is qar479 written against UTX-32 Release 1.0.
        Problem description:  The control line of the form #include < filename
                ( with missing delimiter > ) does not generate an error
                message.  The compiler should abort with bad include syntax.
*/
#include <prep.6263.d
main()
{  
  FILE *fp;
  fp = fopen("prep_res bloc=y","a");
  fprintf(fp," ** prep.6263 fails \n");
  printf(" ** prep.6263 fails \n");
  fclose (fp);
}
