/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      Statements - Conditional                         */
/*                          5.3.2.1 Switch                                   */
/*  Product and Revision :  Unix 1.3                                         */
/*  Author :                Suifun Law                                       */
/*  Date :                  4/25/84                                          */
/*  Source File :           source/stat.5321.c                               */
/*  Revisions :             09/30/83    Sqa     Original UTX 2.0 Release     */
/*  Description :           This program verify that the switch statements   */
/*                          causes control to be transferred to one of       */
/*                          several statements depending on the value of an  */
/*                          expression.                                      */
/*                          The compiler fails if this program does not      */
/*                          compile.                                         */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/stat.53.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
 
#include <stdio.h>
#define TRUE 1
int fail=0;
 
main()
{    int sum = 0,i;
FILE *fp;
fp=fopen("stat_res bloc=y","a");
        /* This test a populated case statement to check the limit
           on the size of code is not a serious one.
           The compiler has a small limit on the size of the case
           statement if the program does not compile.
        */
        for ( i = 0; i < 10 ; i++ )
        switch (i)                              /* switch 1 */
        {
                case 0 : sum = sum + i;
                         switch (sum)           /*    sub switch 1     */
                         {  case 0 : break;
                            default: goto ERROR;
                                                /*    end sub switch 1 */
                         }
                         /* control should fall through to here */
                         sum = sum + 1 ; break;
                case 1 :
                         switch ( sum )
                         {  case 1 : break;
                            default: goto ERROR;
                         }
                         break;
                                                /* nested switch */
                case 2 : switch ( sum )
                         { case 1:switch ( sum )
                                  {case 1:switch (sum)
                                          {case 1:switch(sum)
                                                  {case 1:switch(sum)
                                                          { case 1:break;
                                                            default:goto ERROR;
                                                          } break;
                                                   default:goto ERROR;
                                                  } break;
                                           default: goto ERROR;
                                          } break;
                                   default: goto ERROR;
                                  } break;
                           default: goto ERROR;
                        } sum = sum + i; break;
                case 3 : sum = sum + i; break;
                case 4 : sum = sum + i; break;
                case 5 : sum = sum + i; break;
                case 6 : sum = sum + i; break;
                case 7 : sum = sum + i; break;
                case 8 : sum = sum + i; break;
                case 9 : sum = sum + i; break;
        }
if ( sum != 45 )
      { ERROR: fprintf(fp,"  ** statement, switch 5.3.2.1 class 1 fail -  exit return code : %d\n",sum);
               printf("  ** statement, switch 5.3.2.1 class 1 fail -  exit return code : %d\n",sum);}
else
      { fprintf(fp, "  .. statement, switch 5.3.2.1 class 1 pass\n");
        printf( "  .. statement, switch 5.3.2.1 class 1 pass\n");}
fclose(fp);
}
