/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      Statements - Loops                               */
/*                          5.4.2 Do while                                   */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Suifun Law                                       */
/*  Date :                  10/25/83                                         */
/*  Source File :           source/stat.5422.c                               */
/*  Revisions :             09/30/83    Sqa     Original UTX 2.0 Release     */
/*  Description :           This program verify that the substatement is     */
/*                          executed before the expression is evaluated.     */
/*                          The compiler fails if this program does not      */
/*                          compile, or the message is printed repeatly,     */
/*                          or the message is not executed all.              */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/stat.54.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
/*   statement <-  do statement while (expression); */
#include <stdio.h>
#define TRUE 1
int fail;
 
main()
{  int i,j;
FILE *fp;
fp=fopen("stat_res bloc=y","a");
/* Test 1
   verify that the statement is executed, then the expression
   is evaluated.
*/
 
   i = 0; j = 0;
   do
        j++;
   while (i) ;
   if ( i != 0 || j != 1 )
   {    fail = TRUE;
        fprintf(fp,"  .. statement, do while 5.4.2.2-1 class 1 fail-  exit return code : %d\n",i);
        printf("  .. statement, do while 5.4.2.2-1 class 1 fail-  exit return code : %d\n",i);
   }
 
/* Test 2
   verify that statements are executed, before the expression is
   evaluated.
*/
   i = 1; j = 0;
   do
     {i = 0; j = 1;}
   while ( (i>j?1:0)) ;
   if ( i != 0 || j != 1 )
   { fail = TRUE;
     fprintf(fp,"  ** statement, do while 5.4.2.2-2 class 1 fail -  exit return code : %d\n",(i>j?1:0));
     printf("  ** statement, do while 5.4.2.2-2 class 1 fail -  exit return code : %d\n",(i>j?1:0));
   }
 
   if ( !fail )
       {fprintf(fp,"  .. statement, do while 5.4.2.2 class 1 pass\n");
        printf("  .. statement, do while 5.4.2.2 class 1 pass\n");}
   fclose(fp);
 
}
 
