/*****************************************************************************/
/*                                                                           */
/*  Test Function(s) :      Statements                                       */
/*                          5.5.4 Goto                                       */
/*  Product and Revision :  Unix 1.2                                         */
/*  Author :                Suifun Law                                       */
/*  Date :                  10/25/83                                         */
/*  Source File :           source/stat.5541.c                               */
/*  Revisions :             09/30/83    Sqa     Original UTX 2.0 Release     */
/*                                                                           */
/*  Description :           This program verify that control may be          */
/*                          transferred unconditionally by means of          */
/*                          the statement goto identifier.                   */
/*                          The compiler fails if this program does not      */
/*                          compile.                                         */
/*  Test Operation :        This 'c' source file is compiled and executed    */
/*                          under the control of the shell command file      */
/*                           ../shell/stat.55.j                              */
/*                                                                           */
/*  Associated Files :      Any results are reported to the default output   */
/*                          device.                                          */
/*                                                                           */
/*****************************************************************************/
/* IMPORTANT : stat.5541.c
               This program should not be run until UNIX development has
               solved the problem. The compiler generates incorrect codes
               when label name is as same as function name and the function
               name is defined before the label name.
               System V C compiler has no problem with this. However, released
               2.0 C compiler will compile this program and generate incorrect
               assembly codes which will go into an infinite loop when executed.
*/
#include <stdio.h>
FILE *fp;
main ()
{
    int LABEL();
    int i=1;
    fp=fopen("stat_res bloc=y","a");
    if (i) goto LABEL;
LABEL:
    fprintf(fp,"  .. statements, goto 5.5.4.1 class 1 pass\n");
    printf("  .. statements, goto 5.5.4.1 class 1 pass\n");
    fclose(fp);
}
 
LABEL()
{
    fprintf(fp,"  ** statements, goto 5.5.4.1 class 1 fail\n");
    printf("  ** statements, goto 5.5.4.1 class 1 fail\n");
    fprintf(fp,"     reason : goto statement references to a wrong location\n");
    printf("     reason : goto statement references to a wrong location\n");
}
 
