ident	"@(#)make:defs	1.3.1.2"
include <stdio.h>

define NEWLINE	'\n'
define CNULL	'\0'
define BLANK	' '
define TAB	'\t'
define DOT	'.'
define WIGGLE	'~'
define AT	'@'
define MINUS	'-'
define EQUALS	'='
define SLASH	'/'
define STAR	'*'
define LCURLY	'{'
define RCURLY	'}'
define LPAREN	'('
define RPAREN	')'
define LSQUAR	'['
define RSQUAR	']'
define QUESTN	'?'
define KOLON	':'
define SKOLON	';'
define DOLLAR	'$'
define GREATR	'>'
define POUND	'#'
define BACKSLASH	'\\'


*
*	Flags
*/

define ALLOC(x) (struct x *) intalloc(sizeof(struct x))


define TURNON(a)	(Mflags |= (a))
define TURNOFF(a)	(Mflags &= (~(a)))
define IS_ON(a)	(Mflags&(a))
define IS_OFF(a)	(!(IS_ON(a)))

*	make debugging info can be compiled in by	**
*		defining MKDEBUG when compiling make	**
*		make -f make.mk CFLAGS="-DMKDEBUG -O"	*/
ifdef MKDEBUG
define DBUG	0000001		/* debug flag */
endif
define ENVOVER	0000002		/* environ overides file defines */
define EXPORT	0000004		/* put current variable in environ */
define PRTR	0000010		/* set `-p' flag */
define SIL	0000020		/* set `-s' flag */
define NOEX	0000040		/* set `-n' flag */
define INTRULE	0000100		/* use internal rules */
define TOUCH	0000200		/* set `-t' flag */
define GET	0000400		/* do a $(GET) if file not found */
define QUEST	0001000		/* set `-q' flag */
define INARGS	0002000		/* currently reading cmd args */
define IGNERR	0004000		/* set `-i' flag */
define KEEPGO	0010000		/* set `-k' flag */
define GF_KEEP	0020000		/* keep auto get files */
define MH_DEP	0040000		/* use old question about whether cmd exists */
define MEMMAP	0100000		/* print memory map */

ypedef char *CHARSTAR;
ypedef int  *INTSTAR;
ypedef long int TIMETYPE;
ypedef struct gothead *GOTHEAD;
ypedef struct gotf *GOTF;
ypedef struct chain *CHAIN;
ypedef struct opendir *OPENDIR;
ypedef struct pattern *PATTERN;
ypedef struct varblock *VARBLOCK;
ypedef struct shblock *SHBLOCK;
ypedef struct depblock *DEPBLOCK;
ypedef struct lineblock *LINEBLOCK;
ypedef struct nameblock *NAMEBLOCK;

xtern CHARSTAR *environ;
xtern int Mflags;
xtern FILE *fin;
xtern CHARSTAR *linesptr;
*
*	flags for get()
*/
define CD	0
define NOCD	1


define max(a,b)	((a)>(b)?(a):(b))
define SHELLCOM "/bin/sh"

ifdef unix
*  to install metering, add a statement like */
*******
define METERFILE "/usr/sif/make/Meter"
*****/
* to turn metering on, set external variable meteron to 1 */
endif

* define FSTATIC to be static on systems with C compilers
  supporting file-static; otherwise define it to be null
/
define FSTATIC static

define NO 0
define YES 1

define equal(a,b)	(a[0] == b[0] ? !strcmp((a),(b)) : NO )
define any(a,b)	strchr( (a), (b) )
define HASHSIZE 809
define NLEFTS 200
define NCHARS 500
define NINTS  250
define INMAX 5000
define OUTMAX 2500
define MAXODIR	10

define ALLDEPS  1
define SOMEDEPS 2

define META 01
define TERMINAL 02



xtern int sigivalue;
xtern int sigqvalue;
xtern int waitpid;
xtern int ndocoms;
xtern int okdel;
xtern CHARSTAR prompt;
xtern char junkname[ ];
xtern char RELEASE[];



truct nameblock

NAMEBLOCK nextname;		/* pointer to next nameblock */
NAMEBLOCK backname;		/* pointer to predecessor */
CHARSTAR namep;		/* ASCII name string */
CHARSTAR alias;		/* ASCII alias (when namep translates to another
			 * pathstring.
			 */
LINEBLOCK linep; /* pointer to dependents */
int done:3;		/* flag used to tell when finished */
int septype:3;		/* distinguishes between single and double : */
int rundep:1;		/* flag indicating runtime translation done */
TIMETYPE modtime;	/* set by exists() */
;


xtern NAMEBLOCK mainname ;
xtern NAMEBLOCK firstname;

truct lineblock

LINEBLOCK nextline;
DEPBLOCK depp;
SHBLOCK shp;
;

xtern LINEBLOCK sufflist;

truct depblock

DEPBLOCK nextdep;
NAMEBLOCK depname;
;

truct shblock

SHBLOCK nextsh;
CHARSTAR shbp;
;

truct varblock

VARBLOCK nextvar;
CHARSTAR varname;
CHARSTAR varval;
int noreset:1;
int used:1;
int envflg:1;
int v_aflg:1;
;

xtern VARBLOCK firstvar;

truct pattern

PATTERN nextpattern;
CHARSTAR patval;
;

xtern PATTERN firstpat;

truct	opendir

OPENDIR nextopendir;
FILE * dirfc;
CHARSTAR dirn;
;
xtern OPENDIR firstod;


truct chain

CHAIN nextchain;
CHARSTAR datap;
;

*
*	The following two structures are used to cleanup after
*	`make' does an automatic get of a file. See get() and
*	cleanup().
*/
truct gotf			/* list of files */

GOTF gnextp;
CHARSTAR gnamep;
;

truct gothead			/* first member of list of files */

GOTF gnextp;
CHARSTAR gnamep;
GOTF endp;
;

xtern char Nullstr[];
xtern CHARSTAR badptr;
HARSTAR copys();
HARSTAR copstr();
HARSTAR concat();
HARSTAR colontrans();
HARSTAR dftrans();
HARSTAR straightrans();
HARSTAR mkqlist();
HARSTAR findfl();
HARSTAR addstars();
HARSTAR strshift();
NTSTAR  intalloc();
ARBLOCK varptr();
ARBLOCK srchvar();
IMETYPE prestime(), exists();
EPBLOCK srchdir();
AMEBLOCK srchname(), makename();
INEBLOCK runtime();
HARSTAR strrchr();
HARSTAR strchr();
HARSTAR sdot();
HARSTAR trysccs();
HARSTAR calloc();
