/*~!HAS.H*/
/* Name:  HAS.H Part No.: _______-____r
 *			
 *		     		SOFTWARE ENGINEERING
 *
 * The recipient of this product specifically agrees not to distribute,
 * disclose, or disseminate in any way, to any one, nor use for its own
 * benefit, or the benefit of others, any information contained  herein
 * without the expressed written consent of Software Engineering.
 *
 *                     RESTRICTED RIGHTS LEGEND
 *
 * Use, duplication, or disclosure by the Government is  subject  to
 * restriction  as  set forth in paragraph (b) (3) (B) of the Rights
 * in Technical Data and Computer Software  Clause  in  DAR  7-104.9
 * (a).
 */
/*
 *			 I S C   A s s e m b l e r
 *
 *				 H A S . H
 *
 *			     Revision History
 *			     ----------------
 */

typedef long int32;
typedef int32 WORD;

#include	<stdio.h>
#include	"has_out.h"

#ifdef NULL
#undef NULL
#define NULL 0
#endif

#undef BUFSIZ
#define	NFIELDS		30	/* Maximum fields per line */
#define	MAXSYMS		2400	/* Maximum number of symbol */
#define BUFSIZ		512	/* buffer size on sel */
#define	LINESIZE	254	/* Maximum line length */	

#define	SPREGISTER	3	/* Which register is the Stack Pointer */
#define RETREGISTER	0	/* return register for subroutine calls */
#define LOCNAME		"%"	/* Location counter name */

#define	SAME		0	/* result of strcmp() and prefix() */

/* instruction switchout */
struct sdata {
	char	*token;
	int	(*function)();
};

/* pseudo opcode switchout */
struct pscdata {
	char	*token;
	int	(*pass1)();
	int	(*pass2)();
};

/* contains all data needed to output into a given space */
struct output {
	WORD	o_word;
	FILE	*o_file;
	char	*o_ptr;
	short	o_nleft;
};

extern	short	debug;

#ifndef WE_ARE_DEBUGGING
#define BUG
#endif

#ifdef BUG
#define YESDEBUG
#endif

#ifdef YESDEBUG
/* #define	DEBUG(l,f,a)	if (debug >= l) {fprintf(stderr, f, a);} */
#define	DEBUG(l,f,a)	if (debug >= l) {fprintf(stdout, f, a);}
#else
#define DEBUG(l,f,a)	/* no debugging now */
#endif

struct memref {
	unsigned	int	op:6;
	unsigned	int	reg:3;
	unsigned	int	x:2;
	unsigned	int	ind:1;
	unsigned	int	f:1;
	unsigned	int	wa:17;
	unsigned	int	c:2;
};

struct immed {
	unsigned	int	op:6;
	unsigned	int	reg:3;
	unsigned	int	nu:4;
	unsigned	int	aug:3;
	unsigned	int	val;
};

struct regreg {
	unsigned	int	op:6;
	unsigned	int	rd:3;
	unsigned	int	rs:3;
	unsigned	int	aug:4;
};

struct shift {
	unsigned	int	op:6;
	unsigned	int	reg:3;
	unsigned	int	dir:1;
	unsigned	int	nu:1;
	unsigned	int	cnt:5;
};

