# 1 "log.c"





























# 1 "/u/cinclude/math.h"
























extern int errno, signgam;

extern double atof(), frexp(), ldexp(), modf();
extern double j0(), j1(), jn(), y0(), y1(), yn();
extern double erf(), erfc();
extern double exp(), log(), log10(), pow(), sqrt();
extern double floor(), ceil(), fmod(), fabs();
extern double gamma();
extern double hypot();
extern int matherr();
extern double sinh(), cosh(), tanh();
extern double sin(), cos(), tan(), asin(), acos(), atan(), atan2();
















# 55 "/u/cinclude/math.h"


# 59 "/u/cinclude/math.h"


# 63 "/u/cinclude/math.h"
























struct exception {
	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};










# 30 "log.c"

# 1 "/u/cinclude/values.h"































































# 91 "/u/cinclude/values.h"











































# 31 "log.c"

# 1 "/u/cinclude/errno.h"























# 28 "/u/cinclude/errno.h"

extern int errno;
extern int mpxerr;


























































extern char * sys_errlist[];
void perror ();































































































# 32 "log.c"



extern double log_error();

double
log(x)
register double x;
{
	static double p[] = {
		-0.78956112887491257267e0,
		 0.16383943563021534222e2,
		-0.64124943423745581147e2,
	}, q[] = {
		 1.0,
		-0.35667977739034646171e2,
		 0.31203222091924532844e3,
		-0.76949932108494879777e3,
	};
	register double y;
	int n; 

	if (x <= 0)
		return (log_error(x, "log", 3));
	y = 1.0;
	x = frexp(x, &n);
	if (x < 0.70710678118654752440) {
		n--;
		y = 0.5;
	}
	x = (x - y)/(x + y);
	x += x;
	y = x * x;
	x += x * y * ((( ( p))[0] * ((y)) + ( ( p))[1]) * (y) + ( p)[2])/(((( ( ( q)))[0] * (((y))) + ( ( ( q)))[1]) * ((y)) + ( ( q))[2]) * (y) + ( q)[3]);
	y = (double)n;
	x += y * -2.121944400546905827679e-4;
	return (x + y * 0.693359375);
}

double
log10(x)
register double x;
{
	return (x > 0 ? log(x) * 0.43429448190325182765 : log_error(x, "log10", 5));
}

static double
log_error(x, f_name, name_len)
double x;
char *f_name;
unsigned int name_len;
{
	register char *err_type;
	unsigned int mess_len;
	struct exception exc;

	exc.name = f_name;
	exc.retval = -((float)0.7237005145e76);
	exc.arg1 = x;
	if (x) {
		exc.type = 1;
		err_type = ": DOMAIN error\n";
		mess_len = 15;
	} else {
		exc.type = 2;
		err_type = ": SING error\n";
		mess_len = 13;
	}
	if (!matherr(&exc)) {
		(void) write(2, f_name, name_len);
		(void) write(2, err_type, mess_len);
		errno = 33;
	}
	return (exc.retval);
}
