         LIST      ON,NOMAC,NOREP
         PROGRAM   BRKRTNS
************************************************************************
* BRKRTNS ALLOCATES OR FREES MEMORY FROM THE SYSTEM HEAP
************************************************************************
         SPACE     1
         DEF       __mge
         DEF       __mfe
         SPACE     2
************************************************************************
*   REGISTER EQUATES
************************************************************************
         SPACE     1
AP       EQU       1              ARGUMENT POINTER
X1       EQU       2              GENERAL INDEX NUMBER 1
SP       EQU       3              STACK POINTER
X2       EQU       3
         SPACE     1
R0       EQU       0              GENERAL REGISTER EQUATES
R1       EQU       1
R2       EQU       2
R3       EQU       3
R4       EQU       4
R5       EQU       5
R6       EQU       6
R7       EQU       7
         SPACE     2
************************************************************************
*   LOCAL MACROS
************************************************************************
         SPACE     1
ENTER    DEFM
         TRR       SP,R1           STACK PTR FOR CALLING FUNCTION
         SUI       SP,8W           DECREMENT SP FOR CALLED ROUTINE
         STD       R0,2W,SP        STORE RETURN ADDR IN STACK
         STF       R4,4W,SP        STORE REGS 4 THROUGH 7 IN STACK
         LA        AP,8W,R1        PUT ARG AREA ADDR IN AP
         STW       SP,SPSAVE      SAVE STACK POINTER
         ENDM
         SPACE     1
RETURN   DEFM
         LW        SP,SPSAVE      RESTORE THE STACK POINTER
         LF        R2,2W,SP        RESTORE REGISTERS FROM STACK
         TRSW      R2              RETURN TO CALLING ROUTINE
         ENDM
         SPACE     2
************************************************************************
* ALLOCATE MEMORY SPACE
************************************************************************
         SPACE     1
         CSECT
__mge    EQU       $
         ENTER
         SVC       1,X'67'         GET 2KW MORE SPACE
         TRR       R3,R3           SEE IF GOOD RETURN
         BNZ       $+2W            SKIP IF O.K.
         LI        R4,-1           ERROR RETURN
         TRR       R4,R0           FOR RETURN
         RETURN
         PAGE
************************************************************************
* FREE MEMORY SPACE
************************************************************************
         SPACE     1
__mfe    EQU       $
         ENTER
         SVC       1,X'68'         FREE 2KW SPACE
         TRR       R3,R0           RETURN NEW END ADDRESS
         RETURN
         REL
         BOUND     1W
SPSAVE   RES       1W
         END
