/* *********************************************************************
 *
 * $Header:  005  02-JUL-91 19:01  GANN      GANN                      $
 * $Log:   @ISCSRC^(DV.EDT.INC)TOKENS.H                                $
 * 
 *      Rev  005  02-JUL-91 19:01  GANN      GANN                       
 * Added new flag for mode where the output file has a version          
 * number.                                                              
 *
 *      Rev  004  09-APR-91 13:58  GANN      GANN
 * Added SET [NO]QMC.
 *
 *      Rev  003  09-FEB-89 17:24  GANN      GANN
 * Added qualifier /MULTI_NATIONAL.
 *
 *      Rev  002  20-JAN-89 09:34  GANN      GANN
 * Added support for qualifier /NOOUTPUT.
 * Fix for SPR's 10*337 and 10*430.
 *
 *      Rev  001  11-OCT-88 13:20  GANN      GANN
 *  Version control header added
 */
/*
 */

/* Nokeypad command tokens */

#define C_ADV          0
#define C_APPEND       1
#define C_ASC          2
#define C_BACK         3
#define C_BELL         4
#define C_CHGC         5
#define C_CHGL         6
#define C_CHGU         7
#define C_UPARR        8
#define C_CLSS         9
#define C_CUT          10
#define C_DATE         11
#define C_DEFK         12
#define C_DESEL        13
#define C_D            14
#define C_EXT          15
#define C_EX           16
#define C_FILL         17
#define C_HELP         18
#define C_I            19
#define C_KS           20
#define C_LEARN        21
#define C_OV           22
#define C_PASTE        23
#define C_QUIT         24
#define C_REF          25
#define C_R            26
#define C_SEL          27
#define C_SHL          28
#define C_SHR          29
#define C_SN           30
#define C_SSEL         31
#define C_S            32
#define C_TAB          33
#define C_TADJ         34
#define C_TC           35
#define C_TD           36
#define C_TGSEL        37
#define C_TGTAB        38
#define C_TI           39
#define C_TOP          40
#define C_UND          41
#define C_ISELF        42

/* And then, you have the entities, character, word, sentence, etc. */

#define E_BEG (C_ISELF+1)

#define E_C            43
#define E_W            44
#define E_BW           45
#define E_EW           46
#define E_L            47
#define E_BL           48
#define E_EL           49
#define E_NL           50
#define E_SEN          51
#define E_BSEN         52
#define E_ESEN         53
#define E_PAR          54
#define E_BPAR         55
#define E_EPAR         56
#define E_PAGE         57
#define E_BPAGE        58
#define E_EPAGE        59
#define E_SR           60
#define E_BR           61
#define E_ER           62
#define E_V            63
#define E_SEA          64
/* Line-mode token definitions */

#define S_ADJUST       0
#define S_BEGIN        1
#define S_BOUNDE       2
#define S_BUFFER       3
#define S_CASE         4
#define S_CHANGE       5
#define S_CLEAR        6
#define S_COMMAN       7
#define S_CONTROL      8
#define S_COPY         9
#define S_CURSOR       10
#define S_DEFINE       11
#define S_DELETE       12
#define S_DELIMI       13
#define S_DIACRI       14
#define S_END          15
#define S_ENTITY       16
#define S_EXACT        17
#define S_EXECUT       18
#define S_EXIT         19
#define S_FILES        20
#define S_FILL         21
#define S_FNF          22
#define S_FIND         23
#define S_HELP         24
#define S_GENERA       25
#define S_GOLD         26
#define S_INCLUD       27
#define S_INSENS       28
#define S_INSERT       29
#define S_KEYPAD       30
#define S_KEY          31
#define S_LINES        32
#define S_MACRO        33
#define S_MODE         34
#define S_MOVE         35
#define S_NEXT         36
#define S_NONE         37
#define S_NUMBER       38
#define S_NUMLOCK      39
#define S_OVERWRITE    40
#define S_PARAGR       41
#define S_PAGE         42
#define S_PROMPT       43
#define S_PRINT        44
#define S_QUERY        45
#define S_QUIET        46
#define S_QUIT         47
#define S_REPLAC       48
#define S_SCREEN       49
#define S_TEXT         50
#define S_SEARCH       51
#define S_SENTEN       52
#define S_SET          53
#define S_SHOW         54
#define S_SUMMAR       55
#define S_SUBSTI       56
#define S_TAB          57
#define S_TRUNCA       58
#define S_TYPE         59
#define S_UNBOUN       60
#define S_UPPER        61
#define S_VERSIO       62
#define S_VERIFY       63
#define S_WORD         64
#define S_WORKING      65
#define S_WPS          66
#define S_WRAP         67
#define S_WRITE        68
#define S__BRIEF       69
#define S__DUPLI       70
#define S__NOTYP       71
#define S__SAVE        72
#define S__SEQUE       73
#define S__STAY        74
#define S__QUERY       75
#define S_ALPHA        76
#define S_JOURNA       77
#define S_NOJOUR       78
#define S_FUNCTION     79
#define S_DOS          80
#define S_BEFORE       81
#define S_REST         82
#define S_WHOLE        83
#define S_LAST         84
#define S_SELECT       85
#define S_ALL          86
#define S_FLASHI       87
#define S_BANNER       88
#define S_COLOR        89
#define S_ERROR        90
#define S_BLACK        91
#define S_BLUE         92
#define S_GREEN        93
#define S_CYAN         94
#define S_RED          95
#define S_MAGENT       96
#define S_BROWN        97
#define S_LGREY        98
#define S_DGRAY        99
#define S_LBLUE        100
#define S_LGREEN       101
#define S_LCYAN        102
#define S_LRED         103
#define S_LMAGEN       104
#define S_YELLOW       105
#define S_WHITE        106
#define S_OUTPUT       107
#define S_NOCOMM       108
#define S_READO        109
#define S_RECOVE       110
#define S_VT100        111
#define S_TV921        112
#define S_MAXCOL       113
#define S_ASCII        114
#define S_NOVERS       115
#define S_NOEDTOLD     116
#define S_EDTOLD       117
#define S_OVERSTRIKE   118
#define S_TABC         119
#define S_ESC		   120
#define S_SCS          121
#define S_VT220        122
#define S_TV950        123
#define S_NOOUTPUT     124                                       /*002*/
#define S_MULTINAT     125                                       /*003*/
#define S_QMC          126                                       /*004*/
#define S_VNUMBR       127                                       /*005*/
#define S_NOVNUM       128                                       /*005*/
/* to add more items, add here and renumber S_NULL to be last */
#define S_NULL         129                                       /*005*/
