*ARITHMETIC EXCEPTION TRAP PROC.   MPX-32 RELEASE 3.6.0 HEADER  H.IP0F  0001.000
************************************************************************0002.000
*                                                                      *0003.000
*                    PROPRIETARY INFORMATION                           *0004.000
*                    -----------------------                           *0005.000
*   THE INFORMATION CONTAINED HEREIN IS PROPRIETARY TO ENCORE          *0006.000
*   COMPUTER CORPORATION AND/OR ITS VENDORS, AND ITS USE, DISCLOSURE,  *0007.000
*   OR DUPLICATION IS SUBJECT TO THE RESTRICTIONS STATED IN THE        *0008.000
*   STANDARD ENCORE COMPUTER CORPORATION LICENSE TERMS AND CONDITIONS  *0009.000
*   OR THE APPROPRIATE THIRD-PARTY SUBLICENSE AGREEMENT.               *0010.000
*                                                                      *0011.000
*                       RESTRICTED RIGHTS                              *0012.000
*                       -----------------                              *0013.000
*   USE, DUPLICATION, OR DISCLOSURE BY THE GOVERNMENT IS SUBJECT       *0014.000
*   TO RESTRICTIONS AS SET FOURTH IN SUBDIVISION (c) (1) (ii) OF       *0015.000
*   THE RIGHTS IN TECHNICAL DATA AND COMPUTER SOFTWARE CLAUSE AT       *0016.000
*   252.227.7013                                                       *0017.000
************************************************************************0018.000
* (C) COPYRIGHT 1989 ENCORE COMPUTER CORPORATION                       *0019.000
*     ALL RIGHTS RESERVED                                              *0020.000
************************************************************************0021.000
         M.PGM     H.IP0F,MPX-32,3.6.0,00,Y                             0022.000
         M.VRSION                                                       0023.000
         TITLE H.IP0F REVISION HISTORY                                  0024.000
************************************************************************0025.000
*                                                                      *0026.000
*        MPX-32 REVISION 3 RELEASE 3.5U02A CHANGE HISTORY              *0027.000
*                                                                      *0028.000
************************************************************************0029.000
*                                                                       0030.000
*   VERSION  3.5U02A.02 BL7.1                                   E3IEE35A0031.000
*                                                               E3IEE35A0032.000
*        E3IEE35A  09/08/92 11460  THE LAST MODIFICATION CAUSED E3IEE35A0033.000
*                  A PROBLEM FOR BASE TASKS WITH AN ARITHMETIC  E3IEE35A0034.000
*                  EXCEPTION HANDLER.  IF AN INTEGER ARITHMETIC E3IEE35A0035.000
*                  EXCEPTION OCCURRED, THE ADDRESS OF THE       E3IEE35A0036.000
*                  INSTRUCTION CAUSING THE EXCEPTION WAS NOT    E3IEE35A0037.000
*                  LOADED PROPERLY.  THE CORRECTION IS TO MOVE  E3IEE35A0038.000
*                  THE CHECK FOR EXCESS 64 FORMAT TO FIXUP.     E3IEE35A0039.000
*                                                                       0040.000
*   VERSION  3.5U02A.01 BL7                                     E3IEE35 0041.000
*                                                               E3IEE35 0042.000
*        E3IEE35   08/12/92 11460  ADDED SUPPORT FOR IEEE 754   E3IEE35 0043.000
*                  FORMAT.  IF IEEE, H.IP0F DOES NO FIXUP.      E3IEE35 0044.000
*                                                                       0045.000
************************************************************************0046.000
*                                                                      *0047.000
*        MPX-32 REVISION 3 RELEASE 3.5U02 CHANGE HISTORY               *0048.000
*                                                                      *0049.000
************************************************************************0050.000
*                                                                       0051.000
*   VERSION  3.5U02.03  BL13                                    S910723 0052.000
*                                                               S910723 0053.000
*        S910723   12/13/91 11460  THE REGISTERS AT THE TIME OF S910723 0054.000
*                  THE EXCEPTION ARE SAVED ONTO THE TSA STACK   S910723 0055.000
*                  FOR ALL TASKS. THIS IS A REWORK OF CPR11787. S910723 0056.000
*                  REPLACED C.REGS IN CPU ONLY CODE WITH M.TSAD S910723 0057.000
*                  MACRO AND REMOVED C.REGS REFERENCES FROM     S910723 0058.000
*                  POSSIBLE IPU EXECUTABLE CODE.                S910723 0059.000
*                                                                       0060.000
************************************************************************0061.000
* AT BASELINE 4.1 OF MPX3.5U02 THIS MODULE WAS INCLUDED INTO THE       *0062.000
* MPX3.5U01A RELEASE.                                                  *0063.000
************************************************************************0064.000
*                                                                       0065.000
*   VERSION  3.5U02.02  BL4.1                                   E2RIS35C0066.000
*                                                               E2RIS35C0067.000
*        E2RIS35C  04/17/91 11460  ADDED RISC INSTRUCTIONS THAT E2RIS35C0068.000
*                  CAN CAUSE ARITHMETIC EXCEPTIONS TO OCCUR.    E2RIS35C0069.000
*                                                                       0070.000
*   VERSION  3.5U02.01  BL2                                     E2RIS35B0071.000
*                                                               E2RIS35B0072.000
*        E2RIS35B  03/12/91 11460  ADDED SUPPORT FOR 32W BASE   E2RIS35B0073.000
*                  REGISTER STACK FRAME SIZE. ALSO CHANGED ANY  E2RIS35B0074.000
*                  LITERAL REFERENCES OF THE STACK FRAME SIZE   E2RIS35B0075.000
*                  TO USE THE VALUE IN C.FRAME AND ANY LOAD OF  E2RIS35B0076.000
*                  T.MPXBR+3W TO USE T.REGP PLUS T.BROFF.       E2RIS35B0077.000
*                                                               E2RIS35B0078.000
*                  DEPENDENCIES:  SH.EXEC3 VERSION 3.5U02.02    E2RIS35B0079.000
*                                 SH.EXSUB VERSION 3.5U02.02    E2RIS35B0080.000
*                                 SH.ICP   VERSION 3.5U02.01    E2RIS35B0081.000
*                                 SH.IP06  VERSION 3.5U02.02    E2RIS35B0082.000
*                                 SH.IP0F  VERSION 3.5U02.01    E2RIS35B0083.000
*                                 SH.IPPF  VERSION 3.5U02.02    E2RIS35B0084.000
*                                 SH.PTRAC VERSION 3.5U02.01    E2RIS35B0085.000
*                                 SH.REXS  VERSION 3.5U02.03    E2RIS35B0086.000
*                                 SH.SINIT VERSION 3.5U02.01    E2RIS35B0087.000
*                                 SH.SURE  VERSION 3.5U02.01    E2RIS35B0088.000
*                                 SH.TAMM  VERSION 3.5U02.02    E2RIS35B0089.000
*                                 SH.TSM   VERSION 3.5U02.02    E2RIS35B0090.000
*********************************************************************** 0091.000
*                                                                     * 0092.000
*        MPX-32 REVISION 3 RELEASE 3.5U01 CHANGE HISTORY              * 0093.000
*                                                                     * 0094.000
*********************************************************************** 0095.000
*                                                                      *0096.000
*   VERSION 3.5U01.03                                          E1BLK35 *0097.000
*                                                              E1BLK35 *0098.000
*        E1BLK35  01/01/91  5199  CHANGED ALL OCCURENCES:      E1BLK35 *0099.000
*                                 BEI/UEI TO M.IOFF/IONN       E1BLK35 *0100.000
*                                 LPSD/CM TO M.LPSD            E1BLK35 *0101.000
*                                                              E1BLK35 *0102.000
*                                                                      *0103.000
*                                                               CP11787A0104.000
*     VERSION 3.5U01.02  BL6                                    CP11787A0105.000
*                                                               CP11787A0106.000
*        CP11787A 09/06/90  11460  PROBLEM:  REGSAV CONTAINS    CP11787A0107.000
*                                  AN ADDRESS ON THE TSA STACK  CP11787A0108.000
*                                  (LOGICAL) IF A BASE/ADA TASK CP11787A0109.000
*                                  AND CONTAINS A LOCAL ADDRESS CP11787A0110.000
*                                  (PHYSICAL) IF A NONBASE TASK.CP11787A0111.000
*                                  SOLUTION:  WHEN THIS ADDRESS CP11787A0112.000
*                                  IS LOADED AND USED AS AN INX CP11787A0113.000
*                                  A CHECK IS DONE TO DETERMINE CP11787A0114.000
*                                  WHETHER THE INSTR SHOULD BE  CP11787A0115.000
*                                  INDEXED THRU CONTEXT OR NOT. CP11787A0116.000
*                                                                       0117.000
*     VERSION 3.5U01.01  BL5                                    CP11787 0118.000
*                                                               CP11787 0119.000
*        CP11787  09/06/90  11460  ADDED CODE SO THAT IF THE    CP11787 0120.000
*                                  TASK WAS A BASE REGISTER OR  CP11787 0121.000
*                                  AN ADA TASK, THEN THE USER   CP11787 0122.000
*                                  REGISTERS WOULD BE RESTORED  CP11787 0123.000
*                                  THROUGH CONTEXT.  THIS IS    CP11787 0124.000
*                                  DONE BECAUSE IN THESE CASES, CP11787 0125.000
*                                  THE REGISTERS ARE STORED ON  CP11787 0126.000
*                                  TSA'S STACK.                 CP11787 0127.000
*                                                                       0128.000
*********************************************************************** 0129.000
*        MPX-32 REVISION 3 RELEASE 3.5 CHANGE HISTORY                 * 0130.000
*********************************************************************** 0131.000
*                                                               CPR111120132.000
*     VERSION 3.5.05  BL10                                      CPR111120133.000
*                                                               CPR111120134.000
*        CPR11112  04/06/90 10885  CORRECTED MAPPED OUT CODE.   CPR111120135.000
*                                                               EMCH-35 0136.000
*     VERSION 3.5.04  BL3                                       EMCH-35 0137.000
*                                                               EMCH-35 0138.000
*        EMCH-35      06/05/89 10827 ALLOW 32/2000 TYPE CPU(0). EMCH-35 0139.000
*                                                               ETSA-35 0140.000
*     VERSION 3.5.03  BL3                                       ETSA-35 0141.000
*                                                               ETSA-35 0142.000
*        ETSA-35   06/01/89 10885  MODIFICATIONS TO MOVE THE    ETSA-35 0143.000
*                                  TSA TO EXTENDED MEMORY.      ETSA-35 0144.000
*                                                               ETSA-35 0145.000
*                                                               ETSA-35 0146.000
*        NOTE : MODULE DEPENDANCES FOR THIS VERSION ARE :       ETSA-35 0147.000
*               ONE OF SH.EXEC V/3.5.02 OR SH.EXEC2 V/3.5.02 OR EOUT-35 0148.000
*               SH.EXEC3 V/3.5.05 AND SH.EXSUB V/3.5.02 AND     EOUT-35 0149.000
*               SH.TAMM V/3.5.09 AND SH.IPU V/3.5.03 AND        EOUT-35 0150.000
*               SJ.SPH01 V/3.5.03 AND SJ.SEXEC V/3.5.03 AND     ESME-35 0151.000
*               SM.MPXMC V/3.5.08                               ETSA-35 0152.000
*                                                               ETSA-35 0153.000
*                                                               EOUTA35 0154.000
*     VERSION 3.5.02  BL1                                       EOUTA35 0155.000
*                                                               EOUTA35 0156.000
*        EOUTA35   01/16/89 10471  SET THE T.CPUAE BIT FOR NON  EOUTA35 0157.000
*                  BASE TASKS, SO IT WILL NOT TOUCH T.REGP IF   EOUTA35 0158.000
*                  AE CAME FROM IPU.                            EOUTA35 0159.000
*                                                               EOUTA35 0160.000
*     VERSION 3.5.01  BL1                                       EOUT-35 0161.000
*                                                               EOUT-35 0162.000
*        EOUT-35   01/16/89 10471  CONVERT TO RUN MAPPED OUT    EOUT-35 0163.000
*                                                               EOUT-35 0164.000
*********************************************************************** 0165.000
*                                                               S871493 0166.000
*        MPX-32 REVISION 3 RELEASE 3.4 CHANGE HISTORY           S871493 0167.000
*                                                               S871493 0168.000
****************************************************************S871493 0169.000
*                                                               Q241A34 0170.000
*        VERSION   3.4.04                                       Q241A34 0171.000
*                                                               Q241A34 0172.000
*        Q241A34   02/23/88  8162  REWORK AGAIN OF Q241-34 SO   Q241A34 0173.000
*                  THAT BASE REGISTERS CAN BE RETRIEVED         Q241A34 0174.000
*                  PROPERLY FOR BOTH GCL AND X32 TASKS.         Q241A34 0175.000
*                                                               Q241-34 0176.000
*        VERSION   3.4.03                                       Q241-34 0177.000
*                                                               Q241-34 0178.000
*        02/18/88  Q241-34  8162   REWORK OF EGCFO34 (VERSION   Q241-34 0179.000
*                  3.4.02 BELOW) FIX WHICH BROKE X32 AE HANDLER Q241-34 0180.000
*                  RETURNS.  THIS CODE SHOULD RETURN BASE       Q241-34 0181.000
*                  REGISTERS AT THE TIME OF THE EXCEPTION BACK  Q241-34 0182.000
*                  TO THE TASK AFTER EXECUTING ITS AE HANDLER.  Q241-34 0183.000
*                                                               EGCFO34 0184.000
*        VERSION   3.4.02                                       EGCFO34 0185.000
*                                                               EGCFO34 0186.000
*        EGCFO34   01/27/88  8162  REMOVED STFBR IN IP0F.900    EGCFO34 0187.000
*                  WHEN RETURNING FROM TASK'S EXCEPTION HANDLER.EGCFO34 0188.000
*                  THE BASE REGISTERS WE WANT ARE THOSE STORED  EGCFO34 0189.000
*                  WHEN THE INITIAL AE OCCURRED. (QAR206-34)    EGCFO34 0190.000
*                                                               S871493 0191.000
*        VERSION   3.4.01                                       S871493 0192.000
*                                                               S871493 0193.000
*        S871493   09/24/87  8144  CORRECTED BASE REGISTER      S871493 0194.000
*                                  STACK POINTER FOR ARITHMETIC S871493 0195.000
*                                  EXCEPTIONS IN ADA TASKS      S871493 0196.000
*                                                               S871493 0197.000
************************************************************************0198.000
         TITLE H.IP0F ARITHMETIC EXCEPTION PROCESSING                   0199.000
         TITLE SH.IP0F LOCAL EQUATES                                    0200.000
************************************************************************0201.000
*                                                                      *0202.000
*        H.IP0F, ARITHMETIC EXCEPTION TRAP                             *0203.000
*                                                                      *0204.000
************************************************************************0205.000
         SPACE     3                                                    0206.000
         LIST      NOMAC,NODATA                                         0207.000
         M.EQUS                                                         0208.000
         M.TBLS                                                         0209.000
         M.BREGS                                                EBRG-33 0210.000
         M.FPS.                    GET FLOAT POINT STAT EQUATES E3IEE35 0211.000
*                                                                       0212.000
*        PROGRAM EQUATES                                                0213.000
*                                                                       0214.000
*        NOTE:  THESE EQUATES MATCH ARGLIST AND MUST BE KEPT IN SYNC.   0215.000
*               ALSO...ARGLIST IN THIS MODULE MUST MATCH ARGLIST IN     0216.000
*               H.IPU.                                             32B030217.000
*                                                                       0218.000
ARULEN   EQU       37W             LENGTH OF THE ARGUMENT LIST     32B010219.000
MPLEN    EQU       64W             LENGTH OF STACK ALLOCATED       32B090220.000
DES.PTR  EQU       1W              ADDRESS OF DESCRIPTIVE VECTOR    32000221.000
ADR.PTR  EQU       2W              ADDRESS OF PSD                   32000222.000
ARY.PTR  EQU       3W              ADDRESS OF EXCEPTION ARRAY       32000223.000
STA.PTR  EQU       4W              ADDRESS OF EXCEPTION STATUS      32000224.000
ADR.DPTR EQU       5W              POINTER TO PSD DESCRIPTOR        32000225.000
ARY.DPTR EQU       6W              POINTER TO ARRAY DESCRIPTOR      32000226.000
STA.DPTR EQU       7W              POINTER TO STATUS DESCRIPTOR     32000227.000
EXCP.ADR EQU       14W             ADDR OF INSTR CAUSING TRAP 3200 32B010228.000
ARG.REGS EQU       16W             GPR'S AT TIME OF EXCEPTION 3200 32B010229.000
EXCP.PSD EQU       24W             SAVE AREA FOR THE PSD      3200 32B010230.000
ARG.BREG EQU       26W             BASE REGS AT TIME OF EXCPT 3200 32B010231.000
FIXREG   EQU       34W             FIXED REG(S)               3200 32B010232.000
CONDCOD  EQU       35W             CONDITION CODES            3200 32B010233.000
EXSTAT   EQU       36W                 EXCEPTION STATUS       3200 32B010234.000
** END OF ARG LIST *********************************************** 32B010235.000
** MORE STUFF IN LIST FOR LOCAL STORAGE ************************** 32B080236.000
*!FILL   EQU       37W                                    32B01 E3IEE35 0237.000
AL.ST2   EQU       37W             FLOATING POINT STATUS        E3IEE35 0238.000
PSD.OLD  EQU       38W             OLD PSD SAVE AREA          3200 32B010239.000
BR.FILE  EQU       40W             BR REG SAVE AREA                32B010240.000
*================================================================       0241.000
*        FLAGS WORD AND BIT EQUATES FOLLOW                              0242.000
*                                                                       0243.000
FLAGS    EQU       48W             EXCEPTION FLAGS            3200 32B010244.000
BR.HNDLR EQU       0               TASK IS BASED AND HAS A HANDLER      0245.000
ADA      EQU       1               THIS IS AN ADA TASK             32B080246.000
AF       EQU       2               SPECIAL ARITH FUNCTION       S850700 0247.000
*================================================================       0248.000
FRMPNT   EQU       49W             CALL STACK FRAME POINTER   3200 32B010249.000
REGSAV   EQU       50W             ADDRESS OF REG SAVE AREA   3200 32B010250.000
R0SAV    EQU       51W             REGISTER 0 SAVE AREA       3200 32B010251.000
ADTSA    EQU       52W             TSA ADDRESS SAVE AREA      3200 32B010252.000
BRSAV    EQU       53W             BASE REG SAVE AREA ADDR         32B080253.000
INSTSAV  EQU       54W             INSTRUCTION CAUSING TRAP        32B080254.000
*                                                               S850700 0255.000
*                                                               S850700 0256.000
         TITLE H.IP0F DEF'S AND EXT'S                                   0257.000
         DEF       IP0FS                                                0258.000
         DEF       IP0F.ICB                                             0259.000
         DEF       EXIT                                                 0260.000
         DEF       IP0F.EN                                          32000261.000
*                                                                       0262.000
*        ADA HOOK LABELS                                           32B020263.000
*                  TO BE NOP'D BY H.ADA                            32B020264.000
         DEF       IP0FADA1        LABEL IN BASE OVERLAY CODE      32B020265.000
*                  TO BE REPLACED WITH BL BY H.ADA                 32B020266.000
         DEF       IP0FADA2        IN BASE CODE OVERLAY AREA       32B020267.000
         DEF       IP0F.OLD,IP0F.REG  OLD PSD AND REGS             32B080268.000
*                                                                       0269.000
         EXT       BR.DISP2                                         32000270.000
         EXT       IP00.EXR        LOCATION IN H.IP00                   0271.000
         EXT       S.IP2                                           2001 0272.000
         TITLE H.IP0F MAIN PROCESSING                                   0273.000
HAT      DATAW     2                                                    0274.000
         ACW       IP0F.ICB                                             0275.000
SG.HAT   EQU       $                                                33000276.000
         ACW       IP0FS                                                0277.000
         SPACE     3                                                    0278.000
         BOUND     2W                                                   0279.000
IP0F.ICB EQU       $                                                    0280.000
IP0F.OLD REZ       2W                                                   0281.000
IP0F.NEW M.PSDGEN  IP0F,DIR,BEI                                 EOUT-35 0282.000
*P0F.NEW GEN       1/1,5/1,7/0,19/W(IP0F)       MADE EXTENDED   EOUT-35 0283.000
*        GEN       1/1,13/0,1/0,1/1,1/0,1/1,12/0,2/0            EOUT-35 0284.000
*                   *            *   *   *                              0285.000
*                   *            *   *   *                              0286.000
*                   *            *   *   *49, NEW BLOCK STATE-BEI       0287.000
*                   *            *   *48, LOAD NEW BLOCK STATE          0288.000
*                   *            *47,RETAIN OLD MAP                     0289.000
*                   *32-33, MAP MODE                                    0290.000
IP0F.ST1 DATAW     0                                                    0291.000
IP0F.ST2 DATAW     0                                                    0292.000
         SPACE     3                                                    0293.000
IP0F     EQU       $                                                #T# 0294.000
         STF       R0,IP0F.REG       SAVE ALL REGS                      0295.000
         M.TRAC    7,0F                                                 0296.000
*                                                                       0297.000
*        GET OLD PSD AND GO TO DEXP FOR CHECK                           0298.000
*                                                                       0299.000
         LA        R1,IP0F.OLD     FETCH ADDRESS OF OLD PSD        2001 0300.000
         LI        R7,X'F'         INDICATE TRAP TYPE              2001 0301.000
         BL        S.IP2           IS ON-LINE DEXP ACTIVE          2001 0302.000
         BU        $+2W            YES, BRANCH; OTHERWISE           32000303.000
         BU        IP0F.0                                           32000304.000
         LF        R0,IP0F.REG     RESTORE USER REGS                32000305.000
         BU        EXIT.X                                           32000306.000
*                                                                       0307.000
*        SET UP REGISTERS WITH DATA FOR MERGE WITH COMMON CODE          0308.000
*                                                                       0309.000
*        R1 = ADDRESS OF ARGUMENT LIST                                  0310.000
*        R2 = ADDRESS OF REGISTER SAVE AREA                             0311.000
*        R3 = ADDRESS OF TSA                                            0312.000
*        R6,R7 = OLD PSD                                                0313.000
*                                                                       0314.000
*        GET STACK SPACE FOR BUILDING ARG LIST                          0315.000
*                                                                       0316.000
IP0F.0   EQU       $                                               32B080317.000
*        LW        R2,C.REGS       GET TSA ADDRESS        32B09 S910723 0318.000
         M.TSAD    R2,CPU          GET TSA ADDRESS              S910723 0319.000
         LCW       R3,T.PRNO,R2    GET DQE ADDRESS              EOUT-35 0320.000
*                                                               Q044-33 0321.000
*        DON'T USE TSA STACK FOR ARG LIST IF NOT A BASE TASK    Q044-33 0322.000
*                                                               Q044-33 0323.000
*P0F.BAS EQU       $               HERE FOR BASE CODE   Q044-33 EOUT-35 0324.000
*POF.BAS EQU       $                                    EOUT-35 S910723 0325.000
         LCW       R1,T.REGP,X2    GET STACK POINTER            EOUT-35 0326.000
*        ADI       64W             INCREM 2 LEVELS      EOUT-35 E2RIS35B0327.000
         ADMH      R1,C.FRAME      INCREM 2 LEVELS              E2RIS35B0328.000
         ADMH      R1,C.FRAME                                   E2RIS35B0329.000
         STCW      R1,T.REGP,X2    SAVE NEW STACK PTR           EOUT-35 0330.000
         LA        R6,T.BROFF,X1   GET CURR BR STACK FRAME      E2RIS35B0331.000
         STCW      R6,T.MPXBR+3W,X2  MAINTAIN CURR BR STK FRAME E2RIS35B0332.000
         SUI       R1,32W          ADJUST PTR FOR USAGE         EOUT-35 0333.000
*        TBM       DQE.ADA,DQE.IPUF,X3 ADA TASK??       EOUT-35 S910723 0334.000
*        BS        IP0F.BA1        YES, SO SKIP         EOUT-35 S910723 0335.000
*        LCW       R6,T.MPXBR+3W,X2 GET BR STACK PTR    EOUT-35 E2RIS35B0336.000
*        ADI       R6,16W          INCREM BY 16 WORDS   EOUT-35 E2RIS35B0337.000
*        STCW      R6,T.MPXBR+3W,X2 GET BR STACK PTR    EOUT-35 E2RIS35B0338.000
*        TBM       DQE.BASE,DQE.IPUF,X3  BASE TASK?     EOUT-35 S910723 0339.000
*        BS        IP0F.BA1        YES, SO SKIP         EOUT-35 S910723 0340.000
*        LCW       R6,T.BIT5,X2    GET BR STACK PTR     EOUT-35 S910723 0341.000
*        SBR       R6,T.NOEXCP     INDICATE NO EXCP. HANEOUT-35 S910723 0342.000
*        SBR       R6,T.CPUAE      INDICATE CPU AE OCCUREOUTA35 S910723 0343.000
*        STCW      R6,T.BIT5,X2    GET BR STACK PTR     EOUT-35 S910723 0344.000
*        BU        SETUP           GO SETUP ARGLIST     EOUT-35 S910723 0345.000
*P0F.BA1 EQU       $                                    S871493 S910723 0346.000
*        LW        R3,T.PRNO,R2    GET DQE ADDRESS              Q044-33 0347.000
         ZR        R6              ZERO R6                      EOUT-35 0348.000
         STCW      R6,FLAGS,X1     ZERO FLAG WORD               EOUT-35 0349.000
         TBM       DQE.ADA,DQE.IPUF,R3  ADA?                       32B080350.000
         BNS       NOT.ADA              NO, SO BRANCH           S910723 0351.000
*        BNS       TESTAF               NO, CHECK FOR AFS850700 S910723 0352.000
*        BNS       SETUP                NO SKIP      32B08      S850700 0353.000
*        LCW       R6,FLAGS,X1     GET FLAG WORD        EOUT-35 S910723 0354.000
         SPACE                                                  S910723 0355.000
* THIS IS ADA SPECIFIC CODE.                                    S910723 0356.000
         SBR       R6,ADA          SET ADA FLAG                 EOUT-35 0357.000
         STCW      R6,FLAGS,X1     RESTORE FLAG WORD            EOUT-35 0358.000
         LCW       R7,T.BIT5,X2    GET TSA FLAGS                S910723 0359.000
         ZBR       R7,T.NOEXCP     INDICATE AE HANDLER PRESENT  S910723 0360.000
         STCW      R7,T.BIT5,X2    STORE BACK IN TSA FLAG WORD  S910723 0361.000
         BU        IP0F.MR         GO MOVE REGS                    32B080362.000
*ESTAF   EQU       $                                    S850700 S910723 0363.000
NOT.ADA  CEQU      $                                            S910723 0364.000
         TBM       DQE.BASE,DQE.IPUF,X3  BASE TASK?             S910723 0365.000
         BNS       NO.HNDLR              NO, SO BRANCH          S910723 0366.000
         LCW       R7,T.EXCPAD,X2  BASE REG AE HANDLER?         S910723 0367.000
         BZ        NO.HNDLR              NO, SO BRANCH          S910723 0368.000
         SPACE                                                  S910723 0369.000
* THIS IS BASE REG WITH AE HANDLER SPECIFIC CODE.               S910723 0370.000
         LCW       R7,T.BIT5,X2    GET TSA FLAGS                S910723 0371.000
         ZBR       R7,T.NOEXCP     INDICATE AE HANDLER PRESENT  S910723 0372.000
         STCW      R7,T.BIT5,X2    STORE BACK IN TSA FLAG WORD  S910723 0373.000
         TBM       DQE.AF,DQE.UF2,R3    SPECIAL ARITH FUNCTION? S850700 0374.000
         BNS       SETUP           NO, SKIP                     S850700 0375.000
*        LCW       R6,FLAGS,X1     GET FLAG WORD        EOUT-35 S910723 0376.000
         SBR       R6,AF           SET AF FLAG                  EOUT-35 0377.000
         STCW      R6,FLAGS,X1     RESTORE FLAG WORD            EOUT-35 0378.000
*                                                                       0379.000
*        MOVE BASIC ARG LIST DATA TO STACK FOR TEMP STORAGE             0380.000
*                                                                       0381.000
SETUP    TRR       R1,R5           SAVE R1                         32B080382.000
         LA        R2,ARGLIST      LOCAL ARG LIST DATA             32B080383.000
         LI        R6,-ARULEN      LENGTH OF MOVE                  32B080384.000
IP0F.L1  LW        R7,0,R2         GET A WORD                      32B080385.000
         STCW      R7,0,R1         PUT IN STACK AREA            EOUT-35 0386.000
         ABR       R1,29           BUMP ONE WORD                   32B080387.000
         ABR       R2,29           HERE TOO                        32B080388.000
         BIW       R6,IP0F.L1      DO ALL                          32B080389.000
         TRR       R5,R1           GET R1 BACK                     32B080390.000
         BU        IP0F.MR         DO COMMOM CODE               S910723 0391.000
*        TBM       DQE.BASE,DQE.IPUF,X3 BASE REG TASK   EOUT-35 S910723 0392.000
*        BS        IP0F.MR                              EOUT-35 S910723 0393.000
*        TBM       DQE.ADA,DQE.IPUF,X3 ADA TYPE TASK ?  EOUT-35 S910723 0394.000
*        BS        IP0F.MR                              EOUT-35 S910723 0395.000
*        LD        R6,IP0F.OLD     SET UP R6 OLD PSD    EOUT-35 S910723 0396.000
*        LA        R2,IP0F.REG     SET UP R2 WITH OLD R EOUT-35 S910723 0397.000
*        LW        R3,C.REGS       GET  TSA ADDRES      EOUT-35 S910723 0398.000
*        BU        IP0F.ENE        DO COMMOM CODE       EOUT-35 S910723 0399.000
         SPACE                                                  S910723 0400.000
* THIS IS NONBASE OR BASE WITHOUT AN AE HANDLER SPECIFIC CODE.  S910723 0401.000
NO.HNDLR CEQU      $                                            S910723 0402.000
         LCW       R7,T.BIT5,X2    GET TSA FLAGS                S910723 0403.000
         SBR       R7,T.NOEXCP     INDICATE NO AE HANDLER       S910723 0404.000
         STCW      R7,T.BIT5,X2    STORE BACK IN TSA FLAG WORD  S910723 0405.000
         SPACE                                                  S910723 0406.000
* THIS IS A COMMON MERGE POINT FOR ALL TASKS.                   S910723 0407.000
*                                                                       0408.000
*        BUILD SOME DATA IN THE STORAGE AREA                            0409.000
*                                                                       0410.000
IP0F.MR  LD        R6,IP0F.REG     MOVE REGISTERS TO ARG LIST      32B080411.000
         STCD      R6,ARG.REGS,R1          R0,R1                EOUT-35 0412.000
         LD        R6,IP0F.REG+1D          R2,R3                   32B080413.000
         STCD      R6,ARG.REGS+1D,R1       R2,R3                EOUT-35 0414.000
         LD        R6,IP0F.REG+2D          R4,R5                   32B080415.000
         STCD      R6,ARG.REGS+2D,R1       R4,R5                EOUT-35 0416.000
         LD        R6,IP0F.REG+3D          R6,R7                   32B080417.000
         STCD      R6,ARG.REGS+3D,R1       R6,R7                EOUT-35 0418.000
         LA        R6,ARG.BREG,R1      GET POINTER                 32B080419.000
         STCW      R6,BRSAV,R1         PUT IN DATA STRUCTURE    EOUT-35 0420.000
         LD        R6,IP0F.OLD                                      32000421.000
         LW        R5,IP0F.ST2     GET FLOATING POINT STATUS    E3IEE35 0422.000
         STCW      R5,AL.ST2,X1    STORE IN ARG LIST            E3IEE35 0423.000
*                                                                       0424.000
*        WE SHOULD BE ABLE TO UNBLOCK INTERRUPTS HERE AS ALL       32B080425.000
*        LOCAL STORAGE HAS BEEN MOVED TO STACK TEMP  AREA          32B080426.000
*                                                                       0427.000
*!!!!!!!!!!UEI!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!E1BLK35!!0428.000
         M.IONN                  UNBLOCK EXTERNAL INTS.        E1BLK35  0429.000
*!!!!!!!!!!BEI!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!E1BLK35!!0430.000
         M.IOFF                    BLOCK EXTERNAL INTS.        E1BLK35  0431.000
*                                                                       0432.000
*        MORE REGISTER SET UP                                           0433.000
*                                                                       0434.000
         LA        R2,ARG.REGS,R1                                  32B080435.000
         STCW      R2,REGSAV,R1    BUILD REGISTER POINTER       EOUT-35 0436.000
*        LW        R3,C.REGS                               3200 S910723 0437.000
         M.TSAD    R3,CPU          GET TSA ADDRESS              S910723 0438.000
         LCW       R5,T.BIT5,X3    GET T.BIT5 INTO R7           EOUT-35 0439.000
         SBR       R5,T.CPUAE      A.E. CAME FROM CPU           EOUT-35 0440.000
         STCW      R5,T.BIT5,X3    RESTORE T.BIT5               EOUT-35 0441.000
*P0F.ENE EQU       $                                    Q044-33 S910723 0442.000
         BL        IP0F.EN                                          32000443.000
         STD       R6,TASK.PSD     SAVE PSD FOR RETURN TO TASK  S910723 0444.000
*        STD       R6,IP0F.OLD     SAVE PSD IN NORMAL PLAC 3200 S910723 0445.000
*        M.LF      0W,X1           RESTORE USER REGISTE EOUT-35 CPR111120446.000
*        IFT       C.MPXOUT,%REIS                      CPR11112 S910723 0447.000
*        LW        R3,C.REGS            GET TSA ADDRESS CP11787 S910723 0448.000
*        LCW       R3,T.PRNO,X3         GET DQE ADDRESS CP11787 S910723 0449.000
*        TBM       DQE.BASE,DQE.IPUF,X3 BASE REG TASK?  CP11787 S910723 0450.000
*        BS        IP0F.TA              YES, SO BRANCH  CP11787 S910723 0451.000
*        TBM       DQE.ADA,DQE.IPUF,X3  ADA TASK?       CP11787 S910723 0452.000
*        BS        IP0F.TA              YES, SO BRANCH  CP11787 S910723 0453.000
*        LF        R0,0,X1              RESTORE USER RE CP11787 S910723 0454.000
*        BU        EXIT.X                               CP11787 S910723 0455.000
* IF!BASE!REG!TASK!OR!ADA!TASK,!THEN!THE!USER!REGISTERS!CP11787!S910723!0456.000
* LOCATED!IN!THE!TSA'S!STACK.!!THE!ADDRESS!TO!THE!REGIS!CP11787!S910723!0457.000
* IS!LOCATED!IN!REGISTER!1.!!!!!!!!!!!!!!!!!!!!!!!!!!!!!CP11787!S910723!0458.000
*P0F.TA  EQU       $                                    CP11787 S910723 0459.000
         LCW       R0,0W,X1        RESTORE USER REGISTERS       CPR111120460.000
         LCW       R2,2W,X1        R0 THRU R7                   CPR111120461.000
         LCW       R3,3W,X1                                     CPR111120462.000
         LCW       R4,4W,X1                                     CPR111120463.000
         LCW       R5,5W,X1                                     CPR111120464.000
         LCW       R6,6W,X1                                     CPR111120465.000
         LCW       R7,7W,X1                                     CPR111120466.000
         LCW       R1,1W,X1                                     CPR111120467.000
*        GOTO      %CONT                               CPR11112 S910723 0468.000
*REIS    ANOP                                          CPR11112 S910723 0469.000
*        LF        R0,0,X1                             CPR11112 S910723 0470.000
*CONT    ANOP                                          CPR11112 S910723 0471.000
EXIT.X   M.TRAC    7,0F                                             32000472.000
         M.LPSD    TASK.PSD        RETURN TO USER               S910723 0473.000
*!!!!!!!!!!LPSD!!!!!!IP0F.OLD!!!!!!!!RETURN!TO!USER!!!!!!!!!!!!!E1BLK35!0474.000
*        M.LPSD    IP0F.OLD        RETURN TO USER       E1BLK35 S910723 0475.000
*!                                                              S910723 0476.000
*!       THE FOLLOWING CODE IS ALSO EXECUTED BY H.IPU     32B03 S910723 0477.000
*!                                                              S910723 0478.000
         TITLE H.IP0F COMMON CPU/IPU ROUTINE                    S910723 0479.000
****************************************************************S910723 0480.000
*                                                               S910723 0481.000
*        IP0F.EN - COMMON CPU/IPU ROUTINE                       S910723 0482.000
*                                                               S910723 0483.000
****************************************************************S910723 0484.000
*                                                               S910723 0485.000
*  ENTRY CONDITIONS:                                            S910723 0486.000
*        CALLING SEQUENCE:                                      S910723 0487.000
*           BL IP0F.EN (FROM H.IP0F FOR ARITH EXCP IN CPU)      S910723 0488.000
*                      (FROM H.IPU FOR ARITH EXCP IN IPU)       S910723 0489.000
*        REGISTERS IN:                                          S910723 0490.000
*           R1 = ADDR OF ARGLIST                                S910723 0491.000
*           R2 = ADDR OF REGSAVE AREA IN TSA STACK              S910723 0492.000
*           R3 = ADDR OF TSA                                    S910723 0493.000
*           R6,R7 = OLD PSD                                     S910723 0494.000
*                                                               S910723 0495.000
*  EXIT CONDITIONS:                                             S910723 0496.000
*        RETURN SEQUENCE:                                       S910723 0497.000
*           TRSW   R0                                           S910723 0498.000
*        REGISTERS OUT:                                         S910723 0499.000
*           R1 = ADDR OF REGSAVE AREA                           S910723 0500.000
*           R6,R7 = UNCHANGED                                   S910723 0501.000
*           R2,R3,R4,R5 = DESTROYED                             S910723 0502.000
*                                                               S910723 0503.000
****************************************************************S910723 0504.000
*                                                               S910723 0505.000
IP0F.EN  EQU       $                                                    0506.000
         STCW      R0,R0SAV,R1     SAVE RETURN ADDRESS          EOUT-35 0507.000
*                                                                       0508.000
*        DETERMINE IF OFFENDING INSTRUCTION WAS IN THE OS AND           0509.000
*        IF SO SEE IF IT IS THE BASE REG. TASK HANDLER RETURNING        0510.000
*        TO HERE. THIS IS INDICATED BY THE VALUE OF THE OLD PSD.        0511.000
*                                                                       0512.000
*=======================================================================0513.000
*        TEST FOR BASE REGISTER CODE PRESENT, BRANCH IF YES             0514.000
*                                                                       0515.000
*        TBM       C.NOBASE,C.CONF HAS BASE CODE BEEN REMOVED?  Q044-33 0516.000
         LCW       R5,T.BIT5,X3    GET VALUE OF T.BIT5          EOUT-35 0517.000
         TBR       R5,T.NOEXCP     SET IF NO EXCP HNDLR         EOUT-35 0518.000
IPF.NOP1 BNS       IPF.B001        NO                               33000519.000
*        BASE REGISTER CODE MOVED FROM HERE                             0520.000
IP0F.EN1 EQU       $                                                33000521.000
*=======================================================================0522.000
*                                                                       0523.000
         IFT       C.MPXOUT,%CONT                               EOUT-35 0524.000
         TBM       32,IP0F.OLD     TEST IF OLDPSD WAS MAPPED?   EOUT-35 0525.000
         BS        IP0F.011        YES, SO CHECK BASE REG TASK  EOUT-35 0526.000
         M.KILL    ABT.OSAE        HALT WITH OSAE               EOUT~35 0527.000
ABT.OSAE DATAW     C'OSAE'                                      EOUT~35 0528.000
%CONT    ANOP                                                   EOUT-35 0529.000
         TRR       R6,R4           TEST FOR ABORT IN OS         EOUT-35 0530.000
         ANMW      R4,=X'00FFFFFF' USE 24 BIT ADDRESS           EOUT-35 0531.000
         IFT       C.MPXOUT,%REIS                               ETSA-35 0532.000
         TBM       32,IP0F.OLD                                  ETSA-35 0533.000
         BNS       IP0F.01                                      ETSA-35 0534.000
         GOTO      %SEIS                                        ETSA-35 0535.000
%REIS    TBM       32,IP0F.OLD                                  ETSA-35 0536.000
         BS        IP0F.LOS                                     ETSA-35 0537.000
         CAMW      R4,C.POSEND                                  ETSA-35 0538.000
         BLT       IP0F.01                                      ETSA-35 0539.000
         BU        IP0F.T                                       ETSA-35 0540.000
IP0F.LOS CAMW      R4,C.LOSEND                                  ETSA-35 0541.000
         BLT       IP0F.01                                      ETSA-35 0542.000
IP0F.T   CAMW      R4,T.MPXBR+7W,X3  ADDR IN TASK SPACE?        ETSA-35 0543.000
         BLT       IP0F.011        YES...BRANCH                 EOUT-35 0544.000
         CAMW      R4,T.MPXBR+0W,X3  ADDR IN EXTD MPX?  EBRGG00 EOUT-35 0545.000
         BLE       IP0F.01         YES...BRANCH                 EOUT-35 0546.000
%SEIS    ANOP                                                   ETSA-35 0547.000
*                                                                       0548.000
*        SEE IF THIS ENTRY IS CAUSED BY AN EXCEPTION IN A               0549.000
*        BASED MODE TASK WITH AN EXCEPTION HANDLER.                     0550.000
*                                                                       0551.000
*=======================================================================0552.000
*        TEST FOR BASE REGISTER TASK, BRANCH IF IT IS.                  0553.000
*                                                                       0554.000
*        TBR       R6,6            CHECK FOR BASED MODE TSK 3200EBRG-33 0555.000
*                                                               EBRG-33 0556.000
IP0F.011 EQU       $                                            EBRG-33 0557.000
         LCB       R5,T.BIT2,X3    GET T.BIT2                   EOUT-35 0558.000
         TBR       R5,T.BASE+24    TEST FOR BASE MODE TASK?     EOUT-35 0559.000
IPF.NOP2 BS        IPF.B002        BASE TASK                        33000560.000
*        BASE REGISTER CODE MOVED FROM HERE                             0561.000
IP0F.01  EQU       $                                                    0562.000
*=======================================================================0563.000
*                                                                       0564.000
*        HANDLE THE EXCEPTION HERE - FIRST SET THE TSA FLAG BIT         0565.000
*        AND THE FIND THE BAD INSTRUCTION SO FIX-UP CAN BE              0566.000
*        PERFORMED.                                                     0567.000
*                                                                       0568.000
*        STW       R2,REGSAV,R1    SAVE ADDRESS OF REGS             32000569.000
         LCB       R5,T.BIT1,X3    GET T.BIT1                   EOUT-35 0570.000
         SBR       R5,T.EXCP+24    SET THE EXCP BIT IN TSA      EOUT-35 0571.000
         STCB      R5,T.BIT1,X3    RESTOER T.BIT1               EOUT-35 0572.000
         STCD      R6,PSD.OLD,R1   SAVE OLD PSD FOR LATER       EOUT-35 0573.000
         STCW      R2,REGSAV,R1    SAVE ADDRESS OF REGS         EOUT-35 0574.000
         STCW      R3,ADTSA,R1     SAVE TSA ADDRESS             EOUT-35 0575.000
*!       TBM       C.RISC,C.CONF1  RISC MACHINE (RSX)?  E3IEE35 E3IEE35A0576.000
*!       BNS       IP0F.05         NO, SO SKIP          E3IEE35 E3IEE35A0577.000
*!       LCW       R5,AL.ST2,X1    GET FLOATING POINT S E3IEE35 E3IEE35A0578.000
*!       ANMW      R5,=X'0000000F' PRESERVE LAST NIBBLE E3IEE35 E3IEE35A0579.000
*!       CI        R5,FPS.EX64     EXCESS 64 AE OCCURRE E3IEE35 E3IEE35A0580.000
*!       BNE       ADACHK          NO, SO JUST RETURN   E3IEE35 E3IEE35A0581.000
*!0F.05  CEQU      $                                    E3IEE35 E3IEE35A0582.000
         ZBR       R6,30           TEST FOR LAST INST IN LEFT HW    32000583.000
         BS        IP0F.20         IF IT WAS, BRANCH                    0584.000
         ZBR       R6,31           TEST FOR LAST INST IN RIGHT HW   32000585.000
         BNS       IP0F.10         IF NOT, MUST HAVE BEEN LAST WORD     0586.000
         SUI       R6,2            RIGHT HW INST., BACK UP 2        32000587.000
         BU        IP0F.20         JUMP ON AHEAD                        0588.000
         TITLE H.IP0F FULLWORD INSTRUCTION PROCESSING                   0589.000
*********************************************************************** 0590.000
*                                                                       0591.000
*        COME HERE IF THE LAST INSTRUCTION WAS A FULLWORD INST.         0592.000
*        GET THE WORD AND CHECK FOR A FLOATING POINT MULTIPLY           0593.000
*        DIVIDE, ADD, OR SUBTRACT AND GO TO THE PROPER FIXUP            0594.000
*        ROUTINE.                                                       0595.000
*                                                                       0596.000
*********************************************************************** 0597.000
*                                                                       0598.000
IP0F.10  EQU       $                                                    0599.000
         SUI       R6,1W           WORD INST - BACK UP PC BY 1W     32000600.000
         STCW      R6,EXCP.ADR,R1  SAVE THE ADDRESS OF THE INST EOUT-35 0601.000
         TRR       R6,R2           PUT INTO AN INDEX REG            32000602.000
         LCW       R2,0W,R2        GET THE INSTRUCTION          EOUT~35 0603.000
         STCW      R2,INSTSAV,R1   STORE IN FRAME VARIABLE      EOUT~35 0604.000
         BP        IP0F.20         BR IF LEFT H/W ON 32/67 OR /97   32010605.000
         LW        4,=X'FC000000'  OP CODE MASK                         0606.000
         CMMW      2,=X'E4000000'  COMPARE FOR MP OR DV             32000607.000
         BEQ       FW.MPDV         BRANCH IF MP OR DV                   0608.000
         CMMW      2,=X'E0000000'  COMPARE FOR ADD AND SUBTRACT     32000609.000
         BEQ       FW.ADSUB        BRANCH IF ADD OR SUBTRACT       32B080610.000
*                                                                       0611.000
*        CHECK FOR ADA TASK, REPORT INTEGER EXCEPTION IF YES            0612.000
*                                                                       0613.000
ADACHK   EQU       $                                               32B080614.000
*        TBM       ADA,FLAGS,R1         IS IT ADA?      32B08   S850700 0615.000
*        BNS       EXIT            IF NOT THEN DO NOTHING 32B08 S850700 0616.000
*        LW        R3,C.REGS       SET UP REGISTER FOR LEA32B08 S850700 0617.000
*        LW        R4,T.EXCPAD,R3  EXCEPTION HANDLER ADDR.32B08 S850700 0618.000
         LCW       R3,ADTSA,R1      GET TSA ADDRESS             EOUT-35 0619.000
         LCW       R5,T.BIT5,X3    GET T.BIT5                   EOUT-35 0620.000
         TBR       R5,T.NOEXCP     SEE IF NO EXCEP. HNDLR       EOUT-35 0621.000
         BS        EXIT                                         Q044-33 0622.000
IP0F.15  EQU       $                                            EADA-33 0623.000
         LI        R0,5            SPECIAL STATUS FOR H.ADA        32B080624.000
         STCB      R0,EXSTAT+3B,R1  INDICATES INTEGER OVERFLOW  EOUT-35 0625.000
         LCW       R5,FLAGS,X1     GET FLAG WORD                EOUT-35 0626.000
         TBR       R5,ADA          ADA TASK?                    EOUT-35 0627.000
         BNS       AFCHK            NO, TRY SPECIAL ARITH FUNC  S850700 0628.000
         LCW       R3,ADTSA,R1      GET TSA ADDRESS             EOUT-35 0629.000
         LCW       R4,T.EXCPAD,R3   EXCEPTION HANDLER ADDR.     EOUT-35 0630.000
         BU        IP0FADA2             YES, BRANCH TO H.ADA       32B080631.000
AFCHK    EQU       $                                            S850700 0632.000
         LCW       R5,FLAGS,X1     GET FLAG WORD                EOUT-35 0633.000
         TBR       R5,AF           SPEC ARITH FUNC?             EOUT-35 0634.000
         BS        REPORT           YES, REPORT STATUS          S850700 0635.000
         BU        EXIT             NO DO NOTHING               S850700 0636.000
*                                                                       0637.000
*        HANDLE FULL WORD MULTIPLY OR DIVIDE INSTRUCTIONS HERE          0638.000
*                                                                       0639.000
FW.MPDV  EQU       $                                                    0640.000
         BL        FIXUP           CALL THE ROUTINE TO FIX THE REGISTER 0641.000
         TBR       R2,12           TEST FOR DIVIDE INSTRUCTION      32000642.000
         BS        REPORT          BRANCH IF MULTIPLY                   0643.000
*                                                                       0644.000
*        TEST FOR DIVIDE BY ZERO                                        0645.000
*                                                                       0646.000
IP0F.520 EQU       $                                                    0647.000
         LCW       R5,FLAGS,X1     GET FLAG WORD                EOUT-35 0648.000
         TBR       R5,BR.HNDLR     CHECK IF BASE HANDLER?       EOUT-35 0649.000
IPF.NOP3 BS        IPF.B003          BASE CODE PRESENT              33000650.000
         BU        EXIT            IF NONE, DON'T BOTHER WITH THIS  33000651.000
*                                                                       0652.000
*        HANDLE FULL WORD ADD AND SUBTRACT HERE                         0653.000
*                                                                       0654.000
FW.ADSUB EQU       $                                                    0655.000
         BL        FIXUP           FIXUP THE DESTINATION REGISTER       0656.000
         BU        REPORT          SEE WHAT ELSE TO DO                  0657.000
         TITLE H.IP0F HALFWORD INSTRUCTION PROCESSING                   0658.000
*                                                                       0659.000
*        COME HERE TO DECODE A HALFWORD INSTRUCTION THAT CAUSED         0660.000
*        AN EXCEPTION TRAP. ALL WILL HAVE AN OPCODE OF X'38'.           0661.000
*        THE LAST NIBBLE WILL BE USED TO DECODE WHAT KIND OF            0662.000
*        INSTRUCTION IT IS.                                             0663.000
*                                                                       0664.000
*        FOR ADA TASKS ONLY, THE OPCODE IS CHECKED TO SEE IF IT EADA-33 0665.000
*        IS AN ABR,SLA , SLAD, TRN, OR TRNM. THE FAMILY PART OF EADA-33 0666.000
*        EACH OPCODE IS CHECKED AS THE OTHER MEMBERS OF EACH    EADA-33 0667.000
*        FAMILY CANNOT GENERATE EXCEPTIONS.                     EADA-33 0668.000
*                                                               EADA-33 0669.000
IP0F.20  EQU       $                                                    0670.000
         STCW      R6,EXCP.ADR,R1  SAVE ADDRESS OF INSTRUCTION  EOUT-35 0671.000
         TRR       R6,R2           PUT INTO AN INDEX REGISTER       32000672.000
         LCH       R2,0W,R2        GET THE INSTRUCTION          EOUT~35 0673.000
         STCW      R2,INSTSAV,R1   SAV IN FRAME STORE           EOUT~35 0674.000
         LW        R4,=X'FC00'     GET THE OPCODE MASK                  0675.000
         LCW       R5,FLAGS,X1     GET FLAG WORD                EOUT-35 0676.000
         TBR       R5,ADA          IS IT ADA?                   EOUT-35 0677.000
         BNS       IP0F.22         NO SO AVOID SPECIAL ADA TESTSEADA-33 0678.000
         TRRM      R2,R3           GET THE OPCODE               EADA-33 0679.000
         CI        R3,X'1800'      IS IT A ABR ?                EADA-33 0680.000
         BEQ       IP0F.15         BR IF YES                    EADA-33 0681.000
         CI        R3,X'1C00'      IS IT A SLA/SLAD  ?          EADA-33 0682.000
         BEQ       IP0F.15         BR IF YES                    EADA-33 0683.000
         CI        R3,X'2C00'      IS IT A TRN/TRNM ?           EADA-33 0684.000
         BEQ       IP0F.15         BR IF YES                    EADA-33 0685.000
IP0F.22  CMMW      R2,=X'3800'     IS IT A POSSIBLE?    3200    EADA-33 0686.000
*        BNE       ADACHK     NO, REPORT ONLY TO ADA OR S850700 E2RIS35C0687.000
*        BNE       REPORT          IF NOT, CHECK FOR BAS HANDLR S850700 0688.000
         BNE       IP0F.25         IF NOT, GO CHECK OTHER TABLE E2RIS35C0689.000
         LI        R4,X'F'         GET NIBBLE MASK                      0690.000
         TRRM      R2,R3           AND GET LOW 4 BITS OF INST       32000691.000
         SLL       R3,2            WORD ADJUST                      32000692.000
         SLL       R2,16           MOVE TO LEFT HALF OF REG FOR FIX 33200693.000
         BU       *HW.TAB,R3       JUMP TO PROPER ROUTINE           32000694.000
*                                                                       0695.000
*        THIS TABLE HAS THE ADDRESSES OF THE CODE TO HANDLE EACH TYPE   0696.000
*        OF HALFWORD INSTRUCTION.                                       0697.000
*                                                                       0698.000
HW.TAB   ACH       ADACHK          3800 - ADR OR DVR (BR) - DC          0699.000
         ACH       HW.MAS.W        3801 - ADRFW                         0700.000
         ACH       ADACHK          3802 - MPR - DC                      0701.000
         ACH       HW.MAS.W        3803 - SURFW                         0702.000
         ACH       HW.DIV.W        3804 - DVRFW                         0703.000
         ACH       ADACHK          3805 - FIXW - DC                     0704.000
         ACH       HW.MAS.W        3806 - MPRFW                     300E0705.000
         ACH       ADACHK          3807 - FLTW - DC                     0706.000
         ACH       ADACHK          3808 - ADRM - DC                     0707.000
         ACH       HW.MAS.D        3809 - ADRFD                         0708.000
         ACH       ADACHK          380A - UNDEFINED                     0709.000
         ACH       HW.MAS.D        380B - SURFD                         0710.000
         ACH       HW.DIV.D        380C - DVRFD                         0711.000
         ACH       ADACHK          380D - FIXD - DC                     0712.000
         ACH       HW.MAS.D        380E - MPRFD                         0713.000
         ACH       ADACHK          380F - FLTD - DC                     0714.000
*                                                                       0715.000
IP0F.25  CEQU      $                                            E2RIS35C0716.000
         LI        R3,-TAB2.LEN    GET NEGATIVE LENGTH OF TABLE E2RIS35C0717.000
IP0F.27  CEQU      $                                            E2RIS35C0718.000
         LH        R4,HW.TAB2+TAB2.LEN+TAB2.MSK,X3   GET MASK   E2RIS35C0719.000
         ANR       R2,R4           MASK INSTRUCTION CAUSING AE  E2RIS35C0720.000
         CAMH      R4,HW.TAB2+TAB2.LEN+TAB2.OPC,X3   COMP OPC'S E2RIS35C0721.000
         BNE       IP0F.28         THEY'RE NOT EQUAL            E2RIS35C0722.000
         BU        *HW.TAB2+TAB2.LEN+TAB2.BU,X3    GOTO ROUTINE E2RIS35C0723.000
IP0F.28  CEQU      $                                            E2RIS35C0724.000
         BID       R3,IP0F.27      GO THRU REST OF TABLE        E2RIS35C0725.000
         BU        ADACHK          NO MATCH, MUST BE INTEGER AE E2RIS35C0726.000
*                                                               E2RIS35C0727.000
*        RISC HALFWORD INSTRUCTIONS                             E2RIS35C0728.000
*                                                               E2RIS35C0729.000
         BOUND     1W                                           E2RIS35C0730.000
HW.TAB2  DEQU      $                                            E2RIS35C0731.000
         DATAH     X'0805',MASK1   ATFW                         E2RIS35C0732.000
         ACH       ADACHK                                       E2RIS35C0733.000
         DATAH     X'0806',MASK1   ATFD                         E2RIS35C0734.000
         ACH       ADACHK                                       E2RIS35C0735.000
         DATAH     X'0803',MASK1   MTFW                         E2RIS35C0736.000
         ACH       ADACHK                                       E2RIS35C0737.000
         DATAH     X'0804',MASK1   MTFD                         E2RIS35C0738.000
         ACH       ADACHK                                       E2RIS35C0739.000
         DATAH     X'280D',MASK2   TFWR                         E2RIS35C0740.000
         ACH       ADACHK                                       E2RIS35C0741.000
         DATAH     X'280F',MASK2   TFDR                         E2RIS35C0742.000
         ACH       ADACHK                                       E2RIS35C0743.000
         DATAH     X'290D',MASK2   TSPR                         E2RIS35C0744.000
         ACH       ADACHK                                       E2RIS35C0745.000
         DATAH     X'290F',MASK2   TDPR                         E2RIS35C0746.000
         ACH       ADACHK                                       E2RIS35C0747.000
         DATAH     X'2A0D',MASK2   TSFR                         E2RIS35C0748.000
         ACH       ADACHK                                       E2RIS35C0749.000
         DATAH     X'2A0F',MASK2   TDFR                         E2RIS35C0750.000
         ACH       ADACHK                                       E2RIS35C0751.000
TAB2.LEN DEQU      $-HW.TAB2                                    E2RIS35C0752.000
TAB2.OPC EQU       0W              OPCODE (HW) IN HW.TAB2       E2RIS35C0753.000
TAB2.MSK EQU       1H              MASK (HW) IN HW.TAB2         E2RIS35C0754.000
TAB2.BU  EQU       1W              ADDRESS TO BRANCH TO         E2RIS35C0755.000
MASK1    EQU       X'FC0F'         OPCODE MASK1                 E2RIS35C0756.000
MASK2    EQU       X'FF8F'         OPCODE MASK2                 E2RIS35C0757.000
*                                                                  32C020758.000
*        DO REG-REG MULTIPLY, ADD, AND SUBTRACTS HERE              32C020759.000
*                                                                  32C020760.000
HW.MAS.D SBR       R2,30           SET DW FLAG FOR FIXUP  3200     32C020761.000
HW.MAS.W BL        FIXUP           GO FIX THE REGISTER(S)          32C020762.000
         BU        REPORT          AND REPORT IT                   32C020763.000
*                                                                       0764.000
*        DO REG-REG DIVIDES HERE                                        0765.000
*                                                                       0766.000
HW.DIV.D SBR       R2,30           SET THIS BIT SO FIXUP WILL DO DOU32000767.000
HW.DIV.W BL        FIXUP           GO FIX USER REG(S)                   0768.000
         SRL       R2,16           REJUSTIFY R2 AFTER FIXUP         32000769.000
         LCW       R5,FLAGS,X1     GET FLAG WORD                EOUT-35 0770.000
         TBR       R5,BR.HNDLR     IS IT A BASE TASK W/HANDLER  EOUT-35 0771.000
IPF.NOP4 BS        IPF.B004          YES, BRANCH TO OVERLAY AREA    33000772.000
         BU        EXIT            IF NOT, DON'T LOOK FOR ZERO DIVID33000773.000
         TITLE H.IP0F REGISTER FIXUP SUBROUTINE                         0774.000
**********************************************************************  0775.000
*                                                                       0776.000
*        THIS SUBROUTINE WILL DECODE THE INPUT INSTRUCTION (R2)         0777.000
*        TO DETERMINE THE DESTINATION REGISTER AND, USING THE           0778.000
*        CONDITION CODES, FIX UP THE REGISTER. IF THE INPUT             0779.000
*        IS A HALFWORD INSTR., IT MUST BE IN THE LEFT HALF              0780.000
*        OF R2. THIS ASSURES THE DESTINATION REGISTER WILL              0781.000
*        BE SPECIFIED BY BITS 6-9.                                      0782.000
*                                                                       0783.000
**********************************************************************  0784.000
*                                                                       0785.000
FIXUP    EQU       $                                                    0786.000
         TBM       C.RISC,C.CONF1  RISC MACHINE (RSX)?          E3IEE35A0787.000
         BNS       IP0F.100        NO, SO SKIP                  E3IEE35A0788.000
         LCW       R5,AL.ST2,X1    GET FLOATING POINT STATUS    E3IEE35A0789.000
         ANMW      R5,=X'0000000F' PRESERVE LAST NIBBLE         E3IEE35A0790.000
         CI        R5,FPS.EX64     EXCESS 64 AE OCCURRED?       E3IEE35A0791.000
         BNE       IP0F.130        NO, SO JUST RETURN           E3IEE35A0792.000
IP0F.100 CEQU      $                                            E3IEE35A0793.000
         LCB       R5,PSD.OLD,R1   GET OLD PSD IN R5            EOUT-35 0794.000
         ANMB      R5,=X'18'       R5=INDEX FOR OV VALUE        EOUT-35 0795.000
         SRL       R5,3            RIGHT JUSTIFY FOR USE IN STATUS C32000796.000
         STCB      R5,EXSTAT+3B,R1 STORE IN ARG LIST            EOUT-35 0797.000
         SLL       R5,3            RESTORE TO SAME POSITION         32000798.000
         LW        R4,=X'3800000'   MASK FOR REC REG                    0799.000
         TRRM      R2,R3           R3 CONTAINS REC REG              33200800.000
         SRL       R3,21           ADJUST R3 FOR INDEX                  0801.000
         TRR       R3,R4           COPY REG INDEX                       0802.000
         SRL       R4,2            DIVIDE BY 4                          0803.000
         STCW      R4,FIXREG,R1    SAVE FIXED REG VAL IN ARGLST EOUT-35 0804.000
         TBR       R2,30           TEST FOR DBL PRECISION           32000805.000
         BS        IP0F.150        BRANCH IF DBL PRECISION              0806.000
         SRL       R5,1            ADJ R2 FOR WORD INDEX            32000807.000
         XCR       R5,R3           NEED R3 AS INDEX                 32000808.000
         LW        R4,SINGLE,R3    GET SINGLE OV VALUE              32000809.000
         XCR       R5,R3           GET R3 BACK AGAIN                32000810.000
* CAUTION:!!IF!NONBASE!TASK,!ADDRESS!IN!REGSAV!IS!LOCALCP11787A!S910723!0811.000
* IF!BASE/ADA!TASK,!ADDRESS!IN!REGSAV!IS!ON!TSA!STACK!(CP11787A!S910723!0812.000
         LCW       R5,REGSAV,X1    GET REG SAVE AREA            EOUT-35 0813.000
         ADR       R5,R3           ADD IN R3                    EOUT-35 0814.000
         STCW      R4,0,X3         STORE IN REC REG             S910723 0815.000
*        STW       R4,0,R3         STORE IN REC REG        3200 CPR111120816.000
*        STCW      R4,0,R3         STORE IN REC REG    CPR11112 CP11787A0817.000
*        IFT       C.MAPOUT,%REIS  DO THIS IF MAPPED O CP11787A S910723 0818.000
*        STW       R2,FIXUPTEM     TEMPORARILY STORE R CP11787A S910723 0819.000
*        LW        R2,C.REGS       GET TSA ADDRESS     CP11787A S910723 0820.000
*        LCW       R2,T.PRNO,X2    GET DQE ADDRESS     CP11787A S910723 0821.000
*        TBM       DQE.BASE,DQE.IPUF,X2  BASE TASK?    CP11787A S910723 0822.000
*        BS        FIX.BA1               YES, SO BRANC CP11787A S910723 0823.000
*        TBM       DQE.ADA,DQE.IPUF,X2   ADA TASK?     CP11787A S910723 0824.000
*        BS        FIX.BA1               YES, SO BRANC CP11787A S910723 0825.000
* NONBASE!TASK'S!REGISTER!SAVE!ADDRESS!(R3)!IS!LOCAL!!!CP11787A!S910723!0826.000
*        STW       R4,0,X3         STORE IN REC REG    CP11787A S910723 0827.000
*        BU        FIX.RES1                            CP11787A S910723 0828.000
* BASE/ADA!TASK'S!REGISTER!SAVE!ADDRESS!(R3)!IS!ON!THE!CP11787A!S910723!0829.000
*IX.BA1  STCW      R4,0,X3         STORE IN REC REG    CP11787A S910723 0830.000
*IX.RES1 LW        R2,FIXUPTEM     RESTORE R2          CP11787A S910723 0831.000
*        GOTO      %CONT                               CP11787A S910723 0832.000
*REIS    ANOP                      DO THIS IF NOT MAPP CP11787A S910723 0833.000
*        STW       R4,0,X3         STORE IN REC REG    CP11787A S910723 0834.000
*CONT    ANOP                                          CP11787A S910723 0835.000
IP0F.130 CEQU      $                                            E3IEE35A0836.000
         TRSW      R0              RETURN                               0837.000
IP0F.150 EQU       $                                                    0838.000
         TRR       R5,R2           NEED R2 AS INDEX                 32000839.000
         LD        R4,DOUBLE,R2    GET DOUBLE OV VALUE              32000840.000
         ZBR       R3,29           INSURE DOUBLE WORD BOUNDARY          0841.000
*        LCW       R5,REGSAV,X1    GET REG SAVE AREA    EOUT-35 CPR111120842.000
* CAUTION:!!IF!NONBASE!TASK,!ADDRESS!IN!REGSAV!IS!LOCAL!(PHYS)!!CP11787A0843.000
* IF!BASE/ADA!TASK,!ADDRESS!IN!REGSAV!IS!ON!TSA!STACK!(LOGICAL)!CP11787A0844.000
         LCW       R2,REGSAV,X1    GET REG SAVE AREA            CPR111120845.000
         ADR       R2,R3           ADD IN R3                    CPR111120846.000
*        STD       R4,0,R3         STORE IN REC REG        3200 CPR111120847.000
*        STCD      R4,0,R3         STORE IN REC REG    CPR11112 CP11787A0848.000
*        IFT       C.MAPOUT,%REIS  DO THIS IF MAPPED O CP11787A S910723 0849.000
*        STW       R2,FIXUPTEM     TEMPORARILY STORE R CP11787A S910723 0850.000
*        LW        R2,C.REGS       GET TSA ADDRESS     CP11787A S910723 0851.000
*        LCW       R2,T.PRNO,X2    GET DQE ADDRESS     CP11787A S910723 0852.000
*        TBM       DQE.BASE,DQE.IPUF,X2  BASE TASK?    CP11787A S910723 0853.000
*        BS        FIX.BA2               YES, SO BRANC CP11787A S910723 0854.000
*        TBM       DQE.ADA,DQE.IPUF,X2   ADA TASK?     CP11787A S910723 0855.000
*        BS        FIX.BA2               YES, SO BRANC CP11787A S910723 0856.000
* NONBASE!TASK'S!REGISTER!SAVE!ADDRESS!(R3)!IS!LOCAL!!!CP11787A!S910723!0857.000
*        STD       R4,0,X3         STORE IN REC REG    CP11787A S910723 0858.000
*        BU        FIX.RES2                            CP11787A S910723 0859.000
* BASE/ADA!TASK'S!REGISTER!SAVE!ADDRESS!(R3)!IS!ON!THE!CP11787A!S910723!0860.000
*IX.BA2  STCD      R4,0,X3         STORE IN REC REG    CP11787A S910723 0861.000
*IX.RES2 LW        R2,FIXUPTEM     RESTORE R2          CP11787A S910723 0862.000
*        GOTO      %CONT                               CP11787A S910723 0863.000
*REIS    ANOP                      DO THIS IF NOT MAPP CP11787A S910723 0864.000
*        STD       R4,0,X3         STORE IN REC REG    CP11787A S910723 0865.000
*CONT    ANOP                                          CP11787A S910723 0866.000
         STCD      R4,0,X3         STORE IN REC REG             S910723 0867.000
         LCW       R2,INSTSAV,R1   RESTORE INSTRUCTION IN R2    EOUT-35 0868.000
         TRSW      R0              RETURN TO CALLED                     0869.000
         TITLE H.IP0F REGISTER FIXUP DATA DEFINITIONS                   0870.000
*                                                                       0871.000
************************************************************************0872.000
*        DATA FOR FIXUP ROUTINE                                         0873.000
*                                                                       0874.000
*        ONE OF THE FOLLOWING VALUES IS SELECTED BY USING CONDITION     0875.000
*        CODE BITS 3 AND 4, SHIFTED TO WORD OR DOUBLEWORD INDEX         0876.000
*        AS APPROPRIATE, TO SELECT ONE OF THE FOUR POSSIBLE VALUES.     0877.000
*        IN THE CASE OF AN UNDERFLOW, THE DESTINATION REGISTER(S)       0878.000
*        WILL BE ZEROED. THIS IS TRUE FOR BOTH POSITIVE AND NEGATIVE    0879.000
*        UNDERFLOW. FOR POSITIVE OVERFLOW, THE LARGEST POSITIVE         0880.000
*        NUMBER WILL BE PLACED IN THE REGISTER. THIS NUMBER IS          0881.000
*        7F...F . FOR OVERFLOWS WITH NEGATIVE FRACTIONS, THE LARGEST    0882.000
*        NEGATIVE NUMBER, 80...01, WILL BE PLACED IN THE REGISTER(S).   0883.000
*                                                                       0884.000
************************************************************************0885.000
*                                                                       0886.000
SINGLE   DATAW     X'0',X'7FFFFFFF'                                     0887.000
         DATAW     X'0',X'80000001'                                     0888.000
DOUBLE   DATAD     X'0',X'7FFFFFFFFFFFFFFF'                             0889.000
         DATAD     X'0',X'8000000000000001'                             0890.000
         TITLE H.IP0F REPORT EXCEPTION TO BASE REGISTER TASK            0891.000
*********************************************************************** 0892.000
*                                                                       0893.000
*        THIS ROUTINE WILL DETERMINE IF THE EXCEPTION OCCURED           0894.000
*        WITHIN A BASED MODE TASK. IF THIS IS THE CASE, AND THE         0895.000
*        TASK HAS AN EXCEPTION HANDLER ESTABLISHED, AN ARGUMENT         0896.000
*        LIST WILL BE CONSTRUCTED AND CONTROL WILL BE PASSED TO         0897.000
*        THE TASK'S HANDLER.                                            0898.000
*                                                                       0899.000
*********************************************************************** 0900.000
*                                                                       0901.000
REPORT   EQU       $                                                    0902.000
         LCW       R5,FLAGS,X1     GET FLAGS WORD               EOUT-35 0903.000
         TBR       R5,BR.HNDLR     BASED TASK W/HANDLER         EOUT-35 0904.000
IPF.NOP5 BS        IPF.B005        CONTINUE IN OVERLAY AREA         33000905.000
EXIT     EQU       $                                                    0906.000
*                                                                       0907.000
*        DELETE THE EXTRA STACK PUSHES (BASE TASK ONLY)         Q044-33 0908.000
*                                                                       0909.000
*        BEI                       NO INTERRUPTS FOR A WHILE            0910.000
         LCW       R3,ADTSA,R1     GET TSA ADDRESS              EOUT-35 0911.000
*        LCB       R5,T.BIT2,X3    GET T.BIT2           EOUT-35 E2RIS35B0912.000
*        TBR       R5,T.BASE+24    BASE TASK??          EOUT-35 E2RIS35B0913.000
*        BNS       $+4W            NO...SKIP BR STACK U EOUT-35 E2RIS35B0914.000
*        NOTE: GPR STACK POINTER ALREADY DOWN ONE LEVEL         EBRG-33 0915.000
*        LCW       R7,T.MPXBR+3W,X3  GET BR STACK POINT EOUT-35 E2RIS35B0916.000
*        SUI       R7,16W          DECREMENT BY TWO LEV EOUT-35 E2RIS35B0917.000
*        STCW      R7,T.MPXBR+3W,X3  AND RESTORE        EOUT-35 E2RIS35B0918.000
         LCW       R5,T.BIT5,X3    GET T.BIT5                   EOUT-35 0919.000
         ZBR       R5,T.NOEXCP     CLE NO EXCP HNDLR            EOUT-35 0920.000
         STCW      R5,T.BIT5,X3    RESTORE T.BIT5               EOUT-35 0921.000
*        IFF       C.MPXOUT,%MAPOUT                     EOUT-35 S910723 0922.000
*        BNS       EXIT.1                               Q044-33 S910723 0923.000
*        TBR       R5,T.CPUAE      IS THIS FROM CPU?    EOUTA35 S910723 0924.000
*        BS        EXIT.1          YES,CAME FROM CPU    EOUTA35 S910723 0925.000
*        LD        R6,PSD.OLD,R1   GET OLD PSD          Q044-33 S910723 0926.000
*        LW        R0,R0SAV,R1     GET RETURN ADDRESS   Q044-33 S910723 0927.000
*        LA        R1,IP0F.REG                                  Q044-33A0928.000
*        LW        R1,REGSAV,X1    GET CORRECT REG STCK Q044-33 S910723 0929.000
*        BU        EXIT.2                               Q044-33 S910723 0930.000
*MAPOUT  ANOP                                           EOUT-35 S910723 0931.000
*XIT.1   EQU       $                                            S910723 0932.000
         TRR       R1,R7           COMPUTE OLD STACK POINTER       32B090933.000
*        SUI       R7,32W          SUBTRACT A LEVEL       32B09 E2RIS35B0934.000
         SUMH      R7,C.FRAME      SUBTRACT A LEVEL             E2RIS35B0935.000
         STCW      R7,T.REGP,R3    STORE OLD STACK POINTER BACK EOUT-35 0936.000
         ADI       R7,T.BROFF      ADD GPR TO BR OFFSET         E2RIS35B0937.000
         STCW      R7,T.MPXBR+3W,X3  MAINTAIN CURR BR STK FRAME E2RIS35B0938.000
         LCD       R6,PSD.OLD,R1   GET OLD PSD                  EOUT-35 0939.000
         LCW       R0,R0SAV,R1     GET RETURN ADDRESS           EOUT-35 0940.000
* CAUTION:!!IF!NONBASE!TASK,!ADDRESS!IN!REGSAV!IS!LOCA!CP11787A!S910723!0941.000
* IF!BASE/ADA!TASK,!ADDRESS!IN!REGSAV!IS!ON!TSA!STACK!!CP11787A!S910723!0942.000
         LCW       R1,REGSAV,R1    GET REGISTER SAVE ADDRESS    EOUT-35 0943.000
*XIT.2   EQU       $                                    Q044-33 S910723 0944.000
         LCB       R5,T.BIT4,X3    GET T.BIT4                   EOUT-35 0945.000
         ZBR       R5,T.ARTECP+24  CLE NO ARITHEXCP IN PROG     EOUT-35 0946.000
         STCB      R5,T.BIT4,X3    RESTORE T.BIT4               EOUT-35 0947.000
*        LD        R6,PSD.OLD,R1   GET OLD PSD                  Q044-33 0948.000
*        LW        R0,R0SAV,R1     GET RETURN ADDRESS           Q044-33 0949.000
*        LW        R1,REGSAV,R1    GET REGISTER SAVE ADDRESS    Q044-33 0950.000
         TRSW      R0              RETURN TO UNIQUE PROCESSING      32000951.000
         SPACE     3                                                    0952.000
********************************************************************    0953.000
         BOUND     1F                                                   0954.000
IP0F.REG REZ       1F              REG SAVE AREA                        0955.000
TASK.PSD DATAD     0               TASK PSD FOR RETURN                  0956.000
*                                                                       0957.000
*RETINS  DVFW      6,ZERO          IP0F RETURN INSTRUCTION      S860021 0958.000
RETINS   DVI       6,0                                          S860021 0959.000
*ZERO    DATAW     0               ALWAYS ZERO                  S860021 0960.000
ADR.EXR  DATAW     0           HOLDS ADDRESS OF EXR IN H.IP00           0961.000
NONBASE  DATAW     0               NONBASE FLAG WORD            Q044-33 0962.000
*IXUPTEM DATAW     0               TEMP REGISTER USED D CP11787 S910723 0963.000
********************************************************************    0964.000
*                                                                       0965.000
*        ARGUMENT LIST                                                  0966.000
*                                                                       0967.000
*        NOTE:   THIS ARGLIST IS DUPLICATED IN H.IPU.  ANY         32B030968.000
*                CHANGES TO THIS LIST MUST ALSO BE MADE IN H.IPU   32B030969.000
********************************************************************    0970.000
*                                                                       0971.000
         BOUND     1D              DOUBLE WORD BOUND LIST               0972.000
ARGLIST  EQU       $                                                    0973.000
         DATAW     4               NUMBER OF ARGUMENTS                  0974.000
         DATAW     0,0,0,0,0,0,0                                    32000975.000
         DATAH     3,0             DATA TYPE 3 (WORD INTEGER)           0976.000
         DATAH     3,2             WORD INTEGER; 8 BYTES OF ADD DATA    0977.000
         DATAB     1,2,0,0         DOPE VECTOR                     32B010978.000
         DATAW     4               WORD ARRAY                           0979.000
         DATAW     20W             20 WORDS IN LENGTH                   0980.000
         DATAH     3,0             WORD INTEGER                         0981.000
         RES       1W              ADDRESS OF INSTRUCTION CAUSING TRAP  0982.000
EXARRY   DATAW     20              EXCEPTION 20 WORDS                   0983.000
         RES       8W              GPR'S AT TIME OF EXCEPTION       32000984.000
         RES       2W              SAVE AREA FOR THE PSD            32000985.000
         RES       8W              BASE REGISTERS AT TIME OF EXCEPTI32000986.000
         RES       1W              FIXED REG(S)                     32000987.000
         RES       1W              CONDITION CODES                  32000988.000
         GEN       4/1,4/1,8/52,16/0   EXCEPTION STATUS             32000989.000
** END OF ARGUMENT LIST ****************************************** 32B010990.000
         DATAW     0               FILLER (FOR BOUNDING)           32B010991.000
         DATAD     0               OLD PSD SAVE AREA                32000992.000
         REZ       4D              BR REG SAVE AREA                32B030993.000
         DATAW     0               EXCEPTION FLAGS                      0994.000
         DATAW     0               CALL STACK FRAME POINTER             0995.000
         DATAW     ARGLIST+ARG.REGS   ADDR OF REGISTER SAVE AREA   32B080996.000
         DATAW     0               REGISTER 0 SAVE AREA             32000997.000
         DATAW     0               TSA ADDRESS SAVE AREA            32000998.000
         DATAW     ARGLIST+ARG.BREG  ADDRESS OF BASE REGISTERS     32B080999.000
         DATAW     0                INSTRUCTION CAUSING TRAP       32B081000.000
*                                                                       1001.000
*        LITERAL POOL HERE                                              1002.000
*                                                                       1003.000
         LPOOL                                                          1004.000
         TITLE H.IP0F OPTIONAL BASE REGISTER CODE                       1005.000
IPF.OVY  EQU       $               BASE CODE OVERLAY AREA               1006.000
********************************************************************    1007.000
*                                                                       1008.000
*        THIS CODE TESTS FOR A RETURN FROM A BASED MODE TASK (NOT ADA)  1009.000
*        EXCEPTION HANDLER. IN ORDER TO RETURN TO H.IP0F AN EXCEPTION   1010.000
*        IS FORCED WHEN THE HANDLER RETURNS. THE ADDRESS OF THE         1011.000
*        EXCEPTION IS KNOWN, AND IS CHECKED HERE.                       1012.000
*                                                                       1013.000
********************************************************************    1014.000
*                                                                       1015.000
IPF.B001 EQU       $               OPTIONAL BASE CODE               33001016.000
         TRR       R6,R4                                            32001017.000
         ANMW      R4,=X'00FFFFFF' 24 BIT ADDRESS MASK              32001018.000
         CAMW      R4,ADR.EXR      IS THIS A RETURN FROM BASED HDLR 32001019.000
         BEQ       IP0F.900        YES, GO HANDLE IT                    1020.000
         BU        IP0F.EN1        RETURN                           33001021.000
*                                                                       1022.000
********************************************************************    1023.000
*                                                                       1024.000
*        TEST THE ENVIRONMENT FOR A BASED MODE TASK WITH AN             1025.000
*        ARITHMETIC EXCEPTION HANDLER SPECIFIED.                        1026.000
*                                                                       1027.000
********************************************************************    1028.000
*                                                                       1029.000
IPF.B002 EQU       $                                                33001030.000
         LCB       R5,T.BIT4,X3    GET T.BIT4                   EOUT-35 1031.000
         TBR       R5,T.ARTECP+24  ARITH EXCP IN PROG??         EOUT-35 1032.000
         BS        IP0F.01         IF SET THEN DON'T REPORT TO USER     1033.000
         LCW       R5,T.EXCPAD,R3  LOAD THE HANDLER ADDRESS     EOUT-35 1034.000
         BZ        IP0F.01         BRANCH IF NONE                       1035.000
         LCW       R5,FLAGS,X1     GET FLAGS WORD               EOUT-35 1036.000
         SBR       R5,BR.HNDLR     ELSE, SET THE FLAG           EOUT-35 1037.000
         STCW      R5,FLAGS,X1     GET FLAGS WORD               EOUT-35 1038.000
*        STFBR     R0,ARG.BREG,R1    SAVE THE BASE REGS  32B080FEOUT-35 1039.000
*        STFBR     R0,BR.FILE,R1     AND IN THIS AREA TOO 32B08 EOUT-35 1040.000
         M.STFBR   ARG.BREG,X1     SAVE THE BASE REGS AT ARGLST EOUT-35 1041.000
         M.STFBR   BR.FILE,X1      SAVE THE BASE REGS AT BR.FIL EOUT-35 1042.000
         BU        IP0F.01           AND RETURN                     33001043.000
********************************************************************    1044.000
*                                                                       1045.000
*        CHECK A MEMORY REFERENCE INSTRUCTION FOR A ZERO DIVIDE         1046.000
*                                                                       1047.000
********************************************************************    1048.000
*                                                                       1049.000
IPF.B003 EQU       $               OPTIONAL BASE CODE               33001050.000
*                                                                       1051.000
*        ISOLATE THE BASE REGISTER AND ITS CONTENTS FROM THE            1052.000
*        OFFENDING INSTRUCTION.                                         1053.000
*                                                                       1054.000
         ZR        R5              WE WILL COLLECT THE ADDRESS HERE 32001055.000
         TRR       R2,R3           COPY THE INSTRUCTION TO R3       32001056.000
         SLL       R3,13           ISOLATE THE BASE REGISTER       32B0A1057.000
         SRL       R3,29           BY SHIFTING TWICE               32B0A1058.000
         SLL       R3,2            AND WORD OFFSET IT                   1059.000
         TRR       R3,R3           TEST IT FOR ZERO (NO BASE REG)       1060.000
         BZ        IP0F.521        IF NO BASE REG. USED, SKIP           1061.000
         LCW       R5,BRSAV,X1     GET BASE REG OFFSET          EOUT-35 1062.000
         ADR       R5,R3           ADD IT TO R3                 EOUT-35 1063.000
         LCW       R5,0,R3         GET THE BASE REGISTER CONT   EOUT-35 1064.000
*                                                                       1065.000
*        ISOLATE ANY INDEX REGISTER USED AND ADD ITS CONTENTS           1066.000
*        TO THE DIVISOR ADDRESS IN R5                                   1067.000
*                                                                       1068.000
IP0F.521 EQU       $                                                    1069.000
         TRR       R2,R3           GET A COPTY OF THE INSTRUCTION   32001070.000
         SLL       R3,9            AGAIN, SHIFT THE INSTRUCTION    32B0A1071.000
         SRL       R3,29           TWICE TO ISOLATE THE REG        32B0A1072.000
         SLL       R3,2            AND WORD ADJUST IT                   1073.000
         TRR       R3,R3           TEST FOR INDEX=0                     1074.000
         BZ        IP0F.522        BRANCH IF NONE USED                  1075.000
         LCW       R4,REGSAV,X1    GET REG SAVE AREA            EOUT-35 1076.000
         ADR       R4,R3           ADD IT TO R3 TO GET OFFSET   EOUT-35 1077.000
         LCW       R4,0,X3         GET INDEX IF PRES            EOUT-35 1078.000
         ADR       R4,R5           ADD IT TO R5                 EOUT-35 1079.000
*                                                                       1080.000
*        ADD IN THE OFFSET SPECIFIED IN THE INSTRUCTION                 1081.000
*                                                                       1082.000
IP0F.522 EQU       $                                                    1083.000
         TRR       R2,R3           AGAIN COPY THE INSTRUCTION       32001084.000
         SLL       R3,16           SHIFT OF UPPER 16 BIS                1085.000
         SRL       R3,16           AND PUT OFFSET BACK                  1086.000
         ADR       R5,R3           ADD R5 TO 3 TO GET FINAL ADDRESS 32001087.000
*                                                                       1088.000
*        GET THE DIVISOR FROM MEMORY USING THE VALUE JUST BUILT         1089.000
*        IN R3. ALSO CHECK BIT 30 TO DETERMINE WHETHER TO DO            1090.000
*        AN 'LW' OR AN 'LD' ON THE DATA.                                1091.000
*                                                                       1092.000
         ZBR       R3,30           ZERO THE C-BIT                   32001093.000
         BS        IP0F.523        DO AN 'LD' IF IT WAS SET             1094.000
         LCW       R4,0W,R3        ELSE GET THE WORD            EOUT-35 1095.000
         BU        IP0F.524        BRANCH TO TEST (BU DOESN'T           1096.000
*                                  AFFECT THE CONDITION CODES)          1097.000
IP0F.523 LCD       R4,0W,R3        GET THE DOUBLE WORD DIVISOR  EOUT-35 1098.000
IP0F.524 BZ        HW.ZDIV         BRANCH TO COMMON CODE IF ZERO        1099.000
         BU        REPORT          ELSE BRANCH TO REPORT                1100.000
********************************************************************    1101.000
*                                                                       1102.000
*        CHECK A REGISTER-REGISTER INSTRUCTION FOR ZERO DIVIDE          1103.000
*                                                                       1104.000
********************************************************************    1105.000
*                                                                       1106.000
IPF.B004 EQU       $               BASE CODE OVERLAY                33001107.000
*                                                                       1108.000
*        THIS CODE EXAMINES THE SOURCE REGISTER FOR ZERO AND            1109.000
*        SETS A STATUS CODE TO BE SENT TO AN EXCEPTION HANDLER          1110.000
*                                                                       1111.000
         LI        R4,X'70'        SOURCE REG MASK                      1112.000
         TRRM      R2,R3           GET THE REG OUT                  32001113.000
         SRL       R3,2            SHIFT TO BE R(S)*1W              32001114.000
         TBR       R2,28           THIS IS SET IF DOUBLE WORD DIVIDE32001115.000
         BS        HWDIV.10        BRANCH IF SET                        1116.000
         LCW       R4,REGSAV,X1    GET REGSAVE AREA             EOUT-35 1117.000
         ADR       R4,R3           ADD IT TO R3 TO GET OFFSET   EOUT-35 1118.000
         LCW       R4,0,R3         ELSE GET THE DIVISOR         EOUT-35 1119.000
* (C) COPYRIGHT 1989 ENCORE COMPUTER CORPORATION                        1120.000
*     ALL RIGHTS RESERVED                                               1121.000
         BZ        HW.ZDIV         REPORT                               1122.000
         BU        HWDIV.90                                             1123.000
HWDIV.10 ZBR       R3,28           INSURE DOUBLE WORD BOUND         32001124.000
         LCW       R4,REGSAV,X1    GET REGSAVE AREA             EOUT-35 1125.000
         ADR       R4,R3           ADD IT TO R3 TO GET OFFSET   EOUT-35 1126.000
         LCD       R4,0,R3         GET THE DIVISOR              EOUT-35 1127.000
         BNZ       HWDIV.90        NOT ZERO, GO ON                      1128.000
HW.ZDIV  EQU       $               PROCESS ZERO DIVIDE                  1129.000
         LI        R4,4            GET THE STATUS CODE FOR ZERO DIVIDE  1130.000
         STCB      R4,EXSTAT+3B,R1 AND PUT IN ARG LIST          EOUT-35 1131.000
HWDIV.90 BU        REPORT          GO REPORT WHAT WE FOUND              1132.000
*                                                                       1133.000
*        THE FOLLOWING CODE MOVED TO BEFORE LPOOL (NOT OVERLAYED)  32C021134.000
*        DO REG-REG MULTIPLY, ADD, AND SUBTRACTS HERE              32C021135.000
*                                                                  32C021136.000
*W.MAS.D SBR       R2,30           SET DW FLAG FOR FIXUP  3200     32C021137.000
*W.MAS.W BL        FIXUP           GO FIX THE REGISTER(S)          32C021138.000
*        BU        REPORT          AND REPORT IT                   32C021139.000
********************************************************************    1140.000
*                                                                       1141.000
*        BULD THE ARGUMENT LIST TO SEND TO THE TASK                     1142.000
*                                                                       1143.000
********************************************************************    1144.000
*                                                                       1145.000
IPF.B005 EQU       $                                                33001146.000
*                                                                       1147.000
*        SET THE FLAG TO INDICATE EXCEPTION HANDLING IN PROGRESS        1148.000
*                                                                       1149.000
         LCW       R3,ADTSA,R1     TSA ADDRESS                  EOUT-35 1150.000
         LCW       R4,T.EXCPAD,R3  EXCEPTION HANDLER ADDRESS    EOUT-35 1151.000
         BZ        EXIT            NOT REALLY NEEDED, BUT DO IT ANYWAY  1152.000
*                                  TO PREVENT A BRANCH TO ZERO          1153.000
*                                                                       1154.000
IP0FADA1 BU        IP0F.240        H.ADA WILL NOP THIS INSTRUCTION 32B021155.000
*        LW        R2,C.REGS       GET TSA ADDRESS        32B09 S910723 1156.000
*        LCW       R2,T.PRNO,R2    GET DQE ADDRESS      EOUT-35 S910723 1157.000
         LCW       R2,T.PRNO,X3    GET DQE ADDRESS              S910723 1158.000
         TBM       DQE.ADA,DQE.IPUF,R2  ADA TASK?                  32B021159.000
         BNS       IP0F.240        NO, CONTINUE                    32B021160.000
IP0FADA2 BU        IP0F.240        H.ADA REPLACES WITH BL  S.ADA2  32B021161.000
*                                  NO RETURN FROM S.ADA2           32B021162.000
IP0F.240 EQU       $                                               32B021163.000
*                                                                       1164.000
         LCB       R5,T.BIT4,X3    GET T.BIT4                   EOUT-35 1165.000
         SBR       R5,T.ARTECP+24  SET ARITH EXCEP. IN PROG     EOUT-35 1166.000
         STCB      R5,T.BIT4,X3    RESTORE T.BIT4               EOUT-35 1167.000
*                                                                       1168.000
*        BUILD THE ARG LIST TO GO TO THE HANDLER                        1169.000
*                                                                       1170.000
*                  CC'C                                                 1171.000
*                                                                       1172.000
         TRR       R6,R5           PSW AT TIME OF TRAP              32001173.000
         SLL       R5,1            DROP OFF PRIV. BIT                   1174.000
         SRL       R5,28           RIGHT JUSTIFY CC'S                   1175.000
         STCW      R5,CONDCOD,R1   SAVE IN ARG LIST             EOUT-35 1176.000
*                                                                       1177.000
*                  ALLOCATE STACK SPACE                                 1178.000
*                                                                       1179.000
*        STFBR     R0,BR.FILE,R1   GET BASE REG LOCOAL MEM 3200 EOUT-35 1180.000
         M.STFBR   BR.FILE,X1      SAVE THE BASE LOCAL MEM      EOUT-35 1181.000
         LCW       R2,BR.FILE+2W,R1 B2                          EOUT-35 1182.000
         SUI       R2,ARULEN       MINUS ARG LIST LENGTH                1183.000
         STCW      R2,BR.FILE+2W,R1 ALLOCATE THE STACK SPACE    EOUT-35 1184.000
         STCW      R2,FRMPNT,R1    SAVE IN LOCAL TO SET UP ARG  EOUT-35 1185.000
         STCW      R2,T.AESTKP,R3  TSA ALSO FOR HANDLER RETURN  EOUT-35 1186.000
*                                                                       1187.000
*        TAKE ADVANTAGE OF BR'S TO MOVE GPR'S TO ARG LIST               1188.000
*                                                                       1189.000
         LCW       R3,REGSAV,R1    GET REG SAVE ADDRESS         EOUT-35 1190.000
         M.LFBR    0W,X3           GETALL GPRS                  EOUT-35 1191.000
         M.STFBR   ARG.REGS,X1     AND SAV THEM IN ARG LIST     EOUT-35 1192.000
*        STFBR     R0,ARG.REGS,R1  AND SAVE THEM ARGLIST 3200   EOUT-35 1193.000
*                                                                       1194.000
*        NOW RELOAD THE CORRECT BASE REGS                               1195.000
*                                                                       1196.000
         M.LFBR    BR.FILE,X1      RELOAD THE BASE REGS         EOUT-35 1197.000
*        STFBR     R0,ARG.BREG,R1  AND PUT THEM IN THE ARG LIST TOO 32001198.000
*                                                                       1199.000
*        PUT POINTERS INTO ARG LIST                                     1200.000
*                                                                       1201.000
         TRR       R2,R7           COPY ARG LIST BASE ADDRESS           1202.000
         ADI       R7,5W           GET ADDRESS OF DESCRIPTOR VECTOR     1203.000
         STCW      R7,DES.PTR,R1   PUT IN ARG LIST              EOUT-35 1204.000
         ADI       R7,3W           GET ADDRESS OF ADR DESCRIPTOR        1205.000
         STCW      R7,ADR.DPTR,R1  STORE IN ADR DESCRIPTOR PTR  EOUT-35 1206.000
         ADI       R7,1W           ADDR. OF ARRAY DESCRIPTOR            1207.000
         STCW      R7,ARY.DPTR,R1  ARRAY DESC. POINTER          EOUT-35 1208.000
         ADI       R7,3W           ADDR. OF STATUS DESC.                1209.000
         STCW      R7,STA.DPTR,R1  STATUS DESC. POINTER         EOUT-35 1210.000
         ADI       R7,1W           GET PSD POINTER                      1211.000
         STCW      R7,ADR.PTR,R1   ADR POINTER                  EOUT-35 1212.000
         ADI       R7,1W           GET ARRAY ADDRESS                    1213.000
         STCW      R7,ARY.PTR,R1   ARRAY POINTER                EOUT-35 1214.000
         ADI       R7,21W          GET STATUS ADDRESS                   1215.000
         STCW      R7,STA.PTR,R1   STATUS POINTER               EOUT-35 1216.000
*                                                                       1217.000
*        PUT OLD PSD IN ARG LIST                                        1218.000
*                                                                       1219.000
*        LW        R6,IP0F.OLD     GET THE OLD PSD                  32001220.000
         STCW      R6,EXCP.PSD,R1  AND TO THE LIST              EOUT-35 1221.000
         LCW       R6,PSD.OLD+1W,R1 GET OLD PSD2                EOUT-35 1222.000
         STCW      R6,EXCP.PSD+1W,R1 AND ADD TO LIST            EOUT-35 1223.000
*                                                                       1224.000
*        BUMP STATUS BYTE BY ONE TO AVOID ZERO STATUS CODE              1225.000
*                                                                       1226.000
         LCW       R7,EXSTAT,X1    GET EXSTAT                   EOUT-35 1227.000
         ABR       R7,31           BUMP IT BY ONE               EOUT-35 1228.000
         STCW      R7,EXSTAT,X1    RESTORE EXSTAT               EOUT-35 1229.000
*                                                                       1230.000
*                  MOVE ARG LIST TO STACK                               1231.000
*                                                                       1232.000
         LI        R7,-ARULEN      ARGUMENT LIST LENGTH                 1233.000
*        LA        R1,ARGLIST      ARGUMENT LIST ADDRESS            33201234.000
IP0F.250 EQU       $                                                    1235.000
         LCW       R4,0,R1         GET WORD                     EOUT-35 1236.000
         STCW      R4,0,R2         STORE  IN CALL FRAME         EOUT-35 1237.000
         ABR       R1,29                                                1238.000
         ABR       R2,29                                                1239.000
         BIW       R7,IP0F.250     LOOP TILL ALL MOVED                  1240.000
         SUI       R1,ARULEN       RESTORE R1                       32001241.000
*                                                                       1242.000
*                  SAVE OLD PSD ON STACK AND FREE STACK SPACE           1243.000
*                                                                       1244.000
*        BEI                       NO INTERRUPTS FOR A WHILE            1245.000
         LCW       R3,ADTSA,R1     GET TSA ADDRESS              EOUT-35 1246.000
*        NOTE: GPR STACK POINTER ALREADY DOWN ONE LEVEL         EBRG-33 1247.000
*        LCB       R7,T.BIT2,X3    GET T.BIT2           EOUT-35 E2RIS35B1248.000
*        TBR       R7,T.BASE+24    BASE TASK??          EOUT-35 E2RIS35B1249.000
*        BNS       $+4W            NO...SKIP BR STACK U EBRGB00 E2RIS35B1250.000
*        LCW       R7,T.MPXBR+3W,X3  GET BR STACK POINT EOUT-35 E2RIS35B1251.000
*        SUI       R7,16W          DECREMENT BY TWO LEV EBRG-33 E2RIS35B1252.000
*        STCW      R7,T.MPXBR+3W,X3  AND RESTORE        EOUT-35 E2RIS35B1253.000
         TRR       R1,R7           COMPUTE OLD STACK POINTER       32B091254.000
*        SUI       R7,32W          BACK OUT ONE LEVEL     32B09 E2RIS35B1255.000
         SUMH      R7,C.FRAME      BACK OUT ONE LEVEL           E2RIS35B1256.000
         STCW      R7,T.REGP,R3    PUT BACK T.REGP              EOUT-35 1257.000
         ADI       R7,T.BROFF      ADD GPR TO BR OFFSET         E2RIS35B1258.000
         STCW      R7,T.MPXBR+3W,X3  MAINTAIN CURR BR STK FRAME E2RIS35B1259.000
         LCD       R6,PSD.OLD,R1   GET OLD PSD                  EOUT-35 1260.000
         STCD      R6,T.EXPSD,R3   SAVE IT IN THE TSA           EOUT-35 1261.000
*                                                                       1262.000
*                  SET UP R4 AND R7 AND GO TO HANDLER                   1263.000
*                                                                       1264.000
         LW        R7,RETINS       IP0F RETURN INSTRUCTION              1265.000
         LCW       R5,T.EXCPAD,R3  GET DESTINATION ADDRESS      EOUT-35 1266.000
         LCB       R4,PSD.OLD,R1   GET PRIV ETC FROM OLD PSD    EOUT-35 1267.000
         STB       R4,IP0F.PSD     SAVE IN NEW PSD                  32001268.000
         LCW       R4,FRMPNT,R1    ARGUMENT LIST                EOUT-35 1269.000
         LCW       R2,T.BIT5,X3    GET T.BIT5                   EOUT-35 1270.000
         TBR       R2,T.CPUAE      CPU TASK??                   EOUT-35 1271.000
         BNS       IP.COMM                                      S860833 1272.000
*!!!!!!!!!!UEI!!!!!!!!!!!!!!!!!!!!!!!RETURN!TO!USER!UNBLOCKED!!E1BLK35!!1273.000
         M.IONN                  UNBLOCK EXTERNAL INTS.        E1BLK35  1274.000
IP.COMM  EQU       $                                            S860833 1275.000
*!!!!!!!!!!LPSD!!!!!!IP0F.PSD!!!!!!!!GO!BASED!!!!!!!!!!!EOUT~35!E1BLK35!1276.000
         M.LPSD    IP0F.PSD        GO BASED             EOUT~35 E1BLK35 1277.000
*                                                                       1278.000
IP0F.PSD M.PSDGEN  BR.DISP2,BAS,UEI                             EOUT-35 1279.000
*IP0F.PSD GEN       8/0,24/W(IP0F.DIS)                          S860021 1280.000
*P0F.PSD GEN       8/0,24/W(BR.DISP2)          S860021          EOUT-35 1281.000
*        GEN       1/1,15/1,16/0   MAPPED, RETAIN OLD MAP 3200  EOUT-35 1282.000
*IP0F.DIS BL        BR.DISP2        CALL                   32B06S860021 1283.000
         TITLE H.IP0F HANDLER RETURN CLEAN UP SUBROUTINE                1284.000
*                                                                       1285.000
*        THIS IS WHERE CONTROL COMES WHEN RETURNING FROM A BASE         1286.000
*        REGISTER TASKS ARITHMETIC EXCEPTION HANDLER. SEE THE           1287.000
*        BEGINNING OF THIS LISTING FOR A DISCUSSION OF THE              1288.000
*        MECHANISMS FOR PASSING CONTROL TO AND RETURNING FROM           1289.000
*        THE TASKS EXCEPTION HANDLER.                                   1290.000
*                                                                       1291.000
*                                                                       1292.000
IP0F.900 EQU       $                                                    1293.000
*        BEI                       RESTORE BLOCKED STATE            32001294.000
*                                                                       1295.000
*        PROCESS THE RETURN                                             1296.000
*                                                                       1297.000
         LCW       R4,T.BIT5,X3    GET T.BIT5                   EOUT-35 1298.000
         TBR       R4,T.CPUAE      CPU TASK??                   EOUT-35 1299.000
         BNS       IP0F.901        DON'T BLOCK IN IPU           S860833 1300.000
*!!!!!!!!!!BEI!!!!!!!!!!!!!!!!!!!!!!!BLOCK!EXT!INTS!IN!CPU!!!!!E1BLK35!!1301.000
         M.IOFF                    BLOCK EXTERNAL INTS.        E1BLK35  1302.000
IP0F.901 EQU       $                                            S860833 1303.000
*        THIS ENTRY IS FROM A DVI BY 0 (EXE R7) IN H.IP00 UPON  Q241A34 1304.000
*        RETURN FROM THE TASKS EXCEPTION HANDLER.               Q241A34 1305.000
*        THE FOLLOWING STORE FILE BASE REGISTER IS ONLY DONE    Q241A34 1306.000
*        TO GET B2 INTO R4 SO WE CAN ADJUST IT PROPERLY.  GCL   Q241A34 1307.000
*        TASKS BASE REGISTERS ON RETURN FROM H.IP00 ARE NOT THE Q241A34 1308.000
*        SAME AS THOSE WHEN THE EXCEPTION OCCURRED.  WE ARE     Q241A34 1309.000
*        RETURNING TO TASK WITH BASE REGISTERS LOADED FROM THE  Q241A34 1310.000
*        ARGUMENT LIST.  ITS POINTER (B2) IS SAVED IN T.AESTKP  Q241A34 1311.000
*        DURING IPF.B005 PROCESSING.                            Q241A34 1312.000
*        STFBR     0,BR.FILE,R1    BASE REGS        3200        EGCFO34 1313.000
*        LW        R4,BR.FILE+2W,R1 B2                 3200     Q241A34 1314.000
         LCW       R4,T.AESTKP,R3   GET SAVED B2                EOUT-35 1315.000
         TRR       R4,R2           SAVE A COPY                      32001316.000
         ADI       R4,ARULEN       RESET STACK POINTER              32001317.000
*        STW       R4,BR.FILE+2W,R1 AND PUT INTO SAVE AREA 3200 Q241-34 1318.000
         STCW      R4,ARG.BREG+2W,R2 AND PUT INTO SAVE AREA     EOUT-35 1319.000
         LCW       R3,ADTSA,R1     GET TSA ADDRESS              EOUT-35 1320.000
*        NOTE: GPR STACK POINTER ALREADY DOWN ONE LEVEL         EBRG-33 1321.000
*        LCB       R7,T.BIT2,X3    GET T.BIT2           EOUT-35 E2RIS35B1322.000
*        TBR       R7,T.BASE+24    BASE TASK??          EOUT-35 E2RIS35B1323.000
*        BNS       $+4W            NO...SKIP BR STACK U EBRGB00 E2RIS35B1324.000
*        LCW       R7,T.MPXBR+3W,X3  GET BR STACK POINT EOUT-35 E2RIS35B1325.000
*        SUI       R7,16W          DECREMENT BY TWO LEV EBRG-33 E2RIS35B1326.000
*        STCW      R7,T.MPXBR+3W,X3  AND RESTORE        EOUT-35 E2RIS35B1327.000
         TRR       R1,R7           COMPUTE STACK POINTER           32B091328.000
*        SUI       R7,32W          SUBTRACT ONE PUSH LEVE 32B09 E2RIS35B1329.000
         SUMH      R7,C.FRAME      SUBTRACT ONE PUSH LEVEL      E2RIS35B1330.000
         STCW      R7,T.REGP,R3    STORE IN TSA                 EOUT-35 1331.000
         ADI       R7,T.BROFF      ADD GPR TO BR OFFSET         E2RIS35B1332.000
         STCW      R7,T.MPXBR+3W,X3  MAINTAIN CURR BR STK FRAME E2RIS35B1333.000
*        LCB       R6,T.BIT4,X1    GET T.BIT4           EOUT-35 CPR111121334.000
         LCB       R6,T.BIT4,X3    GET T.BIT4                   CPR111121335.000
         ZBR       R6,T.ARTECP+24  RESET IN PROG FLAG           EOUT-35 1336.000
*        STCB      R6,T.BIT4,X1    RESTORE T.BIT4       EOUT-35 CPR111121337.000
         STCB      R6,T.BIT4,X3    RESTORE T.BIT4               CPR111121338.000
         LCD       R6,T.EXPSD,R3     GET SAVED OLD PSD FROM TSA EOUT-35 1339.000
         STCD      R6,PSD.OLD,R1     SAVE IN NORMAL SPOT        EOUT-35 1340.000
         M.LFBR    ARG.BREG,X2     RELOAD THE BASE REGS         EOUT-35 1341.000
*        LFBR      R0,BR.FILE,R1   RELOAD BASE REGISTERS  3200  Q241-34 1342.000
         LCW       R0,R0SAV,R1     GET RETURN ADDRESS           EOUT-35 1343.000
         LA        R1,ARG.REGS,R2  GET THE REGS ADDRESS          32C04  1344.000
         TRSW      R0              RETURN TO UNIQUE PROCESSING      32001345.000
         TITLE H.IP0F SYSGEN INITIALIZATION ENTRY POINT                 1346.000
*                                                                       1347.000
*        SYSGEN INTIALIZATION CODE HERE                                 1348.000
*                                                                       1349.000
         BOUND     1W                                                   1350.000
IP0FS    EQU       $               INITIALIZATION ENTRY POINT       #E# 1351.000
         M.EIR                                                          1352.000
         TBM       C.NOBASE,C.CONF                                   3XX1353.000
         BNS       IP0FS.1         BASE CODE TO BE INCLUDED         33001354.000
         LA        R5,IPF.OVY      OVERLAY BASE CODE                33001355.000
         STW       R5,SG.HAT                                        33001356.000
         LW        R6,=X'00020002' NOP BRANCHES               3300 32B041357.000
         STW       R6,IPF.NOP1                                      33001358.000
         STW       R6,IPF.NOP2                                      33001359.000
         STW       R6,IPF.NOP3                                      33001360.000
         STW       R6,IPF.NOP4                                      33001361.000
         STW       R6,IPF.NOP5                                      33001362.000
IP0FS.1  EQU       $                                                33001363.000
         LA        R6,IP00.EXR     GET ADDRESS                          1364.000
         ADI       R6,4            ADD 1 WORD TO ALLOW FOR TRAP PSD     1365.000
         STW       R6,ADR.EXR      SAVE IT                              1366.000
         LB        R6,C.MACH                                            1367.000
         BZ        IP0F2000        BRANCH IF MACHINE IS 32/2000 EMCH-35 1368.000
         CI        R6,2                                                 1369.000
         BGE       IP0F.42                                              1370.000
IP0F.7X  EQU       $                                                    1371.000
         LA        R6,IP0F.ICB                                          1372.000
         STW       R6,X'1A4'       STORE ICB ADDRESS IN IVL             1373.000
         LI        R6,X'1A4'       IVL LOCATION                         1374.000
         LW        R1,C.SPAD       GET BASE ADDR                        1375.000
         ADI       R1,X'29'+X'80'*4  ACTUAL C.SPAD LOCATION             1376.000
         STW       R6,0,R1         SAVE IT                              1377.000
         BU        IP0F.LT                                              1378.000
IP0F.42  EQU       $                                                    1379.000
IP0F2000 EQU       $                                            EMCH-35 1380.000
         M.TRPINT  X'F',IP0F.ICB                                        1381.000
IP0F.LT  EQU       $                                                    1382.000
         BU        SG.XI                                                1383.000
         DATAB     C'(C) COPYRIGHT 1989 ENCORE COMPUTER CORPORATION'    1384.000
         DATAB     C' ALL RIGHTS RESERVED'                              1385.000
         BOUND     1W                                                   1386.000
SG.XI    EQU       $                                                    1387.000
         M.XIR     HAT                                                  1388.000
         END                                                            1389.000
