*  *********************************************************************
*
*  $Locked:       01-DEC-93 08:21  BEVIER    Add external trap support.$
*  $Header:  285  01-DEC-93 08:23  BEVIER    BEVIER                    $
*  $Log:   @ISCSRC^(DV.TXPM.SYSM)SH.PTCH35                             $
*  
*       Rev  285  01-DEC-93 08:23  BEVIER    BEVIER                     
*  MPX 3.6 Non-RSX IPU support.                                         
*  
*       Rev  284  22-NOV-93 11:22  MJF       MJF                        
*  Comments                                                             
*
*       Rev  283  22-NOV-93 11:13  MJF       MJF
*   Version control header added
*
*
*  This file was extracted from                                     !284
*  file SH.PTCH.  It contains the patches for 3.5 and later.        !284
*284          IFT       OS.35,END.35                                 *232*
         TITLE     H.PTCH -- MPX 3.5 PATCHES FOR CONCEPT MACH       !249
*                                                                   !249
*  Starting with 3.5 we now patch by searching for everything.      !249
*  See the description of the FI.ENT macro to see how we do the     !249
*  search.                                                          !249
*                                                                   !249
*  Come here if a patch could not be located.  We will generate     !255
*  a TGxx abort and replace SYSGEN's SG26 with our new abort code.  !255
*  We then set C.NOLOAD and abort SYSGEN.  There is a TG.ERR file   !255
* that should give the user (and us) a reasonable abort message.    !255
*
         BU        FI.STRT                                          !249
*255 HATADDR  ACW       HAT                                              !249
*255 NOTFOUND LH        R2,FI.NMBR,X2   Get the number of the offending  !249
*255 *                                  entry                            !249
*255          SLL       R2,5            File bound                       !249
*255          ADMW      R2,HATADDR                                       !249
*255          STW       R2,HAT+1W                                        !249
*255          LCS       R0              Get control switches             !249
*255          TBR       R0,15           On means we don't abort          !249
*255          BS        $+2W                                             !249
NOTFOUND EQU       $                                                !255
         ZBM       AB.SG26,ABSWITCH Init a switch                   !262
         LH        R7,FI.NMBR,X2    Get the sequence number of the  !255
*                                   patch that failed...            !255
         ES        R6               and convert to ascii decimal    !255
         DVI       R6,10            R6 = ones, R7 = tens            !255
         ADI       R7,G'0'          convert to ascii                !255
         ADI       R6,G'0'          ditto                           !255
         XCR       R6,R7            R6 = tens, R7 ones              !255
         SLL       R7,24            collect everything              !255
         SRLD      R6,8                                             !255
         LI        R6,G'TG'                                         !255
         SRLD      R6,16            Abort code TGnn                 !255
NFND.02  EQU       $                                                !281
         LW        R3,=X'6A000'                                     !262
         LW        R5,=C'SG26'                                      !255
NFND.1   EQU       $                                                !255
         CAMW      R3,=X'76000'                                     !255
         BGE       NFND.15          Could'nt find it, abort anyway  !262
         CAMW      R5,0,X3          sg26?                           !255
         BEQ       NFND.2                                           !255
         BIW       R3,NFND.1                                        !255
         BU        NFND.3          Abort if we drop out             !262
* ----------------------------------------------------------------- !262
NFND.15  SBM       AB.SG26,ABSWITCH Have we been this way before?   !262
         BS        NFND.3          Go if so and abort               !262
         LW        R3,=X'60000'    Start our search lower.  We      !262
*        don't start with this low a search, since SYSGEN for       !262
*        3.5U01 BL6 (?) and later don't have memory at 60000,       !262
*        while previous versions do.                                !262
         BU        NFND.1                                           !262
* ----------------------------------------------------------------- !262
NFND.2   EQU       $                                                !255
         STW       R7,0,X3         Change SG26 to my abort code     !255
NFND.3   SBM       C.NOLOAD,C.BIT  Can't continue                   !255
         BL        ABRT.XT         No return                        !249
         PAGE
FI.REGS  RES       1F                                               !249
ABSWITCH EQU       FI.REGS         We use ABSWITCH only when        !262
*        we are aborting, and FI.REGS isn't going to be used        !262
AB.SG26  EQU       0                                                !262
*
*  FINDINST
*
*  On input, R2 points to the search entry.                         !249
*  On exit, CC1 is set if found, else not set.                      !249
*           If found, R3 points to the instruction found in memory  !249
*           Look at the description of the search entry for more    !253
*           info.                                                   !253
FINDINST ZBR       R0,CC1          Not successful yet               !249
         STF       R0,FI.REGS                                       !249
         LA        R3,*1W,X2       Starting address to search       !249
         SUI       R3,1W           Back up so that the loop check   !249
*                                  lets us look at the first addr   !249
         SRL       R3,2            Lose C bits; we need a WORD addr !249
         SLL       R3,2                                             !249
         LA        R0,*2W,X2       Stop address                     !249
FI.1     LW        R7,3W,X2        First instruction to find        !249
         LW        R4,4W,X2        First mask to use                !249
FI.2     ABR       R3,29           Go to next word                  !249
         CAR       R0,R3           Compare with stop address        !249
         BGT       FI.RET          Done -- wasn't found             !249
         CMMW      R7,,X3          Is it in memory?                 !249
         BNE       FI.2            No; go look for first instr again!249
* ----------------------------------------------------------------- !249
         TRR       R2,R5           Save for inner loop              !249
         TRR       R3,R6                                            !249
         LNB       R1,FI.NRENT,X2  Number of bytes to check         !249
FI.3     ADI       R1,1W           We've already found 1 word       !249
         BZ        FI.4            Found a complete match!          !249
         ABR       R2,28           Bump by two words (next entry)   !249
         ABR       R3,29           Next word in memory              !249
         LW        R7,3W,X2        Word to look for                 !249
         LW        R4,4W,X2        Mask to use                      !249
         CMMW      R7,,X3          Look in memory                   !249
         BEQ       FI.3            Found next in sequence           !249
*  If we are here, we failed in our inner loop.  So we reset and    !249
*  start the outer loop again.                                      !249
         TRR       R5,R2           Reset to point to first entry    !249
         TRR       R6,R3           Last word we found               !249
         BU        FI.1            Start outer loop again           !249
* ----------------------------------------------------------------- !249
FI.4     EQU       $               If we are here, we found a comple!249
*        match.  We return the appropriate stuff.                   !249
         TRR       R5,R2           Get entry address back           !249
         TRR       R6,R3           Addr of first match in memory    !249
         ADMB      R3,FI.OFFS,X2   Add offset in                    !249
         STW       R3,FI.REGS+3W   So we can return it              !249
         STW       R3,FI.LFND      Save last found                  !253
         SBM       CC1,FI.REGS     Signal success                   !249
* ----------------------------------------------------------------- !249
FI.RET   LF        R0,FI.REGS                                       !249
         TRSW      R0                                               !249
LSWITCH  REZ       1B              Local switches                   !264
LW.TAM8A EQU       0                                                !264
LW.ICP   EQU       1                                                !275
         EXT       S.IOCS29,S.IOCS31,S.IOCS20,S.IP2                 !249
         EXT       S.MEMM5,S.MEMM7,S.MEMM19,S.MEMM20,S.MEMM21       !249
         EXT       S.IOCS5,S.EXEC5,IP04S,IP05S,EXEC.D1              !249
FI.LFND  REZ       1W              Address of last thing we found   !253
IPUSTRT  REZ       1W                                               !249
IPUEND   REZ       1W                                               !249
EXECSTRT REZ       1W                                               !249
EXECEND  REZ       1W                                               !249
EXSBSTRT REZ       1W                                               !249
EXSBEND  REZ       1W                                               !249
IOCSSTRT REZ       1W                                               !249
IOCSEND  REZ       1W                                               !249
IP0FSTRT REZ       1W                                               !249
IP0FEND  REZ       1W                                               !249
IPCLSTRT REZ       1W                                               !249
IPCLEND  REZ       1W                                               !249
MEMMSTRT REZ       1W                                               !249
MEMMEND  REZ       1W                                               !249
TAMMSTRT REZ       1W                                               !249
TAMMEND  REZ       1W                                               !249
TSMSTRT  REZ       1W                                               !249
TSMEND   REZ       1W                                               !249
BKOPSTRT REZ       1W                                               !249
BKOPEND  REZ       1W                                               !249
IP04STRT REZ       1W                                               !249
IP04END  REZ       1W                                               !249
IP05STRT REZ       1W                                               !249
IP05END  REZ       1W                                               !249
SURESTRT REZ       1W                                               !249
SUREEND  REZ       1W                                               !249
ICPSTRT  REZ       1W                                               !249
ICPEND   REZ       1W                                               !249
RMSSSTRT REZ       1W                                               !257
RMSSEND  REZ       1W                                               !257
*
*  Search entries are described with the FI.ENT macro               !253
*
* ================================================================= !249
*                                                                   !249
*  Beginning of code sequences that H.PTCH will look for            !249
*                                                                   !249
* ================================================================= !249
* ----------------------------------------------------------------- !249
*  IPU code                                                         !249
* ----------------------------------------------------------------- !249
         FI.ENT    IPU1,IPU1.S,IPU1.E,IPU1.L                        !249
         ACW       *IPUSTRT                                         !249
         ACW       *IPUEND                                          !249
IPU1.S   LMW       R5,0                                             !249
         MK.NOADR                                                   !249
         LMW       R6,0                                             !249
         MK.NOADR                                                   !249
         CAR       R5,R6                                            !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         BEQ       0                                                !249
         MK.NOADR                                                   !249
IPU1.L   BGT       0                                                !249
         MK.NOADR                                                   !249
IPU1.L2  LA        R5,0                                             !249
         MK.NOADR                                                   !249
         CAR       R5,R6                                            !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         BGT       0                                                !249
         MK.NOADR                                                   !249
IPU1.L3  LPSD      0                                                !249
         MK.NOADR                                                   !249
IPU1.E   EQU       $                                                !249
         FI.ENT    IPU2,IPU2.S,IPU2.E,IPU2.L                        !249
         ACW       *IPUSTRT                                         !249
         ACW       *IPUEND                                          !249
IPU2.S   LW        R2,C.CIPU                                        !249
         MK.CMPW                                                    !249
         LB        R6,DQE.NUM,X2                                    !249
         MK.CMPW                                                    !249
         SLL       R6,3                                             !249
         SBR       R6,0                                             !249
         MK.CMPW                                                    !249
         STW       R6,0                                             !249
         MK.NOADR                                                   !249
IPU2.L   LPSDCM    0                                                !249
         MK.NOADR                                                   !249
IPU2.E   EQU       $                                                !249
         FI.ENT    IPU3,IPU3.S,IPU3.E,IPU3.L                        !249
         ACW       *IPUSTRT                                         !249
         ACW       *IPUEND                                          !249
         IFF       OS.36,O36                                        !285
IPU3.S   STF       R0,0                                             !249
         MK.NOADR                                                   !249
         LA        R2,0                                             !249
         MK.NOADR                                                   !249
         LD        R6,0                                             !249
         MK.NOADR                                                   !249
         BL        0                                                !249
         MK.NOADR                                                   !249
         BL        0                                                !249
         MK.NOADR                                                   !249
IPU3.L   ZBM       C.ICSIPU,C.BIT                                   !249
         MK.CMPW                                                    !249
O36      ANOP                                                       !285
         IFT       OS.36,O36                                        !285
IPU3.S   STD       R6,0                                             !285
         MK.NOADR                                                   !285
         LD        R0,T.R0,X2                                       !285
         MK.CMPW                                                    !285
         LD        R4,T.R4,X2                                       !285
         MK.CMPW                                                    !285
         LD        R6,T.R6,X2                                       !285
         MK.CMPW                                                    !285
         LD        R2,T.R2,X2                                       !285
         MK.CMPW                                                    !285
IPU3.L   ZBM       C.IPUCSI,C.IPUFLG                                !285
         MK.CMPW                                                    !285
O36      ANOP                                                       !285
         LPSD      0                                                !249
         MK.NOADR                                                   !249
IPU3.E   EQU       $                                                !249
         FI.ENT    IPU4,IPU4.S,IPU4.E,IPU4.L                        !249
         ACW       *IPUSTRT                                         !249
         ACW       *IPUEND                                          !249
IPU4.S   LF        R0,0                                             !249
IPU4.L   EQU       IPU4.S                                           !249
         MK.NOADR                                                   !256
         SBM       0,0                                              !249
         MK.BM                                                      !249
         ZBM       0,0                                              !249
         MK.BM                                                      !249
         BS        0                                                !249
         MK.NOADR                                                   !249
         IFT       OS.36,O36                                        !285
         ZBM       C.IPUCSI,C.IPUFLG                                !285
O36      ANOP                                                       !285
         IFF       OS.36,O36                                        !285
         ZBM       C.ICSIPU,C.BIT                                   !249
O36      ANOP                                                       !285
         MK.CMPW                                                    !249
IPU4.E   EQU       $                                                !249
         FI.ENT    IPU5,IPU5.S,IPU5.E,IPU5.L
         ACW       *IPUSTRT
         ACW       *IPUEND
IPU5.S   LD        R6,0
         MK.NOADR
         BL        0
         MK.NOADR
         BU        0
         MK.NOADR
         STD       R6,0
         MK.NOADR
         LF        R0,0
         MK.NOADR
         IFT       OS.36,O36                                        !285
IPU5.L   ZBM       C.IPUCSI,C.IPUFLG                                !285
O36      ANOP                                                       !285
         IFF       OS.36,O36                                        !285
IPU5.L   ZBM       C.ICSIPU,C.BIT
O36      ANOP                                                       !285
         MK.CMPW
IPU5.L2  LPSD      0
         MK.NOADR
IPU5.E   EQU       $
         FI.ENT    IPU6,IPU6.S,IPU6.E,IPU6.L
         ACW       *IPUSTRT
         ACW       *IPUEND
IPU6.S   LD        R6,0
         MK.NOADR
         BL        0
         MK.NOADR
         BU        0
         MK.NOADR
         STD       R6,0
         MK.NOADR
         LF        R0,0
         MK.NOADR
         IFT       OS.36,O36                                        !285
IPU6.L   ZBM       C.IPUCSI,C.IPUFLG                                !285
O36      ANOP                                                       !285
         IFF       OS.36,O36                                        !285
IPU6.L   ZBM       C.ICSIPU,C.BIT
O36      ANOP                                                       !285
         MK.CMPW
IPU6.L2  LPSD      0
         MK.NOADR
IPU6.E   EQU       $
         FI.ENT    IPU7,IPU7.S,IPU7.E,IPU7.L
         ACW       *IPUSTRT
         ACW       *IPUEND
IPU7.S   TBM       1,0,X3
         MK.CMPW
         BS        0
         MK.NOADR
         LD        R6,0
         MK.NOADR
         BU        0
         MK.NOADR                                                   !256
         LF        R0,0
         MK.NOADR
         IFT       OS.36,O36                                        !285
IPU7.L   ZBM       C.IPUCSI,C.IPUFLG                                !285
O36      ANOP                                                       !285
         IFF       OS.36,O36                                        !285
IPU7.L   ZBM       C.ICSIPU,C.BIT
O36      ANOP                                                       !285
         MK.CMPW
IPU7.L2  LPSD      0
         MK.NOADR
IPU7.E   EQU       $
         FI.ENT    IPU8,IPU8.S,IPU8.E,IPU8.L
         ACW       *IPUSTRT
         ACW       *IPUEND
         IFT       OS.36,O36                                        !285
IPU8.S   SBM       C.IPUCSI,C.IPUFLG                                !285
O36      ANOP                                                       !285
         IFF       OS.36,O36                                        !285
IPU8.S   SBM       C.ICSIPU,C.BIT
O36      ANOP                                                       !285
         MK.CMPW
         STF       R0,0
         MK.NOADR
         LA        R1,0
         MK.NOADR
         LI        R2,6
         MK.CMPW
         BL        S.IP2
         MK.NOADR
IPU8.L   BU        0
         MK.NOADR
         LD        R6,0
         MK.NOADR
         STD       R6,0
         MK.NOADR
         LD        R6,0
         MK.NOADR
         STD       R6,0
         MK.NOADR
         LD        R6,0
         MK.NOADR
         STD       R6,0
         MK.NOADR
         LF        R0,0
         MK.NOADR
IPU8.L2  LPSD      0
         MK.NOADR
IPU8.E   EQU       $
         FI.ENT    IPU9,IPU9.S,IPU9.E,IPU9.L
         ACW       *IPUSTRT
         ACW       *IPUEND
         IFT       OS.36,O36                                        !285
IPU9.S   SBM       C.IPUCSI,C.IPUFLG                                !285
O36      ANOP                                                       !285
         IFF       OS.36,O36                                        !285
IPU9.S   SBM       C.ICSIPU,C.BIT
O36      ANOP                                                       !285
         MK.CMPW
         STF       0,0
         MK.NOADR
         LD        R6,0
         MK.NOADR
         LI        R2,X'F'
         MK.CMPW
         BL        0
         MK.NOADR
IPU9.L   LA        R1,0
         MK.NOADR                                                   !256
         LI        R2,X'F'
         MK.CMPW
         BL        0
         MK.NOADR
IPU9.L2  BU        0
         MK.NOADR
IPU9.E   EQU       $
         FI.ENT    IPU10,IPU10.S,IPU10.E,IPU10.L
         ACW       *IPUSTRT
         ACW       *IPUEND
         IFT       OS.36,O36                                        !285
IPU10.S  TBM       IPU.REQP,EXC.IPUP                                !285
O36      ANOP                                                       !285
         IFF       OS.36,O36                                        !285
IPU10.S  ZBM       IPU.SCH,EXEC.FLG
O36      ANOP                                                       !285
         MK.CMPW
         BNS       0
         MK.NOADR
         STF       R0,0
         MK.NOADR
         LA        R2,0
         MK.NOADR
         LD        R6,0
         MK.NOADR
         BL        0
         MK.NOADR
         BU        0
         MK.NOADR
         IFT       OS.36,O36                                        !285
IPU10.L  ZBM       C.IPUCSI,C.IPUFLG                                !285
O36      ANOP                                                       !285
         IFF       OS.36,O36                                        !285
IPU10.L  ZBM       C.ICSIPU,C.BIT
O36      ANOP                                                       !285
         MK.CMPW
IPU10.L2 LPSD      0
         MK.NOADR
IPU10.E  EQU       $
* ----------------------------------------------------------------- !249
*  EXEC code                                                        !249
* ----------------------------------------------------------------- !249
         FI.ENT    EXC1,EXC1.S,EXC1.E,EXC1.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
EXC1.S   ARMW      R5,C.GINT                                        !249
         MK.CMPW                                                    !249
         BZ        0                                                !249
         MK.NOADR                                                   !249
         LF        R0,T.R0,X2                                       !249
         MK.CMPW                                                    !249
EXC1.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
EXC1.E   EQU       $                                                !249
         FI.ENT    EXC2,EXC2.S,EXC2.E,EXC2.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
EXC2.S   LW        R0,T.FSSP,X3                                     !249
         MK.CMPW                                                    !249
         STW       R0,C.FSSP                                        !249
         MK.CMPW                                                    !249
         TRR       R1,R6                                            !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         SUI       R6,32W                                           !249
         MK.CMPW                                                    !249
         STW       R6,T.REGP,X3                                     !249
         MK.CMPW                                                    !249
         LF        R0,T.R0,X1                                       !249
         MK.CMPW                                                    !249
EXC2.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
EXC2.E   EQU       $                                                !249
         FI.ENT    EXC2A,EXC2A.S,EXC2A.E,EXC2A.L,REPEAT             !266
         ACW       *EXECSTRT                                        !266
         ACW       *EXECEND                                         !266
EXC2A.S  LD        R0,0W,X2                                         !266
         MK.CMPW                                                    !266
         LD        R4,4W,X2                                         !266
         MK.CMPW                                                    !266
         LD        R6,6W,X2                                         !266
         MK.CMPW                                                    !266
         LD        R2,2W,X2                                         !266
         MK.CMPW                                                    !266
EXC2A.L  LPSD      0                                                !266
         MK.NOADR                                                   !266
EXC2A.E  EQU       $                                                !266
         FI.ENT    EXC3,EXC3.S,EXC3.E,EXC3.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
EXC3.S   LB        R6,DQE.NUM,X2                                    !249
         MK.CMPW                                                    !249
         SLL       R6,2                                             !249
         SBR       R6,0                                             !249
         DATAH     X'FFFE'      Could be SLL R6,2 or SLL R6,3       !249
         MK.CMPH                                                    !249
         SBR       R6,16                                            !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         STW       R6,0                                             !249
         MK.NOADR                                                   !249
EXC3.L   LPSDCM    0                                                !249
         MK.NOADR                                                   !249
EXC3.E   EQU       $                                                !249
         FI.ENT    EXC4,EXC4.S,EXC4.E,EXC4.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
*280 EXC4.S   LW        R2,T.FSSP,X3                                     !249
*280          MK.CMPW                                                    !249
*280          STW       R2,C.FSSP                                        !249
*280          MK.CMPW                                                    !249
EXC4.S   EQU       $                                                !280
         LW        R2,C.CURR                                        !249
         MK.CMPW                                                    !249
         TBM       DQE.BASE,DQE.IPUF,X2                             !249
         MK.CMPW                                                    !249
         BNS       0                                                !249
         MK.NOADR                                                   !249
         LW        R7,0                                             !249
         MK.NOADR                                                   !249
EXC4.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
EXC4.E   EQU       $                                                !249
         FI.ENT    EXC5,EXC5.S,EXC5.E,EXC5.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
EXC5.S   TRR       R2,R3                                            !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         ZMW       0,X2                                             !249
         MK.CMPW                                                    !249
         SBM       17,5W,X2                                         !249
         MK.CMPW                                                    !249
EXC5.L   LPSD      4W,X2                                            !249
         MK.CMPW                                                    !249
EXC5.E   EQU       $                                                !249
         FI.ENT    EXC6,EXC6.S,EXC6.E,EXC6.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
*280 EXC6.S   BEI                                                        !249
*280          NOP                                                        !249
*280          MK.CMPH                                                    !249
*280          MK.NOMKH                                                   !249
EXC6.S   EQU       $                                                !280
         STD       R6,0                                             !249
         MK.NOADR                                                   !249
         TBM       DQE.BASE,DQE.IPUF,X2                             !249
         MK.CMPW                                                    !249
         BNS       0                                                !249
         MK.NOADR                                                   !249
         LW        R7,0                                             !249
         MK.NOADR                                                   !249
EXC6.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
EXC6.E   EQU       $                                                !249
         FI.ENT    EXC7,EXC7.S,EXC7.E,EXC7.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
EXC7.S   STW       R5,T.ABRTA,X3                                    !249
         MK.CMPW                                                    !249
         ZBR       R6,5                                             !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         LH        R5,DQE.ATI,X2                                    !249
         MK.CMPW                                                    !249
         M.IOFF                                                     !249
         MK.CMPW                                                    !249
         STD       R6,0                                             !249
         MK.NOADR                                                   !249
EXC7.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
EXC7.E   EQU       $                                                !249
         FI.ENT    EXC7A,EXC7A.S,EXC7A.E,EXC7A.L,REPEAT             !280
         ACW       *EXECSTRT                                        !280
         ACW       *EXECEND                                         !280
EXC7A.S  STW       R5,T.ABRTA,X3                                    !280
         MK.CMPW                                                    !280
         ZBR       R6,5                                             !280
         NOP                                                        !280
         MK.CMPH                                                    !280
         MK.NOMKH                                                   !280
         LH        R5,DQE.ATI,X2                                    !280
         MK.CMPW                                                    !280
         STD       R6,0                                             !280
         MK.NOADR                                                   !280
EXC7A.L  LPSD      0                                                !280
         MK.NOADR                                                   !280
EXC7A.E  EQU       $                                                !280
         FI.ENT    EXC8,EXC8.S,EXC8.E,EXC8.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
EXC8.S   TBR       R6,6                                             !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         BNS       0                                                !249
         MK.NOADR                                                   !249
         LW        R3,C.REGS                                        !249
         MK.CMPW                                                    !249
         LFBR      B0,T.MPXBR,X3                                    !249
         MK.CMPW                                                    !249
         LW        R3,C.CURR                                        !249
         MK.CMPW                                                    !249
EXC8.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
EXC8.E   EQU       $                                                !249
         FI.ENT    EXC9,EXC9.S,EXC9.E,EXC9.L                        !249
         ACW       *EXECSTRT                                        !249
         ACW       *EXECEND                                         !249
EXC9.S   SBR       R6,0                                             !249
         SBR       R6,7                                             !249
         MK.CMPW                                                    !249
         M.IOFF                                                     !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         STW       R6,0                                             !249
         MK.NOADR                                                   !249
         LW        R7,0                                             !249
         MK.NOADR                                                   !249
EXC9.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
EXC9.E   EQU       $                                                !249
         FI.ENT    EXC9A,EXC9A.S,EXC9A.E,EXC9A.L,REPEAT             !277
         ACW       *EXECSTRT                                        !277
         ACW       *EXECEND                                         !277
EXC9A.S  SBR       R6,0                                             !277
         SBR       R6,7                                             !277
         MK.CMPW                                                    !277
         M.IOFF                                                     !277
         NOP                                                        !277
         MK.CMPW                                                    !277
         STW       R6,0                                             !277
         MK.NOADR                                                   !277
         LW        R7,0                                             !277
         MK.NOADR                                                   !277
         TBR      R7,8                                              !277
         NOP                                                        !277
         MK.CMPW                                                    !277
         BNS       0                                                !277
         MK.NOADR                                                   !277
         MK.MTSAD  R3                                               !277
         M.LFBR    T.REGS+T.B0,X3                                   !277
         MK.CMPW                                                    !277
         LW        R3,C.CURR                                        !277
         MK.CMPW                                                    !277
EXC9A.L  LPSD      0                                                !277
         MK.NOADR                                                   !277
EXC9A.E  EQU       $                                                !277
         FI.ENT    EXC9B,EXC9B.S,EXC9B.E,EXC9B.L,REPEAT             !280
         ACW       *EXECSTRT                                        !280
         ACW       *EXECEND                                         !280
EXC9B.S  BNS       0                                                !280
         MK.NOADR                                                   !280
         LW        R7,0                                             !280
         MK.NOADR                                                   !280
         TRR       R1,R2                                            !280
         NOP                                                        !280
         MK.CMPW                                                    !280
         LW        R3,C.CURR                                        !280
         MK.CMPW                                                    !280
EXC9B.L  LPSD      0                                                !280
         MK.NOADR                                                   !280
EXC9B.E  EQU       $                                                !280
* ----------------------------------------------------------------- !249
*  EXECSUB code                                                     !249
* ----------------------------------------------------------------- !249
         FI.ENT    EXS1,EXS1.S,EXS1.E,EXS1.L                        !249
         ACW       *EXSBSTRT                                        !249
         ACW       *EXSBEND                                         !249
EXS1.S   STH       R7,MQ.RBL,X1                                     !249
         MK.CMPW                                                    !249
         TRN       R7,R7                                            !249
         XCR       R1,R2                                            !249
         MK.CMPW                                                    !249
EXS1.L   LW        R1,RXB.RBA,X1                                    !249
         MK.CMPW                                                    !249
         ANMW      R1,C.ADMASK                                      !249
         MK.CMPW                                                    !249
         LW        R2,MQ.PPTR,X2                                    !249
         MK.CMPW                                                    !249
EXS1.E   EQU       $                                                !249
         FI.ENT    EXS2,EXS2.S,EXS2.E,EXS2.L                        !249
         ACW       *EXSBSTRT                                        !249
         ACW       *EXSBEND                                         !249
EXS2.S   LW        R1,C.CURR                                        !249
         MK.CMPW                                                    !249
         LI        R6,-1                                            !249
         MK.CMPW                                                    !249
         ARMB      R6,DQE.NWMR,X1                                   !249
         MK.CMPW                                                    !249
         LW        R1,,X3                                           !249
         MK.NOADR                                                   !249
         LW        R6,PSB.EAA,X1                                    !249
         MK.CMPW                                                    !249
EXS2.L   ANMW      R6,0                                             !249
         MK.NOADR                                                   !249
EXS2.E   EQU       $                                                !249
         FI.ENT    EXS3,EXS3.S,EXS3.E,EXS3.L                        !249
         ACW       *EXSBSTRT                                        !249
         ACW       *EXSBEND                                         !249
EXS3.S   LW        R1,C.CURR                                        !249
         MK.CMPW                                                    !249
         LI        R6,-1                                            !249
         MK.CMPW                                                    !249
         ARMB      R6,DQE.NWRR,X1                                   !249
         MK.CMPW                                                    !249
         LW        R1,,X3                                           !249
         MK.NOADR                                                   !249
         LW        R6,PSB.EAA,X1                                    !249
         MK.CMPW                                                    !249
EXS3.L   ANMW      R6,0                                             !249
         MK.NOADR                                                   !249
EXS3.E   EQU       $                                                !249
* ----------------------------------------------------------------- !249
*  IOCS code                                                        !249
* ----------------------------------------------------------------- !249
         FI.ENT    IOC1,IOC1.S,IOC1.E,IOC1.L                        !249
         ACW       *IOCSSTRT                                        !249
         ACW       *IOCSEND                                         !249
IOC1.S   SBR       R7,0                                             !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         STW       R7,T.SPAD2,X3                                    !249
         MK.CMPW                                                    !249
         LW        R7,T.SPAD1,X3                                    !249
         MK.CMPW                                                    !249
         ORR       R7,R6                                            !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         LW        R7,T.SPAD2,X3                                    !249
         MK.CMPW                                                    !249
IOC1.L   BL        0                                                !249
         MK.NOADR                                                   !249
IOC1.E   EQU       $                                                !249
*  IOC1 and IOC3 won't be found for 3.5u02 and later.  If we don't  !275
*  find them then we will look for IOC1A, which follows.            !275
         FI.ENT    IOC1A,IOC1A.S,IOC1A.E,IOC1A.L,REPEAT             !275
         ACW       *IOCSSTRT                                        !275
         ACW       *IOCSEND                                         !275
IOC1A.S  LW        R3,T.REGP,X3                                     !275
         MK.CMPW                                                    !275
         LW        R4,T.SPAD1,X3                                    !275
         MK.CMPW                                                    !275
         ORR       R4,R6                                            !275
         NOP                                                        !275
         MK.CMPW                                                    !275
IOC1A.L  BL        S.EXEC68                                         !275
         MK.CMPW                                                    !275
IOC1A.E  EQU       $                                                !275
         FI.ENT    IOC2,IOC2.S,IOC2.E,IOC2.L                        !249
         ACW       *IOCSSTRT                                        !249
         ACW       *IOCSEND                                         !249
IOC2.S   LW        R6,FCB.SPST,X1                                   !249
         MK.CMPW                                                    !249
         SBR       R6,0                                             !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         STW       R6,FCB.SPST,X1                                   !249
         MK.CMPW                                                    !249
IOC2.L   M.CALL    H.EXEC,12                                        !249
         MK.MCALL                                                   !249
IOC2.E   EQU       $                                                !249
         FI.ENT    IOC3,IOC3.S,IOC3.E,IOC3.L                        !249
         ACW       *IOCSSTRT                                        !249
         ACW       *IOCSEND                                         !249
IOC3.S   STW       R7,T.SPAD2,X3                                    !249
         MK.CMPW                                                    !249
         LW        R7,T.SPAD1,X3                                    !249
         MK.CMPW                                                    !249
         ORR       R7,R6                                            !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         LW        R7,T.SPAD2,X3                                    !249
         MK.CMPW                                                    !249
IOC3.L   BL        0                                                !249
         MK.NOADR                                                   !249
IOC3.E   EQU       $                                                !249
         FI.ENT    IOC4,IOC4.S,IOC4.E,IOC4.L                        !249
         ACW       *IOCSSTRT                                        !249
         ACW       *IOCSEND                                         !249
IOC4.S   LW        R7,FCB.SFLG,X1                                   !249
         MK.CMPW                                                    !249
IOC4.L   EQU       IOC4.S                                           !249
         ZBR       R7,0                                             !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         STW       R7,FCB.SFLG,X1                                   !249
         MK.CMPW                                                    !249
         LW        R2,C.REGS                                        !249
         MK.CMPW                                                    !249
         LB        R7,FCB.FATA,X1                                   !249
         MK.CMPW                                                    !249
         MPI       R6,FPT.SIZE                                      !249
         MK.CMPW                                                    !249
IOC4.E   EQU       $                                                !249
         FI.ENT    IOC5,IOC5.S,IOC5.E,IOC5.L                        !249
IOC5.1   ACW       S.IOCS20        May get overwritten              !249
         ACW       *IOCSEND                                         !249
IOC5.S   LW        R6,FCB.TCW,X1                                    !249
         MK.CMPW                                                    !249
         SRLD      R6,20                                            !249
         SRL       R7,12                                            !249
         MK.CMPW                                                    !249
IOC5.L   XCR       R6,R7                                            !249
         ZBR       R6,12                                            !249
         MK.CMPW                                                    !249
         BS        0                                                !249
         MK.NOADR                                                   !249
IOC5.E   EQU       $                                                !249
         FI.ENT    IOC6,IOC6.S,IOC6.E,IOC6.L                        !249
IOC6.1   ACW       S.IOCS29        May get overwritten              !249
IOC6.2   ACW       S.IOCS31        Ditto                            !249
IOC6.S   STW       R6,FCB.SFLG,X1                                   !249
         MK.CMPW                                                    !249
         STW       R6,FCB.RECL,X1                                   !249
         MK.CMPW                                                    !249
         STW       R6,FCB.IOQA,X1                                   !249
         MK.CMPW                                                    !249
IOC6.L   STB       R6,FCB.SPST,X1                                   !249
         MK.CMPW                                                    !249
IOC6.E   EQU       $                                                !249
* ----------------------------------------------------------------- !249
*  IP0F code                                                        !249
* ----------------------------------------------------------------- !249
         FI.ENT    IPF1,IPF1.S,IPF1.E,IPF1.L                        !249
         ACW       *IP0FSTRT                                        !249
         ACW       *IP0FEND                                         !249
IPF1.S   LA        R1,0                                             !249
         MK.NOADR                                                   !249
         LI        R7,X'F'                                          !249
         MK.CMPW                                                    !249
         BL        S.IP2                                            !249
         MK.CMPW                                                    !249
IPF1.L   BU        0                                                !249
         MK.NOADR                                                   !249
IPF1.E   EQU       $                                                !249
         FI.ENT    IPF2,IPF2.S,IPF2.E,IPF2.L                        !249
         ACW       *IP0FSTRT                                        !249
         ACW       *IP0FEND                                         !249
IPF2.S   BL        0                                                !249
         MK.NOADR                                                   !249
         STD       R6,0                                             !249
         MK.NOADR                                                   !249
         LF        R0,0,X1                                          !249
         MK.CMPW                                                    !249
IPF2.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
         STW       R0,X'CC',X1                                      !249
         MK.CMPW                                                    !249
         LW        R5,T.BIT5,X3                                     !249
         MK.CMPW                                                    !249
IPF2.E   EQU       $                                                !249
*  This entry is used for 3.5u02 and later.                         !275
         FI.ENT    IPF2A,IPF2A.S,IPF2A.E,IPF2A.L,REPEAT             !275
         ACW       *IP0FSTRT                                        !275
         ACW       *IP0FEND                                         !275
IPF2A.L  LPSD      0                                                !275
IPF2A.S  EQU       IPF2A.L                                          !275
         MK.NOADR                                                   !275
         STW       R0,X'CC',X1                                      !275
         MK.CMPW                                                    !275
         LW        R5,T.BIT5,X3                                     !275
         MK.CMPW                                                    !275
IPF2A.E  EQU       $                                                !275
* ----------------------------------------------------------------- !249
*  IPCL code                                                        !249
* ----------------------------------------------------------------- !249
         FI.ENT    IPCL1,IPCL1.S,IPCL1.E,IPCL1.L                    !249
         ACW       *IPCLSTRT                                        !249
         ACW       *IPCLEND                                         !249
IPCL1.S  ABM       31,C.GINT                                        !249
         MK.CMPW                                                    !249
IPCL1.L  STF       R0,0                                             !249
         MK.NOADR                                                   !249
         LA        R1,0                                             !249
         MK.NOADR                                                   !249
         LI        R7,0                                             !249
         MK.CMPW                                                    !249
IPCL1.L2 BL        S.IP2                                            !249
         MK.CMPW                                                    !249
IPCL1.L3 LF        R0,0                                             !249
         MK.NOADR                                                   !249
         ABM       31,C.INTC                                        !249
         MK.CMPW                                                    !249
IPCL1.E  EQU       $                                                !249
         FI.ENT    IPCL4,IPCL4.S,IPCL4.E,IPCL4.L                    !249
         ACW       *IPCLSTRT                                        !249
         ACW       *IPCLEND                                         !249
IPCL4.S  DAI       X'28'                                            !249
         DATAW     X'FC040000'     DAI                              !249
IPCL4.L  EQU       IPCL4.S                                          !249
         BL        S.EXEC5                                          !249
         MK.CMPW                                                    !249
IPCL4.E  EQU       $                                                !249
         FI.ENT    IPCL5,IPCL5.S,IPCL5.E,IPCL5.L                    !249
         ACW       *IPCLSTRT                                        !249
         ACW       *IPCLEND                                         !249
IPCL5.S  LNW       R7,C.NTIM                                        !249
         MK.CMPW                                                    !249
IPCL5.L  STW       R7,0                                             !249
         MK.NOADR                                                   !249
         BL        S.IOCS5                                          !249
         MK.CMPW                                                    !249
         LW        R5,C.MRQTMR                                      !249
         MK.CMPW                                                    !249
         BZ        0                                                !249
         MK.NOADR                                                   !249
         SUI       R5,1                                             !249
         MK.CMPW                                                    !249
         STW       R5,C.MRQTMR                                      !249
         MK.CMPW                                                    !249
IPCL5.E  EQU       $                                                !249
* ----------------------------------------------------------------- !249
*  MEMM code                                                        !249
* ----------------------------------------------------------------- !249
         FI.ENT    MEM1,MEM1.S,MEM1.E,MEM1.L                        !249
         ACW       *MEMMSTRT                                        !249
         ACW       *MEMMEND                                         !249
MEM1.S   LW        R3,C.REGS                                        !249
         MK.CMPW                                                    !249
         LH        R3,T.ATBIAS,X3                                   !249
         MK.CMPW                                                    !249
         SUR       R3,R4                                            !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
MEM1.L   LW        R3,C.REGS                                        !249
         MK.CMPW                                                    !249
         LH        R5,SMT.CSEN,X1                                   !249
         MK.CMPW                                                    !249
         ADMH      R5,SMT.DSEN,X1                                   !249
         MK.CMPW                                                    !249
MEM1.E   EQU       $                                                !249
*266 FI.NR    SET       FI.NR-1         Decrement this, since MEM1A      !263
*266 *                                  masquerades as MEM1              !263
         FI.ENT    MEM1A,MEM1A.S,MEM1A.E,MEM1A.L,REPEAT             !266
         ACW       *MEMMSTRT                                        !263
         ACW       *MEMMEND                                         !263
MEM1A.S  LW        R3,C.REGS                                        !263
         MK.CMPW                                                    !263
         TBM       0,0,X1                                           !263
         MK.BM                                                      !263
         BS        0                                                !263
         MK.NOADR                                                   !263
         ADMB      R4,C.MSD                                         !263
         MK.CMPW                                                    !263
         LH        R5,T.ATBIAS,X3                                   !263
         MK.CMPW                                                    !263
         SUR       R5,R4                                            !263
         NOP                                                        !263
         MK.CMPH                                                    !263
         MK.NOMKH                                                   !263
         BN        0                                                !264
         MK.NOADR                                                   !264
MEM1A.L  LH        R5,SMT.CSEN,X1                                   !263
         MK.CMPW                                                    !263
         ADMH      R5,SMT.DSEN,X1                                   !263
         MK.CMPW                                                    !263
MEM1A.E  EQU       $                                                !263
         FI.ENT    MEM2,MEM2.S,MEM2.E,MEM2.L                        !249
         ACW       *MEMMSTRT                                        !249
         ACW       *MEMMEND                                         !249
MEM2.S   LW        R5,RD.PGLEN,X1                                   !249
         MK.CMPW                                                    !249
         SUI       R5,1                                             !249
         MK.CMPW                                                    !249
         ADR       R4,R5                                            !249
         SLL       R4,11                                            !249
         MK.CMPW                                                    !249
MEM2.L   CAMW      R4,C.LOSEND                                      !249
         MK.CMPW                                                    !249
         BLE       0                                                !249
         MK.NOADR                                                   !249
         SRL       R4,13                                            !249
         SRL       R5,2                                             !249
         MK.CMPW                                                    !249
         SUR       R4,R5                                            !249
         ABR       R5,31                                            !249
         MK.CMPW                                                    !249
MEM2.E   EQU       $                                                !249
*  Note that we have moved MEM2.E to a point ABOVE MEM2.L2.         !263
*  That's because MEM2.L2 could be one of two instructions.         !263
*  We will check individually for the other two instructions.       !263
MEM2.L2  LH        R3,T.ATBIAS,X3                                   !249
*263          MK.CMPW                                                    !249
MEM2.L2A SUMB      R4,C.MSD                                         !263
MEM2.L2B SUMB      R4,TSK.NMAP,X2  May be used as a replacement     !263
         FI.ENT    MEM4,MEM4.S,MEM4.E,MEM4.L                        !249
         ACW       *MEMMSTRT                                        !249
         ACW       *MEMMEND                                         !249
MEM4.S   STD       R6,SMT.RID+6W,X1                                 !249
         MK.CMPW                                                    !249
         LW        R3,T.REGP,X3                                     !249
         MK.CMPW                                                    !249
         LD        R6,T.SPAD3,X3                                    !249
         MK.CMPW                                                    !249
         STW       R6,T.SPAD2,X3                                    !249
         MK.CMPW                                                    !249
MEM4.L   STH       R6,SMT.MAPS,X1                                   !249
         MK.CMPW                                                    !249
MEM4.E   EQU       $                                                !249
*266 FI.NR    SET       FI.NR-1         MEM4A masquerades as MEM4        !263
         FI.ENT    MEM4A,MEM4A.S,MEM4A.E,MEM4A.L,REPEAT             !266
         ACW       *MEMMSTRT                                        !263
         ACW       *MEMMEND                                         !263
MEM4A.S  STD       R6,SMT.RID+6W,X1                                 !263
         MK.CMPW                                                    !263
         LW        R3,T.REGP,X3                                     !263
         MK.CMPW                                                    !263
         LD        R6,T.SPAD3,X3                                    !263
         MK.CMPW                                                    !263
MEM4A.L  STH       R6,SMT.MAPS,X1                                   !263
         MK.CMPW                                                    !263
MEM4A.E  EQU       $                                                !263
         FI.ENT    MEM5,MEM5.S,MEM5.E,MEM5.L                        !249
         ACW       *MEMMSTRT                                        !249
         ACW       *MEMMEND                                         !249
MEM5.S   LW        R3,C.REGS                                        !249
         MK.CMPW                                                    !249
         LW        R2,T.REGP,X3                                     !249
         MK.CMPW                                                    !249
         LW        R3,T.SPAD2,X2                                    !249
         MK.CMPW                                                    !249
         LW        R2,C.REGS                                        !249
         MK.CMPW                                                    !249
MEM5.L   LH        R2,T.ATBIAS,X2                                   !249
         MK.CMPW                                                    !249
         ADR       R2,R3                                            !249
         SLL       R3,13                                            !249
         MK.CMPW                                                    !249
MEM5.E   EQU       $                                                !249
         FI.ENT    MEM6,MEM6.S,MEM6.E,MEM6.L                        !249
         ACW       *MEMMSTRT                                        !249
         ACW       *MEMMEND                                         !249
MEM6.S   STW       R1,T.SPAD1,X2                                    !249
         MK.CMPW                                                    !249
MEM6.L   LH        R4,SMT.MAPS,X1                                   !249
         MK.CMPW                                                    !249
         TBM       SMT.SHIM,SMT.FLAG,X1                             !249
         MK.CMPW                                                    !249
         BS        0                                                !249
         MK.NOADR                                                   !249
         TBM       SMT.LIN,SMT.FLAG,X1                              !249
         MK.CMPW                                                    !249
MEM6.E   EQU       $                                                !249
         FI.ENT    MEM7,MEM7.S,MEM7.E,MEM7.L                        !249
         ACW       S.MEMM5                                          !249
         ACW       S.MEMM7                                          !249
MEM7.S   STH       R4,DQE.MAPN,X2                                   !249
         MK.CMPW                                                    !249
         LB        R2,DQE.NUM,X2                                    !249
         MK.CMPW                                                    !249
         SLL       R2,3                                             !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         ADMW      R2,C.MPL                                         !249
         MK.CMPW                                                    !249
MEM7.L   STH       R4,1H,X2                                         !249
         MK.CMPW                                                    !249
         LW        R2,T.PRNO,X3                                     !249
         MK.CMPW                                                    !249
MEM7.E   EQU       $                                                !249
         FI.ENT    MEM8,MEM8.S,MEM8.E,MEM8.L                        !249
         ACW       S.MEMM19                                         !249
         ACW       S.MEMM20                                         !249
MEM8.S   LW        R2,T.PRNO,X3                                     !249
         MK.CMPW                                                    !249
         STH       R4,DQE.MAPN,X2                                   !249
         MK.CMPW                                                    !249
         LB        R2,DQE.NUM,X2                                    !249
         MK.CMPW                                                    !249
         SLL       R2,3                                             !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
         ADMW      R2,C.MPL                                         !249
         MK.CMPW                                                    !249
MEM8.L   STH       R4,1H,X2                                         !249
         MK.CMPW                                                    !249
MEM8.E   EQU       $                                                !249
         FI.ENT    MEM9,MEM9.S,MEM9.E,MEM9.L                        !249
         ACW       S.MEMM20                                         !249
         ACW       S.MEMM21                                         !249
MEM9.S   LH        R5,T.EASZ,X3                                     !249
         MK.CMPW                                                    !249
         ADR       R5,R4                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         LH        R5,T.NSTAT,X3                                    !249
         MK.CMPW                                                    !249
         SUR       R5,R4                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
MEM9.L   LH        R3,T.ATBIAS,X3                                   !249
         MK.CMPW                                                    !249
MEM9.E   EQU       $                                                !249
         FI.ENT    MEM9A,MEM9A.S,MEM9A.E,MEM9.L,REPEAT              !282
         ACW       S.MEMM20                                         !282
         ACW       S.MEMM21                                         !282
MEM9A.S  LW        R4,0                                             !282
         MK.NOADR                                                   !282
         LMH       R3,C.TMCC                                        !282
         MK.CMPW                                                    !282
         SUR       R3,R5                                            !282
         NOP                                                        !282
         MK.CMPW                                                    !282
MEM9A.L  ADMB      R5,C.MSD                                         !282
         MK.CMPW                                                    !282
         ADMB      R5,C.MSD2                                        !282
         MK.CMPW                                                    !282
MEM9A.E  EQU       $                                                !282
* ----------------------------------------------------------------- !249
*  TAMM code                                                        !249
* ----------------------------------------------------------------- !249
         FI.ENT    TAM1,TAM1.S,TAM1.E,TAM1.L                        !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM1.S   LW        R5,RG.BYTEC,X2                                   !249
         MK.CMPW                                                    !249
         BZ        0                                                !249
         MK.NOADR                                                   !249
         LW        R7,RG.ORGC,X2                                    !249
         MK.CMPW                                                    !249
TAM1.L   ANMW      R7,0                                             !249
         MK.NOADR                                                   !249
         STW       R7,RG.LOAD,X2                                    !249
         MK.CMPW                                                    !249
         BL        0                                                !249
         MK.NOADR                                                   !249
TAM1.E   EQU       $                                                !249
         FI.ENT    TAM2,TAM2.S,TAM2.E,TAM2.L                        !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM2.S   LW        R6,RG.MAXCT,X2                                   !249
         MK.CMPW                                                    !249
         LW        R5,RG.BYTED,X2                                   !249
         MK.CMPW                                                    !249
         BZ        0                                                !249
         MK.NOADR                                                   !249
         LW        R7,RG.ORGD,X2                                    !249
         MK.CMPW                                                    !249
         TBR       R7,7                                             !249
         NOP                                                        !249
         MK.CMPW                                                    !249
TAM2.L   BS        0                                                !249
         MK.NOADR                                                   !249
TAM2.E   EQU       $                                                !249
         FI.ENT    TAM3,TAM3.S,TAM3.E,TAM3.L                        !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM3.S   LW        R6,T.BFCB+FCB.EQTY,X1                            !249
         MK.CMPW                                                    !249
         TRN       R6,R6                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         LW        R2,T.BFCB+FCB.ERWA,X1                            !249
         MK.CMPW                                                    !249
TAM3.L   LW        R7,T.BIAS,X1                                     !249
         MK.CMPW                                                    !249
         STW       R5,T.WKADR,X1                                    !249
         MK.CMPW                                                    !249
         LW        R4,,X2                                           !249
         MK.CMPW                                                    !249
TAM3.L2  BZ        0                                                !249
         MK.NOADR                                                   !249
         LI        R1,-32                                           !249
         MK.CMPW                                                    !249
         TBR       R4,0                                             !249
         NOP                                                        !249
         MK.CMPW                                                    !249
TAM3.L3  BNS       0                                                !249
         MK.NOADR                                                   !249
TAM3.E   EQU       $                                                !249
         FI.ENT    TAM6,TAM6.S,TAM6.E,TAM6.L                        !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM6.S   ADR       R7,R5                                            !249
         SBR       R5,12                                            !249
         MK.CMPW                                                    !249
         STW       R5,,X3                                           !249
         MK.CMPW                                                    !249
TAM6.L   ABR       R3,29                                            !249
         SLL       R4,1                                             !249
         MK.CMPW                                                    !249
         BIB       R1,0                                             !249
         MK.NOADR                                                   !249
TAM6.E   EQU       $                                                !249
         FI.ENT    TAM7,TAM7.S,TAM7.E,TAM7.L                        !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM7.S   BL        0                                                !249
         MK.NOADR                                                   !249
         TRR       R6,R6                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         BNZ       0                                                !249
         MK.NOADR                                                   !249
         LW        R3,T.BBUFA,X1                                    !249
         MK.CMPW                                                    !249
TAM7.L   LD        R6,T.PRJCT,X1                                    !249
         MK.CMPW                                                    !249
TAM7.E   EQU       $                                                !249
         FI.ENT    TAM8,TAM8.S,TAM8.E,TAM8.L                        !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM8.S   LW        R6,PR.TRAN,X2                                    !249
         MK.CMPW                                                    !249
         TBR       R6,7                                             !249
         NOP                                                        !249
         MK.CMPW                                                    !249
TAM8.L   BS        0                                                !249
         MK.NOADR                                                   !249
         LW        R1,T.BIAS,X3                                     !249
         MK.CMPW                                                    !249
         ADR       R1,R6                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         LW        R1,PR.COMD,X2                                    !249
         MK.CMPW                                                    !249
         ADR       R1,R6                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         ANMW      R6,0                                             !249
         MK.NOADR                                                   !249
         STW       R6,T.TRAD,X3                                     !249
         MK.CMPW                                                    !249
         LW        R6,PR.ENDD,X2                                    !249
         MK.CMPW                                                    !249
TAM8.L2  LW        R1,T.BIAS,X3                                     !249
         MK.CMPW                                                    !249
         ADR       R1,R6                                            !264
         NOP                                                        !249
         MK.CMPW                                                    !249
TAM8.E   EQU       $                                                !249
         FI.ENT    TAM8A,TAM8A.S,TAM8A.E,TAM8A.L,REPEAT             !266
         ACW       *TAMMSTRT                                        !264
         ACW       *TAMMEND                                         !264
TAM8A.S  LW        R6,PR.TRAN,X2                                    !264
         MK.CMPW                                                    !264
         TBR       R6,7                                             !264
         NOP                                                        !264
         MK.CMPW                                                    !264
TAM8A.L  BS        0                                                !264
         MK.NOADR                                                   !264
         LW        R1,T.BIAS,X3                                     !264
         MK.CMPW                                                    !264
         ADR       R1,R6                                            !264
         NOP                                                        !264
         MK.CMPW                                                    !264
         LW        R1,PR.COMD,X2                                    !264
         MK.CMPW                                                    !264
         ADR       R1,R6                                            !264
         NOP                                                        !264
         MK.CMPW                                                    !264
         ANMW      R6,0                                             !264
         MK.NOADR                                                   !264
         STW       R6,T.TRAD,X3                                     !264
         MK.CMPW                                                    !264
         LW        R6,PR.ENDD,X2                                    !264
         MK.CMPW                                                    !264
         ANMW      R6,0                                             !264
         MK.NOADR                                                   !264
         LB        R1,PR.FLAG,X2                                    !264
         MK.CMPW                                                    !264
         TBR       R1,PR.ABSD+24                                    !264
         NOP                                                        !264
         MK.CMPW                                                    !264
TAM8A.L3 BS        0                                                !264
         MK.NOADR                                                   !264
         LW        R1,T.BIAS,X3                                     !264
         MK.CMPW                                                    !264
         ADR       R1,R6                                            !264
         NOP                                                        !264
         MK.CMPW                                                    !264
TAM8A.E  EQU       $                                                !264
         FI.ENT    TAM11,TAM11.S,TAM11.E,TAM11.L                    !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM11.S  LI        R5,G'64'                                         !249
         MK.CMPW                                                    !249
         BU        0                                                !249
         MK.NOADR                                                   !249
TAM11.L  LI        R5,G'65'                                         !249
         MK.CMPW                                                    !249
         BU        0                                                !249
         MK.NOADR                                                   !249
TAM11.E  EQU       $                                                !249
         FI.ENT    TAM12,TAM12.S,TAM12.E,TAM12.L                    !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM12.S  LA        R5,DQE.PSSF,X2                                   !249
         MK.CMPW                                                    !249
TAM12.L  STW       R5,DQE.PSSF,X2                                   !249
         MK.CMPW                                                    !249
TAM12.L2 STW       R5,DQE.PSSB,X2                                   !249
         MK.CMPW                                                    !249
TAM12.E  EQU       $                                                !249
         FI.ENT    TAM14,TAM14.S,TAM14.E,TAM14.L                    !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM14.S  M.CALL    H.TAMM,1                                         !249
TAM14.L  EQU       TAM14.S                                          !249
         MK.MCALL                                                   !249
         STW       R6,T.BIAS,X3                                     !249
         MK.CMPW                                                    !249
         TRR       R7,R7                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         BNZ       0                                                !249
         MK.NOADR                                                   !249
         LW        R1,T.IDXA,X3                                     !249
         MK.CMPW                                                    !249
TAM14.E  EQU       $                                                !249
         FI.ENT    TAM15,TAM15.S,TAM15.E,TAM15.L                    !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM15.S  LW        R6,T.TEND,X3                                     !249
         MK.CMPW                                                    !249
         CAR       R6,R5                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
TAM15.L  BLT       0                                                !249
         MK.NOADR                                                   !249
         BU        0                                                !249
         MK.NOADR                                                   !249
         LW        R5,T.TEND,X3                                     !249
         MK.CMPW                                                    !249
TAM15.L2 STW       R5,T.BIAS,X3                                     !249
         MK.CMPW                                                    !249
TAM15.E  EQU       $                                                !249
         FI.ENT    TAM17,TAM17.S,TAM17.E,TAM17.L                    !249
         ACW       *TAMMSTRT                                        !249
         ACW       *TAMMEND                                         !249
TAM17.S  LH        R4,T.TSASZ,X3                                    !249
         MK.CMPW                                                    !249
         ADR       R4,R6                                            !249
         CAR       R6,R5                                            !249
         MK.CMPW                                                    !249
TAM17.L  BGT       0                                                !249
         MK.NOADR                                                   !249
         LH        R6,T.ATBIAS,X3                                   !249
         MK.CMPW                                                    !249
         ADR       R6,R5                                            !249
         SLL       R5,SHIFTA                                        !249
         MK.CMPW                                                    !249
         SUI       R5,1W                                            !249
         MK.CMPW                                                    !249
TAM17.E  EQU       $                                                !249
* ----------------------------------------------------------------- !249
*  TSM code                                                         !249
* ----------------------------------------------------------------- !249
         FI.ENT    TSM1,TSM1.S,TSM1.E,TSM1.L                        !249
         ACW       *TSMSTRT                                         !249
         ACW       *TSMEND                                          !249
TSM1.S   LW        R6,FCB.TCW,X2                                    !249
         MK.CMPW                                                    !249
         M.CALL    H.IOCS,30                                        !249
         MK.MCALL                                                   !249
TSM1.L   TRN       R4,R4                                            !249
         TRR       R6,R2                                            !249
         MK.CMPW                                                    !249
TSM1.L2  ANMW      R2,0                                             !249
         MK.NOADR                                                   !249
TSM1.L3  BL        0                                                !249
         MK.NOADR                                                   !249
TSM1.E   EQU       $                                                !249
         FI.ENT    TSM4,TSM4.S,TSM4.E,TSM4.L                        !249
         ACW       *TSMSTRT                                         !249
         ACW       *TSMEND                                          !249
TSM4.S   LW        R1,FCB.TCW,X1                                    !249
         MK.CMPW                                                    !249
TSM4.L   EQU       TSM4.S                                           !249
         ANR       R4,R1                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         SUI       R1,1B                                            !249
         MK.CMPW                                                    !249
         BU        0                                                !249
         MK.NOADR                                                   !249
         LW        R4,0                                             !249
         MK.NOADR                                                   !249
TSM4.L2  LW        R1,FCB.TCW,X1                                    !249
         MK.CMPW                                                    !249
         ANR       R4,R1                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
TSM4.L3  LB        R0,0,X1                                          !249
         MK.CMPW                                                    !249
         LB        R4,T.LINNO+1B,X3                                 !249
         MK.CMPW                                                    !249
TSM4.E   EQU       $                                                !249
         FI.ENT    TSM7,TSM7.S,TSM7.E,TSM7.L                        !249
         ACW       *TSMSTRT                                         !249
         ACW       *TSMEND                                          !249
TSM7.S   LW        R6,FCB.TCW,X1                                    !249
         MK.CMPW                                                    !249
         M.CALL    H.IOCS,30                                        !249
         MK.MCALL                                                   !249
         TRR       R4,R5                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
TSM7.L   ANMW      R6,0                                             !249
         MK.NOADR                                                   !249
         TRSW      R0                                               !249
         NOP                                                        !249
         MK.CMPH                                                    !249
         MK.NOMKH                                                   !249
TSM7.E   EQU       $                                                !249
         FI.ENT    TSM8,TSM8.S,TSM8.E,TSM8.L                        !249
         ACW       *TSMSTRT                                         !249
         ACW       *TSMEND                                          !249
TSM8.S   LW        R2,T.REGP,X3                                     !249
         MK.CMPW                                                    !249
TSM8.L   LW        R5,T.CONTXT+8W,X3                                !249
         MK.CMPW                                                    !249
         M.CALL    H.TSM,10                                         !249
         MK.MCALL                                                   !249
         STD       R6,T.SPAD19,X2                                   !249
         MK.CMPW                                                    !249
         LA        R1,T.SPAD19,X2                                   !249
         MK.CMPW                                                    !249
         LA        R2,,X2                                           !249
         MK.NOADR                                                   !249
         LI        R4,-8                                            !249
         MK.CMPW                                                    !249
         BL        0                                                !249
         MK.NOADR                                                   !249
         LW        R2,T.REGP,X3                                     !249
         MK.CMPW                                                    !249
TSM8.L2  LW        R5,T.BIAS,X3                                     !249
         MK.CMPW                                                    !249
TSM8.E   EQU       $                                                !249
* ----------------------------------------------------------------- !249
* BKDM Patches                                                      !249
* ----------------------------------------------------------------- !249
         FI.ENT    BKDM1,BKDM1.S,BKDM1.E,BKDM1.L                    !249
         ACW       *BKOPSTRT                                        !249
         ACW       *BKOPEND                                         !249
BKDM1.S  LB        R6,FCB.OPCD,X1                                   !249
         MK.CMPW                                                    !249
         LW        R2,C.REGS                                        !249
         MK.CMPW                                                    !249
         LW        R2,T.REGP,X2                                     !249
         MK.CMPW                                                    !249
         STB       R6,T.SPAD3,X2                                    !249
         MK.CMPW                                                    !249
         ZR        R6                                               !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         STB       R6,0,X2                                          !249
         MK.NOADR                                                   !249
BKDM1.L  LW        R6,FCB.ERRT,X1                                   !249
         MK.CMPW                                                    !249
BKDM1.E  EQU       $                                                !249
* ----------------------------------------------------------------- !249
* IP04 Patches                                                      !249
* ----------------------------------------------------------------- !249
         FI.ENT    IP41,IP41.S,IP41.E,IP41.L                        !249
         ACW       *IP04STRT                                        !249
         ACW       *IP04END                                         !249
IP41.S   ABM       31,C.GINT                                        !249
         MK.CMPW                                                    !249
         STF       R0,0                                             !249
         MK.NOADR                                                   !249
         LD        R6,0                                             !249
         MK.NOADR                                                   !249
         BL        0                                                !249
         MK.NOADR                                                   !249
         BU        0                                                !249
         MK.NOADR                                                   !249
         STD       R6,0                                             !249
         MK.NOADR                                                   !249
         LI        R5,-1                                            !249
         MK.CMPW                                                    !249
         ARMW      R5,C.GINT                                        !249
         MK.CMPW                                                    !249
         LF        R0,0                                             !249
         MK.NOADR                                                   !249
IP41.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
IP41.E   EQU       $                                                !249
* ----------------------------------------------------------------- !249
* IP05 Patches                                                      !249
* ----------------------------------------------------------------- !249
         FI.ENT    IP51,IP51.S,IP51.E,IP51.L                        !249
         ACW       *IP05STRT                                        !249
         ACW       *IP05END                                         !249
IP51.S   ABM       31,C.GINT                                        !249
         MK.CMPW                                                    !249
         STF       R0,0                                             !249
         MK.NOADR                                                   !249
         LD        R6,0                                             !249
         MK.NOADR                                                   !249
         BL        0                                                !249
         MK.NOADR                                                   !249
         BU        0                                                !249
         MK.NOADR                                                   !249
         STD       R6,0                                             !249
         MK.NOADR                                                   !249
         LI        R5,-1                                            !249
         MK.CMPW                                                    !249
         ARMW      R5,C.GINT                                        !249
         MK.CMPW                                                    !249
         LF        R0,0                                             !249
         MK.NOADR                                                   !249
IP51.L   LPSD      0                                                !249
         MK.NOADR                                                   !249
IP51.E   EQU       $                                                !249
* ----------------------------------------------------------------- !249
* SURE Code                                                         !249
* ----------------------------------------------------------------- !249
         FI.ENT    SUR1,SUR1.S,SUR1.E,SUR1.L                        !249
         ACW       *SURESTRT                                        !249
         ACW       *SUREEND                                         !249
SUR1.S   STW       R0,C.REGS                                        !249
         MK.CMPW                                                    !249
         STW       R0,C.CTSAD                                       !249
         MK.CMPW                                                    !249
         ADI       R0,T.REGS                                        !249
         MK.CMPW                                                    !249
         STW       R0,C.CREGS                                       !249
         MK.CMPW                                                    !249
         LW        R6,C.SCOFDQ                                      !249
         MK.CMPW                                                    !249
         TRSC      R2,R6                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
SUR1.L   LPSDCM    0                                                !249
         MK.NOADR                                                   !249
SUR1.E   EQU       $                                                !249
* ----------------------------------------------------------------- !249
* ICP Code                                                          !249
* ----------------------------------------------------------------- !249
         FI.ENT    ICP1,ICP1.S,ICP1.E,ICP1.L                        !249
         ACW       *ICPSTRT                                         !249
         ACW       *ICPEND                                          !249
ICP1.S   ZBM       DQE.INAC,DQE.USHF,X2                             !249
         MK.CMPW                                                    !249
         LW        R0,T.FSSP,X3                                     !249
         MK.CMPW                                                    !249
         STW       R0,C.FSSP                                        !249
         MK.CMPW                                                    !249
         LW        R6,T.REGP,X3                                     !249
         MK.CMPW                                                    !249
         SUI       R6,32W                                           !249
         MK.NOMKW                   DIFFERENT ON 3.5 U02            !266
         STW       R6,T.REGP,X3                                     !249
         MK.CMPW                                                    !249
         ZBM       0,0                                              !249
         MK.BM                                                      !249
         LW        R6,C.SCOFDQ                                      !249
         MK.CMPW                                                    !249
         TRSC      R2,R6                                            !249
         NOP                                                        !249
         MK.CMPW                                                    !249
         LF        R0,T.R0,X1                                       !249
         MK.CMPW                                                    !249
ICP1.L   LPSDCM    0                                                !249
         MK.NOADR                                                   !249
ICP1.E   EQU       $                                                !249
         FI.ENT    ICP2,ICP2.S,ICP2.E,ICP2.L                        !249
         ACW       *ICPSTRT                                         !249
         ACW       *ICPEND                                          !249
ICP2.S   LF        R0,0,X2                                          !249
         MK.CMPW                                                    !249
ICP2.L   LPSD      EXEC.D1                                          !249
         MK.CMPW                                                    !249
         BU        0                                                !249
         MK.NOADR                                                   !249
ICP2.E   EQU       $                                                !249
         FI.ENT    ICP2A,ICP2A.S,ICP2A.E,ICP2A.L,REPEAT             !275
         ACW       *ICPSTRT                                         !275
         ACW       *ICPEND                                          !275
ICP2A.S  LF        R0,0                                             !275
         MK.NOADR                                                   !275
ICP2A.L  LPSD      EXEC.D1                                          !275
         MK.CMPW                                                    !275
         LPSD      0                                                !275
         MK.NOADR                                                   !275
ICP2A.E  EQU       $                                                !275
* ----------------------------------------------------------------- !257
* RMSS Code                                                         !257
* ----------------------------------------------------------------- !257
         FI.ENT    RMS1,RMS1.S,RMS1.E,RMS1.L                        !257
         ACW       *RMSSSTRT                                        !257
         ACW       *RMSSEND                                         !257
RMS1.S   ABM       31,C.GINT                                        !257
         MK.CMPW                                                    !257
         STF       R0,0                                             !257
         MK.NOADR                                                   !257
         LA        R3,0                                             !257
         MK.NOADR                                                   !257
         BL        0                                                !257
         MK.NOADR                                                   !257
         LI        R0,-1                                            !257
         MK.CMPW                                                    !257
         ARMW      R0,C.GINT                                        !257
         MK.CMPW                                                    !257
         LF        R0,0                                             !257
         MK.NOADR                                                   !257
RMS1.L   LPSD      0                                                !257
         MK.NOADR                                                   !257
RMS1.E   EQU       $                                                !257
         FI.ENT    RMS2,RMS2.S,RMS2.E,RMS2.L                        !257
         ACW       *RMSSSTRT                                        !257
         ACW       *RMSSEND                                         !257
RMS2.S   ABM       31,C.GINT                                        !257
         MK.CMPW                                                    !257
         STW       R0,0                                             !257
         MK.NOADR                                                   !257
         LI        R0,-1                                            !257
         MK.CMPW                                                    !257
         ARMW      R0,C.GINT                                        !257
         MK.CMPW                                                    !257
         LW        R0,0                                             !257
         MK.NOADR                                                   !257
RMS2.L   LPSD      0                                                !257
         MK.NOADR                                                   !257
RMS2.E   EQU       $                                                !257
*279 FI.NR    SET       FI.NR-1         Back it up since RMS3 has the    !262
*279 *        same error as RMS2, and RMS2 will never really generate    !262
*279 *        an error.  If we can't find the RMS2 sequence, we don't    !262
*279 *        abort; we just go to RMS3.                                 !262
         FI.ENT    RMS2A,RMS2A.S,RMS2A.E,RMS2A.L,REPEAT             !279
         ACW       *RMSSSTRT                                        !262
         ACW       *RMSSEND                                         !262
RMS2A.S  ABM       31,C.GINT                                        !279
         MK.CMPW                                                    !262
         STW       R0,0                                             !262
         MK.NOADR                                                   !262
         LI        R0,-1                                            !262
         MK.CMPW                                                    !262
         TBM       2,0                                              !262
         MK.BM                                                      !262
         BNS       0                                                !262
         MK.NOADR                                                   !262
         EXM       0                                                !262
         MK.NOADR                                                   !262
         ARMW      R0,C.GINT                                        !262
         MK.CMPW                                                    !262
         LW        R0,0                                             !262
         MK.NOADR                                                   !262
RMS2A.L  LPSD      0                                                !279
         MK.NOADR                                                   !262
RMS2A.E  EQU       $                                                !279
         FI.ENT    RMS2B,RMS2B.S,RMS2B.E,RMS2B.L,REPEAT             !279
         ACW       *RMSSSTRT                                        !279
         ACW       *RMSSEND                                         !279
RMS2B.S  ABM       31,C.GINT                                        !279
         MK.CMPW                                                    !279
         STW       R0,0                                             !279
         MK.NOADR                                                   !279
         STW       R1,0                                             !279
         MK.NOADR                                                   !279
         LI        R0,-1                                            !279
         MK.CMPW                                                    !279
         LW        R1,0                                             !279
         MK.NOADR                                                   !279
         TBM       PSM.TRAP,PSM.FLAG,X1                             !279
         MK.CMPW                                                    !279
         BNS       0                                                !279
         MK.NOADR                                                   !279
         EXM       0                                                !279
         MK.NOADR                                                   !279
         ARMW      R0,C.GINT                                        !279
         MK.CMPW                                                    !279
         LW        R0,0                                             !279
         MK.NOADR                                                   !279
         LW        R1,0                                             !279
         MK.NOADR                                                   !279
RMS2B.L  LPSD      0                                                !279
         MK.NOADR                                                   !279
RMS2B.E  EQU       $                                                !279
*                                                                   !249
* ================================================================= !249
*                                                                   !249
*  END of code entries that H.PTCH will look for                    !249
*                                                                   !249
* ================================================================= !249
*-------------------------------------------------------------------
*  MPX 3.5, 3.5U00A, and 3.5 U01 PATCHES                            !258
*--------------------------------------------------------------------
         BOUND     1W
FI.STRT  EQU       $                                                !249
         TBM       2,C.CONF        IS IPU PRESENT
         BNS       IPU.NONE        BR IF NONE HERE
*--------------------------------------------------------------------
*
* H.IPU PATCHES - MPX 3.5                                           !249
*
*--------------------------------------------------------------------
         LW        R3,X'4C'        Addr of IPU.ICB
         SUI       R3,X'20'
         STW       R3,IPUSTRT      Where we'll start searching      !249
         ADI       R3,X'3000'                                       !249
         STW       R3,IPUEND       Where we'll end searching        !249
*********
         LA        R2,IPU1         First set of instrs to find      !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         LW        R4,=X'EC000001' GET BU INSTR
         LA        R2,S.TRV.X      GET ADDRESS
         SBR       R2,31           LEFT HW BRANCH
         ORR       R2,R4           NEW ADDRESS
         STW       R4,,X3          PUT IN H.IPU                 *239*
         LA        R2,IPU1.L2-IPU1.L/2,X3                           !249
         LW        R4,=X'EC000001' GET BU INSTR
         ORR       R4,R2           NEW ADDRESS
         STW       R2,S.X.06       PUT IN TXPM
         LA        R2,IPU1.L3-IPU1.L/2,X3     IPU.12 ADDRESS        !249
         STW       R2,IPU.12       PUT IN TXPM
*********
* SEARCH FOR LPSDCM INSTRUCTION DOING REMAP TO NEW TASK
         LA        R2,IPU2         Next set of instrs to find       !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         LW        R6,0W,X3        GET INSTRUCTION AGAIN
         STW       R6,TRV54RPL     PUT IN TXPM
         LW        R6,$+3W         GET BRANCH INSTR
         STW       R6,0W,X3        REPLACE LPSDCM INSTR
         BU        $+2W            GET OUT
         BU        S.TRV.54        TXPM ROUTINE ADDR
*********
         LA        R2,IPU3         Next set of instrs to find       !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         LW        R4,=X'20002'    2 NOP'S
         STW       R4,,X3          NOP CLEAR C.ICSIPU INSTR     *239*
         LA        R1,*1W,X3       Pull out addr from LPSD instr
         LW        R4,$+3W         GET BRANCH INSTRUCTION
         STW       R4,1W,X3        PUT IN H.IPU                 *239*
         BU        $+2W            SKIP
         BU        S.TRV.50        MAIN IPU DISPATCH
         TRR       R1,R2           IPU.D1 address
         ORMW      R2,IPU.REPL     LOAD INSTR
         STW       R2,IPU.REPL
         TRR       R1,R2           IPU.D1 address
         ORMW      R2,IPU.RET      RETURN LPSD
         STW       R2,IPU.RET
*********
         LA        R2,IPU4                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         SBR       R3,31
         STW       R3,IPU.04       PUT IN TXPM
*********
         LA        R2,IPU5                                          !253
         BL        FINDINST                                         !253
         BNS       NOTFOUND                                         !253
*253          LA        R2,X'2A0',X3    UIT.OLD ADDRESS              *239*
         LA        R2,*IPU5.L2-IPU5.L/2,X3 UIT.OLD address          !253
         ORMW      R2,IPUI.RPL     LOAD INSTR                   *232*
         STW       R2,IPUI.RPL     PUT IN CODE                  *232*
*253          LA        R2,X'2A0',X3    UII.OLD ADDRESS              *239*
         LA        R2,*IPU5.L2-IPU5.L/2,X3 UIT.OLD address          !253
         ORMW      R2,IPUI.RT      RETURN LPSD                  *232*
         STW       R2,IPUI.RT      PUT IN CODE                  *232*
         LW        R4,=X'20002'    2 NOP'S                      *232*
*253          STW       R4,X'2E0',X3    NOP CLEAR C.ICSIPU INSTR     *239*
         STW       R4,,X3          NOP clear C.ICSIPU instr         !253
         LW        R4,$+3W         GET BRANCH INSTRUCTION       *232*
*253         STW       R4,X'2E4',X3    FIX UI01 DISPATCH            *239*
         STW       R4,IPU5.L2-IPU5.L/2,X3 Fix UI01 dispatch         !253
         BU        $+2W            SKIP                         *232*
         BU        IPUI.DSP        IPU UI01 DISPATCH            *232*
*********
         LA        R2,IPU6                                          !253
         BL        FINDINST                                         !253
         BNS       NOTFOUND                                         !253
*253          LA        R2,X'318',X3    PVT.OLD ADDRESS              *239*
         LA        R2,*IPU6.L2-IPU6.L/2,X3 PVT.OLD address          !253
         ORMW      R2,IPPV.RPL     LOAD INSTR                   *232*
         STW       R2,IPPV.RPL     PUT IN CODE                  *232*
*253          LA        R2,X'318',X3    PVT.OLD ADDRESS              *239*
         LA        R2,*IPU6.L2-IPU6.L/2,X3 PVT.OLD address          !253
         ORMW      R2,IPPV.RT      RETURN LPSD                  *232*
         STW       R2,IPPV.RT      PUT IN CODE                  *232*
         LW        R4,=X'20002'    2 NOP'S                      *232*
*253          STW       R4,X'354',X3    NOP CLEAR C.ICSIPU INSTR     *239*
         STW       R4,,X3          NOP clear C.ICSIPU instr         !253
         LW        R4,$+3W         GET BRANCH INSTRUCTION       *232*
*253          STW       R4,X'358',X3    FIX PV01 DISPATCH            *239*
         STW       R4,IPU6.L2-IPU6.L/2,X3 Fix PV01 dispatch         !253
         BU        $+2W            SKIP                         *232*
         BU        IPPV.DSP        IPU PV01 DISPATCH            *232*
*********
         LA        R2,IPU7                                          !253
         BL        FINDINST                                         !253
         BNS       NOTFOUND                                         !253
         LA        R2,*IPU7.L2-IPU7.L/2,X3 get SVC.PSD addr         !253
         ORMW      R2,ISVC.RPL     LOAD INSTR                       !253
         STW       R2,ISVC.RPL                                      !253
         LA        R2,*IPU7.L2-IPU7.L/2,X3 get SVC.PSD addr         !253
         ORMW      R2,ISVC.RET     RESTURN LPSD                     !253
         STW       R2,ISVC.RET                                      !253
         LW        R4,=X'20002'    2 NOP'S
*253          STW       R4,X'64C',X3    NOP CLEAR C.ICSIPU INSTR     *239!244
         STW       R4,,X3          NOP clear C.ICSIPU instr         !253
         LW        R4,$+3W         GET BRANCH INSTRUCTION
*253          STW       R4,X'650',X3    FIX SVC DISPATCH             *239!244
         STW       R4,IPU7.L2-IPU7.L/2,X3 Fix SVC dispatch          !253
         BU        $+2W            SKIP
         BU        S.TRV.53        IPU SVC DISPATCH
*253          LA        R2,X'698',X3    SVC.PSD ADDRESS              *239!244
*253          ORMW      R2,ISVC.RPL     LOAD INSTR
*253          STW       R2,ISVC.RPL
*253          LA        R2,X'698',X3    SVC.PSD ADDRESS              *239!244
*253          ORMW      R2,ISVC.RET     RESTURN LPSD
*253          STW       R2,ISVC.RET
*********
         LA        R2,IPU8                                          !253
         BL        FINDINST                                         !253
         BNS       NOTFOUND                                         !253
*253          LA        R2,X'7E0',X3    SVC9.OLD ADDRESS             *239!244
         LA        R2,*IPU8.L2-IPU8.L/2,X3 SVC9.OLD address         !253
         ORMW      R2,IPU9.RPL     LOAD INSTR
         STW       R2,IPU9.RPL
         LA        R2,*IPU8.L2-IPU8.L/2,X3 SVC9.OLD address         !253
*253          LA        R2,X'7E0',X3    SVC9.OLD ADDRESS             *239!244
         ORMW      R2,IPU9.RET     RESTURN LPSD
         STW       R2,IPU9.RET
         LW        R4,=X'20002'    NOP/NOP PAIR
*253          STW       R4,X'80C',X3    DISABLE DEXP BRANCH          *239!244
         STW       R4,,X3          Disable DEXP branch              !253
         LW        R4,$+3W         GET BRANCH INSTRUCTION
*253          STW       R4,X'82C',X3    PUT IN H.IPU                 *239!244
         STW       R4,IPU8.L2-IPU8.L/2,X3 Put in H.IPU              !253
         BU        $+2W            SKIP
         BU        S.TRV.51        IPU SVC9 DISPATCH
*********
         LA        R2,IPU9                                          !253
         BL        FINDINST                                         !253
         BNS       NOTFOUND                                         !253
*253          LA        R2,X'860',X3    IP0F.OLD ADDRESS             *239*
         LA        R2,*0,X3         IP0F.OLD address                !256
         ORMW      R2,IPUF.RPL     LOAD INSTR
         STW       R2,IPUF.RPL
*253          LA        R2,X'860',X3    IP0F.OLD ADDRESS             *239*
         LA        R2,*0,X3         IP0F.OLD address                !256
         ORMW      R2,IPUF.RET     RETURN LPSD
         STW       R2,IPUF.RET
         LW        R4,=X'20002'    2 NOP'S
*253          STW       R4,X'898',X3    DISABLE DEXP BRANCH          *239*
         STW       R4,IPU9.L2-IPU9.L/2,X3 Disable DEXP branch       !253
**********
         LA        R2,IPU10                                         !253
         BL        FINDINST                                         !253
         BNS       NOTFOUND                                         !253
*253          STW       R4,X'9B4',X3    NOP CLEAR C.ICSIPU INSTR     *239*
         STW       R4,,X3          NOP clear C.ICSIPU instr         !253
         LW        R4,$+3W         GET BRANCH INSTRUCTION
*253          STW       R4,X'9B8',X3    PUT IN H.IPU                 *239*
         STW       R4,IPU10.L2-IPU10.L/2,X3 Put in H.IPU            !253
         BU        $+2W            SKIP
         BU        S.TRV.52        IPU IP0F DISPATCH
*********
IPU.NONE EQU       $
*--------------------------------------------------------------------
*
* H.EXEC PATCHES
*
*--------------------------------------------------------------------
         LA        R3,H.EXEC.  GET ADDRESS OF H.EXEC                !249
         STW       R3,EXECSTRT                                      !249
         ADI       R3,X'3000'                                       !249
         STW       R3,EXECEND                                       !249
*
*        FOLLOWING PATCH IN S.EXEC5   LPSD   EXEC.D1
         LA        R2,EXC1                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249  M.PLPSD  H.EXEC.,X'0850',DSP.EX05,PTCH.X5,PTCH.Y5 NESTED INT DISP
         F.PLPSD   R3,DSP.EX05,PTCH.X5,PTCH.Y5  Nested int disp     !249
*        FOLLOWING PATCH IN S.EXEC20  LPSD   EXEC.D1
         LA        R2,EXC2                                          !249
         BL        FINDINST                                         !249
         BS        FND.EXC2                                         !266
         LA        R2,EXC2A         SEE IF 3.5 U02 OR LATER         !266
         BL        FINDINST                                         !266
         BNS       NOTFOUND                                         !249
*249  M.PLPSD  H.EXEC.,X'0D48',DSP.MN,PTCH.08,PTCH.09  MAIN EXEC DISP
FND.EXC2 F.PLPSD   R3,DSP.MN,PTCH.08,PTCH.09 Main exec disp         !266
*        FOLLOWING PATCH IN S.EXEC20  LPSDCM EXEC.NP1
         LA        R2,EXC3                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         LW        R6,,X3          GET INSTRUCTION AGAIN
         STW       R6,TRV39RPL     PUT IN TXPM
         LW        R6,$+3W         GET BRANCH INSTR
         STW       R6,,X3          REPLACE LPSDCM INSTR
         BU        $+2W            GET OUT
         BU        S.TRV.39        TXPM ROUTINE ADDR
*        FOLLOWING PATCH IN S.EXEC21  LPSD   SX21.4T
         LA        R2,EXC4                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249  M.PLPSD  H.EXEC.,X'13CC',DSP.BR,PTCH.10,PTCH.11  BRK RCVR DISP
         F.PLPSD   R3,DSP.BR,PTCH.10,PTCH.11  BRK RCVR disp         !249
*     FOLLOWING PATCH IN S.EXEC21  LPSD   4W,X2
         LA        R2,EXC5                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         LW        R6,$+3W         GET BRANCH INSTR
         STW       R6,,X3          REPLACE LPSD INSTR
         BU        EX.E2X          GET OUT
         BU        DSP.EA2         TXPM ROUTINE ADDR
EX.E2X   EQU       $               DONE...
*        FOLLOWING PATCH IN S.EXEC21  LPSD   SX21.6T
         LA        R2,EXC6                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249  M.PLPSD  H.EXEC.,X'154C',DSP.MR,PTCH.12,PTCH.13  MSG RCVR DISP
         F.PLPSD   R3,DSP.MR,PTCH.12,PTCH.13  MSF RCVR disp         !249
*        FOLLOWING PATCH IN S.EXEC27  LPSD   SX27.PSD
         LA        R2,EXC7                                          !249
         BL        FINDINST                                         !249
         BS        DO.EXC7                                          !280
* We haven't found it yet, but Release 3.5u02a is slightly          !280
* different so let's check it out                                   !280
         LA        R2,EXC7A                                         !280
         BL        FINDINST                                         !280
         BNS       NOTFOUND                                         !249
*249  M.PLPSD  H.EXEC.,X'1864',DSP.AR,PTCH.14,PTCH.15  ABRT RCVR DISP
DO.EXC7  EQU       $                                                !280
         F.PLPSD   R3,DSP.AR,PTCH.14,PTCH.15  ABRT RCVR disp        !249
*        FOLLOWING PATCH IN S.EXEC68  LPSD   SX68.PSD
         LA        R2,EXC8                                          !249
         BL        FINDINST                                         !249
         BS        DO.EXC8                                          !249
*  We haven't found it, but that's because EXEC3 differs from       !249
*  EXEC and EXEC2 in this area.  So let's look for the EXEC3        !249
*  version.                                                         !249
         LA        R2,EXC9                                          !249
         BL        FINDINST                                         !249
         BS        DO.EXC8         Found it                         !277
*  We still haven't found it, but EXEC has changed for 3.5U02.      !277
*  So let's look for a slightly different sequence.                 !277
         LA        R2,EXC9A                                         !277
         BL        FINDINST                                         !277
         BS        DO.EXC8                                          !280
*  Could still be 3.5u02A.  Let's look once more.                   !280
         LA        R2,EXC9B                                         !280
         BL        FINDINST                                         !280
         BNS       NOTFOUND                                         !249
*249  M.PLPSD  H.EXEC.,X'1EE0',DSP.EA,PTCH.16,PTCH.17  I/O E.A. DISP
DO.EXC8  F.PLPSD   R3,DSP.EA,PTCH.16,PTCH.17  IO E.A. disp          !249
         LA        R1,H.EXSUB.                                      !249
         STW       R1,EXSBSTRT                                      !249
         ADI       R1,X'2000'                                       !249
         STW       R1,EXSBEND                                       !249
*        FOLLOWING PATCH IN S.EXEC63                            *232*
         LA        R2,EXS1                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHC   H.EXSUB.,X'0C74' UNBIAS RXB
         F.PTCHC   R3           Unbias RXB                          !249
         BU        TRV.16                                       *232*
         ADI       R3,1W                                            !249
*249          M.PTCHC   H.EXSUB.,X'0C78' USE 20 BIT MASK (NOT 19 BIT)
         F.PTCHC   R3           Use 20-bit mask, not 19-bit         !249
         DATAW     X'00020002'                                  *232*
         ADI       R3,1W                                            !249
*249          M.PTCHCT  TRV.16.R,H.EXSUB.,X'0C7C'  ; BU  RETURN
         F.PTCHCT  TRV.16.R,R3  BU RETURN                           !249
*        FOLLOWING PATCH IN S.EXEC64                            *232*
         LA        R2,EXS2                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.EXSUB.,X'0CDC',EAB.MR,EAB.INST,EAB.MRR
         F.PTCHG   R3,EAB.MR,EAB.INST,EAB.MRR                       !249
*        FOLLOWING PATCH IN S.EXEC65                            *232*
         LA        R2,EXS3                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.EXSUB.,X'0D58',EAB.MR1,EAB.INS1,EAB.MRR1
         F.PTCHG   R3,EAB.MR1,EAB.INS1,EAB.MRR1                     !249
*
*--------------------------------------------------------------------
*
* H.IOCS PATCHES
*
*--------------------------------------------------------------------
         LA        R2,H.IOCS.                                       !249
         STW       R2,IOCSSTRT                                      !249
         ADI       R2,X'3000'                                       !249
         STW       R2,IOCSEND                                       !249
* THESE CHANGES IN S.IOCS17
         LA        R2,IOC1                                          !249
         BL        FINDINST                                         !249
         BS        IOC1.PCH        Go if found                      !275
*  If we're here, we haven't found IOC1.  That could be because     !275
*  we're 3.5u02 and later.  In any case, let's look for IOC1A.      !275
         LA        R2,IOC1A                                         !275
         BL        FINDINST                                         !275
         BNS       NOTFOUND                                         !249
IOC1.PCH EQU       $                                                !275
*249          M.PTCHC   H.IOCS.,X'17B0'  DO BU EAB.IO
         F.PTCHC   R3                                               !249
         BU        EAB.IO           DO DISP TO S.EXEC68         *235*
         LA        R2,IOC2                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.IOCS.,X'1800',EAB.IO1,EAB.IO1A
         F.PTCHG   R3,EAB.IO1,EAB.IO1A                              !249
         LA        R2,IOC3                                          !249
         BL        FINDINST                                         !249
         BS        IOC3.PCH        Go if found                      !275
*  If we're here, we haven't found IOC3.  That could be because     !275
*  we're 3.5u02 and later.  In any case, let's look for IOC1A.      !275
         LA        R2,IOC1A                                         !275
         BL        FINDINST                                         !275
         BNS       NOTFOUND                                         !249
IOC3.PCH EQU       $                                                !275
*249          M.PTCHC   H.IOCS.,X'1828'  DO BU EAB.IO
         F.PTCHC   R3                                               !249
         BU        EAB.IO           DO DISP TO S.EXEC68         *235*
         LA        R2,IOC4                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.IOCS.,X'18CC',EAB.IO2,EAB.IO2A,EAB.IO2R
         F.PTCHG   R3,EAB.IO2,EAB.IO2A,EAB.IO2R                     !249
* THESE CHANGES IN S.IOCS20
         LA        R2,IOC5                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.IOCS.,X'1AC0',SHRT.FCB EXTEND TCW ADDRESS
         F.PTCHG   R3,SHRT.FCB  Extended TCW address                !249
         ADI       R3,1W                                            !249
*249          M.PTCHCT  PTCH.23,H.IOCS.,X'1AC4'   ; BU   S.IOCS20+5W
         F.PTCHCT  PTCH.23,R3   BU S.IOCS20+5W                      !249
* THIS CHANGE IN S.IOCS30
         LA        R2,IOC6                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.IOCS.,X'1FC8',S.TRV.40,,TRV.40.L  FCB.SPST
         F.PTCHG   R3,S.TRV.40,,TRV.40.L  FCB.SPST                  !249
*--------------------------------------------------------------------
*
* H.IP0F PATCHES
*
*--------------------------------------------------------------------
*
         LA        R2,IP0F.ICB                                      !249
         STW       R2,IP0FSTRT                                      !249
         ADI       R2,X'C00'                                        !249
         STW       R2,IP0FEND                                       !249
*
         LA        R2,IPF1                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHC   IP0F.ICB,X'38'-X'10'   IGNORE ONLINE DEXP
         F.PTCHC   R3                                               !249
         DATAW     X'00020002'
         LA        R2,IPF2                                          !249
         BL        FINDINST                                         !249
         BS        IPF2.PCH        Go if found                      !275
*  If we're here, then it might be 3.5u02.  Let's use IPF2A.        !275
         LA        R2,IPF2A                                         !275
         BL        FINDINST                                         !275
         BNS       NOTFOUND                                         !249
IPF2.PCH EQU       $                                                !275
*249  M.PLPSD  IP0F.ICB,X'154'-X'10',DSP.AE,PTCH.18,PTCH.19  A.E. DISP
         F.PLPSD   R3,DSP.AE,PTCH.18,PTCH.19  A.E. Dispatch         !249
*--------------------------------------------------------------------
*
* H.IPCL PATCHES
*
*--------------------------------------------------------------------
*
*
         LA        R1,IPCL.ICB                                      !249
         STW       R1,IPCLSTRT                                      !249
         ADI       R1,X'1000'                                       !249
         STW       R1,IPCLEND                                       !249
*249          M.PTCHCT  PTCH.06,IPCL.ICB,X'12'-X'10'   IPCL.OLD
         LA        R3,IPCL.ICB     IPCL.OLD                         !249
         F.PTCHCT  PTCH.06,R3                                       !249
         LA        R2,IPCL1                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         TRR       R3,R7           Save over macro call             !249
*249          M.PTCHCT  PTCH.07,IPCL.ICB,X'02D'-X'10'  IPCL + 1W
         F.PTCHCT  PTCH.07,R3      IPCL+1W                          !249
*249          M.PTCHC   IPCL.ICB,X'38'-X'10'           IGNORE DEXP
         TRR       R7,R3                                            !249
         ADI       R3,IPCL1.L2-IPCL1.L/2                            !249
         F.PTCHC   R3                                               !249
         DATAW     X'00020002'
*249          M.PTCHC   IPCL.ICB,X'3C'-X'10'           IGNORE DEXP
         TRR       R7,R3                                            !249
         ADI       R3,IPCL1.L3-IPCL1.L/2                            !249
         F.PTCHC   R3                                               !249
         DATAW     X'00020002'
*    THE FOLLOWING PATCH CORRECTLY ALLOWS THE ACCELERATOR
*    TO OPERATE.
         LA        R2,IPCL4                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHCT  PTCH.01,IPCL.ICB,X'1D8'-X'10' IPCL.DAI
         F.PTCHCT  PTCH.01,R3      IPCL.DAI                         !249
         LA        R2,IPCL5                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*  R3 now has the address of an instruction that references         !249
*  our target.  We will get that instruction into R3, then use      !249
*  the appropriate macro.                                           !249
*249          M.PTCHCT  PTCH.02,IPCL.ICB,X'394'-X'10' IPCL.ITU
         LW        R7,,X3                                           !249
         F.PTCHCT  PTCH.02,R7      IPCL.ITU                         !249
*249          M.PTCHCT  PTCH.03,IPCL.ICB,X'397'-X'10' IPCL.ITU
         LW        R7,,X3                                           !249
         ADI       R7,3B           Address of last byte             !249
         F.PTCHCT  PTCH.03,R7      IPCL.ITU                         !249
*249          M.PTCHCT  PTCH.04,IPCL.ICB,X'394'-X'10' IPCL.ITU
         LW        R7,,X3                                           !249
         F.PTCHCT  PTCH.04,R7      IPCL.ITU                         !249
*249          M.PTCHCT  PTCH.05,IPCL.ICB,X'397'-X'10' IPCL.ITU
         LW        R7,,X3                                           !249
         ADI       R7,3B           Address of last byte             !249
         F.PTCHCT  PTCH.05,R7      IPCL.ITU                         !249
*--------------------------------------------------------------------
*
* H.MEMM PATCHES
*
*--------------------------------------------------------------------
         LA        R2,H.MEMM.                                       !249
         STW       R2,MEMMSTRT                                      !249
         ADI       R2,X'4800'                                       !249
         STW       R2,MEMMEND                                       !249
* FOLLOWING CHANGES IN H.MEMM,7
         LA        R2,MEM1                                          !249
         BL        FINDINST                                         !249
         BS        DO.MEM1         Go if found                      !263
*  If not found, we could have 3.5U01 code.  Look for it            !263
*264          LI        R3,2            NOP                              !263
*264          STH       R3,TRV.A5.N                                      !263
*264          STH       R3,TRV.A5.N+1H                                   !263
         LA        R2,MEM1A                                         !263
         BL        FINDINST                                         !263
         BNS       NOTFOUND                                         !249
*249        M.PTCHC   H.MEMM.,X'930'  INCLUDED MEMORY PARTITIONS
*263          F.PTCHC   R3                                               !249
*263          BL        S.TRV.A5                                     *232*
DO.MEM1  F.PTCHG   R3,S.TRV.A5,TRV.A5.P,TRV.A5.R                    !263
         LA        R2,MEM2                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHC   H.MEMM.,X'A70'  INCLUDED MEMORY PARTITIONS
         F.PTCHC   R3                                               !249
         BL        S.TRV114
         ADI       R3,MEM2.L2-MEM2.L/2                              !249
*249          M.PTCHC   H.MEMM.,X'A80'  INCLUDED MEMORY PARTITIONS
*263          F.PTCHC   R3                                               !249
*263          BL        S.TRV.A4                                     *232*
*  Now we see what the next instruction is.  It could be an LH,     !263
*  for 3.5 vanilla and 3.5U00A, or it could be SUMB, for 3.5U01.    !263
*  If it's LH, then we just do the patch.  Otherwise we change      !263
*  an instruction in S.TRV.A4, then do the patch.                   !263
         LW        R7,,X3          Pick up next instruction         !263
         CAMW      R7,MEM2.L2      The LH instruction?              !263
         BEQ       DO.MEM3         Go if yes; no updating needed    !263
         CAMW      R7,MEM2.L2A     The SUMB?                        !263
         BNE       NOTFOUND        Can't match up any code!         !263
         LW        R7,MEM2.L2B     Get the new instruction for      !263
*                                  TRV.A4                           !263
         STW       R7,TRV.A4.C                                      !263
DO.MEM3  F.PTCHG   R3,S.TRV.A4,TRV.A4.S,TRV.A4.R                    !263
         LA        R2,MEM4                                          !249
         BL        FINDINST                                         !249
         BS        DO.MEM4         Found                            !263
         LA        R2,MEM4A        Could be 3.5U01 or later         !263
         BL        FINDINST                                         !263
         BNS       NOTFOUND                                         !249
         F.PTCHG   R3,S.TRV.4J,,TRV4JRET                            !264
         BU        CK.MEM5                                          !264
*249          M.PTCHG   H.MEMM.,X'0ACC',S.TRV.46,,TRV46RET
DO.MEM4  F.PTCHG   R3,S.TRV.46,,TRV46RET                            !249
CK.MEM5  EQU       $                                                !264
         LA        R2,MEM5                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.MEMM.,X'157C',S.TRV.B5,,TRVB5RET
         F.PTCHG   R3,S.TRV.B5,,TRVB5RET                            !249
* FOLLOWING CHANGES IN H.MEMM,8
         LA        R2,MEM6                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHC   H.MEMM.,X'1B1C' EXCLUDED MEMORY PARTITIONS
         F.PTCHC   R3                                               !249
         BL        S.TRV.15
* FOLLOWING CHANGE IN S.MEMM5
         LA        R2,MEM7                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.MEMM.,X'2BD0',S.TRV.41,TRV41RPL  MPL ENT.
         F.PTCHG   R3,S.TRV.41,TRV41RPL  MPL ENT.                   !249
* FOLLOWING CHANGE IN S.MEMM19
         LA        R2,MEM8                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.MEMM.,X'3728',S.TRV.41           MPL ENT.
         F.PTCHG   R3,S.TRV.41                                      !249
* FOLLOWING CHANGE IN S.MEMM20
         LA        R2,MEM9                                          !249
         BL        FINDINST                                         !249
         BS        DO.MEM9         Go if found                      !282
         LA        R2,MEM9A        Could be MPX 3.6                 !282
         BL        FINDINST                                         !282
         BNS       NOTFOUND                                         !249
         BU        NOT.MEM9        Found 3.6; no patch needed       !282
*249          M.PTCHG   H.MEMM.,X'3754',S.TRV.B4,,TRVB4RET
DO.MEM9  EQU       $                                                !282
         F.PTCHG   R3,S.TRV.B4,,TRVB4RET                            !249
NOT.MEM9 EQU       $                                                !282
*--------------------------------------------------------------------
*
* H.TAMM PATCHES
*
*--------------------------------------------------------------------
         LA        R2,H.TAMM.                                       !249
         STW       R2,TAMMSTRT                                      !249
         ADI       R2,X'5C00'                                       !249
         STW       R2,TAMMEND                                       !249
*  PATCH FOR CSECT BIAS DURING LOADING IN TAMM.1
         LA        R2,TAM1                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHC   H.TAMM.,X'50'   ; BR TO S.TRV.48
         F.PTCHC   R3                                               !249
         BL        S.TRV.48        ; BIAS CSECT LOAD ADDRESS
*
*  PATCH FOR DSECT BIAS DURING LOADING IN TAMM.1
         LA        R2,TAM2                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHB   H.TAMM.,X'B0',S.TRV.4A,TRV.4A.R
         TRR       R3,R1                                            !249
         F.PTCHB   R1,S.TRV.4A,TRV.4A.R                             !249
*
*  PATCH ABSOL EXECUTION ADDRESS BIAS IN TAMM.1
         LA        R2,TAM3                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.TAMM.,X'328',AJ.RELB,,AJ.RELBR RELOC BIAS
         F.PTCHG   R3,AJ.RELB,,AJ.RELBR  RELOC BIAS                 !249
         ADI       R3,TAM3.L2-TAM3.L/2                              !249
*249          M.PTCHC   H.TAMM.,X'334'  ;NOP INSTR IN TAMM.1 BIAS RTN
         F.PTCHC   R3                                               !249
         DATAW     X'00020002'     ; BZ BIAS.4 INSTRUCTION
         ADI       R3,TAM3.L3-TAM3.L2/2                             !249
*249          M.PTCHC   H.TAMM.,X'340'  ;BNS  BIAS.3.1  NOT REL
         F.PTCHC   R3                                               !249
         BNS       S.TXPM.A        ;CHECK FOR TSA REFERENCES
         LA        R2,TAM6                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHCT  S.A.RET,H.TAMM.,X'364' ; BU  BIAS.3.1 TAMM.1
         F.PTCHCT  S.A.RET,R3    BU BIAS.3.1  TAMM.1                !249
*
         LA        R2,TAM7                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHC   H.TAMM.,X'540'  INITIALIZE TXPM CONTEXT
         F.PTCHC   R3              Initialize TXPM context          !249
         BL        S.TXPM.8
*
*  PATCH CSECT EXECUTION ADDRESS BIAS IN TAMM.3
         ZBM       LW.TAM8A,LSWITCH Remeber which code sequence     !264
*                                  we found                         !264
         LA        R2,TAM8                                          !249
         BL        FINDINST                                         !249
         BS        DO.TAM8         Go if found                      !264
*  TAM8 code was changed for 3.5U01.  Absolute tasks weren't        !264
*  working correctly withOUT TXPM!                                  !264
         LA        R2,TAM8A                                         !264
         BL        FINDINST                                         !264
         BNS       NOTFOUND                                         !249
         SBM       LW.TAM8A,LSWITCH We found 3.5U01 and later       !264
DO.TAM8  EQU       $                                                !264
*249          M.PTCHB   H.TAMM.,X'B4C',S.TRV.49,TRV.49.R
         TRR       R3,R1                                            !249
         TRR       R3,R7                                            !249
         F.PTCHB   R1,S.TRV.49,TRV.49.R                             !249
*
*  PATCH LAST LOADED DSECT ADDRESS IN TAMM.3
         TBM       LW.TAM8A,LSWITCH Which code sequence did we find !264
         BS        DO.TAM8B        POST-3.5U01                      !264
         TRR       R7,R3           Restore R3                       !249
         ADI       R3,TAM8.L2-TAM8.L/2                              !249
*249          M.PTCHC   H.TAMM.,X'B6C'
         F.PTCHC   R3                                               !249
         BL        S.TRV.BX        ADJUST LAST LOADED ADDRESS DSECT
         BU        DO.TAM11
DO.TAM8B EQU       $                                                !264
         TRR       R7,R1           R1 pts back to code (TAM8A.L)    !264
         ADI       R1,TAM8A.L3-TAM8A.L/2                            !264
         LW        R7,,X1          Destination for return           !264
         SLL       R7,12           Lose all but address             !264
         SRL       R7,12                                            !264
         F.PTCHB   R1,S.TRV.CX,,R7,TRV.CX.R                         !264
*
DO.TAM11 EQU       $                                                !264
         LA        R2,TAM11                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHCT  PTCH.22,H.TAMM.,X'1068' ; BU  TM3.ER65 (RM65)
         F.PTCHCT  PTCH.22,R3   ; BU TM3.ER65                       !249
*
*  PATCH OUT INITIALIZATION OF DQE LOC'S USED BY TXPM IN S.TM2.2
         LA        R2,TAM12                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHC   H.TAMM.,X'1860' ;NOP DQE.PSSF INITIALIZATION
         F.PTCHC   R3              NOP DQE.PSSF Initialization      !249
         DATAW     X'00020002'
         ADI       R3,TAM12.L2-TAM12.L/2                            !249
*249          M.PTCHC   H.TAMM.,X'1864' ;NOP DQE.PSSB INITIALIZATION
         F.PTCHC   R3              NOP DQE.PSSB initialization      !249
         DATAW     X'00020002'
*
*  PATCHES TO CORRECT SIZE OF MIDL/MEML FOR FULL 2MB'S
*
*  PATCH TO S.TM2.8
*237*    M.PTCHG   H.TAMM.,X'2038',S.TRV.BE,,TRV.BE.R ADJ SIZE  *237*
*
*  PATCH TO S.TM3.3
*237*    M.PTCHG   H.TAMM.,X'2A28',S.TRV.BF,,TRV.BF.R           *237*
*  PATCH TO SET DBHAT IN S.TAMM4                                *232*
         LA        R2,TAM14                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.TAMM.,X'4820',SETHAT,,SETHAT.R
         F.PTCHG   R3,SETHAT,,SETHAT.R                              !249
*
*  PATCH FOR ABSOLUTE LOAD MODULES IN S.TAMM5
         LA        R2,TAM15                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249      M.PTCHB   H.TAMM.,X'4960',S.TRV.4B,TRV.4B.E,X'496C',TRV.4B.R
         TRR       R3,R1           Input reg                        !249
         TRR       R3,R7           Return reg                       !249
         ADI       R7,TAM15.L2-TAM15.L/2                            !249
         F.PTCHB   R1,S.TRV.4B,TRV.4B.E,R7,TRV.4B.R                 !249
         LA        R2,TAM17                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.TAMM.,X'49B8',AJ.CSECT ADJUST CSECT ORIGIN
         F.PTCHG   R3,AJ.CSECT   Adjust CSECT origin                !249
*--------------------------------------------------------------------
*
* H.TSM PATCHES
*
*--------------------------------------------------------------------
         LA        R2,H.TSM.                                        !249
         STW       R2,TSMSTRT                                       !249
         ADI       R2,X'2000'                                       !249
         STW       R2,TSMEND                                        !249
*  PATCH TO READTERM
         LA        R2,TSM1                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.TSM.,X'03A0',TSM.1
         F.PTCHG   R3,TSM.1                                         !249
         ADI       R3,TSM1.L2-TSM1.L/2                              !249
         TRR       R3,R7           Save over F.PTCHCT macro         !249
*249          M.PTCHCT  PTCH.25,H.TSM.,X'03A4'    ; BU   RD.27 - 1W
         F.PTCHCT  PTCH.25,R3      BU   RD.27-1W                    !249
         TRR       R7,R3           Restore address of patch         !249
         ADI       R3,TSM1.L3-TSM1.L2/2                             !249
*249          M.PTCHCT  PTCH.24,H.TSM.,X'03A8'    ; BU   RD.27
         F.PTCHCT  PTCH.24,R3      BU   RD.27                       !249
*  PATCH TO WRITERM
         LA        R2,TSM4                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.TSM.,X'04A8',TSM.2A
         F.PTCHG   R3,TSM.2A                                        !249
         ADI       R3,TSM4.L2-TSM4.L/2                              !249
*249          M.PTCHG   H.TSM.,X'04BC',TSM.2                         *239*
         F.PTCHG   R3,TSM.2                                         !249
         ADI       R3,TSM4.L3-TSM4.L2/2                             !249
         TRR       R3,R7           Save over macro call             !249
*249          M.PTCHCT  PTCH.26,H.TSM.,X'04C4'    ; BU   LIN.8WX     *239*
         F.PTCHCT  PTCH.26,R3                                       !249
         TRR       R7,R3                                            !249
*249          M.PTCHCT  PTCH.27,H.TSM.,X'04C4'    ; BU   LIN.8WX     *239*
         F.PTCHCT  PTCH.27,R3                                       !249
         TRR       R7,R3                                            !249
*249          M.PTCHCT  PTCH.SS,H.TSM.,X'04C4'    ; BU   LIN.8WX     *239*
         F.PTCHCT  PTCH.SS,R3                                       !249
         TRR       R7,R3                                            !249
*249          M.PTCHCT  PTCH.TT,H.TSM.,X'04C4'    ; BU   LIN.8WX     *239*
         F.PTCHCT  PTCH.TT,R3                                       !249
*  PATCH TO CLAMP
         LA        R2,TSM7                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHG   H.TSM.,X'08B8',TSM.3
         F.PTCHG   R3,TSM.3                                         !249
*  PATCH TO S.TSM01
         LA        R2,TSM8                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          M.PTCHC   H.TSM.,X'1670'  BIAS ABORTING PSW
         F.PTCHC   R3              Bias aborting PSW                !249
         BL        S.TSM01
         ADI       R3,TSM8.L2-TSM8.L/2                              !249
*249          M.PTCHC   H.TSM.,X'1690'  BIAS ABORTING 'BIAS'
         F.PTCHC   R3                                               !249
         BL        S.TSM015
*--------------------------------------------------------------------
* H.BKDM PATCHES
*--------------------------------------------------------------------
         LW        R2,BKOP                                          !249
         STW       R2,BKOPSTRT                                      !249
         ADI       R2,X'2000'                                       !249
         STW       R2,BKOPEND                                       !249
*  INSERT PATCH INTO H.BKDM FOR SHORT FCB BLOCKED I/O
         LA        R2,BKDM1                                         !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249          LI        R3,X'0FF8'      OFFSET TO PATCH IN S.BKDM5   *241*
*249          SUI       R3,X'34'        LESS H.BKOP ADDRESS OFFSET   *239*
*249          ADMW      R3,BKOP         ADDRESS TO BE PATCHED
         LW        R4,ADR.MASK
         LA        R2,BKDM
         TRRM      R2,R2
         ORMW      R2,=X'EC000001'
         STW       R2,0W,X3        INSERT BRANCH TO BKDM
         ADI       R3,1W           RETURN ADDRESS
         ORMW      R3,=X'EC000001'
         STW       R3,BKDM.RET     INSERT RETURN
*--------------------------------------------------------------------
* H.IP04 PATCHES
*--------------------------------------------------------------------
         LA        R2,IP04.ICB                                      !249
         STW       R2,IP04STRT                                      !249
         LA        R2,IP04S                                         !249
         STW       R2,IP04END                                       !249
*       PATCH REDISPATCH TO TRAP LOC                            *228*
         LA        R2,IP41                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249    M.PLPSD  IP04.ICB,X'4C'-X'10',DSP.IP04,IP04.P1,IP04.RT
         F.PLPSD   R3,DSP.IP04,IP04.P1,IP04.RT                      !249
*--------------------------------------------------------------------
* H.IP05 PATCHES
*--------------------------------------------------------------------
         LA        R2,IP05.ICB                                      !249
         STW       R2,IP05STRT                                      !249
         LA        R2,IP05S                                         !249
         STW       R2,IP05END                                       !249
*       PATCH REDISPATCH TO TRAP LOC                            *228*
         LA        R2,IP51                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
*249    M.PLPSD  IP05.ICB,X'4C'-X'10',DSP.IP05,IP05.P1,IP05.RT
         F.PLPSD   R3,DSP.IP05,IP05.P1,IP05.RT                      !249
*--------------------------------------------------------------------
*
* H.IP06 PATCHES - MPX 3.5 BL10                                 *241!244
*
*--------------------------------------------------------------------
*
*  INSERT PATCHES INTO IP06 FOR M.SHUT & M.OPEN DISPATCHES
*
*        IP06 PATCHES ARE APPLIED BY SEARCHING FOR LPSD SVC3.OLD
*        THIS ALLOWS SUPPORT FOR SPECIAL PACE VERSION OF SH.IP06
*        1 IS APPLIED BETWEEN SVC 0 & 1
*        3 ARE APPLIED BETWEEN SVC 3 & 4
*        1 IS APPLIED BETWEEN SVC 8 AND 9 IF SVC 8 ADDRESS IS
*        LESS THAN SVC 9 ADDRESS, ELSE NOT APPLIED.
*
         LA        R3,H.IP06       GET IP06 HAT ADDRESS
         LW        R4,4W,X3        GET ADDRESS OF SVC3.OLD
         TRR       R4,R7           SAVE SVC3.OLD ADDRESS
         ORMW      R7,PTCH.32      OR IN LD R6,SVC3.OLD INSTR
         STW       R7,PTCH.32      PUT IN PATCH AREA
         ORMW      R4,=X'F9800000' OR IN LPSD INSTRUCTION
         STW       R4,PTCH.33      SET UP PATCH AREA
         LW        R2,1W,X3        GET SVC0 ADDRESS
         LW        R6,SVC.DSP      GET BRANCH INSTR
         BU        SVC0.L          SKIP OVER BRANCH
SVC.DSP  BU        DSP.IP06        BR TO PATCH AREA
SVC0.L   CAMW      R4,0W,X2        IS THIS THE LPSD INSTR
         BNE       SVC0.X          BR IF NOT
         STW       R6,0W,X2        REPLACE WITH BRANCH
SVC0.X   ADI       R2,1W           NEXT LOCATION
         CAMW      R2,2W,X3        GO TO SVC 1 YET
         BLT       SVC0.L          LOOP TILL DONE
         LW        R2,4W,X3        GET SVC3 ADDRESS
SVC3.L   CAMW      R4,0W,X2        IS THIS THE LPSD INSTR
         BNE       SVC3.X          BR IF NOT
         STW       R6,0W,X2        REPLACE WITH BRANCH
SVC3.X   ADI       R2,1W           NEXT LOCATION
         CAMW      R2,5W,X3        GO TO SVC 4 YET
         BLT       SVC3.L          LOOP TILL DONE
         LW        R2,7W,X3        GET SVC6 ADDRESS             *241*
         CAMW      R2,10W,X3       IF < SVC 9, NEW M.CALL HERE  *241*
         BGE       SVC6.XT         BR IF NOT HERE               *241*
SVC6.L   CAMW      R4,0W,X2        IS THIS THE LPSD INSTR       *241*
         BNE       SVC6.X          BR IF NOT                    *241*
         STW       R6,0W,X2        REPLACE WITH BRANCH          *241*
SVC6.X   ADI       R2,1W           NEXT LOCATION                *241*
         CAMW      R2,10W,X3       GOT TO SVC 9 YET             *241*
         BLT       SVC6.L          LOOP TILL DONE               *241*
*        SEE IF PACE IP06 INSTALLED
SVC6.XT  LW        R2,9W,X3        GET SVC 8 ADDRESS            *241*
         CAMW      R2,10W,X3       IF < SVC 9 ADDR, PACE HERE
         BGE       SVC.XT          BR IF NOT HERE
SVC8.L   CAMW      R4,0W,X2        IS THIS THE LPSD INSTR
         BNE       SVC8.X          BR IF NOT
         STW       R6,0W,X2        REPLACE WITH BRANCH
SVC8.X   ADI       R2,1W           NEXT LOCATION
         CAMW      R2,10W,X3       GOT TO SVC 9 YET
         BLT       SVC8.L          LOOP TILL DONE
SVC.XT   EQU       $               ALL DONE WITH H.IP06
*        SEE IF ACX INSTALLED                                   *219*
         LW        R2,8W,X3        GET SVC 7 ADDRESS            *219*
         CAMW      R2,17W,X3       IF > SG ENT ADDR, ACX HERE   *219*
         BLE       SVC.XT7         BR IF NOT HERE               *219*
         TRR       R2,X1           SVC7 ICB ADDR                *219*
         SUI       R1,2W           BACK UP TO HAT               *219*
         LW        R4,=X'F9E00040' GET LPSD 2F,X3 INSTR         *219*
         LI        R0,-2           LOOK FOR TWO LPSD'S          *219*
         LW        R6,$+2W         GET BRANCH INSTR             *219*
         BU        SVC7.L          SKIP INSTR                   *219*
         BU        DSP.SVC7        BRANCH TO DISP AREA          *219*
SVC7.L   CAMW      R4,0W,X2        IS THIS THE LPSD INSTR       *219*
         BNE       SVC7.X          BR IF NOT                    *219*
         STW       R6,0W,X2        REPLACE WITH BRANCH          *219*
         BIB       R0,SVC7.X       LOOP FOR TWO                 *219*
         BU        SVC.XT7         BOTH DONE, CONTINUE          *219*
SVC7.X   ADI       R2,1W           NEXT LOCATION                *219*
         CAMW      R2,1W,X1        GOT TO END OF H.SVC7 YET     *219*
         BLT       SVC7.L          LOOP TILL DONE               *219*
SVC.XT7  EQU       $               ALL DONE WITH H.IP06         *219*
*
*--------------------------------------------------------------------
* H.SURE PATCHES
*--------------------------------------------------------------------
*
*  FIRST SEE IF H.SURE IS GEN'D INTO THE SYSTEM (SVC 5)
         LA        R3,H.IP06       GET IP06 HAT ADDRESS
         LW        R4,6W,X3        GET ADDRESS OF SVC5.OLD
         CAMW      R4,17W,X3       IS IT > SG E.P.              *219*
         BLE       SURE.XT         H.SURE NOT ON SYSTEM IF LESS *219*
*249          TRR       R4,R3           H.SURE ICB ADDR
*249          SUI       R3,X'8'         BACKUP TO START OF H.SURE        !244
*249          ADI       R3,X'1B0'       OFFSET IN H.SURE FOR LPSDCM  *239*
         STW       R4,SURESTRT                                      !249
         ADI       R4,X'800'                                        !249
         STW       R4,SUREEND                                       !249
         LA        R2,SUR1                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         LW        R6,0W,X3        GET LPSDCM INSTR
         STW       R6,SURE.RT      PUT IN TXPM CODE
         ANMW      R6,=X'FFFF8'    GET TEMP PSD ADDR
         ORMW      R6,SURE.P1      OR IN LD INSTR
         STW       R6,SURE.P1      PUT IN DSP CODE
         LW        R6,$+3W         GET BR TO DSP CODE
         STW       R6,0W,X3        PUT IN H.SURE CODE
         BU        SURE.XT         LEAVE NOW
         BU        DSP.SURE        BR INSRT FOR H.SURE DSP
SURE.XT  EQU       $               ALL DONE WITH H.SURE
*--------------------------------------------------------------------
*
*  H.ICP Patches                                                    !249
*
*--------------------------------------------------------------------
*
*  FIRST SEE IF H.ICP IS GEN'D INTO THE SYSTEM
         LW        R7,=X'F8800000' Start by looking for BL H.ICP    !275
ICP.PT0  EQU       $                                                !275
         LW        R3,C.ITLT       GET ITLB ADDRESS
         BZ        ICP.XT          H.ICP NOT ON SYSTEM IF ZERO
         ABR       R3,26           ADD 8 WORDS                      !256
         ZR        R6              LOOP COUNTER                     !256
         LW        R4,=X'FFF00000' GET INSTRUCTION MASK             !256
ICP.PT1  LW        R2,0,X3         GET BL H.ICP INSTRUCTION         !256
*275          CMMW      R2,=X'F8800000' IS IT A BL?                      !256
         CMR       R2,R7           Is it a BL (or BU)?              !275
         BEQ       ICP.PT2                                          !256
         ABR       R3,29           POINT TO NEXT WORD               !256
         ABR       R6,31           UPDATE COUNT                     !256
         CI        R6,8            ONLY SEARCH 8 WORDS              !256
         BLE       ICP.PT1                                          !256
*  If we're here, then we couldn't find the ICP init sequence, and  !275
*  therefore we can't patch well.  However, 3.5U02 uses a different !275
*  entry sequence to H.ICP, and we look for that here.              !275
         SBM       LW.ICP,LSWITCH  Have we done this before?        !275
         BS        ICP.PT1X        Go set up for abort if so        !275
         LW        R7,=X'EC000000' Look for BU H.ICP vice BL        !275
         BU        ICP.PT0         Go search again                  !275
ICP.PT1X EQU       $                                                !275
         LI        R2,2W           FORCE PATCH ERROR                !256
ICP.PT2  ANMW      R2,=X'FFFFC'    MASK OFF LHW BIT                 !256
*249          SUI       R2,2W           BACKUP TO START OF H.ICP
         STW       R2,ICPSTRT                                       !249
         ADI       R2,X'800'                                        !249
         STW       R2,ICPEND                                        !249
*  DO LPSDCM EXEC.D1 FOR DISPATCH FROM H.ICP
*249          TRR       R2,R3           TO WORK REG
*249          ADI       R3,X'27C'       OFFSET IN H.ICP FOR LPSDCM   *239*
         LA        R2,ICP1                                          !249
         BL        FINDINST                                         !249
         BNS       NOTFOUND                                         !249
         LW        R6,0W,X3        GET LPSDCM INSTR
         STW       R6,ICP.RT       PUT IN TXPM CODE
         ANMW      R6,=X'FFFF8'    GET TEMP PSD ADDR
         ORMW      R6,ICP.P1       OR IN LD INSTR
         STW       R6,ICP.P1       PUT IN DSP CODE
         LW        R6,$+3W         GET BR TO DSP CODE
         STW       R6,0W,X3        PUT IN H.ICP CODE
         BU        $+2W            NOW GO DO LPSD
         BU        DSP.ICP         BR INSTR FOR H.ICP DSP       *218*
*  DO LPSD EXEC.D1 FOR NESTED INT'S IN H.ICP
*249          TRR       R2,R3           TO WORK REG
*249          ADI       R3,X'390'       OFFSET IN H.ICP FOR LPSD     *239!244
         LA        R2,ICP2                                          !249
         BL        FINDINST                                         !249
         BS        ICP2.PCH        Go if found                      !275
*  If we're here, we couldn't find ICP2.  The code changed for      !275
*  3.5u02, so we look for that here.                                !275
         LA        R2,ICP2A                                         !275
         BL        FINDINST                                         !275
         BNS       NOTFOUND                                         !249
ICP2.PCH EQU       $                                                !275
         LW        R6,$+3W         GET BU DSP.EX05 INSTR
         STW       R6,0W,X3        PUT IN H.ICP
         BU        ICP.XT          LEAVE NOW
         BU        DSP.EX05        BR INSRT FOR H.ICP DSP
ICP.XT   EQU       $               ALL DONE WITH H.ICP
*
* ----------------------------------------------------------------- !257
* H.RMSS patches                                                    !257
* ----------------------------------------------------------------- !257
*                                                                   !257
*  We must see if RMSS is on the system.  Then we look through      !257
*  the RMSS structure.  It will point to the ICB that RMSS          !257
*  uses.  We take that address, and use it for our code searches.   !257
*                                                                   !257
         LW        R2,C.PSMA       Ptr to RMSS structure            !257
         BZ        RMS.XT          Done if no RMSS on line          !257
*281          LB        R5,C.PSMN       Nr of ints configured            !257
*281          BZ        RMS.XT          Go if none; done                 !257
         LNB       R5,C.PSMN       Nr of ints configured            !281
         BNP       RMS.XT          Go if none; done                 !281
         LI        R3,X'F1'        Get R7 pointing to IVT           !257
         SLL       R3,2                                             !257
         ADMW      R3,C.SPAD                                        !257
         LW        R7,,X3          R7 now has IVT address           !257
RMS.LP   LB        R6,PSM.INTO,X2  Get entry                        !257
         BZ        RMS.LPE         Go to loop end if no int         !257
         LB        R6,PSM.INTI,X2                                   !257
         BZ        RMS.LPE         Loop end again                   !257
         TRR       R6,R3                                            !257
         SLL       R3,2            Word offset                      !257
         ADR       R7,R3           R3 now pts to IVT entry          !257
         LW        R1,,X3          RMSS' ICB                        !257
         CAMW      R1,IP04STRT     Sounds reasonable that H.RMSS    !281
*                                  should start after IP04STRT      !281
         BZ        RMS.LPE         If zero, look some more          !281
         BLT       RMS.ERR         Go if not                        !281
         BU        RMS.FND         Now search; R1 has start addr    !257
RMS.LPE  ADI       R2,PSM.SIZE     Go to next entry                 !257
         BIB       R5,RMS.LP                                        !257
RMS.ERR  LW        R7,=C'TG86'     Error                            !281
         BU        NFND.02         Tell user                        !281
RMS.FND  SUI       R1,X'200'                                        !262
         STW       R1,RMSSSTRT     Where we start our search        !257
         ADI       R1,X'400'       A guess                          !262
         STW       R1,RMSSEND                                       !257
         LA        R2,RMS1         First search block               !257
         BL        FINDINST                                         !257
         BNS       NOTFOUND                                         !257
         F.PLPSD   R3,DSP.RMS1,PTCH.34,PTCH.35                      !257
         LA        R2,RMS1         Second code sequence is identical!257
*                                  to first                         !257
         BL        FINDINST        It won't find the first, since   !257
*                                  we already patched it.           !257
         BNS       NOTFOUND                                         !257
         F.PLPSD   R3,DSP.RMS2,PTCH.36,PTCH.37                      !257
         LA        R2,RMS2                                          !257
         BL        FINDINST                                         !257
         BS        RMS.1           Go if we found it                !262
         LA        R2,RMS2A        This may be version 3.0 U02      !279
         BL        FINDINST                                         !262
         BS        RMS.1           Go if found                      !279
         LA        R2,RMS2B        But, it could be 3.0B!           !279
         BL        FINDINST                                         !279
         BNS       NOTFOUND                                         !257
RMS.1    F.PLPSD   R3,DSP.RMS3,PTCH.38,PTCH.39                      !262
RMS.XT   EQU       $                                                !257
SKP.PTCH EQU       $                                                !257
CC1      EQU       1                                                !257
*284 END.35   ANOP                                                   *232
ABRT.XT  M.XIR     HAT             EXIT TO SYSGEN
*284          IFF       OS.35,NO.35                                      !261
*284          IFF       OS.15E,NO.1X                                     !261
*284 NFND.3   SBM       C.NOLOAD,C.BIT  Can't continue                   !261
*284          BL        ABRT.XT         No return                        !261
*284 NO.1X    ANOP                                                       !261
*284 NO.35    ANOP                                                       !261
*284          IFT       OS.15E,OS15E                                 *238*
*284          BOUND     1W                                           *238*
*284 *                                                               *238*
*284 *      DEFINE SVC 1,3 FOR USER                                  *238*
*284 *                                                               *238*
*284 SVCTAB   GEN       8/X'03',24/W(RST_TSA)  TURN OFF TSA BIASING  *238*
*284 SVC.END  EQU       $-SVCTAB/4      NUMBER OF SVC 1 ENTRIES      *238*
*284 OS15E    ANOP                                                   *238*
*284          IFF       OS.15E,OS15E                                 *238*
         BOUND     1W
*
*      DEFINE SVC 1,3 FOR USER
*
SVCTAB   GEN       8/X'03',24/W(RST_TSA)  TURN OFF TSA BIASING
SVC.END  EQU       $-SVCTAB/4      NUMBER OF SVC 1 ENTRIES
*284 OS15E    ANOP                                                   *238*
BRANCH   BU        0               DUMMY BRANCH INSTRUCTION
         END
