
# line 2 "cgram.y"
/* cgram.y */
/*
 * 	(c) Copyright 1986 Gould Inc.
 * 	    All Rights Reserved.
 */

/*
 * 	(c) Copyright 1990 J B Systems
 *	This file contains non-based support modifications
 *	for operation under MPX.  Derived from Encores' base
 *	mode C compiler.
 */

#ifndef lint
static char *rcsid = "@(#) (Gould) $Header: cgram.pn.y,v 5.5 89/05/12 12:43:09 pcc Rel-3_0 $";
/* static	char *UTXwhat = "@(#) UTX/32 1.3  cgram.y ver 1.2"; */
#endif
# define NAME 2
# define STRING 3
# define ICON 4
# define FCON 5
# define PLUS 6
# define MINUS 8
# define MUL 11
# define AND 14
# define OR 17
# define ER 19
# define QUEST 21
# define COLON 22
# define ANDAND 23
# define OROR 24
# define ASOP 25
# define RELOP 26
# define EQUOP 27
# define DIVOP 28
# define SHIFTOP 29
# define INCOP 30
# define UNOP 31
# define STROP 32
# define TYPE 33
# define CLASS 34
# define STRUCT 35
# define RETURN 36
# define GOTO 37
# define IF 38
# define ELSE 39
# define SWITCH 40
# define BREAK 41
# define CONTINUE 42
# define WHILE 43
# define DO 44
# define FOR 45
# define DEFAULT 46
# define CASE 47
# define SIZEOF 48
# define ENUM 49
# define LP 50
# define RP 51
# define LC 52
# define RC 53
# define LB 54
# define RB 55
# define CM 56
# define SM 57
# define ASSIGN 58
# define ASM 59

# line 137 "cgram.y"
#include "mfile1.h"
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
typedef int yytabelem;

# line 156 "cgram.y"
	static int fake = 0;
#ifndef FLEXNAMES
	static char fakename[NCHNAM+1];
#else
	static char fakename[24];
#endif
# define YYERRCODE 256

# line 892 "cgram.y"


NODE *
mkty( t, d, s ) unsigned t; {
	NODE *p;
	p = block( TYPE, NIL, NIL, t, d, s );
#ifndef BUG1
	if(ddebug) {
		printf("mkty(t=0x%x, d=%d, s=%d) returning %x\n",
			t, d, s, p);
		fwalk(p, eprint, 0);
	}
#endif
	return(p);
	}

NODE *
bdty( op, p, v ) NODE *p; {
	register NODE *q;

	q = block( op, p, NIL, INT, 0, INT );

	switch( op ){

	case UNARY MUL:
	case UNARY CALL:
		break;

	case LB:
		q->in.right = bcon(v);
		break;

	case NAME:
		q->tn.rval = v;
		break;

	default:
		cerror( "bad bdty" );
		}

#ifndef BUG1
	if(ddebug) {
		printf("bdty(op=%s, p=0x%x, v=0x%x) returning 0x%x\n",
			opst[op], p, v, q);
		fwalk(q, eprint, 0);
	}
#endif

	return( q );
	}

dstash( n ){ /* put n into the dimension table */
	if( curdim >= DIMTABSZ-1 ){
		cerror( "dimension table overflow");
		}
	dimtab[ curdim++ ] = n;
	}

savebc() {
	if( psavbc > & asavbc[BCSZ-4 ] ){
		cerror( "whiles, fors, etc. too deeply nested");
		}
	*psavbc++ = brklab;
	*psavbc++ = contlab;
	*psavbc++ = flostat;
	*psavbc++ = swx;
	flostat = 0;
	}

resetbc(mask){

	swx = *--psavbc;
	flostat = *--psavbc | (flostat&mask);
	contlab = *--psavbc;
	brklab = *--psavbc;

	}

addcase(p) NODE *p; { /* add case to switch */

	p = optim( p );  /* change enum to ints */
	if( p->in.op != ICON ){
		uerror( "non-constant case expression");
		return;
		}
	if( swp == swtab ){
		uerror( "case not in switch");
		return;
		}
	if( swp >= &swtab[SWITSZ] ){
		cerror( "switch table overflow");
		}
	swp->sval = p->tn.lval;
	deflab( swp->slab = getlab() );
	++swp;
	tfree(p);
	}

adddef(){ /* add default case to switch */
	if( swtab[swx].slab >= 0 ){
		uerror( "duplicate default in switch");
		return;
		}
	if( swp == swtab ){
		uerror( "default not inside switch");
		return;
		}
	deflab( swtab[swx].slab = getlab() );
	}

swstart(){
	/* begin a switch block */
	if( swp >= &swtab[SWITSZ] ){
		cerror( "switch table overflow");
		}
	swx = swp - swtab;
	swp->slab = -1;
	++swp;
	}

swend(){ /* end a switch block */

	register struct sw *swbeg, *p, *q, *r, *r1;
	CONSZ temp;
	int tempi;

	swbeg = &swtab[swx+1];

	/* sort */

	r1 = swbeg;
	r = swp-1;

	while( swbeg < r ){
		/* bubble largest to end */
		for( q=swbeg; q<r; ++q ){
			if( q->sval > (q+1)->sval ){
				/* swap */
				r1 = q+1;
				temp = q->sval;
				q->sval = r1->sval;
				r1->sval = temp;
				tempi = q->slab;
				q->slab = r1->slab;
				r1->slab = tempi;
				}
			}
		r = r1;
		r1 = swbeg;
		}

	/* it is now sorted */

	for( p = swbeg+1; p<swp; ++p ){
		if( p->sval == (p-1)->sval ){
			uerror( "duplicate case in switch, %d", tempi=p->sval );
			return;
			}
		}

	swepilog( swbeg-1, swp-swbeg );
	swp = swbeg-1;
	}

#ifndef BUG1
lookaround(yypvt)
register YYSTYPE *yypvt;
{
	register i;
	extern int eprint();

	for(i = (-6); i < 4; i++) {
		printf("yypvt[%d].nodep = %x\n", i, yypvt[i].nodep);
		if(yypvt[i].nodep > (NODE *) 0x200000)
			fwalk(yypvt[i].nodep, eprint, 0);
	}
}
#endif

/*
 * 	(c) Copyright 1986 Gould Inc.
 * 	    All Rights Reserved.
 */
yytabelem yyexca[] ={
-1, 1,
	0, -1,
	2, 24,
	11, 24,
	50, 24,
	57, 24,
	-2, 0,
-1, 21,
	56, 82,
	57, 82,
	-2, 8,
-1, 26,
	56, 81,
	57, 81,
	-2, 80,
-1, 34,
	52, 47,
	-2, 45,
-1, 36,
	52, 39,
	-2, 37,
-1, 59,
	53, 51,
	57, 51,
	-2, 0,
-1, 111,
	33, 19,
	34, 19,
	35, 19,
	49, 19,
	-2, 14,
-1, 268,
	33, 17,
	34, 17,
	35, 17,
	49, 17,
	-2, 15,
-1, 285,
	33, 18,
	34, 18,
	35, 18,
	49, 18,
	-2, 16,
	};
# define YYNPROD 180
# define YYLAST 1010
yytabelem yyact[]={

   205,   133,   250,    29,   226,    91,    89,    90,    20,   203,
    82,    79,    23,    80,    95,   194,    81,   134,    11,    10,
    15,    29,    48,    98,   149,    22,    94,    29,    38,   285,
    23,   102,    84,    83,    17,   100,    23,   112,   216,   217,
   221,   168,   225,   214,   215,   222,   223,   224,   228,   227,
    85,    24,    86,    77,   112,   243,    68,    53,   165,   218,
    61,   206,    58,    29,   299,    11,    10,    15,    29,    24,
   114,    47,    23,     7,   298,    24,   268,    23,   207,   135,
   259,    17,    19,    98,   258,   158,   201,   150,   154,   103,
    26,     5,   142,   143,   144,   145,   146,   147,    38,    37,
   292,   279,   254,   253,   245,   166,    93,   198,    76,    18,
    96,    24,   197,   187,    42,    44,    24,    21,   170,   171,
   172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
   182,   183,   184,   185,    43,    45,   164,   135,   188,   109,
   189,   138,    72,   140,   105,   158,   101,    73,   286,   150,
    97,   226,    91,    89,    90,   160,   157,    82,   272,   163,
    80,   141,   162,    81,   116,   139,    40,    71,   274,   186,
    41,   237,    40,   191,   104,   159,    41,    50,    70,    84,
    83,    51,    35,   113,    75,   216,   217,   221,   135,   225,
   214,   215,   222,   223,   224,   228,   227,    85,   241,    86,
    97,   112,   204,    50,   236,   232,   218,    51,   206,   202,
    67,   239,   240,   251,   242,   237,   200,   256,   246,   247,
   248,   249,    50,   252,   233,    33,    51,   271,   266,   231,
   260,   270,   161,   196,   156,    11,    10,    15,   269,   294,
   277,   110,   235,   229,    29,   192,   196,   236,    74,    66,
     9,    17,   276,    23,   288,   265,   287,    99,   219,    30,
   264,   263,   280,   281,   251,   283,   282,   262,   226,    91,
    89,    90,   195,   238,    82,    28,    49,    80,   261,   155,
    81,    28,    55,   155,    59,   195,    54,   289,     4,   295,
    97,   275,    24,   251,   273,   296,    84,    83,    10,   267,
    56,    32,   216,   217,   221,   257,   225,   214,   215,   222,
   223,   224,   228,   227,    85,   123,    86,    99,   112,    11,
   190,    15,    28,   218,     8,   206,    62,   115,   120,    36,
   121,    34,   119,   123,    31,    17,   125,   151,    69,   126,
   104,   127,   220,   130,    59,   128,   129,   131,   117,   124,
   119,   122,   120,   111,   121,   108,   107,   123,   136,    52,
    63,    46,   199,    92,   120,    57,   121,    60,   169,   123,
   167,   106,   125,   297,   119,   126,    65,   127,   118,   130,
   132,   128,   129,   131,   117,   124,   119,   122,    64,    39,
     3,     2,    27,   153,    87,    12,    13,     6,    25,   151,
    14,    16,   120,   213,   121,   219,   120,   123,   121,   293,
   125,   123,   211,   126,   118,   127,   132,   130,   212,   128,
   129,   131,   117,   124,   119,   122,   117,   124,   119,   122,
   210,   208,   209,     1,     0,     0,     0,     0,   120,     0,
   121,     0,     0,   123,     0,     0,   125,   291,     0,   126,
     0,   127,   118,   130,   132,   128,   129,   131,   117,   124,
   119,   122,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   120,     0,   121,     0,
   120,   123,   121,   290,   125,   123,     0,   126,   118,   127,
   132,   130,   284,   128,   129,   131,   117,   124,   119,   122,
   117,     0,   119,   122,     0,     0,     0,     0,     0,     0,
     0,     0,   120,     0,   121,     0,     0,   123,     0,     0,
   125,     0,   219,   126,     0,   127,   118,   130,   132,   128,
   129,   131,   117,   124,   119,   122,   120,     0,   121,     0,
     0,   123,     0,   120,   125,   121,     0,   126,   123,   127,
     0,   130,     0,   128,   129,   131,   117,   124,   119,   122,
     0,     0,   118,   278,   132,   119,   122,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   118,   244,   132,   120,
     0,   121,     0,     0,   123,     0,     0,   125,     0,     0,
   126,     0,   127,     0,   130,     0,   128,   129,   131,   117,
   124,   119,   122,   120,     0,   121,     0,     0,   123,     0,
     0,   125,     0,     0,   126,     0,   127,     0,   130,   230,
   128,   129,   131,   117,   124,   119,   122,     0,   234,   118,
     0,   132,     0,     0,     0,     0,     0,     0,     0,   120,
     0,   121,     0,   120,   123,   121,     0,   125,   123,     0,
   126,   125,   127,   118,   130,   132,   128,   129,   131,   117,
   124,   119,   122,   117,   124,   119,   122,     0,     0,     0,
     0,     0,     0,     0,     0,   120,     0,   121,     0,     0,
   123,     0,     0,   125,   193,     0,   126,     0,   127,   118,
   130,   132,   128,   129,   131,   117,   124,   119,   122,   120,
     0,   121,     0,     0,   123,     0,     0,   125,     0,     0,
   126,     0,   127,     0,   130,     0,   128,   129,   131,   117,
   124,   119,   122,     0,     0,   118,     0,   132,    88,    91,
    89,    90,     0,     0,    82,     0,     0,    80,     0,     0,
    81,    88,    91,    89,    90,     0,     0,    82,     0,     0,
    80,   132,     0,    81,     0,     0,    84,    83,   120,     0,
   121,     0,     0,   123,     0,     0,   125,     0,     0,    84,
    83,   127,     0,     0,    85,     0,    86,     0,   117,   124,
   119,   122,     0,   255,     0,     0,     0,    85,     0,    86,
     0,   137,    88,    91,    89,    90,     0,     0,    82,     0,
     0,    80,     0,     0,    81,    88,    91,    89,    90,     0,
     0,    82,     0,     0,    80,     0,     0,    81,     0,     0,
    84,    83,     0,    11,     0,    15,     0,     0,     0,     0,
     0,     0,     0,    84,    83,     0,     0,     0,    85,    17,
    86,     0,     0,     0,     0,    88,    91,    89,    90,     0,
     0,    85,     0,    86,     0,    78,    88,    91,    89,    90,
     0,     0,    82,     0,     0,    80,     0,     0,    81,    88,
    91,    89,    90,    84,    83,    82,     0,     0,    80,     0,
     0,    81,     0,     0,    84,    83,     0,     0,     0,     0,
     0,    85,     0,    86,     0,     0,     0,    84,    83,     0,
     0,     0,    85,     0,    86,   152,     0,    88,    91,    89,
    90,     0,     0,    82,     0,    85,    80,    86,     0,    81,
     0,     0,     0,     0,     0,     0,   120,     0,   121,     0,
     0,   123,     0,     0,   125,    84,    83,   126,     0,   127,
     0,   130,     0,   128,   129,     0,   117,   124,   119,   122,
     0,     0,   120,    85,   121,   148,     0,   123,     0,     0,
   125,     0,     0,   126,     0,   127,     0,     0,     0,   128,
     0,     0,   117,   124,   119,   122,   120,     0,   121,     0,
     0,   123,     0,     0,   125,     0,     0,   126,     0,   127,
     0,     0,     0,     0,     0,     0,   117,   124,   119,   122 };
yytabelem yypact[]={

 -1000,    32, -1000, -1000, -1000,    52,    25, -1000,   286,   264,
 -1000,   268, -1000, -1000,   173,   329,   130,   327, -1000, -1000,
    42,   122, -1000,   242,   242,    20,   172,    -1, -1000,   236,
 -1000,   286,   267,   286, -1000,   324, -1000, -1000, -1000, -1000,
   198,   155,   172,   122,   127,   116,    91, -1000, -1000, -1000,
   197,   129,   813, -1000, -1000, -1000, -1000,    49, -1000,    61,
    90, -1000,   -27,    66, -1000,   -15, -1000, -1000,   128,   877,
 -1000, -1000, -1000,   325, -1000, -1000,   109,   703,   749,   111,
   877,   877,   877,   877,   877,   915,   800,   864,   229, -1000,
 -1000, -1000,   181,   286,    89, -1000,   122,   153, -1000, -1000,
   179,   324, -1000, -1000,   122, -1000, -1000, -1000, -1000,     1,
    48, -1000, -1000, -1000,   703, -1000, -1000,   877,   877,   877,
   877,   877,   877,   877,   877,   877,   877,   877,   877,   877,
   877,   877,   877,    57, -1000,   703,   749, -1000, -1000,   877,
   318, -1000,   111,   111,   111,   111,   111,   111,   800,   194,
   643,   235, -1000,    56,   703, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000,    29, -1000, -1000, -1000,   149,   202,
   537,   703, -1000,   304,   304,   346, -1000,   474,   400,   762,
   647,   980,   956,   607,   703,   703,   176,   749,    57,   583,
 -1000,   191,   877, -1000,   161,   222,   235,   877, -1000,    61,
 -1000, -1000,     2, -1000, -1000,   530,    47, -1000,   266,   266,
   266,   266,   877,   266,    46,    45,   736,   303, -1000,    27,
   266,   228,   217, -1000,   211,   210,   233,   877,   277,    19,
   877, -1000, -1000,   174, -1000,   853,   111,   103, -1000,   117,
   161,   703, -1000, -1000, -1000, -1000,   252, -1000, -1000,   209,
   189,   679, -1000, -1000, -1000, -1000,   506,    44, -1000, -1000,
 -1000,   877,   877,   877,   877, -1000,   470, -1000, -1000,   -28,
   930, -1000, -1000,    93,   206, -1000,   204,   266, -1000, -1000,
   432,   396,    43,   358, -1000, -1000, -1000,   188,   877, -1000,
 -1000, -1000,   877, -1000, -1000,   322,    17,     7, -1000, -1000 };
yytabelem yypgo[]={

     0,   433,    56,   432,   431,   430,   418,   412,   403,   401,
   400,   398,     0,     2,    11,    73,   397,   250,   396,   395,
    24,    15,   394,    14,   110,    90,   393,   392,   391,   390,
     8,   389,   388,   376,    78,   371,    41,     9,   370,   368,
    26,   324,   367,    35,    60,   365,   363,    62,   362,   361,
    25,   360,   359,     1,    17,   358,   356,   355,   353,   342,
   338 };
yytabelem yyr1[]={

     0,     1,     1,    28,    28,    28,    29,    29,    31,    29,
    32,    33,    33,    36,    36,    38,    38,    39,    39,    39,
    35,    35,    35,    16,    16,    15,    15,    15,    15,    15,
    41,    17,    17,    17,    17,    17,    18,    18,     9,     9,
    42,    42,    44,    44,    19,    19,    10,    10,    45,    45,
    47,    47,    40,    48,    40,    23,    23,    23,    23,    23,
    25,    25,    25,    25,    25,    25,    24,    24,    24,    24,
    24,    24,    24,    11,    49,    49,    49,    30,    51,    30,
    27,    50,    50,    50,    50,    50,    53,    53,    54,    54,
    43,    43,    46,    46,    52,    52,    55,    34,    34,    56,
    57,    58,    37,    37,    37,    37,    37,    37,    37,    37,
    37,    37,    37,    37,    37,    37,    37,    37,    37,    37,
    59,    59,    59,     7,     4,     3,     5,     6,     8,    60,
     2,    13,    13,    26,    26,    12,    12,    12,    12,    12,
    12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
    12,    12,    14,    14,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    14,    14,    14,
    20,    21,    21,    21,    21,    21,    21,    21,    22,    22 };
yytabelem yyr2[]={

     0,     4,     1,     3,     3,     5,     5,     7,     1,     9,
     4,     4,     1,     4,     1,     7,     9,     7,     9,     0,
     7,     5,     5,     2,     1,     5,     4,     3,     3,     7,
     3,     2,     5,     7,     2,     2,    11,     5,     3,     5,
     2,     6,     3,     7,    11,     5,     3,     5,     2,     6,
     5,     3,     3,     1,     9,     2,     2,     7,     5,     3,
     5,     7,     7,     9,     3,     7,     5,     7,     7,     9,
     7,     7,     5,     5,     3,     7,     2,     2,     1,     8,
     3,     3,     3,     7,    13,     2,     2,     6,     3,     9,
     0,     2,     0,     2,     1,     2,     3,     2,     2,     9,
     7,     3,     5,     5,     2,     5,     5,     5,    15,     9,
     5,     5,     5,     5,     7,     7,     2,     4,     4,     4,
     5,     7,     5,     3,     9,     7,     9,    13,     9,     1,
     5,     2,     1,     2,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,    11,     7,
     7,     2,     5,     5,     5,     5,     5,     5,     5,     9,
     9,     9,     5,     7,     7,     3,     3,     3,     3,     7,
     5,     1,     5,    11,     5,     7,     9,     7,     5,     4 };
yytabelem yychk[]={

 -1000,    -1,   -28,   -29,   256,    59,   -16,   -15,   -41,   -17,
    34,    33,   -19,   -18,   -10,    35,    -9,    49,    57,    57,
   -30,   -24,   -50,    11,    50,   -11,   -25,   -27,   256,     2,
   -17,   -41,    33,    52,     2,    52,     2,    57,    56,   -31,
    50,    54,   -25,   -24,   -25,   -24,   -49,    51,     2,   256,
    50,    54,   -52,    58,    50,   -17,    33,   -45,   -47,   -17,
   -42,   -44,     2,   -51,   -32,   -33,    51,    55,    -2,   -60,
    51,    51,    51,    56,    51,    55,    -2,   -12,    52,   -14,
    11,    14,     8,    31,    30,    48,    50,   -22,     2,     4,
     5,     3,   -46,    57,   -40,   -23,   -24,   -25,    22,   256,
   -43,    56,    58,   -50,   -24,   -34,   -35,   -56,   -57,   -15,
   256,   -58,    52,    55,   -12,     2,    55,    26,    56,    28,
     6,     8,    29,    11,    27,    14,    17,    19,    23,    24,
    21,    25,    58,   -53,   -54,   -12,   -55,    52,    30,    54,
    32,    50,   -14,   -14,   -14,   -14,   -14,   -14,    50,   -20,
   -12,   -17,    51,   -26,   -12,    50,    53,   -47,    56,    22,
    -2,    53,   -44,    -2,   -40,    57,    57,   -38,   -36,   -39,
   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
   -12,   -12,   -12,   -12,   -12,   -12,   -43,    56,   -53,   -12,
     2,   -20,    51,    51,   -21,    50,    11,    56,    51,   -48,
    -2,    57,   -36,   -37,    53,   -12,    59,   -34,    -4,    -3,
    -5,    -7,    -6,    -8,    41,    42,    36,    37,    57,   256,
   -59,    38,    43,    44,    45,    40,     2,    47,    46,   -15,
    22,    53,   -54,   -43,    55,    51,   -14,    54,    51,   -21,
   -21,   -12,   -23,    53,    57,    57,   -37,   -37,   -37,   -37,
   -13,   -12,   -37,    57,    57,    57,   -12,     2,    57,    53,
   -37,    50,    50,    50,    50,    22,   -12,    22,    57,   -30,
   -12,    53,    55,    -2,    51,    39,    43,    51,    57,    57,
   -12,   -12,   -13,   -12,    22,    57,    55,    50,    50,   -37,
    51,    51,    57,    51,    51,   -12,   -13,    51,    57,    57 };
yytabelem yydef[]={

     2,    -2,     1,     3,     4,     0,     0,    23,    27,    28,
    30,    31,    34,    35,     0,    46,     0,    38,     5,     6,
     0,    -2,    77,     0,     0,     0,    -2,    94,    85,    64,
    25,    26,    32,     0,    -2,     0,    -2,     7,    78,    12,
     0,   129,    60,    66,     0,     0,     0,    72,    74,    76,
     0,   129,     0,    95,    73,    29,    33,    92,    48,    -2,
    90,    40,    42,     0,     9,     0,    67,    68,     0,     0,
    65,    70,    71,     0,    61,    62,     0,    83,     0,   151,
     0,     0,     0,     0,     0,     0,     0,     0,   165,   166,
   167,   168,     0,    93,    50,    52,    55,    56,   129,    59,
     0,    91,   129,    79,    82,    10,    11,    97,    98,     0,
     0,    -2,   101,    69,   130,    75,    63,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    90,    86,    88,     0,    96,   152,     0,
     0,   179,   153,   154,   155,   156,   157,   158,     0,     0,
     0,   171,   162,     0,   133,   178,    44,    49,    53,   129,
    58,    36,    41,    43,     0,    21,    22,    14,     0,     0,
   135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
   145,   146,   147,     0,   149,   150,     0,    91,    90,     0,
   164,     0,     0,   169,   170,   171,   171,     0,   163,     0,
    57,    20,     0,    13,   100,     0,     0,   104,     0,     0,
     0,     0,   132,     0,     0,     0,     0,     0,   116,     0,
     0,     0,     0,   123,     0,     0,   165,     0,     0,     0,
     0,    84,    87,     0,   161,   160,   159,   129,   172,     0,
   174,   134,    54,    99,   102,   103,   105,   106,   107,     0,
     0,   131,   110,   111,   112,   113,     0,     0,   117,   118,
   119,     0,     0,   132,     0,   120,     0,   122,    -2,     0,
   148,    89,   175,     0,   177,   125,     0,     0,   114,   115,
     0,     0,     0,     0,   121,    -2,   176,     0,     0,   109,
   124,   126,   132,   128,   173,     0,     0,     0,   127,   108 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"NAME",	2,
	"STRING",	3,
	"ICON",	4,
	"FCON",	5,
	"PLUS",	6,
	"MINUS",	8,
	"MUL",	11,
	"AND",	14,
	"OR",	17,
	"ER",	19,
	"QUEST",	21,
	"COLON",	22,
	"ANDAND",	23,
	"OROR",	24,
	"ASOP",	25,
	"RELOP",	26,
	"EQUOP",	27,
	"DIVOP",	28,
	"SHIFTOP",	29,
	"INCOP",	30,
	"UNOP",	31,
	"STROP",	32,
	"TYPE",	33,
	"CLASS",	34,
	"STRUCT",	35,
	"RETURN",	36,
	"GOTO",	37,
	"IF",	38,
	"ELSE",	39,
	"SWITCH",	40,
	"BREAK",	41,
	"CONTINUE",	42,
	"WHILE",	43,
	"DO",	44,
	"FOR",	45,
	"DEFAULT",	46,
	"CASE",	47,
	"SIZEOF",	48,
	"ENUM",	49,
	"LP",	50,
	"RP",	51,
	"LC",	52,
	"RC",	53,
	"LB",	54,
	"RB",	55,
	"CM",	56,
	"SM",	57,
	"ASSIGN",	58,
	"ASM",	59,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"ext_def_list : ext_def_list external_def",
	"ext_def_list : /* empty */",
	"external_def : data_def",
	"external_def : error",
	"external_def : ASM SM",
	"data_def : oattributes SM",
	"data_def : oattributes init_dcl_list SM",
	"data_def : oattributes fdeclarator",
	"data_def : oattributes fdeclarator function_body",
	"function_body : arg_dcl_list compoundstmt",
	"arg_dcl_list : arg_dcl_list declaration",
	"arg_dcl_list : /* empty */",
	"stmt_list : stmt_list statement",
	"stmt_list : /* empty */",
	"r_dcl_stat_list : dcl_stat_list attributes SM",
	"r_dcl_stat_list : dcl_stat_list attributes init_dcl_list SM",
	"dcl_stat_list : dcl_stat_list attributes SM",
	"dcl_stat_list : dcl_stat_list attributes init_dcl_list SM",
	"dcl_stat_list : /* empty */",
	"declaration : attributes declarator_list SM",
	"declaration : attributes SM",
	"declaration : error SM",
	"oattributes : attributes",
	"oattributes : /* empty */",
	"attributes : class type",
	"attributes : type class",
	"attributes : class",
	"attributes : type",
	"attributes : type class type",
	"class : CLASS",
	"type : TYPE",
	"type : TYPE TYPE",
	"type : TYPE TYPE TYPE",
	"type : struct_dcl",
	"type : enum_dcl",
	"enum_dcl : enum_head LC moe_list optcomma RC",
	"enum_dcl : ENUM NAME",
	"enum_head : ENUM",
	"enum_head : ENUM NAME",
	"moe_list : moe",
	"moe_list : moe_list CM moe",
	"moe : NAME",
	"moe : NAME ASSIGN con_e",
	"struct_dcl : str_head LC type_dcl_list optsemi RC",
	"struct_dcl : STRUCT NAME",
	"str_head : STRUCT",
	"str_head : STRUCT NAME",
	"type_dcl_list : type_declaration",
	"type_dcl_list : type_dcl_list SM type_declaration",
	"type_declaration : type declarator_list",
	"type_declaration : type",
	"declarator_list : declarator",
	"declarator_list : declarator_list CM",
	"declarator_list : declarator_list CM declarator",
	"declarator : fdeclarator",
	"declarator : nfdeclarator",
	"declarator : nfdeclarator COLON con_e",
	"declarator : COLON con_e",
	"declarator : error",
	"nfdeclarator : MUL nfdeclarator",
	"nfdeclarator : nfdeclarator LP RP",
	"nfdeclarator : nfdeclarator LB RB",
	"nfdeclarator : nfdeclarator LB con_e RB",
	"nfdeclarator : NAME",
	"nfdeclarator : LP nfdeclarator RP",
	"fdeclarator : MUL fdeclarator",
	"fdeclarator : fdeclarator LP RP",
	"fdeclarator : fdeclarator LB RB",
	"fdeclarator : fdeclarator LB con_e RB",
	"fdeclarator : LP fdeclarator RP",
	"fdeclarator : name_lp name_list RP",
	"fdeclarator : name_lp RP",
	"name_lp : NAME LP",
	"name_list : NAME",
	"name_list : name_list CM NAME",
	"name_list : error",
	"init_dcl_list : init_declarator",
	"init_dcl_list : init_dcl_list CM",
	"init_dcl_list : init_dcl_list CM init_declarator",
	"xnfdeclarator : nfdeclarator",
	"init_declarator : nfdeclarator",
	"init_declarator : fdeclarator",
	"init_declarator : xnfdeclarator optasgn e",
	"init_declarator : xnfdeclarator optasgn LC init_list optcomma RC",
	"init_declarator : error",
	"init_list : initializer",
	"init_list : init_list CM initializer",
	"initializer : e",
	"initializer : ibrace init_list optcomma RC",
	"optcomma : /* empty */",
	"optcomma : CM",
	"optsemi : /* empty */",
	"optsemi : SM",
	"optasgn : /* empty */",
	"optasgn : ASSIGN",
	"ibrace : LC",
	"compoundstmt : dcmpstmt",
	"compoundstmt : cmpstmt",
	"dcmpstmt : begin r_dcl_stat_list stmt_list RC",
	"cmpstmt : begin stmt_list RC",
	"begin : LC",
	"statement : e SM",
	"statement : ASM SM",
	"statement : compoundstmt",
	"statement : ifprefix statement",
	"statement : ifelprefix statement",
	"statement : whprefix statement",
	"statement : doprefix statement WHILE LP e RP SM",
	"statement : forprefix .e RP statement",
	"statement : switchpart statement",
	"statement : BREAK SM",
	"statement : CONTINUE SM",
	"statement : RETURN SM",
	"statement : RETURN e SM",
	"statement : GOTO NAME SM",
	"statement : SM",
	"statement : error SM",
	"statement : error RC",
	"statement : label statement",
	"label : NAME COLON",
	"label : CASE e COLON",
	"label : DEFAULT COLON",
	"doprefix : DO",
	"ifprefix : IF LP e RP",
	"ifelprefix : ifprefix statement ELSE",
	"whprefix : WHILE LP e RP",
	"forprefix : FOR LP .e SM .e SM",
	"switchpart : SWITCH LP e RP",
	"con_e : /* empty */",
	"con_e : e",
	".e : e",
	".e : /* empty */",
	"elist : e",
	"elist : elist CM e",
	"e : e RELOP e",
	"e : e CM e",
	"e : e DIVOP e",
	"e : e PLUS e",
	"e : e MINUS e",
	"e : e SHIFTOP e",
	"e : e MUL e",
	"e : e EQUOP e",
	"e : e AND e",
	"e : e OR e",
	"e : e ER e",
	"e : e ANDAND e",
	"e : e OROR e",
	"e : e QUEST e COLON e",
	"e : e ASOP e",
	"e : e ASSIGN e",
	"e : term",
	"term : term INCOP",
	"term : MUL term",
	"term : AND term",
	"term : MINUS term",
	"term : UNOP term",
	"term : INCOP term",
	"term : SIZEOF term",
	"term : LP cast_type RP term",
	"term : SIZEOF LP cast_type RP",
	"term : term LB e RB",
	"term : funct_idn RP",
	"term : funct_idn elist RP",
	"term : term STROP NAME",
	"term : NAME",
	"term : ICON",
	"term : FCON",
	"term : STRING",
	"term : LP e RP",
	"cast_type : type null_decl",
	"null_decl : /* empty */",
	"null_decl : LP RP",
	"null_decl : LP null_decl RP LP RP",
	"null_decl : MUL null_decl",
	"null_decl : null_decl LB RB",
	"null_decl : null_decl LB con_e RB",
	"null_decl : LP null_decl RP",
	"funct_idn : NAME LP",
	"funct_idn : term LP",
};
#endif /* YYDEBUG */
/*
 *	@(#) yaccpar 1.4 88/11/11 
 *
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1989 AT&T
 *	Portions Copyright 1980-1989 Microsoft Corporation
 *   Portions Copyright 1983-1989 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 */
#ident	"@(#)yacc:yaccpar	1.10"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** global variables used by the parser
*/
YYSTYPE yyv[ YYMAXDEPTH ];	/* value stack */
int yys[ YYMAXDEPTH ];		/* state stack */

YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ YYMAXDEPTH ] )	/* room on stack? */
		{
			yyerror( "yacc stack overflow" );
			YYABORT;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 2:
# line 166 "cgram.y"
ftnend(); break;
case 3:
# line 169 "cgram.y"
{ curclass = SNULL;  blevel = 0; } break;
case 4:
# line 171 "cgram.y"
{ curclass = SNULL;  blevel = 0; } break;
case 5:
# line 174 "cgram.y"
{ asmout(); curclass = SNULL; blevel = 0; } break;
case 6:
# line 178 "cgram.y"
{  yypvt[-1].nodep->in.op = FREE; } break;
case 7:
# line 180 "cgram.y"
{  yypvt[-2].nodep->in.op = FREE; } break;
case 8:
# line 181 "cgram.y"
{
			defid( tymerge(yypvt[-1].nodep,yypvt[-0].nodep), curclass==STATIC?STATIC:EXTDEF );
#ifndef LINT
			pfstab(stab[yypvt[-0].nodep->tn.rval].sname);
#endif
			} break;
case 9:
# line 187 "cgram.y"
{  
			    if( blevel ) cerror( "function level error" );
			    if( reached ) retstat |= NRETVAL; 
			    yypvt[-3].nodep->in.op = FREE;
			    ftnend();
			    } break;
case 12:
# line 198 "cgram.y"
{  blevel = 1; } break;
case 14:
# line 203 "cgram.y"
{  locctr(PROG);
			    bccode();
			    } break;
case 15:
# line 209 "cgram.y"
{  yypvt[-1].nodep->in.op = FREE; 
#ifndef LINT
			    plcstab(blevel);
#endif
			    } break;
case 16:
# line 215 "cgram.y"
{  yypvt[-2].nodep->in.op = FREE; 
#ifndef LINT
			    plcstab(blevel);
#endif
			    } break;
case 17:
# line 223 "cgram.y"
{  yypvt[-1].nodep->in.op = FREE; } break;
case 18:
# line 225 "cgram.y"
{  yypvt[-2].nodep->in.op = FREE; } break;
case 20:
# line 229 "cgram.y"
{ curclass = SNULL;  yypvt[-2].nodep->in.op = FREE; } break;
case 21:
# line 231 "cgram.y"
{ curclass = SNULL;  yypvt[-1].nodep->in.op = FREE; } break;
case 22:
# line 233 "cgram.y"
{  curclass = SNULL; } break;
case 24:
# line 237 "cgram.y"
{  yyval.nodep = mkty(INT,0,INT);  curclass = SNULL; } break;
case 25:
# line 240 "cgram.y"
{  yyval.nodep = yypvt[-0].nodep; } break;
case 27:
# line 243 "cgram.y"
{  yyval.nodep = mkty(INT,0,INT); } break;
case 28:
# line 245 "cgram.y"
{ curclass = SNULL ; } break;
case 29:
# line 247 "cgram.y"
{  yypvt[-2].nodep->in.type = types( yypvt[-2].nodep->in.type, yypvt[-0].nodep->in.type, UNDEF );
			    yypvt[-0].nodep->in.op = FREE;
			    } break;
case 30:
# line 254 "cgram.y"
{  curclass = yypvt[-0].intval; } break;
case 32:
# line 259 "cgram.y"
{  yypvt[-1].nodep->in.type = types( yypvt[-1].nodep->in.type, yypvt[-0].nodep->in.type, UNDEF );
			    yypvt[-0].nodep->in.op = FREE;
			    } break;
case 33:
# line 263 "cgram.y"
{  yypvt[-2].nodep->in.type = types( yypvt[-2].nodep->in.type, yypvt[-1].nodep->in.type, yypvt[-0].nodep->in.type );
			    yypvt[-1].nodep->in.op = yypvt[-0].nodep->in.op = FREE;
			    } break;
case 36:
# line 271 "cgram.y"
{ yyval.nodep = dclstruct(yypvt[-4].intval); } break;
case 37:
# line 273 "cgram.y"
{  yyval.nodep = rstruct(yypvt[-0].intval,0);  stwart = instruct; } break;
case 38:
# line 277 "cgram.y"
{  yyval.intval = bstruct(-1,0); stwart = SEENAME; } break;
case 39:
# line 279 "cgram.y"
{  yyval.intval = bstruct(yypvt[-0].intval,0); stwart = SEENAME; } break;
case 42:
# line 287 "cgram.y"
{  moedef( yypvt[-0].intval ); } break;
case 43:
# line 289 "cgram.y"
{  strucoff = yypvt[-0].intval;  moedef( yypvt[-2].intval ); } break;
case 44:
# line 293 "cgram.y"
{ yyval.nodep = dclstruct(yypvt[-4].intval);  } break;
case 45:
# line 295 "cgram.y"
{  yyval.nodep = rstruct(yypvt[-0].intval,yypvt[-1].intval); } break;
case 46:
# line 299 "cgram.y"
{  yyval.intval = bstruct(-1,yypvt[-0].intval);  stwart=0; } break;
case 47:
# line 301 "cgram.y"
{  yyval.intval = bstruct(yypvt[-0].intval,yypvt[-1].intval);  stwart=0;  } break;
case 50:
# line 309 "cgram.y"
{ curclass = SNULL;  stwart=0; yypvt[-1].nodep->in.op = FREE; } break;
case 51:
# line 311 "cgram.y"
{  if( curclass != MOU ){
				curclass = SNULL;
				}
			    else {
				sprintf( fakename, "$%dFAKE", fake++ );
#ifdef FLEXSTRINGS
				/* No need to hash this, we won't look it up */
				defid( tymerge(yypvt[-0].nodep, bdty(NAME,NIL,lookup( savestr(fakename), SMOS ))), curclass );
#else
				defid( tymerge(yypvt[-0].nodep, bdty(NAME,NIL,lookup( fakename, SMOS ))), curclass );
#endif
				werror("structure typed union member must be named");
				}
			    stwart = 0;
			    yypvt[-0].nodep->in.op = FREE;
			    } break;
case 52:
# line 331 "cgram.y"
{ defid( tymerge(yypvt[-1].nodep,yypvt[-0].nodep), curclass);  stwart = instruct; } break;
case 53:
# line 332 "cgram.y"
{yyval.nodep=yypvt[-2].nodep;} break;
case 54:
# line 333 "cgram.y"
{ defid( tymerge(yypvt[-4].nodep,yypvt[-0].nodep), curclass);  stwart = instruct; } break;
case 57:
# line 339 "cgram.y"
{  if( !(instruct&INSTRUCT) ) uerror( "field outside of structure" );
			    if( yypvt[-0].intval<0 || yypvt[-0].intval >= FIELD ){
				uerror( "illegal field size" );
				yypvt[-0].intval = 1;
				}
			    defid( tymerge(yypvt[-3].nodep,yypvt[-2].nodep), FIELD|yypvt[-0].intval );
			    yyval.nodep = NIL;
			    } break;
case 58:
# line 349 "cgram.y"
{  if( !(instruct&INSTRUCT) ) uerror( "field outside of structure" );
			    falloc( stab, yypvt[-0].intval, -1, yypvt[-2].nodep );  /* alignment or hole */
			    yyval.nodep = NIL;
			    } break;
case 59:
# line 354 "cgram.y"
{  yyval.nodep = NIL; } break;
case 60:
# line 359 "cgram.y"
{  umul:
				yyval.nodep = bdty( UNARY MUL, yypvt[-0].nodep, 0 ); } break;
case 61:
# line 362 "cgram.y"
{  uftn:
				yyval.nodep = bdty( UNARY CALL, yypvt[-2].nodep, 0 );  } break;
case 62:
# line 365 "cgram.y"
{  uary:
				yyval.nodep = bdty( LB, yypvt[-2].nodep, 0 );  } break;
case 63:
# line 368 "cgram.y"
{  bary:
				if( (int)yypvt[-1].intval <= 0 ) werror( "zero or negative subscript" );
				yyval.nodep = bdty( LB, yypvt[-3].nodep, yypvt[-1].intval );  } break;
case 64:
# line 372 "cgram.y"
{  yyval.nodep = bdty( NAME, NIL, yypvt[-0].intval );  } break;
case 65:
# line 374 "cgram.y"
{ yyval.nodep=yypvt[-1].nodep; } break;
case 66:
# line 377 "cgram.y"
{  goto umul; } break;
case 67:
# line 379 "cgram.y"
{  goto uftn; } break;
case 68:
# line 381 "cgram.y"
{  goto uary; } break;
case 69:
# line 383 "cgram.y"
{  goto bary; } break;
case 70:
# line 385 "cgram.y"
{ yyval.nodep = yypvt[-1].nodep; } break;
case 71:
# line 387 "cgram.y"
{
				if( blevel!=0 ) uerror("function declaration in bad context");
				yyval.nodep = bdty( UNARY CALL, bdty(NAME,NIL,yypvt[-2].intval), 0 );
				stwart = 0;
				} break;
case 72:
# line 393 "cgram.y"
{
				yyval.nodep = bdty( UNARY CALL, bdty(NAME,NIL,yypvt[-1].intval), 0 );
				stwart = 0;
				} break;
case 73:
# line 400 "cgram.y"
{
				/* turn off typedefs for argument names */
				stwart = SEENAME;
				if( stab[yypvt[-1].intval].sclass == SNULL )
				    stab[yypvt[-1].intval].stype = FTN;
				} break;
case 74:
# line 409 "cgram.y"
{ ftnarg( yypvt[-0].intval );  stwart = SEENAME; } break;
case 75:
# line 411 "cgram.y"
{ ftnarg( yypvt[-0].intval );  stwart = SEENAME; } break;
case 78:
# line 417 "cgram.y"
{yyval.nodep=yypvt[-2].nodep;} break;
case 80:
# line 421 "cgram.y"
{  defid( yypvt[-0].nodep = tymerge(yypvt[-1].nodep,yypvt[-0].nodep), curclass);
			    beginit(yypvt[-0].nodep->tn.rval);
			    } break;
case 81:
# line 428 "cgram.y"
{  NODE *p = yypvt[-0].nodep;
			    nidcl( tymerge(yypvt[-1].nodep,yypvt[-0].nodep) ); 
#ifndef BUG1
			    if(idebug)
				lookaround(yypvt);
#endif
			    if( ISARY(p->in.type) )
				outstab(&stab[p->tn.rval]);
			} break;
case 82:
# line 438 "cgram.y"
{  defid( tymerge(yypvt[-1].nodep,yypvt[-0].nodep), uclass(curclass) );
			    if(paramno) {
				uerror("can't declare parameters here");
				paramno = 0;
			    }
			} break;
case 83:
# line 446 "cgram.y"
{  NODE *p;
			    p = yypvt[-2].nodep;
			    doinit( yypvt[-0].nodep );
			    endinit(); 
#ifndef BUG1
			    if(idebug)
				lookaround(yypvt);
#endif
			    if( ISARY(p->in.type) )
				outstab(&stab[p->tn.rval]);
			} break;
case 84:
# line 458 "cgram.y"
{  NODE *p;
			    p = yypvt[-5].nodep;
			    endinit(); 
#ifndef BUG1
			    if(idebug)
				lookaround(yypvt);
#endif
			    if( ISARY(p->in.type) )
				outstab(&stab[p->tn.rval]);
			} break;
case 88:
# line 477 "cgram.y"
{  doinit( yypvt[-0].nodep ); } break;
case 89:
# line 479 "cgram.y"
{  irbrace(); } break;
case 94:
# line 491 "cgram.y"
{  werror( "old-fashioned initialization: use =" ); } break;
case 96:
# line 496 "cgram.y"
{  ilbrace(); } break;
case 99:
# line 506 "cgram.y"
{  
#ifndef LINT
			    prcstab(blevel);
#endif
			    --blevel;
			    if( blevel == 1 ) blevel = 0;
			    clearst( blevel );
			    checkst( blevel );
			    autooff = *--psavbc;
			    regvar = *--psavbc;
			    } break;
case 100:
# line 520 "cgram.y"
{  --blevel;
			    if( blevel == 1 ) blevel = 0;
			    clearst( blevel );
			    checkst( blevel );
			    autooff = *--psavbc;
			    regvar = *--psavbc;
			    } break;
case 101:
# line 530 "cgram.y"
{  if( blevel == 1 ) dclargs();
			    ++blevel;
			    if( psavbc > &asavbc[BCSZ-2] ) cerror( "nesting too deep" );
			    *psavbc++ = regvar;
			    *psavbc++ = autooff;
			    } break;
case 102:
# line 539 "cgram.y"
{ ecomp( yypvt[-1].nodep ); } break;
case 103:
# line 542 "cgram.y"
{ asmout(); } break;
case 105:
# line 545 "cgram.y"
{ deflab(yypvt[-1].intval);
			   reached = 1;
			   } break;
case 106:
# line 549 "cgram.y"
{  if( yypvt[-1].intval != NOLAB ){
				deflab( yypvt[-1].intval );
				reached = 1;
				}
			    } break;
case 107:
# line 555 "cgram.y"
{  branch(  contlab );
			    deflab( brklab );
			    if( (flostat&FBRK) || !(flostat&FLOOP)) reached = 1;
			    else reached = 0;
			    resetbc(0);
			    } break;
case 108:
# line 562 "cgram.y"
{  deflab( contlab );
			    if( flostat & FCONT ) reached = 1;
			    ecomp( buildtree( CBRANCH, buildtree( NOT, yypvt[-2].nodep, NIL ), bcon( yypvt[-6].intval ) ) );
			    deflab( brklab );
			    reached = 1;
			    resetbc(0);
			    } break;
case 109:
# line 570 "cgram.y"
{  deflab( contlab );
			    if( flostat&FCONT ) reached = 1;
			    if( yypvt[-2].nodep ) ecomp( yypvt[-2].nodep );
			    branch( yypvt[-3].intval );
			    deflab( brklab );
			    if( (flostat&FBRK) || !(flostat&FLOOP) ) reached = 1;
			    else reached = 0;
			    resetbc(0);
			    } break;
case 110:
# line 580 "cgram.y"
{  if( reached ) branch( brklab );
			    deflab( yypvt[-1].intval );
			   swend();
			    deflab(brklab);
			    if( (flostat&FBRK) || !(flostat&FDEF) ) reached = 1;
			    resetbc(FCONT);
			    } break;
case 111:
# line 588 "cgram.y"
{  if( brklab == NOLAB ) uerror( "illegal break");
			    else if(reached) branch( brklab );
			    flostat |= FBRK;
			    if( brkflag ) goto rch;
			    reached = 0;
			    } break;
case 112:
# line 595 "cgram.y"
{  if( contlab == NOLAB ) uerror( "illegal continue");
			    else branch( contlab );
			    flostat |= FCONT;
			    goto rch;
			    } break;
case 113:
# line 601 "cgram.y"
{  retstat |= NRETVAL;
			    branch( retlab );
			rch:
			    if( !reached ) werror( "statement not reached");
			    reached = 0;
			    } break;
case 114:
# line 608 "cgram.y"
{  register NODE *temp;
			    idname = curftn;
			    temp = buildtree( NAME, NIL, NIL );
			    if(temp->in.type == TVOID)
				uerror("void function %s cannot return value",
					stab[idname].sname);
			    temp->in.type = DECREF( temp->in.type );
			    temp = buildtree( RETURN, temp, yypvt[-1].nodep );
			    /* now, we have the type of the RHS correct */
			    tfree(temp->in.left);
			    temp->in.op = FREE;
			    ecomp( buildtree( FORCE, temp->in.right, NIL ) );
			    retstat |= RETVAL;
			    branch( retlab );
			    reached = 0;
			    } break;
case 115:
# line 625 "cgram.y"
{  register NODE *q;
			    q = block( FREE, NIL, NIL, INT|ARY, 0, INT );
			    q->tn.rval = idname = yypvt[-1].intval;
			    defid( q, ULABEL );
			    stab[idname].suse = -lineno;
			    branch( stab[idname].offset );
			    goto rch;
			    } break;
case 120:
# line 639 "cgram.y"
{  register NODE *q;
			    q = block( FREE, NIL, NIL, INT|ARY, 0, LABEL );
			    q->tn.rval = yypvt[-1].intval;
			    defid( q, LABEL );
			    reached = 1;
			    } break;
case 121:
# line 646 "cgram.y"
{  addcase(yypvt[-1].nodep);
			    reached = 1;
			    } break;
case 122:
# line 650 "cgram.y"
{  reached = 1;
			    adddef();
			    flostat |= FDEF;
			    } break;
case 123:
# line 656 "cgram.y"
{  savebc();
			    if( !reached ) werror( "loop not entered at top");
			    brklab = getlab();
			    contlab = getlab();
			    deflab( yyval.intval = getlab() );
			    reached = 1;
			    } break;
case 124:
# line 665 "cgram.y"
{  ecomp( buildtree( CBRANCH, yypvt[-1].nodep, bcon( yyval.intval=getlab()) ) ) ;
			    reached = 1;
			    } break;
case 125:
# line 670 "cgram.y"
{  if( reached ) branch( yyval.intval = getlab() );
			    else yyval.intval = NOLAB;
			    deflab( yypvt[-2].intval );
			    reached = 1;
			    } break;
case 126:
# line 678 "cgram.y"
{  savebc();
			    if( !reached ) werror( "loop not entered at top");
			    if( yypvt[-1].nodep->in.op == ICON && yypvt[-1].nodep->tn.lval != 0 ) flostat = FLOOP;
			    deflab( contlab = getlab() );
			    reached = 1;
			    brklab = getlab();
			    if( flostat == FLOOP ) tfree( yypvt[-1].nodep );
			    else ecomp( buildtree( CBRANCH, yypvt[-1].nodep, bcon( brklab) ) );
			    } break;
case 127:
# line 689 "cgram.y"
{  if( yypvt[-3].nodep ) ecomp( yypvt[-3].nodep );
			    else if( !reached ) werror( "loop not entered at top");
			    savebc();
			    contlab = getlab();
			    brklab = getlab();
			    deflab( yyval.intval = getlab() );
			    reached = 1;
			    if( yypvt[-1].nodep ) ecomp( buildtree( CBRANCH, yypvt[-1].nodep, bcon( brklab) ) );
			    else flostat |= FLOOP;
			    } break;
case 128:
# line 701 "cgram.y"
{  savebc();
			    brklab = getlab();
			    ecomp( buildtree( FORCE, yypvt[-1].nodep, NIL ) );
			    branch( yyval.intval = getlab() );
			    swstart();
			    reached = 0;
			    } break;
case 129:
# line 710 "cgram.y"
{ yyval.intval=instruct; stwart=instruct=0; } break;
case 130:
# line 712 "cgram.y"
{  yyval.intval = icons( yypvt[-0].nodep );  instruct=yypvt[-1].intval; } break;
case 132:
# line 716 "cgram.y"
{ yyval.nodep=0; } break;
case 134:
# line 721 "cgram.y"
{  goto bop; } break;
case 135:
# line 725 "cgram.y"
{
			preconf:
			    if( yychar==RELOP||yychar==EQUOP||yychar==AND||yychar==OR||yychar==ER ){
			    precplaint:
				if( hflag ) werror( "precedence confusion possible: parenthesize!" );
				}
			bop:
			    yyval.nodep = buildtree( yypvt[-1].intval, yypvt[-2].nodep, yypvt[-0].nodep );
			    } break;
case 136:
# line 735 "cgram.y"
{  yypvt[-1].intval = COMOP;
			    goto bop;
			    } break;
case 137:
# line 739 "cgram.y"
{  goto bop; } break;
case 138:
# line 741 "cgram.y"
{  if(yychar==SHIFTOP) goto precplaint; else goto bop; } break;
case 139:
# line 743 "cgram.y"
{  if(yychar==SHIFTOP ) goto precplaint; else goto bop; } break;
case 140:
# line 745 "cgram.y"
{  if(yychar==PLUS||yychar==MINUS) goto precplaint; else goto bop; } break;
case 141:
# line 747 "cgram.y"
{  goto bop; } break;
case 142:
# line 749 "cgram.y"
{  goto preconf; } break;
case 143:
# line 751 "cgram.y"
{  if( yychar==RELOP||yychar==EQUOP ) goto preconf;  else goto bop; } break;
case 144:
# line 753 "cgram.y"
{  if(yychar==RELOP||yychar==EQUOP) goto preconf; else goto bop; } break;
case 145:
# line 755 "cgram.y"
{  if(yychar==RELOP||yychar==EQUOP) goto preconf; else goto bop; } break;
case 146:
# line 757 "cgram.y"
{  goto bop; } break;
case 147:
# line 759 "cgram.y"
{  goto bop; } break;
case 148:
# line 761 "cgram.y"
{  yyval.nodep=buildtree(QUEST, yypvt[-4].nodep, buildtree( COLON, yypvt[-2].nodep, yypvt[-0].nodep ) );
			    } break;
case 149:
# line 764 "cgram.y"
{  goto bop; } break;
case 150:
# line 766 "cgram.y"
{  goto bop; } break;
case 152:
# line 770 "cgram.y"
{  yyval.nodep = buildtree( yypvt[-0].intval, yypvt[-1].nodep, bcon(1) ); } break;
case 153:
# line 772 "cgram.y"
{ ubop:
			    yyval.nodep = buildtree( UNARY yypvt[-1].intval, yypvt[-0].nodep, NIL );
			    } break;
case 154:
# line 776 "cgram.y"
{  if( ISFTN(yypvt[-0].nodep->in.type) || ISARY(yypvt[-0].nodep->in.type) ){
				werror( "& before array or function: ignored" );
				yyval.nodep = yypvt[-0].nodep;
				}
			    else goto ubop;
			    } break;
case 155:
# line 783 "cgram.y"
{  goto ubop; } break;
case 156:
# line 785 "cgram.y"
{
			    yyval.nodep = buildtree( yypvt[-1].intval, yypvt[-0].nodep, NIL );
			    } break;
case 157:
# line 789 "cgram.y"
{  yyval.nodep = buildtree( yypvt[-1].intval==INCR ? ASG PLUS : ASG MINUS,
						yypvt[-0].nodep,
						bcon(1)  );
			    } break;
case 158:
# line 794 "cgram.y"
{  yyval.nodep = doszof( yypvt[-0].nodep ); } break;
case 159:
# line 796 "cgram.y"
{  yyval.nodep = buildtree( CAST, yypvt[-2].nodep, yypvt[-0].nodep );
			    yyval.nodep->in.left->in.op = FREE;
			    yyval.nodep->in.op = FREE;
			    yyval.nodep = yyval.nodep->in.right;
			    } break;
case 160:
# line 802 "cgram.y"
{  yyval.nodep = doszof( yypvt[-1].nodep ); } break;
case 161:
# line 804 "cgram.y"
{  yyval.nodep = buildtree( UNARY MUL, buildtree( PLUS, yypvt[-3].nodep, yypvt[-1].nodep ), NIL ); } break;
case 162:
# line 806 "cgram.y"
{  yyval.nodep=buildtree(UNARY CALL,yypvt[-1].nodep,NIL); } break;
case 163:
# line 808 "cgram.y"
{  yyval.nodep=buildtree(CALL,yypvt[-2].nodep,yypvt[-1].nodep); } break;
case 164:
# line 810 "cgram.y"
{  if( yypvt[-1].intval == DOT ){
				if( notlval( yypvt[-2].nodep ) )uerror("structure reference must be addressable");
				yypvt[-2].nodep = buildtree( UNARY AND, yypvt[-2].nodep, NIL );
				}
			    idname = yypvt[-0].intval;
			    yyval.nodep = buildtree( STREF, yypvt[-2].nodep, buildtree( NAME, NIL, NIL ) );
			    } break;
case 165:
# line 818 "cgram.y"
{  idname = yypvt[-0].intval;
			    /* recognize identifiers in initializations */
			    if( blevel==0 && stab[idname].stype == UNDEF ) {
				register NODE *q;
#ifndef FLEXNAMES
				werror( "undeclared initializer name %.8s", stab[idname].sname );
#else
				werror( "undeclared initializer name %s", stab[idname].sname );
#endif
				q = block( FREE, NIL, NIL, INT, 0, INT );
				q->tn.rval = idname;
				defid( q, EXTERN );
				}
			    yyval.nodep=buildtree(NAME,NIL,NIL);
			    stab[yypvt[-0].intval].suse = -lineno;
			} break;
case 166:
# line 835 "cgram.y"
{  yyval.nodep=bcon(0);
			    yyval.nodep->tn.lval = lastcon;
			    yyval.nodep->tn.rval = NONAME;
			    if( yypvt[-0].intval ) yyval.nodep->fn.csiz = yyval.nodep->in.type = ctype(LONG);
			    /* DJK put this in. DW took it out.
			    * if( <0 ){
			    *	$$->in.type = UNSIGNED;
			    * }
			    */
			    } break;
case 167:
# line 846 "cgram.y"
{  yyval.nodep=buildtree(FCON,NIL,NIL);
			    yyval.nodep->fpn.dval = dcon;
			    } break;
case 168:
# line 850 "cgram.y"
{  yyval.nodep = getstr(); /* get string contents */ } break;
case 169:
# line 852 "cgram.y"
{ yyval.nodep=yypvt[-1].nodep; } break;
case 170:
# line 856 "cgram.y"
{
			yyval.nodep = tymerge( yypvt[-1].nodep, yypvt[-0].nodep );
			yyval.nodep->in.op = NAME;
			yypvt[-1].nodep->in.op = FREE;
			} break;
case 171:
# line 864 "cgram.y"
{ yyval.nodep = bdty( NAME, NIL, -1 ); } break;
case 172:
# line 866 "cgram.y"
{ yyval.nodep = bdty( UNARY CALL, bdty(NAME,NIL,-1),0); } break;
case 173:
# line 868 "cgram.y"
{  yyval.nodep = bdty( UNARY CALL, yypvt[-3].nodep, 0 ); } break;
case 174:
# line 870 "cgram.y"
{  goto umul; } break;
case 175:
# line 872 "cgram.y"
{  goto uary; } break;
case 176:
# line 874 "cgram.y"
{  goto bary;  } break;
case 177:
# line 876 "cgram.y"
{ yyval.nodep = yypvt[-1].nodep; } break;
case 178:
# line 880 "cgram.y"
{  if( stab[yypvt[-1].intval].stype == UNDEF ){
				register NODE *q;
				q = block( FREE, NIL, NIL, FTN|INT, 0, INT );
				q->tn.rval = yypvt[-1].intval;
				defid( q, EXTERN );
				}
			    idname = yypvt[-1].intval;
			    yyval.nodep=buildtree(NAME,NIL,NIL);
			    stab[idname].suse = -lineno;
			} break;
	}
	goto yystack;		/* reset registers in driver code */
}
