# 1 "pow.c"


































# 1 "/u/cinclude/math.h"
























extern int errno, signgam;

extern double atof(), frexp(), ldexp(), modf();
extern double j0(), j1(), jn(), y0(), y1(), yn();
extern double erf(), erfc();
extern double exp(), log(), log10(), pow(), sqrt();
extern double floor(), ceil(), fmod(), fabs();
extern double gamma();
extern double hypot();
extern int matherr();
extern double sinh(), cosh(), tanh();
extern double sin(), cos(), tan(), asin(), acos(), atan(), atan2();
















# 55 "/u/cinclude/math.h"


# 59 "/u/cinclude/math.h"


# 63 "/u/cinclude/math.h"
























struct exception {
	int type;
	char *name;
	double arg1;
	double arg2;
	double retval;
};










# 35 "pow.c"

# 1 "/u/cinclude/values.h"































































# 91 "/u/cinclude/values.h"











































# 36 "pow.c"

# 1 "/u/cinclude/errno.h"























# 28 "/u/cinclude/errno.h"

extern int errno;
extern int mpxerr;


























































extern char * sys_errlist[];
void perror ();































































































# 37 "pow.c"

double
pow(x, y)
register double x, y;
{
	register int neg;
	struct exception exc;

	if (y == 1) 
		return (x);
	exc.name = "pow";
	exc.arg1 = x;
	exc.arg2 = y;
	exc.retval = 0.0;
	if (!x) {
		if (y > 0)
			return (x); 
		goto domain;
	}
	neg = 0;
	if (x < 0) { 
		if (y >= -(~((unsigned long)1L << (8 * (int)sizeof(long)) - 1)) && y <= (~((unsigned long)1L << (8 * (int)sizeof(long)) - 1))) {
			register long ly = (long)y;

			if ((double)ly != y)
				goto domain; 
			neg = ly % 2;
		} else {
			double fr, dum, modf();

			if (fr = modf(0.5 * y, &dum)) {
				if (fr != 0.5)
					goto domain; 
				neg++; 
			}
		}
		x = -x;
	}
	if (x != 1) { 
		

		if ((x = log(x)) < 0) { 
			x = -x;
			y = -y;
		}
		if (y > (0.69314718055994530942 * ((1 << 8 - 1) - 1 + 0))/x) {
			exc.type = 3;
			exc.retval = neg ? -((float)0.7237005145e76) : ((float)0.7237005145e76);
			if (!matherr(&exc))
				errno = 34;
			return (exc.retval);
		}
		if (y < (0.69314718055994530942 * ((-(((1 << 8 - 1) - 1 + 0)+1)) - 1))/x) {
			exc.type = 4;
			if (!matherr(&exc))
				errno = 34;
			return (exc.retval);
		}
		x = exp(x * y); 
	}
	return (neg ? -x : x);

domain:
	exc.type = 1;
	if (!matherr(&exc)) {
		(void) write(2, "pow: DOMAIN error\n", 18);
		errno = 33;
	}
	return (exc.retval);
}
