/*~!errafter.c*/
/* Name:  errafter.c Part No.: _______-____r
 *
 * Copyright 1992 - J B Systems, Morrison, CO
 *
 * The recipient of this product specifically agrees not to distribute,
 * disclose, or disseminate in any way, to any one, nor use for its own
 * benefit, or the benefit of others, any information contained  herein
 * without the expressed written consent of J B Systems.
 *
 *                     RESTRICTED RIGHTS LEGEND
 *
 * Use, duplication, or disclosure by the Government is  subject  to
 * restriction  as  set forth in paragraph (b) (3) (B) of the Rights
 * in Technical Data and Computer Software  Clause  in  DAR  7-104.9
 * (a).
 */

#ident	"@(#)nbclib:errafter.c	1.1"

/*
	Customized routine called after error message has been printed.
	Command and library version.
	Return a value to indicate action.
*/

#include "errmsg.h"
#include <stdio.h>
#include <varargs.h>

int
errafter(severity, format, print_args)
int	severity;
char	*format;
va_list print_args;
{
    switch (severity) {
      case EHALT:
    	return EABORT;
      case EERROR:
    	return EEXIT;
      case EWARN:
    	return ERETURN;
      case EINFO:
    	return ERETURN;
    }
    return ERETURN;
}
