   00001                                * TXPM EQU FILE FOR TXPM 3X SYSTEM
   00002                                C.3227   SETT
   00003                                C.TRACF  SETF
   00004                                C.MEMO   SETF
   00005                                C.SALONE SETF
   00006                                C.SYSGON SETF
   00007                                C.MPX1X  SETF                           for 1x code
   00008                                C.MPX3X  SETT                           for 3x code
   00009                                MPX35    SETF                           for 3.5 code
   00010                                *
   00236                                *~!c.srt.s*/
   00237                                * Name:  c.srt.s Part No.: _______-____r
   00238                                *
   00239                                * Copyright 1990 - J B Systems, Morrison, CO
   00240                                *
   00241                                * The recipient of this product specifically agrees not to distribute,
   00242                                * disclose, or disseminate in any way, to any one, nor use for its own
   00243                                * benefit, or the benefit of others, any information contained  herein
   00244                                * without the expressed written consent of J B Systems.
   00245                                *
   00246                                *                     RESTRICTED RIGHTS LEGEND
   00247                                *
   00248                                * Use, duplication, or disclosure by the Government is  subject  to
   00249                                * restriction  as  set forth in paragraph (b) (3) (B) of the Rights
   00250                                * in Technical Data and Computer Software  Clause  in  DAR  7-104.9
   00251                                * (a).
   00252                                */
   00253                                * #ident    "@(#)nbclib:c.srt.s 1.0"
   00254                                         PROGRAM   C.SRT
  
   00256                                ************************************************************************
   00257                                *
   00258                                * _C.SRT IS THE MAIN ROUTINE FOR C PROGRAMS.  IT ESTABLISHES THE
   00259                                *        STACK AND CALLS A C ROUTINE THAT READS ARGUMENTS AND INVOKES
   00260                                *        THE C PROGRAM WITH THE ARGUMENTS.  IN ADDITION, IT CALCULATES
   00261                                *        THE SIZE OF A MAP BLOCK AND SETS A POINTER TO THE END OF THE
   00262                                *        PROGRAM'S ADDRESS SPACE.
   00263                                *
   00264                                ************************************************************************
  
   00266                                         DEF       _c.srt
   00267                                         DEF       _eas
   00268                                         DEF       _csect
   00269                                         DEF       _blksize
   00270                                         DEF       _bufrsio
   00271                                         DEF       _runrflg
   00272                                *                                  ! THESE ARE FROM CFLGS.S
   00273                                         DEF       u.mbrk,u.endstk
   00274                                         DEF       c.flgs
   00275                                *
   00276                                         EXT       __mpxini
  
  
   00278                                ************************************************************************
   00279                                * REGISTER AND CONDITION CODE EQUATES
   00280                                ************************************************************************
  
   00282    00000                       R0       EQU       0               ! REGISTER 0 EQUATE
   00283    00001                       R1       EQU       1               ! REGISTER 1 EQUATE
   00284    00002                       R2       EQU       2               ! REGISTER 2 EQUATE
   00285    00003                       R3       EQU       3               ! REGISTER 3 EQUATE
   00286    00003                       SP       EQU       3               ! REGISTER 3 EQUATE (STACK POINTER)
   00287    00004                       R4       EQU       4               ! REGISTER 4 EQUATE
   00288    00005                       R5       EQU       5               ! REGISTER 5 EQUATE
   00289    00006                       R6       EQU       6               ! REGISTER 6 EQUATE
   00290    00007                       R7       EQU       7               ! REGISTER 7 EQUATE
  
   00292                                         IFF       C.MPX1X,SKIP
   00293    00AC4                       C.MGRAN  EQU       X'AC4'          CPU MAP GRANULARITY FOR 3X
   00294                                SKIP     ANOP
   00295                                         IFT       C.MPX1X,SKIP
   00296                                C.MGRAN  EQU       X'ACC'          CPU MAP GRANULARITY FOR 1X
   00297                                SKIP     ANOP
   00298    FFFFE                       STK7X    EQU       -2              ! SIZE OF C STK ON 32/7X
   00299                                *                                    INCLUDING IO BUFS AT TOP
   00300    FFFF8                       STK3X    EQU       -8              ! SIZE OF C STK ON 32/27
   00301                                *                                    INCLUDING IO BUFS AT TOP
   00302  *P00000                                CSECT
  
   00304    00001                       CC1      EQU       1               ! CONDITION CODE 1 EQUATE
  
   00306  *P00000  45303238             ABRTCODE DATAW     C'E028'         ! ABORT CODE
   00308  *P00004                       _c.srt   EQU       $
  
  
   00310                                ************************************************************************
   00311                                * ESTABLISH THE C STACK
   00312                                ************************************************************************
  
   00314  *P00004  D4800010   P00010             STW       R1,_runrflg     ! NON ZERO IF RUN REQ'D
   00315  *P00008  AF000AC4    00AC4             LW        R6,C.MGRAN      ! GET C. CONTAINING BLKSIZE
   00316  *P0000C  D7000008   P00008             STW       R6,_blksize     ! STORE IN BLKSIZE
   00317  *P00010  CB80FFF8                      LI        R7,STK3X        ! Assume Concept machine
   00318  *P00014  CB052000                      CI        R6,X'2000'      ! Concept machine
   00319  *P00018  EE000021  *P00020             BEQ       $+2W            ! Branch if Concept machine
   00320  *P0001C  CB80FFFE                      LI        R7,STK7X        ! It is a 32/7X
   00321  *P00020  C8061067             LOOP     SVC       1,X'67'         ! GET A MAP BLOCK OF BUF SPACE
   00322  *P00024  2DB0                          TRR       R3,R3
          *P00026      0002
   00323  *P00028  EE000065  *P00064             BZ        ABORT
   00324  *P0002C  2EE4                          TRN       R6,R5           ! NEG MAP SIZE
          *P0002E      0002
   00325  *P00030  F8600002    00000             ZMD       0D,R3           ! ZERO A DOUBLE WD
   00326  *P00034  C9810008                      ADI       R3,1D           ! BUMP POINTER
   00327  *P00038  F6E00031  *P00030             BID       R5,$-2W         ! CLEAR THE WHOLE MAP
   00328  *P0003C  F7800021  *P00020             BIB       R7,LOOP         ! LOOP FOR ALL MAP BLOCKS
   00329  *P00040  C8061065                      SVC       1,X'65'         ! GET PROGRAM ADDRESS LIMITS
   00330  *P00044  CA810004                      ADI       R5,1W           ! START OF NEXT MAP
   00331                                *jcb*    SRL       R5,5            ! ROUND STACK ADDR TO FILE BOUND
   00332                                *jcb*    SLL       R5,5
   00333  *P00048  2DD0                          TRR       R5,R3           ! SET STACK POINTER ADDR
          *P0004A      0002
   00334  *P0004C  D6800000   P00000             STW       R5,_eas         ! SET EAS TO END OF ADDRESS SPACE
   00335  *P00050  C9824000                      SUI       R3,X'4000'      ! LEAVE BUFFER SPACE (2 MAP'S)
   00336                                *jcb*    TRR       R3,R4           ! START OF BUFFERS
   00337                                *jcb*    ADI       R4,X'20'        ! MAP BLOCK BOUND
   00338  *P00054  D580000C   P0000C             STW       R3,_bufrsio     ! POINTER TO IO BUFFERS
   00339  *P00058  D7000004   P00004             STW       R6,_csect       ! SET EAS TO START OF CSECT
   00340  *P0005C  000D                          SEA                       ! RUN EXTENDED ANYWAY
          *P0005E      0002
   00341  *P00060  F8800001   X00000             BL        __mpxini        ! CALL THE ARGUMENT INIT ROUTINE
   00342                                * ABORT IF ANY PROBLEMS
  
   00344  *P00064  AE800000  *P00000    ABORT    LW        R5,ABRTCODE
   00345  *P00068  C8061057                      SVC       1,X'57'
   00346                                *
   00347   P00000                                DSECT
   00348   P00000  00000000             _eas     REZ       1W       ! POINTER TO END OF ADDRESS SPACE
   00349   P00004  00000000             _csect   REZ       1W       ! POINTER TO START OF CSECT
   00350   P00008  00000000             _blksize REZ       1W       ! MAP BLOCK SIZE
   00351   P0000C  00000000             _bufrsio REZ       1W       ! POINTER TO IO BUFFERS
   00352   P00010  00000000             _runrflg REZ       1W       ! RUN REQUESTED TASK
   00353   P00014  00000000             c.flgs   DATAW     0
   00354   P00018  00000000             u.mbrk   DATAW     0
   00355   P0001C  00000000             u.endstk DATAW     0
   00356   P00020            *P00004             END       _c.srt
*  0000  ERRORS IN C.SRT
