*  *********************************************************************
*
*  $Locked:       01-DEC-93 08:18  BEVIER    Add external trap support.$
*  $Header:  295  01-DEC-93 08:20  BEVIER    BEVIER                    $
*  $Log:   @ISCSRC^(DV.TXPM.SYSM)SH.TXPM                               $
*  
*       Rev  295  01-DEC-93 08:20  BEVIER    BEVIER                     
*  MPX 3.6 Non-RSX IPU support.                                         
*  
*       Rev  294  24-SEP-93 09:30  MJF       MJF                        
*  M.LOGMVT support (bias R2), used by VOLMGR.                          
*
*       Rev  293  09-JUL-93 14:03  MJF       MJF
*  Fix Rolls Royce problem.  Problem was caused by QDEC (QLNK 6.2a
*  version) not looking like a real handler.  Its ep1 from the hat
*  didn't point to an icb, but rather right to code.  I fixed this in
*  TXPM; SAIC should also fix their handler.
*
*       Rev  292  06-MAY-93 13:21  MJF       MJF
*  Fix fix # 91.  When we move the trap context blocks, we
*  weren't biasing the target of the BL $+1W.
*
*       Rev  291  07-DEC-92 09:31  JACK      SYSTEM
*  Modified CPU Trap routines to ensure that CCs are retained
*
*       Rev  290  04-NOV-92 14:26  MJF       MJF
*  Fix fix# 286.  The check was all wrong, so E.5D worked for
*  3.5u02, but for no other 3.5 version.
*
*       Rev  289  25-AUG-92 15:08  GANN      GANN
*  Changed to allow T-XPM to work on a split MPX system.  When
*  dispatching to a base mode PSD assume an OS dispatch.
*
*       Rev  288  13-JUL-92 13:41  MJF       MJF
*  E.5D version
*  We weren't doing any SVC 4 checking, because TXPM never sees an SVC 4
*  However, TMPX does, and the change mentioned in fix #285 was biting
*  us in TMPX.  That's fixed now.
*
*       Rev  287  07-JUL-92 07:30  MJF       MJF
*  Ensure that our check for C.CIPU is correct.  We were ignoring
*  the fact that bit 0 of that word is occasionally on.
*
*       Rev  286  06-JUL-92 14:45  MJF       MJF
*  Fix two problems with previous modification.  First, the check at
*  SYSGEN time was pretty silly.  I used a label (C_STKREG), yet forgot
*  that that code is moved if there is no IPU on the system.  So the
*  first change was to mod the way we do that check.
*
*  Second, H.IP06 does the STD R2,C.STKREG (as part of the M.STPUSH macro.
*  However, H.IPU does not, and the code that stores into C.STKERG assumes
*  that we're running in the cpu.  So now we ensure that we only do this
*  "fix" if we're in the cpu.
*
*       Rev  285  17-JUN-92 16:45  MJF       MJF
*  The entry into IP06 for SVCs 0, 1, 2, and 4 no longer inhibit
*  context switching, so the first instr is no longer M.SHUT.  Instead,
*  it's STD R2,C.STKREG!  So what happens is that IP06 stores R2/3,
*  then TXPM biases all regs, then IP06 picks up the old (unbiased)
*  R2/3 from C.STKREG!  That's fixed now.
*
*       Rev  284  17-JUN-92 15:09  MJF       MJF
*  Turn F-bit off in the PSD when we dispatch (PSD1).
*
*       Rev  283  24-MAR-92 10:16  GANN      GANN
*  Fixed SVC 2,x'59' so that if the address passed in is greater
*  than 24 bits after being biased, we remember the error and
*  tell the user about when we return. This could be a problem if
*  the user really does want to verify an address above (16 Mb -
*  the bias), but this memory is not available to the OS, so what
*  we do?
*
*       Rev  282  16-MAR-92 15:49  GANN      GANN
*  Added SVC 7,30.
*
*       Rev  281  17-FEB-92 10:01  GANN      GANN
*  Added a check to make sure that we only check the DIRSVC bit
*  in the CPU status word on a 32/2000 CPU.
*
*       Rev  280  14-FEB-92 11:27  GANN      GANN
*  Added various checks to make sure that DIRSVC mode is never on.
*
*       Rev  279  09-JAN-92 09:12  GANN      GANN
*  Corrected last fix.  Several SVC's go to the label I moved,
*  so I changed 2,23 to go to 220 and changed the others to use
*  22d.
*
*       Rev  278  03-JAN-92 08:39  GANN      GANN
*  Change biasing for SVC 2,X'23'.  It needed to bias the RCB
*  properly.
*
*       Rev  277  13-DEC-91 13:54  MJF       MJF
*  Don't bias TCPB for M.CWAT
*
*       Rev  276  18-NOV-91 09:11  MJF       MJF
*  Disallow the user from defining a handler that uses CDT.SIHA
*  but doesn't have a hat that points to the ICB.
*
*       Rev  275  07-NOV-91 08:30  MJF       MJF
*  Add a comment at FIRE;
*  take out two instructions that mod'ed R2--I took the
*  instruction out because after they loaded R2, other instructions
*  then loaded R2 again;
*  take out E.GATE ( a byte var that used one bit as a switch), and
*     put the switch into local switches.
*
*       Rev  274  21-OCT-91 16:10  MJF       MJF
*  The 1.x version still had a reference to SVC2.52, placed
*  there by the last mod.  This was made conditional.
*  I also made the CLU.TBL entries based on equates rather
*  than hard-coded (e.g., REMMTBLE-REMMTBL/4).
*
*       Rev  273  10-OCT-91 13:09  MJF       MJF
*  Allow M.CALLs
*
*       Rev  272  09-OCT-91 16:21  MJF       MJF
*  Handle M.CALL being SVC 6
*
*       Rev  271  09-OCT-91 13:13  MJF       MJF
*  Use modified M.TXPM and new M.TXINTL.
*
*       Rev  270  05-SEP-91 13:20  MJF       MJF
*  Fix the next to previous fix.  The problem was that I inadvertently
*  (of _course_ it was inadvertent!) duplicated an instruction.
*  The duplication was harmless.
*
*       Rev  269  27-AUG-91 14:11  MJF       MJF
*  E.5B Version.
*  Conditional code for last fix (1.x doesn't have some of
*  that code).
*
*       Rev  268  27-AUG-91 13:34  MJF       MJF
*  Fix instruction sequence problem with RSX.  RSX doesn't seem
*  to be able to reliably execute the following:
*     STW     R1,34,X2
*     LW      R1,30,X2
*     BL      *34,X2
*
*       Rev  267  26-AUG-91 16:14  MJF       MJF
*  Name some bit flags.
*
*       Rev  266  05-APR-91 10:31  GANN      GANN
*  Changed BIAS.CNP to only try to bias the partition start address
*  when called from M.INCLUDE biasing.  Also removed former references
*  to OS.35 and changed OS.MI references to use OS.35.
*
*       Rev  265  02-APR-91 15:31  GANN      GANN
*  Added code to bias new field in CNP for MPX3.5 U01.  New field
*  is used for M.INCLUDE to allow the user to specify the address
*  a partition should be included at.  the address needed to be
*  biased.  The new word is word 4 of the CNP which was previously
*  reserved. (The documentation still says that it is reserved, so
*  there is no equate for that word, so I just used "4W" to
*  reference it.)
*
*       Rev  264  12-FEB-91 17:23  MJF       MJF
*  Make runtime check for 32/2000 instead of check at SYSGEN time.
*
*       Rev  263  11-FEB-91 12:57  GANN      GANN
*  Change version to E.5.
*
*       Rev  262  07-DEC-90 16:52  MJF       MJF
*  3.5 baseline 11 updates
*
*       Rev  261  30-NOV-90 16:46  MJF       MJF
*  T.DBHAT was being incorrectly set because we made the assumption that
*  a DBHAT address below the TSA had to be TXPM's DBHAT.  This is
*  no longer true with moved TSAs.
*
*       Rev  260  13-NOV-90 16:25  MJF       MJF
*  Fix bug in Seahawk code.  We were setting bit 0 of MSD 0 back on.
*  SYSGEN under pre-3.5 releases doesn't like that.  Seahawk code now
*  loads the maps while remaining unmapped (only Seahawks do that).
*
*       Rev  259  24-OCT-90 13:04  MJF       MJF
*  Modified TITLEs to say TMPX for the TMPX version.
*  Also, added DO.BUI conditional variable around some
*  code for Yuma Proving Ground.
*
*       Rev  258  11-OCT-90 08:57  MJF       MJF
*  Missed a section while making the previous fix!
*
*       Rev  257  10-OCT-90 11:16  MJF       MJF
*  Fix SVC 6/7/E processing
*
*       Rev  256  27-SEP-90 07:32  MJF       MJF
*  Change version number to E.4C
*
*       Rev  255  20-SEP-90 10:13  MJF       MJF
*  Put in conditional code to check for incorrect dispatches
*  to the right-half of a BU * (branch unconditional, indirect).
*  Also ensured that any abort address is a full word.
*
*       Rev  254  20-JUL-90 08:48  MJF       MJF
*   Version control header added; split from SH.TXPMMS
*
*       Rev  253  19-JUL-90 08:48  MJF       MJF
*  Finish auto patching.  Still needs testing.
*
*       Rev  252  13-JUL-90 14:22  MJF       MJF
*  Seahawk modifications for 3.4U03a. Problem was caused by
*  Seahawk's lack of taking a TRSC to PSD2 correctly.  This version
*  checks for Seahawk, and if it finds it, it uses the actual MPL
*  rather than using its own in the patch area.
*
*       Rev  251  02-JUL-90 13:32  GANN      GANN
*  Delete def to FI.STRT. It was only required for 3.5 debugging and is
*  no longer needed.  Other versions of PTCH do not assemble with it in.
*
*       Rev  250  02-JUL-90 11:58  GANN      GANN
*  Added a mask to accelerator code to fix a MF01. Problem was that
*  a CEA instruction was commented out in rev 236 and so part of
*  the LPSD instruction was being used as part of the index, causing
*  a MF01.  I just masked the reg containing the lpsd instruction
*  before using it as an index.
*
*       Rev  249  18-JUN-90 19:12  MJF       MJF
*  Interim lock during new patch facility.  IPU patches
*  still need to be done.  Everything needs to be tested.
*
*       Rev  248  15-JUN-90 16:33  MJF       MJF
*  Interim unlock during patch facility changes.
*
*       Rev  247  08-JUN-90 14:41  MJF       MJF
*  Support for 3.5 U00A, plus fixed a bug intro'd when we added
*  1.x support.
*
*       Rev  246  18-MAY-90 12:08  GANN      GANN
*  Make H.SURE processing conditional for concept only (C.3227).
*  H.SURE cann only be present for mpx 3.4 U0n and higher. SVC 5
*  is reserved for H.SURE.
*
*       Rev  245  12-MAY-90 13:58  MJF       MJF
*  Integrate 1.x mods made in FtL first week of 5/90.
*  H.SURE mods still need to be made for 1.x.
*
*       Rev  244  11-MAY-90 22:14  MJF       MJF
*  3.5 baseline 10
*
*       Rev  243  20-MAR-90 13:57  BEVIER    BEVIER
*  TXPM.ACC WAS BEING SET IN TXPMFLGS, SHOUND HAVE BEEN RTC IN TXPMFLGS.
*  ADDED ONE.INIT FLAG FOR TXPMFLGS TO SHOW ONE-SHOT INIT COMPLETE.
*
*       Rev  242  20-MAR-90 10:16  BEVIER    BEVIER
*  Correct ipu gating bug. Move TXPMFLGS to byte 0 of C.UBIAS (C8) so
*  in.txpm flag can be cleared from dispatch code.  Set bit 0 (TXPMOS)
*  of TXPMFLGS to indicate TXPM on system.
*
*       Rev  241  14-MAR-90 08:40  BEVIER    BEVIER
*  Modifications for MPX 3.5 baseline 8.0.
*
*       Rev  240  31-JAN-90 12:11  BEVIER    BEVIER
*  Add final 34u03 mods
*
*       Rev  239  30-JAN-90 09:26  BEVIER    BEVIER
*  Add support for MPX 3.5 baseline 7.
*
*       Rev  238  30-JAN-90 08:26  BEVIER    BEVIER
*  Add support for MPX 1.5E.  Add support for movable tsa
*  in mpx 3.5 mapped in.
*
*       Rev  237  30-JAN-90 08:11  BEVIER    BEVIER
*  Add initial support for mapped-out mpx.  Add initial movable
*  TSA support in MPX 3.5 mapped-in mode.  Correct SIMSTAR support
*  in all revisions.
*
*       Rev  236  05-DEC-89 18:33  BEVIER    BEVIER
*  Do not allow csect to be shared for txpm tasks running in auto
*  mode.  Set psd word2 in accel to that in h.ipcl.
*
*       Rev  235  29-NOV-89 19:08  BEVIER    BEVIER
*  Correct interface patches in s.iocs17 to unbias fcb properly
*  before going to s.exec68 EA dispatch.
*
*       Rev  234  29-NOV-89 14:57  BEVIER    BEVIER
*  Correct patch for H.EXEC3.  Add biasing for T.TSAOR for MPX3.5.
*
*       Rev  233  21-NOV-89 15:59  BEVIER    BEVIER
*  Turn on tsa biasing when svc 2,7d called (M.GTSAD)
*
*       Rev  232  20-NOV-89 14:16  BEVIER    BEVIER
*  Add MPX 3.4u03 support and MPX 3.5 BL6 support.  Move S.TXPM.6 routin
*  to PTCH. Correct SVC 1,3 code.  Correct SVC 7,19 code. Add support fo
*  new SVC's 2,AF (M.OSWRIT), 2,7E (M.OSREAD), and 2,7D (M.GTSAD). Make
*  release E4B mods.
*
*       Rev  231  15-MAY-89 16:35  BEVIER    BEVIER
*  Inhibit dispatch to H.AID if H.AID not on system.
*  This was causing AID debugger to get MF01.
*
*       Rev  230  08-MAY-89 16:07  BEVIER    BEVIER
*  CORRECT TYPE CONTROL BLOCK BIASING; HAD INVALID BRANCH
*
*       Rev  229  27-MAR-89 08:08  BEVIER    BEVIER
*  Correct S.TRV.54 to use C.CIPU instead of C.CURR during test for
*  map overrun in H.IPU.
*
*       Rev  228  02-FEB-89 08:50  BEVIER    BEVIER
*  Add support for MPX 3.4 U02.
*
*       Rev  227  13-JAN-89 16:38  BEVIER    BEVIER
*  ADD SUPPORT FOR SVC 2,X'7C' (M.GDD) NEW IN MPX 3.4
*
*       Rev  226  10-JAN-89 07:50  BEVIER    BEVIER
*  CORRECT REG DURING DEBUG DISPATCH.
*  ADD SUPPORT FOR SVC 2,X'AE' M.TSMPC
*  DELETE DUKE POWER CODE THAT'S NOT USED ANYMORE.
*
*       Rev  225  06-JAN-89 06:29  BEVIER    BEVIER
*  CORRECT SVC BIASING FOR SVC 2 AFTER SVC 1.
*  SVC 1 FLAGS WERE BEING LEFT ON CAUSING INCORRECT BIASING.
*
*       Rev  224  09-NOV-88 08:31  GANN      GANN
*   Version control header added
*
*
*    REMAP PROCESSOR  VERSION NUMBER *** E4B ***                *238*
*
*    SUPPORTS: MPX1.5E,MPX2.1A, MPX2.2, MPX2.3, MPX2.4, MPX3.2A, MPX3.2B
*              MPX3.2C, MPX3.2C.UCS, MPX3.2C.U03, MPX3.3, MPX3.3.U02
*              MPX3.4, MPX3.4U01, MPX3.402, MPX3.4U03, MPX3.5
*
************************************************************************
*        RESTRICTED RIGHTS LEGEND                                      *
*                                                                      *
*        USE, DUPLICATION, OR DISCLOSURE IS SUBJECT TO THE             *
*        RESTRICTIONS STATED IN XXXXXXXX LICENSE AGREEMENT             *
*        (FORM NO. 1218) OR, FOR GOVERNMENT CUSTOMERS,                 *
************************************************************************
         LIST      OFF
*
* 93.  MODIFIED BY JCB (10/16/85) TO:
*      A.  OPTIMIZE MORE CODING
*      B.  ADD FIRST IPU SUPPORT
*
* 94.  MODIFIED BY SEM (01/07/85) TO:
*      A.  ABORT WITH TX12 IF FCB IS BUSY
*      B.  MAKE CLASS D THE DEFAULT SETTING FOR RTOM INTERRUPTS
*      C.  FIX BUG IN ECP WHERE PTR NOT BEING RESTORED
*      D.  RESET TSK.ECP FOR WAIT I/O
*
* 95.  MODIFIED BY JCB (01/09/86) TO:
*      A.  UPDATE CODING FOR OTHER THAN 32B SYSTEMS
*      B.  DELETE DEBUG CODE
*
* 96.  MODIFIED BY JCB (01/20/86) TO:
*      A.  ADD BIT TO ALLOW TXPM TASK EXECUTION ONLY (MPX TASKS THAT
*               ARE TOO BIG WILL ABORT WITH RM65
*      B.  ADD BIT TO DISABLE TXPM EXECUTION COMPLETELY
*      C.  DO AUTOMATIC BIASING OF ABSOLUTE TASKS FOR TXPM
*      D.  ADD BIT TO TEST FOR MPX ONLY TASKS AND NOT AUTOMATICALLY
*               FORCE TO TXPM. (USER ABORTS WITH RM64 OR RM65)
*      E.  DO NOT BIAS PHYSICAL CHANNEL ADDRESS IN FCB FOR NON F-CLASS
*               DEVICES.
*
* 97.  MODIFIED BY JCB (02/03/86) TO:
*      A.  ADD SUPPORT FOR H.UBIAS MODULE
*      B.  CHANGES ARE DENOTED BY *97*
*
* 98.  MODIFIED BY JCB (02/06/86) TO:
*      A.  ADD SUPPORT FOR TXPM.LVP MACRO
*      B.  CHANGES ARE DENOTED BY *98*
*
* 99.  MODIFIED BY JCB (02/10/86) TO:
*      A.  ADD CODE CORRECTIONS FOR 7X MACHINES FROM TESTING
*      B.  CHANGES ARE DENOTED BY *99*
*
*100.  MODIFIED BY JCB (02/13/86) TO:
*      A.  ADD CODE TO TEST FOR TSA ORIGIN LESS THAN DISPATCH ADDRESS
*      B.  CHANGES ARE DENOTED BY *100*
*
*101.  MODIFIED BY JCB (02/17/86) TO:
*      A.  CORRECT INTERRUPT CODE WHEN NO CURRENT TASK.
*      B.  CORRECT PATCHES TO S.REMM12 (S.TRV.22,S.TRV.23)
*      C.  CHANGES ARE DENOTED BY *101*
*
*102.  MODIFIED BY JCB (02/18/86) TO:                          *102*
*      A.  CORRECT INITIALIZATION OF SWAPPERS DQE CONTEXT PTR  *102*
*      B.  CORRECT C.DOT'S USED FOR CONCEPT (WAS HARD CODED ADR *102*
*      C.  CHANGES ARE DENOTED BY *102*                        *102*
*
*103.  MODIFIED BY JCB (02/18/86) TO:                          *103*
*      A.  CORRECT HANDLING OF PV01 ERRORS FOR TSA REFERENCES  *103*
*      B.  CHANGES ARE DENOTED BY *103*                        *103*
*
*104.  MODIFIED BY JCB (02/19/86) TO:                          *104*
*      A.  CORRECT HANDLING RELATIVE MAP NUMER (TRV.27 & 28)   *104*
*      B.  CORRECT IPU PATCHES AND ADD DEBUG CODE              *104*
*      C.  CHANGES ARE DENOTED BY *104*                        *104*
*
*105.  MODIFIED BY JCB (02/19/86) TO:                          *105*
*      A.  CORRECT MACROS FOR IPU CONTEXT INITIALIZATION       *105*
*      B.  CORRECT PSD2'S TO INSURE BLOCKED BIT NOT SET        *105*
*      C.  CHANGES ARE DENOTED BY *105*                        *105*
*
*106.  MODIFIED BY JCB (02/20/86) TO:                          *106*
*      A.  CORRECT MORE PLACES WHERE PSD2 HAS BLOCKED BIT SET  *106*
*      B.  ADD PATCH TO EXECUTE CHAN PGM LOGIC FOR CSC         *106*
*      C.  CHANGES ARE DENOTED BY *106*                        *106*
*
*107.  MODIFIED BY JCB (02/20/86) TO:                          *107*
*      A.  CORRECT MORE PLACES WHERE PSD2 HAS BLOCKED BIT SET  *107*
*      B.  CHANGE T.IPU MACRO TO READ SPAD DIRECTLY FOR 7X     *107*
*      C.  CHANGES ARE DENOTED BY *107*                        *107*
*
*108.  MODIFIED BY JCB (02/25/86) TO:                          *108*
*      A.  CORRECT CODING ERROR IN IPU DISPATCH LOGIC          *108*
*      B.  DELETE H.REXS PATCH NOT REQUIRED FOR 2.1A           *108*
*      C.  CORRECT TXPM.LVP ENTRY TO TEST FOR TXPM DISPATCH    *108*
*      D.  DO DYNAMIC CALCULATION OF OVERRUN MAPS IN MAP.MPX   *108*
*      E.  CORRECT EP8 INITIALIZATION OF INT AND CHAN VALUES   *108*
*      F.  CHANGES ARE DENOTED BY *108*                        *108*
*
*109.  MODIFIED BY JCB (02/28/86) TO:                          *109*
*      A.  UPDATE PATCHES FOR 2.2 SYSTEMS FOUND FOR 2.1A       *109*
*      B.  DELETE UNCONDITIONAL UPDATE OF PR.PAGED ON E2 SYSTEM*109*
*      C.  CHANGES ARE DENOTED BY *109*                        *109*
*
*110.  MODIFIED BY JCB (03/05/86) TO:                          *110*
*      A.  UPDATE SVC BIAS ROUTINES FOR ADIO SUPPORT           *110*
*      B.  CHANGES ARE DENOTED BY *110*                        *110*
*
*111.  MODIFIED BY JCB (03/05/86) TO:                          *111*
*      A.  UPDATE PATCHES FOR 3.2C AND 2.3 SYSTEMS             *111*
*      B.  CHANGES ARE DENOTED BY *111*                        *111*
*
*112.  MODIFIED BY JCB (03/11/86) TO:                          *112*
*      A.  FORCE TXPM TASKS WITH SHARED CSECT TO RUN MULTICOPY *112*
*      B.  CORRECT TEST FOR TSA REFERENCES DURING TASK LOADING *112*
*      C.  CHANGES ARE DENOTED BY *112*                        *112*
*
*113.  MODIFIED BY JCB (03/18/86) TO:                          *113*
*      A.  ADD PATCH UPDATES FOR DUKE 3.2C RELEASE             *113*
*      B.  CHANGES ARE DENOTED BY *113*                        *113*
*
*114.  MODIFIED BY JCB (03/21/86) TO:   (REL VER OF REV E2.00) *114*
*      A.  ADD PATCH UPDATES FOR H.BKDM PATCHES                *114*
*      B.  CHANGES ARE DENOTED BY *114*                        *114*
*
*115.  MODIFIED BY JCB (04/14/86) TO:     (REV E2.01)          *115*
*      A.  ADD PATCH UPDATES FOR B.C.A.C. FOR H.IPU            *115*
*      B.  CORRECT BIAS.PSB MACRO TO BE OPTIONAL, FIX M.PTASK  *115*
*      C.  CHANGE MAX.INT TO 48 FROM 36. CAUSED MF01 IN SYSGEN *115*
*      D.  CHANGES ARE DENOTED BY *115*                        *115*
*
*116.  MODIFIED BY JCB (04/17/86) TO:     (REV E2.02)          *116*
*      A.  CORRECT INITIALIZATION IF SIPU ICB TO FIX IPU HT01  *116*
*      B.  CHANGES ARE DENOTED BY *116*                        *116*
*
*117.  MODIFIED BY JCB (04/19/86) TO:       (REV E2.03)        *117*
*      A.  CORRECT SVC'S THAT CALL S.VOMM23 TO NOT RUN IN IPU  *117*
*      B.  CHANGES ARE DENOTED BY *117*                        *117*
*
*118.  MODIFIED BY JCB (04/24/86) TO:       (REV E2.04)        *118*
*      A.  ALWAYS CALCULATE DQE ADDRESS FROM PSD PROVIDED      *118*
*      B.  CHANGES ARE DENOTED BY *118*                        *118*
*
*119.  MODIFIED BY JCB (04/28/86) TO:       (REV E2.05)        *119*
*      A.  CORRECT SVC 2,41 (M.XCLUDE) TO NOT BIAS FOR ART INDEX*119*
*      B.  CHANGES ARE DENOTED BY *119*                        *119*
*
*120.  MODIFIED BY JCB (04/29/86) TO:      (REV E2.06)         *120*
*      A.  CORRECT SPAD SEARCH DURING EP8 FOR 87'S             *120*
*      B.  CORRECT XPEVENT RECORDING FOR INTERRUPTS            *120*
*      C.  CHANGES ARE DENOTED BY *120*                        *120*
*
*121.  MODIFIED BY JCB (04/29/86) TO:    (REV E2.07)           *121*
*      A.  CHANGE ADR.MASK TO BE 24 BITS FOR 67 & 97 CPU'S     *121*
*      B.  CHANGES ARE DENOTED BY *121*                        *121*
*
*122.  MODIFIED BY JCB (04/30/86) TO:    (REV E2.08)           *122*
*      A.  TEST FOR TRAPPING PSD UNMAPPED AND DON'T BIAS IF YES*122*
*      B.  CHANGES ARE DENOTED BY *122*                        *122*
*
*123.  MODIFIED BY JCB (05/06/86) TO:    (REV E2.09) (E2B)     *123*
*      A.  CORRECT SVC 2,48 WHEN O/S DOES ERROR RETURN         *123*
*      B.  MODIFY BIAS.R MACRO TO TEST FOR ADDRESS IN O/S      *123*
*      C.  CHANGES ARE DENOTED BY *123*                        *123*
*
*124.  MODIFIED BY JCB (05/13/86) TO:    (REV E2.10) (E2B)     *124*
*      A.  CORRECT LOGICAL CHANNEL PROGRAM BIASING FOR         *124*
*          HSD'S TO HANDLE TIC'S IN THE LOGICAL IOCL           *124*
*      B.  CHANGES ARE DENOTED BY *124*                        *124*
*
*125.  MODIFIED BY JCB (05/30/86) TO:    (REV E2.11) (E2B)     *125*
*      A.  ADD DISPATCH LOGIC TO IP06 FOR SVC 3,1 (M.OPEN)     *125*
*          AND SVC 3,0 (M.SHUT) TO ALLOW TXPM TASKS TO CALL    *125*
*      B.  CHANGES ARE DENOTED BY *125*                        *125*
*
*126.  MODIFIED BY JCB (06/02/86) TO:    (REV E2.12) (E2B)     *126*
*      A.  CORRECT M.MOD SVC (2,2A & 2,31) TO ACCEPT LFC IN R1 *126*
*      B.  CHANGES ARE DENOTED BY *126*                        *126*
*
*127.  MODIFIED BY JCB (06/05/86) TO:    (REV E2.13) (E2B)     *127*
*      A.  CORRECT M.DASN SVC (2,53) TO NOT BIAS FCB.          *127*
*      B.  CHANGES ARE DENOTED BY *127*                        *127*
*
*128.  MODIFIED BY JCB (06/05/86) TO:    (REV E2.14) (E2B)     *128*
*      A.  SET DQE.PSSF IN DQE IF NOT VALID                    *128*
*      B.  CHANGES ARE DENOTED BY *128*                        *128*
*                                                              *128*
*129.  MODIFIED BY JCB (06/19/86) TO:    (REV E2.15) (E2B)     *129*
*      A.  CORRECT IPU PATCHES FOUND IN ERROR                  *129*
*      B.  CHANGES ARE DENOTED BY *129*                        *129*
*                                                              *129*
*130.  MODIFIED BY JCB (06/30/86) TO:    (REV E2.16) (E2B)     *130*
*      A.  CORRECT INTERRUPT INITIALIZATION CODE FOR LAST INT  *130*
*      B.  CHANGES ARE DENOTED BY *130*                        *130*
*                                                              *130*
*131.  MODIFIED BY JCB (07/07/86) TO:    (REV E2.17) (E2B)     *131*
*      A.  CORRECT IPU CODE TO RESET TRAP VECTOR IF A SIPU IS  *131*
*          RECEIVED DURING PROCESSING OF TSA REFERENCE UI.     *131*
*      B.  CHANGES ARE DENOTED BY *131*                        *131*
*                                                              *131*
*132.  MODIFIED BY JCB (07/31/86) TO:    (REV E2.18) (E2B)     *132*
*      A.  CORRECT CONDITIONAL CODE FOR 3.2C AND RELOAD USERS  *132*
*          REGISTERS FROM T.CONTEXT ON ABORT RECEIVER DISPATCH *132*
*      B.  CHANGES ARE DENOTED BY *132*                        *132*
*                                                              *132*
*133.  MODIFIED BY JCB (08/13/86) TO:    (REV E2.19) (E2B)     *133*
*      A.  CORRECT INITIALIZATION OF SVC 9 TRAP CONTEXT        *133*
*          AREA TO CORRECT INSTRUCTION SEQUENCE                *133*
*      B.  CHANGES ARE DENOTED BY *133*                        *133*
*                                                              *133*
*134.  MODIFIED BY JCB (08/15/86) TO:    (REV E2.20) (E2B)     *134*
*      A.  TEST FOR ENTRY INTO TXPM FROM AN INTERRUPT LEVEL    *134*
*          AND SKIP SVC REBIASING IF WE ARE (C.GINT .NE. 0)    *134*
*      B.  CHANGES ARE DENOTED BY *134*                        *134*
*                                                              *134*
*135.  MODIFIED BY JCB (08/25/86) TO:    (REV E2.21) (E2B)     *135*
*      A.  ADD NEW PATCHES FOR 3.2C UCS VERSION                *135*
*      B.  CHANGES ARE DENOTED BY *135*                        *135*
*
*136.  MODIFIED BY JCB (08/28/86) TO:    (REV E2.22) (E2B)     *136*
*      A.  ADD NEW SPECIAL INTERRUPT ENTRY FOR FAST INTERRUPTS *136*
*      B.  CHANGES ARE DENOTED BY *136*                        *136*
*
*137.  MODIFIED BY JCB (09/01/86) TO:    (REV E2.23) (E2B)     *137*
*      A.  ADD SPECIAL CASE CODE FOR SIPU TO RETURN IF IN TXPM *137*
*      B.  CHANGES ARE DENOTED BY *137*                        *137*
*
*138.  MODIFIED BY JCB (09/09/86) TO:    (REV E2.24) (E2B)     *138*
*      A.  CORRECT SPECIAL INTERRUPT CODING                    *138*
*      B.  CHANGES ARE DENOTED BY *138*                        *138*
*
*139.  MODIFIED BY JCB (09/10/86) TO:    (REV E2.25) (E2B)     *139*
*      A.  CORRECT SPECIAL INTERRUPT CODING (MORE)             *139*
*      B.  CHANGES ARE DENOTED BY *139*                        *139*
*
*140.  MODIFIED BY JCB (09/11/86) TO:    (REV E2.26) (E2B)     *140*
*      A.  MAKE MAP.TXPM & MAP.MPX NOT MODIFY MPL CNTS         *140*
*      B.  CHANGES ARE DENOTED BY *140*                        *140*
*
*141.  MODIFIED BY JCB (09/18/86) TO:    (REV E2.27) (E2B)     *141*
*      A.  USE BIT 4 (FCB.ECP) OF FCB.SPST TO IND ECP IN EFFECT*141*
*      B.  CHANGES ARE DENOTED BY *141*                        *141*
*
*142.  MODIFIED BY JCB (09/19/86) TO:    (REV E2.28) (E2B)     *142*
*      A.  CORRECT AID AND DEBUG SUPPORT FOR INTERRUPTS        *142*
*      B.  CHANGES ARE DENOTED BY *142*                        *142*
*
*143.  MODIFIED BY JCB (09/22/86) TO:    (REV E2.29) (E2B)     *143*
*      A.  CORRECT M.GD BIASING OF R4, (SVC 1,X'69')           *143*
*      B.  CHANGES ARE DENOTED BY *143*                        *143*
*
*144.  MODIFIED BY JCB (09/24/86) TO:    (REV E2.30) (E2B)     *144*
*      A.  CORRECT SVC'S 1,60;1,6B;1,6E AND MEMORY ALLOC SVC'S *144*
*      B.  CHANGES ARE DENOTED BY *144*                        *144*
*
*145.  MODIFIED BY JCB (09/25/86) TO:    (REV E2.31) (E2B)     *145*
*      A.  ADJUST CSECT ORIGIN BY 8KW FOR OVERLAP DSECT TEST   *145*
*      B.  CHANGES ARE DENOTED BY *145*                        *145*
*
*146.  MODIFIED BY JCB (09/25/86) TO:    (REV E2.32) (E2B)     *146*
*      A.  ADD SUPPORT FOR MPXEVENT                            *146*
*      B.  CHANGES ARE DENOTED BY *146*                        *146*
*
*147.  MODIFIED BY JCB (11/20/86) TO:    (REV E2.33) (E2B)     *147*
*      A.  CORRECT SETTING OF C.TXPM FOR AID                   *147*
*      B.  CHANGES ARE DENOTED BY *147*                        *147*
*
*148.  MODIFIED BY JCB (11/21/86) TO:    (REV E2.34) (E2B)     *148*
*      A.  DELETE BEI FROM IPU CODE PATH                       *148*
*      B.  CHANGES ARE DENOTED BY *148*                        *148*
*
*149.  MODIFIED BY JCB (01/05/87) TO:    (REV E2.35) (E2B)     *149*
*      A.  ADD CODE TO UPDATE C.TXPM IN FAST INTR PATH         *149*
*      B.  CHANGES ARE DENOTED BY *149*                        *149*
*
*150.  MODIFIED BY JCB (01/05/87) TO:    (REV E2.36) (E2B)     *150*
*      A.  ADD SUPPORT FOR MPX RELEASE 3.3                     *150*
*      B.  CHANGES ARE DENOTED BY *150*                        *150*
*
*151.  MODIFIED BY JCB (01/06/87) TO:    (REV E2.37) (E2B)     *151*
*      A.  CHANGE UCS TO U02. ADD U03 INITIAL SUPPORT          *151*
*      B.  CHANGES ARE DENOTED BY *151*                        *151*
*
*152.  MODIFIED BY JCB (01/06/87) TO:    (REV E2.38) (E2B)     *152*
*      A.  CHANGE H.IP06 INIT CODE TO SEARCH (PACE SUPPORT)    *152*
*      B.  CHANGES ARE DENOTED BY *152*                        *152*
*
*153.  MODIFIED BY JCB (01/07/87) TO:    (REV E2.39) (E2B)     *153*
*      A.  REPLACE CALLS TO S.VOMM23 WITH LOCAL SUB. ADD INIT  *153*
*          SUPPORT FOR IPU EXECUTION OF SVC'S.  DELETE REV 117 *153*
*      B.  CHANGES ARE DENOTED BY *153*                        *153*
*
*154.  MODIFIED BY JCB (01/08/87) TO:    (REV E2.40) (E2B)     *154*
*      A.  ADD PATCH CHANGES TO H.IPU TO ALLOW SVC EXECUTION   *154*
*      B.  CHANGES ARE DENOTED BY *154*                        *154*
*
*155.  MODIFIED BY JCB (01/09/87) TO:    (REV E2.41) (E2B)     *155*
*      A.  BACK PUT REV 145. DO NOT PAD TASK SIZE TEST BY 8K.  *155*
*      B.  CHANGES ARE DENOTED BY *155*                        *155*
*
*156.  MODIFIED BY JCB (01/14/87) TO:    (REV E2.42) (E2B)     *156*
*      A.  MASK FCB ADDRESS ON NO WAIT END ACTION.             *156*
*      B.  CHANGES ARE DENOTED BY *156*                        *156*
*
*157.  MODIFIED BY JCB (01/19/87) TO:    (REV E2.43) (E2B)     *157*
*      A.  ADD CAPABILITY TO TURN OFF ARITHMATIC EXCEPTION     *157*
*      B.  CHANGES ARE DENOTED BY *157*                        *157*
*
*158.  MODIFIED BY JCB (01/20/87) TO:    (REV E2.44) (E2B)     *158*
*      A.  ADD CONDITIONAL CODE TO GENERATE SH.PTCH & SH.TXPM  *158*
*      B.  CHANGES ARE DENOTED BY *158*                        *158*
*
*159.  MODIFIED BY JCB (02/12/87) TO:    (REV E2.45) (E2B)     *159*
*      A.  CORRECT BIASING FOR M.CMD (SVC 2,61)                *159*
*      B.  RESTORE UCS VERSION AND SUPPORT U03. U02 IS 3.2C    *159*
*      C.  CHANGES ARE DENOTED BY *159*                        *159*
*
*160.  MODIFIED BY JCB (03/02/87) TO:    (REV E2.46) (E2B)     *160*
*      A.  ADD MPX REV 3.3 SUPPORT                             *160*
*      B.  CHANGES ARE DENOTED BY *160*                        *160*
*
*161.  MODIFIED BY JCB (03/04/87) TO:    (REV E2.47) (E2C)     *161*
*      A.  ADD SUPPORT FOR SVC 2,7A (M.GETDEF)                 *161*
*      B.  CHANGES ARE DENOTED BY *161*                        *161*
*
*162.  MODIFIED BY JCB (03/05/87) TO:    (REV E2.48) (E2C)     *162*
*      A.  USE IP0FS EXTERNAL INSTEAD OF IP0F.REG              *162*
*      B.  CHANGES ARE DENOTED BY *162*                        *162*
*
*163.  MODIFIED BY JCB (03/05/87) TO:    (REV E2.49) (E2C)     *163*
*      A.  CORRECT SWAPR PATCHES TO BE INSTALLED AT INIT TIME  *163*
*      B.  CHANGES ARE DENOTED BY *163*                        *163*
*
*164.  MODIFIED BY JCB (03/05/87) TO:    (REV E2.50) (E2C)     *164*
*      A.  ADD CONDITIONAL CODE FOR AR.SIZE. 3.3 IS 8W NOW.    *164*
*      B.  CHANGES ARE DENOTED BY *164*                        *164*
*
*165.  MODIFIED BY JCB (03/24/87) TO:    (REV E2.51) (E2C)     *165*
*      A.  ADD MPX 3.3 PATCH FOR MIDL SIZE TO BE 2048 MAPS     *165*
*      B.  CHANGES ARE DENOTED BY *165*                        *165*
*
*166.  MODIFIED BY JCB (04/06/87) TO:    (REV E2.52) (E2C)     *166*
*      A.  CORRECT INITIALIZATION OF 32/7X INT CONTEXT AREA    *166*
*      B.  CHANGES ARE DENOTED BY *166*                        *166*
*
*167.  MODIFIED BY JCB (04/07/87) TO:    (REV E2.53) (E2C)     *167*
*      A.  DELETE REFERENCES TO IP0F.EN, USE IP0F.ICB INSTEAD. *167*
*      B.  CHANGES ARE DENOTED BY *167*                        *167*
*
*168.  MODIFIED BY JCB (04/09/87) TO:    (REV E2.54) (E2C)     *168*
*      A.  ADD ORBIS SUPPORT FOR MPX 3.3                       *168*
*      B.  CHANGES ARE DENOTED BY *168*                        *168*
*
*169.  MODIFIED BY JCB (04/24/87) TO:    (REV E2.55) (E2C)     *169*
*      A.  ADD SUPPORT FOR SPURIOUS INT ENTRY HANDLING         *169*
*      B.  CHANGES ARE DENOTED BY *169*                        *169*
*
*170.  MODIFIED BY JCB (04/28/87) TO:    (REV E2.56) (E2C)     *170*
*      A.  CORRECT CLOCK HANDLING WHEN IN TMPX.                *170*
*      B.  CHANGES ARE DENOTED BY *170*                        *170*
*
*171.  MODIFIED BY JCB (05/11/87) TO:    (REV E2.57) (E2C)     *171*
*      A.  FIX FOR CHANGE 56 ABOVE. REG BEING DESTROYED        *171*
*      B.  CHANGES ARE DENOTED BY *171*                        *171*
*
*172.  MODIFIED BY JCB (05/12/87) TO:    (REV E2.58) (E2C)     *172*
*      A.  ADD RECORDING FOR FAST INT PATCHS & AID             *172*
*      B.  CHANGES ARE DENOTED BY *172*                        *172*
*
*173.  MODIFIED BY JCB (05/14/87) TO:    (REV E2.59) (E2C)     *173*
*      A.  CHANGE CONTEXT AREA TO BE 16W TO SAVE DQE ADDR.     *173*
*      B.  CHANGES ARE DENOTED BY *173*                        *173*
*
*174.  MODIFIED BY JCB (05/18/87) TO:    (REV E2.60) (E2C)     *174*
*      A.  CORRECT SPECIAL INTERRUPT PATH FOR MPX TASKS        *174*
*      B.  FIX SPECIAL CASE CODE (SVC 1,3) FOR MPX TASKS       *174*
*      C.  CHANGES ARE DENOTED BY *174*                        *174*
*
*175.  MODIFIED BY JCB (05/19/87) TO:    (REV E2.61) (E2C)     *175*
*      A.  CORRECT ABSOLUTE LOAD MODULES FOR MPX 3.3           *175*
*      B.  CHANGES ARE DENOTED BY *175*                        *175*
*
*176.  MODIFIED BY JCB (05/19/87) TO:    (REV E2.62) (E2C)     *176*
*      A.  ADD MORE CORRECTIOS TO FAST INTERRUPT LOGIC         *176*
*      B.  CHANGES ARE DENOTED BY *176*                        *176*
*
*177.  MODIFIED BY JCB (05/29/87) TO:    (REV E2.63) (E2C)     *177*
*      A.  ADD LPOOL DIRECTIVE AFTER IPU CODE TO HAVE MASKS    *177*
*          WITH CODE, NOT AT END OF TXPM. CAUSED NM01 ERROR.   *177*
*      B.  CHANGES ARE DENOTED BY *177*                        *177*
*
*178.  MODIFIED BY JCB (06/04/87) TO:    (REV E2.64) (E2C)     *178*
*      A.  ADD DATE ROLLOVER PATCH IN H.IPCL FOR 3.2C. ALREADY *178*
*          IN OTHER MPX RELEASES.                              *178*
*      B.  CHANGES ARE DENOTED BY *178*                        *178*
*
*179.  MODIFIED BY JCB (06/15/87) TO:    (REV E2.65) (E2C)     *179*
*      A.  CHANGE INTERRUPT TABLE SIZE TO 64 FROM 48.          *179*
*      B.  CHANGES ARE DENOTED BY *179*                        *179*
*
*180.  MODIFIED BY JCB (06/15/87) TO:    (REV E2.66) (E2C)     *180*
*      A.  CORRECT M.TYPE SERVICE TO ALLOW ADDRESSES IN EXT MEM*180*
*      B.  CHANGES ARE DENOTED BY *180*                        *180*
*
*181.  MODIFIED BY JCB (06/15/87) TO:    (REV E2.67) (E2C)     *181*
*      A.  ADD SPECIAL CASING FOR ACC ICB FOR REV 55           *181*
*      B.  CHANGES ARE DENOTED BY *181*                        *181*
*
*182.  MODIFIED BY JCB (06/17/87) TO:    (REV E2.68) (E2C)     *182*
*      A.  CORRECT M.GADL SERVICE (SVC 1,65)                   *182*
*      B.  CHANGES ARE DENOTED BY *182*                        *182*
*
*183.  MODIFIED BY JCB (06/24/87) TO:    (REV E2.69) (E2C)     *183*
*      A.  FIX FAST INTERRUPT PATH AGAIN FOR AID SUPPORT       *183*
*      B.  CHANGES ARE DENOTED BY *183*                        *183*
*
*184.  MODIFIED BY JCB (06/25/87) TO:    (REV E2.70) (E2C)     *184*
*      A.  FIX FAST INT AGAIN AND MAP IN MPX IN SVC 9,99       *184*
*      B.  CHANGES ARE DENOTED BY *184*                        *184*
*
*185.  MODIFIED BY JCB (06/26/87) TO:    (REV E2.71) (E2C)     *185*
*      A.  CHANGE IPU SPECIAL CASE CODE FOR SIPU W/NO TASK     *185*
*      B.  CHANGES ARE DENOTED BY *185*                        *185*
*
*186.  MODIFIED BY JCB (07/01/87) TO:    (REV E2.72) (E2C)     *186*
*      A.  CHANGE IPU DISPATCH CODE TO NOP ZBM C.ICSIPU,C.BIT  *186*
*          WHEN DOING MAP.MPX CODE.                            *186*
*      B.  CHANGES ARE DENOTED BY *186*                        *186*
*
*187.  MODIFIED BY JCB (07/13/87) TO:    (REV E2.73) (E2C)     *187*
*      A.  CORRECT IPU SVC HANDLING CODE IN TXPM TO NOT XEQ    *187*
*          FIRST INSTRUCTION IF STF.  REGS WERE NOT BEING      *187*
*          BIASED CAUSING IO17, ETC. WHEN IN IPU. 32B & 2.3    *187*
*      B.  CHANGES ARE DENOTED BY *187*                        *187*
*
*188.  MODIFIED BY JCB (07/29/87) TO:    (REV E2.74) (E2C)     *188*
*      A.  CORRECT IPU SVC HANDLING CODE IN TXPM TO NOT XEQ    *188*
*          FIRST INSTRUCTION IF STF.  REGS WERE NOT BEING      *188*
*          BIASED CAUSING IO17, ETC. WHEN IN IPU. 32C          *188*
*          CORRECT LPSD RETURN FOR TMPX IN SIPU CODE.          *188*
*      B.  CHANGES ARE DENOTED BY *188*                        *188*
*
*189.  MODIFIED BY JCB (07/29/87) TO:    (REV E2.75) (E2C)     *189*
*      A.  CORRECT IPU SVC HANDLING CODE IN TXPM TO SET        *189*
*          THE TXPM FLAG FIRST BEFORE STORING THE REGS IN      *189*
*          SVC 1,2 AND 4.                                      *189*
*      B.  CHANGES ARE DENOTED BY *189*                        *189*
*
*190.  MODIFIED BY JCB (08/03/87) TO:    (REV E2.76) (E2C)     *190*
*      A.  ADD MPX REV 3.3 U02 SUPPORT.  DELETE CHECKS IN      *190*
*          S.TXPM.6 FOR BIASED/UNBIASED TSA.                   *190*
*      B.  ADD SUPPORT FOR SVC 2,7B (M.GADRL2).                *190*
*      C.  DELETE MPX 3.2C U02 SUPPORT.                        *190*
*      D.  CHANGES ARE DENOTED BY *190*                        *190*
*
*191.  MODIFIED BY JCB (08/19/87) TO:    (REV E2.77) (E2C)     *191*
*      A.  ADD MPX REV 3.3 U02 SUPPORT FOR ORBIS.              *191*
*      B.  CHANGES ARE DENOTED BY *191*                        *191*
*
*192.  MODIFIED BY JCB (08/19/87) TO:    (REV E2.78) (E2C)     *192*
*      A.  FIX IPU CODE FOR 2.X - 7X SYSTEMS, BR'ING TO ZERO.  *192*
*      B.  CHANGES ARE DENOTED BY *192*                        *192*
*
*193.  MODIFIED BY JCB (08/24/87) TO:    (REV E2.79) (E2C)     *193*
*      A.  FIX IPU INITIALIZATION CODE FOR 2.X - 7X SYSTEMS.   *193*
*          NEW IPU CODE EXECUTES 1ST INSTRUCTION.              *193*
*      B.  CHANGES ARE DENOTED BY *193*                        *193*
*
*194.  MODIFIED BY JCB (08/24/87) TO:    (REV E2.80) (E2C)     *194*
*      A.  CHECK FOR MAP OVERRUN IN S.EXEC20 AND ADJUSTFIX IPU *194*
*          COUNT IN MPL. CAUSED MAP FAULT LOOP. SWAPPERS FAULT *194*
*      B.  CHANGES ARE DENOTED BY *194*                        *194*
*
*195.  MODIFIED BY JCB (08/24/87) TO:    (REV E2.81) (E2C)     *195*
*      A.  ADD IPU INITIALIZATION CODE FOR FIRST SIPU FIELDED  *195*
*          BY IPU. CORRECT CONDITIONAL CODE FOR TMPX ON 7X.    *195*
*      B.  CHANGES ARE DENOTED BY *195*                        *195*
*
*196.  MODIFIED BY JCB (09/10/87) TO:    (REV E2.82) (E2C)     *196*
*      A.  CORRECT USAGE OF DQE 0 WHEN A ZERO CPIX IS DETECTED *196*
*      B.  CHANGES ARE DENOTED BY *196*                        *196*
*
*197.  MODIFIED BY JCB (09/10/87) TO:    (REV E2.83) (E2C)     *197*
*      A.  CORRECT BIASING OF IOCL ADDR FOR PHYSICAL CHAN PGM  *197*
*      B.  CHANGES ARE DENOTED BY *197*                        *197*
*
*198.  MODIFIED BY JCB (09/11/87) TO:    (REV E2.84) (E2C)     *198*
*      A.  ADD MPX REV 2.4 SUPPORT                             *198*
*      B.  CHANGES ARE DENOTED BY *198*                        *198*
*
*199.  MODIFIED BY JCB (10/01/87) TO:    (REV E2.85) (E2C)     *199*
*      A.  ADD MISSING PATCH FOR U03 S.EXEC5 DISPATCH          *199*
*      B.  CHANGES ARE DENOTED BY *199*                        *199*
*
*200.  MODIFIED BY JCB (10/05/87) TO:    (REV E2.86) (E2C)     *200*
*      A.  CORRECT M.GD SERVICE WHEN TRYING TO ALLOC 193RD MAP *200*
*      B.  CHANGES ARE DENOTED BY *200*                        *200*
*
*201.  MODIFIED BY JCB (10/05/87) TO:    (REV E2.87) (E2C)     *201*
*      A.  CORRECT M.GADRL2 BIASING ROUTINE                    *201*
*      B.  CHANGES ARE DENOTED BY *201*                        *201*
*
*202.  MODIFIED BY JCB (10/07/87) TO:    (REV E2.88) (E2C)     *202*
*      A.  CORRECT S.TRV.4E TO USE CHILDS DQE, NOT PARENTS     *202*
*      B.  CHANGES ARE DENOTED BY *202*                        *202*
*
*203.  MODIFIED BY JCB (10/13/87) TO:    (REV E3.00) (E3)      *203*
*      A.  CHANGE REVISION NUMBER TO E3.00 FOR RELEASE.        *203*
*      B.  CHANGES ARE DENOTED BY *203*                        *203*
*
*204.  MODIFIED BY JCB (12/07/87) TO:    (REV E3.01) (E3)      *204*
*      A.  CHANGE ADDRESS MASK TO 21 BITS AS DEFAULT.          *204*
*      B.  CHANGES ARE DENOTED BY *204*                        *204*
*
*205.  MODIFIED BY JCB (01/06/88) TO:    (REV E3.02) (E3)      *205*
*      A.  SUPPORT INT ON EOB DISPATCH IN S.EXEC21.            *205*
*      B.  RECALCULATE T.MIDL TO T.MEML OFFSET FOR ABS TASKS   *205*
*      B.  CHANGES ARE DENOTED BY *205*                        *205*
*
*206.  MODIFIED BY JCB (01/07/88) TO:    (REV E3.03) (E3)      *206*
*      A.  ALLOW LW  RX,C.TSAD TO BE IN 1ST 31W OF TASK.       *206*
*      B.  CHANGES ARE DENOTED BY *206*                        *206*
*
*207.  MODIFIED BY JCB (02/05/88) TO:    (REV E3.04) (E3)      *207*
*      A.  CORRECT FAST INTERRUPT PATH IN SVC 9,99 CODE.       *207*
*      B.  CHANGES ARE DENOTED BY *207*                        *207*
*
*208.  MODIFIED BY JCB (02/15/88) TO:    (REV E3.05) (E3)      *208*
*      A.  CORRECT S.TRV.26 WHERE R3 WAS NOT BEING RESTORED    *208*
*      B.  CORRECT S.TRV.28 WHERE BLT TRV.28.L, BLT TRV.27.L   *208*
*      C.  CORRECT S.TRV.16 WHERE R1 WAS NOT BEING RETURNED    *208*
*      D.  CHANGES ARE DENOTED BY *208*                        *208*
*
*209.  MODIFIED BY JCB (02/22/88) TO:    (REV E3.06) (E3)      *209*
*      A.  CORRECT IPU PROCESSING ON STARTUP. CAUSING MF01.    *209*
*      B.  CHANGES ARE DENOTED BY *209*                        *209*
*
*210.  MODIFIED BY JCB (03/21/88) TO:    (REV E3.07) (E3)      *210*
*      A.  ADD SUPPORT FOR MPX REV 3.4.                        *210*
*      B.  CHANGES ARE DENOTED BY *210*                        *210*
*
*211.  MODIFIED BY JCB (03/23/88) TO:    (REV E3.08) (E3)      *211*
*      A.  ADD CODE TO SET EXEC.RUN FLAG IF SIPU REC'D IN TXPM *211*
*      B.  CHANGES ARE DENOTED BY *211*                        *211*
*
*212.  MODIFIED BY JCB (03/28/88) TO:    (REV E3.09) (E3)      *212*
*      A.  DO NOT RESTORE T.LINBUF ADDR IF T.LINBUF ZERO.      *212*
*      B.  CHANGES ARE DENOTED BY *212*                        *212*
*
*213.  MODIFIED BY JCB (05/18/88) TO:    (REV E3.10) (E3)      *213*
*      A.  ON RETURN TO H.AID FROM AID, TXPM DISPATCH FLAG     *213*
*          WAS NOT BEING RESET.  IN TMPX ONLY!                 *213*
*      B.  CHANGES ARE DENOTED BY *213*                        *213*
*
*214.  MODIFIED BY JCB (05/31/88) TO:    (REV E3.11) (E3)      *214*
*      A.  REPLACE SHIFTS WITH MASK INSTRUCTIONS.  THIS IS TO  *214*
*          IMPROVE 32/67 PERFORMANCE.                          *214*
*      B.  CHANGES ARE DENOTED BY *214*                        *214*
*
*215.  MODIFIED BY JCB (06/28/88) TO:    (REV E3.12) (E3A)     *215*
*      A.  CORRECT SVC 5 INITIALIZATION CODE. H.SURE DID NOT   *215*
*          EXECUTE PROPERLY.                                   *215*
*      B.  CHANGES ARE DENOTED BY *215*                        *215*
         LIST       ON
*
*216.  MODIFIED BY JCB (08/10/88) TO:    (REV E3.13) (E3B)     *216*
*      A.  ADD H.MEMM,7 PATCH TO ALLOW INCLUSION OF PARTITION  *216*
*          BELOW C.TSAD ADDRESS IN TXPM TASK.                  *216*
*      B.  CHANGES ARE DENOTED BY *216*                        *216*
*
*217.  MODIFIED BY MJF (8/31/88) TO:     (REV E3.14) (E3B)     *217*
*      A.  SUPPORT 3.4U01                                      *217*
*      B.  CHANGES ARE DENOTED BY *217*                        *217*
*
*218.  MODIFIED BY JCB (9/16/88) TO:     (REV E3.15) (E3B)     *218*
*      A.  CORRECT H.ICP DISPATCH CODE WHEN H.SURE NOT GEN'D.  *218*
*      B.  CHANGES ARE DENOTED BY *218*                        *218*
*
*219.  MODIFIED BY JCB (9/16/88) TO:     (REV E3.16) (E3B)     *219*
*      A.  ADD SUPPORT FOR QUAD SYNC HANDLER, X.25, ETHERNET,  *219*
*          TEL-NET, DOD, ETC. COMM STUFF. SVC 7'S, 6'S, E'S.   *219*
*      B.  CHANGES ARE DENOTED BY *219*                        *219*
*
*220.  MODIFIED BY JCB (10/06/88) TO:    (REV E3.17) (E3B)     *220*
*      A.  ADDED TEST FOR BASE MODE TASK IN S.TXPM.8.          *220*
*          NEW COMMON COMPILER WAS LOOKING LIKE ABS LOAD MOD   *220*
*      B.  CHANGES ARE DENOTED BY *220*                        *220*
*
*221.  MODIFIED BY JCB (10/14/88) TO:    (REV E3.18) (E3B)     *221*
*      A.  ADDED OPTIONAL CODE TO SET MINIMUM TSA BASE IN      *221*
*          SUBROUTINE S.TXPM.8 IN SH.PTCH.                     *221*
*      B.  CHANGES ARE DENOTED BY *221*                        *221*
*
*222.  MODIFIED BY JCB (10/25/88) TO:    (REV E3.19) (E3B)     *222*
*      A.  DELETE BIASING FOR SVC 7,X'18' FROM TXPM.  NOW IN   *222*
*          SN.NOT IN DOD SOFTWARE.                             *222*
*      B.  CHANGES ARE DENOTED BY *222*                        *222*
*
*223.  MODIFIED BY JCB (10/31/88) TO:    (REV E3.20) (E3B)     *223*
*      A.  CORRECT DETECTION OF ON.QSXIO HANDLER LOGIC.        *223*
*          WAS CAUSING MF01 FOR NON I/O SVC'S WITH FCB'S.      *223*
*      B.  CHANGES ARE DENOTED BY *223*                        *223*
*
*224.  MODIFIED BY GC (11/09/88) TO:     (REV E3.224) (E3B)    *224*
*      A.  ADD VERSION CONTROL.                                *224*
*      B.  CHANGES ARE DENOTED BY *224*                        *224*
*
*225.  MODIFIED BY JCB (01/06/89) TO:    (REV E3.225) (E3B)    *225*
*      A.  CORRECT SVC BIASING WHEN SVC 2 IS EXECUTED AFTER    *225*
*          DOING SVC 1,X'54' (M.SUSP). THE SVC 2 WAS BEING     *225*
*          EXECUTED AS AN SVC 1.  SVC TYPE FLAGS WERE NOT      *225*
*          BEING RESET.                                        *225*
*      B.  CHANGES ARE DENOTED BY *225*                        *225*
*
*226.  MODIFIED BY JCB (01/10/89) TO:    (REV E3.226) (E3B)    *226*
*      A.  CORRECT REGISTER VALUE DURING DEBUGGER DISPATCH.    *226*
*      B.  ADD SUPPORT FOR SVC 2,X'AE' (M.TSMPC) NEW IN 3.4.   *226*
*      C.  CHANGES ARE DENOTED BY *226*                        *226*
*
*227.  MODIFIED BY JCB (01/13/89) TO:    (REV E3.227) (E3B)    *227*
*      A.  ADD SUPPORT FOR SVC 2,X'7C' (M.GDD) NEW IN 3.4.     *227*
*      B.  CHANGES ARE DENOTED BY *227*                        *227*
*
*228.  MODIFIED BY JCB (01/31/89) TO:    (REV E3.228) (E3B)    *228*
*      A.  ADD SUPPORT FOR MPX 3.4 U02 RELEASE.                *228*
*      B.  CHANGES ARE DENOTED BY *228*                        *228*
*
*229.  MODIFIED BY JCB (03/27/89) TO:    (REV E3.229) (E3B)    *229*
*      A.  CORRECT MAP OVERRUN TEST FOR IPU TO USE C.CIPU      *229*
*      B.  CHANGES ARE DENOTED BY *229*                        *229*
*
*       Rev  230  08-MAY-89 16:07  BEVIER    BEVIER
*  CORRECT TYPE CONTROL BLOCK BIASING; HAD INVALID BRANCH
*
*230.  MODIFIED BY JCB (05/08/89) TO:    (REV E4.230) (E4)     *230*
*      A.  CORRECT TYPE CONTROL BLOCK BIASING ROUTINE. HAD     *230*
*          INVALID BRANCH.                                     *230*
*      B.  CHANGES ARE DENOTED BY *230*                        *230*
*
*231.  MODIFIED BY JCB (05/15/89) TO:    (REV E4.231) (E4)     *231*
*      A.  ADDED TEST TO SEE IF H.AID WAS ON SYSTEM BEFORE     *231*
*          EXECUTING SVC 'A'-'D'.  CAUSED MF01 IN DEBUGGER.    *231*
*      B.  CHANGES ARE DENOTED BY *231*                        *231*
*
*232.  MODIFIED BY JCB (10/19/89) TO:    (REV E4.232) (E4B)    *232*
*      A.  ADD SUPPORT FOR MPX 34U03                           *232*
*      B.  MOVE S.TXPM.6 TO PTCH CODE FOR BIASING T.TSAEND     *232*
*      C.  CORRECT TCP.UB ROUTINE TO FIX BAD BRANCH            *232*
*      D.  CORRECT SVC 1,3 CODE TO RESET CONTEXT INHIBIT FLAG  *232*
*      E.  CORRECT SVC7.19 ROUTINE TO BIAS R6 NOT R1           *232*
*      F.  CORRECTLY INITIALIZE SVC 2'S ABOVE X'7F'            *232*
*      G.  PRELIMINARY SUPPORT FOR MPX3.5 BL6                  *232*
*      H.  ADD SUPPORT FOR SVC 2,AF M.OSWRIT                   *232*
*      I.  ADD SUPPORT FOR SVC 2,7E M.OSREAD                   *232*
*      J.  ADD SUPPORT FOR SVC 2,7D M.GTSAD                    *232*
*      K.  CHANGES ARE DENOTED BY *232*                        *232*
*
*233.  MODIFIED BY JCB (11/21/89) TO:    (REV E4.233) (E4B)    *233*
*      A.  TURN ON TSA BIASING WHEN SVC 2,7D CALLED (M.GTSAD)  *233*
*      B.  CHANGES ARE DENOTED BY *233*                        *233*
*
*234.  MODIFIED BY JCB (11/29/89) TO:    (REV E4.234) (E4B)    *234*
*      A.  CORRECT MPX3.5 PATCHES                              *234*
*      B.  CHANGES ARE DENOTED BY *234*                        *234*
*
*235.  MODIFIED BY JCB (11/30/89) TO:    (REV E4.235) (E4B)    *235*
*      A.  CORRECT EA DISPATCH TO S.EXEC68 IN S.EXEC17 TO      *235*
*          PROPERLY UNBIAS FCB BEFORE DISPATCH (3.5 ONLY).     *235*
*      B.  CHANGES ARE DENOTED BY *235*                        *235*
*
*236.  MODIFIED BY JCB (12/06/89) TO:    (REV E4.236) (E4B)    *236*
*      A.  CORRECT INHIBITING OF SHARED CSECT FOR AUTO-TXPM    *236*
*      B.  CHANGES ARE DENOTED BY *236*                        *236*
*
*237.  MODIFIED BY JCB (12/07/89) TO:    (REV E4.237) (E4B)    *237*
*      A.  START MODIFICATIONS FOR MPX 3.5 MAPPED OUT MPX      *237*
*      B.  ADD SUPPORT FOR MOVABLE TSA IN 3.5 MAPPED IN MPX    *237*
*      C.  CHANGES ARE DENOTED BY *237*                        *237*
*
*238.  MODIFIED BY JCB (01/18/90) TO:    (REV E4.238) (E4B)    *238*
*      A.  ADD SUPPORT FOR MPX 1.5E TO TXPM                    *238*
*      B.  CHANGES ARE DENOTED BY *238*                        *238*
*
*239.  MODIFIED BY JCB (01/30/90) TO:    (REV E4.239) (E4B)    *239*
*      A.  ADD SUPPORT FOR MPX 3.5 BL 7                        *239*
*      B.  CHANGES ARE DENOTED BY *239*                        *239*
*
*240.  MODIFIED BY JCB (01/31/90) TO:    (REV E4.240) (E4B)    *240*
*      A.  ADD FINAL SUPPORT FOR MPX 3.4 U03                   *240*
*      B.  CHANGES ARE DENOTED BY *240*                        *240*
*
*241.  MODIFIED BY JCB (03/02/90) TO:    (REV E4.241) (E4B)    *241*
*      A.  ADD SUPPORT FOR MPX 3.5 BL 8                        *241*
*      B.  CHANGES ARE DENOTED BY *241*                        *241*
*
*242.  MODIFIED BY JCB (03/20/90) TO:    (REV E4.242) (E4B)    *242*
*      A.  CORRECT IPU GATING PROBLEM.  CAUSED RANDOM ABORTS.  *242*
*          TXPMFLGS NOW EQUATED TO C.UBIAS AND USES BITS 0-7   *242*
*          FOR INTERNAL TXPM FLAGS                             *242*
*      B.  CHANGES ARE DENOTED BY *242*                        *242*
*
*243.  MODIFIED BY JCB (03/02/90) TO:    (REV E4.241) (E4B)    *243*
*      A.  TXPM.ACC BEING SET IN TXPMFLGS INSTEAD OF EVENT.PTR *243*
*      B.  CHANGES ARE DENOTED BY *243*                        *243*
*
************************************************************************
         SPACE     2                                                !259
*  The conditional variable, DO.BUI, is set TRUE if you want        !259
*  to check for incorrect dispatches to the RHW of BU *.            !259
*  Use COND2 -X -DDO.BUI etc. to get this done                      !259
         SPACE     2                                                !259
         LIST      NONG,NOMAC                                   *232*
         IFT       C.3227,N27
C.3227   SETT              Pass C.3227 condition from cond2 to macros
N27      ANOP
         IFF       C.3227,N77
C.3227   SETF              Pass C.3227 condition from cond2 to macros
N77      ANOP
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR                        !259
TTL.TMPX ANOP                                                       !259
         PROGRAM   H.TXPM          XPM-64.E5.ED9                46 $VER
         DEF       VER.TXPM        VERSION NUMBER
         DEF       PRG.TXPM        DATE
VER.TXPM EQU       X'8E5ED9'                                    25 $VER
PRG.TXPM EQU       X'12013'        MMDDY                        22 $PRG
         IFF       OS.15E,SKIP                                  *238*
         LIST      NONG,MAC                                         !244
         M.VRSION                  MACRO LIB VERSION ID
         LIST      NONG,NOMAC                                       !244
SKIP     ANOP                                                   *238*
*        H.TXPM :  REMAPPING PROCESSOR                            *
         DEF       TXPM.RET,TXPMREGS,S.TXPM.1,S.TXPM.0
         DEF       FIRE,CPIX.0                                      !248
         IFF       C.MPXOUT,MO                                  *237*
         DEF       ADR.MASK,S.TRV.16,S.TRV.10,S.TRV.11,EXEC.05
         DEF       FCB.BIAS,BORT.USR,IPUREGS,SPLREGS,CPUREGS
         DEF       BIAS.R1, BIAS.R2          CALLED FROM PTCH       !282
         IFT       DO.BUI,BUI.DO                                    !259
         DEF       RHW.CPU,RHW.IPU                                  !259
BUI.DO   ANOP                                                       !259
         IFF       OS.15E,OS15E                                 *238*
         EXT       S.TXPM23,H.IP06,S.TXPM.6                     *232*
OS15E    ANOP                                                   *238*
         IFF       OS.15E,OS15E                                 *238*
         EXT       XVTBLA,X.SVCTN6,X.SVCTN7,X.SVCTNE            *219*
         EXT       SVC6IN,SVC7IN,SVCEIN,SVC6OUT,SVC7OUT,SVCEOUT *219*
         EXT       ACX.BIAS                                     *219*
OS15E    ANOP                                                   *238*
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         DEF       ADR.MASK,EXEC.05                             *237*
         DEF       BORT.USR,CPUREGS                             *237*
         EXT       H.IP06                                       *237*
         DEF       BORT.USR                                     *237*
MO       ANOP                                                   *237*
         IFT       OS.15E,OS15E                                 *238*
         EXT       H.IP06                                       *238*
OS15E    ANOP                                                   *238*
         DEF       EVNT.PTR,MAP.MPX,MAP.41             *232*    *242*
         DEF       S.TRV.32,MPX.INT,DBHAT
         IFT       C.3227,X.X
         IFF       MPX.EVNT,X.Y
         EXT       A.TRV.13
X.Y      ANOP
X.X      ANOP
         EXT       PTCH.MCL                                         !272
         M.EQUS
         M.MDE                     MACHINE DEPENDENT EQUATES
         M.TBLS                    NEED  EQUATES
         M.PSB.
         M.PRB.
         IFT       OS.35,PRCDEF                                     !280
         M.PRC.                                                     !280
PRCDEF   ANOP                                                       !280
         M.RXB.
*266          IFT       OS.35,GETM   INCLUDE IF MPX 3.5              *232*
*266          M.MIDS    MIDL EQUATES                                 *232*
*266          M.BREGS                                                    !249
*266          M.MRRQ                                                     !249
*266          M.RG.LDR                                                   !249
*266 GETM     ANOP                                                   *232*
         LIST      ON,MAC                                           !271
         M.TXPM                                                     !271
         LIST      NOREPT,NOMAC,NGLIST
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- (MACRO DEFINITIONS)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- (MACRO DEFINITIONS) !259
TTL.TMPX ANOP                                                       !259
*
         IFF       C.MPXOUT,MO                                  *237*
         IFF       OS.15E,OS15E                                 *238*
*--------------------------------------------------------------------
*  MACRO TO BIAS A CNP (IF SUPPLIED)
*  CNP = CALLER NOTIFICATION PACKET
*
BIAS.CNP DEFM      W4
         STW       R0,TSK.RET,X2   SAVE RETURN
         IFT       OS.35,BCNP.M01                                   !266
         IFA       %W4,%BC1                                         !266
         ZBR       R2,1            DO NOT BIAS WORD 4               !266
%BC1     ANOP                                                       !266
         IFP       %W4,%BC2                                         !266
         SBR       R2,1            BIAS WORD 4 OF CNP               !266
%BC2     ANOP                                                       !266
BCNP.M01 ANOP                                                       !266
         BL        CNP.BIAS        BIAS CNP (IF SUPPLIED)
         LW        R0,TSK.RET,X2   RESTORE RETURN
         ENDM
*
*--------------------------------------------------------------------
*  MACRO TO DETERMINE RESOURCE TYPE (IN R1), AND BIAS BOTH R1
*  AND THE FCB IF APPROPRIATE TO THE RESOURCE TYPE.
*
*        ENTRY     R1=REGISTER STACK ADDRESS
*                  R2=CONTEXT ADDRESS
*                  R3=LEVEL POINTER
*                  R4=20-BIT MASK
*                  R5=BIAS
*
RSRC.TYP DEFM
         STW       R0,TSK.RET,X2   SAVE RETURN ADDRESS
         TBM       TSK.SVC,TSK.LVL,X3   BIAS OR RE-BIAS?
         BS        %L1             BRANCH IF BIAS
*271          ZBM       TSK.RTYP,TSK.LVL,X3  DO WE KNOW RESOURCE TYPE?
         ZBM       TSK.RTYP,TSK.SVCI,X3 DO WE KNOW RESOURCE TYPE?   !271
         BS        %LEND           BRANCH IF NOT
         LB        R7,DQE.RTYP,X3  FETCH RESOURCE TYPE
         BU        %L6             GO BIAS ACCORDING TO TYPE
%L1      LW        R6,1W,X1        FETCH USER'S R1
         ADR       R5,R6           COULD BE AN ADDRESS, SO BIAS
         XCR       R6,R1           SAVE REGISTER POINTER
         BL        S.TXPM23        DETERMINE TYPE
         BNS       %L4             BR IF KNOWN
         TRR       R6,R1           RESTORE REGISTER POINTER
         LW        R1,1W,X1        REFETCH R1
         BL        S.TXPM23        TRY AGAIN WITH RE-BIASED ADD
         BNS       %L4             BRANCH IF RESOURCE IDENTIFIE
*271          SBM       TSK.RTYP,TSK.LVL,X3  INDICATE RESOURCE NOT IDENTIFIED
         SBM       TSK.RTYP,TSK.SVCI,X3 INDICATE RESOURCE NOT IDENTI!271
         LW        R0,TSK.RET,X2   RESTORE R0
         TRR       R6,R1           RESTORE REG POINTER
         BU        %LEND
%L4      STB       R7,DQE.RTYP,X3  SAVE RESOURCE TYPE
         TRR       R6,R1           RESTORE REGISTER POINTER
         LW        R0,TSK.RET,X2   RESTORE RETURN ADDRESS
%L6      CI        R7,4            FCB
         BEQ       %L8             GO BIAS FCB AND FCB ADDR
         BGT       %LEND           NO BIAS FOR LFC OR ALLOC IND
         BU        %L9             GO BIAS R1
*
%L8      BIAS.FCB                  BIAS FCB
%L9      BIAS.R    1               BIAS R1
%LEND    EQU       $
         ENDM
OS15E    ANOP                                                   *238*
*
*--------------------------------------------------------------------
*  MACRO TO BIAS REGISTER R
*
BIAS.R   DEFM      R               MACRO TO BIAS REGISTER R
         LMW       R6,1W*%R,X1     FETCH REGISTER TO BIAS
         BZ        %LEND           NO BIAS IF ZERO
         TRR       R5,R5           SEE IF BIAS/REBIAS
         BN        $+2W            GO IF REBIAS
         ADR       R5,R6           BIAS ADDRESS
         CAMW      R6,C.TSAD       IS ADDR IN O/S OR USER
         BLT       $+2W            GO IF IN O/S
         ARMW      R5,1W*%R,X1     BIAS/REBIAS CUZ ADDR IN USER
%LEND    EQU       $
         ENDM
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
*
*--------------------------------------------------------------------
*  MACRO TO BIAS MEMORY WORD WHOSE ADDRESS IS 'O' + CONTENTS OF
*  REGISTER R
*
*        ENTRY     R1=REG STACK ADDRESS
*                  R2=CONTEXT ADDRESS
*                  R3=LEVEL POINTER
*                  R4=20-BIT MASK
*                  R5=BIAS
*                  R7=RESOURCE TYPE
*
BIAS.M   DEFM      R,O
         LW        R6,1W*%R,X1     GET REG VALUE
         BZ        %LEND           EXIT IF ZERO
         ADI       R6,%O           MEMORY ADDRESS OFFSET
         TBM       TSK.SVC,TSK.LVL,X3   BIAS OR RE-BIAS?
         BNS       %LL             BRANCH IF BIAS
         ADR       R5,R6           MUST BIAS REGISTER FIRST
%LL      CAMW      R6,C.TSAD       ABOVE OS?
         BLT       BORT.MEM
         TRR       R6,R1           MEMORY ADDRESS TO XR
         LMW       R6,0W,X1        FETCH MEMORY WORD TO BIAS
         BZ        %LM             DO NOT BIAS IF ZERO
         ARMW      R5,0W,X1        BIAS MEMORY LOCATION
%LM      LW        R1,TSK.REGP,X2  RESTORE REGISTER STACK ADDRESS
%LEND    EQU       $
         ENDM
         IFF       OS.15E,OS15E                                 *238*
*
*--------------------------------------------------------------------
*  MACRO TO BIAS RCB WHOSE ADDRESS IS SUPPLIED IN %R
*  RCB = RESOURCE CREATE BLOCK
*
*        ENTRY     R1=REG STACK ADDRESS
*                  R2=CONTEXT ADDRESS
*                  R3=LEVEL POINTER
*                  R4=20-BIT MASK
*                  R5=BIAS
*                  R7=RESOURCE TYPE
*
BIAS.RCB DEFM      R
         STW       R0,TSK.RET,X2   SAVE RETURN
         LW        R1,1W*%R,X1          FETCH RCB ADDRESS
         BZ        %NON            SKIP BIAS IF NON SUPPLIED
         BL        RCB.BIAS        GO BIAS RCB
%NON     LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         LW        R0,TSK.RET,X2
         ENDM
OS15E    ANOP                                                   *238*
*
*--------------------------------------------------------------------
*  MACRO TO BIAS A CHANNEL PROGRAM
*
BIAS.ECP DEFM
         STW       R0,TSK.RET,X2   SAVE RETURN
         LW        R1,1W,X1        FETCH FCB ADDRESS
         BL        ECP.BIAS        BIAS CHANNEL PROGRAM
         LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         LW        R0,TSK.RET,X2   RESTORE RETURN ADDRESS
         ENDM
         IFF       OS.15E,OS15E                                 *238*
*
*--------------------------------------------------------------------
*  MACRO TO BIAS RLB WHOSE ADDRESS IS SUPPLIED IN %R
*  RCB = RESOURCE LOGGING BLOCK
*
BIAS.RLB DEFM      R
         STW       R0,TSK.RET,X2   SAVE RETURN
         LW        R1,1W*%R,X1          FETCH RLB ADDRESS
         BL        RLB.BIAS        GO BIAS RLB
         LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         LW        R0,TSK.RET,X2
         ENDM
OS15E    ANOP                                                   *238*
*
*--------------------------------------------------------------------
*  MACRO TO BIAS PSB WHOSE ADDRESS IS SUPPLIED IN %R
*  PSB = PARAMETER SEND BLOCK
*
BIAS.PSB DEFM      R
         STW       R0,TSK.RET,X2   SAVE RETURN
         LW        R1,1W*%R,X1      FETCH PSB ADDRESS
         BZ        %NON            SKIP BIAS IF NON SUPPLIED
         BL        PSB.BIAS        GO BIAS PSB
%NON     LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         LW        R0,TSK.RET,X2
         ENDM
*
*--------------------------------------------------------------------
*  MACRO TO BIAS PRB WHOSE ADDRESS IS SUPPLIED IN %R
*  PRB = PARAMETER RECEIVE BLOCK
*
BIAS.PRB DEFM      R
         STW       R0,TSK.RET,X2   SAVE RETURN
         LW        R1,1W*%R,X1          FETCH PRB ADDRESS
         BL        PRB.BIAS        GO BIAS RCB
         LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         LW        R0,TSK.RET,X2
         ENDM
*
*--------------------------------------------------------------------
*  MACRO TO BIAS RXB WHOSE ADDRESS IS SUPPLIED IN %R
*  RXB = RECEIVER EXIT BLOCK
*
BIAS.RXB DEFM      R
         STW       R0,TSK.RET,X2   SAVE RETURN
         LW        R1,1W*%R,X1          FETCH RCB ADDRESS
         BL        RXB.BIAS        GO BIAS RCB
         LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         LW        R0,TSK.RET,X2
         ENDM
*
*--------------------------------------------------------------------
*  MACRO TO BIAS FCB WHOSE ADDRESS IS CONTAINED IN REGISTER 'R'
*
BIAS.FCB DEFM
         STW       R0,TSK.RET,X2   SAVE RETURN
         LW        R1,1W,X1       FETCH FCB ADDRESS
         BL        FCB.BIAS        BIAS FCB
         LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         LW        R0,TSK.RET,X2   RESTORE RETURN ADDRESS
         ENDM
MO       ANOP                                                   *237*
*
*--------------------------------------------------------------------
*  MACRO TO FETCH DQE CONTEXT ADDRESS.
*
*  ON OUTPUT: R2 = DQE CONTEXT ADDRESS IN H.TXPM
*             R3 = CURRENT SOFTWARE INTERRUPT LEVEL POINTER
*
M.DQECXT DEFM
         LW        R2,C.CURR
         LW        R2,DQE.PSSF,X2  GET CONTEXT ADDR FROM DQE
         LW        R3,TSK.LVLP,X2  GET CURRENT LEVEL POINTER
         ENDM
*
         IFF       C.MPXOUT,MO                                  *237*
*-----------------------------------------------------------------------
* MACRO TO TEST IF IN IPU
*
T.IPU    DEFM      R,DSVC
         IFF       C.3227,%1JUNK
         LW        %R,=X'910000'   GET SPAD ADDRESS
         TSCR      %R,%R           READ IPU STATUS WD
%1JUNK   ANOP
         IFT       C.3227,%2JUNK
         RDSTS     %R              READ STATUS
         IFF       MPX.EVNT,%D2JUNK  DON'T DO CHECK FOR MPX EVENT   !280
         IFT       OS.35,%D3JUNK     ONLY DO CHECK FOR MPX 3.5      !280
         IFP       %DSVC,%D1JUNK                                    !280
         TBM       LW.C2000,LSWITCH  Seahawk?                       !281
         BNS       $+3W              If not, skip turbo mode check  !281
         TBR       %R,PRC.DSVC       CHECK TURBO SVC MODE           !280
         BS        BORT.TUR          GENERATE TX ERROR IF ITS ON    !280
%D1JUNK  ANOP                                                       !280
%D3JUNK  ANOP                                                       !280
%D2JUNK  ANOP                                                       !280
%2JUNK   ANOP
         TBR       %R,27           SEE IF IPU
         ENDM
*
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
*--------------------------------------------------------------------
*  MACRO TO BIAS A REGISTER UNLESS THE REGISTER CONTAINS AN LFC
*
BIAS.LFC DEFM      R
         LW        R7,1W*%R,X1
*  SUBROUTINE TO DETERMINE WHETHER OR NOT R7 CONTAINS AN LFC OR NOT
*  ON OUTPUT:
*
*             CONDITION CODE 0 = SET, IF R7 CONTAINS AN LFC
*                                RESET, OTHERWISE
*
         LI        R1,-3           3 BYTE TRIP COUNT
         ZBR       R0,1            RESET CC 0
         SLL       R7,8            LEFT JUSTIFY LFC
%IS.1    ZR        R6
         SLLD      R6,8            ISOLATE NEXT BYTE OF LFC
         CI        R6,X'80'        ASCII?
         BGE       %IS.2           BRANCH IF NOT
         CI        R6,X'20'        ASCII?
         BLT       %IS.2           BRANCH IF NOT
         BIB       R1,%IS.1        GO EXAMINE NEXT BYTE
         BU        %L1             BRANCH,IT POINTS TO LFC
%IS.2    LW        R1,TSK.REGP,X2  RESTORE REG STACK POINTER
         BIAS.R    %R              OTHERWISE, BIAS REGISTER
%L1      LW        R1,TSK.REGP,X2  RESTORE REGISTER POINTER
         ENDM
*
*--------------------------------------------------------------------
*  COMMON MACRO USED TO RETURN FROM EACH BIASING ROUTINE
*
BIAS.LV  DEFM                      MACRO TO RETURN AND BOUND NEXT WORD
         TRSW      R0              CONTINUE PROCESSING
         BOUND     1W
         ENDM
MO       ANOP                                                   *237*
*
*--------------------------------------------------------------------
*  MACRO TO CHANGE TRAP/INTERRUPT SPAD POINTERS TO 'MPX'
*
V.MPX    DEFM
         LW        R1,=X'F00000'   SPAD ADDRESS FOR TRAP VECTORS *214*
         LW        R4,MPX.TRP      FETCH MPX TRAP BASE
         TRSC      R4,R1           PUT IN SCRATCH PAD
         SBR       R1,15           SPAD ADDRESS FOR INTERRUPT VECTORS
         LW        R4,MPX.INT      FETCH MPX INTERRUPT BASE
         TRSC      R4,X1           PUT IN SCRATCH PAD
         ENDM
*
*--------------------------------------------------------------------
*  MACRO TO CHANGE TRAP/INTERRUPT SPAD POINTERS TO 'T-XPM'
*
V.TXPM   DEFM
         LW        R3,=X'F00000'   SPAD ADDRESS FOR TRAP VECTORS *214*
         LA        R4,TRP.VCT      FETCH T-XPM TRAP BASE
         TRSC      R4,R3           PUT IN SCRATCH PAD
         SBR       R3,15           SPAD ADDRESS FOR INTERRUPT VECTORS
         LA        R4,INT.VCT      FETCH T-XPM INTERRUPT BASE
         TRSC      R4,X3           PUT IN SCRATCH PAD
         ENDM
         IFF       C.MPXOUT,MO                                  *237*
*
*--------------------------------------------------------------------
*  MACRO TO CHANGE TRAP/INTERRUPT SPAD POINTERS TO 'MPX' IN IPU
*
V.MPXI   DEFM
         LW        R1,=X'F00000'   SPAD ADDRESS FOR TRAP VECTORS *214*
         LW        R4,MPX.TRPI     FETCH MPX TRAP BASE
         TRSC      R4,R1           PUT IN SCRATCH PAD
         ENDM
*
*--------------------------------------------------------------------
*  MACRO TO CHANGE TRAP/INTERRUPT SPAD POINTERS TO 'T-XPM' IN IPU
*
V.TXPMI  DEFM
         LW        R3,=X'F00000'   SPAD ADDRESS FOR TRAP VECTORS *214*
         LA        R4,TRPI.VCT     FETCH T-XPM TRAP BASE
         TRSC      R4,R3           PUT IN SCRATCH PAD
         ENDM
MO       ANOP                                                   *237*
*
*--------------------------------------------------------------------
*           DEFINE T-XPM TRAP CONTEXT BLOCK
*
TRP.CXT  DEFM
         REZ       1D              OLD PSD
         GEN       12/X'840',20/W($+4W-$+2W)  NEW PSW NOT RELOCATED
         DATAW     X'00014000'     UNMAPPED, RETAIN, BLOCKED
         RES       2W
         ENDM
         IFF       C.MPXOUT,MO                                  *237*
*
*---------------------------------------------------------------
*           DEFINE T-XPM TRAP CONTEXT BLOCK FOR IPU
*
TRI.CXT  DEFM
         REZ       1D              OLD PSD
         GEN       12/X'840',20/W($+4W-$+2W)  NEW PSW NOT REL
         DATAW     X'00018000'     UNMAPPED, RETAIN, UNBLOCKED
         RES       2W
         ENDM
MO       ANOP                                                   *237*
*
*--------------------------------------------------------------------
*           DEFINE T-XPM INTRRUPT CONTEXT BLOCK
*
INT.CXT  DEFM
         REZ       1D              OLD PSD
         GEN       12/X'840',20/W($+4W-$+2W)  NEW PSW NOT RELOCATED
         RES       3W              SET BY EP 8
         ENDM
*
         IFF       OS.35,OLDTSAD NOT IN 35 MAPPED IN MODE     *237* !266
         IFF       C.MPXOUT,MI   NOT IN 35 MAPPED OUT MODE      *237*
*-----------------------------------------------------------    *237*
* MACRO TO GET TSA ADDRESS                                      *237*
M.TSAD   DEFM      R                                            *237*
         LW        %R,C.TSAD                                    *237*
         ENDM                                                   *237*
*                                                               *237*
MI       ANOP                                                   *237*
OLDTSAD  ANOP                                                       !266
         IFF       C.MPXOUT,MO                                  *237*
* MACRO TO DO A "QUICK" TSHUT (DESTROYS ONE USER REGISTER)
*
M.QSHUT  DEFM      R,LOC
         RDSTS     %R              THIS DESTROYS A USER REGISTER
         BEI
         STF       R0,CPUREGS         STORE USER REGISTERS
         M.DQECXT
         ENDM
*
*  MACRO TO DO A "QUICK" TOPEN
*
M.QOPEN  DEFM      R
         LF        R0,CPUREGS         RESTORE CALLERS REGS
         IFT       C.3227,%3227    GET CORRECT TBM FOR THE CPU
         TBR       %R,24           SEE IF WE ENTERED BLOCKED
%3227    EQU       $
         IFF       C.3227,%327X
         TBR       %R,26
%327X    EQU       $
         BS        %QOPEN1         SKIP UNBLOCK
         UEI                       UNBLOCK INTERRUPTS
         NOP
%QOPEN1  EQU       $
         ENDM
MO       ANOP                                                   *237*
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- (EQUATES)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- (EQUATES)           !259
TTL.TMPX ANOP                                                       !259
*--------------------------------------------------------------------
*   SCRATCHPAD AND INTERRUPT EQUATES
*
         M.TXINTL                  Internal equates for us and PTCH !271
IPU.SCH  EQU       6               IPU scheduling flag 3X
TRP.TTBA EQU       X'3C0'          SPAD INDEX TO TRAP TABLE BASE ADDRESS
INT.ITBA EQU       X'3C4'          SPAD INDEX TO INT  TABLE BASE ADDRESS
INT.LEN  EQU       X'1BC'          LENGTH OF INTERRUPT ENTRY TABLE
INT.IESA EQU       X'200'          INTERRUPT ENTRY TABLE SPAD ADDRESS
*MOD MAX.INT  EQU       64         MAXIMUM NUMBER OF I/O INTERRT'S  !MOD
MAX.INT  EQU       80              MAXIMUM NUMBER OF I/O INTERRT'S  !MOD
         IFF       C.MPXOUT,MO                                  *237*
*271 T.LMIT   EQU       X'1800'         LOAD MODULE INFO TABLE BIAS
IPU.GATE EQU       6               IPU GATE FLAG 2X
EXEC.RUN EQU       5               IPU RUNNING FLAG             *211*
         IFT       OS.36,O36                                    !295
         EXT       EXC.IPUP        NEW SCHEDULING WORD          !295
IPU.REQP EQU       0               PENDING IPU REQUEST FLAG     !295
         EXT       EXC.IPUR        NEW SCHEDULING WORD          !295
O36      ANOP                                                   !295
         EXT       EXEC.FLG
MO       ANOP                                                   *237*
*  Additional task context area equates
TSK.LVL5 EQU       9W              INTERRUPT LEVEL 5 (END-ACT PRIOR 1)
* -----------------------------------------------------------------
*  EQUATES FOR EVENT BUFFER
*
EVNT.LEN EQU       X'40'           16 WORD ENTRIES
EVNT.TYP EQU       0               EVENT TYPE
EVNT.SIL EQU       1W              EVENT SOFTWARE INTERRUPT LEVEL
EVNT.NAM EQU       2W              TASK NAME
EVNT.PSD EQU       4W              EVENT PSD
EVNT.SVC EQU       6W              EVENT SVC
EVNT.TSK EQU       7W              EVENT DQE NUMBER
EVNTREGS EQU       1F              USER'S REGISTERS
*--------------------------------------------------------------------
*
*  EQUATES FOR H.AID
*
H.AIDSIZ EQU       X'F00'          SIZE OF AID RELEASE D.2 H.AID
H.AIDBEG EQU       0               PATCHED BEGINNING ADDRESS OF H.AID
H.AIDPAT EQU       0               FLAGS INSTRUCTIONS TO BE PATCHED
*
*--------------------------------------------------------------------
*
*  EQUATES FOR EXECUTE CHANNEL PROGRAM
*
CCHAIN   EQU       0               COMMAND CHAIN
DCHAIN   EQU       1               DATA CHAIN
IOCD.LEN EQU       1D              IOCD LENGTH
*
*
MO       ANOP                                                   *237*
*--------------------------------------------------------------------
*
*  EQUATES FOR TRAP INFORMATION BLOCK (OF WHICH THERE IS ONE FOR
*  EACH TRAP/INTERRUPT FOUND BY TRAVIS AT ENTRY POINT 8) HAVE BEEN
*  MOVED TO MACRO M.TXPM (SOURCE IS SH.XPMMAC)
*
*
*--------------------------------------------------------------------
*
*  EQUATES FOR 'AID' SUBROUTINE CALL STACK (MUST CORRESPOND TO H.AID!)
*
STK.END  EQU       2W
STK.OEND EQU       34W
STK.LPTR EQU       42W
*
*
*  HANDLER ADDRESS TABLE
*
*        LIST      NONG,NODATA,NOMAC
         LIST      NONG,NODATA,MAC,REP
HAT      DATAW     1
         ACW       T.INIT          SYSGEN INITIALIZATION
         BOUND     1D                                               !260
MPT.HAWK GEN       1/1,5/1,26/W(P5.23) Priv, ext'd, BU P5.23        !260
         DATAW     X'00004000'     BEI, UNmapped                    !260
MPM.HAWK GEN       1/1,5/1,26/W(MM.25) Priv, ext'd, BU MM.25        !260
         DATAW     X'00004000'     BEI, UNmapped                    !260
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.1 (H.EXEC DISP)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.1 (H.EXEC DISP)
TTL.TMPX ANOP                                                       !259
*
*-----------------------------------------------------------------------
*
*  S.TXPM.1 IS CALLED WHEN READY TO DISPATCH TO A USER TASK.
*  THIS ROUTINE WILL:
*
*  1.  SIMPLY RETURN IF,
*
*      A.  THIS IS A STD MPX TASK, OR
*      B.  THIS IS A 'TXPM' TASK, BUT THE DISPATCH ADDRESS IS NOT
*          IN THE USER'S TXPM ADDRESS SPACE.
*
*  2.  CHANGE MAPS TO THE 'TXPM' ENVIRONMENT AND DISPATCH TO THE
*      THE 'TXPM' TASK IF,
*
*      A.  THIS IS A 'TXPM' TASK, AND
*      B.  THE DISPATCH IS TO THE USER'S 'TXPM' ADDRESS SPACE.
*
*  3.  ENTRY CONDITIONS
*      A.  MUST BE BEI (BLOCKED)
*      B.  R6 AND R7 = RETURN PSD (MPX ADDRESS)
*      C.  R2 POINTS TO RETURN REGISTER STACK (MAPPED LOGICAL ADDRESS)
*
************************************************************************
**   TXPM.LVP MACRO SUPPORT
**   CALLER MUST BE BEI
**   SAVED REGS IN TXPMREGS
**   CALL TXPM.RET WITH BL
**   TXPM WILL RETURN IF NOT TXPM TASK
************************************************************************
EXEC.05  EQU       $               EXEC5 DISPATCH ENTRY
         LA        R2,TXPMREGS     ADDRESS OF SAVE AREA
TXPM.RET LI        R4,X'3FFC'      MASK FOR CPIX
         BEI                       MAKE SURE WE ARE BLOCKED
         TRR       R0,R5           RETURN ADDR TO R5
         LA        R3,DQE0         DEFAULT DQE ZERO
         TRRM      R7,R1           CPIX TO R1
         BZ        G.DQE0          USE DQE 0 IF CPIX IS ZERO
         IFF       C.3227,THF.1    ADJUST CPIX TO DQE INDEX
         SRL       R1,2            THIS IS 7X BPIX SHIFT
THF.1    ANOP
         IFT       C.3227,THF.2    ADJUST CPIX TO DQE INDEX
         SRL       R1,3            THIS IS CONCEPT BPIX SHIFT
THF.2    ANOP
         SLL       R1,2            WORD ADJUST PROG NUM
         ADMW      R1,C.ADAT       DQE ADDRESS TABLE
         LW        R3,0W,X1        GET DQE ADDR
G.DQE0   LW        R1,DQE.PSSF,X3  GET CONTEXT ADDRESS
         BNZ       OK3TEST         GO ON IF CONTEXT ADDR SET
         LB        R1,DQE.NUM,X3   FETCH DQE NUMBER
         MPI       R0,DQE.LCXT     FORM DQE CONTEXT AREA INDEX
         ADMW      R1,C.CTXT       ADD IN CONTEXT ORIGIN
         STW       R1,DQE.PSSF,X3  SET CONTEXT ADDR IN DQE
*
*  SEE IF THIS IS A NOMPX TASK. IF NOT, THEN JUST RETURN
*
OK3TEST  STW       R3,TSK.DQE,X1   SAVE DQE ADDRESS
         TBM       TSK.TXPM,TSK.FLG1,X1  'NO-MPX' TASK?
         BS        TO.TXPM                BRANCH IF 'NO-MPX' TASK
*
*  AT THIS POINT, GOING TO MPX TASK
*
TEST.SPL ZBM       NOT.MPX,TXPMFLGS  RETURN FROM SPCL INT
         BNS       GO.EXEC         MPX LOADED, SO RETURN
         STD       R6,TSK.RPSD,X1  SAVE RETURN PSD IN CONTEXT AREA
         STW       R2,TSK.REGP,X1  SAVE REG POINTER
         TRR       R1,R2           CONTEXT TO R2
         STW       R5,TSK.RET,X2   SAVE RETURN ADDRESS
         IFT       C.3227,SP.03
         IFF       MPX.EVNT,EVNT
*  RESET BASE SPAD POINTER FOR TRAP & INTERRUPT VECTORS
         V.MPX                     SET SPAD VECTORS TO MPX (CONCEPT
EVNT     ANOP
SP.03    ANOP
         BL        MAP.MPX         GO MAP IN MPX
         IFF       C.MPXOUT,MO                                  *237*
         TBM       TSK.TSAB,TSK.FLG1,X2   IS TSA BIASED?
         BNS       TST.RET         BRANCH IF ALREADY BIASED
         LI        R6,1            UNBIAS TSA
         BL        S.TXPM.6        UNBIAS TSA ADDRESSES
MO       ANOP                                                   *237*
TST.RET  ZBM       DSP.TXPM,TSK.FLG2,X2  CLEAR TXPM DISP FLAG
         TBM       TSK.TXPM,TSK.FLG1,X2  TXPM TASK?
         BNS       TST.RET1        BR IF NOT
         LW        R3,TSK.DQE,X2   GET DQE ADDRESS
         TBM       DQE.ADM,DQE.ATI,X3  IS DEBUGGER XEQING?
         BNS       TST.RET1        BR IF NOT
         LA        R5,DBHAT        GET OUR HAT ADDRESS
         IFF       C.MPXOUT,MO                                  *237*
         M.TSAD    R3              GET TSA ADDRESS              *237*
         STW       R5,T.DBHAT,X3   PUT IN TSA
         BL        SVC1.50         BIAS AID STACK FOR MPX ENV
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         LW        R3,C.REGS       GET TSA ADDRESS              *237*
         STCW      R5,T.DBHAT,X3   PUT IN TSA                   *237*
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
TST.RET1 M.TSAD    R3              GET TSA ADDRESS              *237*
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
TST.RET1 LW        R3,C.REGS       GET TSA ADDRESS              *237*
MO       ANOP                                                   *237*
         STW       R3,C.TXPM       UPDATE TSA ADDRESS FOR H.AID
         LW        R5,TSK.RET,X2   GET RETURN ADDRESS
         TRR       R2,R1           CONTEXT ADDR BACK TO R1
         LW        R2,TSK.REGP,X1  REG ADDR TO R2
         LD        R6,TSK.RPSD,X1  GET RETURN PSD
         LW        R3,TSK.DQE,X1   GET DQE ADDRESS
         BU        GO.EXEC         MPX LOADED, SO RETURN
*
*  HERE TASK IS 'NO-MPX', BUT WE MUST INSURE DISPATCH IS TO USER
*  BEFORE SWITCHING TO 'NO-MPX' ENVIRONMENT.
*
TO.TXPM  TBR       R7,0            NEW PSD MAPPED?
         BNS       TEST.SPL        BRANCH IF UNMAPPED
*
*  INSURE DISPATCH IS TO USER'S LOCAL (ABOVE TSA) ADDRESS SPACE
*
         TRR       R6,R4           COPY PSD WD 1
         IFF       C.MPXOUT,MO                                  *237*
         ANMW      R4,=X'FFFFF'    KEEP MAPPED ADDRESS ONLY
*
         CAMW      R4,C.TSAD       DISPATCH TO USER?
         BLT       TEST.SPL        BRANCH IF NOT
         SUMW      R6,TSK.BIAS,X1  R6 = NEW NOMPX MAPPED ENTRY
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         ANMW      R4,=X'FFFFFF'   KEEP MAPPED ADDRESS ONLY     *237*
*                                                               *237*
         CAMW      R4,C.LOSEND     DISPATCH TO USER?            *237*
         BLT       TEST.SPL        BRANCH IF NOT                *237*
MO       ANOP                                                   *237*
*
*        RETURNING TO TXPM TASK FROM S.EXEC5 OR NESTED
*        INTERRUPT OR TRAP HANDLER EXIT.
*
         TBM       NOT.MPX,TXPMFLGS  RETURN FROM SPCL INT
         BNS       DO.NORM         GO DO NORMAL DISP TO TXPM TASK
         IFT       C.3227,S.1
         LW        R5,=X'F50000'   PSD2 ADDRESS IN CPU SCRATCHPAD
S.1      ANOP
         IFF       C.3227,S.1
         LW        R5,=X'900000'   PSD2 ADDRESS IN CPU SCRATCHPAD
S.1      ANOP
         LI        R4,X'3FFC'      CPIX MASK
         TSCR      R5,R5           GET CPU PSD2
         TRRM      R5,R5           PURIFY PSD2 FROM SPAD
         TRRM      R7,R4           EXTRACT DEST PSD CPIX
         CAR       R4,R5           SAME CPIX
         BNE       DO.NORM         GOING TO ANOTHER TXPM TASK
         IFT       MPX.EVNT,EVNT
         LA        R5,SPL.RET      WHERE TO RETURN TO
         LI        R4,0            TXPM DISPATCH
         BU        GO.EXEC+1W      GO RECORD EVENT
EVNT     ANOP
SPL.RET  STD       R6,PSDR.CPU     SET RETURN PSD
         SBM       DSP.TXPM,TSK.FLG2,X1  SET TXPM DISP FLAG
         SBM       NOT.MPX,TXPMFLGS  RESET INCASE NESTED INTERRUPTS
         LF        R0,0W,X2        RESTORE USERS REGS
         LPSD      PSDR.CPU        DISPATCH TO TXPM TASK
*
DO.NORM  STD       R6,TSK.RPSD,X1  SAVE RETURN PSD
         STW       R2,TSK.REGP,X1  SAVE REG POINTER
         XCR       R1,R2           CONTEXT ADDRESS WILL BE IN R2
         IFT       C.3227,SP.03
         IFF       MPX.EVNT,EVNT
*  RESET BASE SPAD POINTER FOR TRAP & INTERRUPT VECTORS
         V.MPX                     SET SPAD VECTORS TO MPX (CONCEPT
EVNT     ANOP
SP.03    ANOP
         TBM       NOT.MPX,TXPMFLGS  SEE IF SPECIAL INT
         BS        DBG.EXC         GO TO TXPM TASK
         BL        MAP.MPX         GO MAP IN MPX
         BU        NSVC.RET        GO TO TXPM TASK
*
************************************************************************
*
*  MAIN-LINE DISPATCH
*
*        THIS IS COMPATABILITY ENTRY POINT
*        REGS ARE IN CPUREGS
*        RETURN PSD IS R6&R7
*        INTERRUPTS ARE BLOCKED
*
S.TXPM.1 LA        R2,CPUREGS      ADDRESS OF SAVE AREA
         IFF       C.3227,S.S
         IFF       MPX.EVNT,EVNT   SKIP IF MPX EVENT
         LW        R3,C.CURR       GET DQE ADDRESS
         ANMW      R4,=X'FFFFFF'   24 BIT MASK
         CI        R3,C.CURR       ANY TASK
         BNE       S.TXPM.0        BR IF YES
         TRSW      R0              ELSE, EXIT
EVNT     ANOP
S.S      ANOP
*
*        NEW ENTRY POINT FOR VERSION 2
*        THIS ENTRY ASSUMES R2->REG SAVE AREA
*                           R6&R7 CONTAINS RETURN PSD
*                           INTERRUPTS BLOCKED
*
S.TXPM.0 LI        R4,X'3FFC'      MASK FOR CPIX
         LA        R3,DQE0         GET DEFAULT DQE
         TRR       R0,R5           RETURN ADDR TO R5
         TRRM      R7,R1           CPIX TO R1
         BZ        G1.DQE0         USE DQE 0 IF CPIX IS ZERO
         IFF       C.3227,SHF.1    ADJUST CPIX TO DQE INDEX
         SRL       R1,2            THIS IS 7X BPIX SHIFT
SHF.1    ANOP
         IFT       C.3227,SHF.2    ADJUST CPIX TO DQE INDEX
         SRL       R1,3            THIS IS CONCEPT BPIX SHIFT
SHF.2    ANOP
         SLL       R1,2            WORD ADJUST PROG NUM
         ADMW      R1,C.ADAT       DQE ADDRESS TABLE
         LW        R3,0W,X1        GET DQE ADDR
G1.DQE0  TRR       R3,R0           SAVE DQE ADDRESS
         LW        R1,DQE.PSSF,X3  GET CONTEXT ADDRESS
         BNZ       OK2TEST         GO ON IF CONTEXT ADDR SET
         ZR        R0              CLEAR
         LB        R1,DQE.NUM,X3   FETCH DQE NUMBER
         MPI       R0,DQE.LCXT     FORM DQE CONTEXT AREA INDEX
         ADMW      R1,C.CTXT       ADD IN CONTEXT ORIGIN
         STW       R1,DQE.PSSF,X3  SET CONTEXT ADDR IN DQE
         TRR       R3,R0           SAVE DQE ADDRESS
*
*  SEE IF THIS IS A NOMPX TASK. IF NOT, THEN JUST RETURN TO CALLOR.
*  FIRST, SET THE CURRENT SOFTWARE INT LEVEL IN THE DQE CONTEXT AREA.
*
OK2TEST  STW       R3,TSK.DQE,X1   SAVE DQE ADDRESS
         TBM       TSK.TXPM,TSK.FLG1,X1  'NO-MPX' TASK?
         BS        T.TXPM                 BRANCH IF 'NO-MPX' TASK
*
GO.EXEC  EQU       $
         IFT       MPX.EVNT,EVNT   RECORD MPX EVENT
         LI        R4,8     (8 FOR)MPX EVENT RECORDING
*
*        AT THIS POINT THE REGS ARE :
*        RO - WILL BE RETURN ADDR
*        R1 - CONTEXT ADDRESS
*        R2 - REG SAVE AREA POINTER
*        R3 - DQE ADDRESS
*        R4 - EVENT TYPE (DISPATCH)
*        R5 - RETURN ADDRESS TO MPX (OR CALLER)
*        R6 - WD 1 OF RETURN PSD
*        R7 - WD 2 OF RETURN PSD
*
*
*  CHECK TO SEE IF EVENT RECORDING IS TURNED ON
*
         TBM       EVNT.DSP,EVNT.PTR  RECORD T-XPM DISPATCH?
         BNS       NO.LOGR         BRANCH IF NOT
         BL        LOGGER          GO LOG MPX EVENT
NO.LOGR  EQU       $
*
EVNT     ANOP
         TRSW      R5              RETURN TO CALLER
*
*-------------------------------------------------------------------
*
*  HERE TASK IS 'NO-MPX', BUT WE MUST INSURE DISPATCH IS TO USER
*  BEFORE SWITCHING TO 'NO-MPX' ENVIRONMENT.
*
*  IF DESTINATION PSD UNMAPPED, THEN ASSUME DISPATCH TO SYS DEBUGGER
*  AND TREAT AS REGULAR MPX DISPATCH
*
         BOUND     1W                                           *237*
T.TXPM   TBR       R7,0            NEW PSD MAPPED?
         BNS       GO.EXEC         BRANCH IF UNMAPPED
         TBR       R6,6            NEW PSD BASE MODE?               !289
         BS        GO.EXEC         BRANCH IF SO                     !289
*
*  INSURE DISPATCH IS TO USER'S LOCAL (ABOVE TSA) ADDRESS SPACE
*
         TRR       R6,R4           COPY PSD WD 1
         IFF       C.MPXOUT,MO                                  *237*
         ANMW      R4,=X'FFFFF'    KEEP MAPPED ADDRESS ONLY     *214*
*
         CAMW      R4,C.TSAD       DISPATCH TO USER?
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         ANMW      R4,=X'FFFFFF'   KEEP MAPPED ADDRESS ONLY     *237*
*                                                               *237*
         CAMW      R4,C.LOSEND     DISPATCH TO USER?            *237*
MO       ANOP                                                   *237*
         BLT       GO.EXEC         BRANCH IF NOT
*------------------------------------------------------------------
*
*  THE REMAINDER OF S.TXPM.1 INVOLVES SWITCHING TO THE 'TXPM'
*  ENVIRONMENT, SINCE WE FALL THRU ONLY IF WE HAVE DETERMINED
*  THAT CALLER IS DISPATCHING TO THE USER ADDRESS SPACE OF
*  A 'TXPM' TASK.
*
*------------------------------------------------------------------
*
*   HERE WE HAVE A 'NO-MPX' TASK WITH MPX ATTEMTING A USER DISPATCH.
*   NOW WE MUST SWITCH THE ENVIRONMENT TO 'NO-MPX', WHICH CONSISTS OF
*   DOING THE FOLLOWING:
*
*   1.  ESTABLISH 'NO-MPX' MAPS & PSD
*   2.  BIASING TSA ADDRESSES
*   3.  BIASING USER REGISTERS AND DATA STRUCTURES (IF SVC TYPE 1 OR 2)
*   4.  ESTABLISHING ORIGINAL T.DBHAT, IF DISPATCH IS TO TASK DEBUGGER
*
*  SET THE CURRENT SOFTWARE INTERRUPT LEVEL IN ATI
*
         TBM       NO.AE,EVNT.PTR  DOES USER WANT NO A.E. TRAPS
         BNS       $+2W            SKIP NEXT INSTR IF NO
         ZBR       R6,7            CLEAR AE BIT IN PSD WD 1
         STD       R6,TSK.RPSD,X1  SAVE RETURN PSD
         STW       R2,TSK.REGP,X1  SAVE REG POINTER
         SEA                       INSURE EXTENDED ADDRESSING SET!
         TRR       R1,R2           CONTEXT ADDRESS WILL BE IN R2 FOREVER
         TRR       R0,R3           RESTORE DQE ADDRESS
         ZR        R1
         LB        R0,DQE.ATI,X3   FETCH CURRENT INTERRUPT LEVEL
         BZ        LVL.SET         BRANCH IF LEVEL 0
         TBR       R0,29           MESSAGE LEVEL?
         BNS       $+2W
         LI        R1,1W
         TBR       R0,28           I/O END-ACTION?
         BNS       $+2W
         LI        R1,2W
         TBR       R0,27           BREAK?
         BNS       $+2W
         LI        R1,3W
         TBR       R0,26           DEBUG?
         BNS       $+2W
         LI        R1,4W
         TBR       R0,25           END-ACTION PRIORITY 1?
         BNS       $+2W
         LI        R1,5W
*
*  SET CURRENT TASK INTERRUPT LEVEL IN CONTEXT AREA
*
LVL.SET  STB       R1,TSK.ATI,X2   SAVE IN DQE CONTEXT
*
*  NOW ADJUST NEW PSD (FOR 'NO-MPX' ENVIRONMENT) BY TSK.BIAS
*
         LA        R4,TSK.LVL0,X2  GET BASE LEVEL ADDR
         ADR       R4,R1           ADJUST TO CURRENT LEVEL
         LB        R4,TSK.NORM,X2  GET OVERRUN MAPS
         SRC       R4,8            PUT IN UPPER BYTE            *214*
         ORR       R4,R1           MERGE WITH LVL POINTER
         STW       R1,TSK.LVLP,X2  SAVE IN CONTEXT AREA
         IFF       C.MPXOUT,MO                                  *237*
         SUMW      R6,TSK.BIAS,X2  R6 = NEW NOMPX MAPPED ENTRY POINT
         STW       R6,TSK.RPSD,X2  SAVE TXPM ADDR
MO       ANOP                                                   *237*
*
*  IF WE ARE RETURNING FROM AN SVC, THEN REGISTERS/DATA STRUCTURES
*  MUST BE BIASED.
*
         ZBM       TSK.SVC,TSK.LVL,X1       RETURNING FROM AN SVC?
         IFF       C.MPXOUT,MO                                  *237*
         BNS       NSVC.RET        BRANCH IF NOT
*
*---------------------------------------------------------------------
*
*  !  H E R E  W E  A R E  R E T U R N I N G  F R O M  A N  S V C !
*
*  FETCH SVC NUMBER, BIAS DIFFERENCE, AND BRANCH TO APPROPRIATE
*  ROUTINE TO UNBIAS THE REGISTERS/DATA STRUCTURES
*
         LB        R1,TSK.SVCT,X1  FETCH SVC TYPE
         LW        R3,TSK.LVLP,X2  GET CURRENT LEVEL POINTER
         LW        R4,ADR.MASK     FETCH 20-BIT ADDRESS MASK
         LNW       R5,TSK.BIAS,X2  FETCH BIAS DIFFERENCE (NEG TO RE-BIAS
         ZR        R7              I/O SVC INDICATOR
         ZBM       TSK.SVC1,TSK.SVCI,X3  IS IT A TYPE 1?        *219*
         BNS       SVC.M2.0        NOPE, IT MUST BE A TYPE 2
*
*---------------------------------------------------------------------
*
*  HERE, SVC IS TYPE 1
*
SVC.M1.0 CAMH      R1,C.SVTN       SVC > MAX SVC 1 NUMBER
         BGT       NSVC.RET        BRANCH IF SVC IS > MAXIMUM
         ADMW      R1,SVC1OUT      ADD TABLE START ADDRESS NUM
         BU        SVC.MG          MERGE WITH SVC PROCESSING    *219*
*
SVC.M2.0 ZBM       TSK.SVC2,TSK.SVCI,X3  IS IT A TYPE 2?        *219*
         BNS       SVC.M6.0        NOPE, IT MUST BE A TYPE 6    *219*
*
*---------------------------------------------------------------------
*
*  HERE, SVC IS TYPE 2
*
         IFT       OS.15E,DO.15E                                    !247
         CAMH      R1,C.SVTN       SVC > MAX SVC 1 NUMBER           !247
         BGT       NSVC.RET        BRANCH IF SVC IS > MAXIMUM       !247
         ADMW      R1,SVC1OUT      ADD TABLE START ADDRESS NUM      !247
DO.15E   ANOP                                                       !247
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,C.SVTN2      IS SVC > MAX SVC 2 NUMBER
         BGT       NSVC.RET        BRANCH IF SVC IS > MAXIMUM
         ADMW      R1,SVC2OUT      ADD STARTING TABLE ADDRESS
OS15E    ANOP                                                   *238*
*
*  SVC PROCESSING MERGE POINT                                   *219*
*
SVC.MG   LB        R1,0B,X1        GET BIAS ROUTINE NUMBER
         SLL       R1,2            MAKE WORD OFFSET
         ADMW      R1,VTBLA        ADD STARTING VECT TBL ADDR
         LW        R1,0W,X1        GET ADDRESS OF SVC ROUTINE
SVC.MGC  STW       R1,TSK.RET,X2   SAVE ADDRESS TO DISPATCH TO      !273
RSXF.1   LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER       !268
*  The above instruction will be replaced by a BL RSX_FIX on 'Hawks !268
         BL        *TSK.RET,X2     DISPATCH TO SVC BIAS ROUTINES
         BU        NSVC.RET        CONTINUE PROCESSING          *219*
* ----------------------------------------------------------------- !268
*  This routine is here solely as an attempt to fix a problem with  !268
*  the RSX cpu.  It can't handle the code sequence:                 !268
*        STW       R1,TSK.RET,X2   SAVE ADDRESS TO DISPATCH TO      !268
*        LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER       !268
*        BL        *TSK.RET,X2     DISPATCH TO SVC BIAS ROUTINES    !268
*  all the time.  It seems as if TSK.RET hasn't been updated with   !268
*  the contents of R1 by the time the cpu attempts the BL indirect  !268
*  through it.  So now we break the sequence by branching here      !268
*  and diddling for a few instructions, then returning.             !268
RSX_FIX  LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER       !268
         TRSW      R0                                               !268
* ----------------------------------------------------------------- !268
*
SVC.M6.0 ZBM       TSK.SVCL,TSK.SVCI,X3 M.CALL?                     !273
         BNS       SVC.M6.1        Go if no                         !273
         LA        R7,CLU.TBL      Unbias routines                  !273
         BL        MCL.DSPA        Get bias routine address         !273
         BU        SVC.MGC         Merge for M.CALL                 !273
SVC.M6.1 ZBM       TSK.SVC6,TSK.SVCI,X3  IS IT A TYPE 6?        *219*
         BNS       SVC.M7.0        NOPE, IT MUST BE A TYPE 7    *219*
*
*---------------------------------------------------------------------
*
*  HERE, SVC IS TYPE 6                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTN6     IS SVC > MAX SVC 6 NUMBER    *219*
*257          BGT       NSVC.RET        BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       NSVC.RET        BRANCH IF SVC IS > MAXIMUM       !257
         ADMW      R1,SVC6OUT      ADD STARTING TABLE ADDRESS   *219*
         BU        SVC.MGX         MERGE WITH SVC PROCESSING    *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        NSVC.RET        IGNORE THIS TYPE             *238*
OS15E    ANOP                                                   *238*
*
SVC.M7.0 ZBM       TSK.SVC7,TSK.SVCI,X3  IS IT A TYPE 7?        *219*
         BNS       SVC.ME.0        NOPE, IT MUST BE A TYPE E    *219*
*
*---------------------------------------------------------------------
*
*  HERE, SVC IS TYPE 7                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTN7     IS SVC > MAX SVC 7 NUMBER    *219*
*257          BGT       NSVC.RET        BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       NSVC.RET        BRANCH IF SVC IS > MAXIMUM       !257
         ADMW      R1,SVC7OUT      ADD STARTING TABLE ADDRESS   *219*
         BU        SVC.MGX         MERGE WITH SVC PROCESSING    *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        NSVC.RET        IGNORE THIS TYPE             *238*
OS15E    ANOP                                                   *238*
*
SVC.ME.0 ZBM       TSK.SVCE,TSK.SVCI,X3  IS IT A TYPE E?        *219*
         BNS       NSVC.RET        NOPE, IGNORE THIS TYPE       *219*
*
*---------------------------------------------------------------------
*
*  HERE, SVC IS TYPE E                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTNE     IS SVC > MAX SVC E NUMBER    *219*
*257          BGT       NSVC.RET        BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       NSVC.RET        BRANCH IF SVC IS > MAXIMUM       !257
         ADMW      R1,SVCEOUT      ADD STARTING TABLE ADDRESS   *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        NSVC.RET        IGNORE THIS TYPE             *238*
OS15E    ANOP                                                   *238*
         IFF       OS.15E,OS15E                                 *238*
*
*  SVC PROCESSING MERGE POINT                                   *219*
*
SVC.MGX  LB        R1,0B,X1        GET BIAS ROUTINE NUMBER      *219*
         SLL       R1,2            MAKE WORD OFFSET             *219*
*257          ADMW      R1,XVTBLA       ADD STARTING VECT TBL ADDR   *219*
*257          LW        R1,0W,X1        GET ADDRESS OF SVC ROUTINE   *219*
         LW        R1,XVTBLA,X1    GET ADDRESS OF SVC ROUTINE       !257
         STW       R1,TSK.RET,X2   SAVE ADDRESS TO DISPATCH TO  *219*
*270          LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER   *219*
RSXF.2   LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER       !268
*  The above instruction will be replaced by a BL RSX_FIX on 'Hawks !268
         BL        *TSK.RET,X2     DISPATCH TO SVC BIAS ROUTINES*219*
*
*-------------------------------------------------------------------
*
*        RETURN IS TO 'NSVC.RET'
*
*---------------------------------------------------------------------
OS15E    ANOP                                                   *238*
MO       ANOP                                                   *237*
*
*  RESET T.DBHAT (FOR DEBUGGER) AND BIAS TSA ADDRESSES
*
**************************************
*        R2=CONTEXT AREA ADDRESS     *
**************************************
NSVC.RET LW        R3,TSK.DQE,X2   RESTORE DQE ADDRESS
         TBM       DQE.ADM,DQE.ATI,X3   IS THE DEBUGGER EXECUTING?
         BNS       NT.DBG               BRANCH IF NOT
*---------------------------------------------------------------------
*
*  THIS ROUTINE WILL BIAS THE AID SUBROUTINE CALL STACK, IF PRESENT
*
*  ON INPUT:  R2 = DQE CONTEXT AREA
*                  REGULAR MPX MAPS ARE ESTABLISHED
*                  TSA IS BIASED
*
*  ON OUTPUT: AID STACK IS BIASED
*
         IFF       C.MPXOUT,MO                                  *237*
         M.TSAD    R1              GET TSA ADDRESS              *237*
         LW        R1,T.TEND,X1    TSA ENDING ADDRESS
         SUI       R1,2W
         LW        R4,1W,X1        FETCH STACK CHECKSUM
         CAMW      R4,RAID         AID STACK PRESENT?
         BNE       BIAS.L          NO, GO FOR 'T-XPM' DISPATCH
         SBM       STK.BIAS,TSK.FLG1,X2 STACK ALREADY BIASED
         BS        BIAS.L          YES, SKIP BIASING
         LNW       R4,TSK.BIAS,X2  FETCH BIAS DIFFERENCE
         LW        R5,,X1          FETCH MPX STACK BASE
         ARMW      R4,,X1          BIAS STACK BASE
         TRR       R5,R1           STACK POINTER ADDRESS
         ARMW      R4,,X1          BIAS STACK POINTER
         ARMW      R4,STK.LPTR,X1  BIAS ORIGIN SUB STACK
         ARMW      R4,STK.END,X1   BIAS STACK ENDING ADDRESS
         ARMW      R4,STK.OEND,X1  BIAS OVERLAY ENDING ADDRESS
BIAS.L   M.TSAD    R1              FETCH TSA ADDRESS            *237*
         LW        R4,TSK.DBHT,X2  FETCH ORIGINAL HAT
         STW       R4,T.DBHAT,X1   REPLACE HAT WITH ORIGINAL
         XCR       R4,R1           MOVE HAT TO R1
         LNW       R5,TSK.BIAS,X2  COMPUTE T-XPM TSA ORIGIN
         ADR       R5,R4           R4=BIASED TSA ADDRESS
         SBR       R4,0            T-XPM $TSA IN R4 WITH BIT 0 SET
         STW       R4,2W,X1        TELL DEBUGGER THIS IS A T-XPM TASK
         ZR        R6              INDICATE TSA ADDRESSES TO BE BIASED
         BL        S.TXPM.6        BIAS TSA ADDRESSES
         BU        DBG.EXC         SKIP BIAS TSA CHECK
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         LW        R1,C.REGS       GET TSA ADDRESS              *237*
         LW        R4,TSK.DBHT,X2  FETCH ORIGINAL HAT
         STCW      R4,T.DBHAT,X1   REPLACE HAT WITH ORIGINAL    *237*
         XCR       R4,R1           MOVE HAT TO R1
         SBR       R4,0            T-XPM $TSA IN R4 WITH BIT 0 SET
         STCW      R4,2W,X1        TELL DEBUG THIS IS T-XPM     *237*
MO       ANOP                                                   *237*
*
*  NOW BIAS C.TXPM FOR 'NO-MPX' ENVIRONMENT
*
         IFT       C.MPXOUT,MO                                  *237*
NT.DBG   EQU       $                                            *237*
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
NT.DBG   LI        R6,1            DEFAULT TO TSA BEING MPX ADDRS
         TBM       USR.TSAB,TSK.FLG1,X2 DOES USER WANT TO REF. TSA?
         BNS       NT.DBG1         SKIP BIASING IF NOT
         ZR        R6              MAKE TSA ADDRESSES TXPM ADDR'S
NT.DBG1  BL        S.TXPM.6        BIAS TSA ADDRESSES
MO       ANOP                                                   *237*
*
         IFT       C.MPXOUT,MO                                  *237*
DBG.EXC  LW        R6,C.REGS       BIAS TSA ADDRESS             *237*
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
DBG.EXC  T.IPU     R6              ARE WE IN IPU
         BS        MAP.TXPM        SKIP BIAS IF TRUE
         LNW       R6,TSK.BIAS,X2  GET REBIAS VALUE
         ADMW      R6,C.REGS       BIAS TSA ADDRESS             *237*
MO       ANOP                                                   *237*
         STW       R6,C.TXPM       SET FOR H.AID
*
*  ESTABLISH 'NMPX' MAP ENVIRONMENT AND DISPATCH TO THE 'NMPX' TASK
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- MAP.TXPM (MAP OUT MPX)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- MAP.TXPM (MAP OUT MPX)
TTL.TMPX ANOP                                                       !259
*-------------------------------------------------------------------
*
*  THIS ROUTINE WILL ESTABLISH THE MAPS FOR THE CURRENT TASK IN
*  THE 'NMPX' ENVIRONMENT, AND THEN DISPATCH TO THE 'NMPX' TASK
*  ACCORDING TO THE PSD PROVIDED ON INPUT.
*
* ON INPUT:  1.  CPU = MAPPED (OR UNMAPPED)
*            2.  TSK.RPSD IN CONTEXT AREA IS RETURN PSD
*            3.  INTERRUPTS BLOCKED
*            4.  R2 = DQE CONTEXT ADDRESS FOR CURRENT TASK
* ON OUTPUT: 1.  CPU/IPU = MAPPED FOR 'NMPX' ENVIRONMENT
*            2.  MAPS ESTABLISHED FOR CURRENT TASK IN 'NMPX' ENVIRONMENT
*            3.  DISPATCH TO USER TASK ACCORDING TO PROVIDED PSD
*
         IFF       C.MPXOUT,MO                                  *237*
*        PATCH AREA USEAGE - MUST BE DOUBLE WORD BOUNDED
*
*  WORD 0          LPSDCM DSP.1      DO INITIAL DISPATCH OF O/S & TASK 1
*  WORD 1    DSP.C TRSC   R0,R1      R0=MPL ADDRESS, R1=SPAD ADDR (F3)
*                  TRSC   R4,R5      R4=NEW CPIX, R5=SPAD ADDRESS (F5)
*  WORD 2          LD     R0,SV.R01  RESTORE R0 AND R1 (IN WORDS 6&7)
*  WORD 3          LD     R4,SV.R45  RESTORE R4 AND R5 (IN WORDS 8&9)
*  WORD 4          NOP OR ZERO IN TXPM FLAG                     *242*
*  WORD 5          LPSD   DSP.2      DO FINAL DISPATCH TO USER
*                  BOUND  1D         DOUBLE WORD BOUNDED
*  WORD 6   SV.R01 DATAW  $-$        R0 SAVE AREA
*  WORD 7          DATAW  $-$        R1 SAVE AREA
*  WORD 8   SV.R45 DATAW  $-$        R4 SAVE AREA
*  WORD 9          DATAW  $-$        R5 SAVE AREA
*  WORD 10   DSP.1 DATAW  $-$        PSD WORD 1 INITIAL DISPATCH
*  WORD 11         DATAW  $-$        PSD WORD 2 INITIAL DISPATCH
*  WORD 12   DSP.2 DATAW  $-$        PSD WORD 1 FINAL DISPATCH
*  WORD 13         DATAW  $-$        PSD WORD 2 FINAL DISPATCH
*  WORD 14  TX.MPL REZ    4W         TEMP MPL
MO       ANOP                                                   *237*
*
*-------------------------------------------------------------------
*
*  NOW RESTABLISH MAP FOR CPIX = 0.
*
MAP.TXPM  TBM       TSK.TXPM,TSK.FLG1,X2  TXPM TASK
          BNS       $+2W       SKIP SETTING DISPATCH IF NOT
          SBM       DSP.TXPM,TSK.FLG2,X2  INDICATE T-XPM DISPATCH
          IFF       MPX.EVNT,SKIP
          TBM       NOT.MPX,TXPMFLGS  IS THIS A FAST INT
          BS        MAP.41          SKIP EVENT RECORDING IF YES
SKIP      ANOP
*
*  CHECK TO SEE IF EVENT RECORDING IS TURNED ON
*
         TBM       EVNT.DSP,EVNT.PTR  RECORD T-XPM DISPATCH?
         BNS       MAP.41          BRANCH IF NOT
         IFF       MPX.EVNT,EVNT
         ZBM       AID.DSP,TXPMFLGS    H.AID DISPATCH
         BS        MAP.41          IS SO, DON'T RECORD
EVNT     ANOP
*
*  SET UP FOR EVENT RECORD
*
         LD        R6,TSK.RPSD,X2  DESTINATION PSD
         ZR        R1              T-XPM DISPATCH
         BL        REC.EVNT        GO RECORD EVENT
*
*--------------------------------------------------------------------
*
*  THE NEW PSD FOR THE MAP LOAD TRANSFERS CONTROL TO THE PATCH
*  AREA, WHERE THE FIRST INSTRUCTION IS AN 'LPSD' TO
*  TRANSFER CONTROL TO THE USER.  SET TRAP/INTRPT VECTORS TO T-XPM.
*
MAP.41   EQU       $
         IFT       C.3227,SP.00
         IFF       MPX.EVNT,EVNT
*
*   CHANGE TRAP/INTERRUPT SPAD POINTERS TO 'T-XPM'
*
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R3,DSVC         ARE WE IN IPU OR TURBO MODE      !280
         BS        V.3             IF NOT USE CPU VECTOR TABLES
MO       ANOP                                                   *237*
         V.TXPM                    RESET CPU TRAP/INT VECTORS
         IFF       C.MPXOUT,MO                                  *237*
         BU        V.2             SKIP OVER IPU CODE
V.3      EQU       $               SET UP IPU VECTORS
         V.TXPMI                   RESET IPU TRAP VECTORS
V.2      EQU       $
MO       ANOP                                                   *237*
EVNT     ANOP
SP.00    ANOP
*
         IFF       C.MPXOUT,MO                                  *237*
PTCH.530 LA        R3,H.AIDPAT     PATCH AREA ADDR SET IN EP8
         BL        CK.INIT         Check initialize first time      !264
         IFT       DO.BUI,BUI.DO                                    !259
         ZBM       LW.BUI,LSWITCH  Assume we don't have a BU *      !255
         TBM       30,TSK.RPSD,X2  Is dispatch to RHW?              !255
         BNS       $+2W            Go if no                         !255
         SBM       LW.BUI,LSWITCH  Else tell everyone               !255
BUI.DO   ANOP                                                       !255
         T.IPU     R5              ARE WE IN IPU
         BNS       $+2W            IF NOT USE 1ST PATCH AREA
         ADI       R3,CODE.SIZ     IF IPU, USE 2ND PATCH AREA
         LB        R5,TSK.NMAP,X2  FETCH NUMBER OF OS MAPS
         BNZ       $+2W            SKIP IF TXPM TASK
         LB        R5,C.MSD        ELSE, USE STD O/S SIZE
         LI        R4,X'3FFC'      CPIX MASK
         LMW       R1,TSK.RPSD+1W,X2  EXTRACT CPIX
         TBM       LW.C2000,LSWITCH Seahawk?                        !252
         BNS       P5.1            Go if not                        !252
         LW        R4,*C.MPL       Save current setting             !260
         STW       R4,SV.CMPL      Save for later restoration       !260
         STW       R5,*C.MPL       New count for OS                 !252
*260          SBR       R1,0            Mapped                           !252
         SBR       R1,17           BEI                              !252
*260          STW       R1,DSP.1+1W-CODE.DSP,X3 Store as PSD2            !252
         STW       R1,MPT.HAWK+1W  PSD2                             !260
*260          ZBR       R1,0                                             !252
         ZBR       R1,17                                            !252
         ADMW      R1,C.MPL        R1 now pts to our task's MSD     !252
         LB        R5,3B,X1        We now have our count, for       !252
*                                  restoring later on               !252
         STW       R1,SV.MPL       Save for MAP.MPX to use          !252
         STB       R5,SV.CNT       Ditto                            !252
*260          SBM       LW.DOMPL,LSWITCH So MAP.MPX knows when to        !252
         ADMB      R5,TSK.NORM,X2                                   !252
         STB       R5,3B,X1        New count to our task's MSD      !252
         BU        P5.2            Skip non-Seahawk code            !252
* --------------------------------------------------
P5.1     EQU       $                                                !252
         ADMW      R1,C.MPL        FORM MPX ENTRY ADDR
         IFT       C.3227,MAP.X6
         LD        R6,0W,R1        GET TASKS CNT AND MIDL POINTER
         ADMB      R6,TSK.NORM,X2  ADD IN OVERFLOW COUNT
         STD       R6,TX.MPL-CODE.DSP+2W,X3 PUT IN TEMP MPL AS TASK !252
*                                  NUMBER 1                         !252
         STW       R5,TX.MPL-CODE.DSP,X3 REDEFINE MAP BLOCKS FOR    !252
*                                  CPIX=0                           !252
         LW        R0,=X'F30000'   SPAD ADDRESS ON CONCEPT
         LW        R5,=X'F50000'   PSD2 SPAD ADDR
         LW        R4,=X'80004008' NEW BLOCK STATE=BEI, CPIX OF 1
MAP.X6   ANOP
         IFF       C.3227,MAP.X7
         LB        R4,TSK.NORM,X2  FETCH # OF OVERRUN MAPS
         LW        R6,*0W,X1       GET MSD FOR TASK
         STW       R6,*15W,X3      PUT IN TEMP MPL AS TASK 1
         ARMB      R4,*15W,X3      ADJUST FOR T-XPM MAP LOAD
         STB       R5,*14W,X3      REDEFINE MAP BLOCKS FOR CPIX=0
         LW        R0,=X'830000'   SPAD ADDRESS ON 7X
         LW        R5,=X'900000'   PSD2 SPAD ADDR ON 7X
         LW        R4,=X'80004004' RETAIN BLOCK STATE, CPIX OF 1
MAP.X7   ANOP
         STW       R4,DSP.1-CODE.DSP+1W,X3 SET 2ND WD OF INITIAL PSD
P5.2     TBM       NO.AE,EVNT.PTR  USER WANT NO A.E. TRAPS?         !252
         BNS       $+2W            NO, HE WANTS THEM
         ZBM       7,TSK.RPSD,X2   CLEAR A.E. BIT IN PSD THEN
         LD        R6,TSK.RPSD,X2  GET RETURN PSD
         ZBR       R6,12           Ensure no F bit (LA instruction  !284
*                                  sometimes causes F bit to be set)!284
         STD       R6,DSP.2-CODE.DSP,X3 SAVE DESTINATION PSD        !252
         TRR       R3,R4           PSW FOR MAP LOAD
         SBR       R4,0            MAKE PRIVILEGED
         ADI       R4,5            LEFT HW OF 2ND INSTRUCTION
         IFT       DO.BUI,BUI.DO                                    !255
         ZBM       LW.BUI,LSWITCH  Do we have a user RHW to check?  !255
         BNS       P5.21           Go if no                         !255
         ADI       R4,DSP.BUI-DSP.C Else change initial dispatch    !255
*                                  to go to DSP.BUI                 !255
BUI.DO   ANOP                                                       !255
P5.21    STW       R4,DSP.1-CODE.DSP,X3 SAVE WD 1 OF PSD 1          !252
         LW        R1,TSK.REGP,X2  GET REG SAVE AREA ADDRESS
         LD        R6,0W,X1        GET USER REGS 0 AND 1
         STD       R6,SV.R01-CODE.DSP,X3 PUT IN PATCH AREA          !252
         LD        R6,4W,X1        GET USER REGS 4 AND 5
         STD       R6,SV.R45-CODE.DSP,X3 PUT IN PATCH AREA          !252
         TRR       R3,R6           PSW FOR MAP LOAD
         SBR       R6,31           LEFT HW BRANCH
         TRR       R3,R7           PATCH AREA ADDRESS
         ADI       R7,TX.MPL-CODE.DSP POINT TO TEMP MPL ADDRESS     !252
         TRR       R1,R3           REG SAVE ADDR TO R3
         TBM       LW.C2000,LSWITCH Seahawk?                        !252
*260          BS        P5.3            Go if so                         !252
         BNS       P5.22           Go if not                        !260
*  For a Seahawk, we take advantage of the fact that we can do      !260
*  an LPSDCM and stay unmapped!  This works ONLY on a Seahawk!      !260
         ADI       R6,DSP.LD-CODE.DSP Branch right to reg load      !260
         LPSDCM    MPT.HAWK        Load maps, stay unmapped         !260
P5.23    LW        R1,SV.CMPL                                       !260
         STW       R1,*C.MPL                                        !260
         LW        R1,SV.MPL       Replace user's MPL               !260
         LB        R7,SV.CNT                                        !260
         STB       R7,3B,X1        Restore it                       !260
         BU        P5.3            Skip non-Seahawk stuff           !260
* --------------------------------------------------                !260
P5.22    TRR       R0,R1           SPAD ADDRESS TO R1               !260
         LW        R0,C.MPL        MPL ADDRESS TO R0
         LI        R4,X'3FFC'      CPIX MASK
         LMW       R4,TSK.RPSD+1W,X2  EXTRACT CPIX
         IFT       C.3227,SP.01
         SBR       R4,16           SET PRIV BIT (SPAD FORMAT 2X)
SP.01    ANOP
         IFF       C.3227,SP.02
         SBR       R4,0            SET PRIV BIT (SPAD FORMAT 7X)
SP.02    ANOP
         TRSC      R7,R1           LOAD TEMP MPL INTO SPAD
*260 P5.3     T.IPU     R7                   ARE WE IN IPU               !252
         T.IPU     R7                   ARE WE IN IPU               !260
         BS        MAP.X8          BR IF YES
P5.3     STH       R6,MPX.CP0+1H   STUFF IN ADDRESS OF BRANCH INSTR !260
         LD        R6,6W,X3        LOAD REGS 6-7
         LD        R2,2W,X3        LOAD REGS 2-3
         SBM       NOT.MPX,TXPMFLGS  SET MPX NOT LOADED FLAG
*
*        AT THIS POINT R0,R1 AND R4,R5 ARE IN USE for non-Seahawk   !252
*        None are in use for Seahawk, but they still have to be     !260
*        loaded                                                     !260
*        R0=MPX MPL ADDRESS
*        R1=SPAD ADDRESS FOR MPL (F3 OR 83)
*        R4=PSD2 OF NEW TASK IN SPAD FORMAT TO RESET CPIX
*        R5=SPAD ADDRESS OF PSD2 (F5 OR 85?)
*
MPX.CP0  BU        $-$             ESTABLISH OS MAPS AND GO TO PATCH
*
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         TBM       NO.AE,EVNT.PTR  USER WANT NO A.E. TRAPS?     *237*
         BNS       $+2W            NO, HE WANTS THEM            *237*
         ZBM       7,TSK.RPSD,X2   CLEAR A.E. BIT IN PSD THEN   *237*
         LI        R4,X'3FFC'      CPIX MASK                    *237*
         LMW       R1,TSK.RPSD+1W,X2  EXTRACT CPIX              *237*
         LW        R5,=X'00004000' NEW BLOCK STATE=BEI          *237*
         ORR       R1,R5           PUT CPIX IN PSD2             *237*
         STW       R5,NEWMAP+1W    SET PSD2 FOR REMAP           *237*
         ADMW      R1,C.MPL        FORM MPL ENTRY ADDR          *237*
         LB        R4,TSK.NMAP,X2  FETCH NUMBER OF OS MAPS      *237*
         LW        R6,0W,R1        GET TSK CNT & BORROW BIT     *237*
         SBM       0,0W,X1         SET BORROW BIT               *237*
         LW        R3,C.MPL        GET MPX MPL ADDRESS          *237*
         LW        R7,0W,X3        GET O/S CNT & RET BIT        *237*
         STW       R5,0W,X3        SET NEW O/S SIZE W/O RET BIT *237*
         LPSDCM    NEWMAP          SET NEW USER MAPS            *237*
         BOUND     1D                                           *237*
NEWMAP   GEN       8/X'84',24/NEWMAP0                           *237*
         DATAW     $-$                                          *237*
NEWMAP0  STW       R6,0W,X1        RESET USER MPL ENTRY         *237*
         STW       R7,0W,X3        RESET O/S MPL ENTRY          *237*
         LD        R6,TSK.RPSD,X2  GET RETURN PSD               *237*
         STD       R6,MPX.CP0      SAVE DESTINATION PSD         *237*
         LW        R1,TSK.REGP,X2  GET REG SAVE AREA ADDRESS    *237*
         SBM       NOT.MPX,TXPMFLGS  SET MPX NOT LOADED FLAG    *237*
         LF        R0,0W,X1        RESTORE USER REGS            *237*
         LPSD      MPX.CP0         DISPATCH TO USER             *237*
MPX.CP0  DATAD     $-$             PSD GOING TO USER            *237*
*                                                               *237*
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
MAP.X8   STH       R6,MPX.CP0I+1H  STUFF IN ADDRESS OF BRANCH INSTR
         LD        R6,6W,X3        LOAD REGS 6-7
         LD        R2,2W,X3        LOAD REGS 2-3
         IFT       OS.32X,IF.03                                 *242*
         IFT       OS.36,O36                                    !295
         ZBM       C.IPUCSI,C.IPUFLG TELL CPU OK TO SIPU        !295
O36      ANOP                                                   !295
         IFF       OS.36,O36                                    !295
         ZBM       C.ICSIPU,C.BIT  TELL CPU OK TO SIPU          *242*
O36      ANOP                                                   !295
IF.03    ANOP                                                   *242*
         IFF       OS.32X,IF.04                                 *242*
         ZBM       IPU.GATE,EXEC.FLG  TELL CPU OK TO SIPU       *242*
IF.04    ANOP                                                   *242*
*242*    ZBM       IN.TXPM,TXPMFLGS  CLEAR IN TXPM FLAG         *242*
MPX.CP0I BU        $-$             ESTABLISH OS MAPS AND GO TO PATCH
MO       ANOP                                                   *237*
*
*  ! THERE SHOULD BE NO RETURN !
*
*--------------------------------------------------------------------
*
         BOUND     1F
TXPMREGS RES       1F              TXPM.LVP REG SAVE AREA
CPUREGS  RES       1F              USER REGISTER SAVE AREA
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TMPX ANOP                                                       !259
*
*--------------------------------------------------------------------
*
*  CURRENT STATE IS:
*
*    1.  CPU UNMAPPED
*    2.  INTERRUPTS BLOCKED
*    3.  TRAP/INTERRUPT ACTIVE
*    4.  R1 = TRAP/INTERRUPT NUMBER.
*    5.  R0 = CONTEXT ADDRESS + TRAP.LEN AND CC'S IF NEEDED
*
*  IF INTERRUPT, BUMP GLOBAL INTERRUPT COUNT
S.TRV.32 ABM       31,C.GINT
*
*  FIND TRAP/INTERRUPT CONTEXT BLOCK
S.TRV.35 EQU       $
FIRE     TRR       R1,R7           SAVE TRAP/INTERRUPT NUMBER
         TRR       R0,R3           GET TRAP/INT CONTEXT ADDRESS
         IFT       C.3227,FIRE.2X
         IFF       MPX.EVNT,EVNT
         LW        R1,PSD.OTMP,X3  FETCH ADDRESS OF OLD PSD
EVNT     ANOP
         IFT       MPX.EVNT,EVNT
         LW        R1,PSD.OMPX,X3  FETCH ADDRESS OF OLD PSD
EVNT     ANOP
FIRE.2X  ANOP
         IFF       C.3227,FIRE.7X
         LW        R1,PSD.OMPX,X3  FETCH ADDRESS OF OLD PSD
FIRE.7X  ANOP
*
         IFT       DO.BUI,BUI.DO                                    !259
         TBM       30,,X1          RHW instruction?                 !259
         BNS       $+2W            Go if not                        !259
         ABM       31,RHW.CPU      Else count it                    !259
BUI.DO   ANOP
         LI        R4,X'3FFC'      MASK FOR CPIX
         TRR       R1,R6           SAVE OLD PSD ADDRESS
         LMW       R1,1W,X1        GET TRAPPING PSD CPIX
         BNZ       G2.DQE0         BR IF WE HAVE A CPIX
CPIX.0   LA        R1,DQE0         USE DQE 0 FOR ZERO CPIX          !248
         BU        G3.DQE0         SKIP OTHER CODE
         IFF       C.3227,SHZ.5    ADJUST CPIX TO DQE INDEX
G2.DQE0  SRL       R1,2            THIS IS 7X BPIX SHIFT
SHZ.5    ANOP
         IFT       C.3227,SHZ.6    ADJUST CPIX TO DQE INDEX
G2.DQE0  SRL       R1,3            THIS IS CONCEPT BPIX SHIFT
SHZ.6    ANOP
         SLL       R1,2            WORD ADJUST PROG NUM
         ADMW      R1,C.ADAT       DQE ADDRESS TABLE
         LW        R1,0W,X1        GET DQE ADDR
         IFF       C.MPXOUT,MO                                  *237*
*  We check to see if the current task is still thought by MPX      !275
*  to be in the IPU.  This should happen only for some customers    !275
*  who have their own special cpu/ipu schedulers.  If this          !275
*  happens, then we use the DQE for task 1.                         !275
G3.DQE0  LW        R4,=X'FFFFF'    MASK OUT JUNK FOR COMPARE
         CMMW      R1,C.CIPU       TASK NOW IN IPU
         BNE       FIRE.2Z         BR IF NOT
*275          LW        R2,DQE.TCXT     DEFAULT TO TASK 1'S CONTEXT
*275          ADI       R2,DQE.LCXT     BASE + LENGTH = SWAPPERS CXT
         LW        R1,C.ADAT       DQE ADDRESS TABLE
         LW        R1,1W,R1        DQE 1'S ADDRESS
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
G3.DQE0  EQU       $                                            *237*
MO       ANOP                                                   *237*
FIRE.2Z  LW        R2,DQE.PSSF,X1  GET CONTEXT ADDRESS
         BNZ       FIRE.1Z         GO ON IF CONTEXT ADDR SET
         ZR        R4              CLEAR
         LB        R5,DQE.NUM,X1   FETCH DQE NUMBER
         MPI       R4,DQE.LCXT     FORM DQE CONTEXT AREA INDEX
         ADMW      R5,C.CTXT       ADD IN CONTEXT ORIGIN
         STW       R5,DQE.PSSF,X1  SET CONTEXT ADDR IN DQE
         TRR       R5,R2           SAVE CONTEXT ADDRESS
FIRE.1Z  STW       R1,TSK.DQE,X2   SAVE DQE ADDRESS
         XCR       R6,R1           RESTORE OLD PSD ADDRESS
         CI        R7,15           SVC 9?
         BNE       NOT.PRIV        BR IF NOT
         LW        R5,4W,X1        GET SVC CALL NUM, IF ANY
         CI        R5,X'99'        SVC 9,99
         BNE       NOT.PRIV        NOT SPECIAL GET PRIV'D ROUTN
*
         IFT       MPX.EVNT,XXX
         XCR       R6,R1           R6=ICB ADDR, R1=DQE ADDR
         STW       R6,DQE.PSSB,X1  SAVE ICB ADDR IN DQE
         XCR       R6,R1           R6=DQE ADDR, R1=ICB ADDR
XXX      ANOP
         LD        R6,0W,R1        GET RETURN PSD
         SBR       R6,0            SET PRIVED IN OLD PSD
         ZBR       R7,16           CLEAR LOAD NEW BLOCK STATE
         SBR       R7,17           SET BLOCKED
         ZBR       R7,0            SET UNMAPPED
         ZBM       DSP.TXPM,TSK.FLG2,X2  NOT TXPM DISPATCH ANYMORE
         ZBM       USR.TSAB,TSK.FLG1,X2  CLEAR TSA BIASING BIT
*237*    IFF       MPX.EVNT,EVNT                                   *207*
*237*    BU        GO.BACK         JUST REDISPATCH TO USER         *207*
*237*  EVNT     ANOP                                               *207*
*237*    IFT       MPX.EVNT,DOCODE                                 *207*
*237* THE FOLLOWING CODE DOWN TO GO.BACK WAS NOT IN TXPM BUT
*237* WAS IN TMPX.  SIMSTAR WORKED WITH TMPX, BUT NOT TXPM???
         ZBM       NOT.MPX,TXPMFLGS  RETURN FROM SPCL INT
         BNS       GO.BACK         MPX LOADED, SO RETURN
         STD       R6,TSK.RPSD,X2  SAVE RETURN PSD IN CONTEXT AREA
         IFT       C.3227,SP.03
         IFF       MPX.EVNT,EVNT
*  RESET BASE SPAD POINTER FOR TRAP & INTERRUPT VECTORS
         V.MPX                     SET SPAD VECTORS TO MPX (CONCEPT
EVNT     ANOP
SP.03    ANOP
         BL        MAP.MPX         GO MAP IN MPX
         IFF       C.MPXOUT,MO                                  *237*
         LI        R6,1            UNBIAS TSA
         BL        S.TXPM.6        UNBIAS TSA ADDRESSES
MO       ANOP                                                   *237*
*237*    ZBM       DSP.TXPM,TSK.FLG2,X2  CLEAR TXPM DISP FLAG
         LW        R3,TSK.DQE,X2   GET DQE ADDRESS
         TBM       DQE.ADM,DQE.ATI,X3  IS DEBUGGER XEQING?
         BNS       TST.RET2        BR IF NOT
         LA        R6,DBHAT        GET OUR HAT ADDRESS
         IFF       C.MPXOUT,MO                                  *237*
         M.TSAD    R3              GET TSA ADDRESS              *237*
         STW       R6,T.DBHAT,X3   PUT IN TSA
         BL        SVC1.50         BIAS AID STACK FOR MPX ENV
TST.RET2 M.TSAD    R3              GET TSA ADDRESS              *237*
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         LW        R3,C.REGS       GET TSA ADDRESS              *237*
         STCW      R6,T.DBHAT,X3   PUT IN TSA                   *237*
TST.RET2 LW        R3,C.REGS       GET TSA ADDRESS              *237*
MO       ANOP                                                   *237*
         STW       R3,C.TXPM       UPDATE TSA ADDRESS FOR H.AID
         LD        R6,TSK.RPSD,X2  GET RETURN PSD FROM CONTEXT AREA
*
         IFT       MPX.EVNT,XXX
GO.BACK  LI        R4,2            SHOW SVC TYPE
         LW        R3,TSK.DQE,X2   GET DQE ADDRESS
         LW        R1,DQE.PSSB,X3  GET ICB ADDR FROM DQE
         LI        R0,15           SET SVC 9 TYPE
         BU        REC.IT          GO RECORD IT
XXX      ANOP
*237* DOCODE   ANOP                                             *207*
         IFF       MPX.EVNT,XXX
GO.BACK  STD       R6,PSDR.CPU     SET FOR LPSD
         LF        R0,CPUREGS      RESTORE USERS REGS
         LPSD      PSDR.CPU        RETURN PRIV'D, BLOCKED
XXX      ANOP
         BOUND     1W
         IFF       C.3227,7X.1
*
*  CHECK IF T-XPM TASK DISPATCH WAS INTERRUPTED.  IF IT WAS NOT, THEN
*  THIS IS A 32/7X AND MPX WAS INTERRUPTED (H.TXPM HANDLES ---ALL---
*  TRAPS/INTERRUPTS FOR 32/7X
*
NOT.PRIV TBM       DSP.TXPM,TSK.FLG2,X2 T-XPM DISPATCH ?
         BNS       FIRE.0           NO, RETURN TO MPX
7X.1     ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
NOT.PRIV TBM       DSP.TXPM,TSK.FLG2,X2 T-XPM DISPATCH ?
         BNS       FIRE.0           NO, RETURN TO MPX
EVNT     ANOP
         IFT       C.3227,GO.2X
         IFF       MPX.EVNT,GO.2X
*
*    THE FOLLOWING CODE TESTS FOR A NEW ICB BEING CONNECTED TO
*    AN INTERRUPT.  THIS IS TRUE FOR SPUR INT (EP3) ENTRY AND
*    SI INT (EP1) ENTRY FOR NON CLASS F INTERRUPTS.
*    THE INT CONTEXT AREA IS UPDATED WITH THE NEW ICB INFORMATION.
*    THE CLOCK HANDLER IS SPECIAL CASED AND IGNORED
*
NOT.PRIV CI        R7,31           IS THIS AN INTERRUPT
         BLE       GO.ON.I         BR IF NOT
         TBM       ICXT.CLD,ICXT.FLG,X3  IS THIS D CLASS INT
         BNS       GO.ON.I         BR IF NOT
         LB        R1,ICXT.FLG+1B,X3  GET INTERRUPT LEVEL
         SLL       R1,2            WORD ADJUST LEVEL NUMBER
         ADMW      R1,MPX.INT      ADD IN BASE ADDRESS
         LW        R1,0W,X1        GET ICB ADDRESS
         ZBR       R1,31           CLEAR H/W BIT
         CAMW      R1,PSD.OMPX,X3  IS THIS THE ICB CONNECTED
         BEQ       GO.ON.I         BR IF IT IS
         CAMW      R1,A.TRV.13     IS THIS OUR ICB IN ACCEL
         BEQ       GO.ON.I         IGNORE IF YES
         LW        R5,2W,X1        GET NEW PSD WD 1
         ADI       R5,1W           BUMP PAST ABM 31,C.GINT INSTR
         STW       R5,PSD.RET1,X3  STO IN INT CONTEXT AREA
         LW        R5,3W,X1        GET NEW PSD WORD 2
         ANMW      R5,=X'8001C000' ONLY BITS ALLOWED
         STW       R5,PSD.WRD2,X3  SAVE NEW PSD WD 2
         STW       R1,PSD.OMPX,X3  SAVE NEW MPX ICB ADDRESS
GO.ON.I  EQU       $               MERGE CODE
GO.2X    ANOP
         TBM       ICXT.SPL,ICXT.FLG,X3  SPECIAL INT?
         BNS       FIRE.0          BR IF NOT
         IFT       C.3227,FIRE.2X
         IFF       MPX.EVNT,EVNT
         LW        R1,PSD.OTMP,X3  FETCH ADDRESS OF OLD PSD
EVNT     ANOP
         IFT       MPX.EVNT,EVNT
         LW        R1,PSD.OMPX,X3  FETCH ADDRESS OF OLD PSD
EVNT     ANOP
FIRE.2X  ANOP
         IFF       C.3227,FIRE.7X
         LW        R1,PSD.OMPX,X3  FETCH ADDRESS OF OLD PSD
FIRE.7X  ANOP
         LW        R5,1W,X1        FETCH CPIX FROM OLD PSD WORD 2
         ANMW      R5,=X'3FFC'     CPIX MASK
         LW        R6,PSD.WRD2,X3  FETCH PSD WORD 2
         ORR       R5,R6           MERGE WITH NEW PSD WORD 2
         SBR       R6,15           INSURE WE DON'T LOSE ESTAB MAPS
         ZBR       R6,16           RETAIN OLD BLOCK STATE?
         ZBR       R6,0            SPECL INTS MUST BE UNMAPPED
         BNS       ST.SETX         BRANCH IF NOT
         TBM       17,1W,X1        WAS OLD PSD BLOCKED?
         BNS       ST.SETX         BRANCH IF NOT
         SBR       R6,17           NEW BLOCK STATE IS BEI
ST.SETX  EQU       $               NEW PSD BLOCKING STATE SET PROPE
         STW       R6,TSK.RPSD+1W,X2  STUFF AS WORD 2 OF NEW PSD
*
*  SET NEW PSD WORD 1
*
         LW        R6,PSD.RET1,X3  FETCH RETURN PSD WORD 1
         ANMW      R0,=X'F8000000' ISOLATE CC'S                 *214*
         ORR       R0,R6           MERGE WITH CONDITION CODES
         STW       R6,TSK.RPSD,X2  STUFF AS FINAL NEW PSD
*
*  THE PSD TO RETURN TO MPX IS NOW SET UP IN 'PSD.RET'.  SET UP
*  R1 TO POINT TO THE OLD FAULTING PSD.
*
         LW        R5,PSD.OMPX,X3  FETCH OLD PSD ADDRESS (KEEP IN R
         LW        R1,PSD.OTMP,X3  FETCH OLD T-XPM PSD ADDRESS
         IFF       C.3227,7X.1
         TRR       R5,R1            OLD PSD ALWAYS IN MPX TCB/ICB
7X.1     ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         TRR       R5,R1           OLD PSD IN MPX TCB/ICB
         TRR       R7,R0           SAVE INT NUMBER
EVNT     ANOP
*
*  COPY ICB/TCB FROM H.TXPM TO THE ORIGINAL MPX ICB/TCB. WE DO THIS
*  ONLY FOR A CONCEPT MACHINES, SINCE ON A 7X ALL INTERRUPTS/TRAPS
*  FIRE IN THEIR ORIGINAL MPX ICB/TCB'S.
*
         IFT       C.3227,CHK.X
         IFF       MPX.EVNT,EVNT
         STW       R7,TSK.RET,X2   SAVE INT NUM
         LD        R6,0W,X1        FETCH OLD T-XPM PSD
         LW        R0,4W,X1        FETCH ICB + 4W
         LW        R4,5W,X1        FETCH ICB + 5W
         TRR       R5,R1           ADDRESS OF OLD MPX PSD
         STD       R6,0W,X1        INSERT OLD PSD INTO MPX HANDLER
         TBM       ICXT.CLD,ICXT.FLG,X3      IS THIS NON CLASS F IN
         BS        CHK.5Z          DON'T COPY ICB WORDS 4 AND 5
         TBM       ICXT.CLF,ICXT.FLG,X3  IS THIS CLASS F OR AN INT.
*                                        FOR WHICH THERE IS NO CDT
         BS        CHK.48Z         DON'T COPY ICB WORD 4
         STW       R0,4W,X1        UPDATE ICB + 4W
CHK.48Z  STW       R4,5W,X1        UPDATE ICB + 5W
CHK.5Z   EQU       $
         LW        R0,TSK.RET,X2   RESTORE INT NUMBER
EVNT     ANOP
CHK.X    ANOP
         IFF       C.MPXOUT,MO                                  *237*
         TBM       0,1W,X1         IS RETURN PSD UNMAPPED
         BNS       NT.AID.Z        SKIP BIASING IF UNMAPPED
         LW        R6,TSK.BIAS,X2  GET TASK BIAS
         LW        R7,0W,X1        GET INTERRUPTED ADDRESS
         ANMW      R7,=X'FFFFF'    CLEAR JUNK                   *214*
         ADMW      R7,TSK.BIAS,X2  BIAS ADDRESS FOR TSA TEST
         CAMW      R7,C.TSAD       IS ADDRESS IN O/S
         BLE       NT.AID.Z        DO NOT BIAS IF IT IS
         ARMW      R6,0W,X1        BIAS OLD PSD IN MPX HANDLER
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         ANMW      R7,=X'FFFFFF'   CLEAR JUNK                   *237*
         ADMW      R7,TSK.BIAS,X2  BIAS ADDRESS FOR TSA TEST    *237*
         CAMW      R7,C.LOSEND     IS ADDRESS IN O/S            *237*
MO       ANOP                                                   *237*
NT.AID.Z LD        R6,TSK.RPSD,X2  GET RETURN PSD
         SBM       NOT.MPX,TXPMFLGS  SET MPX NOT LOADED FLAG
         IFT       MPX.EVNT,XXXX
         LI        R4,3            TXPM INT
REC.IT   EQU       $
         LW        R3,TSK.DQE,X2   RESTORE DQE ADDRESS
         STB       R0,DQE.PSSB+5B,X3  SAVE TRAP/INT NUM
         STW       R1,DQE.PSSB,X3  SAVE ICB ADDRESS
         LW        R1,DQE.PSSF,X3  GET CONTEXT ADDR
         TBM       TSK.TXPM,TSK.FLG1,X1  TXPM TASK?
         BS        $+2W            BR IF IT IS
         ADI       R4,8            MUST BE MPX THEN
         LA        R2,CPUREGS      REG SAVE AREA ADDR
         CI        R0,32           31 TRAPS
         BLT       REC.XX          BR IF TRAP
         TBM       EVNT.INT,EVNT.PTR  RECORD INTS
         BNS       REC.OUT         BR IF NOT
         BU        REC.REC         GO LOG IT
REC.XX   TBM       EVNT.TRP,EVNT.PTR  RECORD TRAPS
         BNS       REC.OUT         BR IF NOT
REC.REC  BL        LOGGER          GO LOG IT
REC.OUT  EQU       $
XXXX     ANOP
         STD       R6,PSDR.CPU     SAVE RETURN PSD
         LF        R0,CPUREGS      LOAD USERS REGISTERS
         LPSD      PSDR.CPU        NOW, GO TO HANDLER STILL TXPM
*
FIRE.0   LA        R6,CPUREGS      WHERE USER REGS ARE
         STW       R6,TSK.REGP,X2  SAVE IN CONTEXT AREA
         LW        R1,TSK.DQE,X2   RESTORE DQE ADDRESS
************************************************************************
*        AT THIS POINT IPU AND CPU CODE MERGES
*        R1=DQE ADDRESS (C.CURR OR C.CIPU)
*        R2=TXPM DQE CONTEXT ADDRESS
*        R3=TRAP/INTERRUPT CONTEXT BLOCK ADDRESS
*        R0=CC'S IN NORMAL PLACE
*        R7=TRAP/INTERRUPT NUMBER
*        TSK.IPU=SET/RESET TO INDICATE IPU/CPU DISPATCH
*        TSK.REGP=POINTER TO REGISTER STACK
************************************************************************
*
*  SET UP RETURN PSD TO VECTOR TO INTERRUPT CONTEXT BLOCK
*
MERGE.TI EQU       $               MERGE POINT FOR IPU/CPU TRAPS
         IFT       C.3227,FIRE.2X
         IFF       MPX.EVNT,EVNT
         LW        R4,PSD.OTMP,X3  FETCH ADDRESS OF OLD PSD
EVNT     ANOP
         IFT       MPX.EVNT,EVNT
         LW        R4,PSD.OMPX,X3  FETCH ADDRESS OF OLD PSD
EVNT     ANOP
FIRE.2X  ANOP
         IFF       C.3227,FIRE.7X
         LW        R4,PSD.OMPX,X3  FETCH ADDRESS OF OLD PSD
FIRE.7X  ANOP
         STW       R4,TSK.RET,X2   SAVE TRAPPING PSD ADDR IN DQE
         XCR       R4,R1           PUT ADDRESS IN CORRECT REG
         IFF       C.MPXOUT,MO                                  *237*
         CI        R7,4            IS THIS UNDEFINED INSTRUCTION TRAP
         BEQ       S.TXPM.B        PROCESS IT FOR TXPM TASK
MO       ANOP                                                   *237*
         CI        R7,254          IS THIS UNDEFINED INT/TRAP
         BGE       S.TXPM.C        GO PROCESS SPURIOUS INT
         CI        R7,7            SVC 1
         BNE       ST.MRG          BR IF NOT
         LW        R5,4W,X1        GET SVC CALL NUMBER
         CI        R5,X'03'        SVC 1,3
         BNE       ST.MRG          NOT SPEC STOP BIASING SVC
         LD        R6,0W,X1        GET RETURN PSD
         STD       R6,TSK.RPSD,X2  SAVE RETURN PSD
         ZBR       R6,1            C.CSWI SET ON ENTRY          *232*
         BS        $+2W            BR IF YES                    *232*
         ZBM       C.CSWI,C.BIT    CLEAR IT FOR RETURN          *232*
         ZBM       USR.TSAB,TSK.FLG1,X2  STOP TSA BIASING
         TBM       TSK.TSAB,TSK.FLG1,X2  IS TSA BIASED
         IFF       MPX.EVNT,XXX
         IFF       C.MPXOUT,MO                                  *237*
         BNS       MAP.41          BR IF ALLREADY BIASED
         BL        MAP.MPX         MAP IN MPX FOR TSA REBIAS
         LI        R6,1            BIAS FOR MPX ENVIRONMENT
         BL        S.TXPM.6        GO UNBIASED TSA ADDRESSES
MO       ANOP                                                   *237*
         BU        MAP.41          GO REMAP TO TXPM ENVIRONMENT
XXX      ANOP
         IFT       MPX.EVNT,XXX
         IFF       C.MPXOUT,MO                                  *237*
         BNS       MAP.TXPM        BR IF ALLREADY BIASED
         BL        MAP.MPX         MAP IN MPX FOR TSA REBIAS
         LI        R6,1            BIAS FOR MPX ENVIRONMENT
         BL        S.TXPM.6        GO UNBIASED TSA ADDRESSES
MO       ANOP                                                   *237*
         BU        MAP.TXPM        GO REMAP TO TXPM ENVIRONMENT
XXX      ANOP
**
*  NOW BUILD PSD THAT WE WILL USE TO TRANSFER TO MPX
*
*        R1 NOW HAS OLD PSD ADDRESS IN IT, R4=DQE ADDRESS
ST.MRG   EQU       $
         IFT       C.3227,SP.01
         IFF       MPX.EVNT,EVNT
         TRR       R1,R5           SAVE R5
         TRR       R4,R6           SAVE DQE ADDRESS
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R1                   IPU TASK
         BS        V.01            BR IF YES
MO       ANOP                                                   *237*
         V.MPX                     SET SPAD VECTORS TO MPX (CONCEPT)
         IFF       C.MPXOUT,MO                                  *237*
         BU        V.11            CONTINUE
V.01     V.MPXI                    RESET TRAPS ONLY ON IPU
MO       ANOP                                                   *237*
V.11     TRR       R5,R1           RESTORE R1
         TRR       R6,R4           RESTORE DQE ADDRESS
EVNT     ANOP
SP.01    ANOP
         LW        R5,1W,X1        FETCH CPIX FROM OLD PSD WORD 2
         ANMW      R5,=X'3FFC'     CPIX MASK
         LW        R6,PSD.WRD2,X3  FETCH PSD WORD 2
         ORR       R5,R6           MERGE WITH NEW PSD WORD 2
         SBR       R6,15           INSURE WE DON'T LOSE ESTABLISHED MAPS
         ZBR       R6,16           RETAIN OLD BLOCK STATE?
         BNS       ST.SET          BRANCH IF NOT
         TBM       17,1W,X1        WAS OLD PSD BLOCKED?
         BNS       ST.SET          BRANCH IF NOT
         SBR       R6,17           NEW BLOCK STATE IS BEI
ST.SET   STW       R6,TSK.RPSD+1W,X2  STUFF AS WORD 2 OF NEW PSD
*
*  SET NEW PSD WORD 1
*
         LW        R6,PSD.RET1,X3  FETCH RETURN PSD WORD 1
         ANMW      R0,=X'F8000000' ISOLATE CC'S                 *214*
         ORR       R0,R6           MERGE WITH CONDITION CODES
         STW       R6,TSK.RPSD,X2  STUFF AS FINAL NEW PSD
         LW        R0,TSK.RET,X2   REFETCH ICB ADDRESS
         STW       R3,TSK.RET,X2   SAVE TRAP/INTERRUPT CONTEXT ADDRESS
*
*  THE PSD TO RETURN TO MPX IS NOW SET UP IN 'PSD.RET'.  SET UP
*  R1 TO POINT TO THE OLD FAULTING PSD.
*
*
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R6              ARE WE IN IPU
         BS        $+2W            SKIP IF YES
MO       ANOP                                                   *237*
         ZBM       NOT.MPX,TXPMFLGS  CLR MPX NOT LOADED FLAG
         LW        R5,PSD.OMPX,X3  FETCH OLD PSD ADDRESS (KEEP IN R5)
         LW        R1,PSD.OTMP,X3  FETCH OLD T-XPM PSD ADDRESS
         TRR       R4,R3           DQE ADDRESS TO XR
         STW       R0,DQE.PSSB,X3  SAVE ICB ADDRESS IN DQE
         STB       R7,DQE.PSSB+5B,X3    SAVE TRAP/INT # IN DQE
         IFF       C.3227,7X.1
*
*  CHECK IF T-XPM TASK DISPATCH WAS INTERRUPTED.  IF IT WAS NOT, THEN
*  THIS IS A 32/7X AND MPX WAS INTERRUPTED (H.TXPM HANDLES ---ALL---
*  TRAPS/INTERRUPTS FOR 32/7X
*
         TBM       DSP.TXPM,TSK.FLG2,X2 T-XPM DISPATCH ?
         IFT       MPX.EVNT,EVNT
         BNS       LF.RET.0         NO, RETURN TO MPX
EVNT     ANOP
         IFF       MPX.EVNT,EVNT
         BNS       LF.RET.1        NO, RETURN TO MPX
EVNT     ANOP
         TRR       R5,R1            OLD PSD ALWAYS IN MPX TCB/ICB
7X.1     ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         TBM       DSP.TXPM,TSK.FLG2,X2 T-XPM DISPATCH ?
         BNS       LF.RET.0         NO, RETURN TO MPX
         TRR       R5,R1            OLD PSD ALWAYS IN MPX TCB/ICB
EVNT     ANOP
*
*  HERE, A T-XPM TASK WAS INTERRUPTED.  CHECK TO SEE IF THIS IS A
*  TRAP OR INTERRUPT.  IF IT IS A TRAP, THEN WE MUST FURTHER DETERMINE
*  WHAT TYPE OF TRAP.  IF IT IS AN SVC (TYPE 0, 1, 2, OR AID SVC) THEN
*  SPECIAL ACTION MUST BE TAKEN (E.G. BIASING, VECTOR TO H.AID, ETC.)
*  IF THIS IS AN INTERRUPT, THEN WE SKIP ALL THE SVC CHECKS.
*
         CI        R7,15          SVC 9?
         BNE       CHECK.00       CHECK FOR INT IF NOT
         ZBM       USR.TSAB,TSK.FLG1,X2  CLEAR TSA BIASING BIT
         BU        CHECK.0         SKIP CHECKS FOR INTERRUPTS
CHECK.00 CI        R7,21           TRAP OR INTERRUPT?
         BGT       CHECK.0         SKIP SVC CHECKS FOR INTERRUPTS *225*
         CI        R7,6            SEE IF TRAP < SVC 0            *225*
         BLT       CHECK.0         SKIP SVC CHECKS FOR TRAPS      *225*
*  WE HAVE AN SVC, CLEAR FLAGS AND GO PROCESS                     *225*
         LW        R3,TSK.LVLP,X2  GET CURRENT LEVEL POINTER      *225*
         ZMW       TSK.LVL,X3      CLEAR FLAGS ETC.               *225*
         BU        CHECK.X         GO PROCESS SVC                 *225*
*
*  COPY ICB/TCB FROM H.TXPM TO THE ORIGINAL MPX ICB/TCB.  WE DO TH
*  ONLY FOR A CONCEPT MACHINES, SINCE ON A 7X ALL INTERRUPTS/TRAPS
*  FIRE IN THEIR ORIGINAL MPX ICB/TCB'S.
*
CHECK.0  LD        R6,0W,X1        FETCH OLD T-XPM PSD
         IFT       C.3227,CHK.X
         IFF       MPX.EVNT,EVNT
         LW        R0,4W,X1        FETCH ICB + 4W
         LW        R4,5W,X1        FETCH ICB + 5W
         TRR       R5,R1           ADDRESS OF OLD MPX PSD
         STW       R6,0W,X1        INSERT OLD PSD INTO MPX HANDLE
         STW       R7,1W,X1        INSERT OLD PSD INTO MPX HANDLER
         LW        R3,TSK.RET,X2   FETCH TRAP INFORMATION BLOCK
         TBM       ICXT.CLD,ICXT.FLG,X3      IS THIS NON CLASS F
         BS        CHK.5E          DON'T COPY ICB WORDS 4 AND 5
         TBM       ICXT.CLF,ICXT.FLG,X3      IS THIS CLASS F OR AN
*                                            FOR WHICH THERE IS NO CDT?
         BS        CHK.48E         DON'T COPY ICB WORD 4
         STW       R0,4W,X1        UPDATE ICB + 4W
CHK.48E  STW       R4,5W,X1        UPDATE ICB + 5W
CHK.5E   EQU       $
EVNT     ANOP
CHK.X    ANOP
         IFF       C.MPXOUT,MO                                  *237*
         TBM       0,1W,X1         IS RETURN PSD UNMAPPED
         BNS       NT.AID.E        SKIP BIASING IF UNMAPPED
         LW        R6,TSK.BIAS,X2  GET TASK BIAS
         LW        R7,0W,X1        GET INTERRUPTED ADDRESS
         ANMW      R7,=X'FFFFF'    CLEAR JUNK                   *214*
         ADMW      R7,TSK.BIAS,X2  BIAS ADDRESS FOR TSA TEST
         CAMW      R7,C.TSAD       IS ADDRESS IN O/S
         BLE       NT.AID.E        DO NOT BIAS IF IT IS
         ARMW      R6,0W,X1        BIAS OLD PSD IN MPX HANDLER
MO       ANOP                                                   *237*
*  NOW SWITCH MAPS TO MPX ENVIRONMENT
*
         IFF       C.MPXOUT,MO                                  *237*
NT.AID.E BL        MAP.MPX         MAP IN MPX AND USER MAPS
*
         TBM       TSK.TSAB,TSK.FLG1,X2   IS TSA BIASED?
         BNS       LF.RET0         BRANCH IF ALREADY BIASED
         LI        R6,1
         BL        S.TXPM.6        GO UNBIAS TSA ADDRESSES
LF.RET0  M.TSAD    R3              GET TSA ADDRESS              *237*
         T.IPU     R6              ARE WE IN IPU
         BS        $+2W            SKIP UPDATE IF YES
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
NT.AID.E LW        R3,C.REGS       GET TSA ADDRESS              *237*
MO       ANOP                                                   *237*
         STW       R3,C.TXPM       SAVE TSA ADDRESS FOR H.AID
         LW        R1,TSK.DQE,X2   RESTORE DQE ADDR
         TBM       DQE.ADM,DQE.ATI,X1  IS DEBUGGER XEQING
         BNS       LF.RET          RETURN WITHOUT SVC BIASING
         LA        R7,DBHAT
         IFF       OS.15E,DO.STCW                                   !245
         STCW      R7,T.DBHAT,X3   RESET DBHAT TO PNT TO H.TXPM *237*
DO.STCW  ANOP                                                       !245
         IFT       OS.15E,NO.STCW                                   !245
         STW       R7,T.DBHAT,X3   Reset DBHAT to pnt to H.TXPM     !245
NO.STCW  ANOP                                                       !245
         BU        LF.RET          RETURN TO INTERRUPT HANDLER
*
*  CHECK FOR TYPE 0 SVC AND BIAS R1 FOR DEBUG CALL TO H.EXEC,22.
*  DO NOT ALLOW USER TO EXECUTE AN M.CALL!
*
CHECK.X  CI        R7,6            SVC TYPE 0?
         BNE       CHECK.1         BRANCH IF NOT
CHECK.X1 EQU       $                                                !273
         IFF       C.MPXOUT,MO                                  *237*
         LW        R3,TSK.DQE,X2   GET DQE ADDRESS              *225*
         TBM       DQE.ADM,DQE.ATI,X3   IS DEBUGGER EXECUTING?
*273          BNS       SVC0.ABT
         BS        CHECK.X2        Go if so                         !273
*  If we're here, we have a task-level M.CALL, and it's not         !273
*  from the debugger.  We may allow it!                             !273
         LB        R7,18B,X1       Get module number                !273
         LW        R3,TSK.LVLP,X2  Get level pointer again          !273
         LB        R6,TSK.LVL,X3   Get mod # and other stuff        !273
         SBR       R6,TSK.SVC+24   Set SVC bit                      !273
         SRL       R6,4            Lose current mod #               !273
         SLL       R7,28           Put mod # at left end of R7      !273
         SLLD      R6,4            Mod # now in R6, bits 28-31      !273
         STB       R6,TSK.LVL,X3   Save in context area             !273
         SBM       TSK.SVCL,TSK.SVCI,X3 Remember this               !273
         BU        CHK.MRG         Merge up                         !273
CHECK.X2 EQU       $                                                !273
         LH        R7,9H,X1        FETCH CALL #
         CI        R7,X'116'       M.CALL H.EXEC,22 (BY TASK DEBUG?)
         BNE       CHK.MRG         BRANCH IF NOT
         LW        R6,TSK.BIAS,X2  FETCH TASK BIAS DIFFERENCE
         LW        R3,TSK.REGP,X2  GET REGISTER SAVE ADDRESS
         ARMW      R6,1W,X3       BIAS R1
MO       ANOP                                                   *237*
         BU        CHK.MRG
*
CHECK.1  CI        R7,7            SVC TYPE 1?
         BNE       CHECK.2
*
*  INDICATE TYPE 1 OR 15 SVC IN DQE CONTEXT FLAG WORD
*
CHECK.F  EQU       $                                            *225*
         SBM       TSK.SVC,TSK.LVL,X3   INDICATE SVC
         SBM       TSK.SVC1,TSK.SVCI,X3 INDICATE SVC TYPE 1     *219*
         BU        CHK.MRG
*
CHECK.2  CI        R7,8            SVC TYPE 2?
         BNE       CHECK.21                                     *219*
*
*  INDICATE TYPE 2 SVC IN DQE CONTEXT FLAG WORD
*
         SBM       TSK.SVC,TSK.LVL,X3   INDICATE SVC
         SBM       TSK.SVC2,TSK.SVCI,X3 INDICATE SVC TYPE 2     *219*
         BU        CHK.MRG
*
CHECK.21 CI        R7,12           SVC TYPE 6?                  *219*
         BNE       CHECK.22                                     *219*
         LB        R6,PTCH.MCL     Get M.CALL svc #                 !273
         CI        R6,6            Is it 3.5 M.CALL?                !273
         BEQ       CHECK.X1        Go if so                         !273
*
*  INDICATE TYPE 6 SVC IN DQE CONTEXT FLAG WORD                 *219*
*
         SBM       TSK.SVC,TSK.LVL,X3   INDICATE SVC            *219*
         SBM       TSK.SVC6,TSK.SVCI,X3 INDICATE SVC TYPE 6     *219*
         BU        CHK.MRG                                      *219*
*
CHECK.22 CI        R7,13           SVC TYPE 7?                  *219*
         BNE       CHECK.23                                     *219*
*
*  INDICATE TYPE 7 SVC IN DQE CONTEXT FLAG WORD                 *219*
*
         SBM       TSK.SVC,TSK.LVL,X3   INDICATE SVC            *219*
         SBM       TSK.SVC7,TSK.SVCI,X3 INDICATE SVC TYPE 7     *219*
         BU        CHK.MRG                                      *219*
*
CHECK.23 CI        R7,20           SVC TYPE E?                  *219*
         BNE       CHECK.3
*
*  INDICATE TYPE E SVC IN DQE CONTEXT FLAG WORD                 *219*
*
         SBM       TSK.SVC,TSK.LVL,X3   INDICATE SVC            *219*
         SBM       TSK.SVCE,TSK.SVCI,X3 INDICATE SVC TYPE E     *219*
         BU        CHK.MRG                                      *219*
*
CHECK.3  CI        R7,16           SVC TYPE A OR GREATER?
         BLT       CHK.MRG         BR IF NOT, GET SVC NUMBER
         BNE       CHECK.4
*
*  HERE WE HAVE A TYPE 'A' SVC. FIRST, CHECK IF DEBUG IS RETURNING
*  (FROM AN OVERLAY COURTESY CALL) TO H.AID
*
         LH        R6,9H,X1             FETCH CALL #
         CI        R6,X'C04'            DEBUG RETURNING TO H.AID?
         BNE       CHECK.35             BRANCH IF NOT
         BL        RTRN.AID             RETURN TO H.AID
CHECK.35 SBM       SVC.TYPA,TSK.LVL,X3  INDICATE TYPE A SVC     *225*
CHECK.4  CI        R7,21           IS THIS A CALM (TYPE F)?
         BEQ       CHECK.F         TREAT AS SVC TYPE 1
         CI        R7,19           TYPE D?
         BGT       CHK.MRG         GREATER THAN SVC TYPE D
*
*  HERE, WE HAVE AN SVC TYPE A - D.  CHECK IF IT IS AN AID SVC.
*
         TBM       20,4W,X1        AID SVC?
         BNS       CHK.MRG         NO
*                                                               *231*
*  NOW SEE IF H.AID ON SYSTEM                                   *231*
*                                                               *231*
         TBM       NO.AID,TXPMFLGS H.AID ON SYSTEM TO HANDLE    *231*
         BS        CHK.MRG         BR IF NOT                    *231*
*
*  HERE, WE HAVE AN 'AID' SVC, TYPE A, B, C, OR D.
*
         SBM       SVC.AID,TSK.LVL,X3   INDICATE 'AID' SVC
         SBM       1,1W,X1              TELL H.AID TO STAY BLOCKED!
*
*  NOW FETCH SVC CALL # AND PLACE IN DQE CONTEXT AREA
*
CHK.MRG  LB        R7,19B,X1        FETCH CALL #
         LW        R3,TSK.LVLP,X2   GET CURRENT LEVEL POINTER
         STB       R7,TSK.SVCT,X3   STUFF IN CONTEXT AREA
*
*  COPY ICB/TCB FROM H.TXPM TO THE ORIGINAL MPX ICB/TCB.  WE DO THIS
*  ONLY FOR A CONCEPT MACHINES, SINCE ON A 7X ALL INTERRUPTS/TRAPS
*  FIRE IN THEIR ORIGINAL MPX ICB/TCB'S.
*
CHK.END  LD        R6,0W,X1        FETCH OLD T-XPM PSD
         IFT       C.3227,CHK.X
         IFF       MPX.EVNT,EVNT
         LW        R0,4W,X1        FETCH ICB + 4W
         LW        R4,5W,X1        FETCH ICB + 5W
         TRR       R5,R1           ADDRESS OF OLD MPX PSD
         STW       R6,0W,X1        INSERT OLD PSD INTO MPX HANDLER
         STW       R7,1W,X1        INSERT OLD PSD INTO MPX HANDLER
         LW        R3,TSK.RET,X2   FETCH TRAP INFORMATION BLOCK
         TBM       ICXT.CLD,ICXT.FLG,X3      IS THIS NON CLASS F INT.
         BS        CHK.5           DON'T COPY ICB WORDS 4 AND 5
         TBM       ICXT.CLF,ICXT.FLG,X3      IS THIS CLASS F OR AN INT.
*                                            FOR WHICH THERE IS NO CDT?
         BS        CHK.48          DON'T COPY ICB WORD 4
         STW       R0,4W,X1        UPDATE ICB + 4W
CHK.48   STW       R4,5W,X1        UPDATE ICB + 5W
CHK.5    EQU       $
EVNT     ANOP
CHK.X    ANOP
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R3                   ARE WE IN IPU
         BS        NT.AID          BR IF WE ARE, AID NOT IN IPU
MO       ANOP                                                   *237*
*
*  IF AID SVC, GO TO S.TXPM.9
*
         LW        R3,TSK.LVLP,X2       GET CURRENT LEVEL POINTER
         TBM       SVC.AID,TSK.LVL,X3   AID SVC?
         BNS       NT.AID           BRANCH IF NOT
         BL        S.TXPM.9         NO RETURN FROM THIS CALL!
*
NT.AID   LW        R3,TSK.LVLP,X2       GET CURRENT LEVEL POINTER
         ZBM       SVC.TYPA,TSK.LVL,X3  CLEAR TYPE A (SINCE NOT AID SVC)
*
         IFF       C.MPXOUT,MO                                  *237*
         TBM       0,1W,X1         IS RETURN PSD UNMAPPED
         BNS       NT.AID.1        SKIP BIASING IF UNMAPPED
         LW        R6,TSK.BIAS,X2  GET TASK BIAS
         LW        R7,0W,X1        GET INTERRUPTED ADDRESS
         ANMW      R7,=X'FFFFF'    CLEAR JUNK                   *214*
         ADMW      R7,TSK.BIAS,X2  BIAS ADDRESS FOR TSA TEST
         CAMW      R7,C.TSAD       IS ADDRESS IN O/S
         BLE       NT.AID.1        DO NOT BIAS IF IT IS
         ARMW      R6,0W,X1        BIAS OLD PSD IN MPX HANDLER
NT.AID.1 T.IPU     R6              ARE WE IN IPU
         BS        $+3W            SKIP BIAS IF TRUE
         LW        R6,C.REGS       GET MPX TSA ADDRESS          *237*
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
NT.AID.1 LW        R6,C.REGS       GET MPX TSA ADDRESS
MO       ANOP                                                   *237*
         STW       R6,C.TXPM       SAVE FOR H.AID
*  NOW SWITCH MAPS TO MPX ENVIRONMENT
*
         BL        MAP.MPX         MAP IN MPX AND USER MAPS
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TMPX ANOP                                                       !259
*--------------------------------------------------------------------
*
*  CURRENT STATE IS:
*
*    1.  CURRENT TASK IS 'NO-MPX'
*    2.  C.TXPM AND OLD PSD BIASED FOR 'MPX' ENVIRONMENT
*    3.  CPU MAPPED
*    4.  INTERRUPTS BLOCKED
*    5.  TRAP/INTERRUPT ACTIVE
*    6.  USER MAPS ESTABLISHED FOR 'MPX' ENVIRONMENT
*
*  'MPX' ENVIRONMENT MAPS ESTABLISHED. COMPLETE TRANSITON TO 'MPX'
*  ENVIRONMENT BY UNBIASING TSA ADDRESSES AND RESETTING DBHAT (IF
*  DEBUGGER WAS EXECUTING).
*
         IFF       C.MPXOUT,MO                                  *237*
         TBM       TSK.TSAB,TSK.FLG1,X2   IS TSA BIASED?
         BNS       TSA.XB          BRANCH IF ALREADY BIASED
         LI        R6,1
         BL        S.TXPM.6        GO UNBIAS TSA ADDRESSES
TSA.XB   LW        R1,TSK.DQE,X2   GET DQE ADDRESS
         TBM       DQE.ADM,DQE.ATI,X1  IS DEBUGGER XEQING
         BNS       TSA.UB          BR IF NOT
         LA        R7,DBHAT
         M.TSAD    R3              GET TSA ADDRESS              *237*
         STW       R7,T.DBHAT,X3   RESET DBHAT TO POINT TO H.TXPM
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         LW        R3,C.REGS       GET TSA ADDRESS              *237*
         STCW      R7,T.DBHAT,X3   RESET DBHAT TO PNT TO H.TXPM *237*
MO       ANOP                                                   *237*
TSA.UB   LW        R3,TSK.LVLP,X2  GET CURRENT LEVEL POINTER
         TBM       TSK.SVC,TSK.LVL,X3  IS THIS AN SVC           *219*
         BNS       LF.RET          NO, RETURN TO INTERRUPT HANDLER
         IFF       C.MPXOUT,MO                                  *237*
*
*  HERE, WE HAVE AN SVC.  DETERMINE TYPE (1,2,6,7 OR E) AND BRANCH TO *219*
*  APPROPRIATE ROUTINE TO BIAS REGISTERS AND DATA STRUCTURES.
*  BUT FIRST, WE MUST MAP IN THE USER ADDRESS SPACE SINCE WE MAY
*  HAVE TO BIAS CERTAIN ADDRESSES (FCB'S, CNP'S, ETC.)
*
         LB        R1,TSK.SVCT,X3   FETCH SVC TYPE
         LW        R4,ADR.MASK     ADR.MASK  FETCH 20 BIT ADDRESS MASK
         LW        R5,TSK.BIAS,X2  FETCH BIAS DIFFERENCE
         ZR        R7              I/O SVC INDICATOR
         SEA
         TBM       TSK.SVC1,TSK.SVCI,X3 IS IT A TYPE 1?         *219*
         BNS       SVC.M2          NOPE, TRY SVC 2              *219*
*
*  HERE, SVC IS TYPE 1
*
SVC.M1   CI        R1,X'63'        IS IT CALL DEBUGGER?
         BNE       SVC.M1.1        BRANCH IF NOT
         LW        R3,TSK.DQE,X2    GET DQE ADDRESS
         TBM       DQE.ADM,DQE.ATI,X3   DEBUGGER XEQING
         BS        S.TXPM.7        YES, GO EXECUTE MOVE FOR DEBUGGER
SVC.M1.1 EQU       $
         CAMH      R1,C.SVTN       SVC > MAX SVC 1 NUMBER
         BGT       LF.RET          BRANCH IF SVC IS > MAXIMUM
         ADMW      R1,SVC1IN       ADD TABLE START ADDRESS NUM
         BU        SVC.MMG         MERGE WITH SVC 2 PROCESSING
*
SVC.M2   TBM       TSK.SVC2,TSK.SVCI,X3 IS IT A TYPE 2?         *219*
         BNS       SVC.M21         NOPE, TRY SVC 6              *219*
*
*  HERE, SVC IS TYPE 2
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,C.SVTN2      IS SVC > MAX SVC 2 NUMBER    *219*
         BGT       LF.RET          BRANCH IF SVC IS > MAXIMUM
         ADMW      R1,SVC2IN       ADD STARTING TABLE ADDRESS
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        SVC.M1          Go do svc 1 processing           !245
*245 *  SVC 2'S ARE SAME AS SVC 1'S ON 1.5                           *238*
*245          CAMH      R1,C.SVTN       SVC > MAX SVC 1 NUMBER       *238*
*245          BGT       LF.RET          BRANCH IF SVC IS > MAXIMUM   *238*
*245          ADMW      R1,SVC1IN       ADD TABLE START ADDRESS NUM  *238*
OS15E    ANOP                                                   *238*
*
*  Handle SVCs 0, 1, or 2                                           !285
SVC.MMG  LB        R1,0B,X1        GET BIAS ROUTINE NUMBER
         SLL       R1,2            MAKE WORD OFFSET
         ADMW      R1,VTBLA        ADD STARTING VECT TBL ADDR
         LW        R1,0W,X1        GET ADDRESS OF SVC ROUTINE
SVC.MMGC STW       R1,TSK.RET,X2   SAVE ADDRESS TO DISPATCH TO      !273
*270          LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER
RSXF.3   LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER       !268
*  The above instruction will be replaced by a BL RSX_FIX on 'Hawks !268
         BL        *TSK.RET,X2     DISPATCH TO SVC BIAS ROUTINES
         IFT       OS.35,DO.35                                      !285
*  Now for some fun.  3.5U02 decided that C.CSWI didn't need to be  !285
*  set upon entry to SVC 0, 1, 2, and 4.  That's not a problem.     !285
*  But what is is this.  The new first instruction is a STD R2,     !285
*  C.STKREG (which is at addr x'de8').  So TXPM executes that instr !285
*  before we bias the regs.  Then we return to IP06, which will     !285
*  eventually load R2/3 from de8, which are unbiased regs!  So      !285
*  in this code we look at the TXPM trap area for SVC1.  If it's    !285
*  a STD, then we retrieve R2/3 and write it over that area that is !285
*  the target of the STD.  That way IP06 will pick up biased regs.  !285
         TBM       LW.STKR,LSWITCH Do we have to do this?           !285
         BNS       SVC.M205        Go if no                         !285
         T.IPU     R3              Are we in the IPU?               !286
         BS        SVC.M205        Skip if so                       !286
         LW        R3,TSK.REGP,X2  Else point to user regs          !285
         LD        R6,2W,X3        Get R2/3                         !285
         STD       R6,*C_STKREG    And save it in C.STKREG          !285
SVC.M205 EQU       $                                                !285
DO.35    ANOP                                                       !285
         BU        LF.RET          CONTINUE PROCESSING          *219*
*
SVC.M21  TBM       TSK.SVCL,TSK.SVCI,X3 M.CALL?                     !273
         BNS       SVC.M212        Go if no                         !273
         LA        R7,CLB.TBL      Bias routines                    !273
         BL        MCL.DSPA        Get bias routine address         !273
         BU        SVC.MMGC        Merge for M.CALL                 !273
SVC.M212 TBM       TSK.SVC6,TSK.SVCI,X3 IS IT A TYPE 6?         *219*
         BNS       SVC.M22         NOPE, TRY SVC 7              *219*
*
*  HERE, SVC IS TYPE 6                                          *219*
*
         LB        R0,PTCH.MCL     What's the M.CALL SVC?           !272
         CI        R0,6            Is it SVC 6?                     !272
         BEQ       SVC0.ABT        Go if so; can't do               !272
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTN6     IS SVC > MAX SVC 6 NUMBER    *219*
*257          BGT       LF.RET          BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       LF.RET          BRANCH IF SVC IS > MAXIMUM       !257
         ADMW      R1,SVC6IN       ADD STARTING TABLE ADDRESS   *219*
         BU        SVC.MMGX        MERGE WITH COMMON CODE       *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        LF.RET          IGNORE THIS SVC              *238*
OS15E    ANOP                                                   *238*
*
SVC.M22  TBM       TSK.SVC7,TSK.SVCI,X3 IS IT A TYPE 7?         *219*
         BNS       SVC.M23         NOPE, TRY SVC E              *219*
*
*  HERE, SVC IS TYPE 7                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTN7     IS SVC > MAX SVC 7 NUMBER    *219*
*257          BGT       LF.RET          BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       LF.RET          BRANCH IF SVC IS > MAXIMUM       !257
         ADMW      R1,SVC7IN       ADD STARTING TABLE ADDRESS   *219*
         BU        SVC.MMGX        MERGE WITH COMMON CODE       *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        LF.RET          IGNORE THIS SVC              *238*
OS15E    ANOP                                                   *238*
*
SVC.M23  TBM       TSK.SVCE,TSK.SVCI,X3 IS IT A TYPE E?         *219*
         BNS       LF.RET          NOPE, CONTINUE               *219*
*
*  HERE, SVC IS TYPE E                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTNE     IS SVC > MAX SVC E NUMBER    *219*
*257          BGT       LF.RET          BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       LF.RET          BRANCH IF SVC IS > MAXIMUM       !257
         ADMW      R1,SVCEIN       ADD STARTING TABLE ADDRESS   *219*
         BU        SVC.MMGX        MERGE WITH COMMON CODE       *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        LF.RET          IGNORE THIS SVC              *238*
OS15E    ANOP                                                   *238*
*  This routine finds the dispatch address for an M.CALL.
*  R7 has the address of the dispatch table on input.  It will
*  be set to zero on output.
MCL.DSPA LB        R3,TSK.LVL,X3   Get mod #                        !273
         SLL       R3,28           Left justify                     !273
         SRL       R3,28-2         Isolate and make word offset     !273
         ADR       R7,R3           Add in table address             !273
         LNB       R7,,X3          Get count of possibilities       !273
         BZ        SVC0.NO         Go if can't be biased            !273
         LW        R3,,X3          Get ptr to sub-table             !273
SVC0.L   CAMB      R1,,X3          Match on ep#?                    !273
         BEQ       SVC0.F          Go if found                      !273
         ABR       R3,29           Next word                        !273
         BIB       R7,SVC0.L       Loop                             !273
SVC0.NO  ZR        R7              Restore R7                       !273
         LW        R3,TSK.LVLP,X2  And this                         !273
         BU        SVC0.ABT        Abort this creep                 !273
* -------------------------                                         !273
SVC0.F   LW        R1,,X3          Get bias address                 !273
         LW        R3,TSK.LVLP,X2  Restore this                     !273
         ZR        R7              Restore this                     !273
         TRSW      R0              Return                           !273
* ----------------------------------------------------------------- !273
         IFF       OS.15E,OS15E                                 *238*
*
*  Handle SVCs other than 0, 1, or 2                                !285
SVC.MMGX LB        R1,0B,X1        GET BIAS ROUTINE NUMBER      *219*
         SLL       R1,2            MAKE WORD OFFSET             *219*
*257          ADMW      R1,XVTBLA       ADD STARTING VECT TBL ADDR   *219*
*257          LW        R1,0W,X1        GET ADDRESS OF SVC ROUTINE   *219*
         LW        R1,XVTBLA,X1    GET ADDRESS OF SVC ROUTINE       !257
         STW       R1,TSK.RET,X2   SAVE ADDRESS TO DISPATCH TO  *219*
*270          LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER   *219*
RSXF.4   LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER       !268
*  The above instruction will be replaced by a BL RSX_FIX on 'Hawks !268
         BL        *TSK.RET,X2     DISPATCH TO SVC BIAS ROUTINES*219*
OS15E    ANOP                                                   *238*
MO       ANOP                                                   *237*
*
*--------------------------------------------------------------------
*
*  HERE WE DO THE FOLLOWING,
*
*     1.  RESTORE USER REGISTERS.
*     2.  RESTORE MAP AND RETURN TO INTERRUPT CONTEXT AREA WHICH WILL
*         THEN BRANCH BACK THE THE APPROPRIATE HANDLER.
*
LF.RET   ZR        R0              THIS IS A TXPM DISPATCH
         IFT       MPX.EVNT,EVNT
         BU        INT.LV          SKIP OVER MPX STUFF
LF.RET.0 LI        R0,8            8+VAL = MPX EVENT
EVNT     ANOP
INT.LV   TBM       EVNT.TRP,EVNT.PTR  RECORD TRAP EVENTS (TYPE 2)?
         BS        EVT.TRC         BRANCH IF YES
         TBM       EVNT.INT,EVNT.PTR  RECORD INT EVENTS (TYPE 3)?
         BNS       LF.RET.1        SKIP RECORDING IF NEITHER ON
EVT.TRC  LW        R3,TSK.DQE,X2   GET DQE ADDR
         LW        R1,DQE.PSSB,X3  GET INT PSD ADDR
         LD        R6,0W,X1        GET TRAPPING PSD
         LB        R4,DQE.PSSB+5B,X3   GET TRAP/INT TYPE #
         CI        R4,32           31 TRAPS
         BLT       SET.TRP
         TBM       EVNT.INT,EVNT.PTR  RECORD INTERRUPTS?
         BNS       LF.RET.1        LEAVE IF NOT
         ADI       R0,3            SET TYPE TO INTERRUPT
         BU        SET.RE          GO RECORD INT EVENT
SET.TRP  TBM       EVNT.TRP,EVNT.PTR  RECORD TRAPS?
         BNS       LF.RET.1        LEAVE IF NOT
         ADI       R0,2            ASSUME TRAP
SET.RE   TRR       R0,R1           SET TYPE FOR EVENT TRACING
         IFT       MPX.EVNT,EVNT
         TRR       R1,R4           EVENT TYPE
         TRR       R2,R1           CONTEXT ADDRESS
         LW        R2,TSK.REGP,X1  REG POINTER
         BL        LOGGER          RECORD EVENT
         TRR       R1,R2           RESTORE CONTECT POINTER
EVNT     ANOP
         IFF       MPX.EVNT,EVNT
         BL        REC.EVNT        RECORD EVENT
EVNT     ANOP
         IFT       C.3227,SP.03
         IFF       MPX.EVNT,EVNT
*
*  RESET BASE SPAD POINTER FOR TRAP & INTERRUPT VECTORS
*
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R6              IPU TASK
         BS        V.0             BR IF YES
MO       ANOP                                                   *237*
         V.MPX                     SET SPAD VECTORS TO MPX (CONCEPT)
         IFF       C.MPXOUT,MO                                  *237*
         BU        V.1             CONTINUE
V.0      EQU       $               RESET IPU SPAD
         V.MPXI                    RESET TRAPS ONLY ON IPU
V.1      EQU       $
MO       ANOP                                                   *237*
EVNT     ANOP
SP.03    ANOP
*
LF.RET.1 ZBM       DSP.TXPM,TSK.FLG2,X2 CLEAR T-XPM DISPATCH FLAG
         LD        R6,TSK.RPSD,X2  GET RETURN PSD
         LW        R3,TSK.REGP,X2  REG SAVE AREA ADDRESS
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R0              IPU TASK
         BS        RV.0            BR IF YES
MO       ANOP                                                   *237*
         STD       R6,PSDR.CPU     SAVE RETURN PSD
         LF        R0,0W,R3        LOAD USERS REGISTERS
         LPSD      PSDR.CPU        NOW, GO RETURN TO MPX
*
         IFF       C.MPXOUT,MO                                  *237*
RV.0     STD       R6,PSDR.IPU     SAVE RETURN PSD
         LF        R0,0W,R3        LOAD USERS REGISTERS
         ZBM       IN.TXPM,TXPMFLGS  CLEAR IN TXPM FLAG
         LPSD      PSDR.IPU        NOW, GO RETURN TO MPX
*
MO       ANOP                                                   *237*
PSDR.CPU RES       1D              CPU RETURN PSD
         IFF       C.MPXOUT,MO                                  *237*
PSDR.IPU RES       1D              IPU RETURN PSD
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
*
*--------------------------------------------------------------------
*
*  ROUTINES TO BIAS/UNBIAS REGISTERS AND DATA STRUCTURES WHEN
*  SWITCHING BETWEEN THE 'MPX' AND THE 'NOMPX' ENVIRONMENTS.
*  TYPICALLY, THERE IS ONE ROUTINE FOR EACH SVC (TYPE 1 OR 2) THAT
*  NEEDS BIASING.  OCCASIONALLY, THE BIAS AND UNBIAS ROUTINES
*  ARE SEPARATE, IN WHICH CASE THE UNBIAS ROUTINE IS SUFFIXED WITH
*  AN 'R'.
*
*        ON ENTRY: R0 = RETURN ADDRESS
*                  R1 = REG SAVE AREA ADDRESS
*                  R2 = DQE CONTEXT AREA ADDRESS
*                  R3 = DQE CURRENT LEVEL POINTER
*                  R4 = 20-BIT ADDRESS MASK
*                  R5 = BIAS VALUE
*                  R7 = I/O INDICATOR
*
*--------------------------------------------------------------------
SVC1.IO  EQU       $               HANDLES ALL SVC'S (TYPE 1)
         LI        R7,1            INDICATE THAT THIS IS AN I/O SVC
SVC1.30  EQU       $
FCB.R1   EQU       $               DO FCB AND R1
         BIAS.FCB                  ...THAT DO I/O
BIAS.R1  EQU       $
SVC2.50  EQU       $               M.GTIM
         BIAS.R    1
SVC1.RET EQU       $               RETURN FROM SVC 1 PROCESSING
SVC2.RET EQU       $               RETURN FORM SVC 2 PROCESSING
         BIAS.LV
*-------------------------------------------------------------------
SVC1.17  EQU       $               H.ADIO CALL
*                                  R1=A(IOCH)
*                                  R4=A(USR.BUF) OR 0
*                                  R5=SIZE OF BUFF
*                                  R6=A(EOB.END.ACT)
*                                  R7=A(ERR.RTN)
*
*  THIS ROUTINE WILL BIAS AN 'IOCH' DATA STRUCTURE
*
         LW        R1,1W,X1        FETCH IOCH ADDRESS
         TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       IOCH.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS TO REFERENCE IOCH
IOCH.AB  LMW       R7,1W,X1        GET IOCB ADDRESS
         ADR       R5,R7           BIAS TO REFERENCE IOCB
         BU        $+2W            SKIP OVER IOCB LOAD
IOCH.UB  LMW       R7,1W,X1        GET IOCB ADDRESS
         ARMW      R5,1W,X1         BIAS ADDRESS OF IOCB IN IOCH
         LB        R6,2W,X1        GET USER SUPPLIED INSTRUCTION
         CI        R6,X'F8'        IS IT BL INSTRUCTION
         BNE       $+2W            SKIP BIASING IF NOT
         ARMW      R5,3W,X1        BIAS INSTRUCTION ADDRESS
         TRRM      R1,R1           KEEP 20 BIT IOCB ADDRESS
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.IOH        TX13 ABORT CODE
         TRR       R7,R1           IOCB ADDRESS TO R1
IOCH.AA  TBM       TSK.SVC,TSK.LVL,X3  IS THIS A BIAS
         BS        IOCH.AD         YES, MAKE MPX ADDRESSES
         ZBM       7,1W,X1         RESET WE WERE HERE BIT
         BNS       IOCH.XIT        EXIT IF WE WERE HERE
         BU        IOCH.AC         CONTINUE PROCESSING
IOCH.AD  SBM       7,1W,X1         SET WE WERE HERE BIT
         BS        IOCH.XIT        DONE IF HERE BEFORE
IOCH.AC  TBM       5,0W,X1         IS THIS A TIC COMMAND
         BNS       TIC.IOCH        BR IF NOT
         TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       IOCH.UB          NO, BECAUSE THIS IS AN UNBIAS
         BU        IOCH.AB         GO BIAS IOCB ADDRESS
TIC.IOCH LMW       R6,1W,X1         FETCH CHANNEL ADDRESS TABLE POINTER
         BZ        $+2W            SKIP IF 0
         ARMW      R5,1W,X1         BIAS ADDRESS
         LMW       R6,2W,X1         FETCH BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,2W,X1         BIAS ADDRESS
         TBM       6,0W,X1         IS THIS A CHAINED IOCB
         BNS       IOCH.XIT        EXIT IF DONE
         ADI       R1,4W           POINT TO NEXT IOCB
         BU        IOCH.AA         CONTINUE IOCB PROCESSING
*
IOCH.XIT LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         BIAS.R    4               BIAS USERS BUFFER ADDRESS
         BU        SVC1.18         GO BIAS REGS 1, 6 AND 7
*-------------------------------------------------------------------
SVC1.1E  EQU       $               M.TURNON, M.CONN, M.SETT (FUNCT 1,2)
         LW        R6,7W,X1        GET R7 AND SEE IF TASK # OR NAME
         BNZ       SVC1.RET        TASK # OR NAME, EXIT WITH NO BIAS
         BU        BIAS.R6         R6 HAS PNV OR RID, GO BIAS
*--------------------------------------------------------------------
SVC1.25  EQU       $               M.EXCP
         BIAS.ECP                  BIAS CHANNEL PROGRAM
         BU        SVC1.IO         GO BIAS FCB AND R1           *219*
*-------------------------------------------------------------------
*277 SVC1.3D  EQU       $               M.CWAT, M.TYPE
SVC1.3F  EQU       $               M.TYPE                           !277
*
*  TCPB = TYPE CONTROL PARAMETER BLOCK (USED FOR CONSOLE I/O)
*
         LW        R1,1W,X1         FETCH TCB ADDRESS
*
*  THIS ROUTINE WILL BIAS A 'TCB' DATA STRUCTURE
*
*  ON INPUT:   R1 = ADDRESS OF TCB (TYPE CONTROL PARAMETER BLOCK)
*
         TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       TCP.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS TO REFERENCE TCP
TCP.UB   TRRM      R1,R1           KEEP 20 BIT TCP ADDRESS
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.TCP
         TBM       1,TCP.FLGS,X1   IS THIS A 24 BIT ADDRESS
*230*    BNS       TCP.1           BR IF NOT                    *230*
         BS        TCP.1           BR IF YES                    *230*
         LW        R4,=X'7FFFF'    GET A 19 BIT MASK
         TBM       TSK.SVC,TSK.LVL,X3   IS THIS AN UNBIAS?
         BNS       TCP.2           BR IF IT IS
         LMW       R6,TCP.OTCW,X1  FETCH FILE ID ADDRESS
         BZ        TCP.3           SKIP IF 0
         ADR       R5,R6           ADD IN BIAS
         CAMW      R6,=X'80000'    IS ADDR NOW IN EXT MEM
         BGE       TCP.5           BR IF IT IS
TCP.3    LMW       R6,TCP.ITCW,X1  FETCH FILE ID ADDRESS
         BZ        TCP.4           SKIP IF 0
         ADR       R5,R6           ADD IN BIAS
         CAMW      R6,=X'80000'    IS ADDR NOW IN EXT MEM
         BLT       TCP.4           BR IF NOT
TCP.5    SBM       1,TCP.FLGS,X1   SET TCP ADDR'S EXT
         SBM       8,TCP.FLGS,X1   SET FLAG FOR REBIASING
         LW        R6,TCP.OTCW,X1  GET OUTPUT TCW
         SRLD      R6,20           JUST GET ADDR
         SLL       R7,1            DROP BYTE BIT
         SLL       R6,5            MOVE OVER CNT
         SLLD      R6,19           MERGE IN ADDR
         STW       R6,TCP.OTCW,X1  STO IT BACK
         LW        R6,TCP.ITCW,X1  GET INPUT TCW
         SRLD      R6,20           JUST GET ADDR
         SLL       R7,1            DROP BYTE BIT
         SLL       R6,5            MOVE OVER CNT
         SLLD      R6,19           MERGE IN ADDR
         STW       R6,TCP.ITCW,X1  STO IT BACK
         BU        TCP.4           GO BIAS THE DATA
TCP.2    ZBM       8,TCP.FLGS,X1   WAS THIS A SPECIAL BIAS
         BNS       TCP.4           BR IF NOT
         ZBM       1,TCP.FLGS,X1   SHOW NOT EXTENDED ANYMORE
         LW        R6,TCP.OTCW,X1  GET OUTPUT TCW
         BZ        TCP.21          DON'T REBIAS IF ZERO
         ADR       R5,R6           REBIAS ADDR
         SRLD      R6,24           JUST GET ADDR
         SRL       R7,1            MAKE ROOM FOR BYTE BIT
         SBR       R7,0            SET BYTE BIT
         SLLD      R6,19           MERGE IN ADDR
         STW       R6,TCP.OTCW,X1  STO IT BACK
TCP.21   LW        R6,TCP.ITCW,X1  GET INPUT TCW
         BZ        TCP.22          DON'T REBIAS IF ZERO
         ADR       R5,R6           REBIAS ADDR
         SRLD      R6,24           JUST GET ADDR
         SRL       R7,1            MAKE ROOM FOR BYTE BIT
         SBR       R7,0            SET BYTE BIT
         SLLD      R6,19           MERGE IN ADDR
         STW       R6,TCP.ITCW,X1  STO IT BACK
         BU        TCP.22          GO REBIAS R1
TCP.4    LW        R4,ADR.MASK     GET MASK AGAIN
TCP.1    LMW       R6,TCP.OTCW,X1  FETCH FILE ID ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,TCP.OTCW,X1  BIAS
         LMW       R6,TCP.ITCW,X1  FETCH FILE ID ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,TCP.ITCW,X1  BIAS
TCP.22   LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         BU        BIAS.R1         MERGE CODE
*-------------------------------------------------------------------
SVC1.18  EQU       $               H.ADIO CALL
*                                  R1=A(IOCB2)
*                                  R6=A(END.ACT)
*                                  R7=A(ERR.RET)
*
SVC1.40  EQU       $               M.ALOC
         BIAS.R    1
BIAS.R67 EQU       $               BIAS BOTH R6 AND R7
SVC1.44R EQU       $               M.ADRS     (RETURN)
         BIAS.R    6
SVC1.15  EQU       $               M.DATE
SVC1.3A  EQU       $               M.RSRV
SVC1.50R EQU       $               M.LOAD (RETURN)
SVC1.64  EQU       $               M.ID
SVC1.63  EQU       $               Load debugger                    !245
BIAS.R7  EQU       $
         BIAS.R    7
         BIAS.LV
*-------------------------------------------------------------------
SVC1.40R EQU       $               M.ALOC
         LW        R6,6W,X1        GET POSSIBLE ERROR CODE
         CI        R6,32           SEE IF ERROR CODE
         BGT       SVC1.40         NORMAL REBIASING IF NOT
         BIAS.R    1               BIAS R1
         BU        BIAS.R7         GO BIAS REG 7
*-------------------------------------------------------------------
SVC1.45  EQU       $               M.SETT
         LB        R6,3W,X1       FETCH FUNCTION
         CI        R6,3
         IFF       OS.15E,NO.15                                     !245
         BLT       SVC1.1E         CHECK FOR PNB OR RID IN R6
NO.15    ANOP
         IFT       OS.15E,DO.15                                     !245
         BLT       SVC1.RET        Done                             !245
DO.15    ANOP                                                       !245
         CI        R6,5            FUNCTION 5 ?
         IFF       OS.15E,NO.15                                     !245
         BEQ       SVC1.RET        YES, LEAVE
NO.15    ANOP                                                       !245
         IFT       OS.15E,DO.15                                     !245
         BGE       SVC1.RET        Yes, leave                       !245
DO.15    ANOP                                                       !245
         BU        BIAS.R6         BIAS R6 FOR FUNCTIONS 3 & 4
*-------------------------------------------------------------------
SVC1.4F  EQU       $               M.DUMP
         BIAS.R    5
         BU        BIAS.R67        GO BIAS R6 AND R7
*-------------------------------------------------------------------
SVC1.4FR EQU       $               M.DUMP
         LW        R6,7W,X1        GET RETURN REG 6
         BNZ       SVC1.4F         GO BIAS R5, R6 AND R7
         BU        BIAS.R5         GO BIAS R5 ONLY
*-------------------------------------------------------------------
SVC1.50  EQU       $               M.LOAD, M.LOADX
         ZBM       STK.BIAS,TSK.FLG1,X2 AID STACK BIASED?
         BNS       SVC1.5OL             BRANCH IF BIASED?
         LW        R7,TSK.BIAS,X2       FETCH TASK BIAS
         M.TSAD    R3              TSA ADDRESS (MPX)            *237*
         LW        R1,T.TEND,X3         TSA END ADDRESS (MPX)
         SUI       R1,2W
         LW        R4,1W,X1        STACK CHECKSUM
         CAMW      R4,RAID
         BNE       SVC1.5OL        LEAVE IF STACK NOT SET UP
         ARMW      R7,,X1          BIAS BASE STACK POINTER
         LW        R1,,X1          FETCH  BASE STACK POINTER
         ARMW      R7,,X1          BIAS STACK POINTER
         ARMW      R7,STK.LPTR,X1  BIAS ORIGIN SUB STACK
         ARMW      R7,STK.END,X1   BIAS STACK ENDING ADDRESS
         ARMW      R7,STK.OEND,X1  BIAS OVERLAY ENDING ADDRESS
SVC1.5OL EQU       $
         BIAS.LV
*-------------------------------------------------------------------
SVC1.52  EQU       $               M.ACTV
         LW        R6,6W,X1        GET USERS R6
         BNZ       SVC1.RET        6/7 IS NAME, NO BIAS REQ'D
         BU        BIAS.R7         PNV OR RID IN R7, BIAS IT
*-------------------------------------------------------------------
SVC1.5E  EQU       $               M.XMSGR
         BIAS.RXB  2
         BU        BIAS.R2         GO BIAS R2
*-------------------------------------------------------------------
SVC1.5F  EQU       $               M.PTSK
         IFF       OS.15E,NO.15                                     !245
         LW        R1,1W,X1        GET TASK ACTIVATION PARAMETER BLOCK
         STW       R0,TSK.RET,X2   SAVE RETURN ADDRESS
         BL        TAB.BIAS        BIAS TASK ACTV PARM BLOCK
NO.15    ANOP                                                       !245
         LW        R1,TSK.REGP,X2  RESTORE REG STACK ADDR
         LW        R0,TSK.RET,X2   RESTORE RETURN ADDRESS
         BIAS.PSB  2
BIAS.R12 EQU       $               BIAS R1 AND R2
SVC2.51  EQU       $               M.CTIM
         BIAS.R    1
BIAS.R2  EQU       $               BIAS R2
SVC1.5C  EQU       $               M.TBRKON
SVC2.4D  EQU       $               M.LOGMVT                         !294
         BIAS.R    2
         BIAS.LV
*-------------------------------------------------------------------
SVC1.60  EQU       $               M.SUAR
SVC1.6B  EQU       $               M.RCVR
SVC1.6E  EQU       $               M.BRK
         TBM       TSK.SVC,TSK.LVL,X3     BIAS OR RE-BIAS?
         BNS       BIAS.R7         IF RE-BIAS, USE 20-BIT MASK
         LW        R4,=X'7FFFF'    19 BITS ONLY
         BU        BIAS.R7         GO BIAS R7 WITH 19BIT MASK
*-----------------------------------------------------------------
         IFF       OS.15E,OS15E                                 *238*
SVC2.7BR EQU       $               M.GADRL2    (RETURN)
         BIAS.R    1               T.BIAS - DSECT START ADDRESS
         BIAS.R    2               T.END - LAST LOADED ADDRESS
         BIAS.R    3               END OF ALLOCATED DSECT
         BIAS.R    4               DSECT END - CSECT ORIGIN
         LW        R4,=X'FFFFFF'   USE 24 BIT MASK FOR R6 & R7
         BU        BIAS.R67        GO BIAS R6 & R7 WITH 24BIT'S
*-----------------------------------------------------------------
OS15E    ANOP                                                   *238*
SVC1.65R EQU       $               M.GADRL     (RETURN)
         BIAS.R    3               T.BIAS - DSECT START ADDRESS
         BIAS.R    4               T.END - LAST LOADED ADDRESS
         BIAS.R    5               END OF ALLOCATED DSECT
         BU        BIAS.R6         DSECT END - CSECT ORIGIN
*-------------------------------------------------------------------
SVC1.67R EQU       $               M.GE       (RETURN)
         LW        R6,3W,X1        FETCH R3
         BZ        SVC1.RET        RETURN IF ZERO
         ARMW      R5,3W,X1        BIAS R3
         LW        R6,4W,X1        FETCH R4, IF R3 .NE. 0
         BZ        SVC1.RET        RETURN IF ZERO
         ARMW      R5,4W,X1        BIAS R4
         BU        SVC1.RET        RETURN
*-------------------------------------------------------------------
SVC1.68R EQU       $               M.FE       (RETURN)
SVC1.71R EQU       $
SVC1.6AR EQU       $               M.FD       (RETURN)
SVC2.4BR EQU       $               M.MEMB
SVC2.4C  EQU       $               M.MEMFRE
         LW        R6,3W,X1        FETCH R3
         BZ        SVC1.RET        RETURN IF ZERO
         ARMW      R5,3W,X1        BIAS R3
         BU        SVC1.RET        RETURN
*-------------------------------------------------------------------
SVC1.6C  EQU       $               M.SMSGR
SVC1.6D  EQU       $               M.SRUNR
         BIAS.PSB  2
         BU        BIAS.R2         GO BIAS R2
*-------------------------------------------------------------------
SVC1.72  EQU       $               M.INCL
         BIAS.R    0
         BIAS.LV
*-------------------------------------------------------------------
SVC1.7A  EQU       $               M.GMSGP, M.GRUNP
         BIAS.PRB  2
         BU        BIAS.R2         GO BIAS R2
*-------------------------------------------------------------------
         IFF       OS.15E,OS15E                                 *238*
SVC2.20  EQU       $               M.CPERM, M.TEMP
*279 SVC2.23  EQU       $               M.DIR                            !278
         BIAS.RCB  2
SVC2.2D  EQU       $               M.RENAM
SVC2.30  EQU       $               M.REPLAC
         BIAS.R    2
CNP.R1   EQU       $               BIAS CNP AND R1
SVC2.49  EQU       $               M.MOUNT
SVC2.4A  EQU       $               M.DMOUNT
         BIAS.CNP
         BU        BIAS.R1         GO BIAS REG 1
SVC2.40  EQU       $               M.INCLUDE                        !266
SVC2.40R EQU       $               M.INCLUDE  (RETURN)              !266
         BIAS.CNP  WORD4           BIAS WORD 4 IF PRESENT           !266
         BU        BIAS.R1         GO BIAS REG 1                    !266
*-------------------------------------------------------------------
SVC2.24  EQU       $               M.DELR
SVC2.55  EQU       $               M.BATCH
         RSRC.TYP
CNP.ONLY EQU       $               BIAS ONLY CNP
         BIAS.CNP
         BIAS.LV
*-------------------------------------------------------------------
SVC2.27  EQU       $               M.DEFT
         BIAS.R    4
SVC2.54  EQU       $               M.NEWRRS
         BIAS.R    5
         BU        CNP.R1          GO BIAS CNP AND R1
*-------------------------------------------------------------------
SVC2.28  EQU       $               M.TEMPER
         BIAS.LFC  1               BIAS LFC IN R1
         BU        CNP.R2          GO DO CNP AND R2
*-------------------------------------------------------------------
SVC2.29  EQU       $               M.LOGR
         BIAS.RLB  2
CNP.R2   EQU       $               BIAS CNP AND R2
         BIAS.CNP
         BU        BIAS.R2         GO BIAS REG 2
*-------------------------------------------------------------------
SVC2.2A  EQU       $               M.MOD
SVC2.31  EQU       $               M.MODU
         BIAS.LFC  1               BIAS R1 IF NOT LFC
         BU        CNP.R6          GO DO CNP AND R6
*-------------------------------------------------------------------
SVC2.2C  EQU       $               M.LOC
         RSRC.TYP
CNP.R6   EQU       $               BIAS CNP AND R6
SVC2.2B  EQU       $               M.REWRIT
SVC2.32  EQU       $               M.REWRTU
         BIAS.CNP
OS15E    ANOP                                                   *238*
*283 BIAS.R6  EQU       $               BIAS R6
SVC2.59  EQU       $               M.VADDR
         ZBM       ERR.VADD,TSK.FLG1,X2      CLEAR M.VADDR ERROR    !283
         LB        R7,6W,X1        GET BYTE ZERO OF USER R6         !283
         BIAS.R    6                                                !283
         CAMB      R7,6W,X1        DID BIAS ROLL OVER 20 BITS?      !283
         BEQ       $+2W            BRANCH IF NOT                    !283
         SBM       ERR.VADD,TSK.FLG1,X2  INDICATE ADDR ERROR        !283
         BIAS.LV
SVC2.59R EQU       $
         ZBM       ERR.VADD,TSK.FLG1,X2      SEE IF BIAS ERROR      !283
         BNS       BIAS.R6          BRANCH IF NOT                   !283
         SBM       4,TSK.RPSD,X2    SET INVALID ADDRESS FOR USER    !283
         ZBM       3,TSK.RPSD,X2    RESET PROTECTED ADDRESS         !283
BIAS.R6  EQU       $               BIAS R6                          !283
         BIAS.R    6                                                !283
         BIAS.LV                                                    !283
*-------------------------------------------------------------------
         IFF       OS.15E,OS15E                                 *238*
SVC2.2E  EQU       $               M.PNAMB
         BIAS.R    4
         BU        CNP.R1          GO BIAS CNP AND R1
*-------------------------------------------------------------------
SVC2.2F  EQU       $               M.PNAM
         BIAS.CNP
         BIAS.LFC  1
OS15E    ANOP                                                   *238*
BIAS.R4  EQU       $               BIAS R4
         BIAS.R    4
         BIAS.LV
*-------------------------------------------------------------------
         IFF       OS.15E,OS15E                                 *238*
SVC2.41  EQU       $               M.EXCLUDE
         BIAS.CNP
         LB        R6,1W,X1
         BZ        BIAS.R1         IF NAME POINTER, BIAS AS ADDRESS
*  NOW SEE IF IT'S AN ALLOCATION INDEX
         STW       R0,TSK.RET,X2   SAVE RETURN ADDRESS
         LW        R6,1W,R1        FETCH USER'S R1
         XCR       R6,R1           SAVE REG POINTER
         BL        S.TXPM23        GO TEST RESOURCE TYPE
         TRR       R6,R1           RESTORE REG POINTER
         LW        R0,TSK.RET,X2   RESTORE RETURN ADDRESS
         CI        R7,6            IS IT ALLOC INDEX
         BEQ       SVC2.RET        IT'S AN ALLOCATION INDEX, EXIT
         BU        BIAS.R1         BIAS USERS R1
*-------------------------------------------------------------------
SVC2.44  EQU       $               M.LOCK, M.UNLOCK, M.SETSYNC,
         BIAS.CNP                  M.UNSYNC
         LB        R6,5W,X1
         BNZ       SVC2.RET        IF ALLOCATION INDEX THEN LEAVE
OS15E    ANOP                                                   *238*
BIAS.R5  EQU       $               BIAS R5
SVC1.73  EQU       $               M.LOG
         BIAS.R    5
         BIAS.LV
*-------------------------------------------------------------------
         IFF       OS.15E,OS15E                                 *238*
SVC2.48  EQU       $               M.INQUIRY         (OLD 2.48R)
         BIAS.CNP
         BIAS.M    1,4             FAT ADDRESS
         BIAS.M    1,24            FPT ADDRESS
         BIAS.R    1
         LB        R7,17B,X1       FETCH BYTE 1 OF R4
         SRL       R7,4            ISOLATE 1ST NIBBLE
         CI        R7,1            IS IT 0 OR 1?
         BGT       SVC2.48L        IF NOT, THEN ITS ASCII
         BIAS.R    4               IF = 0, THEN R4 IS AN ADDRESS
SVC2.48L LB        R7,20B,X1       GET BYTE 0 OF R5
         BNE       SVC2.RET        IF 0 THEN ADDRESS
         BU        BIAS.R5         BIAS R5
*-------------------------------------------------------------------
SVC2.52  EQU       $               M.ASSN
         LW        R1,1W,X1       FETCH RRS ADDRESS
         BZ        BIAS.R1         BRANCH IF NONE SUPPLIED
         TBM       TSK.SVC,TSK.LVL,X3     BIAS OR RE-BIAS?
         BNS       $+2W            BRANCH IF RE-BIAS
         ADR       R5,R1           BIAS TO FETCH MPX RRS ADDRESS
         TBM       RR.OPEN,RR.OPTS,X1     AUTO OPEN SPECIFIED?
         BNS       SVC2.52M        BRANCH IF NOT
         SBM       TSK.AUTO,TSK.FLG2,X2   INDICATE FCB TO BIAS
SVC2.52M LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         BU        CNP.R1          GO DO CNP AND R1 BIAS
*-------------------------------------------------------------------
SVC2.53  EQU       $               M.DASN
         LB        R6,1W,X1        FETCH USER'S R1  (BYTE 0)
         BNZ       CNP.ONLY        LEAVE, IF ALLOCATION INDEX
         BU        CNP.R1          GO BIAS CNP AND R1
*------------------------------------------------------------------
SVC2.42  EQU       $               M.OPENR
SVC2.43  EQU       $               M.CLOSER
         BIAS.FCB                  BIAS FCB & R1
         BU        CNP.R1          GO BIAS CNP AND R1
*-------------------------------------------------------------------
SVC2.61R EQU       $               M.CMD
         LW        R6,7W,X1        GET USER R7
         BZ        SVC2.61L        BR IF NO CMD FOUND
         SBM       USR.TSAB,TSK.FLG1,X2 USER REF'ING TSA
         SBM       TSK.CMD,TSK.FLG2,X2  SET CMD SVC IN PROGRESS
SVC2.61L BIAS.LV                   EXIT
*-------------------------------------------------------------------
SVC2.62  EQU       $               M.MOVE
         TBM       0,1W,X1        BIT 0 OF R1 SET?
         BS        BIAS.R2         YES, THEN R1 = MPX ADDRESS
         BU        BIAS.R12        GO BIAS R1 AND R2
*-------------------------------------------------------------------
SVC2.7A  EQU       $               M.GETDEF
         LW        R1,1W,X1        GET ADDR OF PARAMETER BLOCK
         TBM       TSK.SVC,TSK.LVL,X3  NEED TO BIAS R1 FIRST
         BNS       GET.UB          BR IF UNBIAS
         ADR       R5,R1           BIAS TO REFERENCE PARM BLK
GET.UB   TRRM      R1,R1           JUST ADDRESS PLEASE
         CAMW      R1,C.TSAD       ABOVE O.S.?
         BLT       BORT.GET        BR IF BAD PARM ADR BLK
         LMW       R6,1W,X1        GET USERS BUFFER ADDRESS
         BZ        $+2W            SKIP IF ZERO                 *232*
         ARMW      R5,1W,X1        BIAS USERS BUFFER ADDRESS
         LW        R1,TSK.REGP,X2  RESTORE REG POINTER
         BU        BIAS.R1         GO BIAS USERS R1
*-------------------------------------------------------------------
SVC2.7DR EQU       $               M.GTSAD                      *233*
         SBM       USR.TSAB,TSK.FLG1,X2 START TSA BIASING       *233*
         BU        BIAS.R1         GO GET REAL TSA ADDRESS      *233*
*-------------------------------------------------------------------
SVC2.AE  EQU       $               M.TSMPC                      *226*
         LW        R1,1W,X1        GET ADDR OF PROCEDURE BLOCK  *226*
         TBM       TSK.SVC,TSK.LVL,X3  NEED TO BIAS R1 FIRST    *226*
         BNS       TPB.UB          BR IF UNBIAS                 *226*
         ADR       R5,R1           BIAS TO REFERENCE PROC BLK   *226*
TPB.UB   TRRM      R1,R1           JUST ADDRESS PLEASE          *226*
         CAMW      R1,C.TSAD       ABOVE O.S.?                  *226*
         BLT       BORT.GET        BR IF BAD PROC BLK ADR       *226*
         LMW       R6,0W,X1        GET SEND BUFFER ADDRESS      *226*
         BZ        $+2W            SKIP IF ZERO                 *232*
         ARMW      R5,0W,X1        BIAS SEND BUFFER ADDRESS     *226*
         LMW       R6,2W,X1        GET RETURN BUFFER ADDRESS    *226*
         BZ        $+2W            SKIP IF ZERO                 *232*
         ARMW      R5,2W,X1        BIAS RETURN BUFFER ADDRESS   *226*
         LW        R1,TSK.REGP,X2  RESTORE REG POINTER          *226*
         BU        BIAS.R1         GO BIAS USERS R1             *226*
OS15E    ANOP                                                   *238*
MO       ANOP                                                   *237*
*-------------------------------------------------------------------
*
*  THIS ROUTINE WILL ESTABLISH THE MAPS FOR THE CURRENT TASK IN
*  THE 'MPX' ENVIRONMENT.
*
*  ON INPUT:
*            1.  CPU = UNMAPPED, or mapped in TXPM env.             !252
*            2.  TSK.RPSD = RETURN PSD
*            3.  INTERRUPTS BLOCKED
*            4.  X2 = DQE CONTEXT ADDRESS
*            5.  If we are mapped, then we are in the TXPM env., and!252
*                MPX's MSD will be set for TXPM (bit 0 off and      !252
*                number of maps set to task's TSABASE)              !252
*  ON OUTPUT:
*            1.  CPU = MAPPED IN THE 'MPX' ENVIORNMENT
*            2.  INTERRUPTS BLOCKED
*            3.  MPX's MSD reset                                    !252
*
*-------------------------------------------------------------------
*
         BOUND     1W
         IFF       C.MPXOUT,MO                                  *237*
MAP.MPX  LH        R1,PTCH.530+1H  GET PATCH AREA ADDRESS
         T.IPU     R7              ARE WE IN IPU
         BNS       $+2W            BR IF NOT
         ADI       R1,CODE.SIZ     PATCH AREA FOR IPU
         STW       R0,SV.R01-CODE.DSP,X1 PUT R0 IN PATCH AREA FOR RESTORE
*
*  IF OVERRUN OF CONFIGURED MAPS, THEN DECREMENT MIDL COUNT
*
         LI        R4,X'3FFC'      CPIX MASK
         LMW       R3,TSK.RPSD+1W,X2    GET RETURN CPIX
         ADMW      R3,C.MPL        ADD IN BASE ADDRESS
         BL        CK.INIT         Check on 32/2000                 !264
         TBM       LW.C2000,LSWITCH On a Seahawk?                   !252
         BS        MM.1            Go if so                         !252
         LB        R6,C.MSD             GET NUMBER OF O/S MAPS
         IFT       C.3227,27.T
         STW       R6,TX.MPL-CODE.DSP,X1 RESTORE WORD 0 OF CPIX 0   !252
*                                  ENTRY IN MPL                     !252
         LD        R6,0W,R3        GET TASKS CNT AND MIDL POINTER
         STD       R6,TX.MPL+2W-CODE.DSP,X1 PUT IN TEMP MPL AS TASK !252
*                                  number 1                         !252
         LW        R4,=X'80004008' NEW BLOCK STATE=BEI, CPIX OF 1
         LW        R5,=X'F30000'   SPAD ADDRESS OF MPL ON CONCEPT
         LW        R0,=X'F50000'   SPAD ADDRESS OF PSD2 ON CONCEPT
27.T     ANOP
         IFF       C.3227,7X.T
         STB       R6,*14W,X1      UPDATE SEGMENT COUNT FOR BPIX
         LW        R6,*0W,X3       GET MSD FOR TASK
         STW       R6,*15W,X1      PUT IN TEMP MPL AS TASK 1
         LW        R0,=X'900000'   SPAD ADDRESS OF PSD2 ON 7X
         LW        R5,=X'830000'   SPAD ADDRESS OF MPL ON 7X
         LW        R4,=X'80004004' RETAIN BLOCK STATE, CPIX OF 1
7X.T     ANOP
         STW       R4,DSP.1+1W-CODE.DSP,X1 SAVE PSD WD 2 IN PATCH AREA
         TRR       R1,R4           PATCH ADDR                       !260
         SBR       R4,0            STAY PRIV'D
         ADI       R4,5            LEFT HW BRANCH ADDR
         STW       R4,DSP.1-CODE.DSP,X1 SAVE WD 1 OF PSD 1
MM.1     LW        R6,PSD.3        GET WD 1 OF RETURN PSD           !260
         LI        R4,X'3FFC'      CPIX MASK
         LMW       R7,TSK.RPSD+1W,X2    GET RETURN PSD CPIX
         TRR       R7,R4           SAVE FOR SPAD LOAD
         IFT       C.3227,SP.03
         SBR       R4,16           SET PRIV BIT (SPAD FORMAT 2X)
SP.03    ANOP
         IFF       C.3227,SP.04
         SBR       R4,0            SET PRIV BIT (SPAD FORMAT 7X)
SP.04    ANOP
         SBR       R7,17           RETAIN BLOCK STATE
         SBR       R7,0            GO MAPPED
         STD       R6,DSP.2-CODE.DSP,X1 PUT IN PATCH AREA           !252
         TRR       R1,R3           PATCH AREA ADDRESS
         TRR       R1,R6           PATCH AREA ADDRESS
         TBM       LW.C2000,LSWITCH A Seahawk?                      !260
         BS        MM.2            Go if so                         !260
         ADI       R6,TX.MPL-CODE.DSP TEMP MPL ADDRESS              !252
*260          ZBM       LW.DOMPL,LSWITCH Do we need to restore the MPL?  !252
*260          BS        MM.2            Go if so                         !252
         TRR       R5,R1           SPAD ADDR TO R1
         TRR       R0,R5           PSD2 SPAD ADDR TO R5
         LW        R0,C.MPL        STD O/S MPL
         TRSC      R6,R1           PUT TEMP MPL IN SPAD
         BU        MM.3            Skip Seahawk code                !252
* ----------------------------------------------------------------- !252
*260 MM.2     LB        R4,SV.CNT                                        !252
*260          LW        R1,SV.MPL       The address of the last          !252
*260 *                                  task's MPL entry                 !252
*260          STB       R4,3B,X1        Restore it                       !252
         SPACE     2
MM.2     LW        R0,*C.MPL       Save this off for a second       !260
         STW       R0,SV.CMPL                                       !260
*  For Seahawk, we take advantage of the fact that we can load the  !260
*  maps and stay unmapped.  This works only on a Seahawk!           !260
         LB        R0,C.MSD                                         !252
         STW       R0,*C.MPL       MPX maps, bit 0 off              !252
         LI        R4,X'3FFC'      CPIX MASK                        !260
         LMW       R4,TSK.RPSD+1W,X2    GET RETURN CPIX             !252
         SBR       R4,17           BEI                              !252
*260          SBR       R4,0            Mapped                           !252
*260          STW       R4,DSP.1+1W-CODE.DSP,X3                          !252
         STW       R4,MPM.HAWK+1W                                   !260
         LPSDCM    MPM.HAWK                                         !260
MM.25    EQU       $               We get here as a result of the   !260
*        preceding LPSDCM.  MPX is mapped in, and we are mapped.    !260
         LW        R0,SV.CMPL      Restore C.MPL                    !260
         STW       R0,*C.MPL                                        !260
MM.3     EQU       $                                                !252
         LW        R6,DSP.ZBM-CODE.DSP,X3 GET ZBM IN.TXPM,TXPMFLGS INSTR *242*
         LW        R7,=X'20002'    GET TWO NOPS
         STW       R7,DSP.ZBM-CODE.DSP,X3 PUT IN DISPATCH AREA      !252
         BU        0W,X3           ESTABLISH OS MAPS & USER MAPS
*
PSD.3    GEN       1/1,5/1,6/0,20/W(MAP.OS)
*
MAP.OS   EQU       $               ENTER HERE WITH OS MAPS ESTABLISHED
         STW       R6,DSP.ZBM-CODE.DSP,X3 RESTORE ORIGINAL INSTRUCTI!252
*260          SBM       0,*C.MPL        Bit 0 back on                    !252
         IFF       MPX.EVNT,DSVCABT                                 !280
         T.IPU     R6,DSVC         CHECK FOR TURBO MODE             !280
*                                  (DON'T CARE ABOUT IPU)           !280
DSVCABT  ANOP                                                       !280
         TRSW      R0              RETURN TO CALLER
         NOP                       FORCE NOP OUT OF EXECUTUION PATH
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
MAP.MPX  TRSW      R0              RETURN TO CALLER             *237*
         NOP                       FORCE NOP OUT OF XEQ PATH    *237*
MO       ANOP                                                   *237*
*
*-------------------------------------------------------------------
*
*  THIS ROUTINE WILL ACCOMPLISH THE RETURN FROM THE TASK DEBUGGER
*  (WHICH WAS EXECUTING IN THE T-XPM ENVIRONMENT) TO H.AID
*  (WHICH WAS EXECUTING IN THE   MPX ENVIRONMENT).
*
*  ON INPUT:
*            1.  R2  = DQE CONTEXT ADDRESS
*            3.  INTERRUPTS BLOCKED
*  ON OUTPUT:
*            CONTROL IS RETURNED TO H.AID AS IF A 'TRSW R0' HAD BEEN
*            DONE BY THE DEBUGGER EXITING ENTRY POINT 6.
*
*-------------------------------------------------------------------
*
RTRN.AID BL        MAP.MPX              ESTABLISH MPX MAPS
         ZBM       DSP.TXPM,TSK.FLG2,X2 CLEAR T-XPM DISP FLAG   *213*
         IFF       C.MPXOUT,MO                                  *237*
         M.TSAD    R6                   GET MPX TSA ADDRESS     *237*
         STW       R6,C.TXPM            SET TSA ADDRESS FOR H.AID
         LI        R6,1                 UNBIAS TSA
         BL        S.TXPM.6             UNBIAS TSA ADDRESSES
         BL        S.TXPM.5             RESET DEBUG HAT TO TRAVIS
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         LW        R6,C.REGS            GET MPX TSA ADDRESS     *237*
         STW       R6,C.TXPM            SET TSA ADDR FOR H.AID  *237*
MO       ANOP                                                   *237*
         LW        R2,C.CURR            FETCH DQE
         ZBM       DQE.ADM,DQE.ATI,X2   DEBU NO LONGER RUNNING
         IFT       C.3227,V.4
         IFF       MPX.EVNT,EVNT
*
*  NOW SWITCH TRAP/INTERRUPT VECTORS BACK TO MPX
*
         V.MPX                          SET SPAD VECTORS TO MPX -CONCEPT
EVNT     ANOP
V.4      ANOP
*
*  ...AND RETURN TO H.AID
*
         LD        R0,CPUREGS           FETCH RETURN + AID STACK PTR
         TRSW      R0                   RETURN TO H.AID
         NOP                       FORCE NOP OUT OF EXECUTION PATH
*
*
*  ROUTINE TO ABORT USER WITH A 'TX02' IF HE,
*
*      ATTEMPTS AN M.CALL OR ATTEMPTS TO USE AN INVALID ADDRESS
*      IN REFERENCING A DATA STRUCTURE (FCB, CNP, PSB, ETC.)
*
*  ON INPUT:  C.TXPM MUST BE AN MPX ADDRESS!!!
*
*  THE FAULTING INSTRUCTION (EITHER AN SVC 0, OR AN SVC 1) IS
*  REPLACED WITH THE ABORT SVC  (SVC 1,X'57') AND CONTROL IS
*  TRANSFERRED TO THE USER IN THE T-XPM ENVIRONMENT SUCH IN ORDER
*  FOR THE USER PROGRAM TO EXECUTE THE ABORT SVC.  WE DO THIS, SINCE
*  H.TXPM HAS NO OTHER WAY TO ABORT THE CURRENT TASK.  H.TXPM CANNOT
*  EXECUTE SVC'S SINCE H.TXPM IS NOT CURRENTLY REENTRANT.
*
SVC0.ABT BL        MAP.MPX         ESTABLISH MPX MAPS
         LW        R5,TX02         TX02 ABORT CODE
BORT.USR LW        R1,TSK.REGP,X2  GET REG POINTER
         STW       R5,5W,X1        SET ABORT CODE
         TBM       DSP.TXPM,TSK.FLG2,X2 TXPM DISPATCH?
         BS        BORT.0          BRANCH IF SO
         IFT       C.3227,SP.04
         IFF       MPX.EVNT,EVNT
*
*  RESET BASE SPAD POINTER FOR TRAP & INTERRUPT VECTORS
*
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R6              IPU TASK
         BS        V.6             BR IF YES
MO       ANOP                                                   *237*
         V.MPX                     SET SPAD VECTORS TO MPX (CONCEPT)
         IFF       C.MPXOUT,MO                                  *237*
         BU        V.5             CONTINUE
V.6      EQU       $               RESET IPU SPAD
         V.MPXI                    RESET TRAPS ONLY ON IPU
V.5      EQU       $
MO       ANOP                                                   *237*
EVNT     ANOP
SP.04    ANOP
*
*  HERE, MPX IS EXECUTING; SO ABORT WITH EXTENDED MESSAGE
*
         IFF       C.MPXOUT,MO                                  *237*
         LI        R6,1
         BL        S.TXPM.6        BIAS TSA ADDRESS (FOR MPX)
         T.IPU     R6              SEE IF IN IPU
         BNS       $+2W            SKIP IPU RESET IF NOT
MO       ANOP                                                   *237*
         ZBM       IN.TXPM,TXPMFLGS    M.CALL'S WILL GET OUT
         LW        R1,TSK.REGP,X2  GET ADDRESS OF REGS
         TRR       R2,R4           SAVE CONTEXT ADDRESS
         LD        R2,EXTCODE      '  H.TXPM'
         LW        R5,5W,X1       RESTORE ABORT CODE
         ZR        R6
         ZR        R7
         IFF       OS.15E,OS15E                                 *238*
         M.CALL    H.REXS,28         ABORT SELF
         M.CALL    H.REXS,18         EXIT
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         M.CALL    H.MONS,28         ABORT SELF                 *238*
         M.CALL    H.MONS,18         EXIT                       *238*
OS15E    ANOP                                                   *238*
*   WE SHOULD EXIT AT THIS POINT, BUT IF NOT WE NEED TO RESTORE
*   R2 FOR CODE BELOW.
         TRR       R4,R2           RESTORE CONTEXT ADDRESS
         IFF       C.MPXOUT,MO                                  *237*
BORT.0   TBM       TSK.TSAB,TSK.FLG1,X2   IS TSA RE-BIASED?
         BS        BORT.1          BRANCH IF ALREADY BIASED
         ZR        R6
         BL        S.TXPM.6        RE-BIAS TSA ADDRESSES (FOR T-XPM)
BORT.1   T.IPU     R6              SEE IF IN IPU
         BS        BORT.2          NO UPDATE FOR AID IN IPU
         M.TSAD    R6              GET MPX TSA ADDRESS          *237*
         SUMW      R6,TSK.BIAS,X2  BIAS FOR TXPM ENVIRONMENT
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
BORT.0   LW        R6,C.REGS       GET TSA ADDRESS              *237*
MO       ANOP                                                   *237*
         STW       R6,C.TXPM       SET TSA ADDRESS FOR H.AID
BORT.2   LW        R1,TSK.DQE,X2   GET DQE ADDRESS
         LW        R1,DQE.PSSB,X1  FETCH OLD T-XPM PSD ADDRESS
         LD        R6,0W,X1        FETCH OLD PSW
         SUI       R6,1W           BACK UP TO FAULTING INSTRUCTION
         ZBR       R6,30           Ensure word address              !255
         STD       R6,TSK.RPSD,X2  USE OLD PSD AS RETURN PSD
         TRR       R6,R1
         IFF       C.MPXOUT,MO                                  *237*
         ADMW      R1,TSK.BIAS,X2  MAKE AN MPX ADDRESS
MO       ANOP                                                   *237*
         LW        R5,BORT.SVC     FETCH 'SVC 1,X'57''
         IFF       C.MPXOUT,MO                                  *237*
         STW       R5,0W,X1        INSERT ABORT AT FAULTING ADDRESS
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         STCW      R5,0W,X1        INSERT ABORT AT FAULTING ADDR*237*
MO       ANOP                                                   *237*
         BL        MAP.TXPM        GO ABORT USER
*
EXTCODE  DATAD     C'  H.TXPM'
*
*  POSSIBLE TXPM ABORT CODES
*
TX01     DATAW     G'TX01'
TX02     DATAW     G'TX02'      TXPM TASK ATTEMPTING SVC TYPE 0
         IFF       C.MPXOUT,MO                                  *237*
TX03     DATAW     G'TX03'      TXPM TASK USING AID, BUT AID NOT MAPPED
TX04     DATAW     G'TX04'      INVALID CNP ADDRESS
TX05     DATAW     G'TX05'      INVALID FCB ADDRESS
TX06     DATAW     G'TX06'      INVALID RCB ADDRESS
TX07     DATAW     G'TX07'      INVALID RLB ADDRESS
TX08     DATAW     G'TX08'      INVALID PSB ADDRESS
TX09     DATAW     G'TX09'      INVALID PRB ADDRESS
TX10     DATAW     G'TX10'      INVALID RXB ADDRESS
TX11     DATAW     G'TX11'      INVALID TCB ADDRESS
TX12     DATAW     G'TX12'      PSB BUSY
TX13     DATAW     G'TX13'
TX14     DATAW     G'TX14'
TX15     DATAW     G'TX15'      BAD PARAMETER BLOCK ADDRESS
TX16     DATAW     G'TX16'      CPU IN TURBO SVC MODE               !280
MO       ANOP                                                   *237*
*
BORT.SVC SVC       1,X'57'
         IFF       C.MPXOUT,MO                                  *237*
         IFF       OS.15E,OS15E                                 *238*
*
*  ROUTINE TO BIAS A CNP (IF SUPPLIED IN R7)
*
*  ON INPUT:
*
*     R1 = REGISTER SAVE AREA ADDRESS
*     R2 = DQE CONTEXT ADDRESS
*     R3 = CURRENT INTERRUPT LEVEL
*     R5 = TXPM BIAS DIFFERENCE (+ OR -)
*     R7   MUST BE PRESERVED !!!
*
CNP.BIAS LW         R6,7W,X1        FETCH CNP ADDRESS
         BZ         NO.CNP          BRANCH IF NOT SUPPLIED
         TBM        TSK.SVC,TSK.LVL,X3   BIAS OR UNBIAS?
         BNS        CK.CNP          BRANCH IF BIAS
*271          SBM        TSK.CNP,TSK.LVL,X3   INDICATE CNP SUPPLIED
         SBM        TSK.CNP,TSK.SVCI,X3 INDICATE CNP SUPPLIED       !271
         BU         EXST.CNP
*271 CK.CNP   ZBM        TSK.CNP,TSK.LVL,X3   WAS A CNP SUPPLIED?
CK.CNP   ZBM        TSK.CNP,TSK.SVCI,X3 WAS A CNP SUPPLIED?         !271
         BNS        NO.CNP          NO, SO LEAVE
EXST.CNP BIAS.M     7,CP.ABRET      BIAS CNP ERROR ADDRESS
         IFT        OS.35,BPRT.001                                  !266
         TRR        R1,R6           SAVE REG SAVE ADDRESS           !265
         ZBR        R2,1            DOING M.INCLUDE?                !266
         BNS        NO.PADR         BRANCH IF NOT                   !266
         LW         R1,7W,X1        GET CNP ADDRESS                 !265
         TBM        TSK.SVC,TSK.LVL,X3   BIAS OR RE-BIAS?           !265
         BNS        $+2W            BRANCH IF RE-BIAS               !265
         ADR        R5,R1           MUST BIAS TO ACCESS CNP         !265
         CAMW       R1,C.TSAD       ABOVE OS?                       !265
         BLT        BORT.CNP                                        !265
         LW         R1,2W,X1        GET CNP FLAGS WORD              !265
         XCR        R1,R6           REG SAVE ADDR BACK TO R1        !265
         TBR        R6,4            PARTITION ADDRESS SUPPLIED?     !265
         BNS        NO.PADR         BRANCH IF NOT                   !265
         BIAS.M     7,4W            BIAS PARTITION START ADDRESS    !265
BPRT.001 ANOP                                                       !265
NO.PADR  ZBM        TSK.AUTO,TSK.FLG2,X2   WAS AUTO OPEN REQESTED?  !265
         BNS        NO.FCB          IF SO, FCB ADDRESS (IF SUPPLIED)
         LW         R1,7W,X1       FETCH CNP ADDRESS
         TBM        TSK.SVC,TSK.LVL,X3   BIAS OR RE-BIAS?
         BNS        $+2W            BRANCH IF RE-BIAS
         ADR        R5,R1           MUST BIAS TO ACCESS CNP
         CAMW       R1,C.TSAD       ABOVE OS?
         BLT        BORT.CNP
         LMW        R1,CP.FCBA,X1   FCB SUPPLIED IN CNP?
         BZ         NO.FCB          BRANCH IF FCB ADDRESS NOT IN CNP
         T.IPU      R6              SEE IF IN IPU
         BS         $+3W            SKIP IF YES
         STW        R0,SAVE0        SAVE RETURN ADDRESS
         BU         $+2W            SKIP ON
         STW        R0,SAVEI        SAVE IPU RETURN ADDRESS
         BL         FCB.BIAS        OTHERWISE, BIAS FCB
         T.IPU      R6              SEE IF IN IPU
         BS         $+3W            SKIP IF YES
         LW         R0,SAVE0        SAVE RETURN ADDRESS
         BU         $+2W            SKIP ON
         LW         R0,SAVEI        SAVE IPU RETURN ADDRESS
         LW         R1,TSK.REGP,X2  GET REG SAVE ADDRESS
         BIAS.M     7,CP.FCBA       BIAS CNP FCB ADDRESS
NO.FCB   LW         R1,TSK.REGP,X2  GET REG SAVE ADDRESS
         BIAS.R     7              BIAS CNP ADDRESS
*
NO.CNP   TRSW      R0              RETURN
SAVE0    RES       1W
SAVEI    RES       1W              IPU SAVE ADDRESS
OS15E    ANOP                                                   *238*
*
*  ROUTINE TO BIAS FILE CONTROL BLOCK ADDRESSED BY R1
*
*  ON INPUT:
*
*     R1 = FCB ADDRESS
*     R2 = DQE CONTEXT ADDRESS
*     R3 = CURRENT INTERRUPT LEVEL
*     R5 = TXPM BIAS DIFFERENCE (+ OR -)
*     R7 = 1, IF THIS IS AN I/O SVC; 0 OTHERWISE
*
FCB.BIAS TRRM      R1,R1           KEEP 20 BIT FCB ADDRESS
         TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       FCB.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS R1 IN ORDER TO REFERENCE FCB
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.FCB
         SBM       FCB.BSED,FCB.SPST,X1  INDICATE FCB IS BIASED
         BS        FCB.BRET        LEAVE IF ALREADY BIASED
         ZBM       FCB.FBIT,FCB.SPST,X1  CLEAR FBIT INDICATOR
         ZBM       FCB.EA,FCB.SPST,X1    CLEAR EA   INDICATOR
         BU        FCB.MRG
FCB.UB   TBM       0,FCB.GCFG,X1   NO-WAIT I/O
         BNS       FCB.UB1         GO UNBIAS IF WAIT OPERATION
         CI        R7,1            IS THIS AN I/O OPERATION?
         BEQ       FCB.BRET        IF SO, DON'T UNBIAS YET!
FCB.UB1  ZBM       FCB.BSED,FCB.SPST,X1  INDICATE FCB IS BIASED
         BNS       FCB.BRET        LEAVE IF ALREADY BIASED
FCB.MRG  CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.FCB
         LMW       R6,FCB.FATA,X1  FAT ADDRESS
         BZ        $+2W
         ARMW      R5,FCB.FATA,X1  BIAS FAT ADDRESS
         TBM       6,FCB.GCFG,X1   SHORT FCB?
         BNS       FCB.SHRT        SKIP BIAS OF NO-WAIT ADDRESSES
         TBM       0,FCB.GCFG,X1   NO-WAIT I/O
         BNS       FCB.WEXP        GO UNBIAS IF WAIT OPERATION
***      NO-WAIT I/O AND EXPANDED FCB
         LMW       R6,FCB.NWOK,X1  FETCH NO-WAIT END-ACTION ADDRESS
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,FCB.NWOK,X1  BIAS NO-WAIT END-ACTION ADDRESS
         LMW       R6,FCB.NWER,X1  FETCH NO-WAIT ERROR RETURN ADDRESS
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,FCB.NWER,X1  BIAS NO-WAIT ERROR RETURN ADDRESS
         BU        FCB.EXP         GO MERGE WITH EXPANDED FCB
***      EXPANDED FCB AND WAIT I/O
FCB.WEXP LMW       R6,FCB.ERRT,X1  WAIT I/O ERROR RETURN ADDRESS
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,FCB.ERRT,X1  BIAS ERROR RETURN ADDRESS
***      EXPANDED FCB AND EITHER WAIT OR NO-WAIT I/O
FCB.EXP  EQU       $                                            *238*
         IFF       OS.15E,OS15E                                 *238*
         LMW       R6,FCB.BBA,X1   FETCH USER BLOCKING BUFFER ADDRESS
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,FCB.BBA,X1   BIAS USER BLOCKING BUFFER ADDRESS
OS15E    ANOP                                                   *238*
         TBM       FCB.ECP,FCB.SPST,X1 IS THIS AN EXECUTE CHAN PROG
         BNS       FCB.NCP         IF NOT, GO BIAS BUFFER ADDRESS
         TBM       2,FCB.GCFG,X1   IS THIS A PHYSICAL CHANNEL PROGRAM?
         BNS       FCB.NCP         IF NOT, GO BIAS BUFFER ADDRESS
*
         M.TSAD    R3              GET TSA ADDRESS              *237*
         LW        R4,=X'FFFFFF'   3 CHAR LFC MASK
         LNB       R6,T.FILES,X3   NEG CNT OF FPT'S
         LW        R2,T.FPTA,X3    BASE ADDR OF FPT'S
         LMW       R3,FCB.LFC,X1   FCB'S LFC
         CMMW      R3,FPT.LFC,X2   IS THIS OUR LFC
         BEQ       FCB.01          BR IF LFC FOUND
         ADI       R2,FPT.SIZE     NEXT FPT
         BIB       R6,$-3W         LOOP FOR ALL FPT'S
         BU        FCB.XIT         NOT FOUND, EXIT
*
FCB.01   LW        R2,FPT.FATA,X2  GET FAT ADDRESS
         LH        R3,DFT.CDTX,X2  GET CDT INDEX
         XCR       R3,R5           SAVE BIAS VALUE
         MPI       R4,CDT.SIZE     TIMES SIZE PER ENTRY
         ADMW      R5,C.CDTA       CDT BASE ADDRESS
         XCR       R5,R3           NEED IT IN AN INDEX REG
         LW        R4,ADR.MASK     RESTORE ADDRESS MASK
         LB        R6,CDT.CLAS,X3  GET I/O CLASS
         CI        R6,X'0F'        IS THIS HSD 'D' CLASS
         BNE       FCB.XIT         DO NOT BIAS IOCL ADDRESS IF TRUE
         LMW       R6,FCB.ERWA,X1  FETCH IOCL ADDRESS FOR F-CLASS I/O
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,FCB.ERWA,X1  BIAS IOCL ADDRESS
FCB.XIT  LW        R4,ADR.MASK     RESTORE MASK
         M.TSAD    R2              GET TSA ADDRESS              *237*
         LW        R2,T.PRNO,X2    GET DQE ADDRESS
         LW        R2,DQE.PSSF,X2  GET CONTEXT ADDRESS
         LW        R3,TSK.LVLP,X2  RESTORE LEVEL POINTER
         BU        FCB.BRET
*
         IFF       OS.15E,OS15E                                 *238*
* HERE WE WANT TO TEST FOR I/O CALLS TO ACX32 (X.25) HANDLER    *219*
* AND IF SO CALL SPECIAL BIASING ROUTINE IN H.PTCH              *219*
*
OS15E    ANOP                                                   *238*
FCB.NCP  EQU       $               LOOK FOR OH.QSXIO HANDLER    *223*
         IFF       OS.15E,OS15E                                 *238*
         TRR       R7,R7           IS THIS AN I/O SVC           *219*
         BZ        FCB.NCPY        BR IF NOT                    *219*
*
* IF HERE, EXTENDED FCB, NO CHAN PROG, AND NOT OPEN/CLOSE SVC   *219*
* JUST A STD I/O SVC.  THE FCB SHOULD HAVE BEEN OPENED.         *219*
*
         M.TSAD    R3              GET TSA ADDRESS              *237*
         LW        R4,=X'FFFFFF'   3 CHAR LFC MASK              *223*
         LNB       R6,T.FILES,X3   NEG CNT OF FPT'S             *223*
         LW        R2,T.FPTA,X3    BASE ADDR OF FPT'S           *223*
         LMW       R3,FCB.LFC,X1   FCB'S LFC                    *223*
         CMMW      R3,FPT.LFC,X2   IS THIS OUR LFC              *223*
         BEQ       FAT.01          BR IF LFC FOUND              *223*
         ADI       R2,FPT.SIZE     NEXT FPT                     *223*
         BIB       R6,$-3W         LOOP FOR ALL FPT'S           *223*
         BU        FAT.XIT         NOT FOUND, EXIT              *223*
*
FAT.01   LW        R2,FPT.FATA,X2  GET FAT ADDRESS              *223*
         LH        R3,DFT.CDTX,X2  GET CDT INDEX                *223*
         XCR       R3,R5           SAVE BIAS VALUE              *223*
         MPI       R4,CDT.SIZE     TIMES SIZE PER ENTRY         *223*
         ADMW      R5,C.CDTA       CDT BASE ADDRESS             *223*
         XCR       R5,R3           NEED IT IN AN INDEX REG      *223*
         LW        R4,ADR.MASK     RESTORE ADDRESS MASK         *223*
         LMW       R3,CDT.SIHA,X3  GET HAT ADDRESS              *219*
         BZ        FAT.XT          BR IF NONE                   *219*
         LW        R3,7W,X3        GET POSSIBLE HANDLER NAME    *219*
         CAMW      R3,=C'N.QS'     SEE IF QUAD SYNC HANDLER     *219*
         BNE       FAT.XT          IT'S NOT, CONTINUE           *219*
         M.TSAD    R2              GET TSA ADDRESS              *237*
         LW        R2,T.PRNO,X2    GET DQE ADDRESS              *223*
         LW        R2,DQE.PSSF,X2  GET CONTEXT ADDRESS          *223*
         LW        R3,TSK.LVLP,X2  RESTORE LEVEL POINTER        *223*
*
* HERE R0 - RETURN ADDR                                         *219*
*      R1 - BIASED FCB ADDRESS                                  *219*
*      R2 - CONTEXT ADDR                                        *219*
*      R3 - CURR LEVEL POINTER                                  *219*
*      R4 - ADDRESS MASK                                        *219*
*      R5 - SIGNED BIAS VALUE                                   *219*
*      R6 - DON'T CARE                                          *223*
*      R7 - I/O IND = 1                                         *219*
*
         BU        ACX.BIAS        GO TO BIAS ROUTN IN H.PTCH   *219*
*
FAT.XIT  LW        R4,ADR.MASK     RESTORE ADDRESS MASK         *223*
FAT.XT   EQU       $               NO ON.QSXIO HANDLER          *223*
         M.TSAD    R2              GET TSA ADDRESS              *237*
         LW        R2,T.PRNO,X2    GET DQE ADDRESS              *223*
         LW        R2,DQE.PSSF,X2  GET CONTEXT ADDRESS          *223*
         LW        R3,TSK.LVLP,X2  RESTORE LEVEL POINTER        *223*
*
OS15E    ANOP                                                   *238*
FCB.NCPY LMW       R6,FCB.ERWA,X1  FETCH BUFFER ADDRESS         *219*
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,FCB.ERWA,X1  BIAS BUFFER ADDRESS
         BU        FCB.BRET
*
***      SHORT FCB AND EITHER WAIT OR NO-WAIT I/O
FCB.SHRT LMW       R6,FCB.TCW,X1   FETCH TCW
         BZ        FCB.S1          BIAS IF NON-ZERO
         ZBR       R6,12           'F' BIT SET?
         BNS       $+2W            BRANCH IF NOT
         SBM       FCB.FBIT,FCB.SPST,X1   INDICATE 'F' BIT IN USE
         ZBM       12,FCB.TCW,X1   AVOID CARRY INTO XFER COUNT FIELD
         ZBM       FCB.EA,FCB.SPST,X1   EXTENDED ADDRESS IN USE?
         BNS       FCB.S           BRANCH IF NOT
         SBM       12,FCB.TCW,X1   SET EXTENDED ADDRESS FOR RE-BIAS
         SBR       R6,12
FCB.S    ARMW      R5,FCB.TCW,X1   BIAS TCW
         ADR       R5,R6           COMPUTE FINAL DATA ADDRESS
         ZBR       R6,12           WILL BIASED ADDRESS FIT IN FCB
         BNS       FCB.S0          BRANCH IF BIASED ADDRESS WILL FIT
         TRR       R5,R5           RE-BIAS?
         BN        $+2W            BRANCH IF RE-BIAS
         SBM       FCB.EA,FCB.SPST,X1     INDICATE ADDRESS OVERFLOW
         ZBM       12,FCB.TCW,X1   CLEAR 'F' BIT (DUE TO OVERFLOW)
FCB.S0   ZBM       FCB.FBIT,FCB.SPST,X1   'F' BIT IN USE?
         BNS       $+2W            BRANCH IF NOT
         SBM       12,FCB.TCW,X1   RESET 'F' BIT
FCB.S1   TBM       0,FCB.GCFG,X1   NO-WAIT I/O
         BS        FCB.BRET        LEAVE IF NO-WAIT I/O
***      SHORT FCB AND WAIT I/O
         LMW       R6,FCB.ERRT,X1  WAIT I/O ERROR RETURN ADDRESS
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,FCB.ERRT,X1  BIAS WAIT I/O ERROR RETURN ADDRESS
*
FCB.BRET TRSW      R0              RETURN
*
*  ROUTINE TO BIAS A CHANNEL PROGRAM WHOSE FCB ADDRESS IS IN R1
*
*  ON INPUT:  R1 = FCB ADDRESS (MUST PRESERVE)
*
ECP.BIAS TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       ECP.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS R1 IN ORDER TO REFERENCE FCB
         LW        R7,FCB.ERWA,X1  FETCH ADDRESS OF CHANNEL PROGRAM
         ZBM       FCB.BSED,FCB.SPST,X1  CLEAR FCB BIASED BIT
         SBM       FCB.ECP,FCB.SPST,X1   SET EXECUTE CHAN PGM BIT
         ADR       R5,R7           BIAS
         BU        ECP.MRG
ECP.UB   TBM       0,FCB.GCFG,X1   NO-WAIT I/O
         BS        ECP.BRET        DON'T UNBIAS YET!
         ZBM       FCB.ECP,FCB.SPST,X1 RESET EXECUTE CHAN PGM BIT
         LW        R7,FCB.ERWA,X1  FETCH ADDRESS OF CHANNEL PROGRAM
ECP.MRG  LMW       R6,FCB.EQTY,X1  FETCH SENSE BUFFER ADDRESS
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,FCB.EQTY,X1  BIAS SENSE BUFFER ADDRESS
         TBM       2,FCB.GCFG,X1   IS THIS A PHYSICAL CHANNEL PROGRAM?
         BS        ECP.BRET        IF SO, DON'T BIAS IOCL
         M.TSAD    R3              GET TSA ADDRESS              *237*
         LW        R4,=X'FFFFFF'   3 CHAR LFC MASK
         LNB       R6,T.FILES,X3   NEG CNT OF FPT'S
         LW        R2,T.FPTA,X3    BASE ADDR OF FPT'S
         LMW       R3,FCB.LFC,X1   FCB'S LFC
         CMMW      R3,FPT.LFC,X2   IS THIS OUR LFC
         BEQ       ECP.01          BR IF LFC FOUND
         ADI       R2,FPT.SIZE     NEXT FPT
         BIB       R6,$-3W         LOOP FOR ALL FPT'S
         BU        ECP.XIT         NOT FOUND, EXIT
ECP.01   LW        R2,FPT.FATA,X2  GET FAT ADDRESS
         LH        R3,DFT.CDTX,X2  GET CDT INDEX
         XCR       R3,R5           SAVE BIAS VALUE
         MPI       R4,CDT.SIZE     TIMES SIZE PER ENTRY
         ADMW      R5,C.CDTA       CDT BASE ADDRESS
         XCR       R5,R3           NEED IT IN AN INDEX REG
         LW        R4,ADR.MASK     RESTORE ADDRESS MASK
         LB        R6,CDT.CLAS,X3  GET I/O CLASS
         CI        R6,X'0D'        IS THIS HSD 'D' CLASS
         BNE       ECP.CF          ELSE ASSUME 'F' CLASS
         XCR       R7,R1           CHANNEL PROGRAM ADDRESS TO R1
         SUI       R1,4W           HSD HAS 4W IOCD'S
NXT.HSD  ADI       R1,4W           POINT TO NEXT HSD IOCD
NXT.TIC  TBM       1,0B,X1         SEE IF CMD TRANSFER
         BS        $+4W            SKIP BIAS IF CMD TRANSFER
         LMW       R6,1W,X1        FETCH DATA ADDRESS IN IOCD
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,1W,X1
         TBM       CCHAIN+6,0W,X1  COMMAND CHAIN? (HSD BIT 6, WD 0)
         BS        NXT.HSD         YES, GO TAKE CARE OF NEXT IOCD
         TBM       DCHAIN+6,0W,X1  DATA CHAIN?  (HSD BIT 7, WD 0)
         BS        NXT.HSD         YES, GO TAKE CARE OF NEXT IOCD
         TBM       5,0W,X1         IS THIS A TIC? (BIT 5, WD 0)
         BNS       ECP.XIT         DONE WITH IOCL IF NOT
         LMW       R1,1W,X1        GET BIASED TIC ADDRESS
         TRR       R5,R5           IS TIC ADDR MPX OR TXPM
         BGE       NXT.TIC         BR IF MPX ADDR
         SUR       R5,R1           IT'S TXPM, MAKE IT MPX
         BU        NXT.TIC         CONT PROCESSING IOCL AFTER TIC
*
ECP.CF   XCR       R7,R1           CHANNEL PROGRAM ADDRESS TO R1
         SUI       R1,IOCD.LEN
NXT.IOCD ADI       R1,IOCD.LEN     POINT TO NEXT IOCD
         LMW       R6,,X1          FETCH DATA ADDRESS IN IOCD
         BZ        $+2W            BIAS IF NON-ZERO
         ARMW      R5,,X1
         TBM       CCHAIN,1W,X1    COMMAND CHAIN?
         BS        NXT.IOCD        YES, GO TAKE CARE OF NEXT IOCD
         TBM       DCHAIN,1W,X1    DATA CHAIN?
         BS        NXT.IOCD        YES, GO TAKE CARE OF NEXT IOCD
ECP.XIT  LW        R4,ADR.MASK     RESTORE MASK
         M.TSAD    R2              GET TSA ADDRESS              *237*
         LW        R2,T.PRNO,X2    GET DQE ADDRESS
         LW        R2,DQE.PSSF,X2  GET CONTEXT ADDRESS
         LW        R3,TSK.LVLP,X2  RESTORE LEVEL POINTER
         TRR       R7,R1           RESTORE FCB ADDRESS
*
ECP.BRET LI        R7,1            INDICATE I/O OPERATION
         TRSW      R0              RETURN
         IFF       OS.15E,OS15E                                 *238*
*
*  THIS ROUTINE WILL BIAS AN 'RCB' DATA STRUCTURE
*
*  ON INPUT:   R1 = ADDRESS OF RCB (RESOURCE CREATE BLOCK)
*
RCB.BIAS TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       RCB.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS TO REFERENCE RCB
RCB.UB   TRRM      R1,R1           KEEP 20 BIT FCB ADDRESS
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.RCB
         LMW       R6,RCB.FAST,X1  FETCH FILE ID ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,RCB.FAST,X1  BIAS
         TRSW      R0              ...AND RETURN
*
*  THIS ROUTINE WILL BIAS AN 'RLB' DATA STRUCTURE
*
*  ON INPUT:   R1 = ADDRESS OF RLB (RESOURCE CREATE BLOCK)
*
RLB.BIAS TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       RLB.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS TO REFERENCE RLB
RLB.UB   TRRM      R1,R1           KEEP 20 BIT RLB ADDRESS
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.RLB
         LMW       R6,RLB.TGT,X1   PN OR RID VECTOR
         BZ        RLB.1           SKIP IF 0
         T.IPU     R7              ARE WE IN IPU
         BS        $+3W            BR IF YES
         STD       R0,RLB.REG0     SAVE REGS 0+1 FOR CPU
         BU        $+2W            SKIP OVER IPU SAVE
         STD       R0,RLB.REGI
         XCR       R6,R1
         TRR       R5,R5           BIAS OR RE-BIAS?
         BN        $+2W            BRANCH IF RE-BIAS
         ADR       R5,R1           BIAS TO REFERENCE FCB
         BL        S.TXPM23        ASCERTAIN RESOURCE TYPE
         BS        RLB.0           BRANCH IF UNKNOWN
         CI        R7,4            IS IT AN FCB?
         BNE       RLB.0           BRANCH IF NOT
         T.IPU     R7              ARE WE IN IPU
         BS        $+3W            BR IF YES
         LD        R0,RLB.REG0     GET REGS 0+1 FOR CPU
         BU        $+2W            SKIP OVER IPU SAVE
         LD        R0,RLB.REGI     GET REGS 0+1 FOR IPU
         LW        R1,RLB.TGT,X1   FETCH FCB ADDRESS
         BL        FCB.BIAS        BIAS FCB
RLB.0    T.IPU     R7              ARE WE IN IPU
         BS        $+3W            BR IF YES
         LD        R0,RLB.REG0     SAVE REGS 0+1 FOR CPU
         BU        $+2W            SKIP OVER IPU SAVE
         LD        R0,RLB.REGI     GET REGS 0+1 FOR IPU
         ARMW      R5,RLB.TGT,X1   BIAS
RLB.1    LMW       R6,RLB.BUFA,X1  BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,RLB.BUFA,X1  BIAS
         LMW       R6,RLB.DIRA,X1  DIRECTORY BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,RLB.DIRA,X1  BIAS
         LMW       R6,RLB.FCB,X1   FCB ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,RLB.FCB,X1   BIAS
         TRSW      R0              ...AND RETURN
         BOUND     1D
RLB.REG0 RES       1D              CPU SAVE AREA
RLB.REGI RES       1D              IPU SAVE AREA
OS15E    ANOP                                                   *238*
*
*  THIS ROUTINE WILL BIAS AN 'PSB' DATA STRUCTURE
*
*  ON INPUT:   R1 = ADDRESS OF PSB (PARAMETER SEND BLOCK)
*
PSB.BIAS TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       PSB.UB          NO, BECAUSE THIS IS AN RE-BIAS
         ADR       R5,R1           BIAS TO REFERENCE PSB
         BU        PSB.MRG
PSB.UB   TBM       PSB.NWM,PSB.OPT,X1    NO-WAIT REQUEST?
         BNS       PSB.MRG         WAIT MODE UNBIAS NOW
         TBM       PSB.NCBM,PSB.OPT,X1  NO CALL BACK OPTION
         BNS       PSB.RET         CALL BACK SPECIFIED, NO UNBIAS NOW
         ZBM       PSB.OIP,PSB.CST,X1   CLEAR ACTIVE BIT (REXS ERROR)
*                                  UNBIAS NOW, NO CALL BACK SPECIFIED
PSB.MRG  TRRM      R1,R1           KEEP 20 BIT PSB ADDRESS
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.PSB
         TBM       TSK.SVC,TSK.LVL,X3   BIAS OR RE-BIAS?
         BNS       PSB.01          NO, BECAUSE THIS IS AN RE-BIAS
         TBM       PSB.OIP,PSB.CST,X1    IS PSB BUSY?
         BS        BORT.BSY        MUST ABORT USER WITH 'TX12'
PSB.01   EQU       $                                                !245
         IFF       OS.15E,NO.15                                     !245
         LW        R6,PSB.TSKN,X1  IF WD 0 OF PSB=0 WD 2 IS PNV OR  !245
*                                  RIDV                             !245
         BNZ       PSB.02          WE HAVE TASK NUM OR NAME
         LMW       R6,PSB.TSKN+1W,X1  GET PNV OR RID VECT
         BZ        $+2W            SKIP IF ZERO
         ARMW      R5,PSB.TSKN+1W,X1  BIAS VECTOR ADDRESS
NO.15    ANOP                                                       !245
PSB.02   LMW       R6,PSB.SBA,X1   FETCH SEND BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,PSB.SBA,X1   BIAS
         LMW       R6,PSB.RBA,X1   FETCH RECV BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,PSB.RBA,X1   BIAS
         LMW       R6,PSB.EAA,X1   FETCH END-ACTION BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,PSB.EAA,X1   BIAS
PSB.RET  TRSW      R0              RETURN
*
*  THIS ROUTINE WILL BIAS A TASK ACTIVATION PARAMETER BLOCK
*
*  ON INPUT:   R1 = ADDRESS OF TAB (TASK ACTIVATION BLOCK)
*
TAB.BIAS TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       TAB.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS TO REFERENCE TAB
TAB.UB   TRRM      R1,R1           KEEP 20 BIT TAB ADDRESS
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.PSB
         LW        R6,2W,X1        SEE IF TASK NAME OR RID,PNV SUPPLIED
         BNZ       TAB.RET         RETURN IF^TASK NAME
         LMW       R6,3W,X1        FETCH VECTOR ADDRESS
         BZ        TAB.RET         SKIP IF 0
         ARMW      R5,3W,X1        BIAS RID VECTOR OF PNV
TAB.RET  TRSW      R0              ...AND RETURN
*
*  THIS ROUTINE WILL BIAS AN 'PRB' DATA STRUCTURE
*
*  ON INPUT:   R1 = ADDRESS OF PRB (PARAMETER RECEIVE BLOCK)
*
PRB.BIAS TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       PRB.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS TO REFERENCE PRB
PRB.UB   TRRM      R1,R1           KEEP 20 BIT PRB ADDRESS
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.PRB
         LMW       R6,PRB.RBA,X1   FETCH RECV BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R5,PRB.RBA,X1   BIAS
         TRSW      R0              ...AND RETURN
*
*  THIS ROUTINE WILL BIAS AN 'RXB' DATA STRUCTURE
*
*  ON INPUT:   R1 = ADDRESS OF RXB (RESOURCE CREATE BLOCK)
*
RXB.BIAS TBM       TSK.SVC,TSK.LVL,X3   NEED TO BIAS REGISTER 1 FIRST?
         BNS       RXB.UB          NO, BECAUSE THIS IS AN UNBIAS
         ADR       R5,R1           BIAS TO REFERENCE RXB
RXB.UB   TRRM      R1,R1
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.RXB
         LMW       R6,RXB.RBA,X1   FETCH RETURN PARAMETER BUFFER ADDR.
         BZ        $+2W            SKIP IF 0
         ARMW      R5,RXB.RBA,X1   BIAS
         TRSW      R0              ...AND RETURN
*
*  CAPTURE ILLEGAL ADDRESS ABORTS
*
BORT.MEM LW        R5,TX01
         BU        BORT.USR
BORT.CNP LW        R5,TX04
         BU        BORT.USR
BORT.FCB LW        R5,TX05
         BU        BORT.USR
BORT.RCB LW        R5,TX06
         BU        BORT.USR
BORT.RLB LW        R5,TX07
         BU        BORT.USR
BORT.PSB LW        R5,TX08
         BU        BORT.USR
BORT.PRB LW        R5,TX09
         BU        BORT.USR
BORT.RXB LW        R5,TX10
         BU        BORT.USR
BORT.TCP LW        R5,TX11
         BU        BORT.USR
BORT.BSY LW        R5,TX12
         BU        BORT.USR
BORT.IOH LW        R5,TX13         IOCH ERROR
         BU        BORT.USR
BORT.GET LW        R5,TX15         SVC 2,7A PARAM BLK ADDR ERR
         BU        BORT.USR
BORT.TUR LW        R5,TX16         CPU IN TURBO MODE                !280
         BU        BORT.USR                                         !280
*
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.B (TSA TRAP FIX)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.B (TSA TRAP FIX)
TTL.TMPX ANOP                                                       !259
*
*--------------------------------------------------------------------
*
*  THIS ROUTINE DOES THE FOLLOWING:
*
*  1.  THIS CODE IS AN EXTENSION OF THE UNIMPLEMENTED INSTRUCTION
*      TRAP PROCESSOR WHILE IN A TXPM TASK.  IT GETS THE TSA ADDRESS
*      FOR THE USER WHEN IN THE TXPM ENVIRONMENT. I.E.
*             TSA ADDRESS - TXPM BIAS = TXPM TSA ADDRESS
*  2.  SETS USR.TSAB SO THE TSA CAN BE BIASED/UNBIASED FOR THE USER.
*
*        R0=CC'S & OLD PSD ADDR + 10W
*        R1=TRAPPING PSD ADDRESS
*        R2=CONTEXT ADDR
*        R3=TRAP CONTEXT ADDRESS
*        R4=DQE ADDRESS
*        R5=?
*        R6=?
*        R7=TRAP CODE (4)
*
         BOUND     1W
S.TXPM.B EQU       $               GET TSA ADDRESS
         IFF       C.3227,S.B.01
*  ALL ERRORS FOR 7X GO TO SAME PLACE
*  MUST TEST FOR UNIMPLEMENTED INSTRUCTION
         TBM       12,4W,X1        SEE IF UI TRAP IN 1ST STATUS WD
         BNS       ST.MRG          LET MPX PROCESS IT IF NOT
S.B.01   ANOP
         TRR       R4,R7           SAVE DQE ADDRESS
         LW        R4,=X'7FFFF'    19_BIT ADDRESS
         LMW       R6,0W,R1        GET EXECUTION ADDRESS
         SUI       R6,1H           BACK UP PC
         ZBR       R6,30           WORD BOUND
         LI        R4,X'3FFC'      CPIX MASK
         LMW       R1,1W,X1        GET CPIX
         BZ        S.B.RET         EXIT IF NO CURR TASK
         TRR       R6,R4           SAVE COPY OF ADDRESS
         ADMW      R1,C.MPL        CALC TASK MPL ADDR
         IFT       C.3227,S.B.27
         LW        R1,1W,X1        GET REAL T.MIDL ADDR
S.B.27   ANOP
         IFF       C.3227,S.B.7X
         LW        R1,*0W,X1       GET T.MIDL ADDRESS
S.B.7X   ANOP
         SRL       R6,SHIFTA       REL MAP NUM OF INSTR
         TRR       R6,R5           USED TO CALC START MAP ADDR
         SLL       R5,SHIFTA       MAKE IT AN ADDRESS
         SUR       R5,R4           R4=REL OFFSET IN MAP
         SUMB      R6,TSK.NMAP,X2  MINUS SIZE OF TXPM OS
         SLL       R6,1            H/W BIAS
         ADR       R6,R1           R1 = CORRECT MAP DESCR
         LH        R1,0H,X1        GET MAP NUMBER
         SLL       R1,SHIFTA       MAKE REAL ADDRESS
         ADR       R4,R1           ADD IN MAP OFFSET
         LW        R4,0W,X1        GET INSTRUCTION
         SRLD      R4,16           JUST LOOK AT 1ST HALF
         CI        R4,X'409'       UI INSTR?
         BNE       S.B.RET         RETURN IF NOT
         ZR        R4              CLEAR FOR SHIFT
         SLLD      R4,6            GET THE OP CODE
         SRL       R5,27           MAKE REG NUM A WORD INDEX
         ADMW      R5,TSK.REGP,X2  R5=POINTS TO DEST REG
         TRR       R5,R1           WE NEED AN INDEX REG
         M.TSAD    R5              GET OUR TSA ADDRESS          *237*
         SUMW      R5,TSK.BIAS,X2  MAKE IT A TXPM TSA ADDRESS   *237*
*237*    LB        R5,TSK.NMAP,X2  GET NUM OF MAPS IN OS        *237*
*237*    SLL       R5,SHIFTA       MAKE IT OUR TSA ADDRESS      *237*
         CI        R4,X'2B'        WAS IT A LOAD
         BEQ       A.LOAD          BR IF IT WAS
         CI        R4,X'2E'        IS IT ADD
         BEQ       A.ADD           BR IF IT IS
         TRN       R5,R5           NEG FOR BIAS
A.ADD    ADMW      R5,0W,X1        ADD TO DESTINATION REG
A.LOAD   STW       R5,0W,X1        SAVE IN DESTINATION REG
         LW        R1,TSK.RET,X2   TRAP CONTEXT ADDRESS
         LD        R6,0W,X1        GET OLD PSD
         SUI       R6,1H           BACK UP 1HW
         IFF       C.3227,LRB      CODE FOR L/R HW BIT IN PSW
         ZBR       R6,6            CLEAR RIGHT HW FLAG IN PSD1
LRB      ANOP
         ZBR       R6,30           WORD BOUND
         ADI       R6,1W           SKIP OVER THIS INSTRUCTION
         STD       R6,TSK.RPSD,X2  SAVE RETURN PSD
         SBM       USR.TSAB,TSK.FLG1,X2  START TSA BIASING
         BL        MAP.MPX         MAP IN MPX FOR TSA REBIAS
         ZR        R6              RE-BIAS
         BL        S.TXPM.6        BIAS TSA FOR TXPM ENVIRONMENT
         T.IPU     R4              ARE WE IN IPU
         BS        MAP.41          BR IF YES
         BEI                       MAKE SURE INTS BLOCKED
         LI        R4,-1           DECR C.GINT
         ARMW      R4,C.GINT       DECR COUNTER
         BU        MAP.41          GO REMAP TO TXPM ENVIRONMENT
* ......NO RETURN.......
S.B.RET  LW        R1,TSK.RET,X2   GET OLD PSD ADDRESS
         TRR       R7,R4           RESTORE DQE ADDRESS
         LI        R7,4            GET TRAP CODE
         BU        ST.MRG          RETURN TO TRAP PROCESSING CODE
MO       ANOP                                                   *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.C (TSA TRAP FIX)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.C (TSA TRAP FIX)
TTL.TMPX ANOP                                                       !259
*
*--------------------------------------------------------------------
*
*  THIS ROUTINE DOES THE FOLLOWING:
*
*  1.  THIS CODE HANDLES UNDEFINED TRAPS/INTERRUPTS THAT THE USER
*      HAS NOT DEFINED TO TXPM DURING SYSGEN.  THEY WILL BE TYPE
*      1 (OLD T-SHUT) AND HAVE #255 (#254 FOR IPU) DEFINED.  AN
*      IMMEDIATE RETURN TO INTERRUPT CONTEXT WILL FOLLOW EVENT
*      RECORDING.
*
*        R0=CC'S & OLD PSD ADDR + 10W
*        R1=TRAPPING PSD ADDRESS
*        R2=CONTEXT ADDR
*        R3=TRAP CONTEXT ADDRESS
*        R4=DQE ADDRESS
*        R5=?
*        R6=?
*        R7=TRAP CODE (255) (254 FOR IPU)
*
         BOUND     1W
*                                  PROCESS UNDEFINED INT/TRAP
S.TXPM.C LD        R6,0W,X1        GET OLD PSD
         STD       R6,TSK.RPSD,X2  SAVE RETURN PSD
         SUI       R6,1H           BACH UP 1HW
         IFF       C.3227,LRBX     CODE FOR L/R HW BIT IN PSW
         ZBR       R6,6            CLEAR RIGHT HW FLAG IN PSD1
LRBX     ANOP
         ZBR       R6,30           WORD BOUND
*
*  SET UP FOR EVENT RECORD
*
         LI        R1,1            USE OLD TSHUT EVENT TYPE
         BL        REC.EVNT        GO RECORD EVENT
         BU        MAP.41          GO RETURN TO TXPM ENVIRONMENT
*
         IFF       C.MPXOUT,MO                                  *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.5 (RESET DBHAT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.5 (RESET DBHAT)
TTL.TMPX ANOP                                                       !259
*
*-----------------------------------------------------------------------
*
*  RESET DEBUGGER HAT IN TSA TO POINT TO TRAVIS
*
*  CALLED BY:  S.TXPM.3, DURING TASK ACTIVATION (AND OVERLAY LOAD).
*
         BOUND     1W
S.TXPM.5 LA        R6,DBHAT
         M.TSAD    R1              FETCH TSA ADDRESS            *237*
         LW        R7,T.DBHAT,X1   FETCH OLD DBHAT
*261          CAR       R1,R7
*261          BLE       TRV5.RET        CONTINUE IF ALREADY SET TO TRAVIS
*  The check commented out above assumed that the TSA was always    !261
*  below the debugger.  This is no longer the case with 3.4U03      !261
*  and above (moved TSA stuff).                                     !261
         CAR       R6,R7           Do we already have it there?     !261
         BEQ       TRV5.RET        Go if so                         !261
         STW       R7,TSK.DBHT,X2  SAVE IN DQE CONTEXT AREA
         STW       R6,T.DBHAT,X1   MAKE T.DBHAT POINT TO TRAVIS
TRV5.RET TRSW      R0              RETURN
*
MO       ANOP                                                   *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.5 (TXPM  DBHAT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.5 (TXPM  DBHAT)
TTL.TMPX ANOP                                                       !259
*-------------------------------------------------------------------
*
*  NEW 'HAT' FOR DEGUBER  (6 ENTRY POINTS)
*
*  THIS HAT IS SET UP BY S.TXPM.5
*
         BOUND     1W
DBHAT    DATAW     6
         ACW       DBG.EP1
         ACW       DBG.EP2
         ACW       DBG.EP3
         ACW       DBG.EP4
         ACW       DBG.EP5
         ACW       DBG.EP6
*
*---------------------------------------------------------------------
*
*  ENTER HERE WHEN H.EXEC IS ATTEMPTING TO DISPATCH TO THE TASK
*  DEBUGGER WHICH IS ATTACHED TO A 'NO-MPX' TASK.
*
*  IDENTIFY EACH DEBUG ENTRY POINT (IN R1) SO WE CAN PICK UP THE
*  'REAL' DEBUGGER DESTINATION ADDRESS.
*
DBG.EP1  BEI
         LI        R1,1
         BU        DBG.BIAS
DBG.EP2  BEI
         LI        R1,2
         BU        DBG.MRG
DBG.EP3  BEI
         LI        R1,3
         BU        DBG.BIAS
DBG.EP4  BEI
         LI        R1,4
         BU        DBG.MRG
DBG.EP5  BEI
         LI        R1,5
         BU        DBG.BIAS
DBG.EP6  BEI
         STF       R0,CPUREGS      STORE THE H.AID REGS TO PASS TO MPXDB
         LI        R1,6
         BU        DBG.MRG
*-------------------------------------------------------------------
*
*  ENTER HERE WITH R1 SET TO THE APPROPRIATE DEBUGGER ENTRY POINT #.
*  NOW, FIND REAL DEBUGGER ENTRY ADDRESS AND DISPATCH TO DEBUGGER
*  AFTER CHANGING THE ENVIRONMENT TO 'NOMPX'
*
DBG.BIAS LW        R3,C.CURR       GET DQE ADDRESS
         STB       R1,DQE.PSSB+4B,X3    SAVE DEBUG NUMBER
         LW        R2,DQE.PSSF,X3  GET TXPM CONTEXT ADDRESS
         STW       R3,TSK.DQE,X2   SAVE DQE ADDRESS
         LW        R3,TSK.LVLP,X2  GET CURRENT LEVEL POINTER
*
*  THIS ROUTINE WILL BIAS THE USER'S REGISTERS IN THE TASK CONTEXT
*  AREA.  THIS ROUTINE IS CALLED WHEN THE OS IS RETURNING TO THE
*  DEBUGGER AT THE TASK ABORT ENTRY POINT.  WE NEED TO UNBIAS THE USER'S
*  REGISTERS IF WE WERE EXECUTING AN SVC AT THE TIME OF THE ABORT.
*
*  ON INPUT :   R2  = DQE CONTEXT ADDRESS
*  ON OUTPUT:   USER'S REGISTERS ARE BIASED IN T.CONTXT
*
         SEA                       INSURE WE ARE EXTENDED       *237*
         ZBM       TSK.SVC,TSK.LVL,X3  WERE WE EXECUTING AN SVC?
         IFF       C.MPXOUT,MO                                  *237*
         BNS       BRT.LV          NO, SO JUST RETURN
         M.TSAD    R1              FETCH TSA ADDRESS            *237*
         LA        R1,T.CONTXT,X1  FETCH USER'S REG ADDRESS
         STW       R1,TSK.REGP,X2  SAVE POINTER TO REGS
         LB        R1,TSK.SVCT,X3   FETCH SVC TYPE
         LW        R4,ADR.MASK     ADR.MASK  FETCH 20 BIT ADDRESS MASK
         LNW       R5,TSK.BIAS,X2  FETCH BIAS DIFFERENCE
         ZR        R7              I/O SVC INDICATOR
*237*    SEA                                                    *237*
         ZBM       TSK.SVC1,TSK.SVCI,X3  IS IT A TYPE 1?        *219*
         BNS       BRT.M2.0        NOPE, IT MUST BE ANOTHER TYPE*219*
*
*  HERE, SVC IS TYPE 1                                          *219*
*
         CAMH      R1,C.SVTN       SVC > MAX SVC 1 NUMBER
         BGT       BRT.L           BRANCH IF SVC IS > MAXIMUM
         ADMW      R1,SVC1OUT      ADD TABLE START ADDRESS NUM
         BU        BRT.MG          MERGE WITH SVC 2 PROCESSING
*
BRT.M2.0 ZBM       TSK.SVC1,TSK.SVCI,X3  IS IT A TYPE 1?        *219*
         BNS       BRT.M3.0        NOPE, IT MUST BE ANOTHER TYPE*219*
*
*  HERE, SVC IS TYPE 2                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,C.SVTN2      IS SVC > MAX SVC 2 NUMBER
         BGT       BRT.L           BRANCH IF SVC IS > MAXIMUM
         ADMW      R1,SVC2OUT      ADD STARTING TABLE ADDRESS
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         CAMH      R1,C.SVTN       SVC > MAX SVC 1 NUMBER       *238*
         BGT       BRT.L           BRANCH IF SVC IS > MAXIMUM   *238*
         ADMW      R1,SVC1OUT      ADD TABLE START ADDRESS NUM  *238*
OS15E    ANOP                                                   *238*
*
BRT.MG   LB        R1,0B,X1        GET BIAS ROUTINE NUMBER
         SLL       R1,2            MAKE WORD OFFSET
         ADMW      R1,VTBLA        ADD STARTING VECT TBL ADDR
         LW        R1,0W,X1        GET ADDRESS OF SVC ROUTINE
BRT.MGC  STW       R1,TSK.RET,X2   SAVE ADDRESS TO DISPATCH TO      !273
*270          LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER
RSXF.5   LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER       !268
*  The above instruction will be replaced by a BL RSX_FIX on 'Hawks !268
         BL        *TSK.RET,X2     DISPATCH TO SVC BIAS ROUTINES
         BU        BRT.L           CONTINUE PROCESSING          *219*
*
BRT.M3.0 ZBM       TSK.SVCL,TSK.SVCI,X3 M.CALL?                     !273
         BNS       BRT.M3.1        Go if no                         !273
         LA        R7,CLU.TBL      Unbias routines                  !273
         BL        MCL.DSPA        Get bias routine address         !273
         BU        BRT.MGC         Merge for M.CALL                 !273
BRT.M3.1 ZBM       TSK.SVC6,TSK.SVCI,X3  IS IT A TYPE 6?        *219*
         BNS       BRT.M4.0        NOPE, IT MUST BE ANOTHER TYPE*219*
*
*  HERE, SVC IS TYPE 6                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTN6     IS SVC > MAX SVC 6 NUMBER    *219*
*258          BGT       BRT.L           BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       BRT.L           BRANCH IF SVC IS > MAXIMUM       !258
         ADMW      R1,SVC6OUT      ADD STARTING TABLE ADDRESS   *219*
         BU        BRT.MGX         MERGE WITH SVC PROCESSING    *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        BRT.L           CONTINUE PROCESSING          *238*
OS15E    ANOP                                                   *238*
*
BRT.M4.0 ZBM       TSK.SVC7,TSK.SVCI,X3  IS IT A TYPE 7?        *219*
         BNS       BRT.M5.0        NOPE, IT MUST BE ANOTHER TYPE*219*
*
*  HERE, SVC IS TYPE 7                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTN7     IS SVC > MAX SVC 7 NUMBER    *219*
*258          BGT       BRT.L           BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       BRT.L           BRANCH IF SVC IS > MAXIMUM       !258
         ADMW      R1,SVC7OUT      ADD STARTING TABLE ADDRESS   *219*
         BU        BRT.MGX         MERGE WITH SVC PROCESSING    *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        BRT.L           CONTINUE PROCESSING          *238*
OS15E    ANOP                                                   *238*
*
BRT.M5.0 ZBM       TSK.SVCE,TSK.SVCI,X3  IS IT A TYPE E?        *219*
         BNS       BRT.L           NOPE, IT MUST BE ANOTHER TYPE*219*
*
*  HERE, SVC IS TYPE E                                          *219*
*
         IFF       OS.15E,OS15E                                 *238*
         CAMH      R1,X.SVCTNE     IS SVC > MAX SVC E NUMBER    *219*
*258          BGT       BRT.L           BRANCH IF SVC IS > MAXIMUM   *219*
         BGE       BRT.L           BRANCH IF SVC IS > MAXIMUM       !258
         ADMW      R1,SVCEOUT      ADD STARTING TABLE ADDRESS   *219*
         BU        BRT.MGX         MERGE WITH SVC PROCESSING    *219*
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         BU        BRT.L           CONTINUE PROCESSING          *238*
OS15E    ANOP                                                   *238*
         IFF       OS.15E,OS15E                                 *238*
*
BRT.MGX  LB        R1,0B,X1        GET BIAS ROUTINE NUMBER      *219*
         SLL       R1,2            MAKE WORD OFFSET             *219*
*258          ADMW      R1,XVTBLA       ADD STARTING VECT TBL ADDR   *219*
*258          LW        R1,0W,X1        GET ADDRESS OF SVC ROUTINE   *219*
         LW        R1,XVTBLA,X1    GET ADDRESS OF SVC ROUTINE       !258
         STW       R1,TSK.RET,X2   SAVE ADDRESS TO DISPATCH TO  *219*
*270          LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER   *219*
RSXF.6   LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER       !268
*  The above instruction will be replaced by a BL RSX_FIX on 'Hawks !268
         BL        *TSK.RET,X2     DISPATCH TO SVC BIAS ROUTINES*219*
OS15E    ANOP                                                   *238*
*
BRT.L    LW        R1,TSK.REGP,X2  GET REGISTER STACK POINTER   *226*
         LW        R4,8W,X1        FETCH PSW                    *226*
         ANMW      R4,=X'FFFFF'    ISOLATE ADDRESS              *214*
         CAMW      R4,C.TSAD       ABORT IN OS?
         BGE       NOT.OS          BRANCH IF NOT
         ARMW      R5,8W,X1        BIAS PSW SAVED IN STACK
NOT.OS   LF        R0,0W,X1        GET THE BIASED REGS
         STF       R0,CPUREGS      SAVE LOCALLY
         LW        R2,C.CURR
         LB        R1,DQE.PSSB+4B,X2    RESTORE DEBUG #
BRT.LV   EQU       $
MO       ANOP                                                   *237*
DBG.MRG  LW        R3,C.CURR       GET DQE ADDRESS              *226*
         STB       R1,DQE.PSSB+4B,X3    SAVE DEBUG NUMBER       *226*
         LW        R2,DQE.PSSF,X3  GET TXPM CONTEXT ADDRESS     *226*
         STW       R3,TSK.DQE,X2   SAVE DQE ADDRESS             *226*
         SEA                       DEBUG MAY BE IN EXTENDED MEMORY!
         LA        R3,CPUREGS      GET REG SAVE AREA ADDRESS
         STW       R3,TSK.REGP,X2  SAVE IN CONTEXT AREA
         LW        R5,TSK.DBHT,X2  FETCH ADDRESS OF DEBUGGER'S HAT
         IFF       C.MPXOUT,MO                                  *237*
         LNW       R6,TSK.BIAS,X2  FETCH TASK BIAS
         ARMW      R6,2W,X3        BIAS USER REG 2 (FOR DEBUG EP 6)
         M.TSAD    R3              FETCH TSA ADDRESS            *237*
         STW       R5,T.DBHAT,X3   RESET MPX DBHAT WHILE DBG RUNNING
         SLL       R1,2            MAKE ENTRY POINT # A WORD OFFSET
         ADR       R5,R1           ADDRESS OF ENTRY POINT ADDRESS
         LW        R6,,X1          FETCH ENTRY POINT ADDRESS
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
         LW        R3,C.REGS       FETCH TSA ADDRESS            *237*
         STCW      R5,T.DBHAT,X3   RESET MPX DBHAT FOR DBG      *237*
         SLL       R1,2            MAKE EP # A WORD OFFSET      *237*
         ADR       R5,R1           ADDRESS OF ENTRY POINT ADDR  *237*
         LCW       R6,,X1          FETCH ENTRY POINT ADDRESS    *237*
MO       ANOP                                                   *237*
         SBR       R6,0            MAKE PRIVILEGED
*
*  NOW BUILD PSD WORD 2
*
         LW        R3,C.CURR
         SBM       DQE.ADM,DQE.ATI,X3   INDICATE DEBUGGER IS RUNNING
         LB        R7,DQE.NUM,X3   FETCH DQE NUMBER
         IFT       C.3227,DBG.2X
         SLL       R7,3            SHIFT FOR CPIX
DBG.2X   ANOP
         IFF       C.3227,DBG.7X
         SLL       R7,2            SHIFT FOR CPIX (7X IS WORD OFFSET)
DBG.7X   ANOP
         SBR       R7,0            MAKE MAPPED
*
*  NOW BLOCK INTERRUPTS & CHANGE TO 'NOMPX'
*
         BEI                       BLOCK THE INT'S
         STD       R6,TSK.RPSD,X2  UPDATE RETURN PSD
         LI        R7,X'10'        DEBUG IS INT LEVEL 4
         STB       R7,TSK.ATI,X2   UPDATE SIL IN DQE CONTEXT AREA
         LA        R4,TSK.LVL0,X2  GET BASE LEVEL ADDR
         ADR       R4,R7           ADJUST TO CURRENT LEVEL
         LB        R4,TSK.NORM,X2  GET OVERRUN MAPS
         SRC       R4,8            PUT IN UPPER BYTE            *214*
         ORR       R4,R7           MERGE WITH LVL POINTER
         STW       R7,TSK.LVLP,X2  SAVE IN CONTEXT AREA
         BU        NSVC.RET        GO DISPATCH TO DEBUGGER IN 'NO-MPX'
*                                  ENVIRONMENT
         IFF       C.MPXOUT,MO                                  *237*
         IFT       OS.15E,OS15E                                 *238*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.6 (BIAS TSA)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.6 (BIAS TSA)
TTL.TMPX ANOP                                                       !259
*---------------------------------------------------------------------
*
*  THIS ROUTINE WILL BIAS/UNBIAS ALL TSA ADDRESSES
*
*  ON INPUT:   R6 = 0, RE-BIAS ALL ADDRESSES (FOR T-XPM ENVIRONMENT)
*                 = 1, BIAS    ALL ADDRESSES (FOR MPX   ENVIRONMENT)
*              R2 = CONTEXT AREA ADDRESS
*
*  ON OUTPUT:  ALL TSA ADDRESSES ARE BIASED/BIASED
*
*  CALLED BY:  S.TXPM.2 AND S.TXPM.1
*
         BOUND     1W
S.TXPM.6 M.TSAD    R3              FETCH TSA ADDRESS            *237*
         LW        R4,ADR.MASK     20 BIT ADDRESS MASK
         LW        R7,TSK.BIAS,X2  FETCH BIAS DIFFERENCE
         CI        R6,0            BIAS OR RE-BIAS
         BNE       TRAV.6.1        BRANCH IF BIAS (FOR MPX ENVIRONMENT)
         SBM       TSK.TSAB,TSK.FLG1,X2   INDICATE TSA IS RE-BIASED
         BS        TXPM.6.L        LEAVE IF ALREADY RE-BIASED
         TRN       R7,R7           NEGATE
         LW        R5,T.LINBUF,X3  GET LINE BUFFER ADDRESS
         BZ        BB.ERR          NO BIAS REQUIRED
* HERE WE MUST SAVE LINBUF ADDRESS AND ALLOCATE BLOCKING BUFFER
* TO MOVE THE LINBUF INTO TO USER CAN REFERENCE LINE BUFFER IN
*  A TXPM TASK.
         LW        R1,TSK.LVL5,X2  GET SAVED BB ADDRESS
         BNZ       TRAV.6.5        GOT ONE, SO JUST COPY CONTENT
         LNB       R6,T.BBUFN,X3   GET # BB'S
         BZ        BB.ERR          BR IF NONE TO ALLOCATE
         LW        R1,T.BBUFA,X3   GET FIRST BB ADDRESS
         BU        $+3W            SKIP OVER INITIAL CODE
         TBM       4,0W,X1         IS BB AVAILABLE
         BS        $+4W            BR IF AVAILABLE
         ADI       R1,192W         NEXT BB
         BIB       R6,$-3W         CHECK THEM ALL
         BU        BB.ERR          BR IF NONE THERE
         STW       R1,TSK.LVL5,X2  SAVE BB ADDRESS IN CONTEXT AREA
         ZMD       0W,X1           CLEAN AND ALLOCATE IT
TRAV.6.5 STW       R5,1W,X1        SAVE OLD LINE BUFFER ADDRESS IN BB
         ADI       R1,1D           START LINBUF AT 2ND DW OF BB
         STW       R1,T.LINBUF,X3  PUT IN TSA
         ARMW      R7,T.LINBUF,X3  BIAS NEW LINE BUFFER ADDRESS
         ZBM       TSK.CMD,TSK.FLG2,X2  IS THERE A M.CMD IN PROGRESS
         BNS       TRAV.6.4        BR IF NOT
         LW        R3,TSK.REGP,X2  GET CURRENT REG POINTER
         LW        R6,7W,X3        GET USERS REG
         SUR       R5,R6           GET DELTA
         ADR       R1,R6           CALC NEW ADDRESS
         STW       R6,7W,X3        UPDATE USERS REG 7
         ARMW      R7,7W,X3        BIAS USERS REG
TRAV.6.4 TRR       R5,R3           GET OLD LINE BUFFER ADDRESS
         LB        R6,16B,X3       GET NUMBER OF WORDS IN LINBUF
         ADI       R6,1            PLUS 1W ROUNDING
         SRL       R6,1            MAKE DW COUNT
         TRN       R6,R6           USE AS LOOP COUNT
         LD        R4,0W,X3        GET LINE BUFFER DOUBLE WORD
         STD       R4,0W,X1        PUT IN BB
         ADI       R1,1D           NEXT BB LOCATION
         ADI       R3,1D           NEXT LINBUF LOC
         BIB       R6,$-4W         LOOP FOR ALL
         M.TSAD    R3              RESTORE TSA ADDRESS          *237*
         LW        R4,ADR.MASK     RELOAD 20 BIT MASK
BB.ERR   LNB       R5,T.FILES,X3   NUMBER OF FPT'S
         LW        R3,T.FPTA,X3    FPT POINTER
*
         BU        TRAV.6.2
TRAV.6.1 ZBM       TSK.TSAB,TSK.FLG1,X2   INDICATE TSA IS BIASED
         BNS       TXPM.6.L               LEAVE IF ALREADY BIASED
         LW        R5,T.LINBUF,X3  GET LINE BUFFER ADDRESS      *212*
         BZ        TRAV.6.3        NO RE-BIAS REQUIRED          *212*
         LW        R1,TSK.LVL5,X2  GET SAVED BLOCKING BUFF ADDR
         BZ        TRAV.6.3        BR IF NON
         LW        R5,1W,X1        GET OLD LINE BUFFER ADDRESS
         STW       R5,T.LINBUF,X3  REPLACE LINE BUFFER ADDRESS
TRAV.6.3 LNB       R5,T.FILES,X3   GET NUMBER OF FPT'S
         LW        R3,T.FPTA,X3    FETCH FPT POINTER
         ADR       R7,R3           BIAS FPT POINTER
*
*  FIRST, BIAS FILE POINTER TABLE ENTRIES
*
TRAV.6.2 LMW       R6,1W,X3        FETCH FCB ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R7,1W,X3        BIAS FCB ADDRESS
         LMW       R6,2W,X3        FETCH FATA ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R7,2W,X3        BIAS FATA ADDRESS
         ADI       R3,3W           POINT TO NEXT FPT
         BIB       R5,TRAV.6.2     GO BIAS NEXT FPT ENTRY
         M.TSAD    R3              RESTORE TSA ADDRESS          *237*
*----------------------------------BIAS ALL KNOWN TSA ADDRESSES
         ARMW      R7,T.BIAS,X3    DSECT START
         ARMW      R7,T.TEND,X3    TSA ENDING ADDRESS
         IFF       OS.15E,OS15X                                 *238*
         ARMW      R7,T.FSSP,X3    CURRENT PUSH DOWN LEVEL
         ARMW      R7,T.LAST,X3    LAST LOGICAL ADDRESS
OS15X    ANOP                                                   *238*
         ARMW      R7,T.FATA,X3    FILE ASSIGNMENT TABLE
         ARMW      R7,T.FPTA,X3    FILE POINTER TABLE
         ARMW      R7,T.END,X3     LAST DSECT LOCATION
*264          IFT       OS.34U03,I343   ONLY IN 34U03                *232*
*264          ARMW      R7,T.TSAEND,X3  BIAS END OF TSA ADDRESS      *232*
*264 I343     ANOP                                                   *232*
*266          IFT       OS.35,I35       ONLY IN 35                   *232*
*266          ARMW      R7,T.TSAEND,X3  BIAS END OF TSA ADDRESS      *232*
*266          ARMW      R7,T.TSAOR,X3   BIAS TSA ORIGIN              *233*
*266 I35      ANOP                                                   *232*
         ARMW      R7,T.TRAD,X3    TRANSFER ADDRESS OF MAIN SEGMENT
         IFT       OS.32X,NOMIDLA
         ARMW      R7,T.MIDLA,X3   MAP IMAGE DESCRIPTOR LIST
         ARMW      R7,T.MEMLA,X3   MEMORY ATTRIBUTE TABLE
NOMIDLA  ANOP
         ARMW      R7,T.REGP,X3    CURRENT PUSHDOWN ADDRESS
         IFF       OS.15E,OS15X                                 *238*
         ARMW      R7,T.BASEP,X3   FILE SYSTEM BUFFER ADDRESS
OS15X    ANOP                                                   *238*
         ARMW      R7,T.VATA,X3    VOLUME ASSIGNMENT TABLE ADDRESS
         IFF       OS.15E,OS15X                                 *238*
         ARMW      R7,T.SEGA,X3    SEGMENT DEFINITION AREA ADDRESS
OS15X    ANOP                                                   *238*
*----------------------------------BIAS ALL CONDITIONAL TSA ADDRESSES
         LMW       R6,T.CONTXT+8W,X3    DEBU CONTEXT PSW
         BZ        $+2W
         ARMW      R7,T.CONTXT+8W,X3    TASK DEBUGGER CONTEXT PSW
         IFF       OS.15E,OS15X                                 *238*
         LMW       R6,T.FIRST,X3
         BZ        $+2W
         ARMW      R7,T.FIRST,X3   FIRST LOGICAL ADDRESS
OS15X    ANOP                                                   *238*
         LMW       R6,T.DBHAT,X3
         BZ        $+2W
         ARMW      R7,T.DBHAT,X3   TASK DEBUGGER HAT
         IFF       OS.15E,OS15X                                 *238*
         LMW       R6,T.EXCPAD,X3
         BZ        $+2W
         ARMW      R7,T.EXCPAD,X3  ARITHEMETIC EXCP. HANDLER
OS15X    ANOP                                                   *238*
         LMW       R6,T.ABRTA,X3
         BZ        $+2W
         ARMW      R7,T.ABRTA,X3   ABORT RECEIVER ADDRESS
         LMW       R6,T.BBUFA,X3
         BZ        $+2W
         ARMW      R7,T.BBUFA,X3   BLOCKING BUFFER ADDRESS
         LMW       R6,T.BREAK,X3
         BZ        $+2W
         ARMW      R7,T.BREAK,X3   BREAK RECEIVER ADDRESS
         IFF       OS.15E,OS15X                                 *238*
         LMW       R6,T.SYCF,X3
         BZ        $+2W
         ARMW      R7,T.SYCF,X3    SYC DEDICATED FAT
         LMW       R6,T.SGOF,X3
         BZ        $+2W
         ARMW      R7,T.SGOF,X3    SGO DEDICATED FAT
         LMW       R6,T.SLOF,X3
         BZ        $+2W
         ARMW      R7,T.SLOF,X3    SLO DEDICATED FAT
         LMW       R6,T.SBOF,X3
         BZ        $+2W
         ARMW      R7,T.SBOF,X3    SBO DEDICATED FAT
OS15X    ANOP                                                   *238*
         LMW       R6,T.MSGR,X3
         BZ        $+2W
         ARMW      R7,T.MSGR,X3    MESSAGE RECEIVER ADDRESS
         LMW       R6,T.CURH,X3
         BZ        $+2W
         ARMW      R7,T.CURH,X3    CURRENT HIGH DSECT ADDRESS
         LMW       R6,T.CRHX,X3
         BZ        $+2W
         ARMW      R7,T.CRHX,X3    CURRENT HIGH EXTENDED ADDRESS
         IFT       OS.32X,NOIDXA
         LW        R6,T.IDXA,X3
         SLL       R6,8
         SRA       R6,8            ISOLATE OVERLAY TABLE ADDRESS
         BNP       $+2W
         ARMW      R7,T.IDXA,X3    OVERLAY TABLE ADDRESS
NOIDXA   ANOP
TXPM.6.L M.TSAD    R3              RESTORE TSA ADDRESS          *237*
         TRSW      R0
OS15E    ANOP                                                   *238*
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.7 (DEBUG MOVE)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.7 (DEBUG MOVE)
TTL.TMPX ANOP                                                       !259
*-------------------------------------------------------------------
*
*  THIS ROUTINE PERFORMS A MOVE (FOR THE DEBUGGER) FROM/TO AN
*  AN MPX ADDRESS TO/FROM A NOMPX ADDRESS.  THIS ROUTINE IS NECESSARY
*  FOR THE DEBUGGER TO ACCESS THE CURRENT TASKS DQE, WHICH MAY NOT
*  BE MAPPED IN SINCE THE DEBUGGER IS EXECUTING IN THE NOMPX ENVIRONMENT
*
*  ON INPUT:
*
*             R2 = DQE ADDRESS
*             USER'S   R1 = MPX MAPPED ADDESS
*                      R2 = NOMPX MAPPED ADDRESS (BIASED)
*                      R3 = NUMBER OF WORDS TO XFER
*                           IF + GO FROM MPX ADDRESS TO NOMPX ADDRESS
*                           IF - GO FROM NOMPX ADDRESS TO MPX ADDRESS
*
*  THIS ROUTINE EXECUTES IN THE 'MPX' ENVIRONMENT AND RETURNS TO
*  NSVC.RET WITH PSD SET TO POINT PAST SVC 1,63
*
*  FIRST SET UP RETURN PSD
*
S.TXPM.7 LW        R3,TSK.LVLP,X2  GET CURRENT LEVEL POINTER
         ZBM       TSK.SVC,TSK.LVL,X3   CLEAR SVC INDICATERS
         ZBM       TSK.SVC1,TSK.SVCI,X3  CLEAR SVC TYPE          *219*
         ZBM       TSK.SVC2,TSK.SVCI,X3  CLEAR SVC TYPE          *219*
         ZBM       TSK.SVC6,TSK.SVCI,X3  CLEAR SVC TYPE          *219*
         ZBM       TSK.SVC7,TSK.SVCI,X3  CLEAR SVC TYPE          *219*
         ZBM       TSK.SVCE,TSK.SVCI,X3  CLEAR SVC TYPE          *219*
         LW        R1,TSK.RET,X2   FETCH CONTEXT TRAP ADDRESS
         LW        R1,PSD.OMPX,X1  FETCH OLD T-XPM PSD ADDRESS
         LD        R6,0W,X1        FETCH OLD PSD
         SUMW      R6,TSK.BIAS,X2  BIAS THE RETURN PSD
         STD       R6,TSK.RPSD,X2  FOR RETURN VIA 'NSVC.RET'
*
*  FETCH USER'S R1 & R2
*
         LW        R5,TSK.BIAS,X2  FETCH BIAS DIFFERENCE
         LW        R3,TSK.REGP,X2  GET REG STACK POINTER
         LW        R1,1W,X3       FETCH USER'S R1
         LW        R6,3W,R3       FETCH QUANTITY
         LW        R3,2W,X3       FETCH USER'S R2
         ADR       R5,R3           BIAS THE NOMPX ADDRESS
*
*  DETERMINE MOVE DIRECTION AND BRANCH ACCORDINGLY
*
         TRR       R6,R6           SET CC'S FOR TEST
         BN        NMPX.MPX
         TRN       R6,R6           MAKE COUNT NEGATIVE
         XCR       R1,R3           MOVE FROM USERS R1 TO R2
*
NMPX.MPX LW        R4,0W,X3        HERE MOVE FROM USERS R2 TO R1
         STW       R4,0W,X1
         ABR       R1,29
         ABR       R3,29
         BIB       R6,NMPX.MPX
         BU        NSVC.RET        RETURN TO DEBUGGER
MO       ANOP                                                   *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.9 (BIAS STACK)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.9 (BIAS STACK)
TTL.TMPX ANOP                                                       !259
*
*---------------------------------------------------------------------
*
*  THIS ROUTINE WILL BIAS THE AID SUBROUTINE CALL STACK FOR THE
*  NO-MPX ENVIRONMENT.  THIS IS DONE ONLY ONCE, SINCE THE STACK
*  WAS INITIALIZED IN THE 'MPX' ENVIRONMENT, BUT H.AID CALLS
*  BY THE TASK ARE ALWAYS EXECUTED IN THE 'NO-MPX' ENVIRONMENT.
*  H.AID RUNS (OTHER THAT STK.ALOC & STK.INIT) IN THE 'NO-MPX'
*  ENVIRONMENT SO THAT WE DON'T HAVE TO CHANGE H.AID FOR 'AID' TO
*  WORK WITH 'T-XPM'.  NOTE ALSO THAT THE TASK DEBUGGER RUNS IN
*  THE 'NO-MPX' ENVIRONMENT.
*
*    !!!   B I A S   S U B R O U T I N E   C A L L   S T A C K   !!!
*
*  ON INPUT:  R2 = DQE CONTEXT ADDRESS
*
         BOUND     1W
*
*  SWITCH MAPS TO MPX ENVIRONMENT (SO WE CAN GO BACK TO NO-MPX!)
*
S.TXPM.9 BL        MAP.MPX         RE-ESTABLISH MPX ENVIRONMENT
*
*  CHECK FOR EVENT RECORDING
*
         TBM       EVNT.TRP,EVNT.PTR    RECORD TRAPS
         BNS       N.AIDREC        BRANCH IF NOT
         LW        R1,TSK.DQE,X2   GET DQE ADDRESS
         LW        R3,DQE.PSSB,X1  GET INT PSD ADDR
         LD        R6,0W,X3        GET TRAPPING PSD
         LI        R1,2            EVENT TYPE IS 2 (= TRAP)
         BL        REC.EVNT        RECORD EVENT
         IFF       C.MPXOUT,MO                                  *237*
         LPSD      RES.ME3         GET MAPPED AGAIN
         BOUND     1D              DW BOUND THE PSD
RES.ME3  GEN       1/1,5/1,6/0,20/W(N.R3)    PRIV
         GEN       1/1,15/1,1/1,15/0    MAPPED,RETAIN,SAME BLK STATE
N.R3     EQU       $
MO       ANOP                                                   *237*
         SBM       AID.DSP,TXPMFLGS   H.AID DISPATCH
*
*  INSURE TSA IS BIASED (FOR H.AID)
*
N.AIDREC LW        R3,TSK.LVLP,X2  GET CURR LEVEL
         ZBM       SVC.AID,TSK.LVL,X3     CLEAR AID SVC INDICATOR
         IFF       C.MPXOUT,MO                                  *237*
         TBM       TSK.TSAB,TSK.FLG1,X2   IS TSA RE-BIASED?
         BS        TRAV.9.1        BRANCH IF ALREADY BIASED
         ZR        R6
         BL        S.TXPM.6        GO BIAS TSA
*
*  NOW CHECK TO SEE IF THIS IS THE FIRST AID 'INIT' OR 'NRCR'
*
TRAV.9.1 SBM       TSK.AID,TSK.FLG1,X2  INDICATE 'AID'    TASK
         BS        AID.IN
         TBM       NO.AID,TXPMFLGS SEE IF H.AID ON SYSTEM       *231*
         BS        AID.IN          BR IF NOT                    *231*
*
*  INSURE H.AID IS MAPPED IN
*
AID.ADDR LA        R7,H.AIDPAT     FETCH H.AID ADDRESS
         ANMW      R7,=X'FFFFF'    ISOLATE ADDRESS              *214*
         ADI       R7,H.AIDSIZ     POINT TO END OF H.AID
         ADMW      R7,TSK.BIAS,X2  BIAS FOR ADDRESS COMPARE
         CAMW      R7,C.TSAD       H.AID MAPPED IN?
         BLE       AID.IN          BRANCH IF H.AID MAPPED IN
         M.TSAD    R6              GET MPX TSA ADDRESS          *214*
         STW       R6,C.TXPM       SET FOR H.AID
         LW        R5,TX03         FETCH ERROR CODE
         BU        BORT.USR        ...AND GO ABORT USER
MO       ANOP                                                   *237*
*
*  SET UP RETURN PSD TO GO DIRECTLY TO H.AID
*
AID.IN   LW        R1,TSK.RET,X2   FETCH ADDRESS OF TRAP CONTEXT
         LW        R1,PSD.RET1,X1  FETCH RETURN ADDRESS (TO H.AID)
         ANMW      R1,=X'FFFFF'    ISOLATE ADDRESS              *214*
         SBR       R1,0            PRIVILEGED AND NON-EXTENDED!
         STW       R1,TSK.RPSD,X2  STUFF AS NEW PSW
*
         IFF       C.MPXOUT,MO                                  *237*
         SBM       STK.BIAS,TSK.FLG1,X2      STACK ALREADY BIASED?
         BS        TRAV.9.L        RETURN IF ALREADY BIASED
*
*  AID SUBROUTINE CALL STACK MUST BE BIASD PRIOR TO H.AID DISPATCH
*
         LNW       R7,TSK.BIAS,X2  FETCH BIAS DIFFERENCE
         M.TSAD    R3              FETCH TSA ADDRESS            *237*
         LW        R1,T.TEND,X3    FETCH TSA END
         TBM       TSK.TSAB,TSK.FLG1,X2   IS TSA RE-BIASED
         BNS       $+2W            SKIP IF ALREADY BIASED
         ADMW      R1,TSK.BIAS,X2  MAKE AN 'MPX' ADDRESS
         SUI       R1,2W           ADDRESS OF STACK BASE POINTER
         LW        R4,1W,X1        FETCH 'RAID' CHECKSUM
         CAMW      R4,RAID         STACK SET UP
         BNE       TRAV.9.L        NOPE, LET H.AID ABORT WITH RD05!
         LW        R3,,X1          FETCH STACK BASE ADDRESS
         ARMW      R7,,X1          BIAS STACK BASE POINTER
         ARMW      R7,,X3          BIAS STACK POINTER
         ARMW      R7,STK.LPTR,X3  BIAS ORIGIN SUB STACK
         ARMW      R7,STK.END,X3   BIAS STACK ENDING ADDRESS
         ARMW      R7,STK.OEND,X3  BIAS OVERLAY ENDING ADDRESS
MO       ANOP                                                   *237*
*
*  NOW ESTABLISH 'NO-MPX' MAP ENVIORNMENT AND 'PRESS ON' TO H.AID
*
TRAV.9.L SBM       0,TSK.RPSD+1W,X2 INSURE H.AID RUNS MAPPED
         SBM       17,TSK.RPSD+1W,X2 & BLOCKED!
         BL        MAP.TXPM
*
*  ! THERE SHOULD BE NO RETURN !
*
         IFF       C.MPXOUT,MO                                  *237*
RAID     DATAW     C'RAID'         AID STACK CHECKSUM
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TRV.10 (UBIAS FCB)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TRV.10 (UBIAS FCB)
TTL.TMPX ANOP                                                       !259
*
*---------------------------------------------------------------------
*
*  THIS ROUTINE WILL UNBIAS AN FCB FOR AN I/O THAT WAS ISSUED
*  IN THE NO-WAIT MODE
*
*  ON INPUT:  R1 = FCB ADDRESS
*             R6 = USER END-ACTION ADDRESS (MUST PRESERVE)
*             R0 = RETURN ADDRESS + CC'S   (MUST PRESERVE)
*
*  ON OUTPUT: FCB IS BIASED (FOR T-XPM TASKS)
*
*  CALLED BY:  S.IOCS17
*
S.TRV.10 M.QSHUT   R3,TR10         SAVE REGS & INHIBIT CONTEXT SWITCH
         TBM       TSK.TXPM,TSK.FLG1,X2 NO-MPX TASK?
         BNS       TRV.10.L        NO
         LNW       R5,TSK.BIAS,X2  FETCH BIAS DIFFERENCE
         LW        R4,ADR.MASK     20 BIT ADDRESS MASK
         TRRM      R1,R1           CLEAR UP R1 BEFORE USING
         TBM       FCB.ECP,FCB.SPST,X1 RESET EXECUTE CHAN PGM BIT
         BNS       UB.FCB          BRANCH IF NOT
         LW        R7,FCB.ERWA,X1  FETCH ADDRESS OF CHANNEL PROGRAM
         BL        ECP.MRG         GO UNBIAS CHANNEL PROGRAM
UB.FCB   BL        FCB.UB1         NOW GO UNBIAS THE FCB
         ZBM       FCB.ECP,FCB.SPST,X1 RESET EXECUTE CHAN PGM BIT
TRV.10.L EQU       $
         M.QOPEN   R3
         TRSW      R0              RETURN
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TRV.11 (UBIAS FCB)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TRV.11 (UBIAS FCB)
TTL.TMPX ANOP                                                       !259
*
*---------------------------------------------------------------------
*
*  THIS ROUTINE WILL UNBIAS A PSB FOR A REQUEST (MESSAGE OR RUN) ISSUED
*  IN THE NO-WAIT MODE
*
*  ON INPUT:  R1 = PSB ADDRESS
*             R6 = USER END-ACTION ADDRESS (MUST PRESERVE)
*
*  ON OUTPUT: PSB IS BIASED (FOR T-XPM TASKS)
*
*  CALLED BY:  S.EXEC64 & S.EXEC65
*
*  USABLE REGS = R0,R2,R4,R7
*  SAVED REGS = R1,R3,R5
*
S.TRV.11 LW        R2,C.CURR       DQE ADDRESS
         LW        R2,DQE.PSSF,X2  CONTEXT ADDR
         TBM       TSK.TXPM,TSK.FLG1,X2 TXPM TASK?
         BNS       TRV.11.L        EXIT IF NOT
         LW        R4,ADR.MASK     20 BIT MASK
         LNW       R7,TSK.BIAS,X2  TXPM BIAS VALUE
         TRRM      R1,R1           KEEP 20 BIT PSB ADDRESS
         CAMW      R1,C.TSAD       ABOVE OS?
         BLT       BORT.PSB
         LW        R2,TSK.LVLP,X2  GET CURRENT LEVEL POINTER
         TBM       TSK.SVC,TSK.LVL,X2   BIAS OR RE-BIAS?
         BNS       TRV.11.1        NO, BECAUSE THIS IS AN RE-BIAS
         TBM       0,PSB.CST,X1    IS PSB BUSY?
         BS        BORT.BSY        MUST ABORT USER WITH 'TX12'
TRV.11.1 LMW       R2,PSB.SBA,X1   FETCH SEND BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R7,PSB.SBA,X1   BIAS
         LMW       R2,PSB.RBA,X1   FETCH RECV BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R7,PSB.RBA,X1   BIAS
         LMW       R2,PSB.EAA,X1   FETCH END-ACTION BUFFER ADDRESS
         BZ        $+2W            SKIP IF 0
         ARMW      R7,PSB.EAA,X1   BIAS
TRV.11.L TRSW      R0              RETURN
*
MO       ANOP                                                   *237*
         IFT       OS.15E,OS15E                                 *238*
*---------------------------------------------------------------*238*
*                                                               *238*
*        SVC 1,3 SVC CODING TO RESET TSA BIASING FOR USER       *238*
*                                                               *238*
         BOUND     1W                                           *238*
RST_TSA  EQU       $               RESET TSA BIASING FOR USER   *238*
         M.TSAD    R3              FETCH TSA ADDRESS            *238*
         LW        R1,T.PRNO,X3    GET HIS DQE ADDRESS          *238*
         LW        R2,DQE.PSSF,X1  GET TXPM CONTEXT ADDRESS     *238*
         ZBM       USR.TSAB,TSK.FLG1,X2  RESET TSA BIASING      *238*
         M.RTRN                    RETURN TO CALLER             *238*
OS15E    ANOP                                                   *238*
         IFF       OS.15E,OS15E                                 *238*
OS15E    ANOP                                                   *238*
         TITLE     H.LOGR -- LOGGING PROCESSOR FOR TXPM
*
*----------------------------------------------------------------------
*
*  ROUTINE TO RECORD EVENT TRACING IN LOCAL BUFFER OR STATIC PARTITION.
*  THE STATIC PARTIION (TRANSPARENT TO H.TXPM) IS SET UP BY THE PROGRAM
*  XPMEVENT.
*
*  ON INPUT: R7 = PSD OF EVENT (WORD 2)
*            R6 = PSD OF EVENT (WORD 1)
*            R2 = CURRENT DQE CONTEXT ADDRESS
*            R1 = EVENT TYPE   0 = T-XPM DISPATCH
*                              1 = M.TSHUT
*                              2 = T-XPM TRAP
*                              3 = T-XPM INTERRUPT
*
*             IMPORTANT NOTE:  ON INPUT,
*
*             1.  INTERRUPTS ARE BLOCKED
*
*
*  ON OUTPUT: EVENT IS RECORDED IN EVENT BUFFER. RETURN IS TO
*             CALLER UNMAPPED!
*
*  POINTERS : THE FOLLOWING POINTERS ARE USED BY THE XPM EVENT TRACE
*
*             EVNT.PTR  = POINTER TO EVNT.CUR
*
*             EVNT.CUR  = POINTER TO CURRENT RECORDED EVENT
*             EVNT.BEG  = POINTER TO BUFFER ORIGIN
*             EVNT.BE   = POINTER TO BUFFER END
*
*             ALL 'EVNT' POINTERS ARE TO BE TREATED AS PHYSICAL &
*             EXTENDED ADDRESSES, SINCE WHO KNOWS WHERE THE PARTITION
*             MAY RESIDE IN PHYSICAL MEMORY.  THEREFORE, REC.EVENT
*             MUST GO UNMAPPED & EXTENDED PRIOR TO RECORDING AN
*             EVENT.
*-----------------------------------------------------------------------
*
*275          BOUND     1W
*275 E.GATE   DATAB     0               IPU/CPU EVENT RECORDING GATE
         BOUND     1W
EVNT.PTR GEN       3/0,29/W(EVNT.CUR)
*
EVNT.CUR ACW       EVNT.BUF        CURRENT EVENT POINTER
EVNT.BEG ACW       EVNT.BUF        EVENT BUFFER ORIGIN
EVNT.END ACW       EVNT.BE         EVENT BUFFER END
*
         BOUND     1F
EVNT.BUF RES       2F              32 WORD EVENT BUFFER
EVNT.BE  EQU       $-1W            32 WORD EVENT BUFFER
*
*  SET UP REGISTERS TO RECORD EVENT (FIRST GET SVC NUMBER)
*
REC.EVNT LW        R3,TSK.DQE,X2   GET DQE ADDRESS
         TRR       R1,R4           SAVE EVENT TYPE
         TRR       R3,R1           SAVE DQE ADDRESS
         LW        R3,TSK.LVLP,X2  GET CURRENT LEVEL POINTER
         TBM       TSK.SVC,TSK.LVL,X3  ARE WE EXECUTING AN SVC?
         BS        REC.2               BRANCH IF YES
         TBM       SVC.AID,TSK.LVL,X3  AID SVC?
         BS        REC.2               BRANCH IF YES
         ZR        R5               OTHERWISE,  CLEAR SVC BYTE
         BU        REC.3           SKIP OVER LOAD
REC.2    LB        R5,TSK.SVCT,X3   FETCH SVC TYPE
REC.3    SLL       R5,16           LEFT JUSTIFY SVC #
         CI        R4,2            IS THIS A TRAP/INT?
         BLT       REC.4           BRANCH IF NOT
         ORMB      R5,DQE.PSSB+5B,X1 MERGE TRAP/INT # WITH SVC TYPE
REC.4    EQU       $                                            *237*
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R2              ARE WE IN IPU
         BNS       G.UNMAP         BR IF NOT IN IPU
         ADI       R4,4            IPU TYPES ARE 4-7
*
*  NOW RECORD THE EVENT (AFTER GOING UNMAPPED & EXTENDED)
*
G.UNMAP  LPSD      UNMAP           GO UNMAPPED
         BOUND     1W
UNMAP    GEN       1/1,4/0,1/1,26/H(REC.5)
         DATAW     X'00018000'     RETAIN MAP & BLOCKING
*
MO       ANOP                                                   *237*
REC.5    SBM       LW.EGATE,LSWITCH GATE IPU/CPU RECORDING          !275
         BS        REC.5           INUSE, WAIT
         LW        R2,EVNT.PTR     FETCH EVENT POINTER
         LW        R3,0W,X2        FETCH ADDRESS OF CURRENT ENTRY
         ADI       R3,EVNT.LEN     POINT TO NEXT AVAILABLE ENTRY
         CAMW      R3,2W,X2        HAVE WE REACHED BUFFER END?
         BLT       REC.6           BRANCH IF OK
*
* BUFFER END REACHED SO WRAP AROUND
*
         LW        R3,1W,X2        FETCH BUFFER ORIGIN
REC.6    STW       R3,0W,X2        USE AS CURRENT EVENT POINTER
         ZBM       LW.EGATE,LSWITCH UNGATE IPU/CPU RECORDING        !275
*
*  PHYSICAL ADDRESS OF EVENT BUFFER ENTRY IS NOW IN R1
*
         LW        R2,DQE.PSSF,X1  GET DQE CONTEXT ADDRESS
         STD       R6,EVNT.PSD,X3  STORE PSD
         SLL       R4,8            EVENT TYPE IN WD 2 NOW
         STW       R4,EVNT.SIL,X3  STORE EVENT TYPE
         SRL       R4,8            RESTORE TO LOW ORDER BYTE
         STW       R5,EVNT.SVC,X3  STORE SVC TYPE/TRAP & INT #
         LD        R4,DQE.LMN,X1   FETCH TASK LMN
         BNZ       $+3W            SKIP IF NOT BLANK
         LW        R4,=C'NO.T'     LOAD NO.TASK
         LW        R5,=C'ASK '     "
         STD       R4,EVNT.NAM,X3  STORE TASK NAME
         LB        R7,TSK.ATI,X2   FETCH SOFTWARE INTERRUPT LEVEL
         SRL       R7,2            /4 (WAS WORD OFFSET)
         ORMW      R7,EVNT.SIL,X3  OR IN EVENT TYPE
         STW       R7,EVNT.SIL,X3  STORE SOFTWARE INTERRUPT LEVEL
         LW        R7,DQE.TAN,X1   GET TASK NUMBER
         STW       R7,EVNT.TSK,X3  STORE TASK PROGRAM NUMBER
         LW        R1,DQE.PSSB,X1  GET INT/TRAP CONTEXT ADDRESS
         IFF       C.3227,EV.7X
         LW        R1,2W,X1        GET CONTEXT INTR ON 7X
         SUI       R1,6W           POINT TO START ON CONTEXT
EV.7X    ANOP
         LW        R4,ICXT.FLG+ITC.LEN,X1   GET INT LVL,CHAN AND DTC
         SRL       R4,8            CLEAN OFF DTC
         SLL       R4,16           POSIT FOR MERGE (LVL,CHAN ONLY)
         ORMW      R4,EVNT.SIL,X3  MERGE SOFTWARE INTERRUPT LEVEL
         STW       R4,EVNT.SIL,X3  SAVE EVENT INFO
         LW        R4,C.INTC       GET RTC VALUE
         STW       R4,EVNT.TYP,X3  USE OLD TYP CELL FOR CLOCK
*
*  NOW SAVE USER'S REGISTERS
*
         LW        R1,TSK.REGP,X2  GET WHERE REGS ARE
         LF        R4,0W,X1        LOAD USER'S REGISTERS 0-3
         STF       R4,EVNTREGS,X3  SAVE USER'S REGISTERS
         LF        R4,4W,X1        FETCH USER'S REGISTERS 4-7
         STF       R4,EVNTREGS+4W,X3  RECORD USER'S REGISTERS
         TRSW      R0              RETURN TO USER
*
         IFT       MPX.EVNT,EV.00  DO MPX EVENT IF SET
         TITLE     H.LOGR -- LOGGING PROCESSOR FOR TXPM (MPX VERSION)
*
*----------------------------------------------------------------------
*
*  ROUTINE TO RECORD EVENT TRACING IN LOCAL BUFFER OR STATIC PARTITION.
*  THE STATIC PARTIION (TRANSPARENT TO H.TXPM) IS SET UP BY THE PROGRAM
*  XPMEVENT.
*
*  ON INPUT: R0 = RETURN ADDRESS
*            R1 = CONTEXT ADDRESS OF TASK (CONTEXT 0 IF NO TASK)
*            R2 = POINTER TO REG SAVE AREA
*            R3 = DQE ADDRESS OF TASK (DQE 0 ADDR IF NO TASK)
*            R4 = EVENT TYPE (0-F)
*                       TYPE   0 = T-XPM CPU DISPATCH
*                              1 = INVALID TRAP/INT IN CPU
*                              2 = T-XPM CPU TRAP
*                              3 = T-XPM CPU INTERRUPT
*                              4 = T-XPM IPU DISPATCH
*                              5 = INVALID TRAP IN IPU
*                              6 = T-XPM IPU TRAP
*                              7 = T-XPM IPU INTERRUPT (NOT USED)
*                              8 = MPX CPU DISPATCH
*                              9 = INVALID TRAP/INT IN CPU
*                              A = MPX CPU TRAP
*                              B = MPX CPU INTERRUPT
*                              C = MPX IPU DISPATCH
*                              D = INVALID TRAP IN IPU
*                              E = MPX IPU TRAP
*                              F = MPX IPU INTERRUPT (NOT USED)
*            R5 = SAVED RETURN ADDRESS (MUST PRESERVE)
*            R6 = PSD WD 1 OF EVENT
*            R7 = PSD WD 2 OF EVENT
*
*
*             IMPORTANT NOTE:  ON INPUT,
*
*             1.  INTERRUPTS ARE BLOCKED
*
*
*  ON OUTPUT: EVENT IS RECORDED IN EVENT BUFFER. RETURN IS TO
*             CALLER UNMAPPED!
*
*  POINTERS : THE FOLLOWING POINTERS ARE USED BY THE XPM EVENT TRACE
*
*             EVNT.PTR  = POINTER TO EVNT.CUR
*
*             EVNT.CUR  = POINTER TO CURRENT RECORDED EVENT
*             EVNT.BEG  = POINTER TO BUFFER ORIGIN
*             EVNT.BE   = POINTER TO BUFFER END
*
*             ALL 'EVNT' POINTERS ARE TO BE TREATED AS PHYSICAL &
*             EXTENDED ADDRESSES, SINCE WHO KNOWS WHERE THE PARTITION
*             MAY RESIDE IN PHYSICAL MEMORY.  THEREFORE, REC.EVENT
*             MUST GO UNMAPPED & EXTENDED PRIOR TO RECORDING AN
*             EVENT.
*-----------------------------------------------------------------------
*
         BOUND     1W
LOGGER   EQU       $               MPX LOGGING ENTRY
*
*  SEIZE LOCK SO WE CAN SAVE REGS LOCALLY
*
* JUST A NOTE, THIS LOCK COULD BE BUSY IF TRAP OUT OF THIS ROUTINE
*
LOG.5    EQU       $               TEST FOR LOCK BUSY
         SBM       LW.EGATE,LSWITCH GATE IPU/CPU RECORDING          !275
         BS        LOG.5           INUSE, WAIT
         STF       R0,LOGSAV       SAVE THE REGS LOCALLY
         LD        R6,DQE.LMN,X3   FETCH TASK LMN
         CAMW      R6,=C'XPME'     IS THIS XPMEVENT
         BNE       LOG.Z1          BR IF NOT
         CAMW      R7,=C'VENT'
         BEQ       LOG.X           RETURN IF YES
LOG.Z1   TBM       EVNT.TSH,EVNT.PTR  ARE ALL TASKS TO BE RECORDED
         BS        LOG.R           BR IF YES
LOG.Z2   CAMW      R6,=C'OPCO'     IS THIS OPCOM
         BNE       LOG.Z3
         CAMW      R7,=C'M   '
         BEQ       LOG.X           RETURN IF YES
LOG.Z3   SRL       R6,16           JUST LOOK AT 2 BYTES
         CAMH      R6,=G'J.'       IS THIS A J. ?
         BEQ       LOG.X           EXIT IF YES
*
*  NOW RECORD THE EVENT (AFTER GOING UNMAPPED & EXTENDED)
*
LOG.R    EQU       $                                            *237*
         IFF       C.MPXOUT,MO                                  *237*
         LPSD      UNMAP.L         GO UNMAPPED
UNMAP.L  GEN       1/1,4/0,1/1,26/H(LOG.7)
         DATAW     X'00018000'     RETAIN MAP & BLOCKING
*
MO       ANOP                                                   *237*
LOG.7    LW        R2,EVNT.PTR     FETCH EVENT POINTER
         LW        R3,0W,X2        FETCH ADDRESS OF CURRENT ENTRY
         ADI       R3,EVNT.LEN     POINT TO NEXT AVAILABLE ENTRY
         CAMW      R3,2W,X2        HAVE WE REACHED BUFFER END?
         BLT       LOG.6           BRANCH IF OK
*
* BUFFER END REACHED SO WRAP AROUND
*
         LW        R3,1W,X2        FETCH BUFFER ORIGIN
LOG.6    STW       R3,0W,X2        USE AS CURRENT EVENT POINTER
*
*  PHYSICAL ADDRESS OF EVENT BUFFER ENTRY IS NOW IN R3
*
         LD        R6,LOGSAV+6W
         STD       R6,EVNT.PSD,X3  STORE PSD
         IFF       C.MPXOUT,MO                                  *237*
         T.IPU     R5              ARE WE IN IPU
         BNS       LOG.2           BR IF WE ARE NOT
         ADI       R4,4            IPU IS CPU TYPE + 4
MO       ANOP                                                   *237*
LOG.2    SLL       R4,8            TYPE NOW IN BYTE 2, WD 1
         STW       R4,EVNT.SIL,X3  STORE EVENT TYPE IN SIL CELL
         SRL       R4,8            RESTORE TO LOW ORDER BYTE
         LW        R1,LOGSAV+3W    RESTORE DQE ADDRESS
         ZR        R5              ASSUME DISPATCH
         TBR       R4,30           IS THIS A TRAP/INT?
         BNS       LOG.4           BRANCH IF NOT
         TBR       R4,31           IS THIS INT
         BS        LOG.3           SKIP OVER SVC # STUFF
         LB        R6,DQE.PSSB+5B,X1  GET TRAP/INT CODE
         CI        R6,6            SVC?
         BLT       LOG.3           BR IF NOT
         CI        R6,21           SVC?
         BGT       LOG.3           BR IF NOT
         LW        R2,DQE.PSSB,X1  GET ICB ADDR
         LH        R5,9H,X2        GET SVC #
LOG.3    SLL       R5,16           LEFT JUSTIFY SVC #
         ORMB      R5,DQE.PSSB+5B,X1 MERGE TRAP/INT # WITH SVC TYPE
LOG.4    STW       R5,EVNT.SVC,X3  STORE SVC TYPE/TRAP & INT #
         LD        R6,DQE.LMN,X1  FETCH TASK LMN
         BNZ       LOG.8           BR IF A  TASK NAME
         LW        R6,=C' NO.'     FIRST PART OF NO.TASK
         LW        R7,=C'TASK'     SECOND PART
LOG.8    STD       R6,EVNT.NAM,X3  STORE TASK NAME
         LW        R2,LOGSAV+1W    GET CONTEXT ADDR
         LB        R7,TSK.ATI,X2   FETCH SOFTWARE INTERRUPT LEVEL
         SRL       R7,2            /4 (WAS WORD OFFSET)
         ORMW      R7,EVNT.SIL,X3  MERGE WITH EVENT TYPE
         STW       R7,EVNT.SIL,X3  STORE SOFTWARE INTERRUPT LEVEL
         LW        R7,DQE.TAN,X1   GET TASK NUMBER
         STW       R7,EVNT.TSK,X3  STORE TASK PROGRAM NUMBER
         TBR       R4,31           IS THIS INT
         BNS       LOG.9           SKIP OVER INT STUFF IF NOT
         LW        R1,DQE.PSSB,X1  GET INT/TRAP CONTEXT ADDRESS
         IFF       C.3227,EV.7X
         LW        R1,2W,X1        GET CONTEXT INTR ON 7X
         SUI       R1,6W           POINT TO START ON CONTEXT
EV.7X    ANOP
         IFT       C.3227,EV.2X
         IFT       MPX.EVNT,EV.2X
         LW        R1,2W,X1        GET CONTEXT INTR ON 7X
         SUI       R1,6W           POINT TO START ON CONTEXT
EV.2X    ANOP
         LW        R4,ICXT.FLG+ITC.LEN,X1   GET INT LVL,CHAN AND DTC
         SRL       R4,8            STRIP OFF DTC
         SLL       R4,16           POSIT FOR MERGE (LVL,CHAN ONLY)
         ORMW      R4,EVNT.SIL,X3  MERGE SOFTWARE INTERRUPT LEVEL
         STW       R4,EVNT.SIL,X3  SAVE EVENT INFO
LOG.9    LW        R4,C.INTC       GET RTC VALUE
         STW       R4,EVNT.TYP,X3  USE OLD TYP CELL FOR CLOCK
*
*  NOW SAVE USER'S REGISTERS
*
         LW        R1,LOGSAV+2W    GET WHERE REGS ARE
         LF        R4,0W,X1        LOAD USER'S REGISTERS 0-3
         STF       R4,EVNTREGS,X3  SAVE USER'S REGISTERS
         LF        R4,4W,X1        FETCH USER'S REGISTERS 4-7
         STF       R4,EVNTREGS+4W,X3  RECORD USER'S REGISTERS
LOG.X    LF        R0,LOGSAV       RESTORE CALLERS REGS
         ZBM       LW.EGATE,LSWITCH UNGATE IPU/CPU RECORDING        !275
         TRSW      R0              RETURN TO USER
*
LOGSAV   RES       1F              WHERE WE SAVE REGS
EV.00    ANOP                      END OF MPX EVENT TRACING
*
         IFF       MPX.EVNT,TTL.TXPM                                !264
         TITLE     H.TXPM -- INIT ROUTINE                           !264
TTL.TXPM ANOP                                                       !264
         IFT       MPX.EVNT,TTL.TMPX                                !264
         TITLE     H.TMPX -- INIT ROUTINE                           !264
TTL.TMPX ANOP                                                       !264
*++                                                                 !264
*                                                                   !264
*  CK.INIT  --  Check some initialization things                    !264
*                                                                   !264
*++                                                                 !264
         SPACE                                                      !264
*  This routine is called once from MAP.TXPM and once from MAP.MPX. !264
*  It checks to see if we're running on a Seahawk or not.  If so,   !264
*  then it makes some changes to the code.  It also replaces        !264
*  the BL CK.INIT to a NOP so we won't waste time repeating the     !264
*  check over and over.                                             !264
         SPACE                                                      !264
*  Input:  R0 set as if a BL was done                               !264
*  Output: LW.C2000 set, plus patches possibly NOPed                !264
*  Regs 5 and 6 destroyed                                           !264
         SPACE                                                      !264
CK.INIT  LW        R5,=X'20002'    Two NOPs                         !264
         TRR       R1,R6           Safekeeping                      !264
         TRR       R0,R1                                            !264
         SUI       R1,1W           Back up to BL                    !264
         STW       R5,,X1          We'll never get called from      !264
*                                  there again                      !264
         SBM       LW.INIT,LSWITCH Have we been through this?       !264
         BS        CKI.RET         Go if so; we've already made     !264
*                                  changes                          !264
         RDSTS     R1                                               !264
         SLL       R1,28           Isolate machine type             !264
         TRR       R1,R1                                            !264
         BNZ       CKI.RET         Go if not a Seahawk              !264
         SBM       LW.C2000,LSWITCH Tell everyone else              !264
         LA        R1,*PTCH.530    Point to patch area              !264
         STW       R5,,X1          NOP the LPSD                     !264
         STW       R5,1W,X1        And the scratchpad stuff         !264
         LW        R5,BLSH         Get BL to RSX_FIX                !268
         STW       R5,RSXF.1       Apply patch                      !268
         STW       R5,RSXF.3       Apply patch                      !268
         STW       R5,RSXF.5       Apply patch                      !268
         IFF       OS.15E,NO.15E                                    !269
         STW       R5,RSXF.2       Apply patch                      !268
         STW       R5,RSXF.4       Apply patch                      !268
         STW       R5,RSXF.6       Apply patch                      !268
NO.15E   ANOP                                                       !269
CKI.RET  TRR       R6,R1           R1 restored                      !264
         TRSW      R0                                               !264
BLSH     BL        RSX_FIX         Template instruction             !268
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- T-XPM TRAP TABLE
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- T-XPM TRAP TABLE
TTL.TMPX ANOP                                                       !259
         IFT       C.3227,VCT.TBLX
         IFF       MPX.EVNT,EVNT
*
*  THIS TABLE IS POINTED TO BY SPAD LOC 'F0' UPTON T-XPM DISPATCH
*
         BOUND     1D
         IFT       OS.35,ET35       Only do for MPX 3.5 or >        !MOD
*  For the RSX and 32/2000 processors there are external traps and  !MOD
*  timers which can be gen'd in.  Their ICB's start -60(hex) from   !MOD
*  the normal SVC locations.  The defaults would be 0x80 for the    !MOD
*  SVC's and 0x20 for the external traps/timers.  Location C.TRAPS  !MOD
*  has a bit set for those that are gen'd into the system.          !MOD
*                                                                   !MOD
TRP.EXT  EQU       $               External traps start here        !MOD
         REPT      24              There are 24 (16 usable)         !MOD
         ACW       TRAP.XX         Default                          !MOD
         ENDR                                                       !MOD
ET35     ANOP                                                       !MOD
TRP.VCT  EQU       $
         REPT      6
         ACW       TRAP.XX         DEFAULT
         ENDR
         ACW       SVC.TBL
         REPT      10
         ACW       TRAP.XX         DEFAULT
         ENDR
SVC.TBL  EQU       $
         REPT      16              16 SVC'S
         ACW       TRAP.XX         DEFAULT
         ENDR
*
*        UNDEFINED TRAP OR INTERRUPT CONTEXT BLOCK
*
TRAP.XX  REZ       1D              OLD PSD
         GEN       12/X'840',20/W($+4W)
         DATAW     X'00014000'
         REZ       1D
         STF       R0,CPUREGS      SAVE USERS REGS
         NOP
         LI        R1,255          INVALID INT/TRAP
         BL        FIRE            GO REPORT
         REZ       1               DUMMY TRAP/INT CONTEXT AREA
         DATAW     TRAP.XX         PSD.OMPX
         DATAW     TRAP.XX         PSD.OTMP
         DATAW     X'00FFFF00'     INT LEV OF 255, DEVICE 255
         RES       2W              FILLER
*
*  END OF T-XPM TRAP VECTOR TABLE
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- T-XPM INTERRUPT TABLE
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- T-XPM INTERRUPT TABLE
TTL.TMPX ANOP                                                       !259
*
*  THIS TABLE IS POINTED TO BY SPAD LOC 'F1' UPTON T-XPM DISPATCH
*
INT.VCT  EQU       $
         REPT      112             112 INTERRUPTS
         ACW       TRAP.XX         DEFAULT
         ENDR
*
*  END OF T-XPM INTERRUPT VECTOR TABLE
*
EVNT     ANOP
VCT.TBLX ANOP
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- CONSTANTS & CTXT BLKS)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- CONSTANTS & CTXT BLKS)
TTL.TMPX ANOP                                                       !259
*
*  CONSTANTS AND WORKING STORAGE
*
*242* TXPMFLGS REZ       1W        NOW EQUATED TO C.UBIAS (C8)  *242*
SVC1IN   DATAW     $-$             ADDRESS OF SVC 1 BIAS TABLE
SVC2IN   DATAW     $-$             ADDRESS OF SVC 2 BIAS TABLE
SVC1OUT  DATAW     $-$             ADDRESS OF SVC 1 UNBIAS TBL
SVC2OUT  DATAW     $-$             ADDRESS OF SVC 2 UNBIAS TBL
VTBLA    DATAW     $-$             ADDRESS OF BIAS/UNBIAS ROUTNS
DQE.TCXT DATAW     ADQE.CXT        ADDRESS OF DQE CONTEXT AREA
ADR.MASK DATAW     X'001FFFFF'     21 BIT ADDRESS MASK          *204*
EXEC.TRV DATAW     0
MPX.TRP  DATAW     0               MPX TRAP TABLE BASE ADDRESS
MPX.INT  DATAW     0               MPX INT  TABLE BASE ADDRESS
*
TRP.CXTA DATAW     0               CURRENT TRAP CONTEXT ADDRESS
*  The following tables are used to bias M.CALLs.  The CLB.TBL is   !273
*  used for biasing, CLU.TBL is used for unbiasing.  There are      !273
*  16 entries per table, one for each module (module as used by     !273
*  the M.CALL SVC).  If an entry is 0, then that module has no      !273
*  ep's that can be biased.  A non-zero entry has a pointer to a    !273
*  sub-table, and the count of entries in the sub-table.  Each      !273
*  sub-table has the ep number in the first byte, and the address   !273
*  of the bias/unbias routine in the rest of the word.              !273
CLB.TBL  DATAW     0,0,0,0,0,0,0,0,0,0                              !273
         IFT       OS.15E,DO.15E                                    !274
         DATAW     0                                                !274
DO.15E   ANOP                                                       !274
         IFF       OS.15E,NO.15E                                    !274
*274          GEN       8/1,24/W(REMMB)                                  !273
         GEN       8/REMMTBLE-REMMTBL/4,24/W(REMMB)                 !274
NO.15E   ANOP                                                       !274
         DATAW     0,0,0,0,0                                        !273
CLU.TBL  DATAW     0,0,0,0,0,0,0,0,0,0                              !273
         IFT       OS.15E,DO.15E                                    !273
         DATAW     0                                                !273
DO.15E   ANOP                                                       !273
         IFF       OS.15E,NO.15E                                    !273
*274          GEN       8/1,24/W(REMMB)                                  !273
         GEN       8/REMMTBLE-REMMTBL/4,24/W(REMMB)                 !274
NO.15E   ANOP                                                       !273
         DATAW     0,0,0,0,0                                        !273
         IFF       OS.15E,NO.15E                                    !274
REMMTBL  EQU       $               REMM bias table start            !274
REMMB    GEN       8/6,24/A(SVC2.52) H.REMM,6  bias R1, RRS, R7,    !273
*                                    and the CNP                    !273
REMMTBLE EQU       $               REMM bias table end              !274
NO.15E   ANOP                                                       !274
         BOUND     1D
DQE0     REZ       DQE.SIZE        DUMMY DQE
C_STKDW  RES       1D              Scratch space                    !286
C_STKREG ACD       C_STKDW         Should be overwritten            !286
LDR.MASK DATAW     X'FFFFC'        ALLOW EXTENDED ADDR FOR 2.X
         IFT       DO.BUI,BUI.DO                                    !259
RHW.CPU  REZ       1W              Count of # of RHW instr's        !259
RHW.IPU  REZ       1W              Ditto for IPU                    !259
BUI.DO   ANOP                                                       !259
SV.MPL   REZ       1W                                               !252
SV.CMPL  REZ       1W                                               !260
SV.CNT   REZ       1B                                               !252
LSWITCH  REZ       1B                                               !252
*260 LW.DOMPL EQU       0               MPLs need to be reset            !252
LW.EGATE EQU       0               XPMEVENT gate bit                !275
LW.C2000 EQU       1               Seahawk                          !252
LW.BUI   EQU       2               Might we have a BUI *?           !255
LW.INIT  EQU       3               Have we done initialization?     !264
LW.STKR  EQU       4               Is IP06 using C.STKREG?          !285
LW.SG26  EQU       7               Used on sysgen abort only        !280
*
         IFF       OS.15E,OS15E                                 *238*
OS15E    ANOP                                                   *238*
         IFF       C.MPXOUT,MO                                  *237*
*  ROUTINE TO UNBIAS RXB (CALLED FROM S.EXEC63) SINCE THERE EXISTS NO
*  SVC RETURN FROM M.XMSGR & M.XRUNR
*
         BOUND     1W
S.TRV.16 M.QSHUT   R6              SAVE REGS & GO BLOCKED
         TBM       TSK.TXPM,TSK.FLG1,X2  T-XPM TASK?
         BNS       TRV.16.N        BRANCH IF NOT
         ZBM       TSK.SVC,*TSK.LVLP,X2  RETURNING FROM SVC
         ZBM       TSK.SVC1+TSK.SVCI,*TSK.LVLP,X2 SVC 1 (5E OR 7D) *219*
         ANMW      R1,ADR.MASK     USE 20-BIT ADDR
         CAMW      R1,C.TSAD       ABOVE O/S
         BLT       BORT.PRB        IF NOT, ERROR
         LW        R6,PRB.RBA,X1   FETCH RECVR BUFF ADDR
         ANMW      R6,ADR.MASK     20-BIT MASK
         BZ        $+2W            NO BIAS IF ZERO
         SUMW      R6,TSK.BIAS,X2  BIAS RECVR ADDR
         TRR       R1,R2           SAVE RXB ADDRESS
         LW        R1,RXB.RBA,X1   TRANSMIT ADDRESS
         STW       R6,PRB.RBA,X2   UPDATE IT
         ANMW      R1,ADR.MASK     20-BIT ADDR
         BU        TRV.16.L        RETURN TO EXEC63
TRV.16.N LW        R1,RXB.RBA,X1   TRANSMIT ADDRESS
         IFT       OS.32X,T.16
         ANMW      R1,C.ADMASK     MASK TO SIZE OF MEMORY
T.16     ANOP
         IFF       OS.32X,T.16
         ANMW      R1,=X'7FFFF'   19-BIT MASK FOR MPX TASK
T.16     ANOP
TRV.16.L STW       R1,CPUREGS+1W   PASS R1 BACK TO CALLER      *208*
         M.QOPEN   R6              RESTORE USER'S REGS         *208*
         TRSW      R0              RETURN
MO       ANOP                                                   *237*
         IFF       OS.15E,OS15E                                 *238*
OS15E    ANOP                                                   *238*
         LPOOL
**********************************************************************
*
*  THIS IS THE START OF THE VARIABLE CODE AND DATA AREA
*  IF AN IPU IS CONFIGURED, THIS CODE WILL REMAIN INTACT AND
*  THE TRAP, INTERRUPT, AND CONTEXT AREAS WILL FOLLOW.
*
*  IF AN IPU IS NOT CONFIGURED, THIS CODE WILL BE OVERLAID
*  DURING SYSGEN INITIALIZATION WITH THE TRAP, INTERRUPT, AND
*  CONTEXT AREAS.  UNUSED AREAS WILL BE RELEASED DURING SYSGEN.
*
**********************************************************************
         BOUND     1D              IF NO IPU, MUST BE DW BOUND
IPU.CODE EQU       $               START OF IPU SUPPORT CODE
         IFF       C.MPXOUT,MO                                  *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.I (TRAPS-IPU)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.I (TRAPS-IPU)
TTL.TMPX ANOP                                                       !259
*
*--------------------------------------------------------------------
*
*  CURRENT STATE IS:
*
*    1.  IPU UNMAPPED
*    2.  INTERRUPTS BLOCKED
*    3.  TRAP ACTIVE
*    4.  R1 = TRAP NUMBER
*    5.  R0 = CONTEXT ADDRESS + TRAP.LEN AND CC'S IF NEEDED
*
*  FIND TRAP/INTERRUPT CONTEXT BLOCK
IFIREJ   SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         BNS       IFIREK          BR IF NOT IN TXPM
         IFT       OS.36,O36                                    !295
         ABM       31,EXC.IPUR  TELL CPU WE GOT SIPU            !295
O36      ANOP                                                   !295
         IFF       OS.36,O36                                    !295
         SBM       EXEC.RUN,EXEC.FLG  TELL CPU WE GOT SIPU         *211*
O36      ANOP                                                   !295
*
         IFF       C.3227,OF.2                                     *211*
         LPSD      *X'2E4'         IN TMPX, RETURN IMMEDIATELY     *211*
OF.2     ANOP                                                      *211*
*
         IFT       OS.32X,IF.01                                    *211*
         IFT       OS.36,O36                                    !295
         SBM       IPU.REQP,EXC.IPUP SET IPU SCHEDULE FLAG      !295
O36      ANOP                                                   !295
         IFF       OS.36,O36                                    !295
         SBM       IPU.SCH,EXEC.FLG  SET IPU SCHEDULE FLAG         *211*
O36      ANOP                                                   !295
IF.01    ANOP                                                      *211*
*
         IFT       C.3227,OF.1
         IFF       MPX.EVNT,EVNT
         LPSD      *DSP.BSY        IN TXPM, RETURN IMMEDIATELY
EVNT     ANOP
         IFT       MPX.EVNT,EVNT
         LPSD      *X'4C'          IN TMPX, RETURN IMMEDIATELY
EVNT     ANOP
OF.1     ANOP
*
IFIREK   STF       R0,SPLREGS      SAVE USERS REGS
         LI        R1,26           SIPU CODE
         IFT       OS.32X,IF.01
         IFT       OS.36,O36                                    !295
         SBM       C.IPUCSI,C.IPUFLG TELL CPU TO HOLD OFF       !295
O36      ANOP                                                   !295
         IFF       OS.36,O36                                    !295
         SBM       C.ICSIPU,C.BIT  TELL CPU TO HOLD OFF
O36      ANOP                                                   !295
IF.01    ANOP
         IFF       OS.32X,IF.02
         SBM       IPU.GATE,EXEC.FLG  TELL CPU TO HOLD OFF
IF.02    ANOP
         BL        $+1W            GET CONDITION CODES
         ANMW      R0,=X'FF000000' KEEP CC'S
         ORMW      R0,DSP.BSY      OR IN ICB ADDR
         ADI       R0,ITC.LEN      POINT TO CONTEXT AREA
*
         SBM       IPU.INIT,TXPMFLGS    IS THE IPU INIT'D
         BS        IFIRE           GO IF YES
         IFT       C.3227,OF.1
         LW        R5,=X'F30000'   MPL SPAD ADDR
         LW        R4,C.MPL        GET MPX ADDR
         TRSC      R4,R5           PUT ADDR IN SPAD
         LI        R4,X'140'       SET PRIV MODE & HALT MODE ACTIV
         SETCPU    R4              PUT IN IPU SPAD
OF.1     ANOP
         IFF       C.3227,OF.2
         LW        R5,=X'830000'   MPL SPAD ADDR
         LW        R4,C.MPL        GET MPX ADDR
         TRSC      R4,R5           PUT ADDR IN SPAD
         LW        R4,=X'11000'    SET 7X MODE & ENABLE MAP
         SETCPU    R4              PUT IN IPU SPAD
* THE FOLLOWING CODE IS FOR OLD 7X COMPUTERS THAT DON'T KNOW    *232*
* THEY ARE AN IPU.  NEWER ONES DO, SO TELLEM, JUST TO BE SAFE.  *232*
         LW        R5,=X'910000'   IPU STATUS WORD ADDR         *232*
         LI        R4,X'11'        SET THIS IS IPU BIT IN S.W.  *232*
         TRSC      R4,R5           PUT STATUS IN SPAD           *232*
OF.2     ANOP
IFIRE    SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         IFT       OS.32X,IF.01
         IFT       OS.36,O36                                    !295
         SBM       C.IPUCSI,C.IPUFLG TELL CPU TO HOLD OFF       !295
O36      ANOP                                                   !295
         IFF       OS.36,O36                                    !295
         SBM       C.ICSIPU,C.BIT  TELL CPU TO HOLD OFF
O36      ANOP                                                   !295
IF.01    ANOP
         IFF       OS.32X,IF.02
         SBM       IPU.GATE,EXEC.FLG  TELL CPU TO HOLD OFF
IF.02    ANOP
         TRR       R1,R7           SAVE TRAP/INTERRUPT NUMBER
         TRR       R0,R3           GET TRAP/INT CONTEXT ADDRESS
         IFT       C.3227,FIRE.2Z
         IFF       MPX.EVNT,EVNT
         LW        R1,PSD.OTMP,X3  FETCH ADDRESS OF OLD PSD
EVNT     ANOP
         IFT       MPX.EVNT,EVNT
         LW        R1,PSD.OMPX,X3  FETCH ADDRESS OF OLD PSD
EVNT     ANOP
FIRE.2Z  ANOP
         IFF       C.3227,FIRE.7Z
         LW        R1,PSD.OMPX,X3  FETCH ADDRESS OF OLD PSD
FIRE.7Z  ANOP
         IFT       DO.BUI,BUI.DO                                    !259
         TBM       30,,X1          RHW?                             !259
         BNS       $+2W                                             !259
         ABM       31,RHW.IPU      Else count it                    !259
BUI.DO   ANOP                                                       !259
         LI        R4,X'3FFC'      MASK FOR CPIX
         TRR       R1,R5           SAVE PSD ADDR
         LMW       R1,1W,X1        GET TRAPPING PSD CPIX
         BNZ       G4.DQE0         BR IF WE HAVE A CPIX
         LA        R1,DQE0         USE DQE 0 FOR ZERO CPIX
         BU        G5.DQE0         MERGE CODE
         IFF       C.3227,STG.5    ADJUST CPIX TO DQE INDEX
G4.DQE0  SRL       R1,2            THIS IS 7X BPIX SHIFT
STG.5    ANOP
         IFT       C.3227,STG.6    ADJUST CPIX TO DQE INDEX
G4.DQE0  SRL       R1,3            THIS IS CONCEPT BPIX SHIFT
STG.6    ANOP
         SLL       R1,2            WORD ADJUST PROG NUM
         ADMW      R1,C.ADAT       DQE ADDRESS TABLE
         LW        R1,0W,X1        GET DQE ADDR
G5.DQE0  LW        R4,=X'FFFFF'    GET ADDRESS MASK
         CMMW      R1,C.CIPU       THIS TASK IN IPU?
         BEQ       IFIRE.1         BR IF ALL AOK
         LW        R4,C.CIPU       CURRENT DQE ADDRESS
         ANMW      R4,=X'FFFFF'    Bit 0 is occasionally on, so mask!287
*                                  it (and any others that might be !287
*                                  on)                              !287
         CI        R4,C.CIPU       CURRENT IPU TASK?
         BNE       IFIRE.1         USE TASK 0 AREA IF NONE
         LA        R1,DQE0         GET DQE 0 ADDRESS
*  AT THIS POINT R1=DQE ADDRESS OF TASK WE ARE USING
IFIRE.1  LA        R6,IPUREGS      WHERE USER REGS ARE
         CI        R7,26           IS THIS SIPU TRAP
         BNE       IF.0            BR IF NOT
         LA        R6,SPLREGS      SPECIAL REG AREA FOR SIPU TRAP
IF.0     LW        R4,=X'FFFFF'    GET ADDRESS MASK
         CMMW      R1,C.CIPU       THIS TASK IN IPU?
         BEQ       IF.1            GO IF YES
         LW        R4,C.CIPU       CURRENT DQE ADDRESS
         ANMW      R4,=X'FFFFF'    Bit 0 is occasionally on, so mask!287
*                                  it (and any others that might be !287
*                                  on)                              !287
         CI        R4,C.CIPU       CURRENT IPU TASK?
         BEQ       IF.0X           USE TASK 0 AREA IF NONE         *209*
         TRR       R4,R1           USE C.CIPU TASK'S DQE
IF.0X    TRR       R5,R2           GET PSD ADDR IN R2
         LW        R4,1W,X2        GET PSD2 OF OLD PSD
         ANMW      R4,=X'FFFFC003' STRIP OFF CPIX
         LB        R5,DQE.NUM,X1   GET DQE NUM
         IFT       C.3227,SJJ.1
         SLL       R5,3            CONCEPT SHIFT
SJJ.1    ANOP
         IFF       C.3227,SJJ.2
         SLL       R5,2            7X SHIFT
SJJ.2    ANOP
         ORR       R5,R4           SET NEW CPIX
         STW       R4,1W,X2        STORE IN OLD PSD WD 2
IF.1     LW        R2,DQE.PSSF,X1  CONTEXT ADDRESS
         BNZ       IF.2X           GO ON IF CONTEXT ADDR SET
         ZR        R4              CLEAR
         LB        R5,DQE.NUM,X1   FETCH DQE NUMBER
         MPI       R4,DQE.LCXT     FORM DQE CONTEXT AREA INDEX
         ADMW      R5,C.CTXT       ADD IN CONTEXT ORIGIN
         STW       R5,DQE.PSSF,X1  SET CONTEXT ADDR IN DQE
         TRR       R5,R2           SAVE CONTEXT ADDRESS
IF.2X    STW       R1,TSK.DQE,X2   SAVE DQE ADDRESS
         STW       R6,TSK.REGP,X2  SAVE REG POINTER IN CONTEXT AREA
*******************************************************************
*        AT THIS POINT IPU AND CPU CODE MERGE
*        R0=CC'S IN NORMAL PLACE
*        R1=DQE ADDRESS (FROM CPIX, C.CIPU, OR CONTEXT ZERO)
*        R2=TXPM DQE CONTEXT ADDRESS
*        R3=TRAP/INTERRUPT CONTEXT BLOCK ADDRESS
*        R7=TRAP/INTERRUPT NUMBER
*******************************************************************
*
         BU        MERGE.TI        MERGE WITH CPU TRAP PROCESSING
*
         IFF       OS.15E,OS15E                                 *238*
OS15E    ANOP                                                   *238*
MPX.TRPI REZ       1W              IPU MPX TRAP TABLE BASE ADDRESS
         IFF       OS.15E,OS15E                                 *238*
IPU.P00  DATAW     $-$             ADDRESS IN H.IPU FOR IPU.REGS
IPU.P01  DATAW     $-$             ADDRESS IN H.IPU FOR IP0F.REG
IPU.P02  DATAW     $-$             ADDRESS IN H.IPU FOR IP09.REG
OS15E    ANOP                                                   *238*
DSP.BSY  DATAW     $-$             ADDRESS OF SIPU ICB IN TXPM
         BOUND     1F
IPUREGS  RES       1F              TEMP SAVE LOC FOR IPU REGS
SPLREGS  RES       1F              TEMP SAVE LOC FOR IPU REGS
         IFF       OS.15E,OS15E                                 *238*
OS15E    ANOP                                                   *238*
*
         LPOOL                     MORE LITERALS HERE
         IFT       C.3227,VCT.IBLE
         IFF       MPX.EVNT,EVNT
         TITLE     H.TXPM -- REMAP PROCESSOR -- T-XPM TRAP TABLE
*
*  THIS TABLE IS POINTED TO BY SPAD LOC 'F0' UPON T-XPM DISPATCH
*
         BOUND     1D                                               !MOD
         IFT       OS.35,ET35       Only do for MPX 3.5 or >        !MOD
*  External traps are not available on the IPU for release 3.6.     !MOD
*  However, for later releases the default IPU traps will be moved  !MOD
*  above memory location 0x20 to allow their use.  So this is just  !MOD
*  defined for the future.                                          !MOD
*                                                                   !MOD
TRPI.EXT EQU       $               External traps start here        !MOD
         REPT      24              There are 24 (16 usable)         !MOD
         ACW       TRAP.YY         Default                          !MOD
         ENDR                                                       !MOD
ET35     ANOP                                                       !MOD
TRPI.VCT EQU       $
         REPT      6
         ACW       TRAP.YY         DEFAULT
         ENDR
         ACW       IVC.TBL
         REPT      10
         ACW       TRAP.YY         DEFAULT
         ENDR
IVC.TBL  EQU       $
         REPT      16              16 SVC'S
         ACW       TRAP.YY         DEFAULT
         ENDR
*
*        UNDEFINED TRAP OR INTERRUPT CONTEXT BLOCK
*
TRAP.YY  REZ       1D              OLD PSD
         GEN       12/X'840',20/W($+4W)
         DATAW     X'00014000'
         REZ       1D
         STF       R0,IPUREGS      SAVE USERS REGS
         NOP
         LI        R1,254          INVALID INT/TRAP
         BL        IFIRE           GO REPORT
         REZ       1               DUMMY TRAP/INT CONTEXT AREA
         DATAW     TRAP.YY         PSD.OMPX
         DATAW     TRAP.YY         PSD.OTMP
         DATAW     X'00FEFE00'     INT LEV OF 254, DEVICE 254
         RES       2W              FILLER
*
*  END OF T-XPM TRAP VECTOR TABLE
*
EVNT     ANOP
VCT.IBLE ANOP
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TMPX ANOP                                                       !259
*
*--------------------------------------------------------------------
*
*  ENTER HERE FROM ANY TRPI OR INTERRUPT. CPU STATE IS:
*
*    1.  IPU UNMAPPED
*    2.  INTERRUPTS BLOCKED
*    3.  TRPI/INTERRUPT ACTIVE
*    4.  THE FIRST INSTRUCTION EXECUTED IN THE INTERRUPT/TRPI HANDLER
*        WAS AN UNCONDITIONAL BRANCH TO THE APPROPRIATE TRPI ENTRY
*        (TRPI.X), WHICH WAS SET UP BY H.TXPM AT ENTRY POINT 8.
*
*  SINCE INTERRUPT HANDLERS MUST ENTER UNMAPPED, WE MUST RE-ESTABLISH
*  ALL OS MAPS.  FIRST, LOAD TRPI TYPE FOR REFERENCE TO TRPI CONTEXT
*  BLOCK.
*
         BOUND     1D              DOUBLE WORD, ALWAYS!!!!
TRPIS    EQU       $
TRPI.0   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,0            POWER FAIL
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.1   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,1            POWER ON
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.2   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,2            MEMORY PARITY
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.3   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,3            NON-PRESENT MEMORY
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.4   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,4            UNDEFINED INSTRUCTION
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.5   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,5            PRIVILEGE VIOLATION
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.0    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,6            SVC TYPE 0
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.1    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,7            SVC TYPE 1
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.2    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,8            SVC TYPE 2
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.3    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,9            SVC TYPE 3
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.4    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,10           SVC TYPE 4
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.5    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,11           SVC TYPE 5
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.6    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,12           SVC TYPE 6
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.7    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,13           SVC TYPE 7
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.8    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,14           SVC TYPE 8
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.9    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,15           SVC TYPE 9
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.A    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,16           SVC TYPE A
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.B    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,17           SVC TYPE B
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.C    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,18           SVC TYPE C
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.D    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,19           SVC TYPE D
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.E    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,20           SVC TYPE E
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
IVC.F    TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,21           SVC TYPE F
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.7   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,22           MACHINE CHECK
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.8   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,23           SYSTEM CHECK
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.9   TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,24           MAP FAULT
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.10  TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,25           IPU UNDEFINED INSTRUCTION
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.11  TRI.CXT
         BU        IFIREJ          SPECIAL CASE CODE FOR SIPU
*        STF       R0,SPLREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,26           SIGNAL CPU/IPU
         IFT       OS.32X,IF.07
         IFT       OS.36,O36                                    !295
         SBM       C.IPUCSI,C.IPUFLG TELL CPU TO HOLD OFF       !295
O36      ANOP                                                   !295
         IFF       OS.36,O36                                    !295
         SBM       C.ICSIPU,C.BIT  TELL CPU TO HOLD OFF
O36      ANOP                                                   !295
IF.07    ANOP
         IFF       OS.32X,IF.08
         SBM       IPU.GATE,EXEC.FLG  TELL CPU TO HOLD OFF
IF.08    ANOP
         BU        IFIREJ          SPECIAL CASE CODE FOR SIPU
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.12  TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,27           ADDRESS SPECIFICATION
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.13  TRI.CXT
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LPSD      TRPI.13         RETURN AT ONCE
         LI        R1,28           CONSOLE ATTENTION
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.14  TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,29           PRIVILEGED MODE HALT
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.15  TRI.CXT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,30           ARITHEMETIC EXECEPTION
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRPI.16  TRI.CXT         IPU.CFT
         SBM       IN.TXPM,TXPMFLGS  SET IN TXPM FLAG
         STF       R0,IPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,31           CACHE PARITY TRPI
         BL        IFIRE
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
MO       ANOP                                                   *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TMPX ANOP                                                       !259
*
*--------------------------------------------------------------------
*
*  ENTER HERE FROM ANY TRAP OR INTERRUPT. CPU STATE IS:
*
*    1.  CPU UNMAPPED
*    2.  INTERRUPTS BLOCKED
*    3.  TRAP/INTERRUPT ACTIVE
*    4.  THE FIRST INSTRUCTION EXECUTED IN THE INTERRUPT/TRAP HANDLER
*        WAS AN UNCONDITIONAL BRANCH TO THE APPROPRIATE TRAP ENTRY
*        (TRAP.X), WHICH WAS SET UP BY H.TXPM AT ENTRY POINT 8.
*
*  SINCE INTERRUPT HANDLERS MUST ENTER UNMAPPED, WE MUST RE-ESTABLISH
*  ALL OS MAPS.  FIRST, LOAD TRAP TYPE FOR REFERENCE TO TRAP CONTEXT
*  BLOCK.
*
         BOUND     1D              DOUBLE WORD, ALWAYS!!!!!
S.TXPM.2 EQU       $
TRAPS    EQU       $
TRAP.0   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         STF       R0,0            SAVE IN IP00.GPR
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,0            POWER FAIL
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.1   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IP01
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,1            POWER ON
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.2   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTURCTION IN H.IP02
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,2            MEMORY PARITY
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.3   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IP03
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,3            NON-PRESENT MEMORY
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.4   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IP04
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,4            UNDEFINED INSTRUCTION
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.5   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IP05
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,5            PRIVILEGE VIOLATION
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TMPX ANOP                                                       !259
*
SVC.0    TRP.CXT
         SBM       C.CSWI,C.BIT    FIRST SVC 0 INSTRUCTION          !291
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,6            SVC TYPE 0
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          SBM       C.CSWI,C.BIT    FIRST SVC 0 INSTRUCTION
*291          BL        S.TRV.35
         BU        S.TRV.35        DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.1    TRP.CXT
         SBM       C.CSWI,C.BIT    FIRST SVC 1 INSTRUCTION          !291
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,7            SVC TYPE 1
*291          SBM       C.CSWI,C.BIT    FIRST SVC 1 INSTRUCTION
*291          BL        S.TRV.35
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        S.TRV.35        DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.2    TRP.CXT
         SBM       C.CSWI,C.BIT    FIRST SVC 2 INSTRUCTION          !291
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,8            SVC TYPE 2
*291          SBM       C.CSWI,C.BIT    FIRST SVC 2 INSTRUCTION
*291          BL        S.TRV.35
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        S.TRV.35        DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.3    TRP.CXT
         TBM       31,0            FIRST SVC 3 INSTRUCTION          !291
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,9            SVC TYPE 3
*291          TBM       31,0            FIRST SVC 3 INSTRUCTION
*291          BL        S.TRV.35
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        S.TRV.35        DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.4    TRP.CXT
         SBM       C.CSWI,C.BIT    FIRST SVC 4 INSTRUCTION          !291
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         BL        $+1W            ESTABLISH CCs                    !291
*288          LI        R1,10           SVC TYPE 4
*291          SBM       C.CSWI,C.BIT    FIRST SVC 4 INSTRUCTION
         LI        R1,10           SVC TYPE 4                       !288
*291          BL        S.TRV.35
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        S.TRV.35        DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.5    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP                       LEAVE NOP'S FOR H.SURE       *210*
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,11           SVC TYPE 5                   *210*
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.6    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,12           SVC TYPE 6                   *210*
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.7    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,13           SVC TYPE 7                   *210*
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.8    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,14           SVC TYPE 8                   *210*
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.9    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         STF       R0,0            SAVE IN SVC9.REG
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,15           SVC TYPE 9
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.A    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,16           SVC TYPE A
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.B    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,17           SVC TYPE B
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.C    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,18           SVC TYPE C
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.D    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,19           SVC TYPE D
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.E    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,20           SVC TYPE E
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
SVC.F    TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST SVC F INSTRUCTION
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CCs                    !291
         LI        R1,21           SVC TYPE F
*291          BL        FIRE
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TMPX ANOP                                                       !259
TRAP.7   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IP07
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,22           MACHINE CHECK
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.8   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IP08
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,23           SYSTEM CHECK
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.9   TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IP09
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,24           MAP FAULT
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.10  TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,25           IPU UNDEFINED INSTRUCTION
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.11  TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,26           SIGNAL CPU/IPU
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.12  TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IPAE
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,27           ADDRESS SPECIFICATION
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.13  TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IPCT
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,28           CONSOLE ATTENTION
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.14  TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         ABM       31,C.GINT       FIRST INSTRUCTION IN H.IPHT
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,29           PRIVILEGED MODE HALT
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.15  TRP.CXT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         STF       R0,0            SAVE IN IP0F.REG
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,30           ARITHEMETIC EXECEPTION
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
TRAP.16  TRP.CXT         IPU.CFT
*291          STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         NOP
         NOP
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.    !291
         BL        $+1W            ESTABLISH CC's                   !291
         LI        R1,31           CACHE PARITY TRAP
         ADI       R0,3W           POINT TO CONTEXT AREA            !291
*291          BL        FIRE
         BU        FIRE            DON'T CHANGE R0                  !291
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- S.TXPM.2 (TRP/INTRPT)
TTL.TMPX ANOP                                                       !259
*
INTRPTS  REPT      MAX.INT         MAX INTERRUPTS USER WANTS
         INT.CXT
         BEI
         STF       R0,CPUREGS      MUST SAVE USER'S REGS, FIRST.
         LI        R1,$$$+31       INTERRUPT # 0
         BL        S.TRV.32
         REZ       TRAP.LEN        TRAP/INT CONTEXT AREA
         ENDR
*
*-----------------------------------------------------------------------
*
*  TRAP AND INTERRUPT CONTEXT AREA  (UNUSED PORTION IS OVERLAID
*  BY SYSGEN VIA H.TXPM AT ENTRY POINT 8)
*
         BOUND     1W
ADQE.CXT REZ       255*DQE.LCXT    CONTEXT AREA FOR UP TO 255 DQE'S
         IFF       C.3227,NOTB
*
* 32/7X 'HARD-WIRED' TRAV VECTOR TABLE
*
TTBL.7X  DATAW    X'0F4'           POWER FAIL
         DATAW    X'0FC'           POWER ON
         DATAW    X'0E8'           MEMORY PARITY
         DATAW    X'190'           NON-PRESENT MEMORY
         DATAW    X'194'           UNDEFINED INSTRUCTION
         DATAW    X'198'           PRIVILEGE VIOLATION
         DATAW    X'180'           SVC
         DATAW    X'184'           MACHINE CHECK
         DATAW    X'188'           SYSTEM CHECK
         DATAW    X'18C'           MAP FAULT
         DATAW    X'000'           IPU UI?
         DATAW    X'2E0'           SIGNAL CPU
         DATAW    X'000'           AD02
         DATAW    X'000'           CONSOLE ATTENTION (INTERRUPT ON 7X)
         DATAW    X'0E4'           WATCH DOG TIMEOUT
         DATAW    X'1A4'           ARITHEMETIC EXCEPTION
*
*      IPU TRAP TABLE
TTBL.7I  DATAW    X'000'           POWER FAIL
         DATAW    X'000'           POWER ON
         DATAW    X'000'           MEMORY PARITY
         DATAW    X'000'           NON-PRESENT MEMORY
         DATAW    X'2EC'           UNDEFINED INSTRUCTION(ALSO ALL OTHER)
         DATAW    X'000'           PRIVILEGE VIOLATION
         DATAW    X'2E8'           SVC
         DATAW    X'000'           MACHINE CHECK
         DATAW    X'000'           SYSTEM CHECK
         DATAW    X'000'           MAP FAULT
         DATAW    X'2F0'           IPU CALM
         DATAW    X'2E4'           SIGNAL CPU
         DATAW    X'000'           AD02
         DATAW    X'000'           CONSOLE ATTENTION (INTERRUPT ON 7X)
         DATAW    X'000'           STOP IPU (DO NOT HANDLE X'2F4')
         DATAW    X'000'           ARITHEMETIC EXCEPTION
NOTB     ANOP
         IFF       C.MPXOUT,MO                                  *237*
*
*-------------------------------------------------------------------
*
*  THE FOLLOWING CODE IS MOVED TO THE PATCH AREA DURING INITIALIZATION
*  OF THE SYSTEM.  IT WILL RESTORE THE C.MPL ADDRESS TO SPAD OF THE
*  CPU OR IPU AND RELOAD R0 AND R1.  WHEN ENTERED, THE O/S IS MAPPED IN
*  WITH THE NUMBER OF TXPM MAP BLOCKS BUT THE USER MAPS HAVE NOT BEEN
*  LOADED.  THE MAP LOAD AND DISPATCH IS COMPLETED BY THE LPSDCM.
*  TWO COPIES ARE PLACED IN THE PATCH AREA, ONE FOR CPU, AND ONE
*  FOR IPU AND BIASED BY PATCH ADDRESS AT LOAD TIME.
*
*        ON ENTRY: R1 = CPU/IPU SPAD ADDRESS
*                  R0 = C.MPL ADDRESS (RETAIN BIT SET)
*                  R5 = PSD2 SPAD ADDRESS (F5 OR 85?)
*                  R4 = PIX FOR NEW TASK
*                  USER REGS R0 AND R1 SET IN PLACE
*                  USER REGS R4 AND R5 SET IN PLACE
*                  DISPATCH PSD SET IN PLACE
*
         BOUND     1D              MUST BE DW BOUNDED
CODE.DSP LPSDCM    DSP.1-CODE.DSP  LOAD O/S AND TASK 1              !252
DSP.C    TRSC      R0,R1           LOAD C.MPL INTO SPAD             !252
         TRSC      R4,R5           LOAD PSD2 INTO SPAD
DSP.LD   LD        R0,SV.R01-CODE.DSP RESTORE USER REGS             !260
         LD        R4,SV.R45-CODE.DSP RESTORE USER REGS             !252
DSP.ZBM  ZBM       IN.TXPM,TXPMFLGS CLEAR IN TXPM FLAG          *242!252
         LPSD      DSP.2-CODE.DSP   DISPATCH TO USER                !252
         BOUND     1D
SV.R01   DATAW     $-$             USER R0                          !252
         DATAW     $-$             USER R1
SV.R45   DATAW     $-$             USER R4                          !252
         DATAW     $-$             USER R5
DSP.1    DATAW     $-$             PSD WD1 INITIAL DISPATCH         !252
         DATAW     $-$             PSD WD2 INITIAL DISPATCH
DSP.2    DATAW     $-$             PSD WD1 FINAL DISPATCH           !252
         DATAW     $-$             PSD WD2 FINAL DISPATCH
TX.MPL   GEN       8/X'01',24/W($+2W-CODE.DSP) TEMP MPL WD1 (7X)    !252
         GEN       8/X'81',24/W($+2W-CODE.DSP) TEMP MPL WD2 (7X)
         DATAW     $-$             TEMP MPL
         DATAW     $-$             TEMP MPL
         IFT       DO.BUI,BUI.DO                                    !255
DSP.R01  RES       1D                                               !255
DSP.R4   RES       1W                                               !255
DSP.MSK1 DATAW     X'7FFFC'        Word address mask                !255
DSP.MSK2 DATAW     X'FFF00000'     To check BU *                    !255
DSP.BUII BU        *0              A BU indirect                    !255
DSP.BUC  DATAW     0               Counter of these events          !255
DSP.BUI  STD       R0,DSP.R01-CODE.DSP                              !255
         STW       R4,DSP.R4-CODE.DSP                               !255
*  First, count that we got here                                    !255
         ABM       15,DSP.BUC-CODE.DSP Count nr of times we checked !255
*  Next, get the instruction's address                              !255
         LW        R4,DSP.MSK1-CODE.DSP                             !255
         LMW       R1,DSP.2-CODE.DSP                                !255
*  Get the instruction                                              !255
         LW        R0,,X1          Pick up the instruction          !255
*  See if it's a BU *                                               !255
         LW        R4,DSP.MSK2-CODE.DSP                             !255
         CMMW      R0,DSP.BUII-CODE.DSP Is it a BU *?               !255
         BNE       DSP.BUI2-CODE.DSP Go if no                       !255
         ABM       31,DSP.BUC-CODE.DSP Else count it                !255
         ZBM       30,DSP.2-CODE.DSP And back up user's PSD by 1 hw !255
DSP.BUI2 LD        R0,DSP.R01-CODE.DSP Get regs back                !255
         LW        R4,DSP.R4-CODE.DSP                               !255
         BU        DSP.C-CODE.DSP                                   !255
BUI.DO   ANOP                                                       !255
         BOUND     1D                                               !255
CODE.END EQU       $
CODE.SIZ EQU       CODE.END-CODE.DSP    SIZE OF PATCH AREA
*
MO       ANOP                                                   *237*
         IFF       C.MPXOUT,MO                                  *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- SECONDARY VECTOR TABLE
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- SECONDARY VECTOR TABLE
TTL.TMPX ANOP                                                       !259
*
SEQ1.IO         EQU     3
SEQ2.50         EQU     2
SEQ1.RET        EQU     0
SEQ1.15         EQU     8
SEQ1.17         EQU     44
SEQ1.18         EQU     49
SEQ1.1E         EQU     48
SEQ1.25         EQU     4
SEQ1.30         EQU     1
SEQ1.3A         EQU     8
*277 SEQ1.3D         EQU     5
SEQ1.3F         EQU     5                                           !277
SEQ1.40         EQU     6
SEQ1.40R        EQU     50
SEQ1.45         EQU     9
SEQ1.4B         EQU     48
SEQ1.4F         EQU     10
SEQ1.4FR        EQU     51
SEQ1.50         EQU     11
SEQ1.52         EQU     47
SEQ1.5C         EQU     15
SEQ1.5E         EQU     12
SEQ1.5F         EQU     13
SEQ1.60         EQU     39
SEQ1.63         EQU     8                                           !245
SEQ1.64         EQU     8
SEQ1.6B         EQU     39
SEQ1.6C         EQU     19
SEQ1.6D         EQU     19
SEQ1.6E         EQU     39
SEQ1.72         EQU     20
SEQ1.73         EQU     37
SEQ1.7A         EQU     21
SEQ2.20         EQU     22
*279 SEQ2.23         EQU     23
SEQ2.24         EQU     25
SEQ2.27         EQU     26
SEQ2.28         EQU     46
SEQ2.29         EQU     28
SEQ2.2A         EQU     29
SEQ2.2B         EQU     31
SEQ2.2C         EQU     30
SEQ2.2D         EQU     23
SEQ2.2E         EQU     33
SEQ2.2F         EQU     34
SEQ2.30         EQU     23
SEQ2.31         EQU     29
SEQ2.32         EQU     31
SEQ2.RET        EQU     0
SEQ2.40         EQU     24
SEQ2.41         EQU     35
SEQ2.42         EQU     42
SEQ2.43         EQU     42
SEQ2.44         EQU     36
SEQ2.48         EQU     38
SEQ2.49         EQU     24
SEQ2.4A         EQU     24
SEQ2.4C         EQU     18
SEQ2.4D         EQU     SEQ1.5C                                     !294
SEQ2.51         EQU     14
SEQ2.52         EQU     40
SEQ2.53         EQU     41
SEQ2.54         EQU     27
SEQ2.55         EQU     25
SEQ2.59         EQU     32
SEQ2.59R        EQU     56                                          !283
SEQ2.62         EQU     45
SEQ1.44R        EQU     7
SEQ1.50R        EQU     8
SEQ1.65R        EQU     16
SEQ1.67R        EQU     17
SEQ1.68R        EQU     18
SEQ1.6AR        EQU     18
SEQ1.71R        EQU     18                                          !245
SEQ2.40R        EQU     24
SEQ2.4BR        EQU     18
SEQ2.61R        EQU     43
SEQ2.7A         EQU     52         M.GETDEF
SEQ2.7BR        EQU     53         M.GADRL2
SEQ2.AE         EQU     54         M.TSMPC 3.4 AND ABOVE        *226*
SEQ2.7DR        EQU     55         M.GTSAD                      *233*
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- BIAS TYPE 1 SVC'S
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- BIAS TYPE 1 SVC'S
TTL.TMPX ANOP                                                       !259
         BOUND     1W
SVC1BTBL DATAB     SEQ1.RET        CALL # = X'00'
         DATAB     SEQ1.RET        CALL # = X'01'
         DATAB     SEQ1.RET        CALL # = X'02'
         DATAB     SEQ1.RET        CALL # = X'03'
         DATAB     SEQ1.RET        CALL # = X'04'
         DATAB     SEQ1.RET        CALL # = X'05'
         DATAB     SEQ1.RET        CALL # = X'06'
         DATAB     SEQ1.RET        CALL # = X'07'
         DATAB     SEQ1.RET        CALL # = X'08'
         DATAB     SEQ1.RET        CALL # = X'09'
         DATAB     SEQ1.RET        CALL # = X'0A'
         DATAB     SEQ1.RET        CALL # = X'0B'
         DATAB     SEQ1.RET        CALL # = X'0C'
         DATAB     SEQ1.IO         CALL # = X'0D'
         DATAB     SEQ2.50         CALL # = X'0E'
         DATAB     SEQ1.RET        CALL # = X'0F'
         DATAB     SEQ1.IO         CALL # = X'10'
         DATAB     SEQ1.RET        CALL # = X'11'
         DATAB     SEQ1.RET        CALL # = X'12'
         DATAB     SEQ1.RET        CALL # = X'13'
         DATAB     SEQ1.RET        CALL # = X'14'
         DATAB     SEQ1.15         CALL # = X'15'
         DATAB     SEQ1.RET        CALL # = X'16'
         DATAB     SEQ1.17         CALL # = X'17'  ADIO
         DATAB     SEQ1.18         CALL # = X'18'  ADIO
         DATAB     SEQ1.RET        CALL # = X'19'
         DATAB     SEQ1.RET        CALL # = X'1A'
         DATAB     SEQ1.RET        CALL # = X'1B'
         DATAB     SEQ1.RET        CALL # = X'1C'
         DATAB     SEQ1.RET        CALL # = X'1D'
         IFF       OS.15E,NO.15                                     !245
         DATAB     SEQ1.1E         CALL # = X'1E'
NO.15    ANOP                                                       !245
         IFT       OS.15E,DO.15                                     !245
         DATAB     SEQ1.RET        CALL # = X'1E'                   !245
DO.15    ANOP                                                       !245
         DATAB     SEQ1.RET        CALL # = X'1F'
         DATAB     SEQ1.RET        CALL # = X'20'
         DATAB     SEQ1.RET        CALL # = X'21'
         DATAB     SEQ1.RET        CALL # = X'22'
         DATAB     SEQ1.RET        CALL # = X'23'
         DATAB     SEQ1.RET        CALL # = X'24'
         DATAB     SEQ1.25         CALL # = X'25'
         DATAB     SEQ1.IO         CALL # = X'26'
         DATAB     SEQ1.IO         CALL # = X'27'
         DATAB     SEQ1.RET        CALL # = X'28'
         DATAB     SEQ1.RET        CALL # = X'29'
         DATAB     SEQ1.RET        CALL # = X'2A'
         DATAB     SEQ1.RET        CALL # = X'2B'
         DATAB     SEQ1.RET        CALL # = X'2C'
         DATAB     SEQ1.RET        CALL # = X'2D'
         DATAB     SEQ1.RET        CALL # = X'2E'
         DATAB     SEQ1.RET        CALL # = X'2F'
         DATAB     SEQ1.30         CALL # = X'30'
         DATAB     SEQ1.IO         CALL # = X'31'
         DATAB     SEQ1.IO         CALL # = X'32'
         DATAB     SEQ1.IO         CALL # = X'33'
         DATAB     SEQ1.IO         CALL # = X'34'
         DATAB     SEQ1.IO         CALL # = X'35'
         DATAB     SEQ1.IO         CALL # = X'36'
         DATAB     SEQ1.IO         CALL # = X'37'
         DATAB     SEQ1.IO         CALL # = X'38'
         DATAB     SEQ1.30         CALL # = X'39' (SAME AS M.OPEN)
         DATAB     SEQ1.3A         CALL # = X'3A'
         DATAB     SEQ1.RET        CALL # = X'3B'
         DATAB     SEQ2.50         CALL # = X'3C'
*277          DATAB     SEQ1.3D         CALL # = X'3D'
         DATAB     SEQ2.50         CALL # = X'3D'                   !277
         DATAB     SEQ1.IO         CALL # = X'3E'
*277          DATAB     SEQ1.3D         CALL # = X'3F' (SAME AS '3D')
         DATAB     SEQ1.3F         CALL # = X'3F'                   !277
         DATAB     SEQ1.40         CALL # = X'40'
         DATAB     SEQ1.RET        CALL # = X'41'
         DATAB     SEQ1.RET        CALL # = X'42'
         DATAB     SEQ1.RET        CALL # = X'43'
         DATAB     SEQ1.RET        CALL # = X'44'
         DATAB     SEQ1.45         CALL # = X'45'
         DATAB     SEQ1.RET        CALL # = X'46'
         DATAB     SEQ1.RET        CALL # = X'47'
         DATAB     SEQ1.RET        CALL # = X'48'
         DATAB     SEQ1.RET        CALL # = X'49'
         DATAB     SEQ1.RET        CALL # = X'4A'
         IFF       OS.15E,NO.15                                     !245
         DATAB     SEQ1.4B         CALL # = X'4B'
NO.15    ANOP                                                       !245
         IFT       OS.15E,DO.15                                     !245
         DATAB     SEQ1.RET        CALL # = X'4B'                   !245
DO.15    ANOP                                                       !245
         DATAB     SEQ1.RET        CALL # = X'4C'
         DATAB     SEQ1.RET        CALL # = X'4D'
         DATAB     SEQ1.RET        CALL # = X'4E'
         IFF       OS.15E,NO.15                                     !245
         DATAB     SEQ1.4F         CALL # = X'4F'
NO.15    ANOP                                                       !245
         IFT       OS.15E,DO.15                                     !245
         DATAB     SEQ1.RET        CALL # = X'4F'                   !245
DO.15    ANOP                                                       !245
         DATAB     SEQ1.50         CALL # = X'50'
         DATAB     SEQ1.50         CALL # = X'51'
         IFF       OS.15E,NO.15                                     !245
         DATAB     SEQ1.52         CALL # = X'52'
NO.15    ANOP                                                       !245
         IFT       OS.15E,DO.15                                     !245
         DATAB     SEQ1.RET        CALL # = X'52'                   !245
DO.15    ANOP                                                       !245
         DATAB     SEQ1.RET        CALL # = X'53'
         DATAB     SEQ1.RET        CALL # = X'54'
         DATAB     SEQ1.RET        CALL # = X'55'
         DATAB     SEQ1.RET        CALL # = X'56'
         DATAB     SEQ1.RET        CALL # = X'57'
         DATAB     SEQ1.RET        CALL # = X'58'
         DATAB     SEQ1.RET        CALL # = X'59'
         DATAB     SEQ1.RET        CALL # = X'5A'
         DATAB     SEQ1.RET        CALL # = X'5B'
         DATAB     SEQ1.5C         CALL # = X'5C'
         DATAB     SEQ1.RET        CALL # = X'5D'
         DATAB     SEQ1.5E         CALL # = X'5E'
         DATAB     SEQ1.5F         CALL # = X'5F'
         DATAB     SEQ1.60         CALL # = X'60'
         DATAB     SEQ1.RET        CALL # = X'61'
         DATAB     SEQ1.RET        CALL # = X'62'
         DATAB     SEQ1.RET        CALL # = X'63'
         DATAB     SEQ1.64         CALL # = X'64'
         DATAB     SEQ1.RET        CALL # = X'65'
         DATAB     SEQ1.RET        CALL # = X'66'
         DATAB     SEQ1.RET        CALL # = X'67'
         DATAB     SEQ1.RET        CALL # = X'68'
         DATAB     SEQ1.RET        CALL # = X'69'
         DATAB     SEQ1.RET        CALL # = X'6A'
         DATAB     SEQ1.6B         CALL # = X'6B'
         DATAB     SEQ1.6C         CALL # = X'6C'
         DATAB     SEQ1.6D         CALL # = X'6D'
         DATAB     SEQ1.6E         CALL # = X'6E'
         DATAB     SEQ1.RET        CALL # = X'6F'
         DATAB     SEQ1.RET        CALL # = X'70'
         DATAB     SEQ1.RET        CALL # = X'71'
         DATAB     SEQ1.72         CALL # = X'72'
         DATAB     SEQ1.73         CALL # = X'73'
         DATAB     SEQ1.RET        CALL # = X'74'
         DATAB     SEQ1.RET        CALL # = X'75'
         DATAB     SEQ1.RET        CALL # = X'76'
         DATAB     SEQ1.RET        CALL # = X'77'
         DATAB     SEQ1.RET        CALL # = X'78'
         DATAB     SEQ1.RET        CALL # = X'79'
         DATAB     SEQ1.7A         CALL # = X'7A'
         DATAB     SEQ1.7A         CALL # = X'7B' (SAME AS '7A')
         DATAB     SEQ1.RET        CALL # = X'7C'
         DATAB     SEQ1.5E         CALL # = X'7D' (SAME AS '5E')
         DATAB     SEQ1.RET        CALL # = X'7E'
         DATAB     SEQ1.RET        CALL # = X'7F'
         REZ       256B            ENOUGH FOR 256 MORE SVC'S
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- UNBIAS TYPE 1 SVC'S
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- UNBIAS TYPE 1 SVC'S
TTL.TMPX ANOP                                                       !259
         BOUND     1W
SVC1UTBL DATAB     SEQ1.RET        CALL # = X'00'
         DATAB     SEQ1.RET        CALL # = X'01'
         DATAB     SEQ1.RET        CALL # = X'02'
         DATAB     SEQ1.RET        CALL # = X'03'
         DATAB     SEQ1.RET        CALL # = X'04'
         DATAB     SEQ1.RET        CALL # = X'05'
         DATAB     SEQ1.RET        CALL # = X'06'
         DATAB     SEQ1.RET        CALL # = X'07'
         DATAB     SEQ1.RET        CALL # = X'08'
         DATAB     SEQ1.RET        CALL # = X'09'
         DATAB     SEQ1.RET        CALL # = X'0A'
         DATAB     SEQ1.RET        CALL # = X'0B'
         DATAB     SEQ1.RET        CALL # = X'0C'
         DATAB     SEQ1.IO         CALL # = X'0D'
         DATAB     SEQ2.50         CALL # = X'0E'
         DATAB     SEQ1.RET        CALL # = X'0F'
         DATAB     SEQ1.IO         CALL # = X'10'
         DATAB     SEQ1.RET        CALL # = X'11'
         DATAB     SEQ1.RET        CALL # = X'12'
         DATAB     SEQ1.RET        CALL # = X'13'
         DATAB     SEQ1.RET        CALL # = X'14'
         DATAB     SEQ1.15         CALL # = X'15'
         DATAB     SEQ1.RET        CALL # = X'16'
         DATAB     SEQ1.17         CALL # = X'17'
         DATAB     SEQ1.18         CALL # = X'18'
         DATAB     SEQ1.RET        CALL # = X'19'
         DATAB     SEQ1.RET        CALL # = X'1A'
         DATAB     SEQ1.RET        CALL # = X'1B'
         DATAB     SEQ1.RET        CALL # = X'1C'
         DATAB     SEQ1.RET        CALL # = X'1D'
         IFF       OS.15E,NO.15                                     !245
         DATAB     SEQ1.1E         CALL # = X'1E'
NO.15    ANOP                                                       !245
         IFT       OS.15E,DO.15                                     !245
         DATAB     SEQ1.RET        CALL # = X'1E'                   !245
DO.15    ANOP                                                       !245
         DATAB     SEQ1.RET        CALL # = X'1F'
         DATAB     SEQ1.RET        CALL # = X'20'
         DATAB     SEQ1.RET        CALL # = X'21'
         DATAB     SEQ1.RET        CALL # = X'22'
         DATAB     SEQ1.RET        CALL # = X'23'
         DATAB     SEQ1.RET        CALL # = X'24'
         DATAB     SEQ1.25         CALL # = X'25'
         DATAB     SEQ1.IO         CALL # = X'26'
         DATAB     SEQ1.IO         CALL # = X'27'
         DATAB     SEQ1.RET        CALL # = X'28'
         DATAB     SEQ1.RET        CALL # = X'29'
         DATAB     SEQ1.RET        CALL # = X'2A'
         DATAB     SEQ1.RET        CALL # = X'2B'
         DATAB     SEQ1.RET        CALL # = X'2C'
         DATAB     SEQ1.RET        CALL # = X'2D'
         DATAB     SEQ1.RET        CALL # = X'2E'
         DATAB     SEQ1.RET        CALL # = X'2F'
         DATAB     SEQ1.30         CALL # = X'30'
         DATAB     SEQ1.IO         CALL # = X'31'
         DATAB     SEQ1.IO         CALL # = X'32'
         DATAB     SEQ1.IO         CALL # = X'33'
         DATAB     SEQ1.IO         CALL # = X'34'
         DATAB     SEQ1.IO         CALL # = X'35'
         DATAB     SEQ1.IO         CALL # = X'36'
         DATAB     SEQ1.IO         CALL # = X'37'
         DATAB     SEQ1.IO         CALL # = X'38'
         DATAB     SEQ1.30         CALL # = X'39' (SAME AS M.OPEN)
         DATAB     SEQ1.3A         CALL # = X'3A'
         DATAB     SEQ1.RET        CALL # = X'3B'
         DATAB     SEQ2.50         CALL # = X'3C'
*277          DATAB     SEQ1.3D         CALL # = X'3D'
         DATAB     SEQ2.50         CALL # = X'3D'                   !277
         DATAB     SEQ1.IO         CALL # = X'3E'
*277          DATAB     SEQ1.3D         CALL # = X'3F' (SAME AS '3D')
         DATAB     SEQ1.3F         CALL # = X'3F'                   !277
         DATAB     SEQ1.40R        CALL # = X'40'
         DATAB     SEQ1.RET        CALL # = X'41'
         DATAB     SEQ1.RET        CALL # = X'42'
         DATAB     SEQ1.RET        CALL # = X'43'
         DATAB     SEQ1.44R        CALL # = X'44'
         DATAB     SEQ1.45         CALL # = X'45'
         DATAB     SEQ1.RET        CALL # = X'46'
         DATAB     SEQ1.RET        CALL # = X'47'
         DATAB     SEQ1.RET        CALL # = X'48'
         DATAB     SEQ1.RET        CALL # = X'49'
         DATAB     SEQ1.RET        CALL # = X'4A'
         DATAB     SEQ1.RET        CALL # = X'4B'
         DATAB     SEQ1.RET        CALL # = X'4C'
         DATAB     SEQ1.RET        CALL # = X'4D'
         DATAB     SEQ1.RET        CALL # = X'4E'
         DATAB     SEQ1.4FR        CALL # = X'4F'
         DATAB     SEQ1.50R        CALL # = X'50'
         DATAB     SEQ1.RET        CALL # = X'51'
         DATAB     SEQ1.RET        CALL # = X'52'
         DATAB     SEQ1.RET        CALL # = X'53'
         DATAB     SEQ1.RET        CALL # = X'54'
         DATAB     SEQ1.RET        CALL # = X'55'
         DATAB     SEQ1.RET        CALL # = X'56'
         DATAB     SEQ1.RET        CALL # = X'57'
         DATAB     SEQ1.RET        CALL # = X'58'
         DATAB     SEQ1.RET        CALL # = X'59'
         DATAB     SEQ1.RET        CALL # = X'5A'
         DATAB     SEQ1.RET        CALL # = X'5B'
         DATAB     SEQ1.5C         CALL # = X'5C'
         DATAB     SEQ1.RET        CALL # = X'5D'
         DATAB     SEQ1.RET        CALL # = X'5E'
         DATAB     SEQ1.5F         CALL # = X'5F'
         DATAB     SEQ1.60         CALL # = X'60'
         DATAB     SEQ1.RET        CALL # = X'61'
         DATAB     SEQ1.RET        CALL # = X'62'
         DATAB     SEQ1.63         CALL # = X'63'                   !245
         DATAB     SEQ1.64         CALL # = X'64'
         DATAB     SEQ1.65R        CALL # = X'65'
         DATAB     SEQ1.RET        CALL # = X'66'
         DATAB     SEQ1.67R        CALL # = X'67'
         DATAB     SEQ1.68R        CALL # = X'68'
         DATAB     SEQ1.67R        CALL # = X'69' (SAME AS '67')
         DATAB     SEQ1.6AR        CALL # = X'6A'
         DATAB     SEQ1.6B         CALL # = X'6B'
         DATAB     SEQ1.6C         CALL # = X'6C'
         DATAB     SEQ1.6D         CALL # = X'6D'
         DATAB     SEQ1.6E         CALL # = X'6E'
         DATAB     SEQ1.RET        CALL # = X'6F'
         DATAB     SEQ1.RET        CALL # = X'70'
         IFF       OS.15E,NO.15                                     !245
         DATAB     SEQ1.RET        CALL # = X'71'
NO.15    ANOP                                                       !245
         IFT       OS.15E,DO.15                                     !245
         DATAB     SEQ1.71R        CALL # = X'71'                   !245
DO.15    ANOP                                                       !245
         DATAB     SEQ1.72         CALL # = X'72'
         DATAB     SEQ1.73         CALL # = X'73'
         DATAB     SEQ1.RET        CALL # = X'74'
         DATAB     SEQ1.RET        CALL # = X'75'
         DATAB     SEQ1.RET        CALL # = X'76'
         DATAB     SEQ1.RET        CALL # = X'77'
         DATAB     SEQ1.RET        CALL # = X'78'
         DATAB     SEQ1.RET        CALL # = X'79'
         DATAB     SEQ1.7A         CALL # = X'7A'
         DATAB     SEQ1.7A         CALL # = X'7B' (SAME AS '7A')
         DATAB     SEQ1.RET        CALL # = X'7C'
         DATAB     SEQ1.RET        CALL # = X'7D' (SAME AS '5E')
         DATAB     SEQ1.RET        CALL # = X'7E'
         DATAB     SEQ1.RET        CALL # = X'7F'
         REZ       256B            ENOUGH FOR 256 MORE SVC'S
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- BIAS TYPE 2 SVC'S
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- BIAS TYPE 2 SVC'S
TTL.TMPX ANOP                                                       !259
         BOUND     1W
SVC2BTBL DATAB     SEQ2.RET        CALL # = X'00'
         DATAB     SEQ2.RET        CALL # = X'01'
         DATAB     SEQ2.RET        CALL # = X'02'
         DATAB     SEQ2.RET        CALL # = X'03'
         DATAB     SEQ2.RET        CALL # = X'04'
         DATAB     SEQ2.RET        CALL # = X'05'
         DATAB     SEQ2.RET        CALL # = X'06'
         DATAB     SEQ2.RET        CALL # = X'07'
         DATAB     SEQ2.RET        CALL # = X'08'
         DATAB     SEQ2.RET        CALL # = X'09'
         DATAB     SEQ2.RET        CALL # = X'0A'
         DATAB     SEQ2.RET        CALL # = X'0B'
         DATAB     SEQ2.RET        CALL # = X'0C'
         DATAB     SEQ2.RET        CALL # = X'0D'
         DATAB     SEQ2.RET        CALL # = X'0E'
         DATAB     SEQ2.RET        CALL # = X'0F'
         DATAB     SEQ2.RET        CALL # = X'10'
         DATAB     SEQ2.RET        CALL # = X'11'
         DATAB     SEQ2.RET        CALL # = X'12'
         DATAB     SEQ2.RET        CALL # = X'13'
         DATAB     SEQ2.RET        CALL # = X'14'
         DATAB     SEQ2.RET        CALL # = X'15'
         DATAB     SEQ2.RET        CALL # = X'16'
         DATAB     SEQ2.RET        CALL # = X'17'
         DATAB     SEQ2.RET        CALL # = X'18'
         DATAB     SEQ2.RET        CALL # = X'19'
         DATAB     SEQ2.RET        CALL # = X'1A'
         DATAB     SEQ2.RET        CALL # = X'1B'
         DATAB     SEQ2.RET        CALL # = X'1C'
         DATAB     SEQ2.RET        CALL # = X'1D'
         DATAB     SEQ2.RET        CALL # = X'1E'
         DATAB     SEQ2.RET        CALL # = X'1F'
         DATAB     SEQ2.20         CALL # = X'20'
         DATAB     SEQ2.20         CALL # = X'21' (SAME AS '20')
         DATAB     SEQ2.20         CALL # = X'22' (SAME AS '20')
         DATAB     SEQ2.20         CALL # = X'23' (SAME AS '20')    !279
         DATAB     SEQ2.24         CALL # = X'24'
         DATAB     SEQ2.24         CALL # = X'25'  (SAME AS '24')
         DATAB     SEQ2.24         CALL # = X'26'  (SAME AS '24')
         DATAB     SEQ2.27         CALL # = X'27'
         DATAB     SEQ2.28         CALL # = X'28'
         DATAB     SEQ2.29         CALL # = X'29'
         DATAB     SEQ2.2A         CALL # = X'2A'
         DATAB     SEQ2.2B         CALL # = X'2B'
         DATAB     SEQ2.2C         CALL # = X'2C'
         DATAB     SEQ2.2D         CALL # = X'2D'
         DATAB     SEQ2.2E         CALL # = X'2E'
         DATAB     SEQ2.2F         CALL # = X'2F'
         DATAB     SEQ2.30         CALL # = X'30'
         DATAB     SEQ2.31         CALL # = X'31'
         DATAB     SEQ2.32         CALL # = X'32'
         DATAB     SEQ2.RET        CALL # = X'33'
         DATAB     SEQ2.RET        CALL # = X'34'
         DATAB     SEQ2.RET        CALL # = X'35'
         DATAB     SEQ2.RET        CALL # = X'36'
         DATAB     SEQ2.RET        CALL # = X'37'
         DATAB     SEQ2.RET        CALL # = X'38'
         DATAB     SEQ2.RET        CALL # = X'39'
         DATAB     SEQ2.RET        CALL # = X'3A'
         DATAB     SEQ2.RET        CALL # = X'3B'
         DATAB     SEQ2.RET        CALL # = X'3C'
         DATAB     SEQ2.RET        CALL # = X'3D'
         DATAB     SEQ2.RET        CALL # = X'3E'
         DATAB     SEQ2.RET        CALL # = X'3F'
         DATAB     SEQ2.40         CALL # = X'40'
         DATAB     SEQ2.41         CALL # = X'41'
         DATAB     SEQ2.42         CALL # = X'42'
         DATAB     SEQ2.43         CALL # = X'43'
         DATAB     SEQ2.44         CALL # = X'44'
         DATAB     SEQ2.44         CALL # = X'45' (SAME AS 44)
         DATAB     SEQ2.44         CALL # = X'46' (SAME AS 44)
         DATAB     SEQ2.44         CALL # = X'47' (SAME AS 44)
         DATAB     SEQ2.48         CALL # = X'48'
         DATAB     SEQ2.49         CALL # = X'49'
         DATAB     SEQ2.4A         CALL # = X'4A'
         DATAB     SEQ2.RET        CALL # = X'4B'
         DATAB     SEQ2.4C         CALL # = X'4C'
*294          DATAB     SEQ2.RET        CALL # = X'4D'
         DATAB     SEQ2.4D         CALL # = X'4D'                   !294
         DATAB     SEQ2.RET        CALL # = X'4E'
         DATAB     SEQ2.RET        CALL # = X'4F'
         DATAB     SEQ2.50         CALL # = X'50'
         DATAB     SEQ2.51         CALL # = X'51'
         DATAB     SEQ2.52         CALL # = X'52'
         DATAB     SEQ2.53         CALL # = X'53'
         DATAB     SEQ2.54         CALL # = X'54'
         DATAB     SEQ2.55         CALL # = X'55'
         DATAB     SEQ2.RET        CALL # = X'56'
         DATAB     SEQ2.RET        CALL # = X'57'
         DATAB     SEQ2.RET        CALL # = X'58'
         DATAB     SEQ2.59         CALL # = X'59'
         DATAB     SEQ2.RET        CALL # = X'5A'
         DATAB     SEQ2.RET        CALL # = X'5B'
         DATAB     SEQ2.RET        CALL # = X'5C'
         DATAB     SEQ2.RET        CALL # = X'5D'
         DATAB     SEQ2.RET        CALL # = X'5E'
         DATAB     SEQ2.RET        CALL # = X'5F'
         DATAB     SEQ2.RET        CALL # = X'60'
         DATAB     SEQ2.RET        CALL # = X'61'
         DATAB     SEQ2.62         CALL # = X'62'
         DATAB     SEQ2.RET        CALL # = X'63'
         DATAB     SEQ2.RET        CALL # = X'64'
         DATAB     SEQ2.RET        CALL # = X'65'
         DATAB     SEQ2.RET        CALL # = X'66'
         DATAB     SEQ2.RET        CALL # = X'67'
         DATAB     SEQ2.RET        CALL # = X'68'
         DATAB     SEQ2.RET        CALL # = X'69'
         DATAB     SEQ2.RET        CALL # = X'6A'
         DATAB     SEQ2.RET        CALL # = X'6B'
         DATAB     SEQ2.RET        CALL # = X'6C'
         DATAB     SEQ2.RET        CALL # = X'6D'
         DATAB     SEQ2.RET        CALL # = X'6E'
         DATAB     SEQ2.RET        CALL # = X'6F'
         DATAB     SEQ2.50         CALL # = X'70'
         DATAB     SEQ2.50         CALL # = X'71'
         DATAB     SEQ2.RET        CALL # = X'72'
         DATAB     SEQ2.RET        CALL # = X'73'
         DATAB     SEQ2.RET        CALL # = X'74'
         DATAB     SEQ2.RET        CALL # = X'75' M.RTRNOS      *232*
         DATAB     SEQ2.RET        CALL # = X'76'
         DATAB     SEQ2.RET        CALL # = X'77'
         DATAB     SEQ2.RET        CALL # = X'78'
         DATAB     SEQ2.RET        CALL # = X'79'
         DATAB     SEQ2.7A         CALL # = X'7A' M.GETDEF
         DATAB     SEQ2.RET        CALL # = X'7B' M.GADRL2
         DATAB     SEQ2.RET        CALL # = X'7C' M.GDD
         DATAB     SEQ2.RET        CALL # = X'7D' M.GTSAD       *232*
         DATAB     SEQ1.5C         CALL # = X'7E' M.OSREAD      *232*
         DATAB     SEQ2.RET        CALL # = X'7F'
         DATAB     SEQ2.RET        CALL # = X'80'               *226*
         DATAB     SEQ2.RET        CALL # = X'81'               *226*
         DATAB     SEQ2.RET        CALL # = X'82'               *226*
         DATAB     SEQ2.RET        CALL # = X'83'               *226*
         DATAB     SEQ2.RET        CALL # = X'84'               *226*
         DATAB     SEQ2.RET        CALL # = X'85'               *226*
         DATAB     SEQ2.RET        CALL # = X'86'               *226*
         DATAB     SEQ2.RET        CALL # = X'87'               *226*
         DATAB     SEQ2.RET        CALL # = X'88'               *226*
         DATAB     SEQ2.RET        CALL # = X'89'               *226*
         DATAB     SEQ2.RET        CALL # = X'8A'               *226*
         DATAB     SEQ2.RET        CALL # = X'8B'               *226*
         DATAB     SEQ2.RET        CALL # = X'8C'               *226*
         DATAB     SEQ2.RET        CALL # = X'8D'               *226*
         DATAB     SEQ2.RET        CALL # = X'8E'               *226*
         DATAB     SEQ2.RET        CALL # = X'8F'               *226*
         DATAB     SEQ2.RET        CALL # = X'90'               *226*
         DATAB     SEQ2.RET        CALL # = X'91'               *226*
         DATAB     SEQ2.RET        CALL # = X'92'               *226*
         DATAB     SEQ2.RET        CALL # = X'93'               *226*
         DATAB     SEQ2.RET        CALL # = X'94'               *226*
         DATAB     SEQ2.RET        CALL # = X'95'               *226*
         DATAB     SEQ2.RET        CALL # = X'96'               *226*
         DATAB     SEQ2.RET        CALL # = X'97'               *226*
         DATAB     SEQ2.RET        CALL # = X'98'               *226*
         DATAB     SEQ2.RET        CALL # = X'99'               *226*
         DATAB     SEQ2.RET        CALL # = X'9A'               *226*
         DATAB     SEQ2.RET        CALL # = X'9B'               *226*
         DATAB     SEQ2.RET        CALL # = X'9C'               *226*
         DATAB     SEQ2.RET        CALL # = X'9D'               *226*
         DATAB     SEQ2.RET        CALL # = X'9E'               *226*
         DATAB     SEQ2.RET        CALL # = X'9F'               *226*
         DATAB     SEQ2.RET        CALL # = X'A0'               *226*
         DATAB     SEQ2.RET        CALL # = X'A1'               *226*
         DATAB     SEQ2.RET        CALL # = X'A2'               *226*
         DATAB     SEQ2.RET        CALL # = X'A3'               *226*
         DATAB     SEQ2.RET        CALL # = X'A4'               *226*
         DATAB     SEQ2.RET        CALL # = X'A5'               *226*
         DATAB     SEQ2.RET        CALL # = X'A6'               *226*
         DATAB     SEQ2.RET        CALL # = X'A7'               *226*
         DATAB     SEQ2.RET        CALL # = X'A8'               *226*
         DATAB     SEQ2.RET        CALL # = X'A9'               *226*
         DATAB     SEQ2.RET        CALL # = X'AA'               *226*
         DATAB     SEQ2.RET        CALL # = X'AB'               *226*
         DATAB     SEQ2.RET        CALL # = X'AC'               *226*
         DATAB     SEQ2.RET        CALL # = X'AD'               *226*
         DATAB     SEQ2.AE         CALL # = X'AE'  M.TSMPC      *226*
         DATAB     SEQ2.50         CALL # = X'AF'  M.OSWRIT     *232*
         DATAB     SEQ2.RET        CALL # = X'B0'               *232*
         DATAB     SEQ2.RET        CALL # = X'B1'               *232*
         DATAB     SEQ2.RET        CALL # = X'B2'               *232*
         DATAB     SEQ2.RET        CALL # = X'B3'               *232*
         DATAB     SEQ2.RET        CALL # = X'B4'               *232*
         DATAB     SEQ2.RET        CALL # = X'B5'               *232*
         DATAB     SEQ2.RET        CALL # = X'B6'               *232*
         DATAB     SEQ2.RET        CALL # = X'B7'               *232*
         DATAB     SEQ2.RET        CALL # = X'B8'               *232*
         DATAB     SEQ2.RET        CALL # = X'B9'               *232*
         DATAB     SEQ2.RET        CALL # = X'BA'               *232*
         DATAB     SEQ2.RET        CALL # = X'BB'               *232*
         DATAB     SEQ2.RET        CALL # = X'BC'               *232*
         DATAB     SEQ2.RET        CALL # = X'BD'               *232*
         DATAB     SEQ2.RET        CALL # = X'BE'               *232*
         DATAB     SEQ2.RET        CALL # = X'BF'               *232*
         DATAB     SEQ2.RET        CALL # = X'C0' M.PGOD        *232*
         DATAB     SEQ2.RET        CALL # = X'C1'               *232*
         DATAB     SEQ2.RET        CALL # = X'C2'               *232*
         DATAB     SEQ2.RET        CALL # = X'C3'               *232*
         DATAB     SEQ2.RET        CALL # = X'C4'               *232*
         DATAB     SEQ2.RET        CALL # = X'C5'               *232*
         DATAB     SEQ2.RET        CALL # = X'C6'               *232*
         DATAB     SEQ2.RET        CALL # = X'C7'               *232*
         DATAB     SEQ2.RET        CALL # = X'C8'               *232*
         DATAB     SEQ2.RET        CALL # = X'C9'               *232*
         DATAB     SEQ2.RET        CALL # = X'CA'               *232*
         DATAB     SEQ2.RET        CALL # = X'CB'               *232*
         DATAB     SEQ2.RET        CALL # = X'CC'               *232*
         DATAB     SEQ2.RET        CALL # = X'CD'               *232*
         DATAB     SEQ2.RET        CALL # = X'CE'               *232*
         DATAB     SEQ2.RET        CALL # = X'CF'               *232*
         REZ       256B            ENOUGH FOR 256 MORE SVC'S
*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- UNBIAS TYPE 2 SVC'S
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- UNBIAS TYPE 2 SVC'S
TTL.TMPX ANOP                                                       !259
         BOUND     1W
SVC2UTBL DATAB     SEQ2.RET        CALL # = X'00'
         DATAB     SEQ2.RET        CALL # = X'01'
         DATAB     SEQ2.RET        CALL # = X'02'
         DATAB     SEQ2.RET        CALL # = X'03'
         DATAB     SEQ2.RET        CALL # = X'04'
         DATAB     SEQ2.RET        CALL # = X'05'
         DATAB     SEQ2.RET        CALL # = X'06'
         DATAB     SEQ2.RET        CALL # = X'07'
         DATAB     SEQ2.RET        CALL # = X'08'
         DATAB     SEQ2.RET        CALL # = X'09'
         DATAB     SEQ2.RET        CALL # = X'0A'
         DATAB     SEQ2.RET        CALL # = X'0B'
         DATAB     SEQ2.RET        CALL # = X'0C'
         DATAB     SEQ2.RET        CALL # = X'0D'
         DATAB     SEQ2.RET        CALL # = X'0E'
         DATAB     SEQ2.RET        CALL # = X'0F'
         DATAB     SEQ2.RET        CALL # = X'10'
         DATAB     SEQ2.RET        CALL # = X'11'
         DATAB     SEQ2.RET        CALL # = X'12'
         DATAB     SEQ2.RET        CALL # = X'13'
         DATAB     SEQ2.RET        CALL # = X'14'
         DATAB     SEQ2.RET        CALL # = X'15'
         DATAB     SEQ2.RET        CALL # = X'16'
         DATAB     SEQ2.RET        CALL # = X'17'
         DATAB     SEQ2.RET        CALL # = X'18'
         DATAB     SEQ2.RET        CALL # = X'19'
         DATAB     SEQ2.RET        CALL # = X'1A'
         DATAB     SEQ2.RET        CALL # = X'1B'
         DATAB     SEQ2.RET        CALL # = X'1C'
         DATAB     SEQ2.RET        CALL # = X'1D'
         DATAB     SEQ2.RET        CALL # = X'1E'
         DATAB     SEQ2.RET        CALL # = X'1F'
         DATAB     SEQ2.20         CALL # = X'20'
         DATAB     SEQ2.20         CALL # = X'21' (SAME AS '20')
         DATAB     SEQ2.20         CALL # = X'22' (SAME AS '20')
         DATAB     SEQ2.20         CALL # = X'23' (SAME AS '20')
         DATAB     SEQ2.24         CALL # = X'24'
         DATAB     SEQ2.24         CALL # = X'25'  (SAME AS '24')
         DATAB     SEQ2.24         CALL # = X'26'  (SAME AS '24')
         DATAB     SEQ2.27         CALL # = X'27'
         DATAB     SEQ2.28         CALL # = X'28'
         DATAB     SEQ2.29         CALL # = X'29'
         DATAB     SEQ2.2A         CALL # = X'2A'
         DATAB     SEQ2.2B         CALL # = X'2B'
         DATAB     SEQ2.2C         CALL # = X'2C'
         DATAB     SEQ2.2D         CALL # = X'2D'
         DATAB     SEQ2.2E         CALL # = X'2E'
         DATAB     SEQ2.2F         CALL # = X'2F'
         DATAB     SEQ2.30         CALL # = X'30'
         DATAB     SEQ2.31         CALL # = X'31'
         DATAB     SEQ2.32         CALL # = X'32'
         DATAB     SEQ2.RET        CALL # = X'33'
         DATAB     SEQ2.RET        CALL # = X'34'
         DATAB     SEQ2.RET        CALL # = X'35'
         DATAB     SEQ2.RET        CALL # = X'36'
         DATAB     SEQ2.RET        CALL # = X'37'
         DATAB     SEQ2.RET        CALL # = X'38'
         DATAB     SEQ2.RET        CALL # = X'39'
         DATAB     SEQ2.RET        CALL # = X'3A'
         DATAB     SEQ2.RET        CALL # = X'3B'
         DATAB     SEQ2.RET        CALL # = X'3C'
         DATAB     SEQ2.RET        CALL # = X'3D'
         DATAB     SEQ2.RET        CALL # = X'3E'
         DATAB     SEQ2.RET        CALL # = X'3F'
         DATAB     SEQ2.40R        CALL # = X'40'
         DATAB     SEQ2.41         CALL # = X'41'
         DATAB     SEQ2.42         CALL # = X'42'
         DATAB     SEQ2.43         CALL # = X'43'
         DATAB     SEQ2.44         CALL # = X'44'
         DATAB     SEQ2.44         CALL # = X'45' (SAME AS '44')
         DATAB     SEQ2.44         CALL # = X'46' (SAME AS '44')
         DATAB     SEQ2.44         CALL # = X'47' (SAME AS '44')
         DATAB     SEQ2.48         CALL # = X'48'
         DATAB     SEQ2.49         CALL # = X'49'
         DATAB     SEQ2.4A         CALL # = X'4A'
         DATAB     SEQ2.4BR        CALL # = X'4B'
         DATAB     SEQ2.4C         CALL # = X'4C'
*294          DATAB     SEQ2.RET        CALL # = X'4D'
         DATAB     SEQ2.4D         CALL # = X'4D'                   !294
         DATAB     SEQ2.RET        CALL # = X'4E'
         DATAB     SEQ2.RET        CALL # = X'4F'
         DATAB     SEQ2.50         CALL # = X'50'
         DATAB     SEQ2.51         CALL # = X'51'
         DATAB     SEQ2.52         CALL # = X'52'
         DATAB     SEQ2.53         CALL # = X'53'
         DATAB     SEQ2.54         CALL # = X'54'
         DATAB     SEQ2.55         CALL # = X'55'
         DATAB     SEQ2.RET        CALL # = X'56'
         DATAB     SEQ2.RET        CALL # = X'57'
         DATAB     SEQ2.RET        CALL # = X'58'
         DATAB     SEQ2.59R        CALL # = X'59'                   !283
         DATAB     SEQ2.RET        CALL # = X'5A'
         DATAB     SEQ2.RET        CALL # = X'5B'
         DATAB     SEQ2.RET        CALL # = X'5C'
         DATAB     SEQ2.RET        CALL # = X'5D'
         DATAB     SEQ2.RET        CALL # = X'5E'
         DATAB     SEQ2.RET        CALL # = X'5F'
         DATAB     SEQ2.RET        CALL # = X'60'
         DATAB     SEQ2.61R        CALL # = X'61'
         DATAB     SEQ2.62         CALL # = X'62'
         DATAB     SEQ2.RET        CALL # = X'63'
         DATAB     SEQ2.RET        CALL # = X'64'
         DATAB     SEQ2.RET        CALL # = X'65'
         DATAB     SEQ2.RET        CALL # = X'66'
         DATAB     SEQ2.RET        CALL # = X'67'
         DATAB     SEQ2.RET        CALL # = X'68'
         DATAB     SEQ2.RET        CALL # = X'69'
         DATAB     SEQ2.RET        CALL # = X'6A'
         DATAB     SEQ2.RET        CALL # = X'6B'
         DATAB     SEQ2.RET        CALL # = X'6C'
         DATAB     SEQ2.RET        CALL # = X'6D'
         DATAB     SEQ2.RET        CALL # = X'6E'
         DATAB     SEQ2.RET        CALL # = X'6F'
         DATAB     SEQ2.50         CALL # = X'70'
         DATAB     SEQ2.50         CALL # = X'71'
         DATAB     SEQ2.RET        CALL # = X'72'
         DATAB     SEQ2.RET        CALL # = X'73'
         DATAB     SEQ2.RET        CALL # = X'74'
         DATAB     SEQ2.RET        CALL # = X'75' M.RTRNOS      *232*
         DATAB     SEQ2.RET        CALL # = X'76'
         DATAB     SEQ2.RET        CALL # = X'77'
         DATAB     SEQ2.RET        CALL # = X'78'
         DATAB     SEQ2.RET        CALL # = X'79'
         DATAB     SEQ2.7A         CALL # = X'7A' M.GETDEF
         DATAB     SEQ2.7BR        CALL # = X'7B' M.GADRL2
         DATAB     SEQ1.67R        CALL # = X'7C' M.GDD         *227*
         DATAB     SEQ2.7DR        CALL # = X'7D' M.GTSAD       *233*
         DATAB     SEQ1.5C         CALL # = X'7E' M.OSREAD      *232*
         DATAB     SEQ2.RET        CALL # = X'7F'
         DATAB     SEQ2.RET        CALL # = X'80'               *226*
         DATAB     SEQ2.RET        CALL # = X'81'               *226*
         DATAB     SEQ2.RET        CALL # = X'82'               *226*
         DATAB     SEQ2.RET        CALL # = X'83'               *226*
         DATAB     SEQ2.RET        CALL # = X'84'               *226*
         DATAB     SEQ2.RET        CALL # = X'85'               *226*
         DATAB     SEQ2.RET        CALL # = X'86'               *226*
         DATAB     SEQ2.RET        CALL # = X'87'               *226*
         DATAB     SEQ2.RET        CALL # = X'88'               *226*
         DATAB     SEQ2.RET        CALL # = X'89'               *226*
         DATAB     SEQ2.RET        CALL # = X'8A'               *226*
         DATAB     SEQ2.RET        CALL # = X'8B'               *226*
         DATAB     SEQ2.RET        CALL # = X'8C'               *226*
         DATAB     SEQ2.RET        CALL # = X'8D'               *226*
         DATAB     SEQ2.RET        CALL # = X'8E'               *226*
         DATAB     SEQ2.RET        CALL # = X'8F'               *226*
         DATAB     SEQ2.RET        CALL # = X'90'               *226*
         DATAB     SEQ2.RET        CALL # = X'91'               *226*
         DATAB     SEQ2.RET        CALL # = X'92'               *226*
         DATAB     SEQ2.RET        CALL # = X'93'               *226*
         DATAB     SEQ2.RET        CALL # = X'94'               *226*
         DATAB     SEQ2.RET        CALL # = X'95'               *226*
         DATAB     SEQ2.RET        CALL # = X'96'               *226*
         DATAB     SEQ2.RET        CALL # = X'97'               *226*
         DATAB     SEQ2.RET        CALL # = X'98'               *226*
         DATAB     SEQ2.RET        CALL # = X'99'               *226*
         DATAB     SEQ2.RET        CALL # = X'9A'               *226*
         DATAB     SEQ2.RET        CALL # = X'9B'               *226*
         DATAB     SEQ2.RET        CALL # = X'9C'               *226*
         DATAB     SEQ2.RET        CALL # = X'9D'               *226*
         DATAB     SEQ2.RET        CALL # = X'9E'               *226*
         DATAB     SEQ2.RET        CALL # = X'9F'               *226*
         DATAB     SEQ2.RET        CALL # = X'A0'               *226*
         DATAB     SEQ2.RET        CALL # = X'A1'               *226*
         DATAB     SEQ2.RET        CALL # = X'A2'               *226*
         DATAB     SEQ2.RET        CALL # = X'A3'               *226*
         DATAB     SEQ2.RET        CALL # = X'A4'               *226*
         DATAB     SEQ2.RET        CALL # = X'A5'               *226*
         DATAB     SEQ2.RET        CALL # = X'A6'               *226*
         DATAB     SEQ2.RET        CALL # = X'A7'               *226*
         DATAB     SEQ2.RET        CALL # = X'A8'               *226*
         DATAB     SEQ2.RET        CALL # = X'A9'               *226*
         DATAB     SEQ2.RET        CALL # = X'AA'               *226*
         DATAB     SEQ2.RET        CALL # = X'AB'               *226*
         DATAB     SEQ2.RET        CALL # = X'AC'               *226*
         DATAB     SEQ2.RET        CALL # = X'AD'               *226*
         DATAB     SEQ2.AE         CALL # = X'AE'  M.TSMPC      *226*
         DATAB     SEQ2.50         CALL # = X'AF'  M.OSWRIT     *232*
         DATAB     SEQ2.RET        CALL # = X'B0'               *232*
         DATAB     SEQ2.RET        CALL # = X'B1'               *232*
         DATAB     SEQ2.RET        CALL # = X'B2'               *232*
         DATAB     SEQ2.RET        CALL # = X'B3'               *232*
         DATAB     SEQ2.RET        CALL # = X'B4'               *232*
         DATAB     SEQ2.RET        CALL # = X'B5'               *232*
         DATAB     SEQ2.RET        CALL # = X'B6'               *232*
         DATAB     SEQ2.RET        CALL # = X'B7'               *232*
         DATAB     SEQ2.RET        CALL # = X'B8'               *232*
         DATAB     SEQ2.RET        CALL # = X'B9'               *232*
         DATAB     SEQ2.RET        CALL # = X'BA'               *232*
         DATAB     SEQ2.RET        CALL # = X'BB'               *232*
         DATAB     SEQ2.RET        CALL # = X'BC'               *232*
         DATAB     SEQ2.RET        CALL # = X'BD'               *232*
         DATAB     SEQ2.RET        CALL # = X'BE'               *232*
         DATAB     SEQ2.RET        CALL # = X'BF'               *232*
         DATAB     SEQ2.RET        CALL # = X'C0' M.PGOD        *232*
         DATAB     SEQ2.RET        CALL # = X'C1'               *232*
         DATAB     SEQ2.RET        CALL # = X'C2'               *232*
         DATAB     SEQ2.RET        CALL # = X'C3'               *232*
         DATAB     SEQ2.RET        CALL # = X'C4'               *232*
         DATAB     SEQ2.RET        CALL # = X'C5'               *232*
         DATAB     SEQ2.RET        CALL # = X'C6'               *232*
         DATAB     SEQ2.RET        CALL # = X'C7'               *232*
         DATAB     SEQ2.RET        CALL # = X'C8'               *232*
         DATAB     SEQ2.RET        CALL # = X'C9'               *232*
         DATAB     SEQ2.RET        CALL # = X'CA'               *232*
         DATAB     SEQ2.RET        CALL # = X'CB'               *232*
         DATAB     SEQ2.RET        CALL # = X'CC'               *232*
         DATAB     SEQ2.RET        CALL # = X'CD'               *232*
         DATAB     SEQ2.RET        CALL # = X'CE'               *232*
         DATAB     SEQ2.RET        CALL # = X'CF'               *232*
         REZ       256B            ENOUGH FOR 256 MORE SVC'S
*
         BOUND     1W
*              SVC BIAS ROUTINES VECTOR TABLE
VCT.TBLE ACW       SVC1.RET        0
         ACW       SVC1.30         1
         ACW       SVC2.50         2
         ACW       SVC1.IO         3
         ACW       SVC1.25         4
*277          ACW       SVC1.3D         5
         ACW       SVC1.3F         5                                !277
         ACW       SVC1.40         6
         ACW       SVC1.44R        7
         ACW       SVC1.15         8
         ACW       SVC1.45         9
         ACW       SVC1.4F         10
         ACW       SVC1.50         11
         ACW       SVC1.5E         12
         ACW       SVC1.5F         13
         IFF       OS.15E,OS15E                                 *238*
         ACW       SVC2.51         14
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         ACW       SVC2.RET        14                           *238*
OS15E    ANOP                                                   *238*
         ACW       SVC1.5C         15
         ACW       SVC1.65R        16
         ACW       SVC1.67R        17
         ACW       SVC1.68R        18
         ACW       SVC1.6C         19
         ACW       SVC1.72         20
         ACW       SVC1.7A         21
         IFF       OS.15E,OS15E                                 *238*
         ACW       SVC2.20         22
         ACW       SVC2.2D         23                               !279
         ACW       SVC2.40         24
         ACW       SVC2.24         25
         ACW       SVC2.27         26
         ACW       SVC2.54         27
         ACW       SVC2.29         28
         ACW       SVC2.2A         29
         ACW       SVC2.2C         30
         ACW       SVC2.2B         31
         ACW       SVC2.59         32
         ACW       SVC2.2E         33
         ACW       SVC2.2F         34
         ACW       SVC2.41         35
         ACW       SVC2.44         36
         ACW       SVC1.73         37
         ACW       SVC2.48         38
         ACW       SVC1.60         39
         ACW       SVC2.52         40
         ACW       SVC2.53         41
         ACW       SVC2.42         42
         ACW       SVC2.61R        43
         ACW       SVC1.17         44
         ACW       SVC2.62         45
         ACW       SVC2.28         46
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         ACW       SVC2.RET        22                           *238*
         ACW       SVC2.RET        23                           *238*
         ACW       SVC2.RET        24                           *238*
         ACW       SVC2.RET        25                           *238*
         ACW       SVC2.RET        26                           *238*
         ACW       SVC2.RET        27                           *238*
         ACW       SVC2.RET        28                           *238*
         ACW       SVC2.RET        29                           *238*
         ACW       SVC2.RET        30                           *238*
         ACW       SVC2.RET        31                           *238*
         ACW       SVC2.RET        32                           *238*
         ACW       SVC2.RET        33                           *238*
         ACW       SVC2.RET        34                           *238*
         ACW       SVC2.RET        35                           *238*
         ACW       SVC2.RET        36                           *238*
         ACW       SVC1.73         37                           *238*
         ACW       SVC2.RET        38                           *238*
         ACW       SVC1.60         39                           *238*
         ACW       SVC2.RET        40                           *238*
         ACW       SVC2.RET        41                           *238*
         ACW       SVC2.RET        42                           *238*
         ACW       SVC2.RET        43                           *238*
         ACW       SVC1.17         44                           *238*
         ACW       SVC2.RET        45                           *238*
         ACW       SVC2.RET        46                           *238*
OS15E    ANOP                                                   *238*
         ACW       SVC1.52         47
         ACW       SVC1.1E         48
         ACW       SVC1.18         49
         ACW       SVC1.40R        50
         ACW       SVC1.4FR        51
         IFF       OS.15E,OS15E                                 *238*
         ACW       SVC2.7A         52
         ACW       SVC2.7BR        53
         ACW       SVC2.AE         54   M.TSMPC                 *226*
         ACW       SVC2.7DR        55   M.GTSAD                 *233*
         ACW       SVC2.59R        56   M.VADDR                     !283
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
         ACW       SVC2.RET        52                           *238*
         ACW       SVC2.RET        53                           *238*
         ACW       SVC2.RET        54   M.TSMPC                 *238*
         ACW       SVC2.RET        55   M.GTSAD                 *238*
         ACW       SVC2.RET        56   M.VADDR                     !283
OS15E    ANOP                                                   *238*
NUM.VECT EQU       $-VCT.TBLE/4-1  HIGHEST SEQUENCE NUMBER
         REZ       20W             20 DUMMY ONES
MO       ANOP                                                   *237*
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- SYSGEN INIT (TRAPS)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- SYSGEN INIT (TRAPS)
TTL.TMPX ANOP                                                       !259
*
*  SET UP ALL TRAP CONTEXT BLOCKS (BASED UPON VECTORS IN SCRATCHPAD)
*
T.INIT   EQU       $               INITIALIZATION ENTRY POINT
         M.EIR
*280          IFF       OS.15E,OS15E                                 *238*
*280 OS15E    ANOP                                                   *238*
*
*  MAKE SURE USER SPECIFIED DIRSVC=DIABLE IN SYSGEN
*
         IFF       MPX.EVNT,DSVCEV  DON'T DO CHECK FOR MPX EVENT    !280
         IFT       OS.35,DSVC35     ONLY DO CHECK FOR MPX 3.5       !280
         LB        R7,C.MACH        GET MACHINE TYPE                !280
         BNZ       DSVC.OK          SKIP CHECK IF NOT SEAHAWK       !280
         LI        R3,X'5A'         GET M.TURBO SVC NUMBER          !280
         SLL       R3,2             CONVERT TO WORD INDEX           !280
         ADMW      R3,C.SVTA2       ADD SVC 2 TABLE ADDRESS         !280
         LW        R7,0,X3          GET M.TURBO VECTOR              !280
         BZ        DSVC.OK          NOT DEFINED DON'T CHECK FURTHER !280
         TBM       C.DVSVCR,C.DIRSVC         DIRSVC SPECIFIED?      !280
         BNS       DSVC.NO          NO, GO ABORT SYSGEN             !280
         TBM       C.DVSVCD,C.DIRSVC         DIRSVC=DISABLE?        !280
         BS        DSVC.OK          YES, GO ON TO NEXT THING        !280
DSVC.NO  EQU       $                COME HERE IF DIRSVC=ENABLE      !280
         LW        R7,=C'TG85'                                      !280
         LW        R3,=X'6A000'                                     !280
         LW        R5,=C'SG26'                                      !280
NFND.1   EQU       $                                                !280
         CAMW      R3,=X'76000'                                     !280
         BGE       NFND.15          Couldn't find it, abort anyway  !280
         CAMW      R5,0,X3          sg26?                           !280
         BEQ       NFND.2                                           !280
         BIW       R3,NFND.1                                        !280
         BU        NFND.3          Abort if we drop out             !280
* ----------------------------------------------------------------- !280
NFND.15  SBM       LW.SG26,LSWITCH Have we been this way before?    !280
         BS        NFND.3          Go if so and abort               !280
         LW        R3,=X'60000'    Start our search lower.  We      !280
*        don't start with this low a search, since SYSGEN for       !280
*        3.5U01 BL6 (?) and later don't have memory at 60000,       !280
*        while previous versions do.                                !280
         BU        NFND.1                                           !280
* ----------------------------------------------------------------- !280
NFND.2   EQU       $                                                !280
         STW       R7,0,X3         Change SG26 to my abort code     !280
NFND.3   SBM       C.NOLOAD,C.BIT  Can't continue                   !280
         BL        ABRT.XT         No return                        !280
DSVC.OK  EQU       $                                                !280
DSVC35   ANOP                                                       !280
DSVCEV   ANOP                                                       !280
         IFT       OS.15E,OS15E                                 *238*
         M.SVCT    SVCTAB,SVC.END  TELL MPX ABOUT SVC 1,3       *238*
OS15E    ANOP                                                   *238*
*
*  SET UP EVENT POINTER
*
         LA        R4,EVNT.PTR
         STW       R4,C.EVNT       STUFF IN LOW MEMORY
         LA        R4,TXPMREGS     CPU REG SAVE LOCATION
         STW       R4,C.TASKR      REG ADDR FOR TXPM.LVP
         LA        R4,TXPM.RET     ADDR OF RETURN ROUTINE
         STW       R4,C.RETURN     SAVE IN LOW MEMORY
         LA        R4,S.TXPM.0     ADDR OF RETURN ROUTINE
         STW       R4,C.XPMRET     SAVE IN LOW MEMORY
         IFF       C.MPXOUT,MO                                  *237*
*
*  SET UP PATCH AREA IF IPU IS PRESENT. MOVE CODE.DSP TO CODE.END
*  TO PATCH AREA.  WHEN EXECUTED IN THE PATCH AREA, THE CODE WILL
*  RESTORE THE MPX # OF MAPS IN THE OS MPL ENTRY 0.  THIS WILL
*  INSURE THAT T-XPM DISPATCHES HAVE NO NEGATIVE EFFECT ON THE
*  IPU WHEN THE IPU EXECUTES A LPSDCM INSTRUCTION.
*
*  ADJUST DESTINATION NEW PSD FOR DISPATCH TO PATCH AREA
*
*  NOW MOVE CODE TO PATCH AREA
*
         LW        R2,C.MPAA       GET LOW PATCH ADDR
         CAMW      R2,C.MPAC       SEE IF SAME AS CURRENT
         BNE       ABT.TXPM        ABORT IF NOT
         ADI       R2,CODE.SIZ     ADD IN AMOUNT TO USE
         CAMW      R2,C.MPAH       COMPARE TO HIGH ADDR
         BGT       ABT.TXPM        ABORT IF NOT ENOUGH
         LW        R2,C.MPAA       GET PATCH ADDRESS AGAIN
         ADI       R2,7B           ADD IN 1DW-1B
         ANMW      R2,=X'FFFFFFF8' INSURE DW BOUNDING
         STH       R2,PTCH.530+1H  PUT IN MAP.TXPM ROUTINE
         LA        R1,CODE.DSP     ORIGIN OF MOVE (used by 7x)
         LD        R6,CODE.DSP     GET 1ST 2 INSTRUCTIONS
         ADR       R2,R6           RELOCATE LPSDCM INSTRUCTION
         STD       R6,0W,X2        PUT IN PATCH AREA
         LD        R6,CODE.DSP+2W  GET 2ND 2 INSTRUCTIONS
         ADR       R2,R6           RELOCATE LD INSTRUCTION
         ADR       R2,R7           RELOCATE LD INSTRUCTION
         STD       R6,2W,X2        PUT IN CPU PATCH AREA
         LD        R6,CODE.DSP+4W
         LW        R6,=X'20002'    GET TWO NOPS FOR CPU
         ADR       R2,R7           RELOCATE LPSD INSTRUCTION
         STD       R6,DSP.ZBM-CODE.DSP,X2                           !252
         ZBM       LW.C2000,LSWITCH Not a Seahawk yet               !252
*264          LB        R4,C.MACH                                        !252
*264          BNZ       IN.1            Go if not                        !252
*264          STW       R6,DSP.C-CODE.DSP,X2 Else NOP out scratchpad     !252
*264 *                                  manipulation                     !252
*264          STW       R6,,X2          Also NOP out LPSDCM              !260
*264          SBM       LW.C2000,LSWITCH And tell everyone we're a       !252
*264 *                                  Seahawk                          !252
IN.1     LW        R4,C.MIDL       GET ADDRESS OF O/S MAPS          !252
         IFT       C.3227,XXJ.1
         STW       R4,TX.MPL+1W-CODE.DSP,X2 STUFF IN PATCH AREA     !252
XXJ.1    ANOP
         IFF       C.3227,XXJ.2
         STW       R4,16W,X2       STUFF IN PATCH AREA
         LD        R6,14W,X1       GET 7X MSD'S
         ADR       R2,R6           RELOCATE MPL ENTRY 1
         ADR       R2,R7           RELOCATE MPL ENTRY 2
         STD       R6,14W,X2       STUFF IN PATCH AREA
XXJ.2    ANOP
         IFT       DO.BUI,BUI.DO                                    !255
         LA        R3,DSP.R01                                       !255
         TRR       R2,R7           Save this for now                !255
         ADI       R2,DSP.R01-CODE.DSP                              !255
         LI        R5,-7           Nr of words to move              !255
IN.L1    LW        R6,,X3          Get a word                       !255
         STW       R6,,X2           and store it                    !255
         ABR       R3,29           Next word                        !255
         ABR       R2,29           Next word                        !255
         BIB       R5,IN.L1                                         !255
         TRR       R7,R2           Restore R2 for a second          !255
         LI        R5,-14          Now relocate BUI stuff           !255
         LA        R3,DSP.BUI      Start of relocated code          !255
         ADI       R2,DSP.BUI-CODE.DSP                              !255
IN.L2    LW        R6,,X3          Get a word                       !255
         CI        R5,-9           The only one we don't relocate   !255
         BEQ       IN.L2E                                           !255
         ADR       R7,R6           Relocate                         !255
IN.L2E   STW       R6,,X2          Store in patch area              !255
         ADI       R3,1W           Next instruction                 !255
         ADI       R2,1W                                            !255
         BIB       R5,IN.L2        Go loop                          !255
         TRR       R7,R2           Restore R2                       !255
BUI.DO   ANOP                                                       !255
         ADI       R2,CODE.SIZ     SIZE OF PATCH AREA USED
         STW       R2,C.MPAA       SET AS LOW ADDRESS
         STW       R2,C.MPAC       SET AS CURRENT ADDR
*        SET IPU DISPATCH AREA IF PRESENT
         TBM       2,C.CONF        IS AN IPU PRESENT
         BNS       CPU.SYS         BR IF ONE NOT CONFIGURED
         ADI       R2,CODE.SIZ     ADD IN AMOUNT TO USE
         CAMW      R2,C.MPAH       COMPARE TO HIGH ADDR
         BGT       ABT.TXPM        ABORT IF NOT ENOUGH
         LW        R2,C.MPAA       GET PATCH ADDRESS AGAIN
         LD        R6,CODE.DSP     GET 1ST 2 INSTRUCTIONS
         ADR       R2,R6           RELOCATE LPSDCM INSTRUCTION
         STD       R6,0W,X2        PUT IN PATCH AREA
         LD        R6,CODE.DSP+2W  GET 2ND 2 INSTRUCTIONS
         ADR       R2,R6           RELOCATE LD INSTRUCTION
         ADR       R2,R7           RELOCATE LD INSTRUCTION
         STD       R6,2W,X2        PUT IN IPU PATCH AREA
         LD        R6,CODE.DSP+4W  GET 3RD 2 INSTRUCTIONS
         ADR       R2,R7           RELOCATE LPSD INSTR
         STD       R6,4W,X2        PUT IN IPU PATCH AREA
         LW        R4,C.MIDL       GET ADDRESS OF O/S MAPS
         IFT       C.3227,XXK.1
         STW       R4,15W,X2       STUFF IN PATCH AREA
XXK.1    ANOP
         IFF       C.3227,XXK.2
         STW       R4,16W,X2       STUFF IN PATCH AREA
         LD        R6,14W,X1       GET 7X MSD'S
         ADR       R2,R6           RELOCATE MPL ENTRY 1
         ADR       R2,R7           RELOCATE MPL ENTRY 2
         STD       R6,14W,X2       STUFF IN PATCH AREA
XXK.2    ANOP
         IFT       DO.BUI,BUI.DO                                    !255
         LA        R3,DSP.R01                                       !255
         TRR       R2,R7           Save this for now                !255
         ADI       R2,DSP.R01-CODE.DSP                              !255
         LI        R5,-7           Nr of words to move              !255
IN.L3    LW        R6,,X3          Get a word                       !255
         STW       R6,,X2           and store it                    !255
         ABR       R3,29           Next word                        !255
         ABR       R2,29           Next word                        !255
         BIB       R5,IN.L3                                         !255
         TRR       R7,R2           Restore R2 for a second          !255
         LI        R5,-14          Now relocate BUI stuff           !255
         LA        R3,DSP.BUI      Start of relocated code          !255
         ADI       R2,DSP.BUI-CODE.DSP                              !255
IN.L4    LW        R6,,X3          Get a word                       !255
         CI        R5,-9           The only one we don't relocate   !255
         BEQ       IN.L4E                                           !255
         ADR       R7,R6           Relocate                         !255
IN.L4E   STW       R6,,X2          Store in patch area              !255
         ADI       R3,1W           Next instruction                 !255
         ADI       R2,1W                                            !255
         BIB       R5,IN.L4        Go loop                          !255
         TRR       R7,R2           Restore R2                       !255
BUI.DO   ANOP                                                       !255
         ADI       R2,CODE.SIZ     SIZE OF PATCH AREA USED
         STW       R2,C.MPAA       SET AS LOW ADDRESS
         STW       R2,C.MPAC       SET AS CURRENT ADDR
         IFT       C.3227,TRI.A
IPU.SYS  LI        R2,X'20'        FETCH TRAP TABLE BASE ADDRESS
         IFF       MPX.EVNT,EVNT
         LA        R1,TRPI.VCT     TRAP VECTOR TABLE FOR IPU
         STW       R1,VCT.BASA     SAVE FOR UPDATING WITH TCB ADDRESS
EVNT     ANOP
TRI.A    ANOP
         IFF       C.3227,TRI.B
IPU.SYS  LA        R2,TTBL.7I      IPU TRAP DEFINITIONS
TRI.B    ANOP
         STW       R2,TRI.BASA     SAVE  TRAP TABLE BASE ADDRESS
         STW       R2,MPX.TRPI      ...DITTO
*
         ZR        R2
         LA        R1,TRPIS        ORIGIN OF H.TXPM TRAP ENTRY POINTS
*
         LI        R4,-32          CONCEPTS HAVE 32 TRAPS
TRI.LOOP LW        R3,TRI.BASA     TRAP BASE ADDRESS
         ADR       R2,R3           ADD TRAP # * 4
         LW        R5,VCT.BASA     TXPM VECTOR BASE ADDRESS
         ADR       R2,R5           ADD TRAP # * 4
         CI        R2,X'1C'        SVC 1? (PROCESSING SVC'S)
         BLT       TRI.2           NOT YET
         CI        R2,X'58'        MACHINE CHECK
         BLT       TRI.1           NOT YET
         BGT       TRI.0
         LW        R3,TRI.SAVE     DONE WITH SVC'S, SO RETORE TRAP BASE
         STW       R3,TRI.BASA
         ADR       R2,R3
         LW        R5,VCT.SAVE     DONE WITH SVC'S, SO RETORE TRAP BASE
         STW       R5,VCT.BASA
         ADR       R2,R5
TRI.0    SUI       R3,X'3C'        BIAS BY 16 SVC'S
         SUI       R5,X'3C'        "
         BU        TRI.2
TRI.1    SUI       R3,X'18'        BASE IS 2ND SVC TBL -- BIAS BY 6 TRPS
         SUI       R5,X'18'        "
         IFF       C.3227,TRI.C0
         BU        TRI.C1
TRI.C0   ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         BU        TRI.C1
EVNT     ANOP
         IFF       C.3227,EVNT
TRI.2    LW        R3,,X3          FETCH TRAP VECTOR
         BZ        TRI.END1        SKIP IF VACANT
EVNT     ANOP
         IFT       C.3227,TRI.C
         IFF       MPX.EVNT,EVNT
TRI.2    LW        R3,,X3          FETCH TRAP VECTOR
         BZ        TRI.END1        SKIP IF VACANT
EVNT     ANOP
TRI.C    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
TRI.2    EQU       $
EVNT     ANOP
         IFF       C.3227,TRI.D
TRI.C1   LW        R7,,X3          FETCH TRAP VECTOR
         BZ        TRI.END1        SKIP IF VACANT
         ZBR       R7,31           CLEAR ANY C BIT
         CI        R2,X'18'        SVC TYPE 0?
         BEQ       TRI.D0          BRANCH IF YES
         TRR       R7,R3           TRAP VECTOR TO R3
TRI.D    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
TRI.C1   LW        R7,,X3          FETCH TRAP VECTOR
         BZ        TRI.END1        SKIP IF VACANT
         ZBR       R7,31           CLEAR ANY C BIT
         CI        R2,X'18'        SVC TYPE 0?
         BEQ       TRI.D0          BRANCH IF YES
         TRR       R7,R3           TRAP VECTOR TO R3
EVNT     ANOP
         CI        R2,X'18'        SVC TYPE 0?
         BNE       TRI.3           BRANCH IF NOT SVC
TRI.D0   LW        R6,TRI.BASA
         STW       R6,TRI.SAVE     SAVE TRAP BASE
         LW        R6,VCT.BASA
         STW       R6,VCT.SAVE     SAVE TRAP BASE
         IFT       C.3227,TRI.E
         IFF       MPX.EVNT,EVNT
         XCR       R5,R3           GET VECTOR IN XR
         LW        R3,0W,X3        GET SVC VECTOR ADDR
         XCR       R5,R3           BACK AGAIN
         STW       R3,TRI.BASA     SECONDARY SVC TABLE BASE
         STW       R5,VCT.BASA     SECONDARY SVC TABLE BASE
         LW        R3,,X3          FETCH SVC TYPE 0 VECTOR
EVNT     ANOP
TRI.E    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         ZBR       R7,31           CLEAR ANY C BIT
         TRR       R7,R3
         STW       R7,TRI.BASA     SECONDARY SVC TABLE BASE
         LW        R5,,X3          FETCH SVC TYPE 0 VECTOR
         TRR       R5,R3           VECTOR TO R3
         ZBR       R3,31           CLEAR ANY C BIT
EVNT     ANOP
         IFF       C.3227,TRI.F
         ZBR       R7,31           CLEAR ANY C BIT
         TRR       R7,R3
         STW       R7,TRI.BASA     SECONDARY SVC TABLE BASE
         LW        R5,,X3          FETCH SVC TYPE 0 VECTOR
         TRR       R5,R3           VECTOR TO R3
         ZBR       R3,31           CLEAR ANY C BIT
TRI.F    ANOP
TRI.3    STW       R5,VCT.CURR     CURR VECTOR ADDRESS
         IFF       C.3227,TRI.4
         TBM       2,2W,X3         HAVE WE ALREADY SEEN THIS MPX TCB?
         BNS       TRI.41          BRANCH IF WE HAVEN'T
         TRR       R1,R6           SAVE T-XPM TCB ADDRESS
         LW        R1,2W,X3        FETCH NEW PSW POINTING TO T-XPM
         ZBR       R1,31           WORD ADDRESS
         ADI       R1,4W           FETCH TRAP CONTEXT ADDRESS
         LW        R5,PSD.WRD2,X1  FETCH ORIGINAL PSD WORD 2
         STW       R5,3W,X3        PUT BACK SO WE CAN REPLACE AGAIN!
         LW        R5,PSD.RET1,X1  FETCH 'ORIGINAL' PSW
         STW       R5,2W,X3        PUT BACK SO WE CAN REPLACE AGAIN!
         TRR       R6,R1           RESTORE CURRENT T-XPM TCB
TRI.4    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         TBM       2,2W,X3         HAVE WE ALREADY SEEN THIS MPX TC
         BNS       TRI.41          BRANCH IF WE HAVEN'T
         TRR       R1,R6           SAVE T-XPM TCB ADDRESS
         LW        R1,2W,X3        FETCH NEW PSW POINTING TO T-XPM
         ZBR       R1,31           WORD ADDRESS
         ADI       R1,4W           FETCH TRAP CONTEXT ADDRESS
         LW        R5,PSD.WRD2,X1  FETCH ORIGINAL PSD WORD 2
         STW       R5,3W,X3        PUT BACK SO WE CAN REPLACE AGAIN
         LW        R5,PSD.RET1,X1  FETCH 'ORIGINAL' PSW
         STW       R5,2W,X3        PUT BACK SO WE CAN REPLACE AGAIN
         TRR       R6,R1           RESTORE CURRENT T-XPM TCB
EVNT     ANOP
TRI.41   LW        R5,*2W,X3       FETCH REPLACED INSTRUCTION
TRI.5    TRR       R1,R7           TRAP CONTEXT ADDRESS TO R7
         ADI       R7,ITC.LEN      POINT TO CONTEXT AREA
         XCR       R2,R7           EXCHANGE TO USE AS INDEX
         STW       R5,RPL.INST,X2  SAVE REPLACED INSTRUCTION
         CI        R7,X'68'        IS THIS START IPU
         BNE       S.7H            SKIP IF NOT
         STW       R5,8W,X1        STUFF 1ST INSTR IN ICB+8
         LW        R5,CXT.BASE     GET CURR ICB ADDR
         STW       R5,DSP.BSY      SAVE FOR SIPU CODE
         BU        S.7K            SKIP OTHER STORE
S.7H     CI        R7,X'70'        CONSOLE ATTENTION
         BEQ       S.7K            LEAVE LPSD FOR DIRECT RETURN
         LW        R5,2W,X3        FETCH NEW PSW
         BU        S.7L            RETURN AT 1ST INSTR
         IFT       OS.32X,IF.01
         IFT       OS.36,O36                                    !295
S.7KK    SBM       C.IPUCSI,C.IPUFLG TELL CPU TO HOLD OFF       !295
O36      ANOP                                                   !295
         IFF       OS.36,O36                                    !295
S.7KK    SBM       C.ICSIPU,C.BIT  TELL CPU TO HOLD OFF
O36      ANOP                                                   !295
IF.01    ANOP
         IFF       OS.32X,IF.02
S.7KK    SBM       IPU.GATE,EXEC.FLG  TELL CPU TO HOLD OFF
IF.02    ANOP
S.7K     LW        R5,2W,X3        FETCH NEW PSW
         ADI       R5,1W           RETURN ADDRESS IS NEXT WORD
S.7L     STW       R5,PSD.RET1,X2  SAVE RETURN ADDRESS
         LW        R5,3W,X3        FETCH NEW PSD WORD 2
         SBR       R5,15           INSURE RETAIN BIT SET
         STW       R5,PSD.WRD2,X2  SAVE NEW PSD WORD 2
         IFF       C.3227,TRI.55
         LW        R5,=X'18000'    UNMAPPED/RETAIN BLOCK STATE
         STW       R5,3W,X3        STUFF AS NEW PSD2 FOR MPX
TRI.55   ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         LW        R5,=X'18000'    UNMAPPED/RETAIN BLOCK STATE
         STW       R5,3W,X3        STUFF AS NEW PSD2 FOR MPX
EVNT     ANOP
         STW       R3,PSD.OMPX,X2  SAVE OLD MPX   PSD ADDRESS
         LW        R6,CXT.BASE     CURRENT CONTEXT ADDRESS
         STW       R6,PSD.OTMP,X2  SAVE OLD T-XPM PSD ADDRESS
         IFF       C.3227,TRI.6
         LW        R6,2W,X1        FETCH T-XPM NEW PSW
         SBR       R6,2            INDICATE WE'VE SEEN THIS MPX TCB
         ADMW      R6,CXT.BASE     BIAS NEW PSD ADDRESS
         STW       R6,2W,X3        STUFF AS NEW PSW FOR MPX
TRI.6    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         LW        R6,2W,X1        FETCH T-XPM NEW PSW
         SBR       R6,2            INDICATE WE'VE SEEN THIS MPX TCB
         ADMW      R6,CXT.BASE     BIAS NEW PSD ADDRESS
         STW       R6,2W,X3        STUFF AS NEW PSW FOR MPX
EVNT     ANOP
         XCR       R7,R2
         LI        R0,-TOT.LEN     NUMBER OF WORD TO MOVE
         LW        R3,CXT.BASE     CURRENT PLACE TO PUT TCB
         TRR       R3,R5           SAVE FOR VECTOR UPDATE
         TRR       R3,R7           CALC NEW CONTEXT ADDRESS
         ADI       R7,ITC.LEN      POINT TO CONTEXT AREA
         ARMW      R3,2W,X1        BIAS NEW PSD
         LW        R6,0W,X1        GET A WORD
         STW       R6,0W,X3        PUT IN TCB AREA
         ADI       R3,1W           NEXT WORD
         ADI       R1,1W           NEXT WORD
         BIW       R0,$-4W         LOOP FOR ALL OF TCB
         STW       R3,CXT.BASE     NEXT TCB LOC
         SUI       R1,TOT.LEN      BACK US UP
         IFT       C.3227,TRI.7
         IFF       MPX.EVNT,EVNT
         LW        R3,VCT.CURR     CURRENT TXPM VECTOR
         STW       R5,0W,R3        UPDATE TXPM VECTOR
EVNT     ANOP
TRI.7    ANOP
TRI.END1 ADI       R2,1W           POINT TO NEXT TRAP VECTOR
         ADI       R1,TOT.LEN      POINT TO NEXT TRAP ENTRY POINT
         BIB       R4,TRI.LOOP     GO PROCESS NEXT TRAP
         BU        IPU.MRGI        MERGE CODE
MO       ANOP                                                   *237*
*        AN IPU IS NOT PRESENT SO SET TRAP AND INTERRUPT ADDRESSES
*        THE ADDRESSES ARE ALREADY SET IF IPU IS CONFIGURED
*
CPU.SYS  LA        R1,IPU.CODE     ADDRESS OF IPU CODE AREA THAT
*                                  IS TO BE OVERLAID
         STW       R1,CXT.BASE     SET TRAP CONTEXT AREA ADDRESS
IPU.MRGI EQU       $               MERGE POINT
         IFT       C.3227,TRP.A
         LW        R1,C.SPAD       FETCH SCRATCHPAD ADDRESS
         LW        R2,TRP.TTBA,X1  FETCH TRAP TABLE BASE ADDRESS
         STW       R2,TRP.BASA     SAVE  TRAP TABLE BASE ADDRESS
         STW       R2,MPX.TRP      ...DITTO
         LW        R1,CXT.BASE     GET TRAP BASE ADDRESS
         STW       R1,C.TRPCA      SAVE IN LOW MEMORY
         IFF       MPX.EVNT,EVNT
         LA        R1,TRP.VCT      TRAP VECTOR TABLE FOR CPU
         STW       R1,VCT.BASA     SAVE FOR UPDATING WITH TCB ADDRESS
EVNT     ANOP
TRP.A    ANOP
         ZMB       TXPMFLGS        MAKE BYTE ZERO OF C.UBIAS ZERO *242*
         SBM       TXPMOS,TXPMFLGS BIT 0 SHOW'S TXPM ON SYSTEM    *242*
*
         IFF       C.3227,TRP.B
         LA        R2,TTBL.7X
         STW       R2,TRP.BASA     TRAP TABLE BASE ADDRESS FOR 32/7X
         STW       R2,MPX.TRP
TRP.B    ANOP
*
         ZR        R2
         LA        R1,TRAPS        ORIGIN OF H.TXPM TRAP ENTRY POINTS
*
         LI        R4,-32          CONCEPTS HAVE 32 TRAPS
TRP.LOOP LW        R3,TRP.BASA     TRAP BASE ADDRESS
         ADR       R2,R3           ADD TRAP # * 4
         LW        R5,VCT.BASA     TXPM VECTOR BASE ADDRESS
         ADR       R2,R5           ADD TRAP # * 4
         CI        R2,X'1C'        SVC 1? (PROCESSING SVC'S)
         BLT       TRP.2           NOT YET
         CI        R2,X'58'        MACHINE CHECK
         BLT       TRP.1           NOT YET
         BGT       TRP.0
         LW        R3,TRP.SAVE     DONE WITH SVC'S, SO RESTORE TRAP BASE
         STW       R3,TRP.BASA
         ADR       R2,R3
         LW        R5,VCT.SAVE     DONE WITH SVC'S, SO RESTORE TRAP BASE
         STW       R5,VCT.BASA
         ADR       R2,R5
TRP.0    SUI       R3,X'3C'        BIAS BY 16 SVC'S
         SUI       R5,X'3C'        "
         BU        TRP.2
TRP.1    SUI       R3,X'18'        BASE IS 2ND SVC TBL -- BIAS BY 6 TRPS
         SUI       R5,X'18'        "
         IFF       C.3227,TRP.C0
         BU        TRP.C1
TRP.C0   ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         BU        TRP.C1
EVNT     ANOP
         IFF       C.3227,EVNT
TRP.2    LW        R3,0W,X3        FETCH TRAP VECTOR
         BZ        TRP.END1        SKIP IF VACANT
EVNT     ANOP
         IFT       C.3227,TRP.C
         IFF       MPX.EVNT,EVNT
TRP.2    LW        R3,0W,X3        FETCH TRAP VECTOR
         BZ        TRP.END1        SKIP IF VACANT
EVNT     ANOP
TRP.C    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
TRP.2    EQU       $
EVNT     ANOP
         IFF       C.3227,TRP.D
TRP.C1   LW        R7,,X3          FETCH TRAP VECTOR
         BZ        TRP.END1        SKIP IF VACANT
         ZBR       R7,31           REMOVE ANY C BIT
         CI        R2,X'18'        SVC TYPE 0?
         BEQ       TRP.D0          BRANCH IF YES
         TRR       R7,R3           TRAP VECTOR TO R3
TRP.D    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
TRP.C1   LW        R7,,X3          FETCH TRAP VECTOR
         BZ        TRP.END1        SKIP IF VACANT
         ZBR       R7,31           REMOVE ANY C BIT
         CI        R2,X'18'        SVC TYPE 0?
         BEQ       TRP.D0          BRANCH IF YES
         TRR       R7,R3           TRAP VECTOR TO R3
EVNT     ANOP
         CI        R2,X'18'        SVC TYPE 0?
         BNE       TRP.3           BRANCH IF NOT SVC
TRP.D0   LW        R6,TRP.BASA
         STW       R6,TRP.SAVE     SAVE TRAP BASE
         LW        R6,VCT.BASA
         STW       R6,VCT.SAVE     SAVE TRAP BASE
*
         IFT       C.3227,TRP.E
         IFF       MPX.EVNT,EVNT
         XCR       R5,R3           GET VECTOR IN XR
         LW        R3,0W,X3        GET SVC VECTOR ADDR
         XCR       R5,R3           BACK AGAIN
         STW       R5,VCT.BASA     SECONDARY SVC TABLE BASE
         STW       R3,TRP.BASA     SECONDARY SVC TABLE BASE
         LW        R3,,X3          FETCH SVC TYPE 0 VECTOR
EVNT     ANOP
TRP.E    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         ZBR       R7,31           CLEAR ANY C BIT
         TRR       R7,R3
         STW       R7,TRP.BASA     SECONDARY SVC TABLE BASE
         LW        R5,,X3          FETCH SVC TYPE 0 VECTOR
         TRR       R5,R3           VECTOR TO R3
         ZBR       R3,31           CLEAR ANY C BIT
EVNT    ANOP
         IFF       C.3227,TRP.F
         ZBR       R7,31           CLEAR ANY C BIT
         TRR       R7,R3
         STW       R7,TRP.BASA     SECONDARY SVC TABLE BASE
         LW        R5,,X3          FETCH SVC TYPE 0 VECTOR
         TRR       R5,R3           VECTOR TO R3
         ZBR       R3,31           CLEAR ANY C BIT
TRP.F    ANOP
*
         IFT       OS.35,DO.35                                      !286
*  Now check to see if IP06 is using C.STKREG.                      !286
         ZBM       LW.STKR,LSWITCH Not in use yet                   !286
*290          LH        R7,*5W,X3       Get replaced instruction         !286
*290          CI        R6,C.BIT        True if old style                !286
         LW        R7,*2W,X3       Get replaced instruction         !290
         SLL       R7,13           Lose all but address...          !290
         SRL       R7,14           ...and lose HW bit               !290
         SLL       R7,1            Back to address                  !290
         CI        R7,C.BIT        True if old style                !290
         BEQ       TRP.CK          Go if so                         !286
         SBM       LW.STKR,LSWITCH                                  !286
         LW        R7,*2W,X3       Get entire address               !286
         STW       R7,C_STKREG     Save addr                        !286
TRP.CK   EQU       $                                                !286
DO.35    ANOP                                                       !286
TRP.3    STW       R5,VCT.CURR     CURR VECTOR ADDRESS
         IFF       C.3227,TRP.4
         TBM       2,2W,X3         HAVE WE ALREADY SEEN THIS MPX TCB?
         BNS       TRP.41          BRANCH IF WE HAVEN'T
         TRR       R1,R6           SAVE T-XPM TCB ADDRESS
         LW        R1,2W,X3        FETCH NEW PSW POINTING TO T-XPM
         ZBR       R1,31           WORD ADDRESS
*291          ADI       R1,4W           GET TRAP CONTEXT ADDRESS
         ADI       R1,6W           GET TRAP CONTEXT ADDRESS         !291
         LW        R5,PSD.WRD2,X1  FETCH ORIGINAL PSD WORD 2
         STW       R5,3W,X3        PUT BACK SO WE CAN REPLACE AGAIN!
         LW        R5,PSD.RET1,X1  FETCH 'ORIGINAL' PSW
         SUI       R5,1W           BACK UP
         STW       R5,2W,X3        PUT BACK SO WE CAN REPLACE AGAIN!
         TRR       R6,R1           RESTORE CURRENT T-XPM TCB
TRP.4    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         TBM       2,2W,X3         HAVE WE ALREADY SEEN THIS MPX TC
         BNS       TRP.41          BRANCH IF WE HAVEN'T
         TRR       R1,R6           SAVE T-XPM TCB ADDRESS
         LW        R1,2W,X3        FETCH NEW PSW POINTING TO T-XPM
         ZBR       R1,31           WORD ADDRESS
*291          ADI       R1,4W           GET TRAP CONTEXT ADDRESS
         ADI       R1,6W           GET TRAP CONTEXT ADDRESS         !291
         LW        R5,PSD.WRD2,X1  FETCH ORIGINAL PSD WORD 2
         STW       R5,3W,X3        PUT BACK SO WE CAN REPLACE AGAIN
         LW        R5,PSD.RET1,X1  FETCH 'ORIGINAL' PSW
         SUI       R5,1W           BACK UP
         STW       R5,2W,X3        PUT BACK SO WE CAN REPLACE AGAIN
         TRR       R6,R1           RESTORE CURRENT T-XPM TCB
EVNT     ANOP
TRP.41   LW        R5,*2W,X3       FETCH REPLACED INSTRUCTION
TRP.5    TRR       R1,R7           GET TCB ADDRESS
*291          ADI       R7,ITC.LEN      TRAP CONTEXT ADDRESS
         ADI       R7,TTC.LEN      TRAP CONTEXT ADDRESS             !291
         XCR       R2,R7           EXCHANGE TO USE AS INDEX
         STW       R5,RPL.INST,X2  SAVE REPLACED INSTRUCTION
         CI        R7,X'48'        SVC 'B'?
         BNE       TRP.51          BR IF NOT
         TRR       R3,R6           SAVE R6                      *231*
         LA        R3,H.IP06       GET ADDR OF H.IP06           *231*
         LW        R0,11W,X3       GET SVC 'A' ADDRESS          *231*
         CAMW      R0,17W,X3       IS IT WITHIN H.IP06          *231*
         BLE       T231            NO H.AID IF IT IS            *231*
         IFF       C.MPXOUT,MO                                  *237*
         TRR       R6,R3           RESTORE R3                   *231*
         LW        R6,AID.ADDR     WHERE ADDRES OF AID IS TO GO
         ORR       R3,R6           OR IN AID.ICB ADDRESS
         SUI       R6,X'10'        BACK UP TO HAT ADDRESS
         STW       R6,AID.ADDR     PUT BACK LA INSTR FOR AID ADDR
         BU        TRP.51          CONTINUE                     *231*
MO       ANOP                                                   *237*
T231     SBM       NO.AID,TXPMFLGS AID NOT ON THIS SYSTEM       *231*
         TRR       R6,R3           RESTORE R3                   *231*
TRP.51   CI        R7,X'18'        LESS THAN SVC 0?
         BLT       S.7W            GO STORE IN ICB + 7W
*288          CI        R7,X'28'        GTR  THAN SVC 4?             *210*
         CI        R7,X'24'        GTR  THAN SVC 3?                 !288
         BLE       S.8W            GO STORE IN ICB + 8W         *215*
         IFT       C.3227,SURE.27                                   !246
         CI        R7,X'2C'        IS THIS SVC 5 (H.SURE)       *210*
         BNE       S.7W            GO PUT IN 7TH WD             *215*
* H.SURE DOES A LW R1,C.CURR AS FIRST INSTR, SO JUST XEQ IT     *210*
         LW        R5,2W,X3        GET PSD WD 1                 *210*
         BU        S.NW            XEQ 1ST INSTR                *210*
SURE.27  ANOP                                                       !246
         IFF       C.3227,SURE.7X                                   !246
         BU        S.7W            ON 7X, JUST GOTO S.7W            !246
SURE.7X  ANOP                                                       !246
*291 S.8W     STW       R5,8W,X1        STUFF 1ST INSTR IN ICB + 8W  *210*
S.8W     STW       R5,6W,X1        STUFF 1ST INSTR IN ICB + 8W  *210!291
         BU        S.XW            MERGE CODE                   *210*
*291 S.7W     STW       R5,7W,X1        STUFF 1ST INSTR IN ICB + 7W  *210*
S.7W     STW       R5,6W,X1        STUFF 1ST INSTR IN ICB + 7W  *210!291
S.XW     LW        R5,2W,X3        FETCH NEW PSW                *210*
         ADI       R5,1W           RETURN ADDRESS IS NEXT WORD
S.NW     STW       R5,PSD.RET1,X2  SAVE RETURN ADDRESS          *210*
         LW        R5,3W,X3        FETCH NEW PSD WORD 2
         STW       R5,PSD.WRD2,X2  SAVE NEW PSD WORD 2
         IFF       C.3227,TRP.55
         LW        R5,PSD.NEWT     FETCH NEW PSD WORD 2
         STW       R5,3W,X3        STUFF AS NEW PSD2 FOR MPX
TRP.55   ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         LW        R5,PSD.NEWT     FETCH NEW PSD WORD 2
         STW       R5,3W,X3        STUFF AS NEW PSD2 FOR MPX
EVNT     ANOP
         STW       R3,PSD.OMPX,X2  SAVE OLD MPX   PSD ADDRESS
         LW        R6,CXT.BASE     CURRENT CONTEXT ADDRESS
         STW       R6,PSD.OTMP,X2  SAVE OLD T-XPM PSD ADDRESS
         IFF       C.3227,TRP.6
         LW        R6,2W,X1        FETCH T-XPM NEW PSW
         SBR       R6,2            INDICATE WE'VE SEEN THIS MPX TCB
         ADMW      R6,CXT.BASE     BIAS NEW PSD ADDRESS
         STW       R6,2W,X3        STUFF AS NEW PSW FOR MPX
TRP.6    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         LW        R6,2W,X1        FETCH T-XPM NEW PSW
         SBR       R6,2            INDICATE WE'VE SEEN THIS MPX TCB
         ADMW      R6,CXT.BASE     BIAS NEW PSD ADDRESS
         STW       R6,2W,X3        STUFF AS NEW PSW FOR MPX
EVNT     ANOP
         XCR       R7,R2
*291          LI        R0,-TOT.LEN     NUMBER OF WORD TO MOVE
         LI        R0,-TTT.LEN     NUMBER OF WORD TO MOVE           !291
         LW        R3,CXT.BASE     CURRENT PLACE TO PUT TCB
         TRR       R3,R5           SAVE FOR VECTOR UPDATE
         TRR       R3,R7           CALC NEW CONTEXT ADDRESS
*291          ADI       R7,ITC.LEN      POINT TO CONTEXT AREA
         ADI       R7,TTC.LEN      POINT TO CONTEXT AREA            !291
         ARMW      R3,2W,X1        BIAS NEW PSD
*  Now let's build a word that looks like a BL, shifted right       !292
*  19 bits.  We need that in the following move.  We will be        !292
*  moving the TRAP context blocks, which means we need to relocate  !292
*  any BL $+1W.  To be safe, we want to do this relocation only     !292
*  for BL $+1W, not any instr that references $+1W.                 !292
         LW        R6,BLSH         Get BL shell                     !292
         SRL       R6,19           'Cause that's what we're going   !292
*                                  to do later                      !292
         STW       R6,BL1W         Save this                        !292
         STW       R7,MVL.R7       Save this; I'm not sure this     !292
*                                  is necessary                     !292
TRP.MVL  EQU       $                                                !292
         LW        R6,0W,X1        GET A WORD
*  Now see if it's a BL $+1W                                        !292
         TRR       R6,R7                                            !292
         SRL       R7,19           Lose address                     !292
         CAMW      R7,BL1W         Is it BL?                        !292
         BNE       TRP.MV1         Go if no                         !292
*  Now see if it's a BL to the next word                            !292
         TRR       R6,R7           Get the word again               !292
         SLL       R7,13           Lose bits 0-12                   !292
         SRL       R7,13                                            !292
         SUI       R7,5            If it was pointing to $+1,...    !292
*                                  ...now it's $, which is in R1    !292
         CAR       R7,R1                                            !292
         BNE       TRP.MV1         Go if not                        !292
         TRR       R3,R7           Else come up with new addr       !292
         ADI       R7,5            $+1W                             !292
         SLL       R7,13           Prep for meld with R6            !292
         SRL       R6,19           Ditto                            !292
         SLLD      R6,19                                            !292
TRP.MV1  STW       R6,0W,X3        PUT IN TCB AREA
         ADI       R3,1W           NEXT WORD
         ADI       R1,1W           NEXT WORD
*292          BIW       R0,$-4W         LOOP FOR ALL OF TCB
         BIW       R0,TRP.MVL      LOOP FOR ALL OF TCB              !292
         LW        R7,MVL.R7       Restore this                     !292
         STW       R3,CXT.BASE     NEXT TCB LOC
*291          SUI       R1,TOT.LEN      BACK US UP
         SUI       R1,TTT.LEN      BACK US UP                       !291
         IFT       C.3227,TRP.7
         IFF       MPX.EVNT,EVNT
         LW        R3,VCT.CURR     CURRENT TXPM VECTOR
         STW       R5,0W,R3        UPDATE TXPM VECTOR
EVNT     ANOP
TRP.7    ANOP
TRP.END1 ADI       R2,1W           POINT TO NEXT TRAP VECTOR
*291          ADI       R1,TOT.LEN      POINT TO NEXT TRAP ENTRY POINT
         ADI       R1,TTT.LEN      POINT TO NEXT TRAP ENTRY POINT   !291
         BIB       R4,TRP.LOOP     GO PROCESS NEXT TRAP
         IFF       MPX.EVNT,TTL.TXPM                                !259
         TITLE     H.TXPM -- REMAP PROCESSOR -- SYSGEN INIT (INTRPTS)
TTL.TXPM ANOP                                                       !259
         IFT       MPX.EVNT,TTL.TMPX                                !259
         TITLE     H.TMPX -- REMAP PROCESSOR -- SYSGEN INIT (INTRPTS)
TTL.TMPX ANOP                                                       !259
         LIST      MAC,NGLIST                                       !267
*
*  SET UP ALL INTRPT CONTEXT BLOCKS (BASED UPON VECTORS IN SCRATCHPAD)
*
         IFT       C.3227,INT.1
         LW        R1,C.SPAD       FETCH SCRATCHPAD ADDRESS
         TRR       R1,R2           DUPLICATE
         ADI       R2,INT.IESA     COMPUTE INT ENTRY SPAD ADDRESS
         STW       R2,INT.IEBA     SAVE  INT ENTRY BASE ADDRESS
         LW        R2,INT.ITBA,X1  INTERRUPT TABLE BASE ADDR
         STW       R2,MPX.INT      ...DITTO
         IFF       MPX.EVNT,EVNT
         LA        R2,INT.VCT      INTERRUPT VECTOR TABLE FOR CPU
EVNT     ANOP
         STW       R2,VCT.BASA     SAVE FOR UPDATING WITH TCB ADDRE
         STW       R2,C.INTVA      SAVE IN LOW MEMORY
INT.1    ANOP
         IFF       C.3227,INT.2
         LI        R2,X'13'        START WITH LEVEL X'13'
         STW       R2,EPRI         SAVE IT
         LI        R2,X'0EC'       INTERRUPTS START AT LOC X'0EC'
         STW       R2,INT.IEBA     32/7X SI VECTORS START AT X'0EC'
INT.2    ANOP
         LA        R1,INTRPTS      ORIGIN OF H.TXPM INT  ENTRY POINTS
         ZR        R2
INT.LOOP EQU       $
         IFT       C.3227,INT.24
         CI        R2,INT.LEN      HAVE WE LOOPED THRU ALL INT. ENTRIES?
         BGT       INT.DONE        YES, THEN LEAVE
INT.24   ANOP
         LW        R3,INT.IEBA     INTRPT ENTRY BASE ADDRESS
         ADR       R2,R3           ADD INTRPT # * 4
         LW        R5,VCT.BASA     TXPM VECTOR BASE ADDRESS
         ADR       R2,R5           ADD TRAP # * 4
         STW       R5,VCT.CURR     CURR VECTOR ADDRESS
         TRR       R3,R6
         IFF       C.3227,INT.26
         CI        R6,X'140'       START OF CHANNELS
         BNE       $+3W            BR IF NOT
         LI        R4,X'14'        CHANNELS START AT PRIO X'14'
         STW       R4,EPRI         SET CURR PRIORITY
         CI        R6,X'190'       START OF REST OF INTS
         BNE       $+3W            BR IF NOT
         LI        R4,X'24'        REST OF INTS START AT X'24'
         STW       R4,EPRI         SET CURR PRIORITY
         LW        R3,EPRI         CURR PRIO TO XR
         SLL       R3,2            MAKE WORD OFFSET
         ADI       R3,X'80'*1W     BIAS TO INT SECTION
         ADMW      R3,C.SPAD       ADD IN SPAD ADDRESS
         STW       R3,CUR.SPAD     SAVE CURRENT SPAD ADDR
         TRR       R6,R3           RESTORE VECTOR ADDRESS
         CI        R6,X'2FC'       PROCESSED LAST POSSIBLE 7X INTERRUPT?
         BGT       INT.DONE        BRANCH IF YES
INT.26   ANOP
         IFT       C.3227,INT.27
         STW       R3,CUR.SPAD     SAVE SPAD ADDRESS
INT.27   ANOP
         LW        R3,,X3          FETCH INTERRUPT ENTRY
         IFF       C.3227,INT.4
*
*  32/7X SI VECTORS ARE LOCATED FROM X'140' TO X'17C' AND FROM
*  X'19C' TO X'2DC' AND FROM X'2F8' TO X'2FC'; BUT NOT INCLUDING
*  X'1A4' (ARITHMETIC EXCEPTION) & INCLUDING X'0EC' (ATTN. INTERRUPT)
*
         BZ        INT.END1        SKIP IF VACANT (32/7X)
         ZBR       R3,31           CLEAR BIT 31
         CI        R6,X'1A4'       ARITHMETIC EXCEPTION
         BEQ       INT.END1        ...IS A TRAP !!!
         CI        R6,X'0EC'       ATTENTION INTERRUPT?
         BEQ       INT.VECT        YES, PROCESS AS INTERRUPT
         CI        R6,X'13C'       REACHED X'140' YET?
         BLE       INT.END1        IF NOT, IGNORE
         CI        R6,X'2FC'
         BGT       INT.END1
         CI        R6,X'17C'
         BLE       INT.VECT
         CI        R6,X'2F8'
         BGE       INT.VECT
         CI        R6,X'2DC'
         BGT       INT.END1
         CI        R6,X'198'
         BLE       INT.END1
         BU        INT.VECT
INT.4    ANOP
         IFT       C.3227,INT.55
*
*  FROM HERE TO 'INT.VECT' IS NOT EXECUTED FOR 32/7X SINCE WE HAVE
*  ALREADY FOUND THE SI VECTOR IN A DEDICATED ADDRESS RANGE
*
         BZ        INT.END1        ZERO ENTRY MARKS END?
         TRR       R3,R5           DITTO TO R5
         CI        R3,-1           EMPTY?
         BEQ       INT.END1        SKIP IF VACANT
         SLL       R3,9
         SRL       R3,25           ISOLATE CHANNEL PRIORITY
         LI        R4,X'7F'
         SUR       R3,R4           + 0 BASED PRIORITY IN R4
         STW       R4,EPRI         SAVE
         TRR       R4,R3
         SLL       R3,2            WORD INDEX INTO INTERRUPT TABLE
         IFF       MPX.EVNT,EVNT
         LW        R7,CXT.BASE     CURRENT TCB ADDRESS
         STW       R7,INT.VCT,X3   PUT SI LOC IN T-XPM INT VCT TABLE
EVNT     ANOP
         ADMW      R3,MPX.INT      ADD IN INTRPT TBL BASE ADDR
         LW        R3,0W,X3        FETCH INTERRUPT VECTOR
         IFT       MPX.EVNT,EVNT
         BZ        INT.END1        SKIP IF VACANT
EVNT     ANOP
INT.55   ANOP
         ZBR       R3,31           CLEAR H/W BIT
*
*  AT THIS POINT R3=ICB ADDRESS, R1=CONTEXT ADDRESS
*
INT.VECT LW        R7,INT.CNT      INTRPT #
         CI        R7,MAX.INT      HAVE WE EXCEEDED MAX # OF INTERRUPTS?
         BLT       INT.OK          BRANCH IF NOT
ABT.TXPM SBM       C.NOLOAD,C.BIT  OOPS! CONTEXT AREA NOT BIG ENUFF
         BU        ABRT.XT         TELL SYSGEN TO ABORT & EXIT
*                                  THERE IS NO RETURN
INT.OK   TRR       R1,R7           TCB ADDRESS
         ZBR       R3,31           CLEAR C BIT
         ADI       R7,ITC.LEN      GET TRAP CONTEXT ADDRESS
         XCR       R2,R7           EXCHANGE TO USE AS INDEX
         LW        R5,=X'20002'    USE AS REPLACED INSTRUCTION
         STW       R5,RPL.INST,X2  'ABM 31,C.GINT' ALREADY DONE
         LW        R5,2W,X3        FETCH NEW PSW
         ADI       R5,1W           RETURN ADDRESS IS NEXT WORD
         STW       R5,PSD.RET1,X2  SAVE RETURN ADDRESS
         LW        R5,EPRI         GET INT PRIORITY
         STB       R5,ICXT.FLG+1B,X2 SAVE INT PRIORITY
         IFF       C.3227,INT.7
*
* H.TXPM PROCESSES ALL INTERRUPTS FOR A 32/7X
*
         LW        R6,2W,X1        FETCH NEW PSW IN T-XPM ICB
         ADMW      R6,CXT.BASE     BIAS NEW PSD ADDRESS
         STW       R6,2W,X3        ALSO  NEW PSW IN MPX   ICB
INT.7    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
*
* H.TXPM PROCESSES ALL INTERRUPTS FOR A 32/7X
*
         LW        R6,2W,X1        FETCH NEW PSW IN T-XPM ICB
         ADMW      R6,CXT.BASE     BIAS NEW PSD ADDRESS
         STW       R6,2W,X3        ALSO  NEW PSW IN MPX   ICB
EVNT     ANOP
         SBM       2,2W,X3         INDICATE THAT THIS PSD PROCESSED
         LW        R6,3W,X3        FETCH NEW PSD WORD 2
         STW       R6,PSD.WRD2,X2  SAVE NEW PSD WORD 2
         ZBR       R6,0            INTERRUPT HANDLERS MUST RUN UNMAPPED!
         SBR       R6,15           BUT ALWAYS RETAIN CURRENT MAP
         STW       R6,3W,X1        STUFF IN T-XPM ICB
         IFF       C.3227,INT.8
         STW       R6,3W,X3        STUFF AS NEW PSD FOR MPX
INT.8    ANOP
         IFT       C.3227,EVNT
         IFT       MPX.EVNT,EVNT
         STW       R6,3W,X3        STUFF AS NEW PSD FOR MPX
EVNT     ANOP
         STW       R3,PSD.OMPX,X2  SAVE OLD PSD ADDRESS
         LW        R6,CXT.BASE     CURRENT CONTEXT ADDRESS
         STW       R6,PSD.OTMP,X2  SAVE OLD T-XPM PSD ADDRESS
         SBM       ICXT.CLD,ICXT.FLG,X2      SET CLASS D TRUE
         LW        R3,CUR.SPAD     GET SPAD ADDR FOR THIS INT
         ZBM       3,0W,X3         IS THIS SPEC INTERRUPT
         BNS       $+3W            BR IF NOT
         SBM       ICXT.SPL,ICXT.FLG,X2  SET SPECL INT FLAG
         ZBM       0,PSD.WRD2,X2   SPCL INTS MUST BE UNMAPPED
         XCR       R7,R2
         LI        R0,-TOT.LEN     NUMBER OF WORD TO MOVE
         LW        R3,CXT.BASE     CURRENT PLACE TO PUT TCB
         TRR       R3,R5           SAVE FOR VECTOR UPDATE
         TRR       R3,R7           CALC NEW CONTEXT ADDRESS
         ADI       R7,ITC.LEN      POINT TO CONTEXT AREA
         ARMW      R3,2W,X1        BIAS NEW PSD
         LW        R6,0W,X1        GET A WORD
         STW       R6,0W,X3        PUT IN TCB AREA
         ADI       R3,1W           NEXT WORD
         ADI       R1,1W           NEXT WORD
         BIW       R0,$-4W         LOOP FOR ALL OF TCB
         STW       R3,CXT.BASE     NEXT TCB LOC
*MOD     SUI       R1,TOT.LEN      BACK US UP                       !MOD
*MOD     ADI       R1,TOT.LEN      POINT TO NEXT TRAP ENTRY POINT   !MOD
         ABM       31,INT.CNT      BUMP INTERRUPT NUMBER
         TBM       LW.CDT,EP8.FLAG PROCESSING CDT'S                 !267
         BS        NXT.CDT         BRANCH IF YES
         IFT       OS.35,EXT.35                                     !MOD
         TBM       LW.EXTRP,EP8.FLAG Processing external traps      !MOD
         BS        NXT.EXT         Branch if yes                    !MOD
EXT.35   ANOP                                                       !MOD
         IFT       C.3227,INT.C
         IFF       MPX.EVNT,EVNT
         LW        R3,VCT.CURR     CURRENT TXPM VECTOR
         STW       R5,0W,R3        UPDATE TXPM VECTOR
EVNT     ANOP
INT.C    ANOP
         BL        SET.CLAS        INSURE I/O CLASS FLAGS SET PROPERLY
INT.END1 ADI       R2,1W           POINT TO NEXT TRAP VECTOR
         IFF       C.3227,INT.D
         ABM       31,EPRI         NEXT PRIORITY PLEASE
INT.D    ANOP
         BU        INT.LOOP        GO PROCESS NEXT INTERRUPT ENTRY
*
*-------------------------------------------------------------------
*
*  ROUTINE:  SET.CLAS
*
*  PURPOSE:  SET I/O CLASS FLAGS PROPERLY IN INTERRUPT INFORMATION BLK
*
*  INPUT  :  R7 = IIB ADDRESS
*            * 'EPRI' CONTAINS THE INTERRUPT PRIORITY LEVEL
*
*  NOTE   :  THIS ROUTINE NEED NOT BE CALLED FOR 7X BECAUSE CLASS FLAGS
*            NEED NOT BE SET SINCE ON A 7X, ALL INTERRUPTS FIRE IN THEIR
*            REGULAR MPX ICB'S.  THE FLAGS ARE NECESSARY IN ORDER TO
*            DETERMINE WHETHER WORDS 5 & 6 NEED TO BE COPIED FROM THE
*            T-XPM ICB/TCB TO THE CORRESPONDING MPX TCB/ICB.
*
SET.CLAS STF       R0,EP8.REGS     SAVE REGISTERS
         TRR       R7,R2           MOVE INFORMATION BLOCK ADDRESS TO R2
         LW        R3,C.CDTA       CDT ADDRESS
         LNH       R4,C.CDTN       NEGATIVE # OF CDT'S
LOOP.CLS LB        R5,CDT.IPL,X3   FETCH INTERRUPT PRIORITY
         CAMW      R5,EPRI         IS THIS CDT FOR IIB?
         BNE       BUMP.CDT        BRANCH IF NOT
         LB        R5,CDT.CHAN,X3  GET CHANNEL ADDRESS
         STB       R5,ICXT.FLG+2B,X2    SAVE IN CONTEXT AREA
         LB        R5,CDT.DTC,X3   GET DEVICE TYPE CODE
         STB       R5,ICXT.FLG+3B,X2    SAVE IN CONTEXT AREA
         LB        R5,CDT.CLAS,X3  FETCH CLASS
         CI        R5,X'F'         CLASS F?
         BNE       SET.LV          SET PROPERLY FOR 'F' CLASS
         SBM       ICXT.CLF,ICXT.FLG,X2  SET CLASS F
         ZBM       ICXT.CLD,ICXT.FLG,X2  CLEAR NON-CLASS F INTERRUPT
         BU        SET.LV
BUMP.CDT ADI       R3,CDT.SIZE     POINT TO NEXT CDT
         BIB       R4,LOOP.CLS     GO LOOK AT NEXT CDT
SET.LV   LF        R0,EP8.REGS     RESTORE REGISTERS
         TRSW      R0              ...AND RETURN
*
EPRI     DATAW     0               TEMP STORAGE FOR PRIORITY
CUR.SPAD DATAW     0               CURRENT SPAD ADDRESS FOR INT
BRANCH   DATAW     X'EC000001'
TRP.BASA REZ       1W              TRAP TABLE BASE ADDRESS
TRP.SAVE RES       1W              ...DITTO...             SAVE AREA
         IFF       C.MPXOUT,MO                                  *237*
TRI.BASA REZ       1W              TRAP TABLE BASE ADDRESS
TRI.SAVE RES       1W              ...DITTO...             SAVE AREA
MO       ANOP                                                   *237*
INT.IEBA RES       1W              INTRPT ENTRY BASE ADDRESS
INT.CNT  REZ       1W              COUNT OF INTERRUPTS PROCESSED
PSD.NEWT DATAW     X'00014000'     UNMAPPED/INTERRUPTS BLOCKED
TRAPBIT  DATAW     0               Contents of C.TRAPS              !MOD
EP8.FLAG DATAW     0
LW.CDT   EQU       0                                                !267
LW.EXTRP EQU       1                                                !267
BL1W     BL        $+1W            Will be overwritten during SG    !292
MVL.R7   RES       1W                                               !292
         IFF       C.MPXOUT,MO                                  *237*
CXT.BASE DATAW     TRPIS           ADDR OF TCB WITH IPU ON SYSTEM
SEQ.MAX  DATAW     NUM.VECT        CURRENT MAXIMUM FOR BRANCH TBL
MO       ANOP                                                   *237*
         IFT       C.MPXOUT,MO                                  *237*
CXT.BASE DATAW     0               ADDR OF TCB W/O IPU ON SYS   *237*
MO       ANOP                                                   *237*
VCT.BASA DATAW     0               CURRENT TXPM VECTOR ADDRESS
VCT.SAVE DATAW     0               SAVE LOC DURING SVC PROCESSING
VCT.CURR DATAW     0               CURRENT VECTOR POINTER
         BOUND     1F
EP8.REGS RES       1F
*
         BOUND     1W
INT.DONE SBM       LW.CDT,EP8.FLAG INDICATE WE ARE PROCESSING CDT'S !267
         LW        R2,C.CDTA       FETCH BASE ADDRESS OF CDT'S
         LNH       R4,C.CDTN       NUMBER OF CDT'S TO EXAMINE
CDT.LOOP LB        R5,CDT.CLAS,X2  FETCH CLASS
         CI        R5,X'0F'        IS IT CLASS F?
         BEQ       NXT.CDT         BRANCH IF SO
         LW        R3,CDT.SIHA,X2  FETCH HANDLER ADDRESS
         BZ        NXT.CDT         BRANCH IF NONE
         LH        R5,1H,X3        Get nr of entry points           !276
         BZ        ABT.TXPM        Cannot continue; must have at    !276
*                                  least one, ptg to icb            !276
         LW        R3,1W,X3        FETCH EP 1 ADDRESS
         ZBR       R3,31           CLEAR C BIT
         LW        R5,0,X3         Old PSD should be zero           !293
         BNZ       NXT.CDT         Go if not; can't process this    !293
         LW        R5,1W,X3        Ditto on next word of PSD        !293
         BNZ       NXT.CDT                                          !293
         TBM       2,2W,X3         NEW PSD POINTING TO H.TXPM?
         BS        NXT.CDT         IF SET, EP1 POINTS TO H.TXPM
         TRR       R3,R5           SAVE INTERRUPT VECTOR
         LB        R6,CDT.CHAN,X2  GET CHANNEL ADDRESS
         STB       R6,ICXT.FLG+2B+ITC.LEN,X1 SAVE IN CONTEXT AREA
         LB        R6,CDT.DTC,X2   GET DEVICE TYPE CODE
         STB       R6,ICXT.FLG+3B+ITC.LEN,X1 SAVE IN CONTEXT AREA
         LB        R3,CDT.IPL,X2   FETCH INTERRUPT PRIORITY
         STW       R3,EPRI         SAVE PRIORITY
         IFT       C.3227,CDT.2X
         IFF       MPX.EVNT,EVNT
         SLL       R3,2            MAKE WORD INDEX
         LW        R6,CXT.BASE     TCB ADDRESS
         STW       R6,INT.VCT,X3   OVER-WRITE SI LOC WITH EP 1 VECTOR
EVNT     ANOP
CDT.2X   ANOP
         TRR       R5,R3           RESTORE EP 1 ADDRESS TO R3
         BU        INT.VECT        GO SET UP ICB
*
NXT.CDT  ADI       R2,CDT.SIZE     POINT TO NEXT CDT
         BIB       R4,CDT.LOOP
*
         IFT       OS.35,EX35                                       !MOD
*  Process external traps                                           !MOD
*                                                                   !MOD
         LW        R2,C.TRAPS      Any external traps defined       !MOD
         BZ        EXT.DONE        No, nothing to do                !MOD
         STW       R2,TRAPBIT      Save contents of C.TRAPS         !MOD
         ZBM       LW.CDT,EP8.FLAG Clear processing CDT'S flag      !MOD
         SBM       LW.EXTRP,EP8.FLAG Show processing external traps !MOD
         LA        R2,X'20'        Where trap vectors start         !MOD
         LI        R4,-24          Maximum of 24 external traps     !MOD
         ZMW       EPRI            Start at trap number 0           !MOD
EXT.LOOP LW        R7,TRAPBIT      Get trap definition bits         !MOD
         BGT       NXT.EXT         More to go, loop                 !MOD
         BZ        EXT.DONE        Nothing else to do               !MOD
* There is a trap to process                                        !MOD
         LW        R3,0W,X2        Get ICB address                  !MOD
         BZ        NXT.EXT         Continue if none there           !MOD
         ZBR       R3,31           Clear C bit                      !MOD
         TRR       R3,R5           Save external trap vector        !MOD
         LW        R3,EPRI         Fetch trap number                !MOD
         IFT       C.3227,EXT.2X                                    !MOD
         IFF       MPX.EVNT,EVNT                                    !MOD
         SLL       R3,2            Make word index                  !MOD
         LW        R6,CXT.BASE     TCB address                      !MOD
         STW       R6,TRP.EXT,X3   Over-write SI loc with vector    !MOD
EVNT     ANOP                                                       !MOD
EXT.2X   ANOP                                                       !MOD
         TRR       R5,R3           Restore ICB address to R3        !MOD
         BU        INT.VECT        Go set up ICB                    !MOD
*                                                                   !MOD
NXT.EXT  ABM       31,EPRI         Next trap number                 !MOD
         LW        R7,TRAPBIT      Get trap bits                    !MOD
         SLL       R7,1            Clear last trap bit              !MOD
         STW       R7,TRAPBIT      And put it back                  !MOD
         ADI       R2,1W           Next trap vector                 !MOD
         BIB       R4,EXT.LOOP     Loop for all of them             !MOD
*                                                                   !MOD
EXT.DONE EQU       $               Done processing external traps   !MOD
EX35     ANOP                                                       !MOD
         LW        R7,CXT.BASE     TCB ADDRESS
         STW       R7,DQE.TCXT     START ADDRESS OF DQE CONTEXT AREA
         STW       R7,C.CTXT       SAVE IN C-DOT ALSO
         ZR        R6
         LB        R7,C.NQUE       # OF DQE ENTRIES
         ADI       R7,1            JUST FOR INSURANCE
         MPI       R6,DQE.LCXT     * NUMBER OF BYTES PER DQE CONTEXT
         TRN       R7,R4           SAVE SIZE OF CONTEXT AREA
         ADMW      R7,DQE.TCXT     ADD IN CONTEXT ORIGIN
         STW       R7,HAT+1W       SYSGEN CAN OVERLAY FROM HERE ON!
         LW        R1,DQE.TCXT     CONTEXT ADDRESS
         ZMD       0W,X1           CLEAR 2 WORDS
         ADI       R1,1D           NEXT LOC'S
         BID       R4,$-2W         CLEAR IT ALL
         LB        R4,C.NQUE       NUMBER OF DQE'S
         ADI       R4,1            ONE MORE FOR DUMMY
         TRN       R4,R4           MAKE NEG
         LW        R3,DQE.TCXT     START OF CONTEXT AREA
         LW        R1,C.ADAT       ADDRESSES OF DQE'S
         LA        R2,DQE0         DUMMY DQE 0 ADDRESS
         BU        DQEILOOP+1W     SKIP FOR DQE 0
DQEILOOP LW        R2,0W,R1        GET DQE ADDRESS
         STW       R3,DQE.PSSF,X2  CONTEXT ADDR TO DQE
         ZMW       DQE.PSSB,X2     CLEAR BIAS VALUE
         LA        R5,TSK.LVL0,X3  CALC CURR LVL POINTER ADDR
         STW       R5,TSK.LVLP,X3  STUFF IN CONTEXT AREA
         ADI       R3,DQE.LCXT     NEXT CONTEXT ADDRESS
         ADI       R1,1W           NEXT DQE ADDRESS
         BIB       R4,DQEILOOP     DO THEM ALL
         IFF       C.MPXOUT,MO                                  *237*
*
*   THIS CODE RELOCATES THE BIAS/REBIAS ROUTINE POINTER TABLES
*   FOR H.TXPM.  IT ALSO LOOKS IN LOC C.UBIAS ("C8") TO SEE IF
*   H.UBIAS IS IN THE SYSTEM.  IF NOT, ONLY THE STANDARD SVC'S
*   ARE SET UP.  IS SO, ALL SVC BIAS/REBIAS ROUTINES ARE ADDED
*   TO THE VECTOR TABLES.  TABLE LENGTH IS SET BY SYSGEN VALUES
*   FOR C.SVCN (NUMBER OF SVC 1'S DEFINED) AND C.SVCN2 (NUMBER
*   OF SVC 2'S DEFINED).  BIAS/UNBIAS ROUTINES IN TXPM CAN BE
*   OVERRIDDEN IF PLACED IN THE H.UBIAS ROUTINE.
*
*        DO SVC 1 TABLE
*
         LH        R5,C.SVTN       GET NUMBER OF SVC 1'S
         ADI       R5,1            C.SVTN IS HIGHEST #
         ADI       R5,3            ROUND UP TO WORD
         SRL       R5,2            WORD BOUND
         SLL       R5,2            MAKE WORD VALUE
         STW       R5,VCT.BASA     SAVE FOR LATER USE
         LW        R6,HAT+1W       GET END OF DQE AREA
         STW       R6,SVC1IN       SET SVC1IN ADDRESS
         TRR       R6,R7           COPY OF ADDRESS
         ADR       R5,R7           SETUP SVC1OUT ADDR
         STW       R7,SVC1OUT      SET SVC1OUT ADDRESS
         TRR       R7,R0           COPY ADDRESS
         ADR       R5,R0           POINT TO END
         STW       R0,HAT+1W       UPDATE END ADDRESS
         TRR       R6,R1           SVC1IN ADDRESS
         TRR       R7,R2           SVC1OUT ADDRESS
         TRN       R5,R4           BYTE COUNT CLEAR
         ZMW       0W,X1           CLEAR 4 BYTES
         ZMW       0W,X2           CLEAR 4 BYTES
         ABR       R1,29           NEXT WORD IN SVC1IN
         ABR       R2,29           NEXT WORD IN SVC1OUT
         BIW       R4,$-3W         GO DO NEXT 4 BYTES
         LNW       R4,VCT.BASA     DEFINED SVC 1 SIZE           *232*
         TRR       R6,R1           SVC1IN ADDRESS
         LA        R2,SVC1BTBL     GET STD TBL ADDRESS
         LW        R3,0W,R2        GET 4 BYTES
         STW       R3,0W,R1        PUT IN SVC1IN TBL
         ABR       R1,29           NEXT WORD
         ABR       R2,29           NEXT WORD
         BIW       R4,$-3W         DO ALL SVC1IN ENTRUES
         LNW       R4,VCT.BASA     DEFINED SVC 1 SIZE           *232*
         TRR       R7,R1           SVC1OUT ADDRESS
         LA        R2,SVC1UTBL     GET STD TBL ADDRESS
         LW        R3,0W,R2        GET 4 BYTES
         STW       R3,0W,R1        PUT IN SVC1OUT TBL
         ABR       R1,29           NEXT WORD
         ABR       R2,29           NEXT WORD
         BIW       R4,$-3W         DO ALL SVC1OUT ENTRUES
*
*        DO SVC 2 TABLE
*
         IFF       OS.15E,OS15E                                 *238*
         LH        R5,C.SVTN2      GET NUMBER OF SVC 2'S
OS15E    ANOP                                                   *238*
         IFT       OS.15E,OS15E                                 *238*
* MPX 1.5 MAPS SVC 2'S TO SVC 1'S                               *238*
         LH        R5,C.SVTN       GET NUMBER OF SVC 1'S        *238*
OS15E    ANOP                                                   *238*
         ADI       R5,1            C.SVTN IS HIGHEST #
         ADI       R5,3            ROUND UP TO WORD
         SRL       R5,2            WORD BOUND
         SLL       R5,2            MAKE WORD VALUE
         STW       R5,VCT.SAVE     SAVE FOR LATER USE
         LW        R6,HAT+1W       GET END OF SVC1 AREA
         STW       R6,SVC2IN       SET SVC2IN ADDRESS
         TRR       R6,R7           COPY OF ADDRESS
         ADR       R5,R7           SETUP SVC2OUT ADDR
         STW       R7,SVC2OUT      SET SVC2OUT ADDRESS
         TRR       R7,R0           COPY ADDRESS
         ADR       R5,R0           POINT TO END
         STW       R0,HAT+1W       UPDATE END ADDRESS
         TRR       R6,R1           SVC2IN ADDRESS
         TRR       R7,R2           SVC2OUT ADDRESS
         TRN       R5,R4           BYTE COUNT CLEAR
         ZMW       0W,X1           CLEAR 4 BYTES
         ZMW       0W,X2           CLEAR 4 BYTES
         ABR       R1,29           NEXT WORD IN SVC2IN
         ABR       R2,29           NEXT WORD IN SVC2OUT
         BIW       R4,$-3W         GO DO NEXT 4 BYTES
         LNW       R4,VCT.SAVE     DEFINED SVC 2 SIZE           *232*
         TRR       R6,R1           SVC2IN ADDRESS
         LA        R2,SVC2BTBL     GET STD TBL ADDRESS
         LW        R3,0W,R2        GET 4 BYTES
         STW       R3,0W,R1        PUT IN SVC2IN TBL
         ABR       R1,29           NEXT WORD
         ABR       R2,29           NEXT WORD
         BIW       R4,$-3W         DO ALL SVC2IN ENTRUES
         LNW       R4,VCT.SAVE     DEFINED SVC 2 SIZE           *232*
         TRR       R7,R1           SVC2OUT ADDRESS
         LA        R2,SVC2UTBL     GET STD TBL ADDRESS
         LW        R3,0W,R2        GET 4 BYTES
         STW       R3,0W,R1        PUT IN SVC2OUT TBL
         ABR       R1,29           NEXT WORD
         ABR       R2,29           NEXT WORD
         BIW       R4,$-3W         DO ALL SVC2OUT ENTRUES
*
*        DO VECTOR TABLE
*
         LW        R5,SEQ.MAX      GET CURR MAX INDEX
         ADI       R5,1            MAKE IT A COUNT
         LW        R6,HAT+1W       GET CURRENT END ADDRESS
         STW       R6,VTBLA        SET VECTOR TABLE ADDRESS
         TRR       R6,R7           COPY ADDRESS
         SLL       R5,2            MAKE WORD OFFSET
         ADR       R5,R7           GENERATE NEW END ADDRESS
         STW       R7,HAT+1W       UPDATE END ADDRESS
         TRR       R6,R1           GET STARTING ADDRESS
         TRN       R5,R4           NUMBER OW WDS TO CLEAR
         ZMW       0W,R1           CLEAR A WORD
         ADI       R1,1W           NEXT WORD
         BIW       R4,$-2W         LOOP FOR ALL
         TRR       R6,R1           GET STARTING ADDRESS
         TRN       R5,R4           NUMBER OF WDS TO FILL
         LA        R2,VCT.TBLE     GET VECTOR TBLE ADDRESS
         LW        R3,0W,R2        GET ROUTINE ADDRESS
         STW       R3,0W,R1        PUT IN TABLE
         ABR       R1,29           NEXT WORD
         ABR       R2,29           NEXT WORD
         BIW       R4,$-3W         LOOP FOR ALL
*
*        SEE IF H.UBIAS PRESENT, AND MODIFY TABLES IF NECESSARY
*
         LW        R1,C.UBIAS      IS H.UBIAS MODULE IN SYSTEM
         ANMW      R1,=X'7FFFF'    LEAVE TXPM OUT OF TEST       *242*
         BZ        NO.UBIAS        CONTINUE IF NOT, ELSE SETUP
*
* THE HAT TABLE IS SCANNED AND THE FOLLOWING DEFINITIONS LOOKED
* AT FOR INCLUSION
*
* BIT 0  IF SET, THIS IS A BIAS ROUTINE ENTRY, ELSE IGNORE
*     1  IF SET, THIS IS SVC TYPE 1, ELSE TYPE 2
*     2  IF SET, THIS ROUTINE IS TO EXECUTE FOR BIASING TI MPX
*     3  IF SET, THIS ROUTINE IS TO EXECUTE FOR BIASING TO USER
*  4-11  SVC NUMBER TO BE BIASED/UNBIASED
* 12-31  HALF WORD ADDRESS OF BIAS ROUTINE TO BE ENTERED
*
         LNW       R4,0W,R1        GET NUMBER OF ENTRIES
         BZ        NO.UBIAS        EXIT IF NON
B.LOOP   ADI       R1,1W           POINT TO FIRST ENTRY
         TBM       0,0W,R1         IS THIS A BIAS ROUTINE ENTRY
         BNS       B.LOOP.X        BR IF NOT
         LW        R2,0W,R1        GET ENTRY
         SRLD      R2,20           ADDRESS TO R3
         SRL       R3,12           SET ADDRESS IN RIGHT PLACE
         ANMW      R2,=X'FF'       LEAVE ONLY SVC NUMBER
         ABM       31,SEQ.MAX      GET NEXT AVAILABLE ROUTN #
         ABM       29,HAT+1W       NEED 1 MORE WORD IN TXPM
         TRR       R2,R6           SVC # TO R6
         LW        R7,SEQ.MAX      GET ROUTINE NUMBER
         SLL       R7,2            MAKE WORD OFFSET
         ADMW      R7,VTBLA        JUMP TABLE ADDRESS
         TRR       R7,R2           TO XR
         STW       R3,0W,R2        BIAS ROUTN ADDR TO TABLE
         TBM       2,0W,R1         BIAS GOING INTO MPX
         BNS       B.OUT.O         BR TO TEST FOR OUT OF MPX
         TRR       R6,R2           RESTORE SVC NUMBER
         TBM       1,0W,R1         IS THIS SVC TYPE 1
         BNS       $+3W            IF NOT, SKIP OVER SVC 1 CODE
         ADMW      R2,SVC1IN       CALCULATE ADDRESS
         BU        $+2W            SKIP OVER SVC 2 CODE
         ADMW      R2,SVC2IN       CALCULATE ADDRESS
         LW        R7,SEQ.MAX      GET ROUTINE NUMBER
         STB       R7,0B,X2        PUT IN TABLE
B.OUT.O  TBM       3,0W,R1         BIAS OUT OF MPX
         BNS       B.LOOP.X        BR IF NOT
         TRR       R6,R2           RESTORE SVC NUMBER
         TBM       1,0W,R1         IS THIS SVC TYPE 1
         BNS       $+3W            IF NOT, SKIP OVER SVC 1 CODE
         ADMW      R2,SVC1OUT      CALCULATE ADDRESS
         BU        $+2W            SKIP OVER SVC 2 CODE
         ADMW      R2,SVC2OUT      CALCULATE ADDRESS
         LW        R7,SEQ.MAX      GET ROUTINE NUMBER
         STB       R7,0B,R2        PUT IN TABLE
B.LOOP.X BIB       R4,B.LOOP       MORE ENTRIES IF NOT ZERO
*
NO.UBIAS EQU       $
*
MO       ANOP                                                   *237*
         IFF       OS.15E,OS15E                                 *238*
OS15E    ANOP                                                   *238*
         IFF       OS.15E,OS15E                                 *238*
OS15E    ANOP                                                   *238*
ABRT.XT  M.XIR     HAT             EXIT TO SYSGEN
         IFT       OS.15E,OS15E                                 *238*
         BOUND     1W                                           *238*
*                                                               *238*
*      DEFINE SVC 1,3 FOR USER                                  *238*
*                                                               *238*
SVCTAB   GEN       8/X'03',24/W(RST_TSA)  TURN OFF TSA BIASING  *238*
SVC.END  EQU       $-SVCTAB/4      NUMBER OF SVC 1 ENTRIES      *238*
OS15E    ANOP                                                   *238*
         IFF       OS.15E,OS15E                                 *238*
OS15E    ANOP                                                   *238*
         END
